/******
buf_3d_rec.h - ???
******/
/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef BUF_3D_REC_H
#define	BUF_3D_REC_H

#include "rect.h"
#include "geometry.h"

#define SLICE_3D_ORIGINAL 1
struct slice_3d_rec
   {
    unsigned short status;
    struct buf_2d_rec *s1,*s2;
    struct hdr_scan_entry_rec *s1_info,*s2_info;
    float slice_thickness;
    float ratio;
   };

/* The following flags might be the possible values for status in a 
buf_3d_rec, but I am making no promises.  -PWH */

#define _3D_BUF_DO_NOT_DEALLOCATE_SLICES 0x00010000
#define _3D_BUF_INTERPOLATED 0x00020000
#define _3D_MASK 0x00040000
#define _3D_VALID 0x00080000
#define _3D_CONPLETE_OBJECT 0x00100000       /* Mispelled??? */
#define _3D_SUB_OBJECT 0x00200000
#define _3D_ORIGINAL 0x00400000

/*  WHAT DO THESE MEAN!!!???  */

#define _3D_XYZ_XY_00 0x01000000
#define _3D_XYZ_XY_01 0x02000000
#define _3D_XYZ_XY_10 0x04000000
#define _3D_XYZ_XY_11 0x08000000

#define _3D_DEFAULT_ORDER 0x10000000
#define _3D_BOTTOM_TO_TOP 0x20000000
#define _3D_APPROX 0x40000000

struct buf_3d_rec
   {
    unsigned long status;
    long startx,starty,startz;
    char *id;
    float xpixel_size,ypixel_size,zpixel_size,slice_thickness;
    struct vector_3d_rec center;
    unsigned long dimx,dimy,dimz;
    unsigned long total_slices,num_slices;
    struct slice_3d_rec *sls;
   };

struct _3d_plane_2d_rec
   {
    struct buf_3d_rec *_3d;
    struct buf_2d_rec *plane_2d;
    struct buf_2d_rec *transform_2d;
   };

struct pt_3d_rec
   {
    short x,y,z;
   };

struct ary_pt_3d_rec
   {
    unsigned long total_coords,num_coords;
    struct pt_3d_rec *coords;
   };

struct _3d_xyz_rec
   {
    short x,y,z;
    short px,py;
    long val;
   };

struct ary_3d_xyz_rec
   {
    unsigned long status;
    unsigned long total_coords,num_coords;
    struct _3d_xyz_rec *coords;
   };

/* The contents of offset_3d are defined in common.c */
#define TOTAL_3D_NEIGHBORS 26
extern char offset_3d[TOTAL_3D_NEIGHBORS][3];


#define ALMOST_0 .000005
#define ALMOST_1 .999995

#endif BUF_3D_REC_H
