/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef COUNT_H
#define	COUNT_H
#include "common.h"
#include "text_format.h"

struct roi_count_anal_rec
   {
    unsigned short status2;
    char *label;
    double min,max;
    unsigned long num_pixels;
    double total_counts,sd;
    unsigned long cnt_neg_val,cnt_smean_min_rej,cnt_smean_max_rej,
                  cnt_rmean_min_rej,cnt_rmean_max_rej;
    double slice_mean,min_smean_threshold,max_smean_threshold,
           roi_mean,min_rmean_threshold,max_rmean_threshold;
   };

struct slice_count_anal_rec
   {
#define COUNT_VALID 1
#define COUNT_NEW_FORMAT 2
    unsigned char status1;
    unsigned long total_rois,num_rois;
    struct roi_count_anal_rec *rois;
   };

/*
#define TEXT_OUTPUT_PARAMS_SETUP 0x0001
#define TEXT_OUTPUT_FORMAT_SETUP 0x0002
#define TEXT_OUTPUT_IN_PROGRESS 0x0004
#define TEXT_OUTPUT_COMPUTED 0x0008
#define TEXT_OUTPUT_DELETED 0xfff3

#define TEXT_OUTPUT_TO_FILE 0x0010
#define TEXT_OUTPUT_TO_TEMP_FILE 0x0020
#define TEXT_OUTPUT_TO_WINDOW 0x0040
#define TEXT_OUTPUT_SAVE_FORMAT 0x0080

#define TEXT_OUTPUT_PIXEL_TYPE_ANALYSIS 0x0100
#define TEXT_OUTPUT_PIXEL_COUNT_ANALYSIS 0x0200
#define TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS 0x0400
*/
struct count_analysis_rec
   {
    unsigned short status;
    struct input_file_rec *file;
    char *text_printing_time;
    unsigned int num_groups;
    struct text_output_analysis_group_rec *groups;
    struct output_text_format_rec format;
    unsigned short out_format_status;
    float lt_percent,gt_percent,roi_lt_percent,roi_gt_percent;
    struct unit_2d_rec img_unit;
    unsigned long echo_num;

    char *text_temp_fn;
    unsigned long total_slices,num_slices;
    struct slice_count_anal_rec *slices;
   };

#endif COUNT_H
