/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef HISTO_H
#define	HISTO_H

/* histo_option
#define HISTO_1D 1
#define HISTO_MULTI_D 2
 */

struct pixel_center_rec
   {
    char *roi_label,*segmented_roi_label;
    long avex,avey;
    float gradient;
    unsigned long ave_occurences,num_xy_pairs;
   };
struct pixel_type_ave_rec
   {
    float x,y;
    unsigned long num_freqs;
   };

#define PIXEL_TISSUE_TYPE_GROW_REGION_DONE 1
#define PIXEL_TISSUE_TYPE_ROI_EDITED 2
struct pixel_tissue_type_rec
   {
    unsigned long status;
    char *roi_label,*segmented_roi_label;
    struct pixel_type_ave_rec type_ave;

    long abs_lb,abs_ub,ext_lb,ext_ub,actual_lb,actual_ub;
   };

#define NEIGHBOR 0x0001
#define NOT_NEIGHBOR 0x0002
#define NO_MORE_NEIGHBORS 0x0004
#define NEIGHBOR_ALREADY_PROCESSED 0x0006
struct histo_common_rec
   {unsigned short status;
    float distance;
   };

struct histo_table_elem_rec
   {struct histo_common_rec *common;
    struct neighbor_elem_rec *member;
    unsigned long row_indx;
    struct pixel_center_rec *center;
   };
#define COLINEAR 0x0001
struct neighbor_rec
   {
    unsigned short status;
    struct pixel_center_rec *neighbor1,*neighbor2;
   };
struct neighbor_elem_rec
   {
    unsigned long num_neighbors;
    struct neighbor_rec *neighbors;
   };

#endif HISTO_H
 
