/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef INTENSITY_H
#define	INTENSITY_H

#define MIN_TOTAL_COLORS 9
#define NUM_RESERVED_COLORS 9
#define CUR_CURVE_COLOR 2
#define CUR_ROI_COLOR 3
#define OTHER_ROIS_COLOR 4
#define NON_MEMBER_ROIS_COLOR 5
#define PIXEL_SELECTION_COLOR 6
#define BREAKER_COLOR 7
#define CLIPBOARD_COLOR 8
#define PIXEL_TYPE_START_COLOR 10

#define COLOR_CONTROL_VALID 0x0001
#define COLOR_CONTROL_UPDATED 0x0002
#define COLOR_CONTROL_OVERWRITE 0x0004
#define COLOR_CONTROL_EXCLUDE_BKG 0x0008
#define COLOR_LOCAL 0x0010

struct color_scale_rec
   {
    char *label;
    unsigned long first,first_visible; /* start from 0 */
    unsigned long num_colors;
    unsigned short status;
    int lb,ub;  /* if range is set lb = ub = range / 2 */
    int mid_value,range;
   };

struct color_rec
   {
    unsigned status; /* FREE_RGB_BUFFERS */
    unsigned long total_colors;
    int use_system_colors;
    unsigned long num_system_colors,reserve_color_start;

/*
   red[0]-green[0]-blue[0] always specifies the rgb value for the background
     color.
   red[num_colors-1]-green[num_colors-1]-blue[num_colors-1] always specifies the     rgb value for the foreground color.
*/
    unsigned short *ori_red,*ori_green,*ori_blue;
    unsigned short *red,*green,*blue;
    unsigned long *color_indxs;
#define BACKGROUND_COLOR 1
#define FOREGROUND_COLOR 2
    unsigned char *color_status;
   };

struct intensity_rec
   {
    char *label;
    struct color_rec color;
    unsigned long cur_scale,num_scales,total_scales;
    struct color_scale_rec *scales;
   };

#endif INTENSITY_H
