/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This header file depends on XView.

FIXME:  This header file does not appear to actually be used anywhere in NRIA.
****************************************************************************/

#ifndef MRITOA_NEW_H
#define MRITOA_NEW_H

#include "mri_format.h"
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <sunwindow/notify.h>

struct panel1_rec 
   {
    Panel panel;
    Panel_item show_header,next_patient,help,quit;
   };

struct panel2_rec 
   {
    Panel panel;
    Panel_item study_num,date,name,study,history,series,comment,orientation,
               seq_code,fov,dim_size,numslices,thickness,spacing,numecho,
               pixelsize,effective_spacing,scan_voxel_vol,interpolate_fac,
               cubic_voxel_vol;
   };

 struct patient_rec
   {
    char study_num[6],date[11],name[31],study[61],
         history[61],series[4],comment[121],
         orientation[13],seq_code[10];
    unsigned short dim_size,numslices,numecho;
    float pixelsize,spacing,fov,thickness,interpolate_fac,scan_voxel_vol,
          cubic_voxel_vol;
    int output_type,cur_slice_offset,new_slice_offset;
   };

struct panel3_rec 
   {
    Panel panel;
    Panel_item output_fn,scale_option,show_slice_num,start_reading;
   };

struct img_canvas_rec
   {
    Frame frame;
    Panel panel;
    Panel_item range,min_value,max_value;
    Canvas canvas,scaled_canvas;
    struct buf_2d_rec ori_data;
    struct buf_2d_rec raw_data;
    struct buf_2d_rec scaled_data;
    };

#define START_READING_IMG 0x0001
#define NEXT_PATIENT_READY 0x0002
#define REWIND 0x0010
#define SKIP_TO_START 0x0020
#define SKIP_DATA 0x0040
#define DISPLAY_DATA_AVAILABLE 0x0080

struct mritoa_prog_rec
   {
    unsigned short status;
    Frame frame;
    Pixfont *font;
    struct panel1_rec panel1;
    struct panel2_rec panel2;
    struct panel3_rec panel3;
    struct intensity_rec intensity;
    struct patient_rec patient;
    struct img_canvas_rec img;

   };


#endif /* MRITOA_NEW_H */
