/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef SEGMENT_H
#define	SEGMENT_H

#include "common.h"
#include "rect.h"
#include "str_def.h"
#include "histo.h"

struct range_indx_rec
   {int range,indx,lb,ub;
   };

struct type_indx_rec
   {
    unsigned short dist;
    unsigned short indx;
   };

struct type_val_rec
   {
    short valx,valy;
    unsigned short num_types;
    struct type_indx_rec *types;
   };

struct the_type_val_rec
   {
    unsigned long total_sets,num_sets;
    struct type_val_rec **sets;
   };

struct stack_xy_rec
   {
    struct pixel_neighbor_type_rec *pix_neigh;
    short x,y;
    struct stack_xy_rec *last,*next;
   };

struct stack_xy_list_rec
   {
    struct stack_xy_rec *top,*bot;
   };

#define STACK_LIST_REC_PROCESSED 0x01
struct stack_list_rec
   {unsigned char status;
    short valx,valy;
    struct stack_xy_rec top,*bot;
   };

struct pixel_stack_rec_ptr
   {
    unsigned long total_lists,num_lists;
    struct stack_list_rec **lists;
   };

#define TISSUE_TYPE_EDITED 0x0001
#define TISSUE_TYPE_SHARED 0x0002
struct grow_rec
   {
    unsigned short status;
    char *label;
    struct pixel_type_ave_rec type_ave;
    char is_done_grow;
    struct buf_2d_rec done_grown;
    struct pixel_stack_rec_ptr grow_stack;
   };

struct segment_rec
   {
    unsigned short status;
    struct buf_2d_rec image_mask;
    struct int_bound_rec bound;
    unsigned long num_types;
    struct grow_rec *types;
    struct buf_2d_rec histo_types;
   };

struct all_segment_rec
   {
    unsigned long num_segs;
    struct segment_rec *segs;
   };

struct type_conn_fac_rec
    {float conn_fac;
     unsigned short type;
    };

#define TYPE_RESOLVED 1
#define TYPE_DONT_CONSIDER 2
#define TYPE_CONSIDER 4
#define LEFT_OVER_WEIGHTS_CHECKED 8
#define TYPE_CHECKED 16
#define IN_SOLVE 0x0020
#define IN_REMAIN 0x0040
#define TYPE_SCANNED 0x0080

#define TYPE_PROCESSED 0x0097
#define TYPE_RESOLVED_OR_CHECKED_OR_DONT_CONSIDER 0x0013
#define TYPE_RESOLVED_OR_CONSIDER_OR_DONT_CONSIDER 0x0007

struct neighbor_type_rec
    {
     unsigned char status;

     unsigned char done_neighs;
     float weights[8];
     struct stack_xy_rec *xy_ptr;

     struct type_conn_fac_rec neighs[8];
     unsigned char num_neighs;
    };

struct pixel_neighbor_type_rec
   {
    struct type_val_rec *pix;
    struct neighbor_type_rec *neigh;
   };

struct xy_pixel_neighbor_type_rec
   {short x,y;
    struct pixel_neighbor_type_rec *pix_neigh;
   };

#endif SEGMENT_H
