/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef SPECT_HDR_H
#define	SPECT_HDR_H

#define SPECT_PROJECTED_DATA 1
#define SPECT_RAW_DATA 2
#define SPECT_CONVOLVED_DATA 3
#define SPECT_IMAGE_DATA 4
#define SPECT_CINE_DATA 5
#define SPECT_IMAGE_MARKER_DATA 6
#define SPECT_CURVE_DATA 7
#define SPECT_GRAPHICS_DATA 8

struct manufacturer_rec
   {
    unsigned char bytes[24];
    unsigned short data_type;
   };

struct spect_patient_rec
   {
    char name[22];
    char pid[22];
    unsigned char bmonth;
    unsigned char bday;
    unsigned short byear;
    char sex[2];
   };

struct hospital_rec
   {char radiologist[22];
    char doctor[22];
    char opr[4];
    char hosp[22];
    char hospid[22];
   };

struct acquisition_rec
   {
    unsigned short protocol_id;
    char seq_num[8];
    unsigned short acq_num;
    unsigned short study_type;
    unsigned char smonth;
    unsigned char sday;
    unsigned short syear;
    char start_time[10];
    unsigned char emonth;
    unsigned char eday;
    unsigned short eyear;
    char end_time[10];
    unsigned short acq_type;
    short table_transverse_posi;
    short table_height;
    short pixel_size;
    unsigned short gantry_direction;
    unsigned short num_scans;
    short start_angle;
    short angle_range;
    short num_projections;
    unsigned char bytes[68];
    char xpixel_size[12];
    char ypixel_size[12];
    long dimx,dimy;
    unsigned char bytes1[46];
    char gantry_direction_str[2];
    char gantry_orientation[2];
    unsigned char bytes2[134];
   };

struct display_rec
   {
    char x_axis_tag[6];
    char y_axis_tag[6];
    short yz_twist;
    short xz_tilt;
    unsigned short plane_type;
    unsigned short ppf;
    char rid[12];
    unsigned char rmonth;
    unsigned char rday;
    unsigned short ryear;
    char recon_time[10];
    char cfs[16];
    unsigned short max_pixel_val,min_pixel_val;
    unsigned short slr;
    short slice_offset;
    unsigned short recon_thickness;
    unsigned short slice_dist;
    unsigned short num_slices;
    short zx,zy;
    unsigned short zd;
    char recon_xpixel_size[12],recon_ypixel_size[12];
    unsigned short vsp;
    long recon_dimx,recon_dimy;
    unsigned short recon_algo;
    char recon_factor[12];
    unsigned short rsa;
    char pad[2];
    char atten_coeff[12];
    char scale_factor[12];
   };

struct misc_rec
   {
    char bytes[64];
   };

struct spect_hdr_rec
   {
    struct manufacturer_rec manu;
    struct spect_patient_rec patient;
    struct hospital_rec hosp;
    struct acquisition_rec acq;
    struct display_rec display;
    struct misc_rec misc;
   };

#endif SPECT_HDR_H
