/****************************************************************************
2d_and_mask.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2d_and_mask.c,v 1.12 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <math.h>
#include <stdio.h>

/*  FIXME:  Never used???
#include <sys/types.h>
#include <sys/timeb.h>
*/

#include "common.h"
#include "error_constants.h"
#include "rect.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)


/* Private functions defined in this file */
int process_buf_2d_rec_by_not_mask(struct buf_2d_rec *_2d, 
    long startleft, long starttop, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, int (*proc)(), void *arg1, void *arg2, 
    void *arg3, void *arg4, void *arg5, void *arg6, void *arg7);
int process_buf_2d_rec_by_general_mask(struct buf_2d_rec *_2d, 
    long startleft, long starttop, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, int (*proc)(), void *arg1, void *arg2, 
    void *arg3, void *arg4, void *arg5, void *arg6, void *arg7);
int process_buf_2d_rec_by_not_general_mask(struct buf_2d_rec *_2d, 
    long startleft, long starttop, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, int (*proc)(), void *arg1, void *arg2, 
    void *arg3, void *arg4, void *arg5, void *arg6, void *arg7);
int Set2d(struct buf_2d_rec *result, long startleft, long starttop, 
    struct buf_2d_rec *mask, struct int_bound_rec *bound, double value);
int Set2dByNotMask(struct buf_2d_rec *result, long startleft, 
    long starttop, struct buf_2d_rec *mask, struct int_bound_rec *bound, 
    double value);
int SelectSet2d(struct buf_2d_rec *result, long startleft, 
    long starttop, struct buf_2d_rec *mask, struct int_bound_rec *bound, 
    double lb, double ub, double setval, int isSetNotInRange, 
    double NotInRangeVal);
int assign_buf_2d_rec_by_mask_proc(struct buf_2d_rec *dest, long row, 
    long col, struct buf_2d_rec *src, long startleft, long starttop);
int PickAssign2d_1(struct buf_2d_rec *dest, struct buf_2d_rec *src, 
    struct buf_2d_rec *type_2d, long src_startleft, long src_starttop, 
    struct int_bound_rec *bound, char *pick_types, 
    unsigned long num_pick_types);
int Smooth2dByMask(struct buf_2d_rec *_2d, long startleft, 
    long starttop, struct buf_2d_rec *mask, struct int_bound_rec *bound, 
    long num_neighbors);
int Add2dsAndScaleByMask(struct buf_2d_rec *dest, 
    struct buf_2d_rec *src, long startleft, long starttop, 
    struct buf_2d_rec *mask, struct int_bound_rec *bound, int is_abs);
int Minus2dsAndScaleByMask(struct buf_2d_rec *dest, 
    struct buf_2d_rec *src, long startleft, long starttop, 
    struct buf_2d_rec *mask, struct int_bound_rec *bound, int is_abs);
int map_buf_2d_rec_by_bound_mask(struct buf_2d_rec *result, 
    long startleft, long starttop, struct buf_2d_rec *_2d, 
    struct buf_2d_rec *mask, struct int_bound_rec *bound, 
    unsigned long *map_values, unsigned long num_map_values, 
    unsigned long const_val);
int assign_buf_2d_rec_by_not_mask(struct buf_2d_rec *dest, 
    struct buf_2d_rec *src, long startleft, long starttop, 
    struct buf_2d_rec *mask, struct int_bound_rec *bound);
int map_buf_2d_rec_by_bound_mask_and_ratio(struct buf_2d_rec *result, 
    long startleft, long starttop, double xratio, double yratio, 
    struct buf_2d_rec *_2d, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, unsigned long *map_values, 
    unsigned long num_map_values, unsigned long const_val);
int Set2dProc(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double *value);
int SelectSet2dProc(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double *lb, double *ub, double *setval, 
    int *isSetNotInRange, double *NotInRangeVal);
int PickAssign2dByMaskProc(struct buf_2d_rec *dest, 
    long row, long col, struct buf_2d_rec *src, struct buf_2d_rec *type_2d, 
    char *pick_types, unsigned long num_pick_types);
int Abs2dByMaskProc(struct buf_2d_rec *dest, unsigned long row, 
    unsigned long col);
int Smooth2dByMaskProc(struct buf_2d_rec *src, unsigned long row, 
    unsigned long col, struct buf_2d_rec *dest, long num_neighbors);
int Add2dsByMaskProc(struct buf_2d_rec *dest, unsigned long row, 
    unsigned long col, struct buf_2d_rec *src1, struct buf_2d_rec *src2);
int Add2dsAndScale(struct buf_2d_rec *dest, struct buf_2d_rec *src, 
    int is_abs);
int Add2dsByBound(struct buf_2d_rec *dest, struct buf_2d_rec *src1, 
    long dleft, long dtop, long dright, long dbottom, long dx, long dy, 
    struct buf_2d_rec *src2, long sleft, long stop, long sright, long sbottom,
    double dstmin, double dstmax, double srcmin, double srcmax, 
    int unselected_is_dest, int is_add_all, int is_ave, int is_scale, 
    double scale_min, double scale_max);
int Minus2dsByMaskProc(struct buf_2d_rec *dest, unsigned long row, 
    unsigned long col, struct buf_2d_rec *src1, struct buf_2d_rec *src2);
int Minus2dsAndScale(struct buf_2d_rec *dest, struct buf_2d_rec *src, 
    int is_abs);
int Map2dPixelValues(struct buf_2d_rec *in_2d, 
    struct buf_2d_rec *out_2d, unsigned long *map_indx, 
    unsigned long num_indxs, unsigned long indx_depth, 
    unsigned long first_indx_value);
int BitMaskTo2d(struct buf_2d_rec *_2d, struct buf_2d_rec *mask);


/*-----------------------------------------------------------------------
process_buf_2d_rec_by_mask - ???
------------------------------------------------------------------------*/

int
process_buf_2d_rec_by_mask(
    struct buf_2d_rec *_2d,
    long startleft,
    long starttop,
    struct buf_2d_rec *mask,
    struct int_bound_rec *bound,
    int (*proc)(),
    void *arg1,
    void *arg2,
    void *arg3,
    void *arg4,
    void *arg5,
    void *arg6,
    void *arg7,
    void *arg8,
    void *arg9)
{
 long row,col,col_bit,indx,start_bit,end_bit,cnt,y;
 struct int_bound_rec bound1;
 long start_byte,start_col_bit,stop_byte;
 /* Changed the following line from long to int, since there seems to be
    no reason to use long, especially since the variables in question get
    their values copied from int variables and the use of long is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left, right, top, bottom;
 unsigned char source_byte;
 int err;

 setup_int_bound_rec(&bound1,0,0,mask->dimx - 1,mask->dimy - 1);
 if (bound == NULL)
     valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
 else 
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);
 if ((startleft + left) >= (long) _2d->dimx) return NO_ERROR;
 if ((startleft + right) >= (long) _2d->dimx)
    right = _2d->dimx - startleft - 1;
 if ((starttop + top) >= (long) _2d->dimy) return NO_ERROR;
 if ((starttop + bottom) >= (long) _2d->dimy)
    bottom = _2d->dimy - starttop - 1;

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 y = top + starttop;
 for (row = top; row <= bottom; row++,y++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        /* FIXME: The assignment in the next line appears to be valid
	   but this has not be definitively tested.  -PWH 19990301 */
        if ((source_byte = mask->buf[row][col]) != 0)
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & C_which_bit[cnt])
                  {if ((err = proc(_2d,y,indx + startleft,
                        arg1,arg2,arg3,arg4,
                        arg5,arg6,arg7,arg8,arg9)) != NO_ERROR)
                      return err;
                  }
           }
     }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
process_buf_2d_rec_by_not_mask - ???
------------------------------------------------------------------------*/

int
process_buf_2d_rec_by_not_mask(
    struct buf_2d_rec *_2d,
    long startleft,
    long starttop,
    struct buf_2d_rec *mask,
    struct int_bound_rec *bound,
    int (*proc)(),
    void *arg1,
    void *arg2,
    void *arg3,
    void *arg4,
    void *arg5,
    void *arg6,
    void *arg7)
{
 long row,col,col_bit,indx,start_bit,end_bit,cnt,y;
 struct int_bound_rec bound1;
 long start_byte,start_col_bit,stop_byte;
 /* Changed the following line from long to int, since there seems to be
    no reason to use long, especially since the variables in question get
    their values copied from int variables and the use of long is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left, right, top, bottom;
 unsigned char source_byte;
 int err;

 setup_int_bound_rec(&bound1,0,0,mask->dimx - 1,mask->dimy - 1);
 if (bound == NULL)
     valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
 else 
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);
 if ((startleft + left) >= (long) _2d->dimx) return NO_ERROR;
 if ((startleft + right) >= (long) _2d->dimx)
    right = _2d->dimx - startleft - 1;
 if ((starttop + top) >= (long) _2d->dimy) return NO_ERROR;
 if ((starttop + bottom) >= (long) _2d->dimy)
    bottom = _2d->dimy - starttop - 1;
 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 y = top + starttop;
 for (row = top; row <= bottom; row++,y++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if ((source_byte = mask->buf[row][col]) != 0xff)
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (!(source_byte & C_which_bit[cnt]))
                  {if ((err = proc(_2d,y,indx + startleft,
                        arg1,arg2,arg3,arg4,arg5,arg6,arg7)) != NO_ERROR)
                      return err;
                  }
           }
     }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
process_buf_2d_rec_by_general_mask - ???
------------------------------------------------------------------------*/

int
process_buf_2d_rec_by_general_mask(
    struct buf_2d_rec *_2d,
    long startleft,
    long starttop,
    struct buf_2d_rec *mask,
    struct int_bound_rec *bound,
    int (*proc)(),
    void *arg1,
    void *arg2,
    void *arg3,
    void *arg4,
    void *arg5,
    void *arg6,
    void *arg7)
{
 long row,col;
 struct int_bound_rec bound1;
 unsigned long y;
 /* Changed the following line from long to int, since there seems to be
    no reason to use long, especially since the variables in question get
    their values copied from int variables and the use of long is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left,right,top,bottom;
 int err;

 setup_int_bound_rec(&bound1,0,0,mask->dimx - 1,mask->dimy - 1);
 if (bound == NULL)
     valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
 else 
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);
 if ((startleft + left) >= (long) _2d->dimx) return NO_ERROR;
 if ((startleft + right) >= (long) _2d->dimx)
    right = _2d->dimx - startleft - 1;
 if ((starttop + top) >= (long) _2d->dimy) return NO_ERROR;
 if ((starttop + bottom) >= (long) _2d->dimy)
    bottom = _2d->dimy - starttop - 1;

 y = top + starttop;
 for (row = top; row <= bottom; row++,y++)
    for (col = left; col <= right; col++)
       if (mask->GetVal(mask,row,col) != .0)
          {if ((err = proc(_2d,y,col + startleft,
                        arg1,arg2,arg3,arg4,arg5,arg6,arg7)) != NO_ERROR)
              return err;
          }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
process_buf_2d_rec_by_not_general_mask - ???
------------------------------------------------------------------------*/

int
process_buf_2d_rec_by_not_general_mask(
    struct buf_2d_rec *_2d,
    long startleft,
    long starttop,
    struct buf_2d_rec *mask,
    struct int_bound_rec *bound,
    int (*proc)(),
    void *arg1,
    void *arg2,
    void *arg3,
    void *arg4,
    void *arg5,
    void *arg6,
    void *arg7)
{
 long row,col;
 struct int_bound_rec bound1;
 unsigned long y;
 /* Changed the following line from long to int, since there seems to be
    no reason to use long, especially since the variables in question get
    their values copied from int variables and the use of long is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left,right,top,bottom;
 int err;

 setup_int_bound_rec(&bound1,0,0,mask->dimx - 1,mask->dimy - 1);
 if (bound == NULL)
     valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
 else
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);
 if ((startleft + left) >= (long) _2d->dimx) return NO_ERROR;
 if ((startleft + right) >= (long) _2d->dimx)
    right = _2d->dimx - startleft - 1;
 if ((starttop + top) >= (long) _2d->dimy) return NO_ERROR;
 if ((starttop + bottom) >= (long) _2d->dimy)
    bottom = _2d->dimy - starttop - 1;

 y = top + starttop;
 for (row = top; row <= bottom; row++,y++)
    for (col = left; col <= right; col++)
       if (mask->GetVal(mask,row,col) == .0)
          {if ((err = proc(_2d,y,col + startleft,
                        arg1,arg2,arg3,arg4,arg5,arg6,arg7)) != NO_ERROR)
              return err;
          }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Set2dProc - ???
------------------------------------------------------------------------*/

int
Set2dProc(_2d,row,col,value)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double *value;
{
 _2d->SetVal(_2d,row,col,*value);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Set2d - ???
------------------------------------------------------------------------*/

int
Set2d(result,startleft,starttop,mask,bound,value)
 struct buf_2d_rec *result;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 double value;
{
 if (mask == NULL)
    {if (bound == NULL)
        return Set2dByArea(result,startleft,starttop,result->dimx - 1,
                    result->dimy - 1,value);
       else 
        return Set2dByArea(result,startleft + bound->left,starttop + bound->top,
            startleft + bound->right,starttop + bound->bottom,value);
    }
   else if (mask->pixel_depth == 1)
    return process_buf_2d_rec_by_mask(result,startleft,starttop,
                            mask,bound,Set2dProc,&value,0,0,0,0,0,0,0,0);
   else 
    return process_buf_2d_rec_by_general_mask(result,startleft,starttop,
                            mask,bound,Set2dProc,&value,0,0,0,0,0,0);
}



/*-----------------------------------------------------------------------
Set2dByNotMask - ???
------------------------------------------------------------------------*/

int
Set2dByNotMask(result,startleft,starttop,mask,bound,value)
 struct buf_2d_rec *result;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 double value;
{
 if (mask->pixel_depth == 1)
    return process_buf_2d_rec_by_not_mask(result,startleft,starttop,mask,bound,
                            Set2dProc,&value,0,0,0,0,0,0);
   else return process_buf_2d_rec_by_not_general_mask(result,startleft,
                   starttop,mask,bound,Set2dProc,&value,0,0,0,0,0,0);
}



/*-----------------------------------------------------------------------
SelectSet2dProc - ???
------------------------------------------------------------------------*/

int
SelectSet2dProc(_2d,row,col,lb,ub,setval,isSetNotInRange,NotInRangeVal)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double *lb,*ub,*setval,*NotInRangeVal;
 int *isSetNotInRange;
{
 double val;

 val = _2d->GetVal(_2d,row,col);
 if ((val >= *lb) && (val <= *ub))
    _2d->SetVal(_2d,row,col,*setval);
   else if (*isSetNotInRange)
    _2d->SetVal(_2d,row,col,*NotInRangeVal);

 return NO_ERROR;
}



/*-----------------------------------------------------------------------
SelectSet2d - ???
------------------------------------------------------------------------*/

int
SelectSet2d(result,startleft,starttop,mask,bound,lb,ub,setval,
              isSetNotInRange,NotInRangeVal)
 struct buf_2d_rec *result;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 double lb,ub,setval,NotInRangeVal;
 int isSetNotInRange;
{
 struct int_bound_rec bound1;

 if (mask == NULL)
    {if (bound == NULL)
        {setup_int_bound_rec(&bound1,startleft,starttop,
            result->dimx - 1,result->dimy - 1);
         SelectSet2dValue(result,&bound1,lb,ub,setval,
                     isSetNotInRange,NotInRangeVal);
        }
       else
        {bound1 = *bound;
         move_int_bound_rec(&bound1,startleft,starttop);
         return SelectSet2dValue(result,&bound1,lb,ub,setval,
                     isSetNotInRange,NotInRangeVal);
        }
    }
   else if (mask->pixel_depth == 1)
    return process_buf_2d_rec_by_mask(result,startleft,starttop,mask,bound,
                            SelectSet2dProc,&lb,&ub,&setval,
                            &isSetNotInRange,&NotInRangeVal,0,0,0,0);
   else 
    return process_buf_2d_rec_by_general_mask(result,startleft,starttop,mask,bound,
                            SelectSet2dProc,&lb,&ub,&setval,
                            &isSetNotInRange,&NotInRangeVal,0,0);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
assign_buf_2d_rec_by_mask_proc - ???
------------------------------------------------------------------------*/

int
assign_buf_2d_rec_by_mask_proc(dest,row,col,src,startleft,starttop)
 struct buf_2d_rec *dest,*src;
 long row,col;
 long startleft,starttop;
{
 dest->SetVal(dest,row,col,
        src->GetVal(src,row-starttop,col - startleft));
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
assign_buf_2d_rec_by_mask - ???
------------------------------------------------------------------------*/

int
assign_buf_2d_rec_by_mask(dest,src,startleft,starttop,mask,bound)
 struct buf_2d_rec *dest,*src;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
{
 if (mask == NULL) return CANCEL;
 if (mask->pixel_depth != 1)
    return process_buf_2d_rec_by_general_mask(dest,startleft,starttop,mask,
               bound, assign_buf_2d_rec_by_mask_proc,src,&startleft,&starttop,
               0,0,0,0);
   else 
       return process_buf_2d_rec_by_mask(dest,startleft,starttop,mask,bound,
                   assign_buf_2d_rec_by_mask_proc,src,&startleft,&starttop,
		   0,0,0,0,0,0);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
PickAssign2dByMaskProc - ???
------------------------------------------------------------------------*/

int
PickAssign2dByMaskProc(
    struct buf_2d_rec *dest,
    long row,
    long col,
    struct buf_2d_rec *src,
    struct buf_2d_rec *type_2d,
    char *pick_types,
    unsigned long num_pick_types)
{
 double val;
 unsigned long indx;

 val = type_2d->GetVal(type_2d,row,col);
 indx = (unsigned long) rint(val);
 if ((indx < num_pick_types) && pick_types[indx])
    {val = src->GetVal(src,row,col);
     dest->SetVal(dest,row,col,val);}
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
PickAssign2d_1 - ???
------------------------------------------------------------------------*/

int
PickAssign2d_1(dest,src,type_2d,
               src_startleft,src_starttop,bound,pick_types,num_pick_types)
 struct buf_2d_rec *dest,*src,*type_2d;
 long src_startleft,src_starttop;
 struct int_bound_rec *bound;
 char *pick_types;
 unsigned long num_pick_types;
{
 struct int_bound_rec bound1;
 /* Changed the following line from long to int, since there seems to be
    no reason to use long, especially since the variables in question get
    their values copied from int variables and the use of long is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left,right,top,bottom;
 double val;
 unsigned long row,col,x,y,indx;

 setup_int_bound_rec(&bound1,0,0,src->dimx - 1,src->dimy - 1);
 if (bound == NULL)
    valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
   else valid_bound(bound,&bound1,&left,&right,&top,&bottom);
 if ((src_startleft + left) >= (long) dest->dimx) return NO_ERROR;
 if ((src_startleft + right) >= (long) dest->dimx)
    right = dest->dimx - src_startleft - 1;
 if ((src_starttop + top) >= (long) dest->dimy) return NO_ERROR;
 if ((src_starttop + bottom) >= (long) dest->dimy)
    bottom = dest->dimy - src_starttop - 1;
 y = top + src_starttop;
 for (row = top; row <= bottom; row++,y++)
    for (x = left + src_startleft,col = left; col <= right; col++,x++)
       {val = type_2d->GetVal(type_2d,row,col);
        indx = (unsigned long) rint(val);
        if ((indx < num_pick_types) && pick_types[indx])
           {val = src->GetVal(src,row,col);
            dest->SetVal(dest,y,x,val);
           }
       }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
PickAssign2d - ???
------------------------------------------------------------------------*/

int
PickAssign2d(dest,src,type_2d,startleft,starttop,mask,bound,pick_types,
             num_pick_types)
 struct buf_2d_rec *dest,*src,*type_2d;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 char *pick_types;
 unsigned long num_pick_types;
{
 if (mask == NULL)
    return PickAssign2d_1(dest,src,type_2d,
                      startleft,starttop,bound,pick_types,num_pick_types);
   else 
    return process_buf_2d_rec_by_mask(dest,startleft,starttop,mask,bound,
        PickAssign2dByMaskProc,src,type_2d,pick_types,&num_pick_types,
        0,0,0,0,0);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
assign_buf_2d_rec_by_not_mask - ???
------------------------------------------------------------------------*/

int
assign_buf_2d_rec_by_not_mask(dest,src,startleft,starttop,mask,bound)
 struct buf_2d_rec *dest,*src;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
{
 return process_buf_2d_rec_by_not_mask(dest,startleft,starttop,mask,bound,
                   assign_buf_2d_rec_by_mask_proc,src,&startleft,&starttop,
		   0,0,0,0);

}



/*-----------------------------------------------------------------------
Abs2dByMaskProc - ???
------------------------------------------------------------------------*/

int
Abs2dByMaskProc(dest,row,col)
 struct buf_2d_rec *dest;
 unsigned long row,col;
{
 double val;

 val = dest->GetVal(dest,row,col);
 if (val < .0)
    dest->SetVal(dest,row,col,-val);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Smooth2dByMaskProc - ???
------------------------------------------------------------------------*/

int
Smooth2dByMaskProc(src,row,col,dest,num_neighbors)
 struct buf_2d_rec *src,*dest;
 unsigned long row,col;
 long num_neighbors;
{
 double val;

 val = Smooth2dValue(src,row,col,num_neighbors);
 dest->SetVal(dest,row,col,val);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Smooth2dByMask - ???
------------------------------------------------------------------------*/

int
Smooth2dByMask(_2d,startleft,starttop,mask,bound,num_neighbors)
 struct buf_2d_rec *_2d;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 long num_neighbors;
{
 struct buf_2d_rec buf;
 int err;

 init_buf_2d_rec(&buf);
 if ((err = SetupBuf2dRec(&buf,_2d->dimx,_2d->dimy,_2d->pixel_depth,
         _2d->status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    return err;
 process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,bound,
			    Smooth2dByMaskProc,&buf,&num_neighbors,
			    0,0,0,0,0,0,0);
 assign_buf_2d_rec_by_mask(_2d,&buf,startleft,starttop,mask,bound);
 free_buf_2d_rec(&buf);
 _2d->status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Add2dsByMaskProc - ???
------------------------------------------------------------------------*/

int
Add2dsByMaskProc(dest,row,col,src1,src2)
 struct buf_2d_rec *dest,*src1,*src2;
 unsigned long row,col;
{
 double val;

 val = src1->GetVal(src1,row,col);
 val += src2->GetVal(src2,row,col);
 dest->SetVal(dest,row,col,val);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Add2dsAndScaleByMask - ???
------------------------------------------------------------------------*/

int
Add2dsAndScaleByMask(dest,src,startleft,starttop,mask,bound,is_abs)
 struct buf_2d_rec *dest,*src;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 int is_abs;
{
 struct buf_2d_rec buf;
 int err;
 double minval,maxval,min,max;

 init_buf_2d_rec(&buf);
 if ((err = SetupSameDimxyDst2d(&buf,dest,src,1)) != NO_ERROR)
    return err;
 process_buf_2d_rec_by_mask(&buf,startleft,starttop,mask,bound,
                           Add2dsByMaskProc,dest,src,0,0,0,0,0,0,0);
 if (is_abs) process_buf_2d_rec_by_mask(&buf,startleft,starttop,mask,bound,
                            Abs2dByMaskProc,0,0,0,0,0,0,0,0,0);
 err = MinMax2dByMask(&buf,startleft,starttop,mask,bound,&min,&max);
 Default2dMinMax(dest,&minval,&maxval,0,(double) .0,(double) .0);
 if ((min >= minval) && (max <= maxval))
    assign_buf_2d_rec_by_mask(dest,&buf,startleft,starttop,mask,bound);
   else
    {GetMinMaxValues(dest,&minval,&maxval);
     Scale2dByMask(&buf,dest,0,0,mask,bound,min,max,minval,maxval);}
 free_buf_2d_rec(&buf);

 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Add2dsAndScale - ???
------------------------------------------------------------------------*/

int
Add2dsAndScale(dest,src,is_abs)
 struct buf_2d_rec *dest,*src;
 int is_abs;
{
 struct buf_2d_rec buf;
 double minval,maxval,min,max;
 int err;

 init_buf_2d_rec(&buf);
 if ((err = SetupSameDimxyDst2d(&buf,dest,src,1)) != NO_ERROR)
 PRT1(printf("Add2dsAndScale....&buf\n"))
 PRT1(pr_buf_2d_rec(&buf))
 Add2ds(&buf,dest,src);
 if (is_abs) Abs2d(&buf);
 Default2dMinMax(&buf,&min,&max,0,(double) .0,(double) .0);
 Default2dMinMax(dest,&minval,&maxval,0,(double) .0,(double) .0);
 PRT1(printf(" min = %f max = %f minval = %f maxval = %f\n",min,max,minval,maxval))
 if ((min >= (long) minval) && (max <= (long) maxval))
    {PRT1(printf("Add2dsAndScale...assign\n"))
     Assign2d(dest,&buf);
    }
   else
    {GetMinMaxValues(dest,&minval,&maxval);
     PRT1(printf("Add2dsAndScale...minval = %f maxval = %f\n",minval,maxval))
     Scale2dPixels(dest,&buf,minval,maxval,0,(double) .0,(double) .0,0);}
 free_buf_2d_rec(&buf);
 return NO_ERROR;
} 



/*-----------------------------------------------------------------------
Add2dsByBound - ???
------------------------------------------------------------------------*/

int
Add2dsByBound(dest,
              src1,dleft,dtop,dright,dbottom,dx,dy,
              src2,sleft,stop,sright,sbottom,
              dstmin,dstmax,srcmin,srcmax,
              unselected_is_dest,is_add_all,is_ave,
              is_scale,scale_min,scale_max)
 struct buf_2d_rec *dest,*src1,*src2;
 long dleft,dtop,dright,dbottom,dx,dy,sleft,stop,sright,sbottom;
 double dstmin,dstmax,srcmin,srcmax,scale_min,scale_max;
 int unselected_is_dest,is_add_all,is_ave,is_scale;
{
 long drow,dcol,scol,dimx,dimy,x,y;
 struct buf_2d_rec buf;
 unsigned long pixel_depth,type4;
 double val,val1,maxval1;
 int err;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;

 PRT(printf("Add2dsByBound...dstmin = %d dstmax = %d...srcmin = %d srcmax = %d\n",
        dstmin,dstmax,srcmin,srcmax);)
 if (dest->status4 & BUF_NON_EMPTY) dest->status4 &= ~BUF_DATA_VALID;
 if (ValidDstAndSrcBound(dleft,dtop,dright,dbottom,dx,dy,
       sleft,stop,sright,sbottom,
       &vs1left,&vs1top,&vs1right,&vs1bottom,
       &vs2left,&vs2top,&vs2right,&vs2bottom) != NO_ERROR)
    {
     return NO_ERROR;}
 dimx = vs1right - vs1left + 1;
 dimy = vs1bottom - vs1top + 1;
 if ((dimx < 0) || (dimy < 0)) return NO_ERROR;

 init_buf_2d_rec(&buf);
 DefineDstDepthAndType(src1,src2,&pixel_depth,&type4,1);
 if ((err = SetupBuf2dRec(&buf,dimx,dimy,pixel_depth,type4)) != NO_ERROR) 
    return err;
 maxval1 = 0;
 for (y = 0,drow = vs1top; drow <= vs1bottom; drow++,y++,vs2top++)
    for (x = 0,scol = vs2left,dcol = vs1left; dcol <= vs1right; scol++,dcol++,x++)
       {val1 = src2->GetVal(src2,vs2top,scol);
        
        if (is_add_all || ((val1 >= srcmin) && (val1 <= srcmax)))
           {val = src1->GetVal(src1,drow,dcol);
            if (is_add_all || ((val >= dstmin) && (val <= dstmax)))
               {val += val1;
                if (is_ave) val /= 2;}
              else val = val1;
            }
          else
           {if (unselected_is_dest)
               {val = src1->GetVal(src1,drow,dcol);
                if ((val < dstmin) || (val > dstmax))
                   val = 0;
               }
              else val = 0;
           }
        if (val > maxval1) maxval1 = val;
        buf.SetVal(&buf,y,x,val);
       }
 if (is_scale)
    {Scale2dPixels(&buf,&buf,scale_min,scale_max,0,(double) .0,(double) .0,2);
     maxval1 = scale_max;}

 pixel_depth = find_num_bits_needed((unsigned long) rint(maxval1));
 PRT(printf("dest in...\n");pr_buf_2d_rec(dest))
 PRT(printf(" maxval1 = %f need dep = %d\n",
              maxval1,pixel_depth))
 if ((err = SetupBuf2dRecIfSmall(dest,dimx,dimy,pixel_depth,
         buf.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    Cp2dByBound(dest,0,0,dimx-1,dimy-1,0,0,
                 &buf,0,0,dimx-1,dimy-1,0,0,0,0);
 free_buf_2d_rec(&buf);
 PRT(printf("Add2dsByBound...end\n"))
 if (dest->status4 & BUF_NON_EMPTY) 
    {Set2dStartOffsetXY(dest,vs1left,vs1top);
     dest->status4 |= BUF_DATA_VALID;}
 return NO_ERROR;
} 



/*-----------------------------------------------------------------------
Minus2dsByMaskProc - ???
------------------------------------------------------------------------*/

int
Minus2dsByMaskProc(dest,row,col,src1,src2)
 struct buf_2d_rec *dest,*src1,*src2;
 unsigned long row,col;
{
 double val;

 val = src1->GetVal(src1,row,col);
 val -= src2->GetVal(src2,row,col);
 dest->SetVal(dest,row,col,val);
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Minus2dsAndScaleByMask - ???
------------------------------------------------------------------------*/

int
Minus2dsAndScaleByMask(dest,src,startleft,starttop,mask,bound,is_abs)
 struct buf_2d_rec *dest,*src;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 int is_abs;
{
 struct buf_2d_rec buf;
 int err;
 double min,max,minval,maxval;

 init_buf_2d_rec(&buf);
 if ((err = SetupSameDimxyDst2d(&buf,dest,src,2)) != NO_ERROR)
    return err;
 PRT1(printf("Minus2dsAndScaleByMask....&buf\n"))
 PRT1(pr_buf_2d_rec(&buf))
 process_buf_2d_rec_by_mask(&buf,startleft,starttop,mask,bound,
                            Minus2dsByMaskProc,dest,src,0,0,0,0,0,0,0);
 if (is_abs) process_buf_2d_rec_by_mask(&buf,startleft,starttop,mask,bound,
                            Abs2dByMaskProc,0,0,0,0,0,0,0,0,0);
 err = MinMax2dByMask(&buf,startleft,starttop,mask,bound,&min,&max);
 Default2dMinMax(dest,&minval,&maxval,0,(double) .0,(double) .0);
 PRT1(printf(" min = %f max = %f minval = %f maxval = %f\n",min,max,minval,maxval))
 if ((min >= minval) && (max <= maxval))
    {PRT1(printf("Minus2dsAndScaleByMask...assign\n"))
     assign_buf_2d_rec_by_mask(dest,&buf,startleft,starttop,mask,bound);}
   else
    {GetMinMaxValues(dest,&minval,&maxval);
     PRT1(printf("Minus2dsAndScaleByMask...minval = %f maxval = %f\n",minval,maxval))
     Scale2dByMask(&buf,dest,0,0,mask,bound,min,max,minval,maxval);
    }

 free_buf_2d_rec(&buf);

 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Minus2dsAndScale - ???
------------------------------------------------------------------------*/

int
Minus2dsAndScale(dest,src,is_abs)
 struct buf_2d_rec *dest,*src;
 int is_abs;
{
 struct buf_2d_rec buf;
 double minval,maxval,min,max;
 int err;

 init_buf_2d_rec(&buf);
 if ((err = SetupSameDimxyDst2d(&buf,dest,src,2)) != NO_ERROR)
 PRT1(printf("Minus2dsAndScale....&buf\n"))
 PRT1(pr_buf_2d_rec(&buf))
 Sub2ds(&buf,dest,src);
 if (is_abs) Abs2d(&buf);

 Default2dMinMax(&buf,&min,&max,0,(double) .0,(double) .0);
 Default2dMinMax(dest,&minval,&maxval,0,(double) .0,(double) .0);
 PRT1(printf(" min = %f max = %f minval = %f maxval = %f\n",min,max,minval,maxval))

 if ((min >= minval) && (max <= maxval))
    {PRT1(printf("Minus2dsAndScale...assign\n"))
     Assign2d(dest,&buf);
    }
   else
    {GetMinMaxValues(dest,&minval,&maxval);
     PRT1(printf("Minus2dsAndScale...minval = %f maxval = %f\n",minval,maxval))
     Scale2dPixels(dest,&buf,minval,maxval,0,(double) .0,(double) .0,0);}
 free_buf_2d_rec(&buf);
 return NO_ERROR;
} 



/*-----------------------------------------------------------------------
Sub2dsByBound - ???

This function appears to be both buggy and never used, and has therefore
been deleted.  If you really want it back, it's in the CVS repository.
                                       -PWH 19990316
------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------
map_buf_2d_rec_by_bound_mask - ???
------------------------------------------------------------------------*/

int
map_buf_2d_rec_by_bound_mask(result,startleft,starttop,_2d,mask,bound,
                          map_values,num_map_values,const_val)
 struct buf_2d_rec *result,*_2d;
 long startleft,starttop;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 unsigned long *map_values;
 unsigned long num_map_values,const_val;
{
 unsigned long row,col,col_bit,indx,start_bit,end_bit,cnt;
 struct int_bound_rec bound1;
 unsigned long start_byte,start_col_bit,stop_byte;
 double value;
 /* Changed the following line from ulong to int, since there seems to be
    no reason to use ulong, especially since the variables in question get
    their values copied from int variables and the use of ulong is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left,right,top,bottom;
 unsigned long indx1;
 unsigned char source_byte;

 setup_int_bound_rec(&bound1,0,0,mask->dimx - 1,mask->dimy - 1);
 if (bound == NULL)
     valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
 else 
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
	 /* FIXME: The assignment below is not known to be correct. */
        if ((source_byte = mask->buf[row][col]) != 0)
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & C_which_bit[cnt])
                  {value = _2d->GetVal(_2d,row,indx);
                   indx1 = (unsigned long) rint(value) + const_val;
                   if (indx1 < num_map_values)
                      result->SetVal(result,row + starttop,indx + startleft,
                        (double) map_values[indx1]);
                  }
           }
    }
 return NO_ERROR;

}



/*-----------------------------------------------------------------------
map_buf_2d_rec_by_bound_mask_and_ratio - ???
------------------------------------------------------------------------*/

int
map_buf_2d_rec_by_bound_mask_and_ratio(result,startleft,starttop,xratio,yratio,
                          _2d,mask,bound,
                          map_values,num_map_values,const_val)
 struct buf_2d_rec *result,*_2d;
 long startleft,starttop;
 float xratio,yratio;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
 unsigned long *map_values;
 unsigned long num_map_values,const_val;
{
 unsigned long row,col,col_bit,indx,start_bit,end_bit,row1;
 struct int_bound_rec bound1;
 unsigned long start_byte,start_col_bit,stop_byte,*adds,cur_col,cur_row,cnt;
 unsigned long nextrow,num_xpixels,num_ypixels,num_elems;
 /* Changed the following line from ulong to int, since there seems to be
    no reason to use ulong, especially since the variables in question get
    their values copied from int variables and the use of ulong is 
    inconsistent with the valid_bound function.  -PWH 19990301 */
 int left,right,top,bottom;
 unsigned long first,last;
 double *values;
 unsigned char source_byte;
 int err;

 if ((xratio <= .0) || (yratio > 1.0)) return ABORT;
 if ((yratio <= .0) || (yratio > 1.0)) return ABORT;
 if ((xratio == 1.0) && (yratio == 1.0))
    return map_buf_2d_rec_by_bound_mask(result,startleft,starttop,
                    _2d,mask,bound,
                    map_values,num_map_values,const_val);
 setup_int_bound_rec(&bound1,0,0,mask->dimx - 1,mask->dimy - 1);
 if (bound == NULL)
     valid_bound(&bound1,&bound1,&left,&right,&top,&bottom);
 else 
     valid_bound(bound,&bound1,&left,&right,&top,&bottom);
 num_xpixels = (long) floor((double) (1.0 / xratio + .5));
 num_ypixels = (long) floor((double) (1.0 / yratio + .5));
 num_elems = mask->dimx / num_xpixels;
 if (mask->dimx % num_xpixels) num_elems += 1;
 cnt = 0;
 get_ptr_memory((void **)&values, &cnt, num_elems, sizeof(*values), &err);
 if (err != NO_ERROR) return err;
 cnt = 0;
 get_ptr_memory((void**)&adds, &cnt, num_elems, sizeof(*adds), &err);
 if (err != NO_ERROR)
    {c_free(values);
     return err;}

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (cnt = 0; cnt < num_elems; cnt++)
    {adds[cnt] = 0;
     values[cnt] = 0;}

 first = left / num_xpixels;
 last = right / num_xpixels;
 if (right % num_xpixels) last += 1;
 for (row = top; row <= bottom; )
    {cur_row = row / num_ypixels;
     for (row1 = row; row1 <= bottom; row1++)
        {
         end_bit = 8;
         start_bit = left - start_col_bit;
         nextrow = row1 / num_ypixels;
         if (nextrow != cur_row) break;
         for (col_bit = start_col_bit,col = start_byte;
                 col < stop_byte; col++,col_bit += 8,start_bit = 0)
            {if (!(source_byte = mask->buf[row][col])) continue;

             if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
             for (indx = col_bit + start_bit,cnt = start_bit;
                       cnt < end_bit; cnt++,indx++)
                {
                 if (source_byte & C_which_bit[cnt])
                    {cur_col = indx / num_xpixels;
                     values[cur_col] += _2d->GetVal(_2d,row1,indx);
                     adds[cur_col] += 1;
                    }
                }
            }
         }
     for (cnt = first; cnt <= last; cnt++)
        {if (adds[cnt] > 0)
            {
             values[cnt] = values[cnt] / (double) adds[cnt];
             indx = (long) floor(
                    (double) ((double) values[cnt] + .5)) + const_val;
             if (indx > num_map_values) indx = num_map_values - 1;
             result->SetVal(result,cur_row + starttop,
                    cnt + startleft,(double) map_values[indx]);
             adds[cnt] = 0;
             values[cnt] = 0;
            }
        }
     row = row1;
    }
 c_free(adds);
 c_free(values);

 return NO_ERROR;
}



/*-----------------------------------------------------------------------
Map2dPixelValues - ???
------------------------------------------------------------------------*/

int
Map2dPixelValues(in_2d,out_2d,map_indx,num_indxs,indx_depth,first_indx_value)
 struct buf_2d_rec *in_2d,*out_2d;
 unsigned long *map_indx;
 unsigned long indx_depth,num_indxs,first_indx_value;
{
 unsigned long row,col,value,indx_value;
 double val;

 if (!is_same_buf_2d_rec_data_size(out_2d,in_2d)) return CANCEL;
 for (row = 0; row < in_2d->dimy; row++)
    for (col = 0; col < in_2d->dimx; col++)
       {val = (double) in_2d->GetVal(in_2d,row,col);
        value = (unsigned long) rint(val) + first_indx_value;
        if (value < num_indxs) {
           indx_value = get_1d_buf_value((unsigned char *)map_indx,
					 value, indx_depth);
	   value = indx_value - first_indx_value;
	   out_2d->SetVal(out_2d,row,col,(double) value); }
	else out_2d->SetVal(out_2d,row,col,(double) .0);
       }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
BitMaskTo2d - ???
------------------------------------------------------------------------*/

int
BitMaskTo2d(_2d,mask)
 struct buf_2d_rec *_2d,*mask;
{
 unsigned long row,col;
 unsigned long dimx,dimy;

 if (!(_2d->status4 & BUF_NON_EMPTY)) return CANCEL;
 if (!(mask->status4 & BUF_NON_EMPTY)) return CANCEL;
 if (mask->dimy > _2d->dimy) dimy = _2d->dimy;
    else dimy = mask->dimy; 
 if (mask->dimx > _2d->dimx) dimx = _2d->dimx;
    else dimx = mask->dimx;

 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx; col += 1)
       {if (mask->GetVal(mask,row,col) != .0)
           _2d->SetVal(_2d,row,col,(double) 1.0);
       }
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
_2dToBitMask - ???
------------------------------------------------------------------------*/

int
_2dToBitMask(mask,_2d,lb,ub)
 struct buf_2d_rec *mask,*_2d;
 double lb,ub;
{
 unsigned long row,col;
 unsigned long dimx,dimy;
 double val;

 if (!(mask->status4 & BUF_NON_EMPTY)) return CANCEL;
 if (!(_2d->status4 & BUF_NON_EMPTY)) return CANCEL;
 if (mask->dimy > _2d->dimy) dimy = _2d->dimy;
    else dimy = mask->dimy; 
 if (mask->dimx > _2d->dimx) dimx = _2d->dimx;
    else dimx = mask->dimx;

 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx; col += 1)
       {val = _2d->GetVal(_2d,row,col);
        if ((val >= lb) && (val <= ub))
           mask->SetVal(mask,row,col,(double) 1.0);
          else mask->SetVal(mask,row,col,(double) .0);
       }
 return NO_ERROR;
}

