#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include "error_constants.h"
#include "ia_hdr.h"
#include "mark_hdr.h"
/*
cc -c build_hdr_from_mark.c
*/
/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)

#define NO_ERROR 0
#define READ_ERROR -1
#define FILE_ACCESS_ERROR -3

/*
use_mark_hdr_to_fill_data_info_rec(info,mark_hdr)
load_hdr_file(fn,db)

build_hdr_from_mark_hdr_old(hdr,mark_hdr,num_echoes)
build_extra_file_info_rec_old(extra_info)
*/

use_mark_hdr_to_fill_data_info_rec(info,mark_hdr)
 struct data_info_rec *info;
 struct mark_hdr *mark_hdr;
{
 int err;

 if ((err = cp_str(&(info->image_id),MRI)) != NO_ERROR)
    return err;
 info->dimx = mark_hdr->dimen.dimx;
 info->dimy = mark_hdr->dimen.dimy;
 info->max_scans = mark_hdr->dimen.max_slices;
 info->max_pixel = (double) mark_hdr->dimen.glmax;
 info->min_pixel = (double) mark_hdr->dimen.glmin;
 info->pixel_depth_bits = mark_hdr->dimen.pixel_depth_bits;
 info->xpixel_size = mark_hdr->dimen.xpixel_size;
 info->ypixel_size = mark_hdr->dimen.ypixel_size;
 info->pixel_thickness = mark_hdr->dimen.pixel_thickness;

 return NO_ERROR;
}

load_hdr_file(fn,db)
 char *fn;
 struct mark_hdr *db;
{
 FILE *fid;
 int err;

 TRACE(printf("load_file_proc...\n"))

 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;

 if (fread(db,sizeof(struct mark_hdr),1,fid) != 1)
    {
     fclose(fid);
     printf("%s is a BAD DATA %s FILE !!!",fn);
     return READ_ERROR;}
 fclose(fid);
 return NO_ERROR;
}


build_hdr_from_mark_hdr_old(hdr,mark_hdr,num_echoes)
 struct hdr_rec *hdr;
 struct mark_hdr *mark_hdr;
 int num_echoes;
{
 int err;

 if ((err = cp_str(&(hdr->id),HDR_ID_V2)) != NO_ERROR)
    return err;
 use_mark_hdr_to_fill_data_info_rec(&(hdr->data_info),mark_hdr);
 if (num_echoes == 1)
    hdr->status = _1_ECHO_IMAGE;
   else hdr->status = _2_ECHO_IMAGE;
 hdr->data_info.num_echoes = num_echoes;
 return build_the_hdr(hdr);
}


build_extra_file_info_rec_old(extra_info)
 struct extra_file_info_rec *extra_info;
{

 cp_str(&(extra_info->color_bundle_label),"GRAY SCALE");
 memset(&(extra_info->color_control),(size_t) 0,
       (size_t) sizeof(struct color_control_rec));
 cp_str(&(extra_info->last_edit_begin),current_asctime());
 cp_str(&(extra_info->last_edit_end),current_asctime());
 TRACE(printf("last_edit_begin = %s last_edit_end = %s\n",
       extra_info->last_edit_begin,extra_info->last_edit_end))
}
