/****************************************************************************
common.c - Some tables used widely in NRIA and its library 

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This tables were taken from header files where they were defined
as static variables (not a clever idea).  They are sort of a
hodgepodge and might want to be cleaned up eventually.

This file is Xview- and GUI-clean, as far as I know.
****************************************************************************/

static const char rcsid[] = "$Id: common.c,v 1.5 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "common.h"
#include "buf_3d_rec.h"
#include "rect.h"


/*--------------------------------------------------------------------------
Offset and friends - ???

You must include common.h to use these tables
---------------------------------------------------------------------------*/

char neighbor_Offset[8][2] = 
   { {-1,-1}, { 0,-1}, { 1,-1}, { 1, 0}, { 1, 1}, { 0, 1}, {-1, 1}, {-1, 0}}; 

unsigned char C_which_bit[]  = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
unsigned char C_not_bit[]    = {0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};
unsigned char C_start_bits[] = {0x80,0xc0,0xe0,0xf0,0xf8,0xfc,0xfe,0xff};
unsigned char C_end_bits[]   = {0xff,0x7f,0x3f,0x1f,0x0f,0x07,0x03,0x01};


/*-------------------------------------------------------------------------
offset_3d and friends - ???

You must include buf_3d_rec.h to use this table 
---------------------------------------------------------------------------*/

char offset_3d[TOTAL_3D_NEIGHBORS][3] = 
        {{-1,-1,-1},{0,-1,-1} ,{1,-1,-1},
         {-1,0,-1} ,{0,0,-1}  ,{1,0,-1},
         {-1,1,-1} ,{0,1,-1}  ,{1,1,-1},

         {-1,-1,0},{0,-1,0} ,{1,-1,0},
         {-1,0,0} ,          {1,0,0},
         {-1,1,0} ,{0,1,0}  ,{1,1,0},

         {-1,-1,1},{0,-1,1} ,{1,-1,1},
         {-1,0,1} ,{0,0,1}  ,{1,0,1},
         {-1,1,1} ,{0,1,1}  ,{1,1,1},
        };



/*------------------------------------------------------------------------
inverse_rect_overlap_status - ???

 You must include rect.h to use this table 
-------------------------------------------------------------------------*/

int inverse_rect_overlap_status[] =
    {RECT_NO_OVERLAP,RECT_EQUAL,RECT_CONTAINS,RECT_CONTAINED,
     RECT_OVERLAPS_AT_BR_CORNER,RECT_OVERLAPS_AT_BR_CORNER_PT,
     RECT_OVERLAPS_AT_BL_CORNER,RECT_OVERLAPS_AT_BL_CORNER_PT,
     RECT_OVERLAPS_AT_TL_CORNER,RECT_OVERLAPS_AT_TL_CORNER_PT,
     RECT_OVERLAPS_AT_TR_CORNER,RECT_OVERLAPS_AT_TR_CORNER_PT,
     RECT_OVERLAPS_AT_BOTTOM_EDGE,RECT_OVERLAPS_AT_BOTTOM,
     RECT_OVERLAPS_AT_LEFT_EDGE,RECT_OVERLAPS_AT_LEFT,
     RECT_OVERLAPS_AT_TOP_EDGE,RECT_OVERLAPS_AT_TOP,
     RECT_OVERLAPS_AT_RIGHT_EDGE,RECT_OVERLAPS_AT_RIGHT,
     RECT_OVERLAPS_AT_BR_EDGE,RECT_OVERLAPS_AT_BL_EDGE,
     RECT_OVERLAPS_AT_TL_EDGE,RECT_OVERLAPS_AT_TR_EDGE,
     RECT_OVERLAPS_AT_RB_EDGE,RECT_OVERLAPS_AT_LB_EDGE,
     RECT_OVERLAPS_AT_LT_EDGE,RECT_OVERLAPS_AT_RT_EDGE
    };
