/****************************************************************************
marktonhdr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: marktonhdr.c,v 1.6 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <string.h>

#include <sys/types.h>

#include "typedef.h"
#include "ia_hdr.h"
#include "mark_hdr.h"
#include "error_constants.h"
#include "nria_lib.h"



/*------------------------------------------------------------------------
assign_hdr_to_nhdr - ???
------------------------------------------------------------------------*/

int
assign_hdr_to_nhdr(mark,hdr)
 struct mark_hdr *mark;
 struct hdr_rec *hdr;
{
 cp_str(&(hdr->data_info.default_datafn),mark->key.name);

 hdr->data_info.dimx = mark->dimen.dimx;
 hdr->data_info.dimy = mark->dimen.dimy;
 hdr->data_info.max_scans = mark->dimen.max_slices;
 hdr->data_info.pixel_depth_bits = mark->dimen.pixel_depth_bits;
 hdr->data_info.xpixel_size = mark->dimen.xpixel_size;
 hdr->data_info.ypixel_size = mark->dimen.ypixel_size;
 hdr->data_info.pixel_thickness = mark->dimen.pixel_thickness;
 hdr->data_info.spacing = mark->dimen.spacing;
 hdr->data_info.plane_type = mark->dimen.plane_type;
 hdr->data_info.var_use_status = mark->dimen.var_use_status;
 hdr->data_info.num_echoes = mark->dimen.num_echoes;
 hdr->data_info.unused2 = mark->dimen.unused2;
 hdr->data_info.unused3 = mark->dimen.unused3;
 hdr->data_info.unused4 = mark->dimen.unused4;
 hdr->data_info.unused5 = mark->dimen.unused5;
 hdr->data_info.unused6 = mark->dimen.unused6;
 hdr->data_info.unused7 = mark->dimen.unused7;
 hdr->data_info.tr = mark->dimen.tr;
 cp_str(&(hdr->data_info.te),mark->dimen.te);
 hdr->data_info.max_pixel = (double) mark->dimen.glmax;
 hdr->data_info.min_pixel = (double) mark->dimen.glmin;

 cp_str(&(hdr->data_info.patient.name),mark->history.patient.name);
 cp_str(&(hdr->data_info.patient.ssnum),mark->history.patient.ssnum);

 cp_str(&(hdr->data_info.patient.patient_id),mark->history.patient.patient_id);

 cp_str(&(hdr->data_info.patient.study_num),mark->history.patient.study_num);

 cp_str(&(hdr->data_info.patient.patient_num),
     mark->history.patient.patient_num);
 hdr->data_info.patient.age = mark->history.patient.age;
 hdr->data_info.patient.sex = mark->history.patient.sex;
 hdr->data_info.patient.height = mark->history.patient.height;
 hdr->data_info.patient.weight = mark->history.patient.weight;
 cp_str(&(hdr->data_info.date_of_study),mark->history.date_of_study);

 cp_str(&(hdr->data_info.time_of_study),mark->history.time_of_study);
 cp_str(&(hdr->data_info.description),mark->history.comment);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
build_pr_t2_hdr - ???
------------------------------------------------------------------------*/

int
build_pr_t2_hdr(hdr,mark_hdr)
 struct hdr_rec *hdr;
 struct mark_hdr *mark_hdr;
{
 int err;

 if ((err = cp_str(&(hdr->id),HDR_ID_V1)) != NO_ERROR)
    return err;
 hdr->status = _2_ECHO_IMAGE;
 hdr->data_info.num_echoes = 2;
 hdr->comment_size = 0;
 return BuildRiaHdr(hdr,0);

}


/*------------------------------------------------------------------------
build_t1_hdr - ???
------------------------------------------------------------------------*/

int
build_t1_hdr(hdr,mark_hdr)
 struct hdr_rec *hdr;
 struct mark_hdr *mark_hdr;
{
 int err;

 if ((err = cp_str(&(hdr->id),HDR_ID_V1)) != NO_ERROR)
    return err;
 hdr->status = _1_ECHO_IMAGE;
 hdr->data_info.num_echoes = 1;

 hdr->comment_size = 0;

 return BuildRiaHdr(hdr,0);
}


/*------------------------------------------------------------------------
build_hdr_from_mark_hdr - ???
------------------------------------------------------------------------*/

int
build_hdr_from_mark_hdr(hdr,mark_hdr,num_echoes)
 struct hdr_rec *hdr;
 struct mark_hdr *mark_hdr;
 int num_echoes;
{
 assign_hdr_to_nhdr(mark_hdr,hdr);
 if (num_echoes == 1) return build_t1_hdr(hdr,mark_hdr);
   else return build_pr_t2_hdr(hdr,mark_hdr);
}



/*------------------------------------------------------------------------
SetupHdrFromMarkHdr - ???
------------------------------------------------------------------------*/

int
SetupHdrFromMarkHdr(hdr,mark_hdr)
 struct hdr_rec *hdr;
 struct mark_hdr *mark_hdr;
{
 assign_hdr_to_nhdr(mark_hdr,hdr);
 if (mark_hdr->dimen.num_echoes == 1) return build_t1_hdr(hdr,mark_hdr);
   else return build_pr_t2_hdr(hdr,mark_hdr);
}


/*------------------------------------------------------------------------
build_extra_file_info_rec - ???
------------------------------------------------------------------------*/

int
build_extra_file_info_rec(extra_info)
 struct extra_file_info_rec *extra_info;
{
 cp_str(&(extra_info->color_bundle_label),"GRAY SCALE");
 memset(&(extra_info->color_control),(size_t) 0,
       (size_t) sizeof(struct color_control_rec));
 cp_str(&(extra_info->last_edit_begin),current_asctime());
 cp_str(&(extra_info->last_edit_end),current_asctime());

 return NO_ERROR;
}
