/****************************************************************************
match.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: match.c,v 1.6 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>

#include "typedef.h"
#include "nria_lib.h"


/*
fb_is_match_vars(str)
fb_compatible_vars(stra,strb)
enter_val(vars,var_name,val)
char *find_var(vars,var_name)
char *locate_val(str,len)
int fb_match_vars(patt,str,vars,name,start,len)
fb_match(patt,str)
*/


/*-------------------------------------------------------------------------
struct var_rec &var_binding_rec - ???
-------------------------------------------------------------------------*/

struct var_rec 
   {
    char name;
    char *val;
   };

struct var_binding_rec
   {
    unsigned int num_vars;
    struct var_rec *vars;
   };


/*-------------------------------------------------------------------------
fb_is_match_vars - ???
-------------------------------------------------------------------------*/

int
fb_is_match_vars(str)
 char *str;
{
 int cnt,len;

 for (len = strlen(str),cnt = 0; cnt < len; cnt++)
    {if (str[cnt] == '*') return 1;
     if ((str[cnt] == '#') && (cnt != len - 1) && (str[cnt+1] != '\0'))
        return 1;
    }
 return 0;
}


/*-------------------------------------------------------------------------
fb_compatible_vars - ???
-------------------------------------------------------------------------*/

int
fb_compatible_vars(stra,strb)
 char *stra,*strb;
{
 int len,len1,len2,cnt,lcv;
 char *str1;
 unsigned char var_str1,var_str2;

 if (strcmp(stra,strb) == 0) return 1;
 var_str1 = fb_is_match_vars(stra);
 var_str2 = fb_is_match_vars(strb);
 if (!var_str1  && !var_str2) return 1;
    else if (!(var_str1 && var_str2)) return 0;
     {
      copy_str(&str1,stra,strlen(stra));
      len1 = strlen(str1);
      for (len = 0,cnt = 0; cnt < len1; cnt++)
         if (str1[cnt] == '#')
           {cnt++;
            if (str1[cnt] != '\0')
               {str1[len] = str1[cnt];
                len++;}
           }
   
      len2 = strlen(strb);
      for (cnt = 0; cnt < len2; cnt++)
         if (strb[cnt] == '#')
           {cnt++;
            if (strb[cnt] != '\0')
               {for (lcv = 0; lcv < len; lcv++)
                   if (str1[lcv] == strb[cnt]) break;
                if (lcv == len)
                   {c_free(str1);
                    return 0;}
               }
           }

      c_free(str1);
      return 1;
     }
}


/*-------------------------------------------------------------------------
enter_val - ???
-------------------------------------------------------------------------*/

static void
enter_val(vars,var_name,val)
 struct var_binding_rec *vars;
 char var_name;
 char *val;
{
 unsigned int cnt;
 int err;

 for (cnt = 0; cnt < vars->num_vars; cnt++)
    if (vars->vars[cnt].name == var_name) 
       {if (vars->vars[cnt].val != NULL) c_free(vars->vars[cnt].val);
        break;}
 if (cnt >= vars->num_vars)
    {
     cnt = get_ptr_memory(&(vars->vars),&(vars->num_vars),(size_t) 1,
       (size_t) sizeof(struct var_rec),&err);
     if (err != 0) return;}
 if (val == NULL) vars->vars[cnt].val = NULL;
   else copy_str(&(vars->vars[cnt].val),val,strlen(val));
 vars->vars[cnt].name = var_name;
}


/*-------------------------------------------------------------------------
find_var - ???
-------------------------------------------------------------------------*/

static char *
find_var(vars,var_name)
 struct var_binding_rec *vars;
 char var_name;
{
 unsigned int cnt;

 for (cnt = 0; cnt < vars->num_vars; cnt++)
    if (vars->vars[cnt].name == var_name) 
      {
       return vars->vars[cnt].val;}
 return NULL;
}


/*-------------------------------------------------------------------------
locate_val - ???
-------------------------------------------------------------------------*/

char *
locate_val(str,len)
 char *str;
 size_t len;
{
 char *ptr;

 copy_str(&ptr,str,len);
 return ptr;
}


/*-------------------------------------------------------------------------
fb_match_vars - ???

   fb_match_vars "#xz#x" "abczabc"
   fb_match calls this with (patt,str,&vars,'\0',"",0)
-------------------------------------------------------------------------*/

static int 
fb_match_vars(patt,str,vars,name,start,len)
     char *patt, *str;
     struct var_binding_rec *vars;
     char name;
     char *start;
     unsigned int len;
{
 char *new_str,*var;
 static char str1[] = {' ','\0'};
 unsigned int result;

 if (((patt[0] == '\0') && (str[0] == '\0')) ||
     ((patt[0] == '*') && (patt[1] == '\0')) ) return 1;

 if ((patt[0] != '*') && (patt[0] != '#'))
    {
     if ((str[0] == '\0') || (str[0] != patt[0])) return 0;
        else if (fb_match_vars(&(patt[1]),&(str[1]),vars,name,start,len)) 
                return 1;
     return 0;
    }
   else if (patt[0] == '*')
    {
     if (fb_match_vars(&(patt[1]),str,vars,'\0',"",0)) return 1;
     if (str[0] != '\0')
        if (fb_match_vars(patt,&(str[1]),vars,'\0',"",0)) return 1;
     return 0;
    }
   else
    {
     if ((patt[1] == '*') || (patt[1] == '\0')) return 0; 
     var = find_var(vars,patt[1]);
     if (var != NULL)
        {
         concat_strs(&new_str,2,var,&(patt[2]));
         result = fb_match_vars(new_str,str,vars,'\0',"",0);
         c_free(new_str);
         return result;
        }
       else 
        {
         if (str[0] != '\0')
            {
             str1[0] = str[0];
             concat_strs(&new_str,2,start,str1);

             if (fb_match_vars(patt,&(str[1]),vars,patt[1],new_str,len+1))
                return 1;
             new_str[len] = '\0';
             enter_val(vars,patt[1],new_str);
             c_free(new_str);}
           else if (name != '\0') enter_val(vars,name,start);

         return fb_match_vars(&(patt[2]),str,vars,'\0',"",0);
        }
    } 

}

/*-------------------------------------------------------------------------
fb_match - ???
-------------------------------------------------------------------------*/

int
fb_match(patt,str)
 char *patt,*str;
{
 struct var_binding_rec vars;

 return fb_match_vars(patt,str,&vars,'\0',"",0);
}


/*********************
validate_matched_strs(str1,str2,new_str2)
 char *str1,*str2;
 char **new_str2;
{
 struct var_binding_rec vars;
 unsigned int cnt;

 *new_str2 = NULL;
 if (strcmp(str1,str2) == 0) return;

}
*******************/


/**************************
main(argc,argv)
 int argc;
 char **argv;
{
 struct var_binding_rec vars;
 unsigned int cnt;

 vars.num_vars = 0;
 printf("fb_match_vars = %d\n",(int) fb_match_vars(argv[1],argv[2],&vars,'\0',"",0));
 for (cnt = 0; cnt < vars.num_vars; cnt++)
    if (vars.vars[cnt].val == NULL)
        printf("var name = %c   NULL\n",vars.vars[cnt].name);
      else 
    printf("var name = %c   val = %s   len = %d\n",vars.vars[cnt].name,
              vars.vars[cnt].val,strlen(vars.vars[cnt].val));
}
**************************/


/*************************
main(argc,argv)
 int argc;
 char **argv;
{
 printf("fb_compatible_vars = %d\n",(int) fb_compatible_vars(argv[1],argv[2]));
}
*************************/
