/****************************************************************************
rd_token.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: rd_token.c,v 1.5 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <stdio.h>
#include <string.h>

#include <sys/types.h>

#include "error_constants.h"
#include "nria_lib.h"


/*
char *next_token(str,is_new_str,next_num)
token_in_line(str,is_new_str,patt,pat_start,pat_stop,token_num)
input_line(fid,line,linelen)
RdUntil(fid,line,line_len,patt,pat_start,pat_stop,token_num)
RdUntilSubstr(fid,line,line_len,substr,start_indx)
RdWrLineUntil(fid,fout,line,line_len,patt,pat_start,pat_stop,token_num)
rd_until(fid,line,line_len,patt,pat_start,pat_stop,token_num)
rd_until_substr(fid,line,line_len,substr,start_indx)
rd_wr_line_until(fid,fout,line,line_len,patt,pat_start,pat_stop,token_num)
*/


static char delimiter[] = {' ',9,'\n','\0'};


/*------------------------------------------------------------------------
next_token - ???
------------------------------------------------------------------------*/

char *
next_token(str,is_new_str,next_num)
 char *str;
 int is_new_str;
 unsigned long next_num;
{
 unsigned long lcv;
 char *next;

 if (is_new_str)
    {if ((next = (char *) strtok(str,delimiter)) == NULL) return NULL;}
   else if ((next = (char *) strtok(NULL,delimiter)) == NULL) return NULL;
 for (lcv = 1; lcv < next_num; lcv++)
    if ((next = (char *) strtok(NULL,delimiter)) == NULL) return NULL;
 return next;
}


/*------------------------------------------------------------------------
token_in_line - ???
------------------------------------------------------------------------*/

int
token_in_line(str,is_new_str,patt,pat_start,pat_stop,token_num)
 char *str,*patt;
 unsigned long *pat_start,*pat_stop,*token_num;
 int is_new_str;
{
 unsigned long len,len1;
 char *next;

 len = get_strlen(str);
 if (is_new_str)
    {*token_num = 0;
     if ((next = (char *) strtok(str,delimiter)) == NULL) return CANCEL;
    }
   else 
     if ((next = (char *) strtok(NULL,delimiter)) == NULL) return CANCEL;
 *token_num += 1;
 do 
    {len1 = get_strlen(next);
     if (str_cmp(next,patt) == 0)
        {*pat_start = (unsigned long) next - (unsigned long) str;
         *pat_stop = (unsigned long) *pat_start + strlen(patt);
         if ((unsigned long) (str + len) != (unsigned long) (next + len1))
            next[len1] = ' ';
         return NO_ERROR;}
     if ((unsigned long) (str + len) != (unsigned long) (next + len1))
        next[len1] = ' ';
     if ((next = (char *) strtok(NULL,delimiter)) == NULL) return CANCEL;
     *token_num += 1;
    }
 while (1);
}


/*------------------------------------------------------------------------
input_line - ???
------------------------------------------------------------------------*/

int
input_line(fid,line,linelen)
 FILE *fid;
 char **line;
 unsigned long *linelen;
{
 int err,add,done,eof;
 long start_indx,len,inputlen;
 char *str;

#define ADD_INPUT_LINE 256
 if (*linelen == 0)
    {get_ptr_memory(line,linelen,ADD_INPUT_LINE,1,&err);
     if (err != NO_ERROR) return err;}
 str = NULL;
 done = add = 0;
 err = NO_ERROR;
 eof = 0;
 inputlen = *linelen - 1;
 while (1)
    {
     if (fgets(*line,inputlen,fid) == NULL)
        {eof = 1;
         break;}
     if (find_sub_str(*line,"\n",&start_indx) == NO_ERROR)
        {
         done = 1;}

     non_ascii_to_ch(*line,' ');
     trim_str_blanks(*line);
     if ((*line)[0] != '\0')
        {
         if (!done || (add > 0))
            {
             if ((err = append_strs(&str,1,*line)) != NO_ERROR)
                break;
             add += 1;
            }
         if (done) break;
        }
       else done = 0;
    }
 if ((err == NO_ERROR) && (add > 0))
    {len = get_strlen(str) + 1;
     if (len > *linelen)
        {len -= *linelen;
         if (len < ADD_INPUT_LINE) len = ADD_INPUT_LINE;
         get_ptr_memory(line,linelen,len,1,&err);}

     if (err == NO_ERROR)
        strcpy(*line,str);
    }
   else if (eof) return END_OF_FILE;
 c_free(str);
 return err;
}


/*------------------------------------------------------------------------
RdUntil - ???
------------------------------------------------------------------------*/

int
RdUntil(fid,line,line_len,patt,pat_start,pat_stop,token_num)
 FILE *fid;
 char *patt,**line;
 unsigned long *line_len;
 unsigned long *pat_start,*pat_stop,*token_num;
{
 int err;

 for (; ; )
    {if ((err = input_line(fid,line,line_len) != NO_ERROR)) return err;
     if (token_in_line(*line,1,patt,pat_start,pat_stop,token_num) == NO_ERROR)
        {
         return NO_ERROR;
        }
    }
}


/*------------------------------------------------------------------------
RdUntilSubstr - ???
------------------------------------------------------------------------*/

int
RdUntilSubstr(fid,line,line_len,substr,start_indx)
 FILE *fid;
 char **line;
 unsigned long *line_len;
 char *substr;
 unsigned long *start_indx;
{
 int err;

 for (; ; )
    {if ((err = input_line(fid,line,line_len) != NO_ERROR)) return err;
     if (find_sub_str(*line,substr,start_indx) == NO_ERROR)
        {
         return NO_ERROR;
        }
    }
}


/*------------------------------------------------------------------------
RdWrLineUntil - ???
------------------------------------------------------------------------*/

int
RdWrLineUntil(fid,fout,line,line_len,patt,pat_start,pat_stop,token_num)
 FILE *fid,*fout;
 char *patt,**line;
 unsigned long *line_len;
 unsigned long *pat_start,*pat_stop,*token_num;
{
 int err;
 char *str;

 for (; ; )
    {if ((err = input_line(fid,line,line_len) != NO_ERROR)) return err;
     if ((err = cp_str(&str,*line)) != NO_ERROR) return err;
     if (token_in_line(str,1,patt,pat_start,pat_stop,token_num) == NO_ERROR)
        {c_free(str);
         return NO_ERROR;
        }
     c_free(str);
     fprintf(fout,"%s",*line);
    }
}


/*------------------------------------------------------------------------
rd_until - ???
------------------------------------------------------------------------*/

int
rd_until(fid,line,line_len,patt,pat_start,pat_stop,token_num)
 FILE *fid;
 char *patt,*line;
 unsigned long line_len;
 unsigned long *pat_start,*pat_stop,*token_num;
{
 for (; ; )
    {if (fgets(line,line_len,fid) == NULL) return ~NO_ERROR;
     /*printf("rd=%s",line);*/
     if (token_in_line(line,1,patt,pat_start,pat_stop,token_num) == NO_ERROR)
        {
         return NO_ERROR;
        }
    }
}


/*------------------------------------------------------------------------
rd_until_substr - ???
------------------------------------------------------------------------*/

int
rd_until_substr(fid,line,line_len,substr,start_indx)
 FILE *fid;
 char *line;
 unsigned long line_len;
 char *substr;
 unsigned long *start_indx;
{

 for (; ; )
    {if (fgets(line,line_len,fid) == NULL) return ~NO_ERROR;
     if (find_sub_str(line,substr,start_indx) == NO_ERROR)
        {
         return NO_ERROR;
        }
    }
}


/*------------------------------------------------------------------------
rd_wr_line_until - ???
------------------------------------------------------------------------*/

int
rd_wr_line_until(fid,fout,line,line_len,patt,pat_start,pat_stop,token_num)
 FILE *fid,*fout;
 char *patt,*line;
 unsigned long line_len;
 unsigned long *pat_start,*pat_stop,*token_num;
{
 static char *str = NULL;
 static unsigned long len = 0;
 int err;

 if (line_len > len)
    {if (str != NULL) c_free(str);
     get_ptr_memory(&str,&len,line_len,
           (size_t) sizeof(*str),&err);
     if (err != NO_ERROR) return err;}
 for (; ; )
    {if (fgets(line,line_len,fid) == NULL) return ~NO_ERROR;
     strcpy(str,line);
     if (token_in_line(str,1,patt,pat_start,pat_stop,token_num) == NO_ERROR)
        {
         return NO_ERROR;
        }
     fprintf(fout,"%s",line);
    }
}
