/****************************************************************************
show_spm_hdr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: show_spm_hdr.c,v 1.5 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <string.h>

#include "spm_hdr.h"
#include "error_constants.h"
#include "nria_lib.h"



/*--------------------------------------------------------------------------
StrNcpy - ???
--------------------------------------------------------------------------*/

void
StrNcpy(dst,src,len)
 char *dst,*src;
 long len;
{
 strncpy(dst,src,len);
 dst[len] = '\0';
}


/*--------------------------------------------------------------------------
pr_spm_hdr_key - ???
--------------------------------------------------------------------------*/

void
pr_spm_hdr_key(key)
 struct spm_hdr_key *key;
{
 printf("size = %d data_type = %s  fn = %s\n",key->size,key->data_type,
    key->name);
 printf("\n");
}


/*--------------------------------------------------------------------------
pr_spm_hdr_dimension - ???
--------------------------------------------------------------------------*/

void
pr_spm_hdr_dimension(dim)
 struct spm_hdr_dimension *dim;
{
 char str[100],str1[100];

 printf("num_dims = %d   dimx = %d   dimy = %d   max_slices = %d\n",
   (int) dim->num_dims,(int) dim->dimx,(int) dim->dimy,(int) dim->max_slices);
 printf("num_vols = %d   histo_dimx = %d   histo_dimy = %d\n",
   (int) dim->num_vols,(int) dim->histo_dimx,
   (int) dim->histo_dimy);
 printf("pixel_depth_bits = %d   glmax = %d   glmin = %d compressed = %ld\n",
   dim->pixel_depth_bits, dim->glmax, dim->glmin,dim->compressed);

 printf("xpixel_size = %.4f   ypixel_size = %.4f\n",
    dim->xpixel_size, dim->ypixel_size);
 printf("pixel_thickness = %.4f   spacing = %.4f\n",
    dim->pixel_thickness,dim->spacing);

 StrNcpy(str,dim->vox_units,4);
 StrNcpy(str1,dim->cal_units,8);
 printf("vox_units = %s cal_units = %s\n",dim->vox_units,dim->cal_units);
 printf("unused1 = %d  datatype = %d dim_un0 = %d\n",
       dim->unused1,dim->datatype,dim->dim_un0);

 printf("pixdim_unused1 = %.4f unused2 = %.4f\n",
                 dim->pixdim_unused1,dim->pixdim_unused2);
 printf("unused3 = %.4f unused4 = %.4f\n",
          dim->pixdim_unused3,dim->pixdim_unused4);
 printf("vox_offset = %.4f cal_max = %.4f cal_min = %.4f verified = %.4f\n",
                 dim->vox_offset,dim->cal_max,dim->cal_min,dim->verified);
 printf("funused1 = %.4f funused2 = %.4f funused3 = %.4f\n",
                 dim->funused1,dim->funused2,dim->funused3);

 printf("\n");

}


/*--------------------------------------------------------------------------
pr_spm_hdr_history - ???
--------------------------------------------------------------------------*/

void
pr_spm_hdr_history(history)
 struct spm_hdr_history *history;
{
 char str[100],str1[100];

 StrNcpy(str,history->descrip,sizeof(history->descrip));
 printf("descrip = %s\n",str);
 StrNcpy(str,history->aux_file,sizeof(history->aux_file));
 printf("aux_file = %s orient = %c\n",str,history->orient);
 printf("origin[0] = %ld [1] = %ld [2] = %ld [3] = %ld [4] = %ld\n",
    (unsigned long) history->origin[0],(unsigned long) history->origin[1],
    (unsigned long) history->origin[2],(unsigned long) history->origin[3],
    (unsigned long) history->origin[4]);
 StrNcpy(str,history->generated,sizeof(history->generated));
 StrNcpy(str1,history->scannum,sizeof(history->scannum));
 printf("generated = %s scannum = %s\n",str,str1);

 StrNcpy(str,history->patient_id,sizeof(history->patient_id));
 StrNcpy(str1,history->hist_un0,sizeof(history->hist_un0));
 printf("patient_id = %s hist_un0 = %s\n",str,str1);

 StrNcpy(str,history->exp_date,sizeof(history->exp_date));
 StrNcpy(str1,history->exp_time,sizeof(history->exp_time));
 printf("exp_date = %s exp_time = %s\n",str,str1);

 printf("views = %ld vols_added = %ld start_field = %ld\n",
        history->views,history->vols_added,history->start_field);
 printf("field_skip = %ld omax = %ld omin = %ld\n",
        history->field_skip,history->omax,history->omin);
 printf("smax = %ld smin = %ld\n",
        history->smax,history->smin);

 printf("\n");
}


/*--------------------------------------------------------------------------
pr_spm_hdr - ???
--------------------------------------------------------------------------*/

void
pr_spm_hdr(hdr)
 struct spm_hdr *hdr;
{
 pr_spm_hdr_key(&(hdr->key));
 pr_spm_hdr_dimension(&(hdr->dimen));
 pr_spm_hdr_history(hdr->history);
}
