/****************************************************************************
str_extra.c - Some uncommonly used string functions

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: str_extra.c,v 1.7 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <ctype.h>

#include "error_constants.h"
#include "nria_lib.h"




/*-----------------------------------------------------------------------
skip_str_first_ch_in_patt - ???
-----------------------------------------------------------------------*/

unsigned long
skip_str_first_ch_in_patt(str,patt)
 char *str,*patt;
{
 unsigned long lcv,cnt;
 int in;

 if (str == NULL) return 0;
 for (lcv = 0; (str[lcv] != '\0') ; lcv++)
    {for (in = 0,cnt = 0; (patt[cnt] != '\0'); cnt++)
        if (str[lcv] == patt[cnt]) 
           {in = 1;
            break;}
     if (in) break;}
 return lcv;
}



/*-----------------------------------------------------------------------
skip_str_until_ch_in_patt - ???
-----------------------------------------------------------------------*/

unsigned long
skip_str_until_ch_in_patt(str,patt)
 char *str,*patt;
{
 unsigned long lcv,cnt;
 int in;

 if (str == NULL) return 0;
 for (lcv = 0; (str[lcv] != '\0') ; lcv++)
    {for (in = 0,cnt = 0; (patt[cnt] != '\0'); cnt++)
        if (str[lcv] == patt[cnt]) 
           {in = 1;
            break;}
     if (in) break;}
 return lcv;
}



/*-----------------------------------------------------------------------
skip_str_until_ch_not_in_patt - ???
-----------------------------------------------------------------------*/

unsigned long
skip_str_until_ch_not_in_patt(str,patt)
 char *str,*patt;
{
 unsigned long lcv,cnt;
 int in;

 if (str == NULL) return 0;
 for (lcv = 0; (str[lcv] != '\0') ; lcv++)
    {for (in = 1,cnt = 0; (patt[cnt] != '\0'); cnt++)
        if (str[lcv] == patt[cnt]) 
           {in = 0;
            break;}
     if (in) break;}
 return lcv;
}



/*-----------------------------------------------------------------------
find_sub_str - ???
-----------------------------------------------------------------------*/

int
find_sub_str(str,substr,start_indx)
 char *str,*substr;
 unsigned long *start_indx;
{
 unsigned long lcv,cnt,indx;

 *start_indx = 0;
 if ((str == NULL) || (substr == NULL) ||
     (substr[0] == '\0')) return ~NO_ERROR;
 for (lcv = 0; str[lcv] != '\0'; lcv++)
    {for (indx = lcv,cnt = 0; substr[cnt] != '\0'; cnt++)
        {if (str[indx] == '\0') return ~NO_ERROR;
         if (str[indx++] != substr[cnt]) break;
        }
     if (substr[cnt] == '\0')
        {*start_indx = lcv;
         return NO_ERROR;}
    }
 return ~NO_ERROR;
}



/*-----------------------------------------------------------------------
replace_ch_by_str - ???
-----------------------------------------------------------------------*/

int
replace_ch_by_str(result,str,replace_ch,replacement_str)
 char **result,*str,replace_ch,*replacement_str;
{
 unsigned int cnt,lcv,len1,len2,len3,total;
 int err;

 len1 = get_strlen(str);
 for (lcv = cnt = 0; lcv < len1; lcv++)
    if (str[lcv] == replace_ch) cnt++;
 if (cnt == 0) return cp_str(result,str);
 len2 = get_strlen(replacement_str);
 len3 = len1 - cnt + cnt * len2;
 total = 0;
 get_handle_memory(result,&total,len3 + 1,(size_t) sizeof(char),&err);
 if (err != NO_ERROR) return err;

 for (len3 = lcv = 0; lcv < len1; lcv++)
    if (str[lcv] == replace_ch)
       {for (cnt = 0; cnt < len2; cnt++)
           (*result)[len3++] = replacement_str[cnt];}
      else (*result)[len3++] = str[lcv];
 (*result)[len3++] = '\0';
 return NO_ERROR;

}



/*-----------------------------------------------------------------------
replace_ch_without_duplicate - ???
-----------------------------------------------------------------------*/

int
replace_ch_without_duplicate(str,str_len,replace_ch,new_ch)
 char *str,replace_ch,new_ch;
 unsigned int str_len;
{
 unsigned int cnt,lcv;
 int yes;

 for (yes = 1,lcv = cnt = 0; cnt < str_len; cnt++)
    if (str[cnt] == replace_ch)
       {if (yes)
           {str[lcv++] = new_ch;
            yes = 0;}
       }
      else
       {yes = 1;
        str[lcv++] = str[cnt];}
 str[lcv++] = '\0';
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
replace_substr_by_str - ???
-----------------------------------------------------------------------*/

int
replace_substr_by_str(str,substr,repl_str)
 char *str,*substr,*repl_str;
{
 unsigned int start_indx,cnt,next,len,lcv,indx,len1,len2,yes;

 len = get_strlen(str);
 len1 = get_strlen(substr);
 len2 = get_strlen(repl_str);
 if (len2 > len1) len2 = len1;
 for (yes = 0,cnt = 0; cnt < len;)
    if (find_sub_str(&(str[cnt]),substr,&start_indx) == NO_ERROR)
       {yes = 1;
        for (indx = cnt + start_indx,lcv = 0; lcv < len2; lcv++)
           str[indx++] = repl_str[lcv];
        if (lcv < len1)
           {
            next = cnt + start_indx + len1;
            for (; next < len; next++) str[indx++] = str[next];
            str[indx] = '\0';
            len = indx;
            cnt += len2;
           }
          else cnt += len1;
       }
      else break;

 if (yes) return NO_ERROR;
   else return NOT_FOUND;
}



/*-----------------------------------------------------------------------
is_blank_in_str - ???
-----------------------------------------------------------------------*/

int
is_blank_in_str(str)
 char *str;
{
 unsigned int lcv,len;

 if (str == NULL) return 0;
 len = (unsigned int) strlen(str);
 for (lcv = 0; lcv < len; lcv++)
    if (str[lcv] == ' ') return 1;
 return 0;

}



/*-----------------------------------------------------------------------
non_ascii_to_ch - ???
-----------------------------------------------------------------------*/

void
non_ascii_to_ch(str,ch)
 char *str,ch;
{
 long lcv;

 for (lcv = 0; str[lcv] != '\0'; lcv++)
    if      (!isascii(str[lcv]))  str[lcv] = ch;
    else if ( iscntrl(str[lcv]))  str[lcv] = ch;
}
