/****************************************************************************
system.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: system.c,v 1.6 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

#include "error_constants.h"
#include "nria_lib.h"


/*-----------------------------------------------------------------------
setup_batch_file - ???
------------------------------------------------------------------------*/

int
setup_batch_file(
    char *cmd1,
    ...)
{
    va_list args;
    char *temp;
    char *batchfn,str[250];
    unsigned long cnt = 0;
    int err;
    FILE *fid;

    if ((err = cp_str(&batchfn,tmpnam(NULL))) != NO_ERROR)
	return err;
    if ((fid = fopen(batchfn,"w")) == NULL)
	return FILE_ACCESS_ERROR;

    clearerr(fid);
    fprintf(fid, "%s\n", cmd1);
    if ((err = ferror(fid)) != NO_ERROR)
	goto cleanup;

    va_start(args, cmd1);
 
    for (cnt = 1; (temp = va_arg(args, char *)) != (char *) 0; cnt++) {
	fprintf(fid,"%s\n",temp);
	if ((err = ferror(fid)) != NO_ERROR) break;
    }
    if (err == NO_ERROR) {
	fprintf(fid,"set res = $status\n");
	fprintf(fid,"rm %s\n",batchfn);
	fprintf(fid,"exit $res\n");
	err = ferror(fid);
    }
    fclose(fid);
    fid = 0;
    if (err == NO_ERROR) {
	    sprintf(str,"csh %s\n",batchfn);
	    system(str);
    }

    va_end(args);

 cleanup:
    if (fid != 0) fclose(fid);
    if ((cnt == 0) || (err != NO_ERROR)) unlink(batchfn);
    return err;
}


#if 0   /* Old varargs version */
int
setup_batch_file(va_alist)
 va_dcl
{
 va_list args;
 char *temp;
 char *batchfn,str[250];
 unsigned long cnt;
 int err;
 FILE *fid;

 if ((err = cp_str(&batchfn,tmpnam(NULL))) != NO_ERROR) return err;
 if ((fid = fopen(batchfn,"w")) == NULL) return FILE_ACCESS_ERROR;

 va_start(args);
 clearerr(fid);
 
 for (cnt = 0; (temp = va_arg(args, char *)) != (char *) 0; cnt++)
    {fprintf(fid,"%s\n",temp);
     if ((err = ferror(fid)) != NO_ERROR) break;
    };
 if (err == NO_ERROR)
    {fprintf(fid,"set res = $status\n");
     fprintf(fid,"rm %s\n",batchfn);
     fprintf(fid,"exit $res\n");
     err = ferror(fid);
    }
 fclose(fid);
 if (err == NO_ERROR)
   {
    sprintf(str,"csh %s\n",batchfn);
    system(str);
   }
 if ((cnt == 0) || (err != NO_ERROR)) unlink(batchfn);
 va_end(args);
 return err;
}
#endif
