/****************************************************************************
time.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: time.c,v 1.5 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <unistd.h>

/* #include <sys/types.h>  FIXME:  Is this necessary? */

#include "error_constants.h"
#include "mytime.h"
#include "nria_lib.h"



/*-----------------------------------------------------------------------
timer_wait - ???

FIXME:  This could be replaced by the POSIX sleep() facility.
----------------------------------------------------------------------*/

int 
timer_wait(secs)
 unsigned long secs;
{
 char str[60];

 sprintf(str,"sleep %lu\n",secs);
 system(str); 
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
current_asctime - ???
----------------------------------------------------------------------*/

char *
current_asctime()
{
 struct tm *_tm;
 time_t the_time;

 time(&the_time);
 _tm = localtime(&the_time);
 return asctime(_tm);
}


/*-----------------------------------------------------------------------
current_time - ???
----------------------------------------------------------------------*/

struct tm *
current_time()
{
 time_t the_time;

 time(&the_time);
 return localtime(&the_time);
}


/*-----------------------------------------------------------------------
timer_compare - ???
----------------------------------------------------------------------*/

int
timer_compare(time,mask,sec,min,hour,monthday,month,year)
 struct tm *time;
 unsigned long mask;
 int sec,min,hour,monthday,month,year;
{
 if (mask & TIMER_YEAR)
    {if (time->tm_year < year) return -1;
     if (time->tm_year > year) return 1;}

 if (mask & TIMER_MONTH)
    {if ((time->tm_mon + 1) < month) return -1;
     if ((time->tm_mon + 1) > month) return 1;}

 if (mask & TIMER_MONTHDAY)
    {if (time->tm_mday < monthday) return -1;
     if (time->tm_mday > monthday) return 1;}

 if (mask & TIMER_HOUR)
    {if (time->tm_hour < hour) return -1;
     if (time->tm_hour > hour) return 1;}

 if (mask & TIMER_MIN)
    {if (time->tm_min < min) return -1;
    if (time->tm_min > min) return 1;}

 if (mask & TIMER_SEC)
    {if (time->tm_sec < sec) return -1;
     if (time->tm_sec > sec) return 1;}

 return 0;
}


/*-----------------------------------------------------------------------
timer_delete_fn - ???
----------------------------------------------------------------------*/

int
timer_delete_fn(fn,mask,sec,min,hour,monthday,month,year,weekday,yearday)
 char *fn;
 unsigned long mask;
 int sec,min,hour,monthday,month,year,weekday,yearday;
{
 struct tm *time;
 int is_delete,cmp;

 time = current_time();
 is_delete = 0;
 if (mask & TIMER_TIME)
    {cmp = timer_compare(time,mask,sec,min,hour,monthday,month,year);
     if ((mask & TIMER_EQUAL) && (cmp == 0)) is_delete = 1;
     if ((mask & TIMER_LESS_THAN) && (cmp < 0)) is_delete = 1;
     if ((mask & TIMER_GREATER) && (cmp > 0)) is_delete = 1;}
   else
    {if (mask & TIMER_WEEKDAY)
        {if ((mask & TIMER_EQUAL) && ((time->tm_wday + 1) == weekday))
            is_delete = 1;
         if ((mask & TIMER_LESS_THAN) && ((time->tm_wday + 1) < weekday))
            is_delete = 1;
         if ((mask & TIMER_GREATER) && ((time->tm_wday + 1) > weekday))
            is_delete = 1;}
     if (mask & TIMER_YEARDAY)
        {if ((mask & TIMER_EQUAL) && (time->tm_yday == yearday))
            is_delete = 1;
         if ((mask & TIMER_LESS_THAN) && (time->tm_yday < yearday))
            is_delete = 1;
         if ((mask & TIMER_GREATER) && (time->tm_yday > yearday))
            is_delete = 1;}
    }
 if (is_delete) return unlink(fn);
 return NO_ERROR;
}

