/****************************************************************************
unit_2d_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: unit_2d_rec.c,v 1.6 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "common.h"
#include "error_constants.h"
#include "nria_lib.h"



/*-----------------------------------------------------------------------
initial_unit_2d_rec - ???
-----------------------------------------------------------------------*/

void
initial_unit_2d_rec(unit)
 struct unit_2d_rec *unit;
{
 unit->status2 = 0;
}


/*-----------------------------------------------------------------------
setup_unit_2d_rec - ???
-----------------------------------------------------------------------*/

int
setup_unit_2d_rec(unit,ustartx,ustarty,unitx,unity,dimx,dimy,
                  local_ustartx,local_ustarty,local_unitx,local_unity)
 struct unit_2d_rec *unit;
 float ustartx,ustarty;
 float unitx,unity;
 unsigned long dimx,dimy; 
 float local_ustartx,local_ustarty,local_unitx,local_unity;
{
 unit->status2 = UNIT_2D_IN_USE;
 unit->ustartx = ustartx;
 unit->ustarty = ustarty;
 unit->unitx = unitx;
 unit->unity = unity;
 unit->dimx = dimx;
 unit->dimy = dimy;
 unit->local_ustartx = local_ustartx;
 unit->local_ustarty = local_ustarty;
 unit->local_unitx = local_unitx;
 unit->local_unity = local_unity;
 setup_scale_2d_matrix_from_xy(&(unit->tolocal_mat),
        unit->unitx / unit->local_unitx,
        unit->unity / unit->local_unity,unit->ustartx,unit->ustarty);
 setup_translate_2d_matrix(&(unit->localto_mat),
        -unit->local_ustartx,-unit->local_ustarty);
 mult_2d_matrix(&(unit->tolocal_mat),&(unit->localto_mat),
                &(unit->tolocal_mat));
 inverse_2d_matrix(&(unit->localto_mat),&(unit->tolocal_mat));
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
unit_2d_rec_extra_trans_matrix - ???
-----------------------------------------------------------------------*/

int
unit_2d_rec_extra_trans_matrix(trans,unit)
 struct matrix_2d_rec *trans;
 struct unit_2d_rec *unit;
{
 struct unit_2d_rec unit1;

 setup_unit_2d_rec(&unit1,unit->ustartx,unit->ustarty,
          unit->unitx,unit->unity,unit->dimx,unit->dimy,
          unit->local_ustartx,unit->local_ustarty,unit->local_unitx,
          unit->local_unity);    
 mult_2d_matrix(trans,&(unit->localto_mat),&(unit1.tolocal_mat));
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
pr_unit_2d_rec - ???
-----------------------------------------------------------------------*/

void
pr_unit_2d_rec(unit)
 struct unit_2d_rec *unit;
{
 printf("pr_unit_2d_rec...unit = %p\n",unit);
 printf("status2 = %lx ustartx = %f ustarty = %f\n",
   (unsigned long) unit->status2,unit->ustartx,unit->ustarty);
 printf("unitx = %f unity = %f  dimx = %ld dimy = %ld\n",
   unit->unitx,unit->unity,unit->dimx,unit->dimy);
 printf("local ustartx = %f ustarty = %f  unitx = %f unity = %f\n",
   unit->local_ustartx,unit->local_ustarty,unit->local_unitx,unit->local_unity);
 pr_2d_matrix(&(unit->tolocal_mat));
 pr_2d_matrix(&(unit->localto_mat));
 printf("pr_unit_2d_rec...end\n");
}
