/****************************************************************************
v3rwbuf2drec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: v3rwbuf2drec.c,v 1.6 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <stdio.h>
#include <sys/types.h>

#include "common.h"
#include "error_constants.h"
#include "nria_lib.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)


/******************************
struct buf_2d_rec1
   {
    unsigned short status; 
    unsigned long dimx,dimy;
    unsigned long total_bytes;
    unsigned long pixel_depth;     unsigned char **buf; 
    unsigned long min_val,max_val;
    unsigned long min_val_set,max_val_set;
    unsigned long mean_val,mean_val_set;
   };
*****************************/



/*------------------------------------------------------------------------
v3_rd_buf_2d_rec_hdr - ???
------------------------------------------------------------------------*/

int
v3_rd_buf_2d_rec_hdr(fid,_2d)
 FILE *fid;
 struct buf_2d_rec *_2d;
{
 unsigned long min_val,max_val;
 unsigned long min_val_set,max_val_set;
 unsigned long mean_val,mean_val_set;
 unsigned char **dummy;

 if ((fread(&(_2d->status4),sizeof(_2d->status4),1,fid) != 1) ||
     (fread(&(_2d->startoffx),sizeof(_2d->startoffx),1,fid) != 1) ||
     (fread(&(_2d->startoffy),sizeof(_2d->startoffy),1,fid) != 1) ||
     (fread(&(_2d->dimx),sizeof(_2d->dimx),1,fid) != 1) ||
     (fread(&(_2d->dimy),sizeof(_2d->dimy),1,fid) != 1) ||
     (fread(&(_2d->total_bytes),sizeof(_2d->total_bytes),1,fid) != 1) ||
     (fread(&(_2d->pixel_depth),sizeof(_2d->pixel_depth),1,fid) != 1))
    return READ_ERROR;
 PRT1(printf("v3_rd_buf_2d_rec_hdr _2d->status4 = %u\n",_2d->status4))
 if (!(_2d->status4 & BUF_VERSION_NUM_USED))
    {if ((fread(&dummy,sizeof(dummy),1,fid) != 1) ||
         (fread(&min_val,sizeof(min_val),1,fid) != 1) ||
         (fread(&max_val,sizeof(max_val),1,fid) != 1) ||
         (fread(&min_val_set,sizeof(min_val_set),1,fid) != 1) ||
         (fread(&max_val_set,sizeof(max_val_set),1,fid) != 1) ||
         (fread(&mean_val,sizeof(mean_val),1,fid) != 1) ||
         (fread(&mean_val_set,sizeof(mean_val_set),1,fid) != 1))
        return READ_ERROR;
     _2d->minval = (double) min_val;
     _2d->maxval = (double) max_val;
     _2d->minval_set = (double) min_val_set;
     _2d->maxval_set = (double) max_val_set;
     _2d->meanval = (double) mean_val;
     _2d->meanval_set = (double) mean_val_set;
    }
   else
    {if ((fread(&(_2d->minval),sizeof(_2d->minval),1,fid) != 1) ||
         (fread(&(_2d->maxval),sizeof(_2d->maxval),1,fid) != 1) ||
         (fread(&(_2d->minval_set),sizeof(_2d->minval_set),1,fid) != 1) ||
         (fread(&(_2d->maxval_set),sizeof(_2d->maxval_set),1,fid) != 1) ||
         (fread(&(_2d->meanval),sizeof(_2d->meanval),1,fid) != 1) ||
         (fread(&(_2d->meanval_set),sizeof(_2d->meanval_set),1,fid) != 1) ||
         (fread(&(_2d->version_num),sizeof(_2d->version_num),1,fid) != 1) ||
         (fread(&(_2d->ustartx),sizeof(_2d->ustartx),1,fid) != 1) ||
         (fread(&(_2d->ustarty),sizeof(_2d->ustarty),1,fid) != 1) ||
         (fread(&(_2d->unitx),sizeof(_2d->unitx),1,fid) != 1) ||
         (fread(&(_2d->unity),sizeof(_2d->unity),1,fid) != 1) ||
         (fread(&(_2d->matrix),sizeof(_2d->matrix),1,fid) != 1))
        return READ_ERROR;
    }
 if (!(_2d->status4 & BUF_VERSION_NUM_USED))
    {_2d->status4 &= 0x0000ffff;
     _2d->status4 |= BUF_VERSION_NUM_USED;
     _2d->version_num = BUF_2D_VERSION_NUM;}
 _2d->status4 &= ~(BUF_NON_EMPTY | BUF_DATA_VALID);

 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_rd_buf_2d_rec - ???
------------------------------------------------------------------------*/

int
v3_rd_buf_2d_rec(fid,_2d)
 FILE *fid;
 struct buf_2d_rec *_2d;
{
 struct buf_2d_rec temp_2d,temp;
 int err;

 PRT1(printf("v3_rd_buf_2d_rec...begin\n"))

 if ((err = v3_rd_buf_2d_rec_hdr(fid,&temp_2d)) != NO_ERROR) return err;
 PRT1(printf("dimx = %d dimy = %d pixel_depth = %d status4 = %u\n",
     temp_2d.dimx,temp_2d.dimy,temp_2d.pixel_depth,temp_2d.status4))

 if ((temp_2d.dimx == 0) || (temp_2d.dimy == 0) ||
     (temp_2d.pixel_depth == 0)) return BAD_DATA;
 if ((temp_2d.dimx > 15000) || (temp_2d.dimy > 15000)) return BAD_DATA;
 init_buf_2d_rec(&temp);
 if ((err = SetupBuf2dRec(&temp,temp_2d.dimx,temp_2d.dimy,
       temp_2d.pixel_depth,0)) != NO_ERROR)
    return err;
 copy_buf_2d_rec_hdr_only(&temp,&temp_2d);
 Set2dValueType(&temp,temp_2d.status4 & BUF_VALUE_TYPE);

 TRACE(printf("v3_rd_buf_2d_rec temp.total_bytes = %d\n",temp.total_bytes))
 if (fread(temp.buf[0],temp.total_bytes,(size_t) 1,fid) != 1)
    {free_buf_2d_rec(&temp);
     return READ_ERROR;}
 free_buf_2d_rec(_2d);
 *_2d = temp;
 TRACE(printf("v3_rd_buf_2d_rec...end size(_2d) = %d\n",get_buf_2d_rec_size(_2d)))
 _2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_rd_non_contiguos_buf_2d_rec - ???
------------------------------------------------------------------------*/

int
v3_rd_non_contiguos_buf_2d_rec(fid,_2d)
 FILE *fid;
 struct buf_2d_rec *_2d;
{
 struct buf_2d_rec temp_2d;
 int err;

 PRT(printf("v3_rd_non_contiguos_buf_2d_rec...begin\n"))

 init_buf_2d_rec(&temp_2d);
 if ((err = v3_rd_buf_2d_rec(fid,&temp_2d)) != NO_ERROR)
    {if (err == BAD_DATA)
        {free_buf_2d_rec(_2d);
         return NO_ERROR;}
     return err;}
 if (!(temp_2d.status4 & BUF_NON_EMPTY))
    {free_buf_2d_rec(_2d);
     return NO_ERROR;}

 err = CopyToNonContiguos2d(_2d,&temp_2d);
 free_buf_2d_rec(&temp_2d);
 PRT(printf("v3_rd_non_contiguos_buf_2d_rec...err = %d\n",err))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_wr_buf_2d_rec_hdr - ???
------------------------------------------------------------------------*/

int
v3_wr_buf_2d_rec_hdr(fid,_2d)
 FILE *fid;
 struct buf_2d_rec *_2d;
{
 if (!(_2d->status4 & BUF_VERSION_NUM_USED))
    {_2d->status4 = BUF_VERSION_NUM_USED;
     _2d->version_num = BUF_2D_VERSION_NUM;}
 if ((fwrite(&(_2d->status4),sizeof(_2d->status4),1,fid) != 1) ||
     (fwrite(&(_2d->startoffx),sizeof(_2d->startoffx),1,fid) != 1) ||
     (fwrite(&(_2d->startoffy),sizeof(_2d->startoffy),1,fid) != 1) ||
     (fwrite(&(_2d->dimx),sizeof(_2d->dimx),1,fid) != 1) ||
     (fwrite(&(_2d->dimy),sizeof(_2d->dimy),1,fid) != 1) ||
     (fwrite(&(_2d->total_bytes),sizeof(_2d->total_bytes),1,fid) != 1) ||
     (fwrite(&(_2d->pixel_depth),sizeof(_2d->pixel_depth),1,fid) != 1) ||
     (fwrite(&(_2d->minval),sizeof(_2d->minval),1,fid) != 1) ||
     (fwrite(&(_2d->maxval),sizeof(_2d->maxval),1,fid) != 1) ||
     (fwrite(&(_2d->minval_set),sizeof(_2d->minval_set),1,fid) != 1) ||
     (fwrite(&(_2d->maxval_set),sizeof(_2d->maxval_set),1,fid) != 1) ||
     (fwrite(&(_2d->meanval),sizeof(_2d->meanval),1,fid) != 1) ||
     (fwrite(&(_2d->meanval_set),sizeof(_2d->meanval_set),1,fid) != 1) ||
     (fwrite(&(_2d->version_num),sizeof(_2d->version_num),1,fid) != 1) ||
     (fwrite(&(_2d->ustartx),sizeof(_2d->ustartx),1,fid) != 1) ||
     (fwrite(&(_2d->ustarty),sizeof(_2d->ustarty),1,fid) != 1) ||
     (fwrite(&(_2d->unitx),sizeof(_2d->unitx),1,fid) != 1) ||
     (fwrite(&(_2d->unity),sizeof(_2d->unity),1,fid) != 1) ||
     (fwrite(&(_2d->matrix),sizeof(_2d->matrix),1,fid) != 1))
    return WRITE_ERROR;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_wr_buf_2d_rec - ???
------------------------------------------------------------------------*/

int
v3_wr_buf_2d_rec(fid,_2d)
 FILE *fid;
 struct buf_2d_rec *_2d;
{
 int err;

 TRACE(printf("wr_buf_2d_rec...begin size(_2d) = %d\n",get_buf_2d_rec_size(_2d)))
 if (!(_2d->status4 & BUF_VERSION_NUM_USED))
    {_2d->status4 |= BUF_VERSION_NUM_USED;
     _2d->version_num = BUF_2D_VERSION_NUM;}

 if ((err = v3_wr_buf_2d_rec_hdr(fid,_2d)) != NO_ERROR) return err;

 TRACE(printf("v3_wr_buf_2d_rec _2d->total_bytes = %d\n",_2d->total_bytes))
 if (fwrite(_2d->buf[0],(size_t) _2d->total_bytes,(size_t) 1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("v3_wr_buf_2d_rec...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_wr_non_contiguos_buf_2d_rec - ???
------------------------------------------------------------------------*/

int
v3_wr_non_contiguos_buf_2d_rec(fid,_2d)
 FILE *fid;
 struct buf_2d_rec *_2d;
{
 int err;
 unsigned long lcv,cnt,dimy,row_bytes,status4=0;

 PRT(printf("v3_wr_non_contiguos_buf_2d_rec...\n"))
 for (cnt = lcv = 0; lcv < _2d->dimy; lcv++)
    if (_2d->buf[lcv] != NULL) cnt++;
 dimy = _2d->dimy;
 _2d->dimy = cnt;
 if (cnt == 0)
    {status4 = _2d->status4;
     _2d->status4 &= ~BUF_NON_EMPTY;}

 PRT(printf("v3_wr_non_contiguos_buf_2d_rec...dimy = %d cnt = %d\n",dimy,cnt))
 err = v3_wr_buf_2d_rec_hdr(fid,_2d);
 _2d->dimy = dimy;
 if (cnt == 0)
    {PRT(printf("v3_wr_non_contiguos_buf_2d_rec...buf is empty\n"))
     _2d->status4 = status4;
     return NO_ERROR;}
 PRT(printf("v3_wr_non_contiguos_buf_2d_rec...err = %d\n",err))
 if (err != NO_ERROR) return err;

 row_bytes = GetRowBytes(_2d->dimx,_2d->pixel_depth);
 for (lcv = 0; lcv < _2d->dimy; lcv++)
    if (_2d->buf[lcv] != NULL) 
       if (fwrite(_2d->buf[lcv],(size_t) row_bytes,(size_t) 1,fid) != 1)
          return WRITE_ERROR;
 PRT(printf("v3_wr_non_contiguos_buf_2d_rec...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_rd_2d - ???
------------------------------------------------------------------------*/

int
v3_rd_2d(fn,_2d)
 char *fn;
 struct buf_2d_rec *_2d;
{
 FILE *fid;
 int err;

 if ((fid = fopen(fn,"r")) == NULL) 
    {printf("v3_rd_2d...read err\n");
     return FILE_ACCESS_ERROR;}
 err = v3_rd_buf_2d_rec(fid,_2d);
 printf("v3_rd_2d...\n");
 fclose(fid);

 return err;
}


/*------------------------------------------------------------------------
v3_wr_2d - ???
------------------------------------------------------------------------*/

int
v3_wr_2d(fn,_2d)
 char *fn;
 struct buf_2d_rec *_2d;
{
 FILE *fid;
 int err;

 if ((fid = fopen(fn,"w")) == NULL) 
    {printf("v3_wr_2d...write err\n");
     return FILE_ACCESS_ERROR;}

 err = v3_wr_buf_2d_rec(fid,_2d);
 printf("v3_wr_2d...\n");
 fclose(fid);
 return err;
}

