#include "lib/mri_format.h"
/*
csh ltype-roi.com
cc -c type-roi.c
*/
/*
#define TRACE(x) x; fflush(stdout);
type-roi /omri/te/gwmri10347ar1.nhdr /omri/te "" a options.dat

*/
#define TRACE(x)

/*
IsAllPixelTypeMapReady(pixel_type,hdr)
DefinePartitionedPixelMap(slice_map,map,_2d1,_2d2)
setup_pixel_type_maps(pixel_type,num_slice_maps)
SetupPartitionedSliceMaps(pixel_type,hdr,hdrfn)
define_and_filter_pixel_type_map(pixel_type,hdr,ndatfn,types,is_filter_type,
                                 slice_rois,rois,is_filter_roi)

process_and_wr_images_1(fid,imgfn,outfid,outfn,hdr,pixel_type,slice_rois,
                        rois,is_filter_type,is_filter_roi)
process_and_wr_images(fn,hdr,pixel_type,slice_rois,
                      types,rois,is_filter_type,is_filter_roi,out_prefix)
process_data(fn,ndatdir,ndatprefix,types,rois,fmtfn,out_prefix,
             is_filter_type,is_filter_roi)
prog_usage(argc,argv)
get_options(fn,types,rois,fmtfn,is_filter_type,is_filter_roi)
main(argc,argv)
*/
char *locate_dirfn();
struct roi_rec *get_roi();
unsigned long NumberOfSliceCuts();

IsAllPixelTypeMapReady(pixel_type,hdr)
 struct pixel_type_rec *pixel_type;
 struct hdr_rec *hdr;
{
 long lcv;
 struct pixmap_hdr_rec *pixhdr;
 long num_slices;
 int yes;

 TRACE(printf("IsAllPixelTypeMapReady num_slice_maps = %d\n",
             pixel_type->num_slice_maps);)
 if (pixel_type->order.num_strs == 0) return 0;
 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 TRACE(printf("IsAllPixelTypeMapReady num_slices = %d\n",
             num_slices);)
 if ((hdr->data_info.num_echoes == 2) &&
     !(pixel_type->status & PIXEL_TYPE_GROW_REGION))
    {
     TRACE(printf("IsAllPixelTypeMapReady partitioned\n");)
     if (pixel_type->map.status4 & BUF_DATA_VALID)
        return 2;
    }
   else if (pixel_type->num_slice_maps == num_slices)
    {pixhdr = &(pixel_type->pixmap_hdr);
     TRACE(if (pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID)
        printf("PIXEL_TYPE_PIXMAP_HDR_VALID...\n");)
     TRACE(printf("IsAllPixelTypeMapReady pixmap\n");)
     for (yes = 0,lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
        if (!(pixel_type->slice_maps[lcv]->status4 & BUF_DATA_VALID)) 
           {TRACE(printf("lcv = %d\n",lcv);)
            if ((pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID) &&
                (lcv < pixhdr->max_slices) &&
                (pixhdr->pixmap_offsets[lcv] != 0))
               {yes = 1;
                continue;}
            break;}
          else yes = 1;
     if (lcv == pixel_type->num_slice_maps) return 2;
     TRACE(printf("IsAllPixelTypeMapReady lcv = %d\n",lcv);)
     if (yes) return 1;
     for (lcv++; lcv < pixel_type->num_slice_maps; lcv++)
        if (!(pixel_type->slice_maps[lcv]->status4 & BUF_DATA_VALID)) 
           {
            if ((pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID) &&
                (lcv < pixhdr->max_slices) &&
                (pixhdr->pixmap_offsets[lcv] != 0))
               return 1;
           }
          else return 1;
    }
 return 0;
}

DefinePartitionedPixelMap(slice_map,map,_2d1,_2d2)
 struct buf_2d_rec *slice_map,*map,*_2d1,*_2d2;
{
 int err;

 unsigned long row,col,indx,val1,val2;

 for (row = 0; row < map->dimy; row++)
    for (col = 0; col < map->dimx; col++)
       {val1 = get_1d_buf_value(_2d1->buf[row],col,_2d1->pixel_depth);
        val2 = get_1d_buf_value(_2d2->buf[row],col,_2d2->pixel_depth);
        indx = get_1d_buf_value(map->buf[val2],val1,map->pixel_depth);
        set_1d_buf_value(slice_map->buf[row],col,slice_map->pixel_depth,indx);}
}

setup_pixel_type_maps(pixel_type,num_slice_maps)
 struct pixel_type_rec *pixel_type; 
 unsigned long num_slice_maps;
{
 int err;
 long lcv;

 if (pixel_type->num_slice_maps == 0)
    {
     if ((err = get_handle(&(pixel_type->slice_maps),
          &(pixel_type->num_slice_maps),
          (unsigned long) num_slice_maps,
          (size_t) sizeof(**(pixel_type->slice_maps)))) != NO_ERROR)
        return err;
     for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
        init_buf_2d_rec(pixel_type->slice_maps[lcv]);
    }
 return NO_ERROR;
}

SetupPartitionedSliceMaps(pixel_type,hdr,hdrfn)
 struct pixel_type_rec *pixel_type;
 struct hdr_rec *hdr;
 char *hdrfn;
{
 FILE *fid;
 char *reason,*imgfn,*temp;
 struct buf_2d_rec _2d1,_2d2;
 long lcv;
 long num_slices;
 int err;

 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 if ((err = setup_pixel_type_maps(pixel_type,num_slices)) != NO_ERROR)
    return err;
 temp = imgfn = NULL;
 if (((err = cp_str(&temp,hdrfn)) != NO_ERROR) ||
     ((err = drop_suffix(temp)) != NO_ERROR) ||
     ((err = concat_strs(&imgfn,2,temp,".img")) != NO_ERROR))
    {printf("Error constructing imgfn = %s...err = %d\n",hdrfn,err);
     c_free(temp);
     c_free(imgfn);
     return err;
    }
 c_free(temp);
 if ((fid = fopen(imgfn,"r")) == NULL)
    {file_access(imgfn,4,NULL,&reason);
     printf("Error opening the img file = %s...reason = %s\n",imgfn,reason);
     c_free(reason);
     c_free(imgfn);
     return FILE_ACCESS_ERROR;}
 TRACE(printf("SetupPartitionedSliceMaps...imgfn = %s\n",imgfn))

 init_buf_2d_rec(&_2d1);
 init_buf_2d_rec(&_2d2);
 if (((err = SetupBuf2dRec(&_2d1,hdr->data_info.dimx,hdr->data_info.dimy,
          hdr->data_info.pixel_depth_bits,0)) == NO_ERROR) &&
     ((err = SetupBuf2dRec(&_2d2,hdr->data_info.dimx,hdr->data_info.dimy,
          hdr->data_info.pixel_depth_bits,0)) == NO_ERROR))
    {
     for (lcv = 0; lcv < num_slices; lcv++)
        {if ((err = SetupBuf2dRec(pixel_type->slice_maps[lcv],
             hdr->data_info.dimx,hdr->data_info.dimy,
             pixel_type->map.pixel_depth,0)) != NO_ERROR)
            break;

         if ((fread(_2d1.buf[0],(size_t) _2d1.total_bytes,(size_t) 1,fid) != 1) ||
             (fread(_2d2.buf[0],(size_t) _2d2.total_bytes,(size_t) 1,fid) != 1))
            {err = READ_ERROR;
             printf("Error reading Slice#%d from %s\n",lcv+1,imgfn);
             break;}
         _2d1.minval_set = _2d2.minval_set = hdr->data_info.min_pixel;
         _2d1.maxval_set = _2d2.maxval_set = hdr->data_info.max_pixel;
         _2d1.status4 |= BUF_MIN_MAX_SET;
         _2d2.status4 |= BUF_MIN_MAX_SET;

         if (((err = Scale2dPixels(&_2d1,&_2d1,(double) .0,
               (double) (pixel_type->map.dimx - 1),
               0,(double) .0,(double) .0,0)) != NO_ERROR) ||
             ((err = Scale2dPixels(&_2d2,&_2d2,(double) .0,
               (double) (pixel_type->map.dimy - 1),
               0,(double) .0,(double) .0,0)) != NO_ERROR))
            break;
         DefinePartitionedPixelMap(pixel_type->slice_maps[lcv],
                &(pixel_type->map),&_2d1,&_2d2);
        }
    }

 free_buf_2d_rec(&_2d1);
 free_buf_2d_rec(&_2d2);
 c_free(imgfn);
 return err;
}

define_and_filter_pixel_type_map(pixel_type,hdr,ndatfn,types,is_filter_type,
                                 slice_rois,rois,is_filter_roi)
 struct pixel_type_rec *pixel_type;
 struct hdr_rec *hdr;
 char *ndatfn;
 struct strs_rec *types;
 int is_filter_type;
 struct slice_roi_rec *slice_rois;
 struct strs_rec *rois;
 int is_filter_roi;
{
 unsigned long row,col,indx,lcv,cnt,num_slices;
 unsigned long *type_indxs,total;
 int err;
 struct buf_2d_rec *map;
 char *dir,*fn1,*suffix;
 int define;

 TRACE(printf("define_and_filter_pixel_type_map...\n");)
 if (!is_filter_type) return NO_ERROR;
 TRACE(printf("define_and_filter_pixel_type_map...1\n");)
 err = NO_ERROR;
 if (pixel_type->status & PIXEL_TYPE_GROW_REGION)
    {
     num_slices = NumberOfSliceCuts(&(hdr->data_info));
     if ((err = break_fn(ndatfn,&dir,&fn1,&suffix)) == NO_ERROR)
        if ((err = AutoRdFilePixmapHdr1(dir,fn1,".pixmap",pixel_type))
                        == NO_ERROR)
           {TRACE(printf("rd_file_pixmap_slices...\n");)
            if ((err = rd_file_pixmap_slices(dir,fn1,".pixmap",
                       pixel_type,num_slices)) == NO_ERROR)
               pixel_type->status &= ~PIXEL_TYPE_2D_PARTITION;
           }
     c_free(dir);
     c_free(fn1);
     c_free(suffix);
    }
 TRACE(printf("define_and_filter_pixel_type_map.2..err = %d\n",err);)
 if (err != NO_ERROR) return err;
 if ((define = IsAllPixelTypeMapReady(pixel_type,hdr)) != 2)
    {err = CANCEL;
     if (define == 0)
        printf("CANCEL : pixel type map undefined !!!\n");
       else
        printf("CANCEL : not all slice pixel type maps are defined !!!\n");
     return err;
    }
 if (!(pixel_type->status & PIXEL_TYPE_DEFINED))
    {printf("CANCEL : PIXEL TYPE UNDEFINED\n");
     return CANCEL;}
 if (pixel_type->order.num_strs == 0)
    {printf("CANCEL : PIXEL TYPE LABELS UNDEFINED\n");
     return CANCEL;}
 type_indxs = NULL;
 TRACE(printf("define_and_filter_pixel_type_map.3..err = %d\n",err);)
 if (types->num_strs > 0)
    {total = 0;
     if ((err = get_ptr(&type_indxs,&total,types->num_strs,
            (size_t) sizeof(*type_indxs))) != NO_ERROR)
        return err;
     for (lcv = 0; lcv < types->num_strs; lcv++)
        {if ((err = find_str_in_strs_rec(&(pixel_type->order),types->strs[lcv],&indx))
                != NO_ERROR)
            {c_free(type_indxs);
             printf("CANCEL : %s UNDEFINED\n",types->strs[lcv]);
             return CANCEL;}
         type_indxs[lcv] = indx + 1;}
    }

 if (pixel_type->status & PIXEL_TYPE_2D_PARTITION)
    {TRACE(printf("process_ntxt...PIXEL_TYPE_2D_PARTITION\n"))
     if (types->num_strs > 0)
        {map = &(pixel_type->map);
         for (row = 0; row < map->dimy; row++)
            for (col = 0; col < map->dimx; col++)
               {indx = get_1d_buf_value(map->buf[row],col,map->pixel_depth);
                for (lcv = 0; lcv < types->num_strs; lcv++)
                   if (indx == type_indxs[lcv]) break;
                if (lcv == types->num_strs)
                   set_1d_buf_value(map->buf[row],col,map->pixel_depth,0);
               }
        }
     if ((err = SetupPartitionedSliceMaps(pixel_type,hdr,
                     ndatfn)) != NO_ERROR)
        printf("ERROR setting up the slice pixel maps !!!\n");
    }
   else if (types->num_strs > 0)
    {
     TRACE(printf("define_and_filter_pixel_type_map.4..err = %d\n",err);)
     for (cnt = 0; cnt < pixel_type->num_slice_maps; cnt++)
        {map = pixel_type->slice_maps[cnt];
         if (is_filter_roi > 0)
            {for (lcv = 0; lcv < rois->num_strs; lcv++)
                if (get_roi(&(slice_rois[cnt]),rois->strs[lcv]) != NULL)
                   break;
             if (lcv == rois->num_strs) continue;}

         for (row = 0; row < map->dimy; row++)
            for (col = 0; col < map->dimx; col++)
               {indx = get_1d_buf_value(map->buf[row],col,map->pixel_depth);
                for (lcv = 0; lcv < types->num_strs; lcv++)
                   if (indx == type_indxs[lcv]) break;
                if (lcv == types->num_strs)
                   set_1d_buf_value(map->buf[row],col,map->pixel_depth,0);
               }
        }
     TRACE(printf("define_and_filter_pixel_type_map.5..err = %d\n",err);)
    }
 c_free(type_indxs);
 TRACE(printf("define_and_filter_pixel_type_map...6\n");)

 return NO_ERROR;
}

process_and_wr_images_1(fid,imgfn,outfid,outfn,hdr,pixel_type,slice_rois,
                        rois,is_filter_type,is_filter_roi)
 FILE *fid,*outfid;
 char *imgfn,*outfn;
 struct hdr_rec *hdr;
 struct pixel_type_rec *pixel_type;
 struct slice_roi_rec *slice_rois;
 struct strs_rec *rois;
 int is_filter_type,is_filter_roi;
{
 struct buf_2d_rec orig;
 long lcv,cnt,indx,indx1;
 int err,done;
 struct int_bound_rec affected;
 struct draw_mask_rec mask,mask1;
 struct roi_rec *roi;
 unsigned long num_slices,max_scans;

 TRACE(printf("process_and_wr_images_1...pixel_type->num_slice_maps = %d\n",
        pixel_type->num_slice_maps))
 init_buf_2d_rec(&orig);
 init_draw_mask_rec(&mask);
 init_draw_mask_rec(&mask1);
 if (is_filter_roi >= 0)
    {if (((err = get_draw_mask_rec(&mask,
           hdr->data_info.dimx,hdr->data_info.dimy)) != NO_ERROR) ||
         ((err = get_draw_mask_rec(&mask1,
           hdr->data_info.dimx,hdr->data_info.dimy)) != NO_ERROR))
        {
         free_draw_mask_rec(&mask);
         free_draw_mask_rec(&mask1);
         return err;
        }
    }
 if ((err = SetupBuf2dRec(&orig,
          hdr->data_info.dimx,hdr->data_info.dimy,
          hdr->data_info.pixel_depth_bits,0)) == NO_ERROR)
    {num_slices = NumberOfSliceCuts(&(hdr->data_info));
     printf("   Total slices = %d...\n",num_slices);
/* has been changed */
     max_scans = num_slices * hdr->data_info.num_echoes;

     for (indx = 0; indx < max_scans; indx++)
        {lcv = indx / hdr->data_info.num_echoes;
         printf("Processing Slice#%d echo#%d...\n",lcv+1,
               indx % hdr->data_info.num_echoes + 1);
         fflush(stdout);
         if (is_filter_roi > 0)
            {for (done = 0,cnt = 0; cnt < rois->num_strs; cnt++)
                if ((roi = get_roi(&(slice_rois[lcv]),rois->strs[cnt])) != NULL)
                   {done = 1;
                    break;}
             if (!done)
                {InitBuf2dRecData(&orig,(double) .0);
                 delete_all_rois(&(slice_rois[lcv]));
                 if (fwrite(orig.buf[0],(size_t) orig.total_bytes,
                         (size_t) 1,outfid) != 1)
                    {err = WRITE_ERROR;
                     printf("Error writing Slice#%d echo#%d to %s\n",
                        lcv+1,indx % hdr->data_info.num_echoes + 1,outfn);
                     break;}
                 continue;
                }
            }
         fseek(fid,hdr->scans[indx].img_addr,0);
         if (fread(orig.buf[0],(size_t) orig.total_bytes,
                         (size_t) 1,fid) != 1)
            {err = READ_ERROR;
             printf("Error reading Slice#%d echo#%d from %s\n",
                     lcv+1,indx % hdr->data_info.num_echoes + 1,imgfn);
             break;}
         TRACE(printf("init  orig = %d\n",
                      cnt_val_buf_2d_rec(&orig,0));)
         if (is_filter_type)
            {
             Set2dByNotMask(&orig,0,0,pixel_type->slice_maps[lcv],NULL,0);
             TRACE(printf(" pix filter  orig = %d\n",cnt_val_buf_2d_rec(&orig,0));)
            }
         if (is_filter_roi >= 0)
            {
             TRACE(printf("orig mask = %d  ",
                      cnt_val_buf_2d_rec(&(mask.mask._2d),1));)
             if (is_filter_roi > 0)
                {for (cnt = 0; cnt < rois->num_strs; cnt++)
                    {if ((roi = get_roi(&(slice_rois[lcv]),rois->strs[cnt])) != NULL)
                        if ((err = GetFilledRoiMask(roi,NULL,
                             &mask1,&affected)) == NO_ERROR)
                           {
                            TRACE(printf(" mask1 = %d  \n",
                             cnt_val_buf_2d_rec(&(mask1.mask._2d),1));)
                            superimpose_bitmap_region(&(mask.mask._2d),
                                &(mask1.mask._2d),&affected);}
                          else break;
                    }
                 for (done = 0; !done;)
                    {for (done = 1,cnt = 0; cnt < slice_rois[lcv].num_rois; cnt++)
                        if (find_str_in_strs_rec(rois,slice_rois[lcv].rois[cnt]->label,
                                     &indx1) != NO_ERROR)
                           {TRACE(printf("Deleting %s\n",
                                    slice_rois[lcv].rois[cnt]->label))
                            delete_roi(&(slice_rois[lcv]),slice_rois[lcv].rois[cnt]);
                            done = 0;
                            break;}
                    }
                }
               else
                if ((err = GetFilledAllRoisMask(&(slice_rois[lcv]),NULL,
                                &mask1)) == NO_ERROR)
                    {TRACE(printf(" mask1 = %d  \n",
                            cnt_val_buf_2d_rec(&(mask1.mask._2d),1)) ;)
                     OrBitmaps(&(mask.mask._2d),&(mask.mask._2d),
                                 &(mask1.mask._2d));}
             TRACE(printf("  mask = %d\n",
                      cnt_val_buf_2d_rec(&(mask.mask._2d),1));)
             Set2dByNotMask(&orig,0,0,&(mask.mask._2d),NULL,0);
             InitBuf2dRecData(&(mask.mask._2d),(double) .0);
            }
         if (err != NO_ERROR) break;
         TRACE(printf("  orig = %d\n",
                      cnt_val_buf_2d_rec(&orig,0));)
         if (fwrite(orig.buf[0],(size_t) orig.total_bytes,
                         (size_t) 1,outfid) != 1)
            {err = WRITE_ERROR;
             printf("Error writing Slice#%d echo#%d to %s\n",
                        lcv+1,indx % hdr->data_info.num_echoes + 1,outfn);
             break;}
        }
    }
 TRACE(printf("process_and_wr_images_1...err = %d\n",err))
 free_buf_2d_rec(&orig);
 free_draw_mask_rec(&mask);
 free_draw_mask_rec(&mask1);

 return err;
}

process_and_wr_images(fn,hdr,pixel_type,slice_rois,
                      rois,is_filter_type,is_filter_roi,out_prefix)
 char *fn,*out_prefix;
 struct hdr_rec *hdr;
 struct pixel_type_rec *pixel_type;
 struct slice_roi_rec *slice_rois;
 struct strs_rec *rois;
 int is_filter_type,is_filter_roi;
{
 FILE *fid,*outfid;
 char *str,*imgfn,*outimgfn,*imgdir,*outfn;
 int err;

 TRACE(printf("process_and_wr_images....fn = %s\n",fn))
 str = imgfn = outimgfn = NULL;
 if (((err = cp_str(&str,fn)) == NO_ERROR) &&
     ((err = drop_suffix(str)) == NO_ERROR) &&
     ((err = concat_strs(&imgfn,2,str,".img")) == NO_ERROR) &&
     ((err = cp_str(&outimgfn,imgfn)) == NO_ERROR) &&
     ((err = drop_dirfn(outimgfn)) == NO_ERROR) &&
     ((err = concat_strs(&outfn,2,out_prefix,outimgfn)) == NO_ERROR))
    {
     if ((fid = fopen(imgfn,"r")) != NULL)
        {
         if ((outfid = fopen(outfn,"w")) != NULL)
            {err = process_and_wr_images_1(fid,imgfn,outfid,outfn,hdr,pixel_type,
                          slice_rois,rois,is_filter_type,is_filter_roi);
             fclose(outfid);
             if (err != NO_ERROR) delete_file(outfn);
               else printf(" ...%s created\n",outfn);
            }
           else
            {printf("\nCould not open the output file: %s\n",outfn);
             err = FILE_ACCESS_ERROR;}
         fclose(fid);
        }
       else
        {printf("\nCould not open img file: %s\n",imgfn);
         err = FILE_ACCESS_ERROR;}
    }
 c_free(str);
 c_free(imgfn);
 c_free(outimgfn);
 c_free(outfn);
 if (err == NO_ERROR)
    {outfn = str = NULL;
     if (((err = cp_str(&str,fn)) == NO_ERROR) &&
         ((err = drop_dirfn(str)) == NO_ERROR) &&
         ((err = concat_strs(&outfn,2,out_prefix,str)) == NO_ERROR))
        {if ((err = wr_the_hdr(outfn,hdr)) == NO_ERROR)
            printf("...%s created !!!\n",outfn);
           else printf("Error creating %s !!!\n",outfn);
         }
     c_free(str);
     c_free(outfn);
    }

 return err;
}

process_data(fn,ndatdir,ndatprefix,types,rois,fmtfn,out_prefix,
             is_filter_type,is_filter_roi)
 char *fn,*ndatdir,*ndatprefix;
 struct strs_rec *types,*rois;
 char *fmtfn,*out_prefix;
 int is_filter_type,is_filter_roi;
{
 struct hdr_rec hdr;
 int err;
 char *str,*datfn,*str1;
 struct output_hdr_rec ndathdr;
 struct slice_roi_rec *slice_rois;
 long total_slice_rois;
 struct histo_params_rec histo;
 struct pixel_type_rec pixel_type;
 struct text_output_analysis_group_rec *groups;
 unsigned_int num_groups;
 struct output_text_format_rec format;
 struct count_analysis_rec count;

 TRACE(printf("process_2_echoes....fn = %s\n",fn))
 init_hdr_rec(&hdr);
 init_pixel_type_rec(&pixel_type);
 str = datfn = NULL;
 if ((err = rd_the_hdr(fn,&hdr)) != NO_ERROR)
    printf("  ...Error reading the header file %s\n",fn);
   else if (((err = cp_str(&str,fn)) == NO_ERROR) &&
     ((err = drop_suffix(str)) == NO_ERROR) &&
     ((err = drop_dirfn(str)) == NO_ERROR) &&
     ((err = concat_strs(&datfn,5,ndatdir,"/",ndatprefix,str,".ndat")) == NO_ERROR))
    {if (((err = RdTheNdatFields(datfn,&ndathdr,&slice_rois,&total_slice_rois,
              &histo,&pixel_type,&groups,&num_groups,
              &format,&count)) == NO_ERROR) &&
         ((err = define_and_filter_pixel_type_map(&pixel_type,&hdr,datfn,
                types,is_filter_type,slice_rois,rois,is_filter_roi)) == NO_ERROR) &&
         ((err = process_and_wr_images(fn,&hdr,&pixel_type,slice_rois,rois,
                    is_filter_type,is_filter_roi,out_prefix)) == NO_ERROR))
        {str1 = NULL;

         if ((drop_dirfn(datfn) == NO_ERROR) &&
             (concat_strs(&str1,2,out_prefix,datfn) == NO_ERROR))
            {printf("ndat fn = %s\n",str1);
             free_output_text_format_rec(&format);
              
             if (RdTextFormat(fmtfn,&groups,&num_groups,&format) != NO_ERROR)
                {printf("Warning : error reading the format file %s !!!\n",fmtfn);
                }
             free_histo_params_rec(&histo);
             if (WrRiaNdatFile(str1,&ndathdr,slice_rois,total_slice_rois,
                       &histo,&pixel_type,groups,num_groups,&format,&count) == NO_ERROR)
                printf("%s created !!!\n",str1);
               else printf("Warning : error creating %s !!!\n",str1);
            }
           else printf("Warning : error creating the ndat file !!!\n");
         c_free(str1);}
      free_ndat_fields(&ndathdr,slice_rois,total_slice_rois,
              &histo,&pixel_type,groups,num_groups,&format,&count);
     }
 TRACE(printf("process_2_echoes....err = %d\n",err))

 free_hdr_rec(&hdr);
 c_free(str);
 c_free(datfn);
 free_pixel_type_rec(&pixel_type);
 if (err != NO_ERROR) printf("  ...Error processing %s\n",fn);
 return err;
}

prog_usage(argc,argv)
 int argc;
 char *argv[];
{

 if (argc != 6)
    {printf("Usage 1 : %s a.nhdr ndat-dir ndat-prefix output-prefix option-file\n",argv[0]);
     printf("Example 1 : %s a.nhdr /omri/ndat abc g option-file\n",argv[0]);
     printf("1) INPUT : a.nhdr\n");
     printf("         : /omri/ndat/abca.ndat\n\n");
     printf("         : option-file\n\n");
     printf("2) OUTPUT : ga.nhdr\n");
     printf("3) OUTPUT : ga.img\n");
     printf("      2 : %s \"*.nhdr\" ndat-dir ndat-prefix g option-file\n",argv[0]);
     printf("1) INPUT : *.nhdr\n");
     printf("2) OUTPUT : g*.nhdr\n");
     printf("3) OUTPUT : g*.img\n");
     printf("\n");
     printf("Example of content of the option-file\n");
     printf("2   #  filter the image pixels by these number of tissue types\n");
     printf("    #   0 --> ignoring the tissue types...all image pixels\n");
     printf("\"gray matter\"  # type = gray matter\n");
     printf("\"white matter\"  # type = white matter\n");
     printf("\n");
     printf("1   #  filter the image pixels by these number of rois\n");
     printf("2   #  number of rois to be retrieved\n");
     printf("    #  0 --> all rois\n");
     printf("    #  < 0 --> all image pixels\n");
     printf("\"left temporal\"\n");
     printf("\"right temporal\"\n");
     printf("\n");
     printf("text_format.dat  # text format specification\n");
     printf("                 # \"\" if provided means use the existing\n");
     printf("\n");
     exit(1);}
}

get_options(fn,types,rois,fmtfn,is_filter_type,is_filter_roi)
 char *fn;
 struct strs_rec *types,*rois;
 char **fmtfn;
 int *is_filter_type,*is_filter_roi;
{
 FILE *fid;
 long num,lcv,total_items;
 char str[80];
 int err;

 if ((fid = fopen(fn,"r")) == NULL)
    {printf("\nCould not open the option file: %s\n",fn);
     return FILE_ACCESS_ERROR;}
 
 total_items = 1;
 if ((err = RdText(fid,&num,&total_items,RD_INT,0)) != NO_ERROR) 
    {printf("Error reading the option file: %s\n",fn);
     return err;}
 if (num == 0) *is_filter_type = 0;
   else
    {*is_filter_type = 1;
     for (lcv = 0; lcv < num; lcv++)
        {total_items = sizeof(str) - 1;
         if ((err = RdText(fid,str,&total_items,RD_TEXT,0)) != NO_ERROR) 
            {printf("Error reading the option file: %s\n",fn);
             return err;}
         if ((err = add_str_to_strs_rec(types,str)) != NO_ERROR) 
            {printf("Error processing the option file: %s\n",fn);
             return err;}
        }
    }
 TRACE(printf("types...*is_filter_type = %d\n",*is_filter_type);pr_strs_rec(types);)
 total_items = 1;
 if ((err = RdText(fid,&num,&total_items,RD_INT,0)) != NO_ERROR) 
    {printf("Error reading the option file: %s\n",fn);
     return err;}
 if (num < 0) *is_filter_roi = -1;
   else if (num == 0) *is_filter_roi = 0;
   else
    {*is_filter_roi = 1;
     for (lcv = 0; lcv < num; lcv++)
        {total_items = sizeof(str) - 1;
         if ((err = RdText(fid,str,&total_items,RD_TEXT,0)) != NO_ERROR) 
            {printf("Error reading the option file: %s\n",fn);
             return err;}
         if ((err = add_str_to_strs_rec(rois,str)) != NO_ERROR) 
            {printf("Error processing the option file: %s\n",fn);
             return err;}
        }
    }
 TRACE(printf("rois...*is_filter_roi = %d\n",*is_filter_roi);pr_strs_rec(rois);)
 total_items = sizeof(str) - 1;
 if ((err = RdText(fid,str,&total_items,RD_TEXT,0)) != NO_ERROR) 
    {printf("Error reading the option file: %s\n",fn);
     return err;}
 if ((err = cp_str(fmtfn,str)) != NO_ERROR) 
    printf("Error processing the option file: %s\n",fn);
   TRACE(else printf("fmtfn = %s\n",*fmtfn);)
 return err;

}

main(argc,argv)
 int argc;
 char *argv[];
{
 char **fns;
 unsigned int num_fns;
 unsigned long lcv;
 char *dirfn,fn[200],*fmtfn;
 int err;
 int is_filter_type,is_filter_roi;
 struct strs_rec warn,errlog,types,rois;

 prog_usage(argc,argv);

 dirfn = (char *) locate_dirfn(argv[1]);
 drop_dirfn(argv[1]);
 if (dirfn == NULL) dirfn = ".";
 if ((err = get_fns(dirfn,NULL,0,0,NULL,&fns,&num_fns,1,argv[1],
         NULL,0,0,NULL)) != NO_ERROR) exit(err);
 if (num_fns == 0)
    {printf("Sorry...No file names...\n");
     sprintf(fn,"%s/%s",dirfn,argv[1]);
     printf("...Fn specification processed = %s\n",fn);
    }
   else
    {printf("\n");
     init_strs_rec(&errlog);
     init_strs_rec(&warn);
     init_strs_rec(&types);
     init_strs_rec(&rois);
     if ((err = get_options(argv[5],&types,&rois,&fmtfn,&is_filter_type,
             &is_filter_roi)) !=  NO_ERROR)
        exit(err);
     for (lcv = 0; lcv < num_fns; lcv++)
        {sprintf(fn,"%s/%s",dirfn,fns[lcv]);
         printf("%d) reading %s\n",lcv,fn);
         if ((err = process_data(fn,argv[2],argv[3],&types,&rois,fmtfn,
              argv[4],is_filter_type,is_filter_roi)) != NO_ERROR)
           {printf("...%d) ERROR processing %s...err = %d\n",
                       lcv,fn,err);
            add_str_to_strs_rec(&errlog,fn);
            err = NO_ERROR;}
        }
     if (errlog.num_strs > 0)
        {printf("\nErrors occurred when processing the following files :-\n");
         for (lcv = 0; lcv < errlog.num_strs; lcv++)
            printf("%d) %s\n",lcv,errlog.strs[lcv]);
         printf("\n");}
     free_strs_rec(&errlog);
     free_strs_rec(&warn);
    }

 exit(0);
}
