/****************************************************************************
3d_setup.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_setup.c,v 1.9 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";

/* FIXME:  Apparently not needed.
#include <time.h>
#include <sys/timeb.h>
*/


#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT3(x)
#define PRT4(x)
#define PRT2(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)



/* Functions defined in this file */
int GroupViewWids(struct view_rec *view, struct strs_rec *labels,
    int is_cp_str, int is_sorted);
int FileViewWids(struct input_file_rec *file, struct strs_rec *labels,
    int is_cp_str, int is_sorted, int inc_cur_group, int cur_group_num);
int AnyViewWids(struct input_file_rec *file, struct strs_rec *labels,
    int is_cp_str, int is_sorted, int inc_cur_file, int inc_cur_group,
    int cur_group_num);
struct view_rec *view_with_group_num(struct input_file_rec *file,
    int group_num);
char *encode_img_label(char *img_label, char *plane_label);
char *decode_img_label(char *img_label);
int rois_to_img_label(char **img_label, char *img_type, struct strs_rec *roi,
    struct strs_rec *pixel_type);
int volume_to_img_label(char **img_label, char *img_type,
    struct int_bound_rec *area, long minz, long maxz,
    struct strs_rec *pixel_type);
void loading_3d_data_error(int select);
int get_file_3d_data(struct input_file_rec *file, char *id,
    int (*project_plane_proc)(), struct view_rec *view, void *arg2,
    void *arg3, void *arg4, int interpolation_method, char *msg);
int Setup3dRoi(struct input_file_rec *file, char *roi_label,
    struct buf_3d_rec *_3d, int (*next_proc)(), int *error, void *arg1,
    void *arg2, void *arg3, void *arg4);
int get_file_3d_roi_data(struct input_file_rec *file, char *id,
    int (*project_plane_proc)(), struct view_rec *view, void *arg2,
    void *arg3, void *arg4, int interpolation_method, char *msg);
int Redefine3dPixmaps(struct input_file_rec *file);
void WinRedefine3dPixmaps(struct image_display_window *win);
int get_file_3d_pixel_types(struct input_file_rec *file, char *id,
    int (*project_plane_proc)(), struct view_rec *view, void *arg2,
    void *arg3, void *arg4, int interpolation_method, char *msg);
int get_3d_sub_region(struct input_file_rec *file, struct view_rec *view,
    struct strs_rec *labels, struct int_bound_rec *area, long minz, long maxz);
int get_3d_sub_obj(struct input_file_rec *file, struct view_rec *view,
    struct strs_rec *roi_strs, struct strs_rec *labels,
    struct int_bound_rec *area, long minz, long maxz);
int get_sub_obj_img_labels(struct input_file_rec *file, char *plane_id,
    struct strs_rec *labels, int get_all);
int get_3d_sub_obj_by_pixel_types(struct view_rec *view,
    struct strs_rec *pixel_types, char *plane_id);
int get_file_3d_sub_obj(struct input_file_rec *file, struct view_rec *view,
    struct strs_rec *roi_strs, struct strs_rec *pixel_types, char *plane_id,
    struct int_bound_rec *area, long minz, long maxz, int is_roi);
int get_file_sub_obj_volume(struct view_rec *view, struct strs_rec *roi_strs,
    struct int_bound_rec *area, long *minz, long *maxz);
int get_file_3d(struct input_file_rec *file, char *id,
    int (*project_plane_proc)(), int (*project_plane_proc_if_found)(),
    struct view_rec *view, void *arg2, void *arg3, void *arg4,
    int interpolation_method, char *msg);
void SetupAll3dEchoes(struct view_rec *view, int indx, int (*next_proc)(),
    void *next_proc_arg, int method, char *msg);
void setup_and_display_3d_rois(struct view_rec *view, struct list_rec *list);
void setup_and_display_3d_pixel_types(struct view_rec *view,
    struct list_rec *list);
int find_file_3d(struct input_file_rec *file, char *id,
    struct buf_3d_rec **_3d);
int is_file_3d_valid(struct input_file_rec *file, struct buf_3d_rec *_3d);
int _3d_xyz_pixel_sizes(struct img_buf_rec *img, float *xpixel_size,
    float *ypixel_size, float *zpixel_size);
int get_3d_use_status(struct input_file_rec *file, struct buf_3d_rec *_3d);
int delete_file_3d(struct input_file_rec *file, char *id);
int SetupViewRec(struct view_rec *view, struct input_file_rec *file,
    char *id, double x, double y, double z, double normalx, double normaly,
    double normalz, struct vector_3d_rec *start, struct vector_3d_rec *end,
    long buf_dimx, long buf_dimy, struct vector_3d_rec *translate,
    struct vector_3d_rec *scale, struct vector_3d_rec *rotate,
    struct vector_3d_rec *center, double xratio, double yratio,
    double zratio, struct matrix_3d_rec *global_matrix,
    int is_adjust_to_center, unsigned long is_approx_value);
void delete_view_rec(struct input_file_rec *file, struct view_rec *view);
int SetupFileViewRec(struct input_file_rec *file, char *id, double x,
    double y, double z, double normalx, double normaly, double normalz,
    struct vector_3d_rec *start, struct vector_3d_rec *end, long buf_dimx,
    long buf_dimy, struct vector_3d_rec *translate,
    struct vector_3d_rec *scale, struct vector_3d_rec *rotate,
    struct vector_3d_rec *center, double xratio, double yratio, double zratio,
    struct matrix_3d_rec *global_matrix, int is_adjust_to_center,
    unsigned long option, struct view_rec **view_data);
int setup_file_3d(struct input_file_rec *file, char *id, unsigned long option);
int setup_file_3d_sub_obj(struct input_file_rec *file, char *id,
    struct view_rec *view);



/*----------------------------------------------------------------------
GroupViewWids - ???
----------------------------------------------------------------------*/

int
GroupViewWids(view,labels,is_cp_str,is_sorted)
 struct view_rec *view;
 struct strs_rec *labels;
 int is_cp_str,is_sorted;
{
 struct view_rec *view1;
 struct list_rec *cur,*next;
 int err;
 long cnt;

 PRT3(printf("GroupViewWids...\n"))
 if (is_sorted) sort_strs_rec_ascendingly(labels);
 PRT3(pr_strs_rec(labels))
 next = cur = &(view->_3d_list);
 do 
    {view1 = next->item;
     PRT3(printf("GroupViewWids view1->wid = %s\n",view1->wid))
     if ((view1 != NULL) && (view1->img != NULL) && (view1->img->win != NULL))
        {
         PRT3(printf("in wid = %s\n",view1->wid))
         if (is_cp_str)
            {if (is_sorted) 
                {if ((err = AddStrToSortedStrsRec(labels,view1->wid,0,1)) != NO_ERROR)
                    {return err;}
                }
               else if ((err = add_str_to_strs_rec(labels,view1->wid)) != NO_ERROR)
                 return err;
            }
           else if (is_sorted) 
            {if ((err = AddStrPtrToSortedStrsRec(labels,view1->wid,0,1)) != NO_ERROR)
                {return err;
                }
            }
           else if ((err = add_str_ptr_to_strs_rec(labels,view1->wid)) != NO_ERROR)
            return err;
        }
     next = next->next;
    }
 while (cur != next);
 labels->cur_str = 0;
 if (labels->num_strs > 0)
    {cnt = find_handle_element(labels->strs,labels->num_strs,view->wid,&err);
     if (err == NO_ERROR) labels->cur_str = cnt;
    } 
 PRT3(printf("GroupViewWids NO_ERROR\n"))
 return NO_ERROR;
}


/*----------------------------------------------------------------------
FileViewWids - ???
----------------------------------------------------------------------*/

int
FileViewWids(file,labels,is_cp_str,is_sorted,inc_cur_group,cur_group_num)
 struct input_file_rec *file;
 struct strs_rec *labels;
 int is_cp_str,is_sorted,inc_cur_group,cur_group_num;
{
 int err;
 struct slice_info_rec *slice_info;
 long lcv;

 slice_info = &(file->slice_info);
 labels->cur_str = 0;
 if (is_sorted) sort_strs_rec_ascendingly(labels);

 if (is_cp_str)
    {for (lcv = 0; lcv < slice_info->num_views; lcv++)
        {PRT3(printf("FileViewWids cp inc_cur_group = %d wid = %s gn = %d %d\n",
           inc_cur_group,slice_info->views[lcv]->wid,
            slice_info->views[lcv]->group_num,cur_group_num);)
         if (inc_cur_group || 
             (slice_info->views[lcv]->group_num != cur_group_num))
            if (is_sorted) 
               {if ((err = AddStrToSortedStrsRec(labels,
                      slice_info->views[lcv]->wid,0,1)) != NO_ERROR)
                   {if (err == FOUND) err = NO_ERROR;
                      else return err;}
               }
              else if ((err = add_str_to_strs_rec(labels,
                slice_info->views[lcv]->wid)) != NO_ERROR)
               return err;
        }
    }
   else
    for (lcv = 0; lcv < slice_info->num_views; lcv++)
       {PRT3(printf("FileViewWids inc_cur_group = %d wid = %s gn = %d %d\n",
           inc_cur_group,slice_info->views[lcv]->wid,
            slice_info->views[lcv]->group_num,cur_group_num);)
        if (inc_cur_group || (slice_info->views[lcv]->group_num != cur_group_num))
           if (is_sorted) 
               {if ((err = AddStrPtrToSortedStrsRec(labels,
                      slice_info->views[lcv]->wid,0,1)) != NO_ERROR)
                   {return err;}
               }
             else if ((err = add_str_ptr_to_strs_rec(labels,
                  slice_info->views[lcv]->wid)) != NO_ERROR)
             return err;
       }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
AnyViewWids - ???
----------------------------------------------------------------------*/

int
AnyViewWids(file,labels,is_cp_str,is_sorted,inc_cur_file,inc_cur_group,cur_group_num)
 struct input_file_rec *file;
 struct strs_rec *labels;
 int is_cp_str,is_sorted,inc_cur_file,inc_cur_group,cur_group_num;
{
 struct input_file_rec **files;
 int err,inc_cur;
 long indx;
        
 files = file->prog->input.files;
 err = NO_ERROR;
 for (indx = 0; indx < file->prog->input.num_files; indx++)
    {TRACE(printf("AnyViewWids...inc_cur_file = %d %u %u\n",
         inc_cur_file,files[indx],file);)
     if (inc_cur_file || (files[indx] != file))
        {if (files[indx] != file) inc_cur = 1;
           else inc_cur = inc_cur_group;
         if ((err = FileViewWids(files[indx],labels,
                      is_cp_str,is_sorted,inc_cur,cur_group_num)) != NO_ERROR)
           break;
        }
    }
 return err;
}


/*----------------------------------------------------------------------
view_with_group_num - ???
----------------------------------------------------------------------*/

struct view_rec *
view_with_group_num(file,group_num)
 struct input_file_rec *file;
 int group_num;
{
 struct slice_info_rec *slice_info;
 long lcv;

 slice_info = &(file->slice_info);
 for (lcv = 0; lcv < slice_info->num_views; lcv++)
    if (slice_info->views[lcv]->group_num == group_num)
       return slice_info->views[lcv];
 return NULL;
}


/*----------------------------------------------------------------------
encode_img_label - ???
----------------------------------------------------------------------*/

char *
encode_img_label(img_label,plane_label)
 char *img_label,*plane_label;
{
 static char *str = NULL;
 unsigned long start_indx,len;
 int err;

 free_ptr(&str);
 TRACE(printf("encode_img_label plane_label = %s\n",plane_label))
 if (find_sub_str(plane_label,"x*x",&start_indx) == NO_ERROR)
    {TRACE(printf("start_indx = %d\n",start_indx))
     len = get_strlen(img_label) + get_strlen(&(plane_label[start_indx]));
     if (len == 0) return NULL;
     if ((err = concat_strs(&str,2,img_label,
                 &(plane_label[start_indx]))) != NO_ERROR)
        return NULL;
    }
   else
    {if ((err = cp_str(&str,img_label)) != NO_ERROR)
        return NULL;
    }
 TRACE(printf("encode_img_label = %s\n",str))
 return str;
}


/*----------------------------------------------------------------------
decode_img_label - ???
----------------------------------------------------------------------*/

char *
decode_img_label(img_label)
 char *img_label;
{
 static char *str = NULL;
 unsigned long start_indx;
 int err;

 free_ptr(&str);
 if (find_sub_str(img_label,"x*x",&start_indx) == NO_ERROR)
    {
     if (start_indx == 0) return NULL;
     img_label[start_indx] = '\0';
     err = cp_str(&str,img_label);
     img_label[start_indx] = 'x';
     if (err != NO_ERROR) return NULL;
    }
   else if (find_sub_str(img_label,"R*E",&start_indx) == NO_ERROR)
    {
     if (start_indx == 0) return NULL;
     img_label[start_indx] = '\0';
     err = cp_str(&str,img_label);
     img_label[start_indx] = 'R';
     if (err != NO_ERROR) return NULL;
    }
   else
    {if ((err = cp_str(&str,img_label)) != NO_ERROR)
        return NULL;
    }
 TRACE(printf("decode_img_label = %s\n",str))
 return str;
}


/*----------------------------------------------------------------------
rois_to_img_label - ???
----------------------------------------------------------------------*/

int
rois_to_img_label(img_label,img_type,roi,pixel_type)
 char **img_label,*img_type;
 struct strs_rec *roi,*pixel_type;
{
 unsigned long lcv,len,total,len1;
 int err;

 len1 = strlen(img_type);
 len = len1 + 3 + roi->num_strs + pixel_type->num_strs;
 for (lcv = 0; lcv < roi->num_strs; lcv++)
    len += strlen(roi->strs[lcv]);
 for (lcv = 0; lcv < pixel_type->num_strs; lcv++)
    len += strlen(pixel_type->strs[lcv]);
 total = 0;
 *img_label = NULL;
 get_ptr_memory(img_label,&total,len,
      (size_t) sizeof(**img_label),&err);
 if (err != NO_ERROR) return err;

 memcpy(*img_label,img_type,len1);
 (*img_label)[len1] = '\0';
 strcat(&((*img_label)[len1]),"x*x");
 len1 += 3;
 for (lcv = 0; lcv < roi->num_strs; lcv++)
    {strcat(&((*img_label)[len1]),roi->strs[lcv]);
     len1 += strlen(roi->strs[lcv]);
     if (((lcv + 1) < roi->num_strs) || (pixel_type->num_strs > 0))
        (*img_label)[len1++] = '/';
    }
 for (lcv = 0; lcv < pixel_type->num_strs; lcv++)
    {strcat(&((*img_label)[len1]),pixel_type->strs[lcv]);
     len1 += strlen(pixel_type->strs[lcv]);
     if (((lcv + 1) < pixel_type->num_strs))
        (*img_label)[len1++] = '/';
    }

 TRACE(printf("*img_label = %s\n",*img_label))
 return NO_ERROR;
}


/*----------------------------------------------------------------------
volume_to_img_label - ???
----------------------------------------------------------------------*/

int
volume_to_img_label(img_label,img_type,area,minz,maxz,pixel_type)
 char **img_label,*img_type;
 struct strs_rec *pixel_type;
 struct int_bound_rec *area;
 long minz,maxz;
{
 unsigned long lcv,len,len2,total,len1;
 int err;
 char str[60];

 sprintf(str,"[%d..%d,%d..%d,%ld..%ld]",
      area->left,area->right,area->top,area->bottom,
      minz,maxz);

 len1 = strlen(img_type);
 len2 = strlen(str);
 len = len1 + 4 + len2 + pixel_type->num_strs;
 for (lcv = 0; lcv < pixel_type->num_strs; lcv++)
    len += strlen(pixel_type->strs[lcv]);
 total = 0;
 *img_label = NULL;
 get_ptr_memory(img_label,&total,len,
      (size_t) sizeof(**img_label),&err);
 if (err != NO_ERROR) return err;

 memcpy(*img_label,img_type,len1);
 (*img_label)[len1] = '\0';
 strcat(&((*img_label)[len1]),"x*x");
 len1 += 3;
 strcat(&((*img_label)[len1]),str);
 len1 += len2;
 if (pixel_type->num_strs > 0)
    (*img_label)[len1++] = '/';
 for (lcv = 0; lcv < pixel_type->num_strs; lcv++)
    {strcat(&((*img_label)[len1]),pixel_type->strs[lcv]);
     len1 += strlen(pixel_type->strs[lcv]);
     if (((lcv + 1) < pixel_type->num_strs))
        (*img_label)[len1++] = '/';
    }

 TRACE(printf("*img_label = %s\n",*img_label))
 return NO_ERROR;
}


/*----------------------------------------------------------------------
loading_3d_data_error - ???
----------------------------------------------------------------------*/

void
loading_3d_data_error(select)
 int select;
{
 Frame *frame;

 if ((frame = (Frame *) main_display(2,NULL,0,0)) && (*frame != 0))
    {if (select == 1)
        notice_prompt(*frame,(Event *) NULL,
                  NOTICE_MESSAGE_STRINGS,
                  "NOT ENOUGH MEMORY ERROR when loading & setting up the 3d data...",
                   0,
                   NOTICE_BUTTON_YES,OPERATION_ABORTED,
                   0);
       else if (select == 2)
        notice_prompt(*frame,(Event *) NULL,
                  NOTICE_MESSAGE_STRINGS,
                  "READ ERROR when loading & setting up the 3d data...",
                   0,
                   NOTICE_BUTTON_YES,OPERATION_ABORTED,
                   0);
       else 
        notice_prompt(*frame,(Event *) NULL,
                  NOTICE_MESSAGE_STRINGS,
                  "ERROR when loading & setting up the 3d data...",
                   0,
                   NOTICE_BUTTON_YES,OPERATION_ABORTED,
                   0);
    }
}


/*----------------------------------------------------------------------
get_file_3d_data - ???
----------------------------------------------------------------------*/

#define LINEAR_INTERPOLATION 1
#define SETUP_3D_PIXEL_TYPES 2
#define SETUP_3D_ROIS 3

int
get_file_3d_data(file,id,project_plane_proc,view,arg2,arg3,arg4,
                 interpolation_method,msg)
 struct input_file_rec *file;
 char *id;
 int (*project_plane_proc)();
 struct view_rec *view;
 void *arg2,*arg3,*arg4;
 int interpolation_method;
 char *msg;
{
 unsigned long cnt,total;
 struct slice_info_rec *slice_info;
 struct hdr_scan_entry_rec *head,*cur_slice;
 struct data_info_rec *info;
 struct buf_3d_rec *new;
 int err;
 char *str;

 TRACE(printf("get_file_3d_data id = %s  = %u\n",id,id))
 if (find_file_3d(file,id,&new) == NO_ERROR) 
    {
     TRACE(printf("get_file_3d_data found id = %s\n",new->id))
     if (project_plane_proc != NULL)
        return project_plane_proc(view,arg2,arg3,arg4,interpolation_method,msg);
       else return NO_ERROR;
    }
 slice_info = &(file->slice_info);
 info = &(file->hdr.data_info);
 total = 0;
 if ((err = get_ptr(&new,&total,1,(size_t)sizeof(*new))) != NO_ERROR)
    {view->status |= PLANE_3D_LOAD_DATA_ERROR;
     return err;}
 init_buf_3d_rec(new);

 cur_slice = &(file->hdr.scans[0]);
 str = id;
 for (cnt = 0; cnt < file->hdr.analysis.num_img_labels; cnt++)
    {if (str_cmp(file->hdr.analysis.img_labels[cnt],str) == 0) break;
     TRACE(printf("img_labels[%d] = %s...str = %s\n",cnt,
            file->hdr.analysis.img_labels[cnt],str))
     cur_slice = cur_slice->partner_slice;}
 if (cnt == file->hdr.analysis.num_img_labels)
    {view->status |= PLANE_3D_LOAD_DATA_ERROR;
     TRACE(printf("PLANE_3D_LOAD_DATA_ERROR...\n"))
     c_free(new);
     return CANCEL;}
 head = cur_slice;
 for (;;)
    {if (!(cur_slice->slice->_2d.status4 & BUF_NON_EMPTY))
        if ((err = SetupBuf2dRec(&(cur_slice->slice->_2d),
                  info->dimx,info->dimy,info->pixel_depth_bits,
                  InputDataTypeToBufType(info))) != NO_ERROR)
           {view->status |= PLANE_3D_LOAD_DATA_ERROR;
            c_free(new);
            loading_3d_data_error(1);
            return err;}
     cur_slice = cur_slice->next_slice;
     if (cur_slice == head) break;
    }

 cur_slice = head;
 for (;;)
    {
/*
     if (cur_slice->slice->_2d.status & BUF_NON_EMPTY)
        {printf("cur_slice->img_addr = %u\n",cur_slice->img_addr);
         mmap_buf_2d_rec(&(cur_slice->slice->_2d),
                3,file->img_fid,cur_slice->img_addr);}
*/
     if (!(cur_slice->slice->_2d.status4 & BUF_DATA_VALID))
        {
         if ((err = rd_cur_slice_data(file->img_fid,
                   cur_slice,&(cur_slice->slice->_2d))) != NO_ERROR)
            {view->status |= PLANE_3D_LOAD_DATA_ERROR;
             c_free(new);
             loading_3d_data_error(2);
             return err;}
        }
     cur_slice = cur_slice->next_slice;
     if (cur_slice == head) break;}

 if ((err = setup_buf_3d_rec(new,
         id,info->dimx,info->dimy,
         NumberOfSliceCuts(&(file->hdr.data_info)),
         info->xpixel_size,info->ypixel_size,info->xpixel_size,
         info->pixel_thickness,0,0,0)) != NO_ERROR)
    {free_buf_3d_rec(new);
     c_free(new);
     view->status |= PLANE_3D_LOAD_DATA_ERROR;
     loading_3d_data_error(1);
     return err;}
 new->status |= _3D_BUF_DO_NOT_DEALLOCATE_SLICES;
 TRACE(printf("add_slice_to_3d...\n"))
 for (cnt = 0;;cnt++)
    {if (interpolation_method == LINEAR_INTERPOLATION)
        err = add_3d_slice_own(new,
             &(cur_slice->slice->_2d),cur_slice,cnt,info->pixel_thickness);
       else 
        err = add_3d_slice_infect(new,
             &(cur_slice->slice->_2d),cur_slice,cnt,info->pixel_thickness,0);
     if (err != NO_ERROR)
        {free_buf_3d_rec(new);
         c_free(new);
         view->status |= PLANE_3D_LOAD_DATA_ERROR;
         loading_3d_data_error(3);
         return err;}
     cur_slice = cur_slice->next_slice;
     if (cur_slice == head) break;}
 if ((err = setup_3d_interpolation(new)) != NO_ERROR)
    {free_buf_3d_rec(new);
     c_free(new);
     view->status |= PLANE_3D_LOAD_DATA_ERROR;
     loading_3d_data_error(3);
     return err;}
 new->status |= BUF_DATA_VALID | _3D_XYZ_XY_00 |  _3D_ORIGINAL | _3D_DEFAULT_ORDER;
 if (file->slice_info.select_3d_gravity == _3D_SLICE_BOTTOM_TO_TOP)
    reverse_3d_slice_order(new);
/*
 pr_buf_3d_rec(new);
*/
 if ((err = add_slice_info_3d(slice_info,new)) == NO_ERROR)
    {slice_info->status |= RD_ALL_IMAGES;
     TRACE(printf("add_slice_to_3d...end\n"))
     if (project_plane_proc != NULL)
        return project_plane_proc(view,arg2,arg3,arg4,interpolation_method,msg);
       else return NO_ERROR;
    }
   else
    {free_buf_3d_rec(new);
     loading_3d_data_error(3);
     c_free(new);}
 return err;
}


/*----------------------------------------------------------------------
Setup3dRoi - ???
----------------------------------------------------------------------*/

int
Setup3dRoi(file,roi_label,_3d,next_proc,error,arg1,arg2,arg3,arg4)
 struct input_file_rec *file;
 char *roi_label;
 struct buf_3d_rec *_3d;
 int (*next_proc)();
 int *error;
 void *arg1,*arg2,*arg3,*arg4;
{
 unsigned long cnt;
 long cur;
 struct hdr_scan_entry_rec *cur_slice;
 struct slice_info_rec *slice_info;
 struct draw_mask_rec mask;
 struct int_bound_rec affected;
 struct buf_2d_rec *_2d;
 struct roi_rec *roi;
 int err,is_init,is_rev;

 PRT5(printf("Setup3dRoi...\n"))
 init_draw_mask_rec(&mask);
 if ((err = get_draw_mask_rec(&mask,_3d->dimx,_3d->dimy)) != NO_ERROR)
    {free_draw_mask_rec(&mask);
     if (error != NULL) *error = err;
     if (next_proc != NULL) return next_proc(error,arg1,arg2,arg3,arg4);
     return err;}
 if (_3d->status & _3D_BOTTOM_TO_TOP)
    {reverse_3d_slice_order(_3d);
     is_rev = 1;}
   else is_rev = 0;

 slice_info = &(file->slice_info);
 cur_slice = &(file->hdr.scans[0]);
 PRT1(printf("Setup3dRoi...roi_label = %s  num_sroi_wins= %d\n",roi_label,
          slice_info->num_sroi_wins))
 for (cnt = 0; cnt < slice_info->num_sroi_wins; cnt++)
    {
     if (((roi = get_roi(&(slice_info->sroi_wins[cnt]->slice_roi),roi_label)) != NULL) &&
         is_roi_non_empty(roi))
        {InitBuf2dRecData(&(mask.mask._2d),(double) .0);
         if ((err = GetFilledRoiMask(roi,NULL,&mask,&affected)) == NO_ERROR)
            {
             if ((err = get_zindx(_3d->zpixel_size,_3d->slice_thickness,cnt,
                      _3d->startz,_3d->dimz,&cur)) != NO_ERROR)
                break;
             is_init = 0;
             PRT1(printf("%d) cur = %d s1 = %u\n",cnt,cur,_3d->sls[cur].s1))
             if (_3d->sls[cur].s1 == NULL)
                {
                 if ((err = get_ptr(&_2d,NULL,1,(size_t) sizeof(*_2d))) == NO_ERROR)
                    {init_buf_2d_rec(_2d);
                     is_init = 1;
                     err = SetupBuf2dRec(_2d,affected.right - affected.left + 1,
                            affected.bottom - affected.top + 1,1,0);                     
                    }
                }
               else
                {PRT5(if (_3d->sls[cur].status & SLICE_3D_ORIGINAL)
                         printf("%d) ORIGINAL cur = %d s1 = %u\n",cnt,cur,_3d->sls[cur].s1);
                        else printf("%d) cur = %d s1 = %u\n",cnt,cur,_3d->sls[cur].s1);
                     )
                  _2d = _3d->sls[cur].s1;}
             if (err == NO_ERROR)
                {PRT1(printf("%d) 2d = %u l = %d t = %d r = %d b = %d dimx = %d dimy = %d stx = %d sty = %d\n",
                       cnt,_2d,affected.left,affected.top,affected.right,affected.bottom,
                       _2d->dimx,_2d->dimy,_2d->startx,_2d->starty))
                 Set2dStartOffsetXY(_2d,affected.left,affected.top);
                 CpBuf2dRecByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
                        0,0,&(mask.mask._2d),affected.left,affected.top,
                        affected.right,affected.bottom);
                 err = add_3d_slice_infect(_3d,
                       _2d,cur_slice,cnt,_3d->slice_thickness,1);
                }
             if (err != NO_ERROR)
                {if (is_init)
                    {free_buf_2d_rec(_2d);
                     c_free(_2d);}
                 break;}
            }
           else break;
        }
     cur_slice = cur_slice->next_slice;
   }

 if (is_rev) 
    {PRT5(printf("Setup3dRoi ...is_rev\n"))
     reverse_3d_slice_order(_3d);}

 free_draw_mask_rec(&mask);
 PRT5(printf("Setup3dRoi...is_rev = %d err = %d\n",is_rev,err))
 if (next_proc != NULL) 
    {if (error != NULL) *error = err;
     return next_proc(error,arg1,arg2,arg3,arg4);
    }
   else return err;
}


/*----------------------------------------------------------------------
get_file_3d_roi_data - ???
----------------------------------------------------------------------*/

int
get_file_3d_roi_data(file,id,project_plane_proc,view,arg2,arg3,arg4,
                     interpolation_method,msg)
 struct input_file_rec *file;
 char *id;
 int (*project_plane_proc)();
 struct view_rec *view;
 void *arg2,*arg3,*arg4;
 int interpolation_method;
 char *msg;
{
 struct data_info_rec *info;
 struct buf_3d_rec *new;
 int err;

 PRT5(printf("get_file_3d_roi_data...id = %s id = %d\n",id,id))
 if (find_file_3d(file,id,&new) == NO_ERROR) 
    {
     TRACE(printf("get_file_3d_roi_data found id = %s\n",new->id))
     if (project_plane_proc != NULL)
        return project_plane_proc(view,arg2,arg3,arg4,interpolation_method,msg);
       else return NO_ERROR;
    }

 info = &(file->hdr.data_info);
 if ((err = get_ptr(&new,NULL,1,(size_t)sizeof(*new))) != NO_ERROR)
    {view->status |= PLANE_3D_LOAD_DATA_ERROR;
     return err;}
 init_buf_3d_rec(new);
 if (((err = setup_buf_3d_rec(new,
         id,info->dimx,info->dimy,
         NumberOfSliceCuts(&(file->hdr.data_info)),
         info->xpixel_size,info->ypixel_size,info->xpixel_size,
         info->pixel_thickness,0,0,0)) != NO_ERROR) ||
     ((err = Setup3dRoi(file,id,new,NULL,NULL,NULL,NULL,NULL,NULL)) != NO_ERROR))
    {free_buf_3d_rec(new);
     c_free(new);
     view->status |= PLANE_3D_LOAD_DATA_ERROR;
     return err;}

 new->status |= BUF_DATA_VALID | _3D_XYZ_XY_01 | _3D_APPROX | _3D_DEFAULT_ORDER;
/*
 new->status |= BUF_DATA_VALID | _3D_XYZ_XY_01 | _3D_DEFAULT_ORDER;
*/
 if (file->slice_info.select_3d_gravity == _3D_SLICE_BOTTOM_TO_TOP)
    reverse_3d_slice_order(new);

 PRT1(pr_buf_3d_rec(new);)

 if ((err = add_slice_info_3d(&(file->slice_info),new)) == NO_ERROR)
    {if (project_plane_proc != NULL)
        return project_plane_proc(view,arg2,arg3,arg4,interpolation_method,msg);
       else return NO_ERROR;
    }
   else
    {free_buf_3d_rec(new);
     c_free(new);}
 PRT1(printf("get_file_3d_roi_data...err = %d end\n\n",err))
 return err;
}


/*----------------------------------------------------------------------
Redefine3dPixmaps - ???
----------------------------------------------------------------------*/

int
Redefine3dPixmaps(file)
 struct input_file_rec *file;
{
 struct buf_3d_rec *_3d;
 int err;
 struct hdr_scan_entry_rec *cur_slice;
 unsigned long cnt;

 PRT5(printf("Redefine3dPixmaps...\n"))
 if (find_file_3d(file,PIXEL_TYPE_3D_ID,&_3d) != NO_ERROR)
    return NO_ERROR;

 PRT5(printf("Redefine3dPixmaps...found\n"))
 PRT5(printf("...num_slices = %d num_slice_maps = %d\n",
    _3d->num_slices,file->pixel_type.num_slice_maps))
 for (cnt = 0; cnt < _3d->num_slices; cnt++)
    init_slice_3d_rec(&(_3d->sls[cnt]));
 cur_slice = &(file->hdr.scans[0]);
 for (cnt = 0; cnt < _3d->num_slices; cnt++)
    {if (cnt >= file->pixel_type.num_slice_maps) break;
     if ((file->pixel_type.slice_maps[cnt] != NULL) &&
         (file->pixel_type.slice_maps[cnt]->status4 & BUF_NON_EMPTY))
        {if ((err = add_3d_slice_infect(_3d,file->pixel_type.slice_maps[cnt],
              cur_slice,cnt,_3d->slice_thickness,1)) != NO_ERROR)
            break;
         PRT5(MinMax2dValues(file->pixel_type.slice_maps[cnt],0,(double) .0,(double) .0,
                    &min4,&max4);
          printf("get_file_3d_pixel_types %d) depth = %d min4 = %f max4 = %f\n",
              cnt,file->pixel_type.slice_maps[cnt]->pixel_depth,min4,max4);)
        }
     cur_slice = cur_slice->next_slice;
   }
 if (_3d->status & _3D_BOTTOM_TO_TOP)
    {PRT5(printf("=Redefine3dPixmaps..._3D_BOTTOM_TO_TOP\n"))
     _3d->status &= ~_3D_BOTTOM_TO_TOP;
     _3d->status |= _3D_DEFAULT_ORDER;
     reverse_3d_slice_order(_3d);}
 PRT5(printf("=Redefine3dPixmaps..._3d->status = %x err = %d\n",
       (unsigned long) _3d->status,err))

 return err;
}


/*----------------------------------------------------------------------
WinRedefine3dPixmaps - ???
----------------------------------------------------------------------*/

void
WinRedefine3dPixmaps(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct buf_3d_rec *_3d;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 if (find_file_3d(img->file,PIXEL_TYPE_3D_ID,&_3d) != NO_ERROR)
    return;

 ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,3,
               "Redefining the pixel types for the 3D",
               "Computing the pixel type maps...",
               PLEASE_WAIT,Redefine3dPixmaps,1,img->file);
}


/*----------------------------------------------------------------------
get_file_3d_pixel_types - ???
----------------------------------------------------------------------*/

int
get_file_3d_pixel_types(file,id,project_plane_proc,view,arg2,arg3,arg4,
                     interpolation_method,msg)
 struct input_file_rec *file;
 char *id;
 int (*project_plane_proc)();
 struct view_rec *view;
 void *arg2,*arg3,*arg4;
 int interpolation_method;
 char *msg;
{
 unsigned long cnt,num_slices;
 struct slice_info_rec *slice_info;
 struct hdr_scan_entry_rec *cur_slice;
 struct data_info_rec *info;
 struct buf_3d_rec *new;
 int err,is_ready;

 PRT2(printf("get_file_3d_pixel_types...\n"))
 if (find_file_3d(file,id,&new) == NO_ERROR) 
    {
     TRACE(printf("get_file_3d_pixel_types found id = %s\n",new->id))
     if (project_plane_proc != NULL)
        return project_plane_proc(view,arg2,arg3,arg4,interpolation_method,msg);
       else return NO_ERROR;
    }

 if ((err = SetupAllSliceMaps(file,&is_ready)) != NO_ERROR) return err;
 PRT2(printf("get_file_3d_pixel_types...is_ready = %d\n",is_ready))
 if (is_ready == 0) return CANCEL;

 slice_info = &(file->slice_info);
 info = &(file->hdr.data_info);
 if ((err = get_ptr(&new,NULL,1,(size_t)sizeof(*new))) != NO_ERROR)
    {view->status |= PLANE_3D_LOAD_DATA_ERROR;
     return err;}
 init_buf_3d_rec(new);
 num_slices = NumberOfSliceCuts(&(file->hdr.data_info));
 if ((err = setup_buf_3d_rec(new,id,info->dimx,info->dimy,
         num_slices,info->xpixel_size,info->ypixel_size,info->xpixel_size,
         info->pixel_thickness,0,0,0)) != NO_ERROR)
    {
     free_buf_3d_rec(new);
     c_free(new);
     view->status |= PLANE_3D_LOAD_DATA_ERROR;
     return err;}
 PRT2(printf("get_file_3d_pixel_types...1\n"))

 cur_slice = &(file->hdr.scans[0]);
 for (cnt = 0; cnt < num_slices; cnt++)
    {
     if (cnt >= file->pixel_type.num_slice_maps) break;
     if ((file->pixel_type.slice_maps[cnt] != NULL) &&
         (file->pixel_type.slice_maps[cnt]->status4 & BUF_NON_EMPTY))
        {if ((err = add_3d_slice_infect(new,file->pixel_type.slice_maps[cnt],
                cur_slice,cnt,info->pixel_thickness,1)) != NO_ERROR)
            break;
         PRT2(MinMax2dValues(file->pixel_type.slice_maps[cnt],0,(double) .0,(double) .0,
                    &min4,&max4);
          printf("get_file_3d_pixel_types %d) depth = %d min4 = %f max4 = %f\n",
              cnt,file->pixel_type.slice_maps[cnt]->pixel_depth,min4,max4);)
        }
     cur_slice = cur_slice->next_slice;
    }
 PRT2(printf("get_file_3d_pixel_types...err = %d\n",err))
 if (err != NO_ERROR)
    {free_buf_3d_rec(new);
     c_free(new);
     view->status |= PLANE_3D_LOAD_DATA_ERROR;
     return err;}
 new->status |= BUF_DATA_VALID | _3D_XYZ_XY_00 | _3D_APPROX | _3D_DEFAULT_ORDER;
 if (file->slice_info.select_3d_gravity == _3D_SLICE_BOTTOM_TO_TOP)
    reverse_3d_slice_order(new);

/*
 new->status |= BUF_DATA_VALID | _3D_XYZ_XY_00;
*/
 PRT2(pr_buf_3d_rec(new);)

 if ((err = add_slice_info_3d(slice_info,new)) == NO_ERROR)
    {if (project_plane_proc != NULL)
        return project_plane_proc(view,arg2,arg3,arg4,interpolation_method,msg);
       else return NO_ERROR;
    }
   else
    {free_buf_3d_rec(new);
     c_free(new);}
 PRT2(printf("get_file_3d_pixel_types...err = %d end\n\n",err))
 return err;
}


/*----------------------------------------------------------------------
get_3d_sub_region - ???
----------------------------------------------------------------------*/

int
get_3d_sub_region(file,view,labels,area,minz,maxz)
 struct input_file_rec *file;
 struct view_rec *view;
 struct strs_rec *labels;
 struct int_bound_rec *area;
 long minz,maxz;
{
 unsigned long cnt,lcv,num,indx,total;
 struct slice_info_rec *slice_info;
 struct hdr_scan_entry_rec *cur_slice,*partner;
 struct data_info_rec *info;
 struct buf_2d_rec *_2d,*the_data;
 struct buf_2d_rec data;
 struct buf_3d_rec *_3d;
 int err,all_echoes,whole_slice;

 slice_info = &(file->slice_info);
 info = &(file->hdr.data_info);
 init_buf_2d_rec(&data);
 for (all_echoes = 1,lcv = 0; lcv < file->hdr.analysis.num_img_labels; lcv++)
    if (find_file_3d(file,file->hdr.analysis.img_labels[lcv],&_3d) != NO_ERROR)
       {all_echoes = 0;
        break;}
 if (!all_echoes)
    {if ((err = SetupBuf2dRec(&data,info->dimx,info->dimy,
          info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR)
        return err;
    }
 if ((area->left == 0) && (area->right == (info->dimx - 1)) &&
     (area->top == 0) && (area->bottom == (info->dimy - 1)))
    whole_slice = 1;
   else whole_slice = 0;

 cur_slice = &(file->hdr.scans[0]);
 for (cnt = 0; cnt < minz; cnt++) cur_slice = cur_slice->next_slice;

 for (cnt = minz; cnt <= maxz; cnt++)
    {partner = cur_slice;
     for (indx = slice_info->num_3ds,num = 0; num < labels->num_strs; num++)
        {if (labels->strs[num] == NULL)
            {partner = partner->partner_slice;
             continue;}
         total = 0;
         get_ptr_memory(&_2d,&total,1,(size_t) sizeof(*_2d),&err);
         if (err == 0)
            {init_buf_2d_rec(_2d);
             if ((err = SetupBuf2dRec(_2d,area->right - area->left + 1,
                       area->bottom - area->top + 1,
                       info->pixel_depth_bits,
                       InputDataTypeToBufType(info))) == NO_ERROR)
                {if ((partner->slice->_2d.status4 & BUF_NON_EMPTY) &&
                          (partner->slice->_2d.status4 & BUF_DATA_VALID))
                    {the_data = &(partner->slice->_2d);}
                   else
                    {if ((err = rd_cur_slice_data(file->img_fid,
                                partner,&data)) == NO_ERROR)
                        the_data = &data;
                    }
                 if (err == NO_ERROR)
                    {Set2dStartOffsetXY(_2d,area->left,area->top);
                     if (whole_slice)
                        copy_buf_2d_rec_content(_2d,the_data);
                       else 
                        CpBuf2dRecByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
                           0,0,the_data,
                           area->left,area->top,area->right,area->bottom);

                     if ((err = add_3d_slice_own(slice_info->_3ds[indx],
                              _2d,partner,cnt,info->pixel_thickness)) == NO_ERROR) 
                        indx++;
                    }
                }
             if (err != NO_ERROR)
                {free_buf_2d_rec(_2d);
                 c_free(_2d);
                 break;}
            }
           else break;
          partner = partner->partner_slice;
         }
      if (err != NO_ERROR) break;
      cur_slice = cur_slice->next_slice;
     }
 free_buf_2d_rec(&data);
 if (err == NO_ERROR)
    {
     for (indx = slice_info->num_3ds,num = 0; num < labels->num_strs; num++)
        {if (labels->strs[num] == NULL) continue;
         setup_3d_interpolation(slice_info->_3ds[indx]);
         slice_info->_3ds[indx]->status |= BUF_DATA_VALID | _3D_SUB_OBJECT |
                     _3D_XYZ_XY_10 | _3D_DEFAULT_ORDER;
         if (file->slice_info.select_3d_gravity == _3D_SLICE_BOTTOM_TO_TOP)
            reverse_3d_slice_order(slice_info->_3ds[indx]);
         indx++;}
    }

 return err;
}


/*----------------------------------------------------------------------
get_3d_sub_obj - ???
----------------------------------------------------------------------*/

int
get_3d_sub_obj(file,view,roi_strs,labels,area,minz,maxz)
 struct input_file_rec *file;
 struct view_rec *view;
 struct strs_rec *roi_strs,*labels;
 struct int_bound_rec *area;
 long minz,maxz;
{
 unsigned long cnt,lcv,num,indx,total;
 struct slice_info_rec *slice_info;
 struct hdr_scan_entry_rec *cur_slice,*partner;
 struct data_info_rec *info;
 struct buf_2d_rec *_2d,*the_data;
 struct draw_mask_rec mask;
 struct buf_2d_rec mask_2d,data;
 struct roi_rec *roi;
 struct int_bound_rec affected,region;
 struct buf_3d_rec *_3d;
 int err,all_echoes,yes;
 long left,top;

 TRACE(printf("get_3d_sub_obj...0\n"))
 slice_info = &(file->slice_info);
 info = &(file->hdr.data_info);
 init_buf_2d_rec(&data);
 for (all_echoes = 1,lcv = 0; lcv < file->hdr.analysis.num_img_labels; lcv++)
    if (find_file_3d(file,file->hdr.analysis.img_labels[lcv],&_3d) != NO_ERROR)
       {all_echoes = 0;
        break;}
 if (!all_echoes)
    {if ((err = SetupBuf2dRec(&data,info->dimx,info->dimy,
          info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR)
        return err;
    }

 init_buf_2d_rec(&mask_2d);
 init_draw_mask_rec(&mask);
 if (((err = get_draw_mask_rec(&mask,info->dimx,info->dimy)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&mask_2d,info->dimx,info->dimy,1,0)) != NO_ERROR))
    {
     free_draw_mask_rec(&mask);
     free_buf_2d_rec(&data);
     free_buf_2d_rec(&mask_2d);
     return err;}
 TRACE(printf("get_3d_sub_obj...minz = %d  maxz = %d\n",minz,maxz))

 cur_slice = &(file->hdr.scans[0]);
 for (cnt = 0; cnt < minz; cnt++) cur_slice = cur_slice->next_slice;

 TRACE(pr_int_bound_rec(area))
 for (; cnt <= maxz; cnt++)
    {TRACE(printf("processing slice# %d cur_slice->num = %d\n",cnt,(int) cur_slice->num))
     InitBuf2dRecData(&mask_2d,(double) .0);
     for (yes = 0,lcv = 0; lcv < roi_strs->num_strs; lcv++)
        if (((roi = get_roi(&(slice_info->sroi_wins[cnt]->slice_roi),
                roi_strs->strs[lcv])) != NULL) && is_roi_non_empty(roi))
           {if ((err = GetFilledRoiMask(roi,NULL,&mask,&region)) == NO_ERROR)
               {superimpose_bitmap_region(&mask_2d,&(mask.mask._2d),&region);
                if (!yes)
                   {affected = region;
                    yes += 1;}
                  else
                   {if (affected.left > region.left) affected.left = region.left;
                    if (affected.top > region.top) affected.top = region.top;
                    if (affected.right < region.right) affected.right = region.right;
                    if (affected.bottom < region.bottom) affected.bottom = region.bottom;
                   }
               }
              else break;
           }
      if ((err == NO_ERROR) && !yes)
         {partner = cur_slice;
          TRACE(printf("get_3d_sub_obj...add NULL scans\n"))

          for (indx = slice_info->num_3ds,num = 0; num < labels->num_strs; num++)
             {if (labels->strs[num] != NULL)
                 {
                  if ((err = add_3d_slice_own(slice_info->_3ds[indx],
                          NULL,partner,cnt,info->pixel_thickness)) == NO_ERROR) 
                     indx++;
                    else break;
                 }
              partner = partner->partner_slice;
             }
         }
        else
         {partner = cur_slice;
          for (indx = slice_info->num_3ds,num = 0; num < labels->num_strs; num++)
             {if (labels->strs[num] == NULL)
                 {partner = partner->partner_slice;
                  continue;}
              total = 0;
              get_ptr_memory(&_2d,&total,1,(size_t) sizeof(*_2d),&err);
              if (err == 0)
                 {init_buf_2d_rec(_2d);
/*
              printf("slice# %d label = %s img_label = %s sl_num = %d  _2d = %u\n",
                    cnt,labels->strs[num],partner->img_label,partner->num,_2d);
*/
                  if ((err = SetupBuf2dRec(_2d,affected.right - affected.left + 1,
                       affected.bottom - affected.top + 1,
                       info->pixel_depth_bits,
                       InputDataTypeToBufType(info) | 1)) == NO_ERROR)
                     {if ((partner->slice->_2d.status4 & BUF_NON_EMPTY) &&
                          (partner->slice->_2d.status4 & BUF_DATA_VALID))
                         {TRACE(printf("data exist num = %d\n",(int) partner->num))
                          the_data = &(partner->slice->_2d);}
                        else
                         {TRACE(printf("rd_cur_slice_data = %d\n",(int) partner->num))
                          if ((err = rd_cur_slice_data(file->img_fid,
                                partner,&data)) == NO_ERROR)
                             the_data = &data;
                         }
                      if (err == NO_ERROR)
                         {left = affected.left - area->left;
                          top = affected.top - area->top;
                          Set2dStartOffsetXY(_2d,left,top);
                          assign_buf_2d_rec_by_mask(_2d,the_data,
                                    -affected.left,-affected.top,&mask_2d,&affected);
                          if ((err = add_3d_slice_own(slice_info->_3ds[indx],
                              _2d,partner,cnt,info->pixel_thickness)) == NO_ERROR) 
                             indx++;
                         }
                     }
                  if (err != NO_ERROR)
                     {free_buf_2d_rec(_2d);
                      c_free(_2d);
                      break;}
                 }
                else break;
              partner = partner->partner_slice;
             }
         }
     if (err != NO_ERROR) break;
     cur_slice = cur_slice->next_slice;
    }
 free_draw_mask_rec(&mask);
 free_buf_2d_rec(&data);
 free_buf_2d_rec(&mask_2d);


 if (err == NO_ERROR)
    {TRACE(printf("get_3d_sub_obj setup_3d_interpolation...\n"))
     for (indx = slice_info->num_3ds,num = 0; num < labels->num_strs; num++)
        {if (labels->strs[num] == NULL) continue;
         setup_3d_interpolation(slice_info->_3ds[indx]);
         slice_info->_3ds[indx]->status |= BUF_DATA_VALID | _3D_SUB_OBJECT | _3D_XYZ_XY_11
                  | _3D_DEFAULT_ORDER;
         if (file->slice_info.select_3d_gravity == _3D_SLICE_BOTTOM_TO_TOP)
            reverse_3d_slice_order(slice_info->_3ds[indx]);
/*
         printf("\n\n\n");
         pr_buf_3d_rec(slice_info->_3ds[indx]);
         printf("\n\n\n");
*/
         indx++;}
    }

 TRACE(printf("get_3d_sub_obj...end\n"))

 return err;
}


/*----------------------------------------------------------------------
get_sub_obj_img_labels - ???
----------------------------------------------------------------------*/

int
get_sub_obj_img_labels(file,plane_id,labels,get_all)
 struct input_file_rec *file;
 char *plane_id;
 struct strs_rec *labels;
 int get_all;
{
 int lcv,cnt,err;
 char *str;
 struct buf_3d_rec *_3d;
 struct slice_info_rec *slice_info;
 
 slice_info = &(file->slice_info);
 labels->cur_str = 0;
 TRACE(printf("get_sub_obj_img_labels plane_id = %s\n",plane_id))
 for (cnt = lcv = 0; lcv < file->hdr.analysis.num_img_labels; lcv++)
    {str = encode_img_label(file->hdr.analysis.img_labels[lcv],plane_id);
     TRACE(printf("lcv = %d...id = %s...\n",lcv,str))
     if (get_all || (find_file_3d(file,str,&_3d) != NO_ERROR))
        labels->cur_str += 1;
       else str = NULL;
     if ((err = add_str_to_strs_rec(labels,str)) != NO_ERROR)
        return err;
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
get_3d_sub_obj_by_pixel_types - ???
----------------------------------------------------------------------*/

int
get_3d_sub_obj_by_pixel_types(view,pixel_types,plane_id)
 struct view_rec *view;
 struct strs_rec *pixel_types;
 char *plane_id;
{
 struct strs_rec labels;
 struct buf_3d_rec *_3d,*_3d1;
 struct buf_2d_rec pixel_type_map;
 struct strs_rec *order;
 struct data_info_rec *info;
 char *picks;
 int err;
 long cnt,lcv;

 if (view->img->file->hdr.analysis.num_img_labels == 2)
    if (!(view->img->file->pixel_type.map.status4 & BUF_NON_EMPTY) ||
        !(view->img->file->pixel_type.map.status4 & BUF_DATA_VALID)) 
       return CANCEL;

 if (pixel_types->num_strs == 0) return NO_ERROR;
 init_strs_rec(&labels);
 if ((err = get_sub_obj_img_labels(view->img->file,plane_id,&labels,1)) != NO_ERROR)
    {free_strs_rec(&labels);
     return err;
    }
 if (labels.num_strs == 0) return NO_ERROR;
 init_buf_2d_rec(&pixel_type_map);
 picks = NULL;
 info = &(view->img->file->hdr.data_info);
 order = &(view->img->file->pixel_type.order);
 if (labels.num_strs ==  2)
    {TRACE(printf("labels.num_strs == 2\n"))
     if (((err = find_file_3d(view->img->file,labels.strs[0],&_3d)) == NO_ERROR) &&
         ((err = find_file_3d(view->img->file,labels.strs[1],&_3d1)) == NO_ERROR) &&
         ((err = SetupBuf2dRec(&pixel_type_map,_3d->dimx,
                   _3d->dimy,order->num_strs + 1,0)) == NO_ERROR) &&
         ((err = selected_strs(order,pixel_types,&picks)) == NO_ERROR))
        {
         for (lcv = 0; lcv < _3d->num_slices; lcv++)
            if ((_3d->sls[lcv].status & SLICE_3D_ORIGINAL) && 
                (_3d->sls[lcv].s1 != NULL))
               {
                InitBuf2dRecData(&pixel_type_map,(double) .0);
                pixel_type_map.dimx = _3d->sls[lcv].s1->dimx;
                pixel_type_map.dimy = _3d->sls[lcv].s1->dimy;
                get_2d_map_pick(_3d->sls[lcv].s1,_3d1->sls[lcv].s1,
                      &(view->img->file->pixel_type.map),
                      &pixel_type_map,picks);
/*
                SelectAssign2d(_3d->sls[lcv].s1,&pixel_type_map,0x00000421,
                    (double) .0,(double) .0,(double) .0,(double) .0,
                    NULL,0,0);
                SelectAssign2d(_3d1->sls[lcv].s1,&pixel_type_map,0x00000421,
                    (double) .0,(double) .0,(double) .0,(double) .0,
                    NULL,0,0);
*/

                Select2d(&pixel_type_map,(double) .0,(double) .0,
                      _3d->sls[lcv].s1,1,(double) .0,0,(double) .0);
                Select2d(&pixel_type_map,(double) .0,(double) .0,
                      _3d1->sls[lcv].s1,1,(double) .0,0,(double) .0);
               }
        }
    }
   else
    if (((err = find_file_3d(view->img->file,labels.strs[0],&_3d)) == NO_ERROR) &&
         ((err = SetupBuf2dRec(&pixel_type_map,_3d->dimx,
                   _3d->dimy,order->num_strs + 1,0)) == NO_ERROR) &&
         ((err = selected_strs(order,pixel_types,&picks)) == NO_ERROR))
       {for (lcv = 0; lcv < _3d->num_slices; lcv++)
           if ((_3d->sls[lcv].status & SLICE_3D_ORIGINAL) && 
               (_3d->sls[lcv].s1 != NULL))
              {InitBuf2dRecData(&pixel_type_map,(double) .0);
               Get1dMapPick(&(view->img->file->pixel_type.map),
                         &pixel_type_map,picks,order->num_strs + 1);
/*
                SelectAssign2d(_3d->sls[lcv].s1,&pixel_type_map,0x00000421,
                    (double) .0,(double) .0,(double) .0,(double) .0,
                    NULL,0,0);
*/
                Select2d(&pixel_type_map,(double) .0,(double) .0,
                      _3d->sls[lcv].s1,1,(double) .0,0,(double) .0);

               if (labels.num_strs > 1)
                  {for (cnt = 1; cnt < labels.num_strs; cnt++)
                      if ((err = find_file_3d(view->img->file,labels.strs[cnt],
                              &_3d1)) == NO_ERROR)
/*
                         SelectAssign2d(_3d1->sls[lcv].s1,
                                &pixel_type_map,0x00000421,
                              (double) .0,(double) .0,(double) .0,(double) .0,
                              NULL,0,0);
*/
                         Select2d(&pixel_type_map,(double) .0,(double) .0,
                              _3d1->sls[lcv].s1,1,(double) .0,0,(double) .0);
                        else break;
                   if (err != NO_ERROR) break;
                  }
              }
       }
 free_buf_2d_rec(&pixel_type_map);
 c_free(picks);
 free_strs_rec(&labels);
 return err;
}


/*----------------------------------------------------------------------
get_file_3d_sub_obj - ???
----------------------------------------------------------------------*/

int
get_file_3d_sub_obj(file,view,roi_strs,pixel_types,plane_id,area,minz,maxz,is_roi)
 struct input_file_rec *file;
 struct view_rec *view;
 struct strs_rec *roi_strs,*pixel_types;
 char *plane_id;
 struct int_bound_rec *area;
 long minz,maxz;
{
 unsigned long lcv,total,indx,temp_num_3ds;
 struct slice_info_rec *slice_info;
 struct data_info_rec *info;
 struct strs_rec labels;
 struct buf_3d_rec **news;
 int err;

 TRACE(printf("get_file_3d_sub_obj...1\n"))
 init_strs_rec(&labels);
 if ((err = get_sub_obj_img_labels(file,plane_id,&labels,0)) != NO_ERROR)
    {free_strs_rec(&labels);
     return err;
    }
 if (labels.num_strs == 0) return NO_ERROR;

 slice_info = &(file->slice_info);
 info = &(file->hdr.data_info);
 total = 0;
 if ((err = get_handle(&news,&total,labels.cur_str,
         (size_t) sizeof(**news))) != NO_ERROR)
    {view->status |= PLANE_3D_LOAD_DATA_ERROR;
     free_strs_rec(&labels);
     return err;}
 for (lcv = 0; lcv < total; lcv++)
    init_buf_3d_rec(news[lcv]);
 TRACE(printf("get_file_3d_sub_obj...2\n"))

 for (lcv = 0; lcv < labels.num_strs; lcv++)
    if (labels.strs[lcv] != NULL)
       {if ((err = setup_buf_3d_rec(news[lcv],labels.strs[lcv],
                area->right - area->left + 1,area->bottom - area->top + 1,
                maxz - minz + 1,
                info->xpixel_size,info->ypixel_size,info->xpixel_size,
                info->pixel_thickness,area->left,area->top,minz)) != NO_ERROR)
           break;
        indx++;
       }

 TRACE(printf("get_file_3d_sub_obj...num_3ds = %d indx = %d  err = %d\n",
          slice_info->num_3ds,indx,err))
 temp_num_3ds = slice_info->num_3ds;
 if (err == NO_ERROR)
    for (lcv = 0; lcv < labels.num_strs; lcv++)
       if ((err = add_slice_info_3d(slice_info,news[lcv])) != NO_ERROR)
          break;

 if (err == NO_ERROR)
    {if (is_roi)
        err = get_3d_sub_obj(file,view,roi_strs,&labels,area,minz,maxz);
    else err = get_3d_sub_region(file,view,&labels,area,minz,maxz);
     if (err == NO_ERROR)
       {slice_info->num_3ds = indx;
        if (pixel_types->num_strs > 0)
           err = get_3d_sub_obj_by_pixel_types(view,pixel_types,plane_id);
       }
    }
 if (err != NO_ERROR)
    {
     for (lcv = 0; lcv < labels.num_strs; lcv++)
        {drop_slice_info_3d(slice_info,news[lcv]);
         free_buf_3d_rec(news[lcv]);
         c_free(news[lcv]);}
     view->status |= PLANE_3D_LOAD_DATA_ERROR;
    }
 free_strs_rec(&labels);
 c_free(news);

 TRACE(printf("get_file_3d_sub_obj...end\n"))
 return err;
}


/*----------------------------------------------------------------------
get_file_sub_obj_volume - ???
----------------------------------------------------------------------*/

int
get_file_sub_obj_volume(view,roi_strs,area,minz,maxz)
 struct view_rec *view;
 struct strs_rec *roi_strs;
 struct int_bound_rec *area;
 long *minz,*maxz;
{
 struct slice_info_rec *slice_info;
 long minx,maxx,miny,maxy;
 unsigned long cnt,lcv;
 struct roi_rec *roi;
 int yes,in;

 slice_info = &(view->img->file->slice_info);
 for (yes = 0,cnt = 0; cnt < slice_info->num_sroi_wins; cnt++)
    {
     for (in = 0,lcv = 0; lcv < roi_strs->num_strs; lcv++)
        {if (((roi = get_roi(&(slice_info->sroi_wins[cnt]->slice_roi),
             roi_strs->strs[lcv])) != NULL) && is_roi_non_empty(roi))
            {FindRoiLongMinMax(roi,NULL,&minx,&maxx,&miny,&maxy,0,0,0);
             if (!yes)
                {*minz = *maxz = cnt;
                 setup_int_bound_rec(area,minx,miny,maxx,maxy);
                 yes += 1;}
               else
                {if (area->left > minx) area->left = minx;
                 if (area->top > miny) area->top = miny;
                 if (area->right < maxx) area->right = maxx;
                 if (area->bottom < maxy) area->bottom = maxy;
                 in = 1;
                }
            }
        }
     if (in) if (*maxz < cnt) *maxz = cnt;
    }
 if (yes)
    {TRACE(printf("region minz = %d    maxz = %d....area\n",*minz,*maxz))
     TRACE(pr_int_bound_rec(area))
     return NO_ERROR;
    }
 return CANCEL;
}



/*----------------------------------------------------------------------
get_file_3d - ???
----------------------------------------------------------------------*/

int
get_file_3d(file,id,project_plane_proc,project_plane_proc_if_found,view,
            arg2,arg3,arg4,interpolation_method,msg)
 struct input_file_rec *file;
 char *id;
 int (*project_plane_proc)();
 int (*project_plane_proc_if_found)();
 struct view_rec *view;
 void *arg2,*arg3,*arg4;
 int interpolation_method;
 char *msg;
{
 Frame *frame;
 static struct buf_3d_rec *_3d;
 char str[255];

 PRT5(printf("begin get_file_3d ID = %s  = %u\n",id,id))
 if (find_file_3d(file,id,&_3d) != NO_ERROR)
    {PRT5(printf("ID = %s not found\n",id))
     frame = (Frame *) main_display(2,NULL,0,0);
     sprintf(str,"Loading the 3D-%s data !!!\n",id);
     if (interpolation_method == SETUP_3D_ROIS)
        ShowMsgStrs(*frame,1,0,0,2,str,PLEASE_WAIT,
          get_file_3d_roi_data,7,
          file,id,project_plane_proc,view,arg2,arg3,arg4);
       else if (interpolation_method == SETUP_3D_PIXEL_TYPES)
        ShowMsgStrs(*frame,1,0,0,2,str,PLEASE_WAIT,
          get_file_3d_pixel_types,7,
          file,id,project_plane_proc,view,arg2,arg3,arg4);
       else ShowMsgStrs(*frame,1,0,0,2,str,PLEASE_WAIT,
             get_file_3d_data,9,file,id,project_plane_proc,view,arg2,
                  arg3,arg4,interpolation_method,msg);
    }
   else
    {if (msg == NULL)
        return project_plane_proc_if_found(view,arg2,arg3,arg4,
                     interpolation_method,NULL);
       else
        {frame = (Frame *) main_display(2,NULL,0,0);
         ShowMsgStrs(*frame,1,0,0,2,msg,PLEASE_WAIT,
             project_plane_proc_if_found,6,view,arg2,arg3,arg4,
             interpolation_method,NULL);}
    }
 PRT5(printf("end get_file_3d ID = %s  = %u\n",id,id))
 return NO_ERROR;
}


/*----------------------------------------------------------------------
SetupAll3dEchoes - ???
----------------------------------------------------------------------*/

void
SetupAll3dEchoes(view,indx,next_proc,next_proc_arg,method,msg)
 struct view_rec *view;
 int indx;
 int (*next_proc)();
 void *next_proc_arg;
 int method;
 char *msg;
{
 if (indx < view->img->file->hdr.analysis.num_img_labels)
    {get_file_3d(view->img->file,
		 view->img->file->hdr.analysis.img_labels[indx],
		 SetupAll3dEchoes,
		 SetupAll3dEchoes,
		 view, indx+1, next_proc, next_proc_arg,
		 method, msg);}
 else if (next_proc != NULL)
    next_proc(view,next_proc_arg);
}


/*----------------------------------------------------------------------
setup_and_display_3d_rois - ???
----------------------------------------------------------------------*/

void
setup_and_display_3d_rois(view,list)
 struct view_rec *view;
 struct list_rec *list;
{
 unsigned long cur;
 struct list_rec **list_ptr,*next;

 PRT5(printf("\nsetup_and_display_3d_rois...\n"))
 if (view == NULL)
    {next = list->next;
     if (list != NULL)
        {delete_item_from_list(list);
         setup_and_display_3d_rois(next->item,next);}
       else return;
    }
 if ((view->all_rois.cur_str < view->all_rois.num_strs) && 
     !(view->status & PLANE_3D_LOAD_DATA_ERROR))
    {
     cur = view->all_rois.cur_str;
     PRT5(printf("setup_and_display_3d_rois..cur_str = %d %s\n",
                cur,view->all_rois.strs[cur]))
     view->all_rois.cur_str += 1;
     get_file_3d(view->img->file,view->all_rois.strs[cur],setup_and_display_3d_rois,
         setup_and_display_3d_rois,view,list,NULL,NULL,SETUP_3D_ROIS,NULL);
    }
   else
    {if (view->status & PLANE_3D_LOAD_DATA_ERROR)
        view->status &= ~PLANE_3D_LOAD_DATA_ERROR;
       else view->status |= PLANE_3D_ROIS_READY;
     if (!(view->status & PLANE_3D_PIXEL_TYPES_READY) &&
         (view->status & PLANE_PROJECT_PIXEL_TYPES) && 
         (view->pixel_types.num_strs > 0))
        {view->pixel_types.cur_str = 0;
         PRT5(printf("setup_and_display_3d_rois...setup_and_display_3d_pixel_types\n"))
         setup_and_display_3d_pixel_types(view,NULL);
        }
      else
       {
         PRT5(printf("setup_and_display_3d_rois...view->wid = %s list = %u\n",
                 view->wid,list))
        if ((get_plane_slice_data(view) == NO_ERROR) &&
            (view->img->win != NULL))
           WinNewColorMultiCanvas(view->img->win->image_display);
       }
     if (list != NULL)
        {next = list->next;
         if (next != list)
            {delete_item_from_list(list);
             PRT5(printf("setup_and_display_3d_rois...next = %u\n",next))
             setup_and_display_3d_rois(next->item,next);}
           else
            {list_ptr = (struct list_rec **) next->item1;
             PRT(printf("setup_and_display_3d_rois deallocate item1 = %u\n",*list_ptr))
             c_free(*list_ptr);
             *list_ptr = NULL;}
        }
    }

}


/*----------------------------------------------------------------------
setup_and_display_3d_pixel_types - ???
----------------------------------------------------------------------*/

void
setup_and_display_3d_pixel_types(view,list)
 struct view_rec *view;
 struct list_rec *list;
{
 struct list_rec **list_ptr,*next;

 PRT5(printf("\nsetup_and_display_3d_pixel_types...\n"))
 if (view == NULL)
    {next = list->next;
     if (list != NULL)
        {delete_item_from_list(list);
         setup_and_display_3d_pixel_types(next->item,next);}
       else return;
    }
 if ((view->pixel_types.cur_str < 1) &&
     !(view->status & PLANE_3D_LOAD_DATA_ERROR))
    {
     PRT4(printf("setup_and_display_3d_pixel_types..plane id = %s   cur_str = %d\n",
                view->id,view->pixel_types.cur_str))
     view->pixel_types.cur_str += 1;
     get_file_3d(view->img->file,PIXEL_TYPE_3D_ID,
         setup_and_display_3d_pixel_types,setup_and_display_3d_pixel_types,
         view,list,NULL,NULL,SETUP_3D_PIXEL_TYPES,NULL);
    }
   else
    {if (view->status & PLANE_3D_LOAD_DATA_ERROR)
        view->status &= ~PLANE_3D_LOAD_DATA_ERROR;
       else view->status |= PLANE_3D_PIXEL_TYPES_READY;

     if (!(view->status & PLANE_3D_ROIS_READY) &&
         (view->all_rois.num_strs > 0))
        {view->all_rois.cur_str = 0;
         setup_and_display_3d_rois(view,list);
        }
       else
        {view->img->status4 |= IMAGE_3D_SUPERIMPOSED_READY;
         PRT5(printf("setup_and_display_3d_pixel_types...view->wid = %s list = %u\n",
                 view->wid,list))
         if ((get_plane_slice_data(view) == NO_ERROR) &&
             (view->img->win != NULL))
            WinNewColorMultiCanvas(view->img->win->image_display);
         if (list != NULL)
            {next = list->next;
             if (next != list)
                {delete_item_from_list(list);
                 PRT5(printf("setup_and_display_3d_pixel_types next = %u\n",next))
                 setup_and_display_3d_pixel_types(next->item,next);}
               else
                {list_ptr = (struct list_rec **) next->item1;
                 TRACE(printf("setup_and_display_3d_pixel_types deallocate item1 = %u\n",
                     *list_ptr))
                 c_free(*list_ptr);
                 *list_ptr = NULL;}
            }
        }
    }
}


/**********************
find_file_3d(file,id,_3d)
 struct input_file_rec *file;
 char *id;
 struct buf_3d_rec **_3d;
{
 struct slice_info_rec *slice_info;
 unsigned long cnt;

 slice_info = &(file->slice_info);
 *_3d = NULL;
 for (cnt = 0; cnt < slice_info->num_3ds; cnt++)
    if (str_cmp(slice_info->_3ds[cnt]->id,id) == 0)
       {*_3d = slice_info->_3ds[cnt];
        PRT5(printf("find_file_3d id = %s found\n",id))
        return NO_ERROR;}
 PRT5(printf("find_file_3d id = %s NOT_FOUND\n",id))
 return NOT_FOUND;
}
**********************/


/*----------------------------------------------------------------------
find_file_3d - ???
----------------------------------------------------------------------*/

int
find_file_3d(file,id,_3d)
 struct input_file_rec *file;
 char *id;
 struct buf_3d_rec **_3d;
{
 struct slice_info_rec *slice_info;
 unsigned long cnt;
 struct buf_3d_rec *_3d_ptr,the_3d;

 slice_info = &(file->slice_info);
 *_3d = NULL;
 if (slice_info->num_3ds == 0) return NOT_FOUND;
   else if (slice_info->num_3ds == 1) 
    {if (str_cmp(slice_info->_3ds[0]->id,id) == 0)
        {*_3d = slice_info->_3ds[0];
         PRT5(printf("find_file_3d id = %s found\n",id))
         return NO_ERROR;}
    }
   else
    {the_3d.id = id;
     _3d_ptr = &the_3d;
     if (obj_binary_search(slice_info->_3ds,slice_info->num_3ds,
         (size_t) sizeof(*(slice_info->_3ds)),&_3d_ptr,SortBuf3dRec,&cnt) == NO_ERROR)
        {*_3d = slice_info->_3ds[cnt];
         PRT5(printf("find_file_3d id = %s found\n",id))
         return NO_ERROR;}
    }
 PRT5(printf("find_file_3d id = %s NOT_FOUND\n",id))
 return NOT_FOUND;
}


/*----------------------------------------------------------------------
is_file_3d_valid - ???
----------------------------------------------------------------------*/

int
is_file_3d_valid(file,_3d)
 struct input_file_rec *file;
 struct buf_3d_rec *_3d;
{
 struct slice_info_rec *slice_info;
 long lcv,cnt;

 for (cnt = 0; cnt < file->prog->input.num_files; cnt++)
    {slice_info = &(file->prog->input.files[cnt]->slice_info);
     for (lcv = 0; lcv < slice_info->num_3ds; lcv++)
        if (slice_info->_3ds[lcv] == _3d)
           return 1;
    }
 return 0;
}


/*----------------------------------------------------------------------
_3d_xyz_pixel_sizes - ???
----------------------------------------------------------------------*/

int
_3d_xyz_pixel_sizes(img,xpixel_size,ypixel_size,zpixel_size)
 struct img_buf_rec *img;
 float *xpixel_size,*ypixel_size,*zpixel_size;
{
 struct buf_3d_rec *_3d;
 int err;

 if (img->cur_slice->slice->view == NULL) return CANCEL;
 if ((err = find_file_3d(img->file,img->cur_slice->slice->view->id,
              &_3d)) == NO_ERROR)
    {*xpixel_size = _3d->xpixel_size;
     *ypixel_size = _3d->ypixel_size;
     *zpixel_size = _3d->zpixel_size;
    }
 return err;
}


/*----------------------------------------------------------------------
get_3d_use_status - ???
----------------------------------------------------------------------*/

int
get_3d_use_status(file,_3d)
 struct input_file_rec *file;
 struct buf_3d_rec *_3d;
{
 struct slice_info_rec *slice_info;
 struct buf_3d_rec *_3d1;
 long lcv,gnum;
 int yes;

 slice_info = &(file->slice_info);
 for (yes = 0,lcv = 0; lcv < slice_info->num_views; lcv++)
    {find_file_3d(file,slice_info->views[lcv]->id,&_3d1);
     if (_3d1 == _3d)
       if (!yes)
          {yes = 1;
           gnum = slice_info->views[lcv]->group_num;}
         else if (gnum != slice_info->views[lcv]->group_num)
          return 2;
    }
 if (!yes) return 0;
 return 1;
}


/*----------------------------------------------------------------------
delete_file_3d - ???
----------------------------------------------------------------------*/

int
delete_file_3d(file,id)
 struct input_file_rec *file;
 char *id;
{
 unsigned long cnt;
 struct slice_info_rec *slice_info;

 printf("delete_file_3d...\n");
 slice_info = &(file->slice_info);
 for (cnt = 0; cnt < slice_info->num_3ds; cnt++)
    if (str_cmp(slice_info->_3ds[cnt]->id,id) == 0)
       {
        free_buf_3d_rec(slice_info->_3ds[cnt]);
        c_free(slice_info->_3ds[cnt]);
        slice_info->num_3ds -= 1;
        for (; cnt < slice_info->num_3ds; cnt++)
           slice_info->_3ds[cnt] = slice_info->_3ds[cnt+1];
        slice_info->_3ds[slice_info->num_3ds] = NULL;
        printf("delete_file_3d...deleted\n");
        return NO_ERROR;}
 printf("delete_file_3d...end\n");
 return NOT_FOUND;
}


/*----------------------------------------------------------------------
SetupViewRec - ???
----------------------------------------------------------------------*/

int
SetupViewRec(view,file,id,x,y,z,normalx,normaly,normalz,start,end,
             buf_dimx,buf_dimy,translate,scale,rotate,center,
             xratio,yratio,zratio,global_matrix,is_adjust_to_center,
	     is_approx_value)
 struct view_rec *view;
 struct input_file_rec *file;
 char *id;
 float x,y,z,normalx,normaly,normalz;
 struct vector_3d_rec *start,*end;
 long buf_dimx,buf_dimy;
 /* FIXME:  Added decl for `center' below without verifying that it's
    correct.  -PWH 19990319 */
 struct vector_3d_rec *translate,*scale,*rotate,*center; 
 float xratio,yratio,zratio;
 struct matrix_3d_rec *global_matrix;
 int is_adjust_to_center;
 unsigned long is_approx_value;
{
 int err;

 TRACE(printf("SetupViewRec...id = %s\n",id))
 view->status &= ~(PLANE_DATA_PROJECTED | PLANE_SETUP_OK);
 view->file = file;
 if ((err = cp_str(&(view->id),id)) != NO_ERROR) return err;
 PtNormalPlane(&(view->gplane),x,y,z,normalx,normaly,normalz,
           start->x,end->x,start->y,end->y,start->z,end->z,buf_dimx,buf_dimy,
           translate,scale,rotate,center,90.0,30.0,xratio,yratio,zratio,
           global_matrix,1,is_adjust_to_center,is_approx_value);

 TRACE(printf("SetupViewRec.1..id = %s\n",id))
 if ((err = setup_data_slice_rec(&(view->sl),&(file->slice_info),
     view,(char *) get_plane_img_label(&(view->gplane)),
     view->gplane.plane_num,&(view->sl.slice),&(view->sl.slice),
         &(view->sl.slice))) != NO_ERROR)
    {free_data_slice_rec(&(view->sl));
     return err;}
 setup_list_rec(&(view->_3d_list),view,NULL,NULL,NULL,NULL);
 TRACE(printf("SetupViewRec.2..id = %s\n",id))

 view->status |= PROJECT_PLANE_DATA | PLANE_SETUP_OK;
 return NO_ERROR;
}



/*----------------------------------------------------------------------
delete_view_rec - ???
----------------------------------------------------------------------*/

void
delete_view_rec(file,view)
     struct input_file_rec *file;
     struct view_rec *view;
{
  TRACE(printf("delete_view_rec file = %u  view = %u\n",file,view));
  drop_view_rec(&(file->slice_info),view);
  TRACE(printf("delete_view_rec 1\n"));
  free_view_rec(view);
  TRACE(printf("delete_view_rec end\n"));
}



/*----------------------------------------------------------------------
SetupFileViewRec - ???
----------------------------------------------------------------------*/

int
SetupFileViewRec(file,id,x,y,z,normalx,normaly,normalz,start,end,
                 buf_dimx,buf_dimy,translate,scale,rotate,center,
                 xratio,yratio,zratio,global_matrix,is_adjust_to_center,
                 option,view_data)
 struct input_file_rec *file;
 char *id;
 float x,y,z,normalx,normaly,normalz;
 struct vector_3d_rec *start,*end;
 long buf_dimx,buf_dimy;
 struct vector_3d_rec *translate,*scale,*rotate,*center;
 float xratio,yratio,zratio;
 struct matrix_3d_rec *global_matrix;
 int is_adjust_to_center;
 unsigned long option;
 struct view_rec **view_data;
{
 struct view_rec *view;
 int err;

 *view_data = NULL;
 if ((err = get_ptr(&view,NULL,1,(size_t) sizeof(*view))) != NO_ERROR) return err;
 init_view_rec(view);
 if (((err = SetupViewRec(view,file,id,x,y,z,normalx,normaly,normalz,start,end,
          buf_dimx,buf_dimy,translate,scale,rotate,center,
          xratio,yratio,zratio,global_matrix,is_adjust_to_center,option)) != NO_ERROR) ||
     ((err = add_view_rec(&(file->slice_info),view)) != NO_ERROR))
    {free_view_rec(view);
     c_free(view);
     return err;}

 TRACE(printf("SetupFileViewRec...ok\n"));
 if (option) 
    view->more_status |= VIEW_3D_APPROX;
 *view_data = view;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
setup_file_3d - ???
----------------------------------------------------------------------*/

int
setup_file_3d(file,id,option)
 struct input_file_rec *file;
 char *id;
 unsigned long option;
{
 int err;
 struct view_rec *axial,*sag,*cor,*obl;
 float x,y,z,last_slice_thickness;
 struct data_info_rec *info;
 unsigned long zslices;
 struct vector_3d_rec start,end,v1,v2,normal;
 static char *the_id = NULL;

 if (the_id != NULL) c_free(the_id);
 if ((err = cp_str(&the_id,id)) != NO_ERROR) return err;
 info = &(file->hdr.data_info);
 total_zslices(info->pixel_thickness,info->xpixel_size,
             NumberOfSliceCuts(&(file->hdr.data_info)),
             &zslices,&last_slice_thickness);
 setup_vector_3d_rec(&start,.0,.0,.0);
 setup_vector_3d_rec(&end,(float) (info->dimx - 1),
                     (float) (info->dimy - 1),(float) zslices - 1.0);
 setup_vector_3d_rec(&v1,end.x,end.y,start.z);
 sub_vector_3d(&v1,&start);
 v2 = end;
 sub_vector_3d(&v2,&start);
 vector_cross_product(&normal,&v2,&v1);

 z = (float) ULongRound((double) (start.z + end.z) / 2.0);
 x = (float) (info->dimx / 2);
 y = (float) (info->dimy / 2);
 axial = sag = cor = obl = NULL;
 if (((err = SetupFileViewRec(file,id,x,y,z, .0,.0,1.0,
         &start,&end,(long) file->hdr.data_info.dimx,(long) file->hdr.data_info.dimy,
         NULL,NULL,NULL,NULL,1.0,1.0,1.0,NULL,1,option,&axial)) != NO_ERROR) ||
     ((err = SetupFileViewRec(file,id,x,y,z,1.0,.0,.0,
         &start,&end,(long) file->hdr.data_info.dimx,(long) file->hdr.data_info.dimy,
         NULL,NULL,NULL,NULL,1.0,1.0,1.0,NULL,1,option,&sag)) != NO_ERROR) ||
     ((err = SetupFileViewRec(file,id,x,y,z, .0,1.0,.0,
         &start,&end,(long) file->hdr.data_info.dimx,(long) file->hdr.data_info.dimy,
         NULL,NULL,NULL,NULL,1.0,1.0,1.0,NULL,1,option,&cor)) != NO_ERROR) ||
     ((err = SetupFileViewRec(file,id,(start.x + end.x) / 2.0,
         (start.y + end.y) / 2.0,(start.z + end.z) / 2.0,
         normal.x,normal.y,normal.z,
         &start,&end,(long) file->hdr.data_info.dimx,(long) file->hdr.data_info.dimy,
         NULL,NULL,NULL,NULL,1.0,1.0,1.0,NULL,1,option,&obl)) != NO_ERROR))
    {TRACE(printf("setup_file_3d...1 deleting\n"))
     if (axial != NULL) delete_view_rec(file,axial);
     TRACE(printf("setup_file_3d...2 deleting\n"))
     if (sag != NULL) delete_view_rec(file,sag);
     if (cor != NULL) delete_view_rec(file,cor);
     if (obl != NULL) delete_view_rec(file,obl);
     TRACE(printf("setup_file_3d...done deleting\n"))
     return err;}
 add_item_after_cur_list(&(axial->_3d_list),&(sag->_3d_list));
 add_item_after_cur_list(&(sag->_3d_list),&(cor->_3d_list));
 add_item_after_cur_list(&(cor->_3d_list),&(obl->_3d_list));
 set_view_group_num(axial);

 return get_file_3d(file,the_id,project_view_recs,project_view_recs,axial,NULL,
                 NULL,NULL,LINEAR_INTERPOLATION,"Preparing the 3D images...");

}


/*----------------------------------------------------------------------
setup_file_3d_sub_obj - ???
----------------------------------------------------------------------*/

int
setup_file_3d_sub_obj(file,id,view)
 struct input_file_rec *file;
 char *id;
 struct view_rec *view;
{
 struct buf_3d_rec *_3d;
 float x,y,z;
 struct vector_3d_rec start,end,v1,v2,normal;
 struct view_rec *axial,*sag,*cor,*obl;
 long dim1,dim2;
 double dist;
 int err;

 if ((err = find_file_3d(file,id,&_3d)) != NO_ERROR) return err;
 setup_vector_3d_rec(&start,(float) _3d->startx,(float) _3d->starty,(float) _3d->startz);
 setup_vector_3d_rec(&end,(float) (_3d->startx + _3d->dimx - 1),
           (float) (_3d->starty + _3d->dimy - 1),(float) (_3d->startz + _3d->dimz - 1));
 setup_vector_3d_rec(&v1,end.x,end.y,start.z);
 sub_vector_3d(&v1,&start);
 v2 = end;
 sub_vector_3d(&v2,&start);
 vector_cross_product(&normal,&v2,&v1);
 dim1 = _3d->dimx;
 if ((_3d->dimx < _3d->dimy) && (_3d->dimx < _3d->dimz))
    {dim1 = _3d->dimy;
     dim2 = _3d->dimz;}
   else if ((_3d->dimy < _3d->dimx) && (_3d->dimy < _3d->dimz))
    {dim1 = _3d->dimx;
     dim2 = _3d->dimz;}
   else
    {dim1 = _3d->dimx;
     dim2 = _3d->dimy;}

 dist = (double) (dim1 * dim1 + dim2 * dim2);
 dist = sqrt(dist);
 dim1 = (long) ULongRound(dist);
 axial = sag = cor = obl = NULL;
 z = (float) ULongRound((double) (start.z + end.z) / 2.0);
 x = (float) ULongRound((double) (start.x + end.x) / 2.0);
 y = (float) ULongRound((double) (start.y + end.y) / 2.0);

 TRACE(printf("setup_file_3d_sub_obj...dim1 = %d\n",dim1))
 if (((err = SetupFileViewRec(file,id,x,y,z,.0,.0,1.0,
       &start,&end,dim1,dim1,&(view->gplane.translate),
       &(view->gplane.scale),&(view->gplane.rotate),&(view->gplane.center),
       view->gplane.coord_ratio.x,view->gplane.coord_ratio.y,
       view->gplane.coord_ratio.z,&(view->gplane.global),1,0,
       &axial)) != NO_ERROR) ||
     ((err = SetupFileViewRec(file,id,x,y,z,1.0,.0,.0,
       &start,&end,dim1,dim1,&(view->gplane.translate),
       &(view->gplane.scale),&(view->gplane.rotate),&(view->gplane.center),
       view->gplane.coord_ratio.x,view->gplane.coord_ratio.y,
       view->gplane.coord_ratio.z,&(view->gplane.global),1,0,
       &sag)) != NO_ERROR) ||
     ((err = SetupFileViewRec(file,id,x,y,z, .0,1.0,.0,
       &start,&end,dim1,dim1,&(view->gplane.translate),
       &(view->gplane.scale),&(view->gplane.rotate),&(view->gplane.center),
       view->gplane.coord_ratio.x,view->gplane.coord_ratio.y,
       view->gplane.coord_ratio.z,&(view->gplane.global),1,0,
       &cor)) != NO_ERROR) ||
     ((err = SetupFileViewRec(file,id,(start.x + end.x) / 2.0,
         (start.y + end.y) / 2.0,(start.z + end.z) / 2.0,
       normal.x,normal.y,normal.z,&start,&end,dim1,dim1,
       &(view->gplane.translate),
       &(view->gplane.scale),&(view->gplane.rotate),&(view->gplane.center),
       view->gplane.coord_ratio.x,view->gplane.coord_ratio.y,
       view->gplane.coord_ratio.z,&(view->gplane.global),1,0,
       &obl)) != NO_ERROR))
    {PRT(printf("setup_file_3d_sub_obj delete_view_rec\n"))
     if (axial != NULL) delete_view_rec(file,axial);
     if (sag != NULL) delete_view_rec(file,sag);
     if (cor != NULL) delete_view_rec(file,cor);
     if (obl != NULL) delete_view_rec(file,obl);
     return err;}
 add_item_after_cur_list(&(axial->_3d_list),&(sag->_3d_list));
 add_item_after_cur_list(&(sag->_3d_list),&(cor->_3d_list));
 add_item_after_cur_list(&(cor->_3d_list),&(obl->_3d_list));
 axial->status |= PLANE_3D_SUB_OBJ;
 sag->status |= PLANE_3D_SUB_OBJ;
 cor->status |= PLANE_3D_SUB_OBJ;
 obl->status |= PLANE_3D_SUB_OBJ;
 set_view_group_num(axial);

/*
 TRACE(printf("setup_file_3d_sub_obj...project_view_recs\n"))
 TRACE(printf("\n\n..axial\n"))
 TRACE(pr_plane_3d_rec(&(axial->plane)))
*/
 TRACE(printf("..axial...end\n\n"))
 return err = project_view_recs(axial);
}

