/****************************************************************************
3d_split.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_split.c,v 1.8 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "buf_3d_rec.h"
#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRINT(x) printf(x); fflush(stdout);
#define TRACE(x) x; fflush(stdout);
*/
#define PRINT(x)
#define TRACE(x)



#define CLEAN_UP_3D_MENU 0
#define SETUP_3D_MENU 1
#define GET_ALL_3D_MENU_PTR 2
#define CLOSE 10
#define OPEN 11

#define CLOSE_UPON_OWNER_REQUEST 1



struct split_3d_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item show_roi,show_pixel_type,obj,minx,maxx,miny,maxy,minz,maxz;
   };

struct all_split_3d_recs
   {
    int num_3ds;
    struct split_3d_rec **_3ds;
   };



void init_split_3d_rec(struct split_3d_rec *_3d);
void free_split_3d_rec(struct split_3d_rec *_3d);
void init_all_split_3d_recs(struct all_split_3d_recs *all_3ds);
void setup_obj_proc(struct img_buf_rec *img, Panel_item item);
void _3d_split_done_proc(Frame frame);
void setup_split_3d_pixel_type_proc(struct split_3d_rec *_3d);
void set_3d_split_minmax_proc(Panel_item item, int value, Event *event);
int split_rois_proc(Panel_item item, Event *event);
int split_region_volume(struct split_3d_rec *_3d, struct view_rec *view,
    struct int_bound_rec *area, long *minz, long *maxz);
int split_region_proc(Panel_item item, Event *event);
void delete_obj_proc(Panel_item item, Event *event);
int setup_split_3d_rec(struct split_3d_rec *_3d,
    struct image_display_window *win);
struct split_3d_rec *find_split_3d_rec(struct all_split_3d_recs *all_3ds,
    struct image_display_window *win);
int enter_3d_split_rois(struct image_display_window *win, int status);



/*------------------------------------------------------------------------
init_split_3d_rec - ???
------------------------------------------------------------------------*/

void
init_split_3d_rec(_3d)
 struct split_3d_rec *_3d;
{
 _3d->status = 0;
 _3d->win = NULL;
 _3d->frame  = 0;
}


/*------------------------------------------------------------------------
free_split_3d_rec - ???
------------------------------------------------------------------------*/

void
free_split_3d_rec(_3d)
 struct split_3d_rec *_3d;
{
 struct all_split_3d_recs *all_3ds;

 if (_3d->frame != 0) xv_destroy_safe(_3d->frame);
 all_3ds = (struct all_split_3d_recs *) enter_3d_split_rois(NULL,
            GET_ALL_3D_MENU_PTR);
 c_free(_3d);
 DropHandleAryPtr(&(all_3ds->_3ds),&(all_3ds->num_3ds),_3d);
}


/*------------------------------------------------------------------------
init_all_split_3d_recs - ???
------------------------------------------------------------------------*/

void
init_all_split_3d_recs(all_3ds)
 struct all_split_3d_recs *all_3ds;
{
 all_3ds->num_3ds = 0;
 all_3ds->_3ds = NULL;
}


/**********************
setup_obj_proc(img,roi_item)
 struct img_buf_rec *img;
 Panel_item roi_item;
{
 int cnt,lcv,indx;
 struct strs_rec roi_labels,*roi;
 struct buf_3d_rec **_3ds;

 FileGetAllRoiLabelPtrs(img->file,&roi_labels,0,1);
 _3ds = img->file->slice_info._3ds;
 for (indx = 0,cnt = 0; cnt < img->file->slice_info.num_3ds; cnt++)
    {for (lcv = 0; lcv < img->file->hdr.analysis.num_img_labels; lcv++)
        if (str_cmp(img->file->hdr.analysis.img_labels[lcv],_3ds[cnt]->id) == 0)
           break;
     if (lcv == img->file->hdr.analysis.num_img_labels)
        {for (lcv = 0; lcv < img->file->hdr.analysis.num_img_labels; lcv++)
            if (str_cmp(img->file->hdr.analysis.img_labels[lcv],_3ds[cnt]->id) == 0)
               break;
         for (lcv = 0; lcv < roi_labels.num_strs; lcv++)
            if (str_cmp(roi_labels.strs[lcv],_3ds[cnt]->id) == 0)
               break;
         if (lcv == roi_labels.num_strs)
            xv_set(roi_item,PANEL_LIST_STRING,indx,_3ds[cnt]->id,0);
        }
   }
 free_strs_rec_ptrs(&roi_labels);
}
*********************/


/*------------------------------------------------------------------------
setup_obj_proc - ???
------------------------------------------------------------------------*/

void
setup_obj_proc(img,item)
 struct img_buf_rec *img;
 Panel_item item;
{
 int cnt,indx;
 struct buf_3d_rec **_3ds;

 _3ds = img->file->slice_info._3ds;
 for (indx = 0,cnt = 0; cnt < img->file->slice_info.num_3ds; cnt++)
    {if (_3ds[cnt]->status & _3D_SUB_OBJECT)
        {xv_set(item,PANEL_LIST_STRING,indx,_3ds[cnt]->id,0);
         indx++;}
    }

}


/*------------------------------------------------------------------------
_3d_split_done_proc - ???
------------------------------------------------------------------------*/

void
_3d_split_done_proc(frame)
 Frame frame;
{
 struct split_3d_rec *_3d;

 _3d = (struct split_3d_rec *)
                     xv_get(frame,WIN_CLIENT_DATA);
 free_split_3d_rec(_3d);
}


/*------------------------------------------------------------------------
setup_split_3d_pixel_type_proc - ???
------------------------------------------------------------------------*/

void
setup_split_3d_pixel_type_proc(_3d)
 struct split_3d_rec *_3d;
{
 int cnt;
 struct img_buf_rec *img;
 struct strs_rec *order;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL)
    return;

 order = &(img->file->pixel_type.order);
 for (cnt = 0; cnt < order->num_strs; cnt++)
    xv_set(_3d->show_pixel_type,
          PANEL_LIST_STRING,cnt,order->strs[cnt],
          PANEL_LIST_SELECT,cnt,0,0);
}


/*------------------------------------------------------------------------
set_3d_split_minmax_proc - ???
------------------------------------------------------------------------*/

void
set_3d_split_minmax_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct split_3d_rec *_3d;
 int val1;

 _3d = (struct split_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (item == _3d->minx)
    {val1 = (int) xv_get(_3d->maxx,PANEL_VALUE);
     if (value > val1) xv_set(_3d->maxx,PANEL_VALUE,value,0);
    }
   else if (item == _3d->maxx)
    {val1 = (int) xv_get(_3d->minx,PANEL_VALUE);
     if (value < val1) xv_set(_3d->minx,PANEL_VALUE,value,0);
    }
   else if (item == _3d->miny)
    {val1 = (int) xv_get(_3d->maxy,PANEL_VALUE);
     if (value > val1) xv_set(_3d->maxy,PANEL_VALUE,value,0);
    }
   else if (item == _3d->maxy)
    {val1 = (int) xv_get(_3d->miny,PANEL_VALUE);
     if (value < val1) xv_set(_3d->miny,PANEL_VALUE,value,0);
    }
   else if (item == _3d->minz)
    {val1 = (int) xv_get(_3d->maxz,PANEL_VALUE);
     if (value > val1) xv_set(_3d->maxz,PANEL_VALUE,value,0);
    }
   else if (item == _3d->maxz)
    {val1 = (int) xv_get(_3d->minz,PANEL_VALUE);
     if (value < val1) xv_set(_3d->minz,PANEL_VALUE,value,0);
    }
}


/*------------------------------------------------------------------------
split_rois_proc - ???
------------------------------------------------------------------------*/

int
split_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct split_3d_rec *_3d;
 struct strs_rec roi_strs,pixel_type;
 struct int_bound_rec area;
 struct img_buf_rec *img;
 struct view_rec *view;
 long minz,maxz;
 char *img_type,*view_id;
 int err;

 _3d = (struct split_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 set_win_busy(_3d->win);
 xv_set(_3d->frame,FRAME_BUSY,TRUE,0);
 init_strs_rec(&roi_strs);
 init_strs_rec(&pixel_type);
 TRACE(printf("split_rois_proc....\n"))
 if (((err = selected_list_items(&roi_strs,_3d->show_roi)) == NO_ERROR) &&
     ((err = selected_list_items(&pixel_type,_3d->show_pixel_type)) == NO_ERROR))
    {TRACE(printf("split_rois_proc roi->num_strs = %d\n",roi_strs.num_strs))
     if (roi_strs.num_strs > 0)
        {if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
         view = img->cur_slice->slice->view;
         if ((err = get_file_sub_obj_volume(view,&roi_strs,&area,&minz,&maxz)) ==
                  NO_ERROR)
            {img_type = decode_img_label(view->id);

             if ((err = rois_to_img_label(&view_id,img_type,
                        &roi_strs,&pixel_type)) == NO_ERROR)
                {if ((err = get_file_3d_sub_obj(img->file,
                         view,&roi_strs,&pixel_type,
                         view_id,&area,minz,maxz,1)) == NO_ERROR)
                    {if ((err = setup_file_3d_sub_obj(img->file,view_id,view))
                            != NO_ERROR)
                        notice_prompt(_3d->dwin->frame,(Event *) NULL,
                           NOTICE_MESSAGE_STRINGS,"Error occurred when projecting ",
                            "the contructed 3D Volume !!!",0,
                            NOTICE_BUTTON_YES,"OK !",0);
                    }
                   else
                    notice_prompt(_3d->dwin->frame,(Event *) NULL,
                         NOTICE_MESSAGE_STRINGS,"Error occurred when constructing ",
                          "the 3D Volume !!!",0,
                         NOTICE_BUTTON_YES," Volume not constructed",0);
                }
               else notice_prompt(_3d->dwin->frame,(Event *) NULL,
                         NOTICE_MESSAGE_STRINGS,"Error occurred when setting up ",
                          "the 3D Volume !!!",
                          "Memory might be insufficient !!!",0,
                         NOTICE_BUTTON_YES," Volume not constructed",0);
            }
           else
            {
             notice_prompt(_3d->dwin->frame,(Event *) NULL,
                  NOTICE_MESSAGE_STRINGS,"ROIS do not exist !!!",
                    "or existing rois are empty !!!",0,
                  NOTICE_BUTTON_YES," Volume not constructed",0);
            }
        }
    }
    
 free_strs_rec(&pixel_type);
 free_strs_rec(&roi_strs);
 
 set_win_not_busy(_3d->win);
 xv_set(_3d->frame,FRAME_BUSY,FALSE,0);
 return err;
}


/*------------------------------------------------------------------------
split_region_volume - ???
------------------------------------------------------------------------*/

int
split_region_volume(_3d,view,area,minz,maxz)
 struct split_3d_rec *_3d;
 struct view_rec *view;
 struct int_bound_rec *area;
 long *minz,*maxz;
{
 struct buf_3d_rec *the_3d;
 int err;

 setup_int_bound_rec(area,
        (int) xv_get(_3d->minx,PANEL_VALUE),(int) xv_get(_3d->miny,PANEL_VALUE),
        (int) xv_get(_3d->maxx,PANEL_VALUE),(int) xv_get(_3d->maxy,PANEL_VALUE));
 if ((err = find_file_3d(view->img->file,view->id,&the_3d)) != NO_ERROR)
    return err;
 *minz = (int) xv_get(_3d->minz,PANEL_VALUE) - 1;
 *maxz = (int) xv_get(_3d->maxz,PANEL_VALUE) - 1;
 TRACE(printf("split_region_volume mixz = %d  maxz = %d\n",*minz,*maxz))

 return NO_ERROR;
}


/*------------------------------------------------------------------------
split_region_proc - ???
------------------------------------------------------------------------*/

int
split_region_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct split_3d_rec *_3d;

 struct strs_rec pixel_type;
 struct int_bound_rec area;
 struct img_buf_rec *img;
 struct view_rec *view;
 long minz,maxz;
 char *img_type,*view_id;
 int err;

 _3d = (struct split_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 set_win_busy(_3d->win);
 xv_set(_3d->frame,FRAME_BUSY,TRUE,0);
 init_strs_rec(&pixel_type);
 TRACE(printf("split_region_proc....\n"))
 if ((err = selected_list_items(&pixel_type,_3d->show_pixel_type)) == NO_ERROR)
    {if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
     view = img->cur_slice->slice->view;
     if ((err = split_region_volume(_3d,view,&area,&minz,&maxz)) == NO_ERROR)
        {img_type = decode_img_label(view->id);

         if ((err = volume_to_img_label(&view_id,img_type,
                        &area,minz,maxz,&pixel_type)) == NO_ERROR)
            {if ((err = get_file_3d_sub_obj(img->file,view,NULL,&pixel_type,
                         view_id,&area,minz,maxz,0)) == NO_ERROR)
                {TRACE(printf("***&&& view_id = %s\n",view_id))
                 if ((err = setup_file_3d_sub_obj(img->file,view_id,view))
                            != NO_ERROR)
                    notice_prompt(_3d->dwin->frame,(Event *) NULL,
                           NOTICE_MESSAGE_STRINGS,"Error occurred when projecting ",
                            "the contructed 3D Volume !!!",0,
                            NOTICE_BUTTON_YES,"OK !",0);
                }
               else
                notice_prompt(_3d->dwin->frame,(Event *) NULL,
                         NOTICE_MESSAGE_STRINGS,"Error occurred when constructing ",
                          "the 3D Volume !!!",0,
                         NOTICE_BUTTON_YES," Volume not constructed",0);
            }
           else notice_prompt(_3d->dwin->frame,(Event *) NULL,
                         NOTICE_MESSAGE_STRINGS,"Error occurred when setting up ",
                          "the 3D Volume !!!",
                          "Memory might be insufficient !!!",0,
                         NOTICE_BUTTON_YES," Volume not constructed",0);
        }
       else
        {
         notice_prompt(_3d->dwin->frame,(Event *) NULL,
                         NOTICE_MESSAGE_STRINGS,"Bad region provided for ",
                          "the 3D Volume !!!",0,
                         NOTICE_BUTTON_YES," Volume not constructed",0);
        }
    }
    
 free_strs_rec(&pixel_type);
 
 set_win_not_busy(_3d->win);
 xv_set(_3d->frame,FRAME_BUSY,FALSE,0);
 return err;
}


/*------------------------------------------------------------------------
delete_obj_proc - ???
------------------------------------------------------------------------*/

void
delete_obj_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct split_3d_rec *_3d;

 _3d = (struct split_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);

}


/*------------------------------------------------------------------------
setup_split_3d_rec - ???
------------------------------------------------------------------------*/

int
setup_split_3d_rec(_3d,win)
 struct split_3d_rec *_3d;
 struct image_display_window *win;
{
 Cms cms;
 Panel_item item;
 int row,offset,temp,temp1;
 struct img_buf_rec *img;
 struct view_rec *view;
 char *str;
 Rect *rr;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 _3d->frame = xv_create(win->dwin->frame, FRAME,
			/*WIN_DYNAMIC_VISUAL,TRUE,*/
			FRAME_INHERIT_COLORS,TRUE,
			WIN_CLIENT_DATA,_3d,
			0);
 /* FIXME:  Added return value in next line w/o verifying.  -PWH 19990319 */
 if (_3d->frame == 0) return ~NO_ERROR;  
 xv_set(_3d->frame,		/* DRW 19970811  See display_init_free.c */
	WIN_CMS,cms,
	NULL);
 _3d->win = win;
 _3d->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,_3D_SPLIT_ROIS_MENU);
 xv_set(_3d->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,_3d_split_done_proc,
              0);
 c_free(str);
 xv_set(_3d->frame,FRAME_CLOSED,FALSE,0);

 _3d->panel = xv_create(_3d->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);
 if (_3d->panel == 0)
    {free_split_3d_rec(_3d);
     return 0;}

 row = 5;
 offset = xv_rows(_3d->panel,1) - xv_rows(_3d->panel,0) - 10;
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"ALL",
	PANEL_NOTIFY_PROC,all_list_proc,
        XV_KEY_DATA,1,&(_3d->show_roi),
        XV_X,5,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"NONE",
	PANEL_NOTIFY_PROC,none_list_proc,
        XV_KEY_DATA,1,&(_3d->show_roi),
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SPLIT ROIS",
	PANEL_NOTIFY_PROC,split_rois_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"ALL",
	PANEL_NOTIFY_PROC,all_list_proc,
        XV_KEY_DATA,1,&(_3d->show_pixel_type),
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"NONE",
	PANEL_NOTIFY_PROC,none_list_proc,
        XV_KEY_DATA,1,&(_3d->show_pixel_type),
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 temp = row;
 row += offset;

 _3d->show_roi = xv_create(_3d->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,3,
        PANEL_LIST_WIDTH,100,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,0);
 setup_file_rois_list_item(img,_3d->show_roi);

 rr = (Rect *) xv_get(_3d->show_roi,XV_RECT);
 _3d->show_pixel_type = xv_create(_3d->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,3,
        PANEL_LIST_WIDTH,100,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,0);
 setup_split_3d_pixel_type_proc(_3d);
/*
 row = rr->r_top + rr->r_height + 5;

 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DELETE OBJECT",
	PANEL_NOTIFY_PROC,delete_obj_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	0);
 row += offset;

 _3d->obj = xv_create(_3d->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,1,
        PANEL_LIST_WIDTH,200,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,0);
 setup_obj_proc(img,_3d->obj);
 rr = (Rect *) xv_get(_3d->obj,XV_RECT);
 xv_set(item,XV_X,rr->r_left + rr->r_width / 2,0);
*/
 temp = row = rr->r_top + rr->r_height + 5;

 row += offset;
 _3d->minx = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"X",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) img->file->hdr.data_info.dimx - 1,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_3d_split_minmax_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	0);
 _3d->maxx = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_VALUE,(int) img->file->hdr.data_info.dimx - 1,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) img->file->hdr.data_info.dimx - 1,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_3d_split_minmax_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_Y,row,
	0);
 item = xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,25,XV_Y,temp,
	              PANEL_LABEL_STRING,"MIN",0);

 rr = (Rect *) xv_get(_3d->maxx,XV_RECT);
 temp1 = rr->r_left + 40;
 xv_create(_3d->panel,PANEL_MESSAGE,
                      XV_X,temp1,XV_Y,temp,
	              PANEL_LABEL_STRING,"MAX",0);
 rr = (Rect *) xv_get(item,XV_RECT);
 temp1 = (temp1 + rr->r_left + rr->r_width) / 2;
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SPLIT REGION",
	PANEL_NOTIFY_PROC,split_region_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_Y,temp,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 xv_set(item,XV_X,temp1 - rr->r_width / 2,0);

 row += offset;
 _3d->miny = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"Y",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) img->file->hdr.data_info.dimx - 1,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_3d_split_minmax_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	0);
 _3d->maxy = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_VALUE,(int) img->file->hdr.data_info.dimx - 1,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,(int) img->file->hdr.data_info.dimx - 1,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_3d_split_minmax_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_Y,row,
	0);
 row += offset;
 _3d->minz = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"S",
	PANEL_VALUE,1,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,(int) img->file->slice_info.num_sroi_wins,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_3d_split_minmax_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_X,5,XV_Y,row,
	0);
 _3d->maxz = xv_create(_3d->panel,PANEL_SLIDER,
	PANEL_VALUE,(int) img->file->slice_info.num_sroi_wins,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,(int) img->file->slice_info.num_sroi_wins,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_3d_split_minmax_proc,
        PANEL_CLIENT_DATA,_3d,
        XV_Y,row,
	0);
 rr = (Rect *) xv_get(_3d->maxz,XV_RECT);
 temp = rr->r_left + rr->r_width + 15;
 xv_set(_3d->panel,XV_WIDTH,temp,
           XV_HEIGHT,rr->r_top + rr->r_height + 5,0);
 window_fit(_3d->frame);
 make_2_wins_adjacent(_3d->frame,win->dwin->frame,0);
 win_set_mouse_at_center(_3d->frame);

 return NO_ERROR;
}


/*------------------------------------------------------------------------
find_split_3d_rec - ???
------------------------------------------------------------------------*/

struct split_3d_rec *
find_split_3d_rec(all_3ds,win)
 struct all_split_3d_recs *all_3ds;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_3ds->num_3ds; lcv++)
    if ((img = win_rec_cur_img_buf(all_3ds->_3ds[lcv]->win->owner)) != NULL)
       if (img->file == f1)
          return all_3ds->_3ds[lcv];
 return NULL;
}


/*------------------------------------------------------------------------
enter_3d_split_rois - ???
------------------------------------------------------------------------*/

int
enter_3d_split_rois(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_split_3d_recs all_3ds;
 static char first_time = 1;
 int err;
 struct split_3d_rec *_3d;

 err = NO_ERROR;
 if (status == GET_ALL_3D_MENU_PTR)
    {if (first_time) return 0;
     return (unsigned long) &all_3ds;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_3D_MENU)
   {if (!first_time)
       /* FIXME:  Removed final argument `win->dwin' below to match called
	  function.  Should be confirmed.  -PWH 19990319 */
       if ((_3d = find_split_3d_rec(&all_3ds,win)) != NULL)
          free_split_3d_rec(_3d);
    return NO_ERROR;}
 if (first_time)
    {init_all_split_3d_recs(&all_3ds);
     first_time = 0;}
   else
    {if ((_3d = find_split_3d_rec(&all_3ds,win)) != NULL)
        if (_3d->win == win)
           {xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
            win_set_mouse_at_center(_3d->frame);
            wmgr_top(_3d->frame);
            return NO_ERROR;}
          else free_split_3d_rec(_3d);
    }
 /***
    {if ((_3d = find_split_3d_rec(&all_3ds,win)) != NULL)
        {_3d->win = win;
         _3d->dwin = win->dwin;
         xv_set(_3d->frame,XV_SHOW,TRUE,0);
         xv_set(_3d->frame,XV_OWNER,win->dwin->frame,
              XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         str = win_rec_win_id_title(win->owner,_3D_SPLIT_ROIS_MENU);
         xv_set(_3d->frame,XV_LABEL,str,0);
         win_set_mouse_at_center(_3d->frame);
         c_free(str);

         wmgr_top(_3d->frame);
         _3d->status &= ~CLOSE_UPON_OWNER_REQUEST;
         return NO_ERROR;}
    }
 ***/
 get_handle_memory(&(all_3ds._3ds),&(all_3ds.num_3ds),1,
     (size_t) sizeof(struct split_3d_rec),&err);
 if (err != NO_ERROR) return err;
 _3d = all_3ds._3ds[all_3ds.num_3ds - 1];
 init_split_3d_rec(_3d);
 if ((err = setup_split_3d_rec(_3d,win)) == NO_ERROR)
    xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return err;
}





