#include "mri_format.h"
#include "text_format.h"

/*
cc -c batch_text_output.c
*/

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)

extern char * current_asctime();
extern struct roi_rec *get_roi();

/*
  
  store_in_collection_rec_buf(buf,total_buf_size,buf_size,str,str_len)
  get_collection(collection,group,
  		pixel_type,voxel,counts,num_slices,group_indx)
  setup_page_rec(text)
  SetupPixelTypeOutput(format,hdr,slice_rois,pixel_type)
  SetupAllCollectionRec(text,hdr,slice_rois,pixel_type)

  flush_the_text_output(text)

  is_text_output(text)
  WrPixelTypeTextFileInfo_1(fid,text_printing_time,format,
  	hdr,ndathdr,pixel_type,prog_name,prog_id,
  	hdrdirfn,hdrfn,hdrsuffix,imgsuffix,ndatdir,ndatfn,ndatsuffix)
  wr_pixel_type_text_labels(fid,text)

  PrintPixelTypeTextToFile_1(fn,text,hdr,ndathdr,pixel_type,prog_name,prog_id,
  	hdrdirfn,hdrfn,hdrsuffix,imgsuffix,ndatdir,ndatfn,ndatsuffix)
  PrintPixelTypeTextToTempFile(text,hdr,slice_rois,pixel_type,
  	ndathdr,prog_name,prog_id,
	hdrdirfn,hdrfn,hdrsuffix,imgsuffix,ndatdir,ndatfn,ndatsuffix)
  SavePixelTypeTextToFile(fn,text,hdr,slice_rois,pixel_type,
  	ndathdr,prog_name,prog_id,
	hdrdirfn,hdrfn,hdrsuffix,imgsuffix,ndatdir,ndatfn,ndatsuffix)
*/




int
SetupAllCollectionRec(text,hdr,slice_rois,pixel_type)
     struct text_output_rec *text;
     struct hdr_rec *hdr;
     struct slice_roi_rec *slice_rois;
     struct pixel_type_rec *pixel_type;
{
  struct all_collection_rec *analysis;
  unsigned_int lcv,cnt,indx;
  char str[20];
  int err;

  TRACE(printf("SetupAllCollectionRec...\n"));
  if (!(text->format.status & OUT_FORMAT_DEFINED))
  {
    TRACE(printf("setup_output_format...\n"););
    if ((err = setup_output_format(text)) != NO_ERROR)
      return err;
  }

#if 0
  if (!(text->format.status & OUT_FORMAT_COUNT_DEFINED))
    if ((err = SetupPixelTypeOutput(&(text->format),
				    hdr,slice_rois,pixel_type)) != NO_ERROR)
      return err;
#endif

  TRACE(printf("SetupAllCollectionRec...1\n"));
  analysis = &(text->analysis);
  free_all_collection_rec(analysis);

  text->analysis.total_slices = text->format.num_slices;

  c_free(analysis->text_temp_fn);
  if ((err = cp_str(&(analysis->text_temp_fn),tmpnam(NULL))) != NO_ERROR)
    return err;
     
  sprintf(str,"%d",analysis->total_slices);
  analysis->num_line_label_spaces = strlen(str);
  if (analysis->num_line_label_spaces < FIRST_COL_SPACES)
    analysis->num_line_label_spaces = FIRST_COL_SPACES;

  analysis->cur_collect = analysis->num_collects = 0;

  get_ptr_memory(&(analysis->collects),&(analysis->num_collects),
		 text->format.num_groups,
		 (size_t) sizeof(struct collection_rec),&err);
  if (err)
    return err;

  for (lcv = 0; lcv < analysis->num_collects; lcv++)
    init_collection_rec(&(analysis->collects[lcv]));

  for (cnt = 0; cnt < text->format.num_groups; cnt++)
  {
    if ((err = get_collection(&(analysis->collects[cnt]),
			      &(text->format.groups[cnt]),
			      text->format.groups[cnt].pixel_type_indx,
			      text->format.voxel_size,
			      text->format.counts,
			      text->format.num_slices,cnt)) != NO_ERROR)
    {
      free_all_collection_rec(analysis);
      TRACE(printf("after setup_collection err = %d\n",err));
      return err;
    }
  }

  if ((err = setup_page_rec(text)) != NO_ERROR)
  {
    free_all_collection_rec(analysis);
    return err;
  }
  text->status |= TEXT_OUTPUT_COMPUTED;
  TRACE(printf("SetupAllCollectionRec...END\n"));
  return err;
}


WrPixelTypeTextFileInfo_1(fid,text_printing_time,format,
			  hdr,ndathdr,pixel_type,prog_name,prog_id,
			  hdrdirfn,hdrfn,hdrsuffix,imgsuffix,
			  ndatdir,ndatfn,ndatsuffix)
     FILE *fid;
     char **text_printing_time;
     struct output_text_format_rec *format;
     struct hdr_rec *hdr;
     struct output_hdr_rec *ndathdr;
     struct pixel_type_rec *pixel_type;
     char *prog_name,*prog_id,*hdrdirfn,*hdrfn,*hdrsuffix,*imgsuffix,
       *ndatdir,*ndatfn,*ndatsuffix;
{
  char *str,*fn;
  int err,define;
  unsigned_int lcv;

  if (get_strlen(ndathdr->rater) == 0)
    fprintf(fid,"RATER = UNKNOWN\n");
  else
    fprintf(fid,"RATER = %s\n",ndathdr->rater);
  if (text_printing_time != NULL)
  {
    if (*text_printing_time == NULL)
      *text_printing_time = current_asctime();
    fprintf(fid,"PRINTING DATE : %s",*text_printing_time);
  }
  fprintf(fid,"PROGRAM : %s",prog_name);
  fprintf(fid,"       VERSION : %s\n",prog_id);

  if (pixel_type->slice_map_data_creation_date != NULL)
    fprintf(fid,"PIXEL TYPE CREATION DATE : %s",
	    pixel_type->slice_map_data_creation_date);

  if ((err = build_fn(&str,hdrdirfn,hdrfn,hdrsuffix)) != NO_ERROR)
    return CANCEL;
  if ((err = concat_strs(&fn,3,str,"-",imgsuffix)) != NO_ERROR)
  {
    c_free(str);
    return CANCEL;
  }

  fprintf(fid,"INPUT FILES : 1) %s   VERSION : %s\n",fn,hdr->id);
  c_free(str);
  c_free(fn);

  if ((err = build_fn(&fn,ndatdir,ndatfn,ndatsuffix)) != NO_ERROR)
    return CANCEL;
  fprintf(fid,"              2) %s   VERSION : %s\n",fn,ndathdr->id);
  c_free(fn);

  if ((err = build_fn(&fn,ndatdir,ndatfn,TXT_SUFFIX)) != NO_ERROR)
    return CANCEL;
  fprintf(fid,"OUTPUT FILE : 1) %s\n",fn);
  c_free(fn);

  fprintf(fid,"\n");
  fprintf(fid,"IMAGE INFO.\n");
  fprintf(fid,"   Image dimension size = %d * %d   Pixel size = %-d bits\n",
	  (int) hdr->data_info.dimx,
	  (int) hdr->data_info.dimy,
	  (int) hdr->data_info.pixel_depth_bits);

  fprintf(fid,"   PIXEL SIZE (X,Y) = %-.4fmm,%-.4fmm   THICKNESS = %-.4fmm\n",
	  format->xpixel_size,format->ypixel_size,
	  format->pixel_thickness);
  fprintf(fid,"   VOXEL = %-.4f (Cubic mm)\n",format->voxel_size);
  fprintf(fid,"   Total slice cuts = %d   Total scans = %d\n",
	  NumberOfSliceCuts(&(hdr->data_info)),
	  NumberOfSliceScans(&(hdr->data_info)));
  fprintf(fid,"   Total image slices = %d\n",
	  (int) hdr->data_info.max_scans);

  for (lcv = 0; lcv < hdr->analysis.num_img_labels; lcv++)
    fprintf(fid,"      Image slices of type %s = %d\n",
	    hdr->analysis.img_labels[lcv],format->num_slices);

  fprintf(fid,"\n");
  if (define = IsAllPixelTypeMapReady(pixel_type,hdr))
  {
    if (define == 1)
      fprintf(fid,"WARNING : Pixel types are only defined for some slices.\n");

    if (pixel_type->order.num_strs > 0)
    {
      fprintf(fid,"DEFINED PIXEL TYPES LISTED ACCORDING TO THEIR PRIORITY\n");
      for (lcv = 0; lcv < pixel_type->order.num_strs; lcv++)
	fprintf(fid,"   %-d. %s\n",lcv,pixel_type->order.strs[lcv]);
    }

    if (!(pixel_type->status & HISTO_AND_PIXEL_TYPE_RELATED))
      fprintf(fid,"WARNING : Pixel types are not defined based on the current histogram.\n");
    if (!(pixel_type->status & PIXEL_TYPE_AND_ANALYSIS_RELATED))
      fprintf(fid,"WARNING : Pixel types are not defined based on the current pixel types.\n");
  }
  else
    fprintf(fid,"WARNING : Pixel types are not defined for all slices !!!\n");
  fprintf(fid,"\n");

  return NO_ERROR;
}


wr_pixel_type_text_labels(fid,text)
     FILE *fid;
     struct text_output_rec *text;
{
  char str[25],roi_format[25],pixel_type_format[25],format[256];
  unsigned_int roi_len,pixel_type_len,temp,lcv,cnt,indx;
  static char *roi_label = "ROI NAMES";
  static char *pixel_type_label = "PIXEL TYPE NAMES";
  char is_pr_line;

  sprintf(str,"   [%-d] ",text->format.roi_labels.num_strs - 1);
  roi_len = strlen(str) +
    get_strs_rec_max_some_str_len(&(text->format.roi_labels),
				  text->format.roi_nums);
  if (roi_len < 9)
    roi_len = 9;

  sprintf(str,"   %-d) ",text->format.pixel_type_labels.num_strs - 1);
  pixel_type_len = strlen(str) +
    get_strs_rec_max_some_str_len(&(text->format.pixel_type_labels),
				  text->format.pixel_type_nums);
  if (pixel_type_len < 16)
    pixel_type_len = 16;

  temp = roi_len + pixel_type_len + 1;
  if (temp > text->format.page_row_size)
  {
    fprintf(fid,"%s\n",roi_label);
    for (lcv = 0; lcv < text->format.roi_labels.num_strs; lcv++)
      if (text->format.roi_nums[lcv] > 0)
	fprintf(fid,"   [%-d] %s\n",text->format.roi_nums[lcv],
                text->format.roi_labels.strs[lcv]);

    fprintf(fid,"\n%s\n",pixel_type_label);
    for (lcv = 0; lcv < text->format.pixel_type_labels.num_strs; lcv++)
      if (text->format.pixel_type_nums[lcv] > 0)
	fprintf(fid,"   %-d) %s\n",text->format.pixel_type_nums[lcv],
		text->format.pixel_type_labels.strs[lcv]);
  }
  else
  {
    sprintf(roi_format,"%%-%ds",roi_len);
    sprintf(pixel_type_format,"%%-%ds",pixel_type_len);
    temp = text->format.page_row_size - pixel_type_len - roi_len - 2;
    sprintf(str,"%%-%ds",temp);
    if (text->format.pixel_type_labels.num_strs > 
	text->format.roi_labels.num_strs)
      temp = text->format.pixel_type_labels.num_strs;
    else
      temp = text->format.roi_labels.num_strs;

    fprintf(fid,roi_format,roi_label);
    fprintf(fid,str," ");
    fprintf(fid,pixel_type_format,pixel_type_label);
    fprintf(fid,"\n");

    for (cnt = indx = lcv = 0; lcv < temp; lcv++,cnt++,indx++)
    {
      is_pr_line = 0;
      for (; cnt < text->format.roi_labels.num_strs; cnt++)
	if (text->format.roi_nums[cnt] > 0)
	{
	  is_pr_line = 1;
	  sprintf(format,"   [%-d] %s",text->format.roi_nums[cnt],
		  text->format.roi_labels.strs[cnt]);
	  fprintf(fid,roi_format,format);
	  break;
	}
      for (; indx < text->format.pixel_type_labels.num_strs; indx++)
	if (text->format.pixel_type_nums[indx] > 0)
	{
	  is_pr_line = 1;
	  if (cnt >= text->format.roi_labels.num_strs)
	    fprintf(fid,roi_format," ");
	  sprintf(format,"   %-d) %s",text->format.pixel_type_nums[indx],
		  text->format.pixel_type_labels.strs[indx]);
	  fprintf(fid,str," ");
	  fprintf(fid,pixel_type_format,format);
	  break;
	}
      if (is_pr_line)
	fprintf(fid,"\n");
    }
  }

  fprintf(fid,"\nNOTE : '?' = PIXEL TYPE UNDEFINED       ");
  fprintf(fid,"'*' = ROI NOT DEFINED\n");
  fprintf(fid,  "       '-' = ROI PIXEL COUNT NOT COMPUTED\n");
  fprintf(fid,"\n");

  return NO_ERROR;
}


PrintPixelTypeTextToFile_1(fn,text,hdr,ndathdr,pixel_type,prog_name,prog_id,
			   hdrdirfn,hdrfn,hdrsuffix,imgsuffix,
			   ndatdir,ndatfn,ndatsuffix)
     char *fn;
     struct text_output_rec *text;
     struct hdr_rec *hdr;
     struct output_hdr_rec *ndathdr;
     struct pixel_type_rec *pixel_type;
     char *prog_name,*prog_id,*hdrdirfn,*hdrfn,*hdrsuffix,*imgsuffix,
       *ndatdir,*ndatfn,*ndatsuffix;
{
  FILE *fid;
  struct all_collection_rec *analysis;
  struct page_rec *page;
  unsigned_int lcv,cnt,indx,temp,num_line,total_lines,total_line_chs;
  char first_line_format[30],first_line_str_format[30],
    field_format[30],collect_format[30];
  int err;

  if ((text->analysis.num_pages == 0) ||
      (text->format.roi_labels.num_strs == 0) ||
      (text->format.pixel_type_labels.num_strs == 0) ||
      (text->num_groups == 0))
    return CANCEL;
  TRACE(printf("PrintPixelTypeTextToFile_1...num_pages = %d\n",
	       text->analysis.num_pages));
  if ((fid = fopen(fn,"w")) == NULL)
    return FILE_ACCESS_ERROR;
  text->text_printing_time = NULL;
  if ((err = WrPixelTypeTextFileInfo_1(fid,&(text->text_printing_time),
				       &(text->format), hdr, ndathdr,
				       pixel_type, prog_name, prog_id,
				       hdrdirfn, hdrfn, hdrsuffix, imgsuffix,
				       ndatdir,ndatfn,ndatsuffix))
      != NO_ERROR) 
    return err;
  TRACE(printf("PrintPixelTypeTextToFile_1...1...\n"));

  analysis = &(text->analysis);
  sprintf(first_line_format,"%%%dd",analysis->num_line_label_spaces);
  sprintf(first_line_str_format,"%%%ds",analysis->num_line_label_spaces);
  sprintf(collect_format,"%%%ds",text->format.num_collect_spaces);
  TRACE(printf("PrintPixelTypeTextToFile_1...2...\n"));
  for (lcv = 0; lcv < analysis->num_pages; lcv++)
  {
    page = &(analysis->pages[lcv]);
    if ((err = wr_pixel_type_text_labels(fid,text)) != NO_ERROR)
      return err;
    TRACE(printf("PrintPixelTypeTextToFile_1...3...\n"));

    for (cnt = 0; cnt < page->num_collects; cnt++)
      page->collects[cnt]->cur_indx = 0;
    TRACE(printf("PrintPixelTypeTextToFile_1...4...\n"));

    total_lines = analysis->total_slices + 3;
    for (num_line = 0; num_line < total_lines; num_line++)
    {
      if (num_line == 0)
	fprintf(fid,first_line_str_format,"#");
      else if (num_line == (analysis->total_slices + 1))
	fprintf(fid,first_line_str_format,"PIXELS");
      else if (num_line == (analysis->total_slices + 2))
	fprintf(fid,first_line_str_format,"VOL(cc)");
      else
	fprintf(fid,first_line_format,num_line);
      if (num_line == 0)
	total_line_chs = analysis->num_line_label_spaces +
	  page->num_collects * text->format.num_collect_spaces;

      for (cnt = 0; cnt < page->num_collects; cnt++)
      {
	fprintf(fid,collect_format," ");
	temp = text->format.num_field_spaces +
	  page->collects[cnt]->max_digit_chs;
	sprintf(field_format,"%%%ds",temp);
	if (num_line == 0)
	  total_line_chs += temp * page->collects[cnt]->num_fields;

	for (indx = 0; indx < page->collects[cnt]->num_fields; indx++)
	{
	  temp = page->collects[cnt]->cur_indx + 1;
	  fprintf(fid,field_format,&(page->collects[cnt]->buf[temp]));

	  page->collects[cnt]->cur_indx +=
	    page->collects[cnt]->buf[page->collects[cnt]->cur_indx] + 2;
	}
      }

      fprintf(fid,"\n");
      if ((num_line == analysis->total_slices) || (num_line == 0))
      {
	for (indx = 0; indx < total_line_chs; indx++)
	  fprintf(fid,"-");
	fprintf(fid,"\n");
      }
    }
    fprintf(fid,"%c",(char) 12);
    if ((lcv + 1) != analysis->num_pages)
      fprintf(fid,"\n");
  }
  fclose(fid);
  text->status |= TEXT_OUTPUT_TO_FILE;
  TRACE(printf("PrintPixelTypeTextToFile_1...10...\n"));
  return NO_ERROR;
}


PrintPixelTypeTextToTempFile(text,hdr,slice_rois,pixel_type,
			     ndathdr,prog_name,prog_id,
			     hdrdirfn,hdrfn,hdrsuffix,imgsuffix,
			     ndatdir,ndatfn,ndatsuffix)
     struct text_output_rec *text;
     struct hdr_rec *hdr;
     struct slice_roi_rec *slice_rois;
     struct pixel_type_rec *pixel_type;
     struct output_hdr_rec *ndathdr;
     char *prog_name,*prog_id,*hdrdirfn,*hdrfn,*hdrsuffix,*imgsuffix,
       *ndatdir,*ndatfn,*ndatsuffix;
{
  int err;

  TRACE(printf("PrintPixelTypeTextToTempFile...1\n"));
  if (text->status & TEXT_OUTPUT_TO_TEMP_FILE)
  {
    delete_file(text->analysis.text_temp_fn);
    text->status &= ~TEXT_OUTPUT_TO_TEMP_FILE;
  }
  if (!(text->status & TEXT_OUTPUT_COMPUTED))
  {
    err = SetupAllCollectionRec(text,hdr,slice_rois,pixel_type);
    if (err)
      return err;
  }
  TRACE(printf("PrintPixelTypeTextToTempFile...2\n"));
  if (text->status & TEXT_OUTPUT_COMPUTED)
  {
    if ((err = PrintPixelTypeTextToFile_1(text->analysis.text_temp_fn,text,
					  hdr,ndathdr,pixel_type,
					  prog_name,prog_id,
					  hdrdirfn,hdrfn,hdrsuffix,imgsuffix,
					  ndatdir,ndatfn,ndatsuffix))
	== NO_ERROR)
      text->status |= TEXT_OUTPUT_TO_TEMP_FILE;
  }
  else
    return CANCEL;
  TRACE(printf("PrintPixelTypeTextToTempFile...err = %d\n",err));
  return err;
}


SavePixelTypeTextToFile(fn,text,hdr,slice_rois,pixel_type,
			ndathdr,prog_name,prog_id,
			hdrdirfn,hdrfn,hdrsuffix,imgsuffix,
			ndatdir,ndatfn,ndatsuffix)
     char *fn;
     struct text_output_rec *text;
     struct hdr_rec *hdr;
     struct slice_roi_rec *slice_rois;
     struct pixel_type_rec *pixel_type;
     char *prog_name,*prog_id,*hdrdirfn,*hdrfn,*hdrsuffix,*imgsuffix,
       *ndatdir,*ndatfn,*ndatsuffix;
{
  int err;

  TRACE(printf("SavePixelTypeTextToFile = %s\n",fn));
  if (!(text->status & TEXT_OUTPUT_COMPUTED))
  {
    err = SetupAllCollectionRec(text,hdr,slice_rois,pixel_type);
    if (err)
      return err;
  }
  if (text->status & TEXT_OUTPUT_COMPUTED)
    err = PrintPixelTypeTextToFile_1(fn,text,
				     hdr,ndathdr,pixel_type,prog_name,prog_id,
				     hdrdirfn,hdrfn,hdrsuffix,imgsuffix,
				     ndatdir,ndatfn,ndatsuffix);
  else
    return CANCEL;
  return err;
}



#if 0

/*************************************************************************
 *  The following routines (until the EOF) were commented out by Teong.
 *************************************************************************/

flush_the_text_output(text)
 struct text_output_rec *text;
{
 text->status &= FLUSH_TEXT_OUTPUT_STATUS;
}

is_text_output(text)
 struct text_output_rec *text;
{
 if (!(text->status & TEXT_OUTPUT_PARAMS_SETUP))
    {TRACE(printf("TEXT_OUTPUT_PARAMS_SETUP not exist...\n"))
     return 0;}
   else if (!(text->status & TEXT_OUTPUT_FORMAT_SETUP))
    {TRACE(printf("TEXT_OUTPUT_FORMAT_SETUP not exist...\n"))
     return 0;}
   else if (text->status & TEXT_OUTPUT_IN_PROGRESS)
    {TRACE(printf("TEXT_OUTPUT_IN_PROGRESS...\n"))
     return 0;}
   else if (!(text->status & TEXT_OUTPUT_COMPUTED))
    {TRACE(printf("TEXT_OUTPUT_COMPUTED hasn't been computed yet...\n"))
     return 0;}
 return 1;
}



store_in_collection_rec_buf(buf,total_buf_size,buf_size,str,str_len)
     char **buf;
     char *str;
     unsigned_int *total_buf_size,*buf_size,str_len;
{
  unsigned_int temp;
  int err;

  temp = *buf_size + str_len + 2;
  TRACE(printf("store_in_collection_rec_buf:temp = %d *total_buf_size = %d\n",
	       temp, *total_buf_size));
  if (temp >= *total_buf_size)
  {
    get_ptr_memory(buf,&(*total_buf_size),
		   (unsigned_int) 512,(size_t) sizeof(char),&err); 
    if (err)
    {
      TRACE(printf("store_in_collection_rec_buf...err = %d\n",err));
      return err;
    }
  }
  TRACE(printf("temp = %d *total_buf_size = %d\n",temp,*total_buf_size));
  (*buf)[(*buf_size)++] = str_len;
  memcpy(&((*buf)[*buf_size]),str,(size_t) str_len);
  (*buf)[(*buf_size)+str_len] = '\0';
  *buf_size = temp;

  return NO_ERROR;
}




/*
 format...
  1) max_digit_chs
  2) num_fields
  3) num_digit_chs
  4) digit chs
     3) & 4) are as follow :
       --- a) the first line is the field titles...
           b) repeated by "num_fields" * "num_slices" times where the pixel
              count of each pixel type for each roi is represented.
           c) following b) is the total pixel count of each pixel type for 
              each roi.
           d) and the last line is the total voxel value of each pixel type for
              each roi.
*/


get_collection(collection,group,
                pixel_type,voxel,counts,num_slices,group_indx)
 struct collection_rec *collection;
 struct output_field_rec *group;
 unsigned_int pixel_type;
 float voxel;
 struct output_count_group_rec *counts;
 unsigned_int num_slices,group_indx;
{
 unsigned_int cnt,lcv,size,temp,*total_pixels,num_fields,row_total,cnt_field,
                cnt_defined;
 char str[30];
 int err,is_pixel_type_undefined;
 struct roi_rec *roi;
 struct pixel_type_cnt_rec *ptr;

 if (pixel_type == 0) return NO_ERROR;
 pixel_type -= 1;

 collection->num_fields = group->num_roi_indxs;
 collection->num_slices = num_slices;

 TRACE(printf("\n\nget_collection..num_roi_indxs = %d num_fields = %d\n",
         group->num_roi_indxs,collection->num_fields))
 TRACE(printf("group_indx = %d counts[0].groups[group_indx].num_fields = %d\n",group_indx,counts[0].groups[group_indx].num_fields))

 collection->max_digit_chs = 0;
 for (num_fields = 0,lcv = 0; lcv < collection->num_fields; lcv++)
    {
     if (group->roi_indxs[lcv] > 0)
        {
         sprintf(str,"%-d/[%d]",pixel_type + 1,group->roi_indxs[lcv]);
         size = (unsigned_int) strlen(str);
         if ((err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,
                 size))!= NO_ERROR)
            return err;
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
         num_fields += 1;
        }
    }
 TRACE(printf("get_collection.&&&&&.num_roi_indxs = %d\n",
         group->num_roi_indxs))

 if (num_fields > 1)
    {num_fields += 1;
     if ((err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),"TOTAL",
                  (unsigned_int) 5)) != NO_ERROR)
        return err;
     if (5 > collection->max_digit_chs) collection->max_digit_chs = size;
    }
 TRACE(printf("get_collection..num_fields = %d max_digit_chs = %d\n",num_fields,
           collection->max_digit_chs))
 if (num_fields == 0) return NO_ERROR;
 temp = 0;
 get_ptr_memory(&total_pixels,&temp,(unsigned_int) num_fields,
      (size_t) sizeof(unsigned_int),&err);
 if (err) return err;
 for (lcv = 0; lcv < num_fields; lcv++) total_pixels[lcv] = 0;
     
 TRACE(printf("setup_collection..group_indx = %d\n",group_indx))
 for (cnt = 0; cnt < collection->num_slices; cnt++)
    {cnt_defined = cnt_field = row_total = 0;
     is_pixel_type_undefined = 0;
     for (lcv = 0; lcv < collection->num_fields; lcv++)
        {if (group->roi_indxs[lcv] == 0) continue;

         if (counts[cnt].groups[group_indx].fields[lcv].valid &
                        COUNT_PIXEL_TYPE_NOT_DEFINED)
            {is_pixel_type_undefined = 1;
             sprintf(str,"?");}
           else if (counts[cnt].groups[group_indx].fields[lcv].valid &
                        COUNT_ROI_DEFINED)
            {if (counts[cnt].groups[group_indx].fields[lcv].valid &
                        COUNT_ROI_NOT_COMPUTED)
                sprintf(str,"-");
               else 
               {cnt_defined += 1;
                sprintf(str,"%-d",
                   counts[cnt].groups[group_indx].fields[lcv].value);

                total_pixels[lcv] += 
                    counts[cnt].groups[group_indx].fields[lcv].value;
                if (num_fields > 1)
                   row_total +=
                     counts[cnt].groups[group_indx].fields[lcv].value;
                cnt_field += 1;
               }
            }
           else sprintf(str,"*");
         size = (unsigned_int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }
     if (num_fields > 1)
        {if (cnt_defined == 0)
            {if (is_pixel_type_undefined) sprintf(str,"?");
               else sprintf(str,"*");
            }
           else if (cnt_field == 0) sprintf(str,"-");
           else sprintf(str,"%-d",row_total);
         total_pixels[num_fields - 1] += row_total;
         size = (unsigned_int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }
    }

 TRACE(printf("setup_collection..3 max = %d\n",collection->max_digit_chs))
 for (lcv = 0; lcv < collection->num_fields; lcv++)
    {
     if (group->roi_indxs[lcv] > 0)
        {sprintf(str,"%-d",total_pixels[lcv]);
         size = (unsigned_int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }

    }
 if (num_fields > 1)
    {sprintf(str,"%-d",total_pixels[num_fields - 1]);
     size = (unsigned_int) strlen(str);
     err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
     if (size > collection->max_digit_chs)
        collection->max_digit_chs = size;
     if (err != NO_ERROR)
        {c_free(total_pixels);
         return err;}
    }

 TRACE(printf("setup_collection..4 max = %d\n",collection->max_digit_chs))
 for (lcv = 0; lcv < collection->num_fields; lcv++)
    {if (group->roi_indxs[lcv] > 0)
        {sprintf(str,"%-.2f",(float) (total_pixels[lcv] * voxel / 1000.0));
         size = (unsigned_int) strlen(str);
         err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
         if (err != NO_ERROR)
            {c_free(total_pixels);
             return err;}
         if (size > collection->max_digit_chs)
            collection->max_digit_chs = size;
        }
    }
 if (num_fields > 1)
    {sprintf(str,"%-.2f",total_pixels[num_fields - 1] * voxel / 1000.0);
     size = (unsigned_int) strlen(str);
     err = store_in_collection_rec_buf(&(collection->buf),
               &(collection->total_buf_size),&(collection->buf_size),str,size);
     if (err != NO_ERROR)
        {c_free(total_pixels);
         return err;}
     if (size > collection->max_digit_chs)
        collection->max_digit_chs = size;
    }

 collection->num_fields = num_fields;
 TRACE(printf("setup_collection..end num_fields = %d max = %d\n",collection->num_fields,collection->max_digit_chs))
 c_free(total_pixels);
 return NO_ERROR;
}

setup_page_rec(text)
 struct text_output_rec *text;
{
 struct all_collection_rec *analysis;
 unsigned_int row_size,temp,cnt,lcv,indx;
 struct page_rec *page;
 int err;

 analysis = &(text->analysis);
 TRACE(printf("\n\nsetup_page_rec...begin analysis->num_collects = %d\n",
            analysis->num_collects))
 for (lcv = 0; lcv < analysis->num_collects; lcv = cnt)
    {row_size = analysis->num_line_label_spaces;
     for (cnt = lcv; cnt < analysis->num_collects; )
        {temp = row_size + text->format.num_collect_spaces +
                (text->format.num_field_spaces +
                  analysis->collects[cnt].max_digit_chs) *
                            analysis->collects[cnt].num_fields;
         if (temp >= text->format.page_row_size) break;
         cnt++;
         row_size = temp;
        }
     if (cnt == lcv) cnt++;
     get_ptr_memory(&(analysis->pages),&(analysis->num_pages),(unsigned_int) 1,
          (size_t) sizeof(struct page_rec),&err);
     if (err) return err;
     page = &(analysis->pages[analysis->num_pages - 1]);
     init_page_rec(page);
     temp = cnt - lcv;
     get_ptr_memory(&(page->collects),&(page->num_collects),(unsigned_int) temp,
          (size_t) sizeof(struct collection_rec *),&err);
     if (err) return err;
     for (temp = 0,indx = lcv; indx < cnt; indx++,temp++)
        page->collects[temp] = &(analysis->collects[indx]);
    }
 TRACE(printf("setup_page_rec...end\n"))
 return NO_ERROR;
}



SetupPixelTypeOutput(format,hdr,slice_rois,pixel_type)
 struct output_text_format_rec *format;
 struct hdr_rec *hdr;
 struct slice_roi_rec *slice_rois;
 struct pixel_type_rec *pixel_type;
{
 char *str,*str1;
 long slnum,gnum,fnum,lcv,cnt;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 char *label;
 struct output_count_field_rec *group;
 struct pixel_type_cnt_rec *ptr;
 unsigned long roi_indx,pixel_type_indx,type_indx;
 int err,found;

 TRACE(printf("SetupPixelTypeOutput...num_slices = %d counts = %u\n",
             format->num_slices,format->counts))
 TRACE(pr_strs_rec(&(format->roi_labels)))
 TRACE(pr_strs_rec(&(format->pixel_type_labels)))
 TRACE(pr_strs_rec(&(pixel_type->order)))
 for (slnum = 0; slnum < format->num_slices; slnum++)
    {slice_roi = &(slice_rois[slnum]);
     TRACE(printf("...slnum = %d\n",slnum))

     for (gnum = 0; gnum < format->counts[slnum].num_groups; gnum++)
        {group = &(format->counts[slnum].groups[gnum]);
         for (fnum = 0; fnum < group->num_fields; fnum++)
            group->fields[fnum].valid = 0;
        }
     for (lcv = 0; lcv < format->roi_labels.num_strs; lcv++)
        {
         TRACE(printf(" label = %s ",format->roi_labels.strs[lcv]))
         if ((roi = get_roi(slice_roi,format->roi_labels.strs[lcv])) != NULL)
            {
             ptr = (struct pixel_type_cnt_rec *) roi->user.ptr;
            }
           else ptr = NULL;
         roi_indx = format->roi_nums[lcv];
         TRACE(printf("  ptr = %u  roi = %u roi_indx = %d\n",ptr,roi,roi_indx))
         for (gnum = 0; gnum < format->counts[slnum].num_groups; gnum++)
            {
             group = &(format->counts[slnum].groups[gnum]);
             if (pixel_type_indx = format->groups[gnum].pixel_type_indx)
                {TRACE(printf("   pixel_type_indx = %d type = %s ",pixel_type_indx,
                         format->pixel_type_labels.strs[pixel_type_indx-1]))
                 str1 = format->pixel_type_labels.strs[pixel_type_indx-1];
                 if ((found = find_str_in_strs_rec(&(pixel_type->order),
                        str1,&type_indx)) != NO_ERROR)
                    {if ((err = concat_strs(&str,2,str1,".TYPE")) != NO_ERROR)
                        {TRACE(printf("\n"))
                         return err;}
                 
                     found = find_str_in_strs_rec(&(pixel_type->order),
                           str,&type_indx);
                     c_free(str);
                    }
                 if (found != NO_ERROR)
                    {
                     TRACE(printf("\n"))
                     for (fnum = 0; fnum < group->num_fields; fnum++)
                            group->fields[fnum].valid |= COUNT_PIXEL_TYPE_NOT_DEFINED; 
                     continue;}
                }
               else
                {for (fnum = 0; fnum < group->num_fields; fnum++)
                    group->fields[fnum].valid |= COUNT_PIXEL_TYPE_NOT_DEFINED;
                 continue;}

             for (fnum = 0; fnum < group->num_fields; fnum++)
                {
                 if (roi_indx != format->groups[gnum].roi_indxs[fnum]) continue;
                 if (roi == NULL) continue;

                 group->fields[fnum].valid = COUNT_ROI_DEFINED;
                 if ((ptr == NULL) ||
                     !(ptr->status & PIXEL_TYPE_CNTS_COMPUTED))
                    group->fields[fnum].valid |= COUNT_ROI_NOT_COMPUTED;
                   else
                    {
                     group->fields[fnum].value = 
                                    ptr->pixel_type_cnts[type_indx+1];

                     TRACE(printf("gnum = %d fnum = %d type = %d type_indx = %d val = %d",
                               gnum,fnum,pixel_type_indx,type_indx+1,
                               group->fields[fnum].value))
                 
                     }
                  TRACE(printf("\n"))
                 }
            }
         }
     }
 format->status |= OUT_FORMAT_COUNT_DEFINED;
 TRACE(printf("SetupPixelTypeOutput...end\n"))
 return NO_ERROR;
}
#endif
