#include "mri_format.h"
/*
cc -c v3_output_opr.c
*/
/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)

/*
init_default_output_hdr_info_rec(info,file)
init_output_file_rec(output,file)

setup_output_fn(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix)
change_output_fn(output,output_fn,bin_fn_suffix)

rd_dat_slice_rois(output,is_rd_all,slice_num)
rd_dat_output(output)
setup_output_file(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix)

close_output_file_rec(output)

get_output_fn(output,fn)
wr_dat_file(fn,output)
WrDatOutput(output,is_quit_file)
check_file_save(output)
flush_output_save_status(output)
AutoSaveDatOutput(output,is_quit_file)
set_dat_file_changed(file)
set_dat_file_saved(file,is_save)
wr_file_dat_output(file)

save_pixel_types_1(file)
save_pixel_types(file,frame,is_dp_msg)
*/
char *UniqueFn();

init_default_output_hdr_info_rec(info,file)
 struct output_hdr_info_rec *info;
 struct input_file_rec *file;
{
 int err;

 if (((err = cp_str(&(info->dirfn),file->dirfn)) != NO_ERROR) ||
     ((err = cp_str(&(info->fn),file->fn)) != NO_ERROR) ||
     ((err = cp_str(&(info->hdr_fn_suffix),file->hdr_fn_suffix)) != NO_ERROR) ||
     ((err = cp_str(&(info->img_fn_suffix),file->img_fn_suffix)) != NO_ERROR))
    {free_output_hdr_info_rec(info);
     return err;}
 TRACE(printf("info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,info->hdr_fn_suffix,
    info->img_fn_suffix))

 info->dimx = file->hdr.data_info.dimx;
 info->dimy = file->hdr.data_info.dimy;
 info->max_slices = file->hdr.data_info.max_scans;
 info->pixel_depth_bits = file->hdr.data_info.pixel_depth_bits;
 info->status |= OUTPUT_HDR_INFO_REC_SETUP;
 return NO_ERROR;
}

init_output_file_rec(output,file)
 struct output_file_rec *output;
 struct input_file_rec *file;
{
 output->file = file;
 output->status = FILE_TO_BE_SETUP;
 output->dirfn = NULL;
 output->fn = NULL;
 output->dat_fn_suffix = NULL;
 output->bin_fn_suffix = NULL;
 init_output_hdr_rec(&(output->hdr));
}

setup_output_fn(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix)
 struct output_file_rec *output;
 char *dirfn,*fn;         /* directory fn & fn */
 char *dat_fn_suffix,*bin_fn_suffix;
{
 int err;

 if (((err = str_dealloc_and_cpy(&(output->dirfn),dirfn)) != NO_ERROR) ||
     ((err = str_dealloc_and_cpy(&(output->fn),fn)) != NO_ERROR) ||
     ((err = str_dealloc_and_cpy(&(output->dat_fn_suffix),dat_fn_suffix)) 
            != NO_ERROR))
    err = str_dealloc_and_cpy(&(output->bin_fn_suffix),bin_fn_suffix);
 return err;
}

change_output_fn(output,output_fn,bin_fn_suffix)
 struct output_file_rec *output;
 char *output_fn,*bin_fn_suffix;
{
 char *dirfn,*fn,*suffix;
 int err;

 if ((err = break_fn(output_fn,&dirfn,&fn,&suffix)) != NO_ERROR)
    return err;
 return setup_output_fn(output,dirfn,fn,suffix,bin_fn_suffix);

}

rd_dat_slice_rois(output,is_rd_all,slice_num)
 struct output_file_rec *output;
 int is_rd_all;
 long slice_num;
{
 char *fn;
 int err;

 TRACE(printf("rd_dat_slice_rois...\n"))
 if (output->fn == NULL)
    {TRACE(printf("No output fn supplied...\n"))
     return FILE_NAME_ERROR;}
 if ((err = get_output_fn(output,&fn)) != NO_ERROR)
    return err;
 if (is_rd_all)
    err = rd_dat_file_slice_rois(fn,output->file);
   else err = rd_file_slice_roi_rec(fn,output->file,slice_num);

 c_free(fn);
 TRACE(printf("rd_dat_slice_rois...end err = %d\n",err))
 return err;
}

rd_dat_output(output)
 struct output_file_rec *output;
{
 char *fn;
 int err;

 if (output->fn == NULL)
    {TRACE(printf("No output fn supplied...\n"))
     return FILE_NAME_ERROR;}
 PRT(printf("rd_dat_output...output->dirfn = %s output->fn = %s output->dat_fn_suffix = %s\n",output->dirfn,output->fn,output->dat_fn_suffix))

 if ((err = get_output_fn(output,&fn)) != NO_ERROR)
    return err;
 PRT(printf("rd_dat_output...1 err = %d\n",err))
 if ((err = rd_dat_file(fn,output)) == NO_ERROR)
    {flush_the_text_output(&(output->file->text));
     output->status = FILE_READY;}
 c_free(fn);
 PRT(printf("rd_dat_output...end err = %d\n",err))
 return err;
}

setup_output_file(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix)
 struct output_file_rec *output;
 char *dirfn,*fn;         /* directory fn & fn */
 char *dat_fn_suffix,*bin_fn_suffix;
{
 int err;

 if ((err = setup_output_fn(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix))
           != NO_ERROR)
    return err;
 output->status &= ~FILE_TO_BE_SETUP;
 TRACE(printf("setup_output_file.....END\n"))
 err = rd_dat_output(output);
 return err;
}

close_output_file_rec(output)
 struct output_file_rec *output;
{
 TRACE(printf("close_output_file_rec output->dirfn = %s %s %s %s\n",output->dirfn,
     output->fn,output->dat_fn_suffix,output->bin_fn_suffix))
 c_free(output->dirfn);
 c_free(output->fn);
 c_free(output->dat_fn_suffix);
 c_free(output->bin_fn_suffix);
 TRACE(printf("before free_output_hdr_rec\n"))
 free_output_hdr_rec(&(output->hdr));
 TRACE(printf("after free_output_hdr_rec\n"))
 init_output_file_rec(output,output->file);
 TRACE(printf("close_output_file_rec...done\n"))

}

get_output_fn(output,fn)
 struct output_file_rec *output;
 char **fn;
{
 int err;

 return build_fn(fn,output->dirfn,output->fn,output->dat_fn_suffix);
}

wr_dat_file(fn,output)
 char *fn;
 struct output_file_rec *output;
{
 struct output_hdr_rec *hdr;
 struct slice_num_and_roi_rec *slices;
 unsigned long num_slices,lcv,num_sroi_wins;
 int err;
 struct slice_roi_win_rec **sroi_wins;
     
 sroi_wins = output->file->slice_info.sroi_wins;
 num_sroi_wins = output->file->slice_info.num_sroi_wins;
 for (num_slices = 0,lcv = 0; lcv < num_sroi_wins; lcv++)
    if (is_slice_roi_non_empty(&(sroi_wins[lcv]->slice_roi)))
       num_slices += 1;
 if (num_slices == 0)
    slices = NULL;
   else
    {lcv = 0;
     if ((err = get_ptr(&slices,&lcv,num_slices,sizeof(*slices))) != NO_ERROR)
        return err;
     for (num_slices = 0,lcv = 0; lcv < num_sroi_wins; lcv++)
        if (is_slice_roi_non_empty(&(sroi_wins[lcv]->slice_roi)))
           {slices[num_slices].slice_num = lcv;
            TRACE(printf("%d) sroi_win = %u\n",lcv,sroi_wins[lcv]);)
            slices[num_slices++].slice_roi = &(sroi_wins[lcv]->slice_roi);}
    }
 TRACE(printf("wr_dat_file...1\n");)
 hdr = &(output->hdr);
 if (output->file->prog != NULL)
    str_dealloc_and_cpy(&(hdr->rater),
            output->file->prog->defaults.whch.rater);
 if (!(hdr->info.status & OUTPUT_HDR_INFO_REC_SETUP))
    err = init_default_output_hdr_info_rec(&(hdr->info),
                    output->file);
   else err = NO_ERROR;
 TRACE(printf("wr_dat_file...2\n");)
 if (err == NO_ERROR)
    err = wr_ria_dat_file(fn,hdr,slices,num_slices,
         output->file->slice_info.num_sroi_wins,
         &(output->file->histo_params),
         &(output->file->pixel_type),&(output->file->text),
         &(output->file->count));
 TRACE(printf("wr_dat_file...1\n");)
 c_free(slices);

 return err;
}


/*
WrDatOutput(output)
 struct output_file_rec *output;
{
 char *fn;
 int err;

 TRACE(printf("WrDatOutput...output->status = %x\n",(int) output->status))

 if ((err = get_output_fn(output,&fn)) == NO_ERROR)
    {if ((err = wr_dat_file(fn,output)) == NO_ERROR)
          output->status |= FILE_READY;
    }
   else
    {TRACE(printf("No output fn supplied...\n"))
     c_free(fn);
     return err;}

 c_free(fn);
 TRACE(printf("WrDatOutput...end err = %d\n",err))

 return err;
}
*/
WrDatOutput(output,is_quit_file)
 struct output_file_rec *output;
 int is_quit_file;
{
 char *fn,*fn1,*str,*reason;
 int err,err1;
 Frame *frame;
 int result;
 static char *discard = "DISCARD EDIT AND IGNORE SAVE THEN !";

 PRT1(printf("WrDatOutput...status = %x is_quit_file = %d\n",
        (int) output->status,is_quit_file))
 fn = fn1 = NULL;
 if (((err = get_output_fn(output,&fn)) == NO_ERROR) &&
     ((fn1 = UniqueFn("",fn,".temp")) != NULL))
    {
     if ((err = file_access(fn,2,NULL,&reason)) != NO_ERROR)
         str = "Error writing to the .ndat file !!!";
       else if ((err = file_access(fn1,2,NULL,&reason)) != NO_ERROR)
         str = "Error writing to the temp .ndat file !!!";
     err1 = err;
     if (err != NO_ERROR)
        {if ((is_quit_file != 2) &&
             (frame = (Frame *) main_display(2,NULL)) && (*frame != NULL))
            {if (is_quit_file)
                {result = notice_prompt(*frame,(Event *) NULL,
                        NOTICE_MESSAGE_STRINGS,str,reason,0,
                        NOTICE_BUTTON_YES,OPERATION_ABORTED,
                        NOTICE_BUTTON_NO,discard,0);
                 if (result == NOTICE_NO) err = NO_ERROR;}
               else notice_prompt(*frame,(Event *) NULL,
                        NOTICE_MESSAGE_STRINGS,str,reason,0,
                        NOTICE_BUTTON_YES,OPERATION_ABORTED,
                        0);
            }
          c_free(reason);
         }
     if ((err == NO_ERROR) && (err1 == NO_ERROR))
        if ((err = wr_dat_file(fn1,output)) == NO_ERROR)
           {if (rename(fn1,fn) != 0)
               {err = FILE_ACCESS_ERROR;
                if ((is_quit_file != 2) &&
                    (frame = (Frame *) main_display(2,NULL)) && (*frame != NULL))
                   {concat_strs(&str,2,"Temp file = ",fn);
                    result = notice_prompt(*frame,(Event *) NULL,
                        NOTICE_MESSAGE_STRINGS,
                        "Error : was able to save to a temp file",
                        str,"but failed to rename it to",fn,
                        "You may rename it yourself later...",0,
                        NOTICE_BUTTON_YES,"DELETE TEMP FILE !",
                        NOTICE_BUTTON_NO,"WILL RENAME LATER !",
                        0);
                    if (result == NOTICE_YES) delete_file(fn1);
                   }
               }
           }
          else
           {delete_file(fn1);
            if ((is_quit_file != 2) &&
                (frame = (Frame *) main_display(2,NULL)) && (*frame != NULL))
               {if (is_quit_file)
                   {result = notice_prompt(*frame,(Event *) NULL,
                     NOTICE_MESSAGE_STRINGS,
                     "Write Error : unable to save to the .ndat file =",fn,0,
                      NOTICE_BUTTON_YES,OPERATION_ABORTED,
                      NOTICE_BUTTON_NO,discard,0);
                    if (result == NOTICE_NO) err = NO_ERROR;}
                  else
                   notice_prompt(*frame,(Event *) NULL,
                     NOTICE_MESSAGE_STRINGS,
                     "Write Error : unable to save to the .ndat file =",fn,0,
                      NOTICE_BUTTON_YES,OPERATION_ABORTED,0);
               }
           }
    }
   else
    {TRACE(printf("No output fn supplied...\n"))
     if (err == NO_ERROR) err = CANCEL;
     if ((is_quit_file != 2) &&
         (frame = (Frame *) main_display(2,NULL)) && (*frame != NULL))
        {result = notice_prompt(*frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,
               "Error : Unable to construct the output file name !!!",
               "Memory error !!!",
               0,
            NOTICE_BUTTON_YES,OPERATION_ABORTED,
            NOTICE_BUTTON_NO,discard,
            0);
         if (result == NOTICE_NO) err = NO_ERROR;
        }
    }

 c_free(fn);
 c_free(fn1);
 TRACE(printf("WrDatOutput...end err = %d\n",err))

 return err;
}

check_file_save(output)
 struct output_file_rec *output;
{
 unsigned_int lcv;
 struct slice_roi_win_rec *slice_roi_win;
 struct slice_roi_rec *slice_roi;

 for (lcv = 0; lcv < output->file->hdr.num_scans; lcv++)
    {slice_roi = &(output->file->hdr.scans[lcv].slice->slice_roi_win->slice_roi);
     if (slice_roi->status & SLICE_ROI_MUST_SAVE)
        {
         output->status |= FILE_CHANGED;
         return NO_ERROR;}
    }
 if ((output->file->histo_params.slice_roi_win_1d.slice_roi.status &
              SLICE_ROI_MUST_SAVE) ||
     (output->file->histo_params.slice_roi_win_2d.slice_roi.status &
              SLICE_ROI_MUST_SAVE))
    {
     output->status |= FILE_CHANGED;}
 return NO_ERROR;
}

flush_output_save_status(output)
 struct output_file_rec *output;
{
 unsigned_int lcv;
 struct slice_roi_win_rec *slice_roi_win;

 for (lcv = 0; lcv < output->file->hdr.num_scans; lcv++)
    output->file->hdr.scans[lcv].slice->slice_roi_win->slice_roi.status &=
           ~SLICE_ROI_MUST_SAVE;
 output->file->histo_params.slice_roi_win_1d.slice_roi.status
                  &= ~SLICE_ROI_MUST_SAVE;
 output->file->histo_params.slice_roi_win_2d.slice_roi.status
                  &= ~SLICE_ROI_MUST_SAVE;
 slice_roi_win->slice_roi.status &= ~SLICE_ROI_MUST_SAVE;
 output->status &= ~FILE_TO_BE_SAVED;
 output->status &= ~FILE_CHANGED;
}

AutoSaveDatOutput(output,is_quit_file)
 struct output_file_rec *output;
 int is_quit_file;
{
 int err;

 if (!((output->status & FILE_TO_BE_SAVED) && (output->status & FILE_CHANGED)))
    check_file_save(output);
 TRACE(printf("AutoSaveDatOutput status = %x\n",(unsigned long) output->status))
 if ((output->status & FILE_TO_BE_SAVED) || (output->status & FILE_CHANGED))
    {
     if ((err = WrDatOutput(output,is_quit_file)) == NO_ERROR)
        {flush_output_save_status(output);         
        }
     TRACE(printf("AutoSaveDatOutput....end...err = %d\n",err))
     return err;
    }

 return NO_ERROR;
}

set_dat_file_changed(file)
 struct input_file_rec *file;
{
 file->output.status |= FILE_CHANGED;
}

set_dat_file_saved(file,is_save)
 struct input_file_rec *file;
 int is_save;
{
 if (is_save)
    file->output.status |= FILE_TO_BE_SAVED;
   else file->output.status &= ~FILE_TO_BE_SAVED;
}
/*
wr_file_dat_output(file,is_quit_file)
 struct input_file_rec *file;
 int is_quit_file;
{
 int err;
 char *fn,*reason;
 Frame *frame;

 if (file == NULL) return CANCEL;
 get_output_fn(&(file->output),&fn);
 if ((err = file_access(fn,2,NULL,&reason)) != NO_ERROR)
    {
     frame = (Frame *) main_display(2,NULL);
     ShowMsgStrs(*frame,0,err,0,2,
               "Error writing to the .dat file !!!",
               reason,NULL,0);
    }
   else if ((err = AutoSaveDatOutput(&(file->output),is_quit_file)) != NO_ERROR)
    {
     frame = (Frame *) main_display(2,NULL);
     ShowMsgStrs(*frame,0,err,0,2,
               "Error writing to the .dat file !!!",
               fn,NULL,0);
    }
 c_free(fn);
 c_free(reason);
 return err;

}
*/

save_pixel_types_1(file)
 struct input_file_rec *file;
{
 int err;
 char *err_reason;
 Frame *frame;

 if (!(file->pixel_type.status & PIXEL_TYPE_PIXMAP_HDR_VALID))
    err = wr_file_pixmap(file->output.dirfn,file->output.fn,
              PIXMAP_SUFFIX,&(file->pixel_type),&err_reason);
   else err = append_wr_file_pixmap(file->output.dirfn,file->output.fn,
              PIXMAP_SUFFIX,&(file->pixel_type),
              file->hdr.data_info.dimx,file->hdr.data_info.dimy,&err_reason);
 if (err != NO_ERROR)
    {
     frame = (Frame *) main_display(2,NULL);
     if (*frame != NULL)
        if (err_reason != NULL)
           notice_prompt(*frame,(Event *) NULL,NOTICE_MESSAGE_STRINGS,
               "Error saving the pixmap file !!!",err_reason,0,
               NOTICE_BUTTON_YES,OPERATION_ABORTED,0);
          else notice_prompt(*frame,(Event *) NULL,NOTICE_MESSAGE_STRINGS,
               "Error saving the pixmap file !!!",0,
               NOTICE_BUTTON_YES,OPERATION_ABORTED,0);
     c_free(err_reason);
    }
   else file->status &= ~FILE_SAVE_PIXEL_TYPE;
 return err;
}

save_pixel_types(file,frame,is_dp_msg)
 struct input_file_rec *file;
 Frame frame;
 int is_dp_msg;
{
 unsigned long lcv;
 Frame *the_frame,win_frame;

 if (!(file->status & FILE_SAVE_PIXEL_TYPE)) return NO_ERROR;
 if ((file->pixel_type.order.num_strs == 0) || 
     (file->pixel_type.num_slice_maps == 0))
    return NO_ERROR;

 for (lcv = 0; lcv < file->pixel_type.num_slice_maps; lcv++)
    if ((file->pixel_type.slice_maps[lcv]->status4 & BUF_NON_EMPTY) &&
        (file->pixel_type.slice_maps[lcv]->status4 & BUF_DATA_VALID))
       break;
 if (lcv == file->pixel_type.num_slice_maps) return NO_ERROR;
 if (is_dp_msg)
    {if (frame == NULL)
        {the_frame = (Frame *) main_display(2,NULL);
         win_frame = *the_frame;}
       else win_frame = frame;
     if (win_frame != NULL)
        {ShowMsgStrs(win_frame,1,NO_ERROR,0,2,
               "1) Saving the pixmap file...",
               PLEASE_WAIT,save_pixel_types_1,1,file);
         return NO_ERROR;}
       else return CANCEL;
    }
   else return save_pixel_types_1(file);
}

