#include "mri_format.h"
/*
cc -c v3_rd_wr_pixmap.c
*/
/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
/*
init_pixmap_hdr_rec(hdr)
free_pixmap_hdr_rec(hdr)
pr_pixmap_hdr_rec(hdr)
RdPixmapHdr(fn,hdr)
RdThePixmapHdr(dir,fn,suffix,pixmap_hdr)
rd_pixmap_slices(fn,hdr)
rd_pixmap_for_slice_num(fn,hdr,slice_map,slice_num)
rd_pixmap(fn,file,err_reason)
wr_updated_pixmap_params(fid,hdr)
wr_pixmap_hdr(fn,hdr)
WrPixmap(fn,order,slice_maps,num_slice_maps,hdr)
is_compatible_pixmap(pixel_type,dimx,dimy)
append_wr_file_pixmap(dir,fn,suffix,pixel_type,dimx,dimy,err_reason)
wr_file_pixmap_for_slice_num(dir,fn,suffix,pixel_type,dimx,dimy,
                             num_slices,slice_map,slice_num,err_reason)
wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason)
*/
char *UniqueFn();

init_pixmap_hdr_rec(hdr)
 struct pixmap_hdr_rec *hdr;
{
 hdr->id = NULL;
 hdr->status = 0;
 init_strs_rec(&(hdr->order));
 hdr->max_slices = 0;
 hdr->pixmap_start = 0;
 hdr->pixmap_offsets = NULL;
 hdr->num_pixmaps = 0;
}

free_pixmap_hdr_rec(hdr)
 struct pixmap_hdr_rec *hdr;
{
 c_free(hdr->id);
 free_strs_rec(&(hdr->order));
 c_free(hdr->pixmap_offsets);
 init_pixmap_hdr_rec(hdr);
}

pr_pixmap_hdr_rec(hdr)
 struct pixmap_hdr_rec *hdr;
{
 unsigned long lcv,num_bytes;

 printf("\npr_pixmap_hdr_rec id = %s  status = %x\n",
           hdr->id,(unsigned long) hdr->status);
 pr_strs_rec(&(hdr->order));
 printf("   dimx = %d  dimy = %d  max_slice = %d num_pixmaps = %d\n",
     hdr->dimx,hdr->dimy,hdr->max_slices,hdr->num_pixmaps);
 printf("hdr->pixmap_start = %d\n",hdr->pixmap_start);
 for (lcv = 0; lcv < hdr->max_slices; lcv++)
    {printf("%d) %d   ",lcv,hdr->pixmap_offsets[lcv]);
     if (lcv == 10) printf("\n");
    }
 printf("pr_pixmap_hdr_rec end\n");
}

RdPixmapHdr(fn,hdr)
 char *fn;
 struct pixmap_hdr_rec *hdr;
{
 FILE *fid;
 int err;
 unsigned long lcv;

 free_pixmap_hdr_rec(hdr);
 TRACE(printf("RdPixmapHdr...fn = %s\n",fn))
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 if (((err = rd_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = rd_strs_rec(fid,&(hdr->order))) == NO_ERROR))
    {TRACE(printf("RdPixmapHdr...1\n"))
     if ((fread(&(hdr->status),(size_t) sizeof(hdr->status),1,fid) != 1) ||
        (fread(&(hdr->dimx),(size_t) sizeof(hdr->dimx),1,fid) != 1) ||
        (fread(&(hdr->dimy),(size_t) sizeof(hdr->dimy),1,fid) != 1) ||
        (fread(&(hdr->max_slices),(size_t) sizeof(hdr->max_slices),1,fid) != 1) ||
        (fread(&(hdr->num_pixmaps),(size_t) sizeof(hdr->num_pixmaps),1,fid) != 1) ||
        (fread(&(hdr->pixmap_start),(size_t) sizeof(hdr->pixmap_start),1,fid) != 1))
       {err = READ_ERROR;}
      else if ((err = get_ptr(&(hdr->pixmap_offsets),NULL,hdr->max_slices,
                 (size_t) sizeof(*(hdr->pixmap_offsets)))) == NO_ERROR)
              {TRACE(printf("RdPixmapHdr...2\n"))
               if (fread(hdr->pixmap_offsets,
                 (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets)),1,fid) != 1)
                 {err = READ_ERROR;}
              }
    }         
 TRACE(pr_pixmap_hdr_rec(hdr))
 TRACE(printf("RdPixmapHdr...err = %d\n",err))
 if (err != NO_ERROR)
    free_pixmap_hdr_rec(hdr);
   else
    {TRACE(for (lcv = 0; lcv < hdr->max_slices; lcv++)
              printf("%d) off = %d\n", lcv,hdr->pixmap_offsets[lcv]);
          )
    }
 fclose(fid);
 return err;
}

RdThePixmapHdr(dir,fn,suffix,pixmap_hdr)
 char *dir,*fn,*suffix;
 struct pixmap_hdr_rec *pixmap_hdr;
{
 int err;
 char *fn1;

 fn1 = NULL;
 if ((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR)
    if (access(fn1,0) != 0)
       {err = FILE_NOT_EXIST;}
      else
       {
        err = RdPixmapHdr(fn1,pixmap_hdr);
       }
 c_free(fn1);
 return err;
}

rd_pixmap_slices(fn,hdr,slice_maps,num_slice_maps)
 char *fn;
 struct pixmap_hdr_rec *hdr;
 struct buf_2d_rec **slice_maps;
 unsigned long num_slice_maps;
{
 FILE *fid;
 int err;
 long lcv,max_slices;

 if ((fid = fopen(fn,"r")) == NULL) err = FILE_ACCESS_ERROR;
 if (num_slice_maps < hdr->max_slices)
    max_slices = num_slice_maps;
   else max_slices = hdr->max_slices;
 TRACE(printf("rd_pixmap_slices...max_slices = %d\n",max_slices))
 for (lcv = 0; lcv < max_slices; lcv++)
    {if (hdr->pixmap_offsets[lcv])
        {
         fseek(fid,hdr->pixmap_offsets[lcv],0);
         TRACE(printf("rd %d) off = %d\n",
                      lcv,hdr->pixmap_offsets[lcv]))

         if ((err = v3_rd_buf_2d_rec(fid,slice_maps[lcv])) != NO_ERROR)
            {free_buf_2d_rec(slice_maps[lcv]);
             break;}
        }
    }
 fclose(fid);
 TRACE(printf("rd_pixmap_slices...err = %d\n",err))
 return err;
}

rd_pixmap_for_slice_num(fn,hdr,slice_map,slice_num)
 char *fn;
 struct pixmap_hdr_rec *hdr;
 struct buf_2d_rec *slice_map;
 int slice_num;
{
 int err;
 FILE *fid;

 PRT(printf("rd_pixmap_for_slice_num..slice_num = %d\n",slice_num))
 if (slice_num >= hdr->max_slices) return NOT_FOUND;
 if (hdr->pixmap_offsets[slice_num] == 0) return NOT_FOUND;
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 PRT(printf("rd_pixmap_for_slice_num..2\n"))
 free_buf_2d_rec(slice_map);
 fseek(fid,hdr->pixmap_offsets[slice_num],0);
 if ((err = v3_rd_buf_2d_rec(fid,slice_map)) != NO_ERROR)
    free_buf_2d_rec(slice_map);
 fclose(fid);
 PRT(printf("rd_pixmap_for_slice_num..err = %d slice_map...\n",err))
 PRT(pr_buf_2d_rec(slice_map))
 return err;
}

wr_updated_pixmap_params(fid,hdr)
 FILE *fid;
 struct pixmap_hdr_rec *hdr;
{
 unsigned long size;
 int err;

 fflush(fid);
 fseek(fid,hdr->pixmap_start - sizeof(hdr->num_pixmaps) -
            sizeof(hdr->pixmap_start),0);
 if (fwrite(&(hdr->num_pixmaps),(size_t) sizeof(hdr->num_pixmaps),1,fid) != 1)
    err = WRITE_ERROR;
   else
    {size = (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets));
     fflush(fid);
     fseek(fid,hdr->pixmap_start,0);
     if (fwrite(hdr->pixmap_offsets,size,1,fid) != 1)
        err = WRITE_ERROR;
       else err = NO_ERROR;
    }
 return err;
}

wr_pixmap_hdr(fn,hdr)
 char *fn;
 struct pixmap_hdr_rec *hdr;
{
 FILE *fid;
 int err;

 TRACE(printf("wr_pixmap_hdr...0\n"))
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 if (((err = wr_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = wr_strs_rec(fid,&(hdr->order))) == NO_ERROR))
    if ((fwrite(&(hdr->status),(size_t) sizeof(hdr->status),1,fid) != 1) ||
        (fwrite(&(hdr->dimx),(size_t) sizeof(hdr->dimx),1,fid) != 1) ||
        (fwrite(&(hdr->dimy),(size_t) sizeof(hdr->dimy),1,fid) != 1) ||
        (fwrite(&(hdr->max_slices),(size_t) sizeof(hdr->max_slices),1,fid) != 1) ||
        (fwrite(&(hdr->num_pixmaps),(size_t)
                      sizeof(hdr->num_pixmaps),1,fid) != 1))
       err = WRITE_ERROR;
      else
       {fflush(fid);
        TRACE(printf("wr_pixmap_hdr...1\n"))
        hdr->pixmap_start = ftell(fid) + sizeof(hdr->pixmap_start);
        if ((fwrite(&(hdr->pixmap_start),
                 (size_t) sizeof(hdr->pixmap_start),1,fid) != 1) ||
            (fwrite(hdr->pixmap_offsets,
                 (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets)),1,fid) != 1))
           {err = WRITE_ERROR;}
        TRACE(printf("wr_pixmap_hdr...err = %d\n",err))
       }
 fclose(fid);
 TRACE(printf("wr_pixmap_hdr..1.err = %d\n",err))
 if (err != NO_ERROR) delete_file(fn);
 return err;
}

WrPixmap(fn,order,slice_maps,num_slice_maps,hdr)
 char *fn;
 struct strs_rec *order;
 struct buf_2d_rec **slice_maps;
 unsigned long num_slice_maps;
 struct pixmap_hdr_rec *hdr;
{
 int err,first;
 FILE *fid;
 unsigned long lcv,size,total;

 TRACE(printf("WrPixmap...fn = %s num_slice_maps = %d\n",fn,num_slice_maps))
 if (num_slice_maps == 0) return CANCEL;
 TRACE(printf("WrPixmap...0\n"))
 if ((err = cp_str(&(hdr->id),PIXMAP_V1)) != NO_ERROR) return err;
 if ((err = cp_strs_rec(&(hdr->order),order)) != NO_ERROR) return err;
 hdr->max_slices = num_slice_maps;
 TRACE(printf("WrPixmap...1\n"))
 if ((err = get_ptr(&(hdr->pixmap_offsets),NULL,hdr->max_slices,
                 (size_t) sizeof(*(hdr->pixmap_offsets)))) != NO_ERROR)
    return err;
 TRACE(printf("WrPixmap...2\n"))

 for (first = 1,hdr->num_pixmaps = 0,lcv = 0; lcv < num_slice_maps; lcv++)
    {if ((slice_maps[lcv]->status4 & BUF_NON_EMPTY) && 
         (slice_maps[lcv]->status4 & BUF_DATA_VALID))
        {if (first)
            {hdr->dimx = slice_maps[lcv]->dimx;
             hdr->dimy = slice_maps[lcv]->dimy;
             first = 0;}
           else if ((hdr->dimx != slice_maps[lcv]->dimx) ||
                    (hdr->dimy != slice_maps[lcv]->dimy))
            return CANCEL;
         hdr->num_pixmaps += 1;}
     hdr->pixmap_offsets[lcv] = 0;}
 TRACE(printf("WrPixmap...hdr->num_pixmaps = %d\n",hdr->num_pixmaps))

 if ((err = wr_pixmap_hdr(fn,hdr)) != NO_ERROR)
    {
     return err;}
 TRACE(printf("WrPixmap...4\n"))

 if ((fid = fopen(fn,"r+")) == NULL)
    {
     delete_file(fn);
     return FILE_ACCESS_ERROR;}
 total = (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets));
 size = hdr->pixmap_start + total;
 fseek(fid,size,0);

 TRACE(printf("WrPixmap...ftell(fid) = %d\n",ftell(fid)))
 for (lcv = 0; lcv < num_slice_maps; lcv++)
    {if ((slice_maps[lcv]->status4 & BUF_NON_EMPTY) &&
         (slice_maps[lcv]->status4 & BUF_DATA_VALID))
        {hdr->pixmap_offsets[lcv] = ftell(fid);
         TRACE(printf("wr %d) off = %d\n",lcv,hdr->pixmap_offsets[lcv]))
         TRACE(printf("   ");pr_buf_2d_rec(slice_maps[lcv]);)
         if ((err = v3_wr_buf_2d_rec(fid,slice_maps[lcv])) != NO_ERROR)
            {TRACE(printf("WrPixmap wr_buf_2d_rec err = %d\n",err))
             break;}
         fflush(fid);
        }
    }
 if (err == NO_ERROR)
    {
     fseek(fid,hdr->pixmap_start,0);
     if (fwrite(hdr->pixmap_offsets,total,1,fid) != 1)
        err = WRITE_ERROR;
    }
 TRACE(printf("WrPixmap err = %d\n",err))
 fclose(fid);
 if (err != NO_ERROR) delete_file(fn);
 return err;
}

is_compatible_pixmap(pixel_type,dimx,dimy)
 struct pixel_type_rec *pixel_type;
 long dimx,dimy;
{
 int result;

 cmp_str_arys(pixel_type->order.strs,pixel_type->order.num_strs,
            pixel_type->pixmap_hdr.order.strs,
            pixel_type->pixmap_hdr.order.num_strs,&result);
 if ((result != 0) ||
     (pixel_type->pixmap_hdr.dimx != dimx) ||
     (pixel_type->pixmap_hdr.dimy != dimy))
    return 0;
 return 1;
}

append_wr_file_pixmap(dir,fn,suffix,pixel_type,dimx,dimy,err_reason)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 char **err_reason;
{
 int err,update;
 char *fn1;
 unsigned long lcv,size;
 FILE *fid;
 struct pixmap_hdr_rec *hdr;

 TRACE(printf("append_wr_file_pixmap..0\n"))
 if (err_reason != NULL) *err_reason = NULL;
 if (!is_compatible_pixmap(pixel_type,dimx,dimy))
    return wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason);
 TRACE(printf("append_wr_file_pixmap..1\n"))

 fn1 = NULL;
 if (((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR) &&
     ((err = file_access(fn1,2,NULL,err_reason)) == NO_ERROR))
    {size = get_file_size_by_fn(fn1,&err);
     TRACE(printf("append_wr_file_pixmap..fn1 = %s size = %d\n",fn1,size))
     if ((fid = fopen(fn1,"r+")) == NULL)
        err = FILE_ACCESS_ERROR;
       else
        {
         hdr = &(pixel_type->pixmap_hdr);
         for (update = 0,lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
            {
             if ((pixel_type->slice_maps[lcv]->status4 & BUF_NON_EMPTY) &&
                 (pixel_type->slice_maps[lcv]->status4 & BUF_DATA_VALID))
                {if (hdr->pixmap_offsets[lcv] == 0)
                    {hdr->pixmap_offsets[lcv] = size;
                     hdr->num_pixmaps += 1;
                     update = 1;}
                 fseek(fid,hdr->pixmap_offsets[lcv],0);
                 TRACE(printf("%d)..off = %d\n",
                        lcv,hdr->pixmap_offsets[lcv]))
                 if ((err = v3_wr_buf_2d_rec(fid,
                          pixel_type->slice_maps[lcv])) != NO_ERROR)
                    {TRACE(printf("append_wr_file_pixmap..wr_buf_2d_rec = %d\n",err))
                     break;}
                 if (update)
                    {fflush(fid);
                     size = ftell(fid);
                     update = 0;}
                } 
            }
         if (err == NO_ERROR)
            err = wr_updated_pixmap_params(fid,hdr);
         fclose(fid);
        }
    }
 c_free(fn1);
 TRACE(printf("append_wr_file_pixmap..err = %d\n",err))
 return err;
}

wr_file_pixmap_for_slice_num(dir,fn,suffix,pixel_type,dimx,dimy,
                             num_slices,slice_map,slice_num,err_reason)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 long num_slices;
 int slice_num;
 char **err_reason;
{
 int err;
 FILE *fid;
 unsigned long size;
 char *fn1;
 unsigned long lcv;
 struct pixmap_hdr_rec *hdr;

 TRACE(printf("wr_pixmap_for_slice_num..1\n"))
 if (slice_num >= num_slices) return CANCEL;
 if (slice_num >= pixel_type->num_slice_maps) return CANCEL;
 if (!(pixel_type->slice_maps[slice_num]->status4 & BUF_NON_EMPTY) ||
     !(pixel_type->slice_maps[slice_num]->status4 & BUF_DATA_VALID))
    return NO_ERROR;
 if (!is_compatible_pixmap(pixel_type,dimx,dimy) ||
     !(pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID))
    return wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason);

 hdr = &(pixel_type->pixmap_hdr);
 TRACE(printf("wr_pixmap_for_slice_num..2\n"))
 if (hdr->pixmap_offsets[slice_num] == 0)
    {size = get_file_size_by_fn(fn,&err);
     if (err != NO_ERROR) return err;
     hdr->pixmap_offsets[slice_num] = size;
     hdr->num_pixmaps += 1;
    }
 fn1 = NULL;
 if (((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR) &&
     ((err = file_access(fn1,2,NULL,err_reason)) == NO_ERROR))
   {if ((fid = fopen(fn1,"r+")) == NULL)
       err = FILE_ACCESS_ERROR;
      else
       {fseek(fid,hdr->pixmap_offsets[slice_num],0);
        err = v3_wr_buf_2d_rec(fid,pixel_type->slice_maps[slice_num]);
        if (err == NO_ERROR) err = wr_updated_pixmap_params(fid,hdr);
        fclose(fid);}
   }
 c_free(fn1);
 TRACE(printf("wr_pixmap_for_slice_num..err = %d\n",err))
 return err;
}

wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 char **err_reason;
{
 int err;
 char *fn1,*fn2;
 struct pixmap_hdr_rec hdr;

 if (err_reason != NULL) *err_reason = NULL;

 TRACE(printf("wr_file_pixmap..1\n"))
 fn1 = fn2 = NULL;
 if (((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR) &&
     ((err = file_access(fn1,2,NULL,err_reason)) == NO_ERROR))
    if ((fn2 = UniqueFn("",fn1,".temp")) == NULL) 
       err = CANCEL;
      else if ((err = file_access(fn2,2,NULL,err_reason)) == NO_ERROR)
       {init_pixmap_hdr_rec(&hdr);
        err = WrPixmap(fn2,&(pixel_type->order),
             pixel_type->slice_maps,pixel_type->num_slice_maps,&hdr);
        TRACE(printf("WrPixmap...2.err = %d\n",err))
        if (err == NO_ERROR)
           {if (rename(fn2,fn1) != 0)
               {free_pixmap_hdr_rec(&hdr);
                err = CANCEL;}
              else
               {free_pixmap_hdr_rec(&(pixel_type->pixmap_hdr));
                pixel_type->pixmap_hdr = hdr;
                TRACE(printf("rename to %s\n",fn1))
               }
           }
          else free_pixmap_hdr_rec(&hdr);
       }
 c_free(fn1);
 c_free(fn2);
 TRACE(printf("wr_file_pixmap..err = %d\n",err))
 return err;
}

