#include "mri_format.h"
/*
cc -c v3_rd_wr_slice_roi_rec.c
*/
/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)

/*
v3_rd_curve_rec(fid,curve)
v3_rd_curve_2d_rec(fid,pen)
v3_rd_roi_rec(fid,roi)
v3_rd_slice_roi_rec(fid,slice_roi)

v3_wr_curve_rec(fid,curve)
v3_wr_curve_2d_rec(fid,pen)
v3_wr_roi_rec(fid,roi)
v3_wr_slice_roi_rec(fid,slice_roi)
*/

struct coordinate_xy_rec
   {
    short x,y;
   };

v3_rd_curve_rec(fid,curve)
 FILE *fid;
 struct curve_rec *curve;
{
 unsigned long lcv;
 struct short_bound_rec sh_bound;
 short left,top,right,bottom;
 struct coordinate_xy_rec *ptr;
 int err;

 PRT(printf("rd_curve_rec..curve = %u\n",curve))

 if ((fread(&(curve->status),(size_t) sizeof(curve->status),1,fid) != 1) ||
     (fread(&(curve->more_status),(size_t) sizeof(curve->more_status),1,fid) != 1) ||
     (fread(&(curve->num_xys),(size_t) sizeof(curve->num_xys),1,fid) != 1))
    {init_curve_rec(curve);
     return READ_ERROR;}
 PRT1(printf("rd_curve_rec..status = %x more_status = %x num_xys = %d\n",
         curve->status,curve->more_status,curve->num_xys))

 if (!(curve->more_status & CURVE_NEW))
    {if ((fread(&left,(size_t) sizeof(left),1,fid) != 1) ||
         (fread(&top,(size_t) sizeof(top),1,fid) != 1) ||
         (fread(&right,(size_t) sizeof(right),1,fid) != 1) ||
         (fread(&bottom,(size_t) sizeof(bottom),1,fid) != 1) ||
         (fread(&(curve->matrix),(size_t) sizeof(curve->matrix),1,fid) != 1))
        {init_curve_rec(curve);
         return READ_ERROR;}
     curve->fl_bound.left = (float) left;
     curve->fl_bound.top = (float) top;
     curve->fl_bound.right = (float) right;
     curve->fl_bound.bottom = (float) bottom;
    }
   else if ((fread(&(curve->fl_bound),
            (size_t) sizeof(curve->fl_bound),1,fid) != 1) ||
           (fread(&(curve->matrix),(size_t) sizeof(curve->matrix),1,fid) != 1))
    {init_curve_rec(curve);
     return READ_ERROR;}

 curve->total_xys = curve->num_xys;
 if (curve->num_xys == 0)
    {curve->status &= ~CURVE_MATRIX_IN_USE;
     return NO_ERROR;}
 if ((err = get_ptr(&(curve->xys),NULL,curve->num_xys,
                   (size_t) sizeof(*(curve->xys)))) != NO_ERROR)
    {curve->num_xys = 0;
     curve->total_xys = 0;
     return err;}

 if (!(curve->more_status & CURVE_NEW))
    {if ((err = get_ptr(&ptr,NULL,curve->num_xys,
                   (size_t) sizeof(*ptr))) != NO_ERROR)
        {init_curve_rec(curve);
         return err;}
     if (fread(ptr,(size_t) ((size_t) sizeof(*ptr) *
           curve->num_xys),1,fid) != 1)
        {curve->num_xys = 0;
         curve->status &= ~CURVE_MATRIX_IN_USE;
         c_free(ptr);
         return READ_ERROR;}
     for (lcv = 0; lcv < curve->num_xys; lcv++)
        {curve->xys[lcv].x = (float) ptr[lcv].x;
         curve->xys[lcv].y = (float) ptr[lcv].y;}
     c_free(ptr);
    }
   else if (fread(curve->xys,(size_t) ((size_t) sizeof(*(curve->xys)) *
           curve->num_xys),1,fid) != 1)
    {curve->num_xys = 0;
     curve->status &= ~CURVE_MATRIX_IN_USE;
     return READ_ERROR;}

 if (curve->status & CURVE_MATRIX_IN_USE)
    inverse_2d_matrix(&(curve->inv),&(curve->matrix));

 PRT1(printf("rd_curve_rec..end\n"))
 return NO_ERROR;
}

v3_rd_curve_2d_rec(fid,pen)
 FILE *fid;
 struct curve_2d_rec *pen;
{
 unsigned_int total;
 int err;

 TRACE(printf("v3_rd_curve_2d_rec..pen = %u\n",pen))
 init_curve_2d_rec(pen,0);

 if ((fread(&(pen->pen_type),(size_t) sizeof(pen->pen_type),1,fid) != 1) ||
     (fread(&(pen->cur_curve),(size_t) sizeof(pen->cur_curve),1,fid) != 1) ||
     (fread(&(pen->num_curves),(size_t) sizeof(pen->num_curves),1,fid) != 1))
    {init_curve_2d_rec(pen,0);
     return READ_ERROR;}
 if (pen->cur_curve >= pen->num_curves) pen->cur_curve = 0;
 if (pen->num_curves == 0) return NO_ERROR;

 TRACE(printf("v3_rd_curve_2d_rec..pen_type = %d cur_curve = %d num_curves = %d total =  %d\n",
              pen->pen_type,pen->cur_curve,pen->num_curves,pen->total_curves))

 get_handle_memory(&(pen->curves),&(pen->total_curves),pen->num_curves,
         (size_t) sizeof(**(pen->curves)),&err);
 if (err)
    {init_curve_2d_rec(pen,0);
     return err;}
 for (total = 0; total < pen->total_curves; total++)
    init_curve_rec(pen->curves[total]);

 for (total = 0; total < pen->total_curves; total++)
    if ((err = v3_rd_curve_rec(fid,pen->curves[total])) != NO_ERROR)
       return err;

 TRACE(printf("v3_rd_curve_2d_rec...end.\n"))
 return NO_ERROR;
}

v3_rd_roi_rec(fid,roi)
 FILE *fid;
 struct roi_rec *roi;
{
 unsigned_int total,lcv;
 int err;

 TRACE(printf("v3_rd_roi_rec....roi = %u\n",roi))
 if (rd_file_strs(fid,&(roi->label),1) != NO_ERROR)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
 TRACE(printf("v3_rd_roi_rec...1\n"))
 if (fread(&(roi->status),(size_t) sizeof(roi->status),
           1,fid) != 1)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
 TRACE(printf("v3_rd_roi_rec...2\n"))
 if (fread(&(roi->cur_pen),(size_t) sizeof(roi->cur_pen),
           1,fid) != 1) 
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
 TRACE(printf("v3_rd_roi_rec...3\n"))
 if (fread(&(roi->num_pens),(size_t) sizeof(roi->num_pens),
           1,fid) != 1)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
/*
 if ((rd_file_strs(fid,&(roi->label),1) != NO_ERROR) ||
     (fread(&(roi->status),(size_t) sizeof(roi->status),
           1,fid) != 1) ||
     (fread(&(roi->cur_pen),(size_t) sizeof(roi->cur_pen),
           1,fid) != 1) ||
     (fread(&(roi->num_pens),(size_t) sizeof(roi->num_pens),
           1,fid) != 1))
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
*/
 TRACE(printf("v3_rd_roi_rec....roi->label = %s status = %x num_pens = %d\n",
         roi->label,(unsigned long) roi->status,roi->num_pens);)
 if (roi->cur_pen >= roi->num_pens) roi->cur_pen = 0;
 if (roi->num_pens == 0) return NO_ERROR;
 if ((err = get_handle(&(roi->pens),&(roi->total_pens),roi->num_pens,
              (size_t) sizeof(**(roi->pens)))) != NO_ERROR)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return err;}
 roi->status |= ROI_VISIBLE;
 for (total = 0; total < roi->num_pens; total++)
    init_curve_2d_rec(roi->pens[total],0);

 for (total = 0; total < roi->num_pens; total++)
    {if ((err = v3_rd_curve_2d_rec(fid,roi->pens[total])) != NO_ERROR)
        return err;
    }
 TRACE(printf("v3_rd_roi_rec...end\n"))
 return NO_ERROR;

}

v3_rd_slice_roi_rec(fid,slice_roi)
 FILE *fid;
 struct slice_roi_rec *slice_roi;
{
 unsigned_int total;
 int err;

 TRACE(printf("v3_rd_slice_roi_rec...slice_roi = %u\n",slice_roi))
 free_slice_roi_rec(slice_roi);
 TRACE(printf("v3_rd_slice_roi_rec...\n"))

 if (
     (fread(&(slice_roi->status),
         (size_t) sizeof(slice_roi->status),1,fid) != 1) ||
     (fread(&(slice_roi->xpixel_size),
         (size_t) sizeof(slice_roi->xpixel_size),1,fid) != 1) ||
     (fread(&(slice_roi->ypixel_size),
         (size_t) sizeof(slice_roi->ypixel_size),1,fid) != 1) ||
     (fread(&(slice_roi->dimx),
         (size_t) sizeof(slice_roi->dimx),1,fid) != 1) ||
     (fread(&(slice_roi->dimy),
         (size_t) sizeof(slice_roi->dimy),1,fid) != 1) ||
     (fread(&(slice_roi->num_rois),
         (size_t) sizeof(slice_roi->num_rois),1,fid) != 1) ||
     (fread(&(slice_roi->cur_roi),
         (size_t) sizeof(slice_roi->cur_roi),1,fid) != 1))
    {init_slice_roi_rec(slice_roi);
     return READ_ERROR;}

 if (slice_roi->cur_roi >= slice_roi->num_rois) slice_roi->cur_roi = 0;
 TRACE(printf("v3_rd_slice_roi_rec cur_roi = %d num_rois = %d\n",
           slice_roi->cur_roi,slice_roi->num_rois))
 if (slice_roi->num_rois == 0) return NO_ERROR;
 get_handle_memory(&(slice_roi->rois),&(slice_roi->total_rois),slice_roi->num_rois,
         (size_t) sizeof(**(slice_roi->rois)),&err);
 if (err)
    {init_slice_roi_rec(slice_roi);
     return err;}
 for (total = 0; total < slice_roi->total_rois; total++)
    init_roi_rec(slice_roi->rois[total],NULL);

 for (total = 0; total < slice_roi->total_rois; total++)
    {TRACE(printf("reading roi# = %d\n",total))
     if ((err = v3_rd_roi_rec(fid,slice_roi->rois[total])) != NO_ERROR)
       {
        free_slice_roi_rec(slice_roi);
        return err;}
    }
 TRACE(printf("***********v3_rd_slice_roi_rec...end."))
 slice_roi->status |= SLICE_ROI_NON_EMPTY;
 return NO_ERROR;

}

v3_wr_curve_rec(fid,curve)
 FILE *fid;
 struct curve_rec *curve;
{
 curve->more_status |= CURVE_NEW;
 TRACE(printf("v3_wr_curve_rec..curve->num_xys = %d\n",curve->num_xys))
 if ((fwrite(&(curve->status),(size_t) sizeof(curve->status),1,fid) != 1) ||
     (fwrite(&(curve->more_status),(size_t) sizeof(curve->more_status),1,fid) != 1) ||
     (fwrite(&(curve->num_xys),(size_t) sizeof(curve->num_xys),1,fid) != 1) ||
     (fwrite(&(curve->fl_bound),(size_t) sizeof(curve->fl_bound),1,fid) != 1) ||
     (fwrite(&(curve->matrix),(size_t) sizeof(curve->matrix),1,fid) != 1))
    return WRITE_ERROR;
 if (curve->num_xys == 0) return NO_ERROR;
 if (fwrite(curve->xys,(size_t) (sizeof(*(curve->xys)) *
              curve->num_xys),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("v3_wr_curve_rec..end\n"))
 return NO_ERROR;
}

v3_wr_curve_2d_rec(fid,pen)
 FILE *fid;
 struct curve_2d_rec *pen;
{
 unsigned_int total;
 int err;

 TRACE(printf("v3_wr_curve_2d_rec..\n"))
 if ((fwrite(&(pen->pen_type),(size_t) sizeof(pen->pen_type),1,fid) != 1) ||
     (fwrite(&(pen->cur_curve),(size_t) sizeof(pen->cur_curve),1,fid) != 1) ||
     (fwrite(&(pen->num_curves),(size_t) sizeof(pen->num_curves),1,fid) != 1))
     return WRITE_ERROR;
 TRACE(printf("v3_wr_curve_2d_rec..pen_type = %d cur_curve = %d num_curves = %d\n",
              pen->pen_type,pen->cur_curve,pen->num_curves))
 if (pen->num_curves == 0) return NO_ERROR;

 for (total = 0; total < pen->num_curves; total++)
    if ((err = v3_wr_curve_rec(fid,pen->curves[total])) != NO_ERROR)
        return err;
 TRACE(printf("v3_wr_curve_2d_rec..end\n"))
 return NO_ERROR;
}

v3_wr_roi_rec(fid,roi)
 FILE *fid;
 struct roi_rec *roi;
{
 unsigned_int total;
 int err;

 TRACE(printf("v3_wr_roi_rec..\n"))

 if ((wr_file_strs(fid,&(roi->label),1) != NO_ERROR) ||
     (fwrite(&(roi->status),(size_t) sizeof(roi->status),
           1,fid) != 1) ||
     (fwrite(&(roi->cur_pen),(size_t) sizeof(roi->cur_pen),
           1,fid) != 1) ||
     (fwrite(&(roi->num_pens),(size_t) sizeof(roi->num_pens),
           1,fid) != 1))
     return WRITE_ERROR;
 if (roi->num_pens == 0) return NO_ERROR;
 TRACE(printf("v3_wr_roi_rec..\n"))

 for (total = 0; total < roi->num_pens; total++)
    if ((err = v3_wr_curve_2d_rec(fid,roi->pens[total])) != NO_ERROR)
        return err;
 TRACE(printf("v3_wr_roi_rec..end\n"))
 return NO_ERROR;

}

v3_wr_slice_roi_rec(fid,slice_roi)
 FILE *fid;
 struct slice_roi_rec *slice_roi;
{
 unsigned_int total;
 int err;

 TRACE(printf("v3_wr_slice_roi_rec..7777..slice_roi = %d\n",slice_roi))
 keep_only_non_empty_curves(slice_roi);
 TRACE(printf("v3_wr_slice_roi_rec..88..\n"))

 if (
     (fwrite(&(slice_roi->status),
         (size_t) sizeof(slice_roi->status),1,fid) != 1) ||
     (fwrite(&(slice_roi->xpixel_size),
         (size_t) sizeof(slice_roi->xpixel_size),1,fid) != 1) ||
     (fwrite(&(slice_roi->ypixel_size),
         (size_t) sizeof(slice_roi->ypixel_size),1,fid) != 1) ||
     (fwrite(&(slice_roi->dimx),
         (size_t) sizeof(slice_roi->dimx),1,fid) != 1) ||
     (fwrite(&(slice_roi->dimy),
         (size_t) sizeof(slice_roi->dimy),1,fid) != 1) ||
     (fwrite(&(slice_roi->num_rois),
         (size_t) sizeof(slice_roi->num_rois),1,fid) != 1) ||
     (fwrite(&(slice_roi->cur_roi),
         (size_t) sizeof(slice_roi->cur_roi),1,fid) != 1))
     return WRITE_ERROR;
 TRACE(printf("v3_wr_slice_roi_rec...slice_roi->num_rois = %d",slice_roi->num_rois))

 for (total = 0; total < slice_roi->num_rois; total++)
    {
     if ((err = v3_wr_roi_rec(fid,slice_roi->rois[total])) != NO_ERROR)
        return err;}
 TRACE(printf("v3_wr_slice_roi_rec...end."))
 return NO_ERROR;

}

