/****************************************************************************
anal_dp_options.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: anal_dp_options.c,v 1.11 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"



/*
#define TRACE(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT15(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT12(x)
#define PRT15(x)
#define PRT3(x)
#define PRT4(x)



#define CLEAN_UP_ANAL_DP_OPTIONS 0
#define SETUP_ANAL_DP_OPTIONS 1
#define GET_ALL_DP_PTR 2


struct anal_dp_option_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item types,which_region;
   };

struct all_anal_dp_option_recs
   {
    int num_dps;
    struct anal_dp_option_rec **dps;
   };


/* Functions defined in this file */
void init_anal_dp_option_rec(struct anal_dp_option_rec *dp);
void free_anal_dp_option_rec(struct anal_dp_option_rec *dp);
void init_all_anal_dp_option_recs(struct all_anal_dp_option_recs *all_dps);
void dp_anal_dp_options_frame_done_proc(Frame frame);
int select_pixel_type_mask_proc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct buf_2d_rec *mask, unsigned char *selected);
int win_get_img_map(struct image_display_window *win,
    struct buf_2d_rec **slice_map, unsigned int *offset_value);
int WinSlicePixelTypeOverlayOn(struct image_display_window *win);
int WinSlicePixelTypeOverlay(struct image_display_window *win,
    struct buf_2d_rec *mask, struct int_bound_rec *bound);
int WinShowPixelTypesProc(struct image_display_window *win,
    struct buf_2d_rec *_2d, unsigned int offset_value, int option);
int win_reshow_pixel_types(struct image_display_window *win);
int WinReshowPixelTypesToScreen(struct image_display_window *win);
int WinShowPixelTypes(struct image_display_window *win, int option);
int win_filter_image_tissue_types(struct image_display_window *win);
int disable_display_tissue_type(struct image_display_window *win);
int enable_display_tissue_type(struct image_display_window *win, int option);
int win_image_tissue_type_to_screen(struct image_display_window *win);
void dp_show_proc(Panel_item item, Event event);
void unselected_to_background_proc(Panel_item item, int value, Event event);
void apply_to_stack_proc(Panel_item item, int value, Event event);
void dp_original_proc(Panel_item item, Event event);
void dp_reset_proc(Panel_item item, Event event);
int setup_anal_dp_option_rec(struct anal_dp_option_rec *dp,
    struct image_display_window *win);
struct anal_dp_option_rec *find_anal_dp_option_rec(
   struct all_anal_dp_option_recs *all_dps, struct image_display_window *win);
struct anal_dp_option_rec *find_anal_dp_option_rec_1(
   struct all_anal_dp_option_recs *all_dps, struct image_display_window *win);
int enter_anal_display_options(struct image_display_window *win, int status);



/*---------------------------------------------------------------------
init_anal_dp_option_rec - ???
---------------------------------------------------------------------*/

void
init_anal_dp_option_rec(dp)
 struct anal_dp_option_rec *dp;
{
 dp->status = 0;
 dp->win = NULL;
 dp->frame  = 0;
}


/*---------------------------------------------------------------------
free_anal_dp_option_rec - ???
---------------------------------------------------------------------*/

void
free_anal_dp_option_rec(dp)
 struct anal_dp_option_rec *dp;
{
 struct all_anal_dp_option_recs *all_dps;

 if (dp->frame != 0)
    {xv_destroy_safe(dp->frame);
     dp->frame = 0;
    }
 c_free(dp);
 all_dps = (struct all_anal_dp_option_recs *) 
           enter_anal_display_options(NULL,GET_ALL_DP_PTR);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
 TRACE(printf("free_anal_dp_option_rec...end\n"))
}


/*---------------------------------------------------------------------
init_all_anal_dp_option_recs - ???
---------------------------------------------------------------------*/

void
init_all_anal_dp_option_recs(all_dps)
 struct all_anal_dp_option_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}



/*---------------------------------------------------------------------
dp_anal_dp_options_frame_done_proc - ???
---------------------------------------------------------------------*/

void
dp_anal_dp_options_frame_done_proc(frame)
 Frame frame;
{
 struct anal_dp_option_rec *dp;

 dp = (struct anal_dp_option_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_anal_dp_option_rec(dp);
}


/*---------------------------------------------------------------------
select_pixel_type_mask_proc - ???
---------------------------------------------------------------------*/

int
select_pixel_type_mask_proc(_2d,row,col,mask,selected)
 struct buf_2d_rec *_2d,*mask;
 unsigned long row,col;
 unsigned char *selected;
{
 double value;
 unsigned long val;

 value = _2d->GetVal(_2d,row,col);
 val = (unsigned long) rint(value);
 if (selected[val] == 0)
    mask->SetVal(mask,row,col,(double) 0);
 return NO_ERROR;
}


/*---------------------------------------------------------------------
win_get_img_map - ???
---------------------------------------------------------------------*/

int
win_get_img_map(win,slice_map,offset_value)
 struct image_display_window *win;
 struct buf_2d_rec **slice_map;
 unsigned int *offset_value;
{
 struct img_buf_rec *img;

 TRACE(printf("win_get_img_map(...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    {
     *slice_map = NULL;
     return CANCEL;}
 *offset_value = win->intensity->color.reserve_color_start;
 TRACE(printf("win_get_img_map(...offset_value = %d\n",*offset_value))
 if (win->type2 & HISTOGRAM_WINDOW)
    {PRT12(printf("HISTOGRAM_WINDOW..img = %u\n",img))
     *slice_map = (struct buf_2d_rec *) get_histo_map(img);}
   else
    {
     *slice_map = get_cur_slice_map(img->file,img->cur_slice);
     PRT12(printf("win_get_img_map...get_cur_slice_map slice_map = %u img = %u\n",
             *slice_map,img))
    }
 if ((*slice_map) == NULL) return CANCEL;
 else return NO_ERROR;
}


/*---------------------------------------------------------------------
WinSlicePixelTypeOverlayOn - ???
---------------------------------------------------------------------*/

int
WinSlicePixelTypeOverlayOn(win)
 struct image_display_window *win;
{
 int err;

 PRT12(printf("WinSlicePixelTypeOverlayOn...status = %x display_status = %x\n",
          (unsigned long) win->status4,(unsigned long) win->dwin->display_status) )
 if (win->dwin->display_status & DISPLAY_PIXEL_TYPE)
    {
     if (win->status4 & RECOMPUTE_PIXEL_TYPES)
        {PRT12(printf("WinSlicePixelTypeOverlayOn...RECOMPUTE_PIXEL_TYPES\n"))
         if ((err = win_reshow_pixel_types(win)) != NO_ERROR)
            {err = WinSetColorDataStatus(win,PIXEL_TYPE_ID,
                            0xffffffff,COLOR_DATA_DISABLED);
             return err;}
        }
     PRT12(printf("WinSlicePixelTypeOverlayOn WinSetColorDataStatus\n"))
     err = WinSetColorDataStatus(win,PIXEL_TYPE_ID,~COLOR_DATA_DISABLED,0);
    }
   else
    {PRT12(printf("WinSlicePixelTypeOverlayOn COLOR_DATA_DISABLED\n"))
     WinDropColorDataRec1(win,PIXEL_TYPE_ID,1,0,NULL,1);
    }
 PRT12(printf("WinSlicePixelTypeOverlayOn err = %d\n",err))
 return err;
}


/*---------------------------------------------------------------------
WinSlicePixelTypeOverlay - ???
---------------------------------------------------------------------*/

int
WinSlicePixelTypeOverlay(win,mask,bound)
 struct image_display_window *win;
 struct buf_2d_rec *mask;
 struct int_bound_rec *bound;
{
 struct buf_2d_rec *slice_map;
 unsigned long offset_value,select,num;
 struct color_data_rec *new;
 double zero,offset;
 int err;

 PRT15(printf("WinSlicePixelTypeOverlay...display_status = %x\n",
          (unsigned long) win->dwin->display_status))
 if (win->dwin->display_status & DISPLAY_PIXEL_TYPE)
    {PRT12(printf("WinSlicePixelTypeOverlay...DISPLAY_PIXEL_TYPE\n"))
     win_get_img_map(win,&slice_map,&offset_value);
     if (slice_map != NULL)
        {PRT12(printf("...slice_map\n"))
         PRT12(pr_buf_2d_rec(slice_map))
         PRT12(printf("...slice_map = %u = %d\n",slice_map,
               CntValBuf2dRec(slice_map,(double) .0)))
         num = offset_value + num_bit_values(slice_map->pixel_depth) + 1;
         num = find_num_bits_needed(num);
         if ((err = WinSetupColorDataRec2(win,0,PIXEL_TYPE_ID,0,0,0,0,num,1,&new,0)) != NO_ERROR)
            return err;
         PRT4(printf("===new = %u mask = %u...pixel_type_overlay = %d\n",
           new,mask,CntValBuf2dRec(&(new->_2d),(double) .0)))
         if (mask == NULL)
            {PRT12(printf("WinSlicePixelTypeOverlay SelectAssign2d...\n"))
             PRT12(pr_buf_2d_rec(&(new->_2d)))
             PRT12(pr_buf_2d_rec(slice_map))
             SelectAssign2d(&(new->_2d),
                  slice_map,0x00000C02,(double) .0,(double) .0,
                   (double) .0,(double) offset_value,NULL,0,0);
             PRT4(MinMax2dValues(&(new->_2d),0,(double) .0,(double) .0,&min4,&max4);
             printf(" new->_2d mask == NULL min4 = %f max4 = %f\n",min4,max4))
            }
           else 
            {select = 0x00000C02;
             zero = .0;
             offset = (double) offset_value;
             PRT12(printf("WinSlicePixelTypeOverlay SelectAssign2dProc...\n"))
             PRT12(pr_buf_2d_rec(&(new->_2d)))
             PRT12(pr_buf_2d_rec(slice_map))
             process_buf_2d_rec_by_mask(&(new->_2d),
                  0, 0, mask,bound, SelectAssign2dProc, slice_map, select,
                  &zero, &zero, &zero, &offset, 0, 0, 0);
             PRT15(MinMax2dValues(&(new->_2d),0,(double) .0,(double) .0,&min4,&max4);
             printf(" new->_2d min4 = %f max4 = %f\n",min4,max4))
            }
         win->status4 &= ~RECOMPUTE_PIXEL_TYPES;
         PRT12(printf("after...pixel_type_overlay = %d\n",slice_map,
               CntValBuf2dRec(&(new->_2d),(double) .0)))
        }
    }
 return NO_ERROR;
}


/*---------------------------------------------------------------------
WinShowPixelTypesProc - ???
---------------------------------------------------------------------*/

#define CLEAR_OPTION 0
#define ROI_SUPERIMPOSE_OPTION 1
#define WHOLE_SLICE_SUPERIMPOSE_OPTION 2
#define ROIS_SUPERIMPOSE_OPTION 3
#define VIEW_FILTER_ROI_OPTION 4

int
WinShowPixelTypesProc(win,_2d,offset_value,option)
 struct image_display_window *win;
 struct buf_2d_rec *_2d;
 unsigned int offset_value;
 int option;
{
 struct draw_mask_rec mask;
 struct roi_rec *roi;
 struct int_bound_rec affected,*bound;
 unsigned long dimx,dimy;
 int err;

 PRT4(printf("WinShowPixelTypesProc...begin wid = %s\n",win->owner->wid))
 PRT4(printf("option = %d   _2d = %u  buf = %u\n",option,_2d,_2d->buf))
 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;
 if (option == CLEAR_OPTION)
    {PRT3(printf("CLEAR_OPTION...\n"))
     WinDropColorDataRec1(win,PIXEL_TYPE_ID,1,0,NULL,1);
     WinScreenCanvas(win);
     return NO_ERROR;
    }
   else if (option == WHOLE_SLICE_SUPERIMPOSE_OPTION)
    {PRT4(printf("WHOLE_SLICE_SUPERIMPOSE_OPTION...\n"))
     return WinSlicePixelTypeOverlay(win,NULL,NULL);
    }
   else
    {PRT4(printf("ROI_SUPERIMPOSE_OPTION......\n"))
     init_draw_mask_rec(&mask);
     err = get_draw_mask_rec(&mask,dimx,dimy);
     if (err == NO_ERROR)
        if ((option == ROI_SUPERIMPOSE_OPTION) ||
            (option == VIEW_FILTER_ROI_OPTION))
           {if (option == ROI_SUPERIMPOSE_OPTION)
               roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi));
              else roi = &(win->image_view_roi);
            err = GetFilledRoiMask(roi,win->control.sroi.localto,&mask,&affected);}
          else err = GetFilledAllRoisMask(
                  &(win->control.sroi.sroi_win->slice_roi),
                  win->control.sroi.localto,&mask);
     if (err != NO_ERROR)
        {free_draw_mask_rec(&mask);
         win->dwin->display_status &= ~DISPLAY_PIXEL_TYPE;
         return err;}
     if (option == ROI_SUPERIMPOSE_OPTION) bound = &affected;
       else bound = NULL;
     PRT4(printf("ROI_SUPERIMPOSE_OPTION......1\n"))
     err = WinSlicePixelTypeOverlay(win,&(mask.mask._2d),
               bound);
     PRT4(printf("ROI_SUPERIMPOSE_OPTION......2\n"))
     free_draw_mask_rec(&mask);
    }
 PRT4(printf("WinShowPixelTypesProc...end err = %d\n",err))
 return NO_ERROR;
}


/*---------------------------------------------------------------------
win_reshow_pixel_types - ???
---------------------------------------------------------------------*/

int
win_reshow_pixel_types(win)
 struct image_display_window *win;
{
 struct buf_2d_rec *slice_map;
 unsigned int offset_value;
 int err,option;

 PRT4(printf("win_reshow_pixel_types...display_status = %x\n",
      (unsigned long) win->dwin->display_status))
 if (win->dwin->display_status & DISPLAY_PIXEL_TYPE)
    {if (win->dwin->display_status & VALUE_SHOW_ROI_PIXEL_TYPE)
        option = ROI_SUPERIMPOSE_OPTION;
       else if (win->dwin->display_status & VALUE_SHOW_ALL_ROIS_PIXEL_TYPE)
        option = ROIS_SUPERIMPOSE_OPTION;
       else if (win->dwin->display_status & VALUE_SHOW_SLICE_PIXEL_TYPE)
        option = WHOLE_SLICE_SUPERIMPOSE_OPTION;
       else if (win->dwin->display_status & 
                        DISPLAY_VIEW_FILTER_ROI_TISSUE_TYPE)
        option = VIEW_FILTER_ROI_OPTION;

     PRT4(printf("win_reshow_pixel_types...1\n"))

     if ((err = win_get_img_map(win,&slice_map,&offset_value)) == NO_ERROR)
        {
         PRT4(printf("win_reshow_pixel_types...slice_map = %u buf = %u\n",
              slice_map,slice_map->buf))
         err = WinShowPixelTypesProc(win,slice_map,
               offset_value,option);}
     return err;
    }
 PRT4(printf("win_reshow_pixel_types...2\n"))
 return NO_ERROR;
}


/*---------------------------------------------------------------------
WinReshowPixelTypesToScreen - ???
---------------------------------------------------------------------*/

int
WinReshowPixelTypesToScreen(win)
 struct image_display_window *win;
{
 int err;

 PRT4(printf("WinReshowPixelTypesToScreen...2\n"))
 if ((err = win_reshow_pixel_types(win)) == NO_ERROR)
    {PRT4(printf("WinReshowPixelTypesToScreen...WinCanvas\n"))
     WinScreenCanvas(win);}
 PRT4(printf("WinReshowPixelTypesToScreen...end err = %d\n",err))

 return err;
}


/*---------------------------------------------------------------------
WinShowPixelTypes - ???
---------------------------------------------------------------------*/

int
WinShowPixelTypes(win,option)
 struct image_display_window *win;
 int option;
{
 struct buf_2d_rec *slice_map;
 int err;
 unsigned int offset_value;

 PRT4(printf("WinShowPixelTypes...begin...option = %d\n",option))
 if (!(option & DISPLAY_PIXEL_TYPE)) return CANCEL;
 if ((err = win_get_img_map(win,&slice_map,&offset_value)) != NO_ERROR)
    {win->dwin->display_status &= ~DISPLAY_PIXEL_TYPE;
     ShowMsgStrs(win->dwin->frame,0,err,0,2,
           "TO DISPLAY PIXEL TYPES, PLEASE DEFINE THE",
           "PIXEL TYPES FIRST !!!",NULL,0);
     return CANCEL;}
 if (option != VALUE_SHOW_SLICE_PIXEL_TYPE)
    {if (win->dwin->display_status & option)
        {win->dwin->display_status &= ~DISPLAY_PIXEL_TYPE;
         option = CLEAR_OPTION;}
       else
        {if (win->dwin->display_status & DISPLAY_PIXEL_TYPE)
            if ((err = WinShowPixelTypesProc(win,slice_map,
                 offset_value,CLEAR_OPTION)) !=
                 NO_ERROR)
               return err;

         win->dwin->display_status &= ~DISPLAY_PIXEL_TYPE;
         win->dwin->display_status |= option;
         if (option == VALUE_SHOW_ROI_PIXEL_TYPE)
            option = ROI_SUPERIMPOSE_OPTION;
           else option = ROIS_SUPERIMPOSE_OPTION;
        }
    }
   else
    {if (win->dwin->display_status & VALUE_SHOW_SLICE_PIXEL_TYPE)
        {win->dwin->display_status &= ~DISPLAY_PIXEL_TYPE;
         option = CLEAR_OPTION;}
       else
        {win->dwin->display_status &= ~DISPLAY_PIXEL_TYPE;
         win->dwin->display_status |= VALUE_SHOW_SLICE_PIXEL_TYPE;
         option = WHOLE_SLICE_SUPERIMPOSE_OPTION;}
    }
 if ((err = WinShowPixelTypesProc(win,slice_map,
               offset_value,option)) == NO_ERROR)
    {WinScreenCanvas(win);
     PRT4(printf("WinShowPixelTypes...win_redisplay_all_curves\n"))
     win_redisplay_all_curves(win);}
 PRT4(printf("WinShowPixelTypes...err = %d display_status = %x\n",
     err,win->dwin->display_status))
 return err;
}


/*---------------------------------------------------------------------
win_filter_image_tissue_types - ???
---------------------------------------------------------------------*/

int
win_filter_image_tissue_types(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct draw_mask_rec mask;
 struct int_bound_rec affected;
 struct buf_2d_rec _2d,*the_2d;
 int which_region,err;
 struct buf_2d_rec *slice_map;
 unsigned char *selected;
 struct curve_rec *curve;
 struct roi_rec *roi;

 TRACE(printf("win_filter_image_tissue_types status = %x\n",(unsigned long) win->status4))
 TRACE(pr_strs_rec(&(win->data_filter_types)))
 if (!(win->status4 & DISPLAY_TISSUE_TYPE)) return NO_ERROR;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
 if (win->status4 & DISPLAY_CUR_CURVE_TISSUE_TYPE)
    {if ((curve = get_cur_curve(&(win->control.sroi.sroi_win->slice_roi))) == NULL)
       return NO_ERROR;
     which_region = CUR_CURVE;}
   else if (win->status4 & DISPLAY_CUR_ROI_TISSUE_TYPE)
    {if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) == NULL)
       return NO_ERROR;
     which_region = CUR_ROI;}
   else if (win->status4 & DISPLAY_ALL_ROIS_TISSUE_TYPE)
    {if (!is_slice_roi_non_empty(&(win->control.sroi.sroi_win->slice_roi)))
       return NO_ERROR;
     which_region = ALL_ROIS;}
   else if (win->status4 & DISPLAY_VIEW_FILTER_ROI_TISSUE_TYPE)
    {if (!is_roi_non_empty(&(win->image_view_roi)))
       return NO_ERROR;
     which_region = IMAGE_FILTER_ROI;}
   else which_region = 0;

 TRACE(printf("win_filter_image_tissue_types 1\n"))

 if ((img->file->pixel_type.order.num_strs > 0) &&
     (win->data_filter_types.num_strs > 0))
    {if ((slice_map = get_cur_slice_map(img->file,img->cur_slice)) == NULL) 
        return NO_ERROR;

     if ((err = selected_strs(&(img->file->pixel_type.order),
             &(win->data_filter_types),&selected)) != NO_ERROR)
        return err;
     if (selected == NULL) return NO_ERROR;
     TRACE(printf("win_filter_image_tissue_types selected = %u slice_map = %u\n",
               selected,slice_map))
    }
   else if (!which_region)
    return NO_ERROR;
   else selected = NULL;

 the_2d = &(img->_2d);
 TRACE(printf("win_filter_image_tissue_types 2\n"))
 init_buf_2d_rec(&_2d);
 if ((err = SetupBuf2dRec(&_2d,the_2d->dimx,the_2d->dimy,the_2d->pixel_depth,
                 the_2d->status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    {
     c_free(selected);
     free_buf_2d_rec(&_2d);
     return err;}

 InitBuf2dRecData(&_2d,(double) .0);
 TRACE(printf("win_filter_image_tissue_types which_region = %d\n",which_region))
 if (which_region)
    {
     init_draw_mask_rec(&mask);
     TRACE(printf("win_filter_image_tissue_types 3\n"))
     err = GetRoiMask(&(win->control.sroi.sroi_win->slice_roi),
          win->control.sroi.localto,
         img->_2d.dimx,img->_2d.dimy,&mask,&affected,which_region,
         &(win->image_view_roi));
     TRACE(printf("win_filter_image_tissue_types 4 err = %d\n",err))
     if (err == NO_ERROR)
        {if (win->status4 & UNSELECTED_TISSUE_UNAFFECTED)
            assign_buf_2d_rec_by_not_mask(&_2d,the_2d,0,0,&(mask.mask._2d),NULL);
         if (selected != NULL)
            {
             process_buf_2d_rec_by_mask(slice_map,0,0,&(mask.mask._2d),&affected,
                  select_pixel_type_mask_proc,&(mask.mask._2d),selected,
                  0,0,0,0,0,0,0);
             TRACE(printf("win_filter_image_tissue_types 4\n"))
            }
         assign_buf_2d_rec_by_mask(&_2d,the_2d,0,0,&(mask.mask._2d),&affected);
        }
     TRACE(printf("win_filter_image_tissue_types 5\n"))
     free_draw_mask_rec(&mask);
    }
   else PickAssign2d(&_2d,the_2d,slice_map,0,0,NULL,NULL,selected,
          img->file->pixel_type.order.num_strs + 1);
 TRACE(printf("win_filter_image_tissue_types err = %d\n",err))
 if (err == NO_ERROR)
    {MinMax2d(the_2d,0,(double) .0,(double) .0);
     copy_buf_2d_rec_hdr_only(&_2d,the_2d);

     err = copy_buf_2d_rec_content(the_2d,&_2d);
    }
 c_free(selected);
 free_buf_2d_rec(&_2d);
 return err;
}


/*---------------------------------------------------------------------
disable_display_tissue_type - ???
---------------------------------------------------------------------*/

int
disable_display_tissue_type(win)
 struct image_display_window *win;
{
 win->status4 &= ~DISPLAY_TISSUE_TYPE;
 free_strs_rec(&(win->data_filter_types));
 return NO_ERROR;
}


/*---------------------------------------------------------------------
enable_display_tissue_type - ???
---------------------------------------------------------------------*/

int
enable_display_tissue_type(win,option)
 struct image_display_window *win;
 int option;
{
 struct all_anal_dp_option_recs *all_dps;
 struct anal_dp_option_rec *dp;
 struct strs_rec types;
 int err;

 TRACE(printf("enable_display_tissue_type...option = %d\n",option))
 win->status4 &= ~DISPLAY_TISSUE_TYPE;
 if (option == CUR_CURVE) win->status4 |= DISPLAY_CUR_CURVE_TISSUE_TYPE;
   else if (option == CUR_ROI) win->status4 |= DISPLAY_CUR_ROI_TISSUE_TYPE;
   else if (option == ALL_ROIS) win->status4 |= DISPLAY_ALL_ROIS_TISSUE_TYPE;
   else if (option == IMAGE_FILTER_ROI) 
    win->status4 |= DISPLAY_VIEW_FILTER_ROI_TISSUE_TYPE;
   else 
    {option = 0;
     win->status4 |= DISPLAY_SLICE_TISSUE_TYPE;}
 if ((all_dps = (struct all_anal_dp_option_recs *) 
           enter_anal_display_options(NULL,GET_ALL_DP_PTR)) != NULL)
    if ((dp = find_anal_dp_option_rec_1(all_dps,win)) != NULL)
       {init_strs_rec(&types);
        if ((err = selected_list_items(&types,dp->types)) == NO_ERROR)
           {free_strs_rec(&(win->data_filter_types));
            win->data_filter_types = types;}
          else free_strs_rec(&types);
        TRACE(printf("enable_display_tissue_type option = %d\n",option);)
        xv_set(dp->which_region,PANEL_LIST_SELECT,option,1,0);
       }
 return NO_ERROR;
}


/*---------------------------------------------------------------------
win_image_tissue_type_to_screen - ???
---------------------------------------------------------------------*/

int
win_image_tissue_type_to_screen(win)
 struct image_display_window *win;
{
 int err;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
     return CANCEL;
 RdSlice(img,0,NULL,4);
 if ((err = win_filter_image_tissue_types(win)) != NO_ERROR)
    disable_display_tissue_type(win);
 WinNewColorMultiCanvas(win);
 return err;
}


/*---------------------------------------------------------------------
dp_show_proc - ???
---------------------------------------------------------------------*/

void
dp_show_proc(item,event)
 Panel_item item;
 Event event;
{
 struct anal_dp_option_rec *dp;
 int option;

 dp = (struct anal_dp_option_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dp->win->status4 &= ~DISPLAY_TISSUE_TYPE;
 if (next_selected_item(dp->which_region,0,&option) != NO_ERROR)
     return;

 xv_set(dp->frame,FRAME_BUSY,TRUE,0);
 TRACE(printf("dp_show_proc option = %d\n",option);)
 if (dp->win->status4 & DONT_APPLY_SAME_TISSUE_TO_STACK_WINS)
    {if (enable_display_tissue_type(dp->win,option) == NO_ERROR)
        win_image_tissue_type_to_screen(dp->win);}
 else if (WinRunProcInList(WIN_LIST,dp->win,enable_display_tissue_type,
			   option,0,0,0,0,0) == NO_ERROR)
    WinRunProcInList(WIN_LIST,dp->win,win_image_tissue_type_to_screen,
		     0,0,0,0,0,0);
 xv_set(dp->frame,FRAME_BUSY,FALSE,0);
 return;
}


/*---------------------------------------------------------------------
unselected_to_background_proc - ???
---------------------------------------------------------------------*/

void
unselected_to_background_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct anal_dp_option_rec *dp;

 dp = (struct anal_dp_option_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value) dp->win->status4 &= ~UNSELECTED_TISSUE_UNAFFECTED;
 else       dp->win->status4 |=  UNSELECTED_TISSUE_UNAFFECTED;
}


/*---------------------------------------------------------------------
apply_to_stack_proc - ???
---------------------------------------------------------------------*/

void
apply_to_stack_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct anal_dp_option_rec *dp;

 dp = (struct anal_dp_option_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value) dp->win->status4 &= ~DONT_APPLY_SAME_TISSUE_TO_STACK_WINS;
   else dp->win->status4 |= DONT_APPLY_SAME_TISSUE_TO_STACK_WINS;
}


/*---------------------------------------------------------------------
dp_original_proc - ???
---------------------------------------------------------------------*/

void
dp_original_proc(item,event)
 Panel_item item;
 Event event;
{
 struct anal_dp_option_rec *dp;
 struct display_win_rec *dwin;
 int option;

 dp = (struct anal_dp_option_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dwin = dp->win->dwin;
 dp->win->dwin = dp->dwin;
 option = dp->win->status4 & DISPLAY_TISSUE_TYPE;
 dp->win->status4 &= ~DISPLAY_TISSUE_TYPE;
 WinNewImgMultiCanvas(dp->win);
 dp->win->status4 |= option;
 dp->win->dwin = dwin;
}


/*---------------------------------------------------------------------
dp_reset_proc - ???
---------------------------------------------------------------------*/

void
dp_reset_proc(item,event)
 Panel_item item;
 Event event;
{
 struct anal_dp_option_rec *dp;

 dp = (struct anal_dp_option_rec *) xv_get(item,PANEL_CLIENT_DATA);
 WinRunProcInList(WIN_LIST,dp->win,disable_display_tissue_type,0,0,0,0,0,0);
 WinRunProcInList(WIN_LIST,dp->win,WinNewImgMultiCanvas,0,0,0,0,0,0);
}


/*---------------------------------------------------------------------
setup_anal_dp_option_rec - ???
---------------------------------------------------------------------*/

int
setup_anal_dp_option_rec(dp,win)
 struct anal_dp_option_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;
 Panel_item item;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_anal_dp_option_rec...1\n"))
 if (dp->frame == 0)
    {free_anal_dp_option_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,FILTER_SHOW_TISSUES);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,dp_anal_dp_options_frame_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_anal_dp_option_rec(dp);
     return CANCEL;}
 row = 0;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 10;
 dp->types = xv_create(dp->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_LABEL_STRING,"PIXEL TYPES",
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,4,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,0);
 
 setup_list_items(&(img->file->pixel_type.order),dp->types,0);
 if (win->status4 & DISPLAY_TISSUE_TYPE) 
    select_list_items(&(win->data_filter_types),dp->types);

 rr = (Rect *) xv_get(dp->types,XV_RECT);
 dp->which_region = xv_create(dp->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_LABEL_STRING,"REGION",
        PANEL_CHOOSE_ONE,TRUE,
        PANEL_LIST_STRINGS,"CUR SLICE -<Sh>M ","CUR CURVE - <",
              "CUR ROI - >","ALL ROIS - ?","VIEW FILTER ROI",NULL,
        PANEL_LIST_DISPLAY_ROWS,4,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,dp,0);
 if (win->status4 & DISPLAY_TISSUE_TYPE) 
    if (win->status4 & DISPLAY_CUR_CURVE_TISSUE_TYPE)
       xv_set(dp->which_region,PANEL_LIST_SELECT,1,1,0);
      else if (win->status4 & DISPLAY_CUR_ROI_TISSUE_TYPE)
       xv_set(dp->which_region,PANEL_LIST_SELECT,2,1,0);
      else if (win->status4 & DISPLAY_ALL_ROIS_TISSUE_TYPE)
       xv_set(dp->which_region,PANEL_LIST_SELECT,3,1,0);
      else if (win->status4 & DISPLAY_VIEW_FILTER_ROI_TISSUE_TYPE)
       xv_set(dp->which_region,PANEL_LIST_SELECT,4,1,0);
      else xv_set(dp->which_region,PANEL_LIST_SELECT,0,1,0);

 TRACE(printf("ok333.,...win->status4 = %x",(unsigned long) win->status4))
 row = rr->r_top + rr->r_height + 5;
 item = xv_create(dp->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"UNSELECTED REGION = BACKGROUND",NULL,
        PANEL_VALUE,1,
        PANEL_NOTIFY_PROC,unselected_to_background_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,row,
        0);
 if (win->status4 & UNSELECTED_TISSUE_UNAFFECTED)
    xv_set(item,PANEL_VALUE,0,0);

 if (win->list.next != win->list.head)
    {row += offset;
     item = xv_create(dp->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"APPLY TO STACK WINDOWS",NULL,
        PANEL_NOTIFY_PROC,apply_to_stack_proc,
        PANEL_CLIENT_DATA,dp,
        PANEL_VALUE,1,
        XV_X,5,XV_Y,row,
        0);
     if (win->status4 & DONT_APPLY_SAME_TISSUE_TO_STACK_WINS)
        xv_set(item,PANEL_VALUE,0,0);
    }

 row += offset;
 str = "FILTER TISSUE";
 xv_create(dp->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,str,
        PANEL_NOTIFY_PROC,dp_show_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,row,
        0);

 str = "CUR WINDOW ORIGINAL";
 xv_create(dp->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,dp_original_proc,
                   XV_Y,row,
                   PANEL_CLIENT_DATA,dp,
                   0);

 str = "RESET";
 xv_create(dp->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,dp_reset_proc,
                   XV_Y,row,
                   PANEL_CLIENT_DATA,dp,
                   0);

 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_HEIGHT,rr->r_height - 10,XV_WIDTH,rr->r_width - 10,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*---------------------------------------------------------------------
find_anal_dp_option_rec - ???
---------------------------------------------------------------------*/

struct anal_dp_option_rec *
find_anal_dp_option_rec(all_dps,win)
 struct all_anal_dp_option_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    {
     if (all_dps->dps[lcv]->win == win) return all_dps->dps[lcv];
/*
     head1 = head_list(&(win->list));
     head2 = head_list(&(all_dps->dps[lcv]->win->list));
     TRACE(printf("win = %u dp win = %u head = %u dp head = %u\n",
            win,all_dps->dps[lcv]->win,head1,head2))
     if (head1 == head2)
        return all_dps->dps[lcv];
*/
    }
 return NULL;
}


/*---------------------------------------------------------------------
find_anal_dp_option_rec_1 - ???
---------------------------------------------------------------------*/

struct anal_dp_option_rec *
find_anal_dp_option_rec_1(all_dps,win)
 struct all_anal_dp_option_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;
 struct list_rec *head1,*head2;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    {
     if (all_dps->dps[lcv]->win == win) return all_dps->dps[lcv];
     head1 = head_list(&(win->list));
     head2 = head_list(&(all_dps->dps[lcv]->win->list));
     TRACE(printf("win = %u dp win = %u head = %u dp head = %u\n",
            win,all_dps->dps[lcv]->win,head1,head2))
     if (head1 == head2)
        return all_dps->dps[lcv];
    }
 return NULL;
}


/*---------------------------------------------------------------------
enter_anal_display_options - ???
---------------------------------------------------------------------*/

int
enter_anal_display_options(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_anal_dp_option_recs all_dps;
 struct anal_dp_option_rec *dp;
 static char first_time = 1;
 int err;

 TRACE(printf("enter_anal_display_options...0\n"))
 err = NO_ERROR;
 if (first_time)
    {init_all_anal_dp_option_recs(&all_dps);
     first_time = 0;}
 if (status == GET_ALL_DP_PTR)
    {return (unsigned long) &all_dps;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_ANAL_DP_OPTIONS)
   {if ((dp = find_anal_dp_option_rec(&all_dps,win)) != NULL)
       free_anal_dp_option_rec(dp);
    return NO_ERROR;}
 TRACE(printf("enter_anal_display_options...1\n"))
 if ((dp = find_anal_dp_option_rec(&all_dps,win)) != NULL)
    if (dp->win == win)
       {xv_set(dp->frame,
               XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
        win_set_mouse_at_center(dp->frame);
        wmgr_top(dp->frame);
        return NO_ERROR;}
      else free_anal_dp_option_rec(dp);
 TRACE(printf("enter_anal_display_options...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct anal_dp_option_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_anal_dp_option_rec(dp);
 TRACE(printf("enter_anal_display_options...2\n"))
 if ((err = setup_anal_dp_option_rec(dp,win)) == NO_ERROR)
    {TRACE(printf("setup_anal_dp_option_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               FILTER_SHOW_TISSUES,NULL,0);
 return err;

}

