/****************************************************************************
break_objects.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: break_objects.c,v 1.10 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "object.h"
#include "edge.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)



/* Functions defined in this file */
int qualify_breaker_and_cut_region(struct buf_2d_rec *_2d,
    struct coord_rec *breaker);
int add_breaker(struct all_object_rec *all_objs, struct coord_rec *breaker);
int enter_xy_into_cur_obj_with_breaker(struct all_object_rec *all_objs,
    long x, long y, struct buf_2d_rec *breaker);
int detect_all_objs_with_breaker(struct all_object_rec *all_objs,
    int update_id_2d, struct buf_2d_rec *breaker);
int break_objects(struct all_object_rec *all_objs, struct coord_rec *breaker,
    struct curve_rec ***curves, unsigned int *total_curves,
    unsigned int *num_curves);
int get_breaker_coords(struct coord_rec *coords, unsigned int dimx,
    unsigned int dimy, struct roi_rec *breaker);
int ScanAndBreakCurCurve(struct curve_rec *cur_curve,
    struct matrix_2d_rec *localto, unsigned int pen_type,
    struct roi_rec *breaker, struct curve_rec ***curves,
    unsigned int *total_curves, unsigned int *num_curves);



/*------------------------------------------------------------------------
qualify_breaker_and_cut_region - ???
------------------------------------------------------------------------*/

int
qualify_breaker_and_cut_region(_2d,breaker)
 struct buf_2d_rec *_2d;
 struct coord_rec *breaker;
{
 long *indxs;
 unsigned long total,lcv;
 int err;
 long val,x,y;

 if (breaker->num_pts == 0) return NO_ERROR;
 total = 0;
 get_ptr_memory(&indxs,&total,breaker->num_pts,(size_t) sizeof(*indxs),&err);
 if (err != NO_ERROR) return err;
 for (total = lcv = 0; lcv < breaker->num_pts; lcv++)
    {x = breaker->pts[lcv].x;
     y = breaker->pts[lcv].y;
     if ((x >= 0) && (x < _2d->dimx) && (y >= 0) && (y < _2d->dimy))
        {val = get_1d_buf_value(_2d->buf[y],x,_2d->pixel_depth);
         if (val)
            {set_1d_buf_value(_2d->buf[y],x,_2d->pixel_depth,0);
             indxs[total++] = lcv;}
        }
    }
 if (total != breaker->num_pts)
    {TRACE(printf("qualify_breaker_and_cut_region total = %d breaker->num_pts = %d\n",
               total,breaker->num_pts))
     breaker->num_pts = total;
     if (total > 0) 
        {for (lcv = 0; lcv < total; lcv++)
            {
             if (indxs[lcv] != lcv)
                breaker->pts[lcv] = breaker->pts[indxs[lcv]];
            }
        }
    }
 c_free(indxs);

 return err;
}


/*------------------------------------------------------------------------
add_breaker - ???
------------------------------------------------------------------------*/

int
add_breaker(all_objs,breaker)
 struct all_object_rec *all_objs;
 struct coord_rec *breaker;
{
 long lcv,cnt,ids[8],num_ids,val,x,y,indx;
 struct object_rec *obj;
 int err;

/*
 for (num_ids = 0,lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     obj = all_objs->objs[lcv];
     for (cnt = 0; cnt < obj->num_pts; cnt++)
        {x = obj->pts[lcv].x;
         y = obj->pts[lcv].y;
         val = get_1d_buf_value(all_objs->id_2d.buf[y],x,
                      all_objs->id_2d.pixel_depth);
         if (val)
            {for (indx = 0; indx < num_ids; indx++)
                if (val == ids[indx]) break;
                 if (indx == num_ids)
                    {
                     ids[num_ids++] = val;
                    }
            }
        }
    }
 for (row = all_objs->bound.top; row <= all_objs->bound.bottom; row++)
    for (col = all_objs->bound.left; col <= all_objs->bound.right; col++)
       {
        val = get_1d_buf_value(all_objs->id_2d.buf[row],col,
                                all_objs->id_2d.pixel_depth);
        if (val == 1)
           {val = get_1d_buf_value(all_objs->in_2d->buf[row],col,
                                all_objs->in_2d->pixel_depth);
            printf("x/y = %d/%d == 1   val = %d\n",col,row,val);}
      }
 for (indx = 0; indx < num_ids; indx++)
    printf("%d) indx = %d cnt_2d = %d\n",indx,ids[indx],
              CntValBuf2dRec(&(all_objs->id_2d),(double) ids[indx]));
*/
 for (lcv = 0; lcv < breaker->num_pts; lcv++)
    {for (num_ids = cnt = 0; cnt < 8; cnt++)
        {x = breaker->pts[lcv].x + _EdgeOffset[cnt][0];
         y = breaker->pts[lcv].y + _EdgeOffset[cnt][1];
         if ((x >= all_objs->bound.left) && (x <= all_objs->bound.right) &&
             (y >= all_objs->bound.top) && (y <= all_objs->bound.bottom))
            {val = get_1d_buf_value(all_objs->id_2d.buf[y],x,
                      all_objs->id_2d.pixel_depth);
             if (val)
                {for (indx = 0; indx < num_ids; indx++)
                    if (val == ids[indx]) break;
                 if (indx == num_ids)
                    {
                     ids[num_ids++] = val;
                    }
                }
            }
        }
     
     for (indx = 0; indx < num_ids; indx++)
        {
         if ((obj = get_obj(all_objs,ids[indx],&err)) != NULL)
            {
             /*if (obj->num_pts == 0)
                {printf("*** obj->num_pts == 0 *** num_ids = %d indx = %d ids[indx] = %d\n",
                         num_ids,indx,ids[indx]);
                 printf("cnt_2d = %d\n",
                    CntValBuf2dRec(&(all_objs->id_2d),(double) ids[indx]));
                 pr_object_rec(obj,1,0);}*/

             enter_obj_xy(obj,(unsigned char) OBJ_BOUNDARY_PT,
                 (int) breaker->pts[lcv].x,(int) breaker->pts[lcv].y);}
           else
            {/* printf("object not found...\n"); */
             return err;}
        }
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
enter_xy_into_cur_obj_with_breaker - ???
------------------------------------------------------------------------*/

int
enter_xy_into_cur_obj_with_breaker(all_objs,x,y,breaker)
 struct all_object_rec *all_objs;
 long x,y;
 struct buf_2d_rec *breaker;
{
 int err,err1;
 long ids[4],num_ids;
 unsigned char neighbors,status;
 static unsigned char internal_pt = 0x3a;
 long tempx,tempy,val;
 struct object_rec *src_obj;
 unsigned long lcv;
 static int xy[4][2] = {{ -1, -1},{ 0, -1},{ 1, -1},{-1, 0}};

 neighbors = 0;
 if (all_objs->cur_obj == NULL)
    {all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
     if (err != NO_ERROR) return err;
    }
   else
    {num_ids = 0;
     for (lcv = 0; lcv < 4; lcv++)
        {tempx = x + xy[lcv][0];
         tempy = y + xy[lcv][1];
         if ((tempx >= all_objs->bound.left) && 
             (tempx <= all_objs->bound.right) &&
             (tempy >= all_objs->bound.top) &&
             (tempy <= all_objs->bound.bottom))
            {
             if (val = get_1d_buf_value(all_objs->id_2d.buf[tempy],tempx,
                        all_objs->id_2d.pixel_depth))
                {
                 if ((lcv == 0) || (lcv == 2))
                    {
                     if (get_1d_buf_value(breaker->buf[tempy],x,
                              breaker->pixel_depth) &&
                         get_1d_buf_value(breaker->buf[y],tempx,
                              breaker->pixel_depth))
                        {
                         continue;}
                    } 
                 ids[num_ids++] = val;
                 neighbors |= (1 << lcv);
                }
            }
        }
     if (num_ids == 0)
        {
         all_objs->cur_obj = get_obj(all_objs,all_objs->next_id,&err);
         if (err != NO_ERROR) return err;
        }
       else
        {for (lcv = 1; lcv < num_ids; lcv++)
            if (ids[lcv - 1] != ids[lcv]) break;
         if (lcv == num_ids)
            {if (ids[0] != all_objs->cur_obj->id)
                {all_objs->cur_obj = get_obj(all_objs,ids[0],&err);
                 if (err != NO_ERROR) return err;
                }
            }
           else 
            {for (lcv = 0; lcv < num_ids; lcv++)
                if (all_objs->cur_obj->id == ids[lcv])
                   break;
             if (lcv == num_ids)
                {all_objs->cur_obj = get_obj(all_objs,ids[0],&err);
                 if (err != NO_ERROR) return err;
                 lcv = 1;}
               else lcv = 0;
             for (; lcv < num_ids; lcv++)
                if (all_objs->cur_obj->id != ids[lcv])
                  {src_obj = get_obj(all_objs,ids[lcv],&err1);
                   if (err1 == NO_ERROR)
                      merge_objs(all_objs,all_objs->cur_obj,src_obj);
                  }
            }
        }
     if (((neighbors & 0x0a) == 0x0a))
        {tempx = x + 1;
         if ((tempx >= all_objs->bound.left) &&
             (tempx <= all_objs->bound.right))
            if (get_1d_buf_value(all_objs->in_2d->buf[y],tempx,
                        all_objs->in_2d->pixel_depth))
               {neighbors |= 16;
                tempy = y + 1;
                if ((tempy >= all_objs->bound.top) &&
                    (tempy <= all_objs->bound.bottom))
                   if (get_1d_buf_value(all_objs->in_2d->buf[tempy],x,
                        all_objs->in_2d->pixel_depth))
                      neighbors |= 32;
               }
        }

    }
 
 if ((neighbors & internal_pt) == internal_pt) status = OBJ_INTERNAL_PT;
   else status = OBJ_BOUNDARY_PT;
 if ((err = enter_obj_xy(all_objs->cur_obj,status,x,y)) == NO_ERROR)
    set_1d_buf_value(all_objs->id_2d.buf[y],
                    x,all_objs->id_2d.pixel_depth,
                     (unsigned int) all_objs->cur_obj->id);

 return err;
}


/*------------------------------------------------------------------------
detect_all_objs_with_breaker - ???
------------------------------------------------------------------------*/

int
detect_all_objs_with_breaker(all_objs,update_id_2d,breaker)
 struct all_object_rec *all_objs;
 int update_id_2d;
 struct buf_2d_rec *breaker;
{
 unsigned long row,col,val;
 int err;

 for (row = all_objs->bound.top; row <= all_objs->bound.bottom; row++)
    for (col = all_objs->bound.left; col <= all_objs->bound.right; col++)
       {
        val = get_1d_buf_value(all_objs->in_2d->buf[row],col,
                                all_objs->in_2d->pixel_depth);
        if ((val >= all_objs->lbval) && (val <= all_objs->ubval))
           if ((err = enter_xy_into_cur_obj_with_breaker(all_objs,col,row,
                              breaker)) != NO_ERROR)
              return err;
       }
/*
 printf("detect_all_objs_with_breaker...\n");
 printf("id_2d[199][140] = %d\n",get_1d_buf_value(all_objs->id_2d.buf[199],140,
                                all_objs->id_2d.pixel_depth));
*/
 merge_all_objs_rec_merged_objs(all_objs,update_id_2d,0);
/*
 printf("detect_all_objs_with_breaker....\n");
     pr_all_object_rec(all_objs,0);
*/
 return NO_ERROR;
}


/*------------------------------------------------------------------------
break_objects - ???
------------------------------------------------------------------------*/

int
break_objects(all_objs,breaker,curves,total_curves,num_curves)
 struct all_object_rec *all_objs;
 struct coord_rec *breaker;
 struct curve_rec ***curves;
 unsigned int *total_curves,*num_curves;
{
 int err;
 struct int_bound_rec bound;
 int lcv;
 struct buf_2d_rec breaker_2d;

 bound = all_objs->bound;
 init_buf_2d_rec(&breaker_2d);
 if ((err = SetupBuf2dRec(&breaker_2d,all_objs->in_2d->dimx,
            all_objs->in_2d->dimy,1,1)) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < breaker->num_pts; lcv++)
    if ((breaker->pts[lcv].x >= 0) && (breaker->pts[lcv].x < breaker_2d.dimx) &&
        (breaker->pts[lcv].y >= 0) && (breaker->pts[lcv].y < breaker_2d.dimy))
       set_1d_buf_value(breaker_2d.buf[breaker->pts[lcv].y],
                (unsigned int) breaker->pts[lcv].x,breaker_2d.pixel_depth,1);

 if ((err = qualify_breaker_and_cut_region(all_objs->in_2d,breaker)) != 
        NO_ERROR)
    {free_buf_2d_rec(&breaker_2d);
     return err;}
 if (breaker->num_pts == 0)
    {free_buf_2d_rec(&breaker_2d);
     return NO_ERROR;}

 if (((err = setup_all_object_rec(all_objs,all_objs->in_2d,NULL,0,
                    &bound,1,1)) == NO_ERROR) &&
     ((err = detect_all_objs_with_breaker(all_objs,1,&breaker_2d)) == NO_ERROR) &&
     ((err = add_breaker(all_objs,breaker)) == NO_ERROR))
    {TRACE(printf("after detect_all_objs_with_breaker....breaker->num_pts = %d\n",
         breaker->num_pts);
         pr_all_object_rec(all_objs,0);)
     err = get_all_obj_curve_recs(all_objs,curves,
                total_curves,num_curves);}

 free_buf_2d_rec(&breaker_2d);

 return err;

}


/*------------------------------------------------------------------------
get_breaker_coords - ???
------------------------------------------------------------------------*/

int
get_breaker_coords(coords,dimx,dimy,breaker)
 struct coord_rec *coords;
 unsigned int dimx,dimy;
 struct roi_rec *breaker;
{
 long lcv,cnt;
 int err;
 unsigned long total_pts_draw;

 TRACE(printf("get_breaker_coords...breaker->num_pens = %d\n",
        breaker->num_pens))

 for (lcv = 0; lcv < breaker->num_pens; lcv++)
    {
     TRACE(printf("...%d) num_curves = %d  coords->num_pts = %d\n",lcv,
        breaker->pens[lcv]->num_curves,coords->num_pts);)

     for (cnt = 0; cnt < breaker->pens[lcv]->num_curves; cnt++)
        {
         if ((breaker->pens[lcv]->curves[cnt] != NULL) &&
             (breaker->pens[lcv]->curves[cnt]->num_xys > 0))
            if ((err = DrawInBuf(NULL,0,0,dimx - 1,dimy - 1,0,
                breaker->pens[lcv]->curves[cnt]->xys,
                breaker->pens[lcv]->curves[cnt]->num_xys,
                breaker->pens[lcv]->pen_type,NULL,0,1,
                coords,&total_pts_draw,NULL)) != 
                 NO_ERROR)
               return err;
        }
    }
 TRACE(printf("get_breaker_coords..final.coords->num_pts = %d\n",coords->num_pts))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
ScanAndBreakCurCurve - ???
------------------------------------------------------------------------*/

int
ScanAndBreakCurCurve(cur_curve,localto,pen_type,breaker,
                     curves,total_curves,num_curves)
 struct curve_rec *cur_curve;
 struct matrix_2d_rec *localto;
 unsigned int pen_type;
 struct roi_rec *breaker;
 struct curve_rec ***curves;
 unsigned int *total_curves,*num_curves;
{
 struct coord_rec coords,coords1;
 struct all_object_rec all_objs;
 struct buf_2d_rec _2d;
 unsigned int dimx,dimy;
 int err;
 struct int_bound_rec bound;
 long minx,maxx,miny,maxy,lcv;


 if (breaker == NULL) return NO_ERROR;
 *curves = NULL;
 *total_curves = *num_curves = 0;
 init_coord_rec(&coords);
 init_coord_rec(&coords1);
 init_all_object_rec(&all_objs);
 init_buf_2d_rec(&_2d);
 if (FindCurveLongMinMax(cur_curve,localto,&minx,&maxx,&miny,&maxy,
            (unsigned short) pen_type,0,0,0) != NO_ERROR)
    return NO_ERROR;

 dimx = maxx + 1;
 dimy = maxy + 1;
 if ((err = SetupBuf2dRec(&_2d,dimx,dimy,1,1)) != NO_ERROR) return err;

 setup_int_bound_rec(&bound,minx,miny,maxx,maxy);
 if (((err = setup_all_object_rec(&all_objs,&_2d,NULL,0,
                    &bound,1,1)) == NO_ERROR) &&
     ((err = FillObjRegion(&all_objs,0,&cur_curve,1,localto,
           &coords,&_2d,1)) == NO_ERROR) &&
     ((err = get_breaker_coords(&coords1,dimx,dimy,breaker)) == NO_ERROR))
    err = break_objects(&all_objs,&coords1,curves,total_curves,num_curves);
 if (err == NO_ERROR)
    {for (lcv = 0; lcv < *num_curves; lcv++)
        {(*curves)[lcv]->status &= ~DRAW_MODE;
         if (is_curve_closed((*curves)[lcv])) 
            (*curves)[lcv]->status |= DRAW_FREE_CLOSED;
           else (*curves)[lcv]->status |= DRAW_FREE;
        }
     }
 free_buf_2d_rec(&_2d);
 free_all_object_rec1(&all_objs,1);
 free_coord_rec(&coords);
 free_coord_rec(&coords1);
 return err;
}

