/****************************************************************************
breaker.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: breaker.c,v 1.9 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

/* FIXME: Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRINT(x) printf(x);fflush(stdout);
#define TRACE(x) x; fflush(stdout);
*/
#define PRINT(x) 
#define TRACE(x)


/* Functions defined in this file */
int win_setup_breaker(struct image_display_window *win);
int win_paint_breaker(struct image_display_window *win);
int win_clear_breaker(struct image_display_window *win);
int win_erase_breaker(struct image_display_window *win);
int win_hide_breaker(struct image_display_window *win);
int win_must_show_breaker(struct image_display_window *win);
int win_show_breaker(struct image_display_window *win);
int win_move_show_breaker(struct image_display_window *win);
void win_display_breaker(struct image_display_window *win);
void win_delete_breaker(struct image_display_window *win);
int save_for_checking(struct image_display_window *win,
    struct roi_rec *breaker_roi, char *cur_curve_label,
    struct curve_rec *cur_curve);
int win_break_cur_curve_1(struct image_display_window *win);
int win_break_cur_curve(struct image_display_window *win);
int win_break_undo_cur_curve(struct image_display_window *win);



/*------------------------------------------------------------------------
win_setup_breaker - ???
------------------------------------------------------------------------*/

int
win_setup_breaker(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *breaker_mask;
 struct slice_roi_rec *breaker;
 unsigned long dimx,dimy;
 int err;

 TRACE(printf("win_setup_breaker...\n"))
 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;
 breaker_mask = win_rec_get_breaker_mask(win->owner);
 if (!(breaker_mask->mask._2d.status4 & BUF_NON_EMPTY) ||
     (breaker_mask->mask._2d.dimx != dimx) ||
     (breaker_mask->mask._2d.dimy != dimy))
    err = get_draw_mask_rec(breaker_mask,dimx,dimy);
 if (err == NO_ERROR)
    {breaker = win_rec_get_breaker(win->owner);
     if (!is_slice_roi_non_empty(breaker))
        {TRACE(printf("win_setup_breaker...is_slice_roi_non_empty(breaker)\n"))

         err = setup_more_rois(breaker,BREAKER_LABEL,1);
        }
    }
 TRACE(printf("win_setup_breaker...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
win_paint_breaker - ???
------------------------------------------------------------------------*/

int
win_paint_breaker(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *breaker_mask;
 struct slice_roi_rec *breaker;
 int err;

 TRACE(printf("win_paint_breaker...\n"))
 if ((err = win_setup_breaker(win)) != NO_ERROR) return err;
 breaker_mask = win_rec_get_breaker_mask(win->owner);
 if (err == NO_ERROR)
    {breaker = win_rec_get_breaker(win->owner);
     TRACE(printf("win_paint_breaker..DrawCurRoiRec...\n"))
     err = DrawCurRoiRec(
                 breaker,NULL,breaker_mask,breaker_mask,0);}
 TRACE(printf("win_paint_breaker...end..err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
win_clear_breaker - ???
------------------------------------------------------------------------*/

int
win_clear_breaker(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *breaker_mask;

 if ((win->control.display_options & DISPLAY_BREAKER))
 breaker_mask = win_rec_get_breaker_mask(win->owner);
 if (!(breaker_mask->mask._2d.status4 & BUF_NON_EMPTY)) return CANCEL;
 clear_draw_masks(breaker_mask,1);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_erase_breaker - ???
------------------------------------------------------------------------*/

int
win_erase_breaker(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *breaker_mask;
 int err;

 breaker_mask = win_rec_get_breaker_mask(win->owner);
 if (!(breaker_mask->mask._2d.status4 & BUF_NON_EMPTY)) return CANCEL;
 set_paint_status(breaker_mask,1,PAINT_ERASE);
 err = paint_cur_curve_to_multiple_win(win,win->data.draw_masks,
         win->data.num_draw_masks,0);
 set_paint_status(breaker_mask,1,PAINT_SUPERIMPOSE);
 return err;
}


/*------------------------------------------------------------------------
win_hide_breaker - ???
------------------------------------------------------------------------*/

int
win_hide_breaker(win)
 struct image_display_window *win;
{
 int err;

 if (win->control.display_options & DISPLAY_BREAKER)
    {err = win_erase_breaker(win);
     win->control.display_options &= ~DISPLAY_BREAKER;
     win_set_control_pen_type(win,1);
    }
 return err;
}


/*------------------------------------------------------------------------
win_must_show_breaker - ???
------------------------------------------------------------------------*/

int
win_must_show_breaker(win)
 struct image_display_window *win;
{
 int err;

 if ((err = win_paint_breaker(win)) != NO_ERROR)
    if (err != CANCEL) return err;
 win->control.display_options |= DISPLAY_BREAKER;
 win->control.pen_type = DRAW_LINE;
 TRACE(printf("win_must_show_breaker paint_cur_curve_to_multiple_win\n"))
 paint_cur_curve_to_multiple_win(win,win->data.draw_masks,
                win->data.num_draw_masks,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_show_breaker - ???
------------------------------------------------------------------------*/

int
win_show_breaker(win)
 struct image_display_window *win;
{
 if (!(win->control.display_options & DISPLAY_BREAKER))
    return win_must_show_breaker(win);

 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_move_show_breaker - ???
------------------------------------------------------------------------*/

int
win_move_show_breaker(win)
 struct image_display_window *win;
{
 win_execute_proc_to_related_wins(win,win_erase_breaker,0,0);
 win_execute_proc_to_related_wins(win,win_must_show_breaker,0,0);

 win_execute_proc_to_related_wins(win,WinMultiCanvas,0,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_display_breaker - ???
------------------------------------------------------------------------*/

void
win_display_breaker(win)
 struct image_display_window *win;
{
 int err;

 if ((err = win_paint_breaker(win)) == NO_ERROR)
    win_execute_proc_to_related_wins(win,WinMultiCanvas,0,0);
}


/*------------------------------------------------------------------------
win_delete_breaker - ???
------------------------------------------------------------------------*/

void
win_delete_breaker(win)
 struct image_display_window *win;
{
 struct slice_roi_rec *breaker;

 breaker = win_rec_get_breaker(win->owner);
 delete_cur_roi_curve(breaker);
 win_execute_proc_to_related_wins(win,win_erase_breaker,0,0);
 win_execute_proc_to_related_wins(win,WinMultiCanvas,0,0);
}


/*------------------------------------------------------------------------
save_for_checking - ???
------------------------------------------------------------------------*/

int
save_for_checking(win,breaker_roi,cur_curve_label,cur_curve)
 struct image_display_window *win;
 struct roi_rec *breaker_roi;
 char *cur_curve_label;
 struct curve_rec *cur_curve;
{
 struct roi_rec *roi1;
 struct slice_roi_rec *slice_roi;
 char *str,str2[30];
 int err;

 slice_roi = &(win->owner->root->prog->cut_slice_roi);
/*
 printf("save_for_checking slice_roi->num_rois = %d\n",slice_roi->num_rois);
*/
 sprintf(str2,"%ld-",slice_roi->num_rois);
 str = NULL;
 if (((err = concat_strs(&str,2,str2,breaker_roi->label)) == NO_ERROR) &&
     ((err = setup_more_rois(slice_roi,str,0)) == NO_ERROR) &&
     ((roi1 = get_roi(slice_roi,str)) != NULL))
    err = JoinRoiRecs(roi1,breaker_roi,0,&(slice_roi->status),1.0,1.0,
                        NULL,NULL,NULL);
 c_free(str);
 str = NULL;
 if (((err = concat_strs(&str,2,str2,cur_curve_label)) == NO_ERROR) &&
     ((err = setup_more_rois(slice_roi,str,0)) == NO_ERROR) &&
     ((roi1 = get_roi(slice_roi,str)) != NULL))
    err = JoinCurveToRoiRec(roi1,cur_curve,
             cur_curve->status,0,&(slice_roi->status),1.0,1.0,NULL,NULL,NULL);
 c_free(str);
/*
 printf("save_for_checking out slice_roi->num_rois = %d\n",slice_roi->num_rois);
 pr_slice_roi_rec(slice_roi);
*/
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_break_cur_curve_1 - ???
------------------------------------------------------------------------*/

int
win_break_cur_curve_1(win)
 struct image_display_window *win;
{
 struct draw_mask_rec *breaker_mask;
 struct slice_roi_rec *breaker;
 int err;
 struct roi_rec *roi,*roi1,*roi2;
 struct draw_mask_rec mask;
 struct curve_rec **curves,*cur_curve;
 unsigned int num_curves,lcv,cnt,total_curves;
 struct curve_2d_rec *pen;
 char *str,str1[30];
 struct slice_roi_rec *slice_roi;
 unsigned long dimx,dimy;

 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;
 breaker_mask = win_rec_get_breaker_mask(win->owner);
 breaker = win_rec_get_breaker(win->owner);
 if (((roi = get_roi(breaker,BREAKER_LABEL)) == NULL) ||
     !is_roi_non_empty(roi)) return NO_ERROR;
 if ((err = win_paint_breaker(win)) != NO_ERROR) return CANCEL;
 TRACE(printf("win_break_cur_curve...\n"))
 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 if (!is_cur_curve_non_empty(slice_roi) ||
     ((roi1 = get_cur_roi(slice_roi)) == NULL) ||
     ((pen = get_cur_pen(slice_roi)) == NULL) ||
     ((cur_curve = get_cur_curve(slice_roi))== NULL))
    return CANCEL;

 TRACE(printf("win_break_cur_curve...1\n"))
 init_draw_mask_rec(&mask);
 if (((err = get_draw_mask_rec(&mask,dimx,dimy)) != NO_ERROR) ||
     ((err = DrawCurveRec(&mask,cur_curve,NULL,pen->pen_type)) 
           != NO_ERROR))
    {free_draw_mask_rec(&mask);
     return err;}

 TRACE(printf("win_break_cur_curve...2\n"))
 err = ScanAndBreakCurCurve(cur_curve,win->control.sroi.localto,
           (unsigned int) DRAW_LINE,roi,&curves,&total_curves,&num_curves);

 TRACE(printf("win_break_cur_curve...3\n"))
 if (err == NO_ERROR)
    {DeleteRoisOfType(breaker,BREAKER_ROI,1);
     if (num_curves > 2)
        save_for_checking(win,roi,roi1->label,cur_curve);

     delete_roi(breaker,roi);

     if (((err = setup_more_rois(breaker,roi1->label,0)) == NO_ERROR) &&
         ((roi = get_roi(breaker,roi1->label)) != NULL))
        roi->status |= BREAKER_ROI;
     TRACE(printf("win_break_cur_curve...4...err = %d\n",err))
     if (err == NO_ERROR)
        {
         if (breaker->prog_status & BREAKER_DELETE_CUR_REGION)
            if ((err = JoinCurveToRoiRec(roi,cur_curve,pen->pen_type,1,
                  &(breaker->status),1.0,1.0,NULL,NULL,NULL)) == NO_ERROR)
               delete_cur_curve(pen,&(slice_roi->status),1);
         if (err == NO_ERROR)
            {
             if (breaker->prog_status & BREAKER_LABEL_BREAKER_REGION)
                {for (lcv = 0; lcv < num_curves; lcv++)
                    FindTheCurveMinMax(curves[lcv],NULL,curves[lcv]->status,
                                   0,0,0);
                 qsort(curves,num_curves,
                       (size_t) sizeof(*curves),sort_curve_min_max_lt);}
             roi2 = roi1;
             for (cnt = lcv = 0; lcv < num_curves; lcv++)
                {if (!is_curve_non_empty(curves[lcv]))
                    {curves[lcv] = NULL;
                     continue;}
                 cnt += 1;
                 if (breaker->prog_status & BREAKER_LABEL_BREAKER_REGION)
                    {sprintf(str1,"-%d",cnt);
                     if (((err = concat_strs(&str,2,roi2->label,str1)) == NO_ERROR) &&
                         ((err = setup_more_rois(slice_roi,str,0)) == NO_ERROR))
                        if ((roi1 = get_roi(slice_roi,str)) == NULL)
                            roi1 = roi2;

                     c_free(str);}
                 if (err == NO_ERROR)
                    err = append_curve_to_roi_rec(roi1,curves[lcv],
                           curves[lcv]->status,0,&(slice_roi->status));

                 if (err != NO_ERROR) break;
                   else curves[lcv] = NULL;
                }
            }
        }
     win_execute_proc_to_related_wins(win,win_hide_breaker,0,0);
     if (!(breaker->prog_status & BREAKER_DISABLE_BREAKER_AFTER_APPLY))
        win_execute_proc_to_related_wins(win,win_must_show_breaker,0,0);
     win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
     TRACE(printf("win_break_cur_curve...5\n"))
    }
 if (total_curves > 0)
    {
     for (; lcv < num_curves; lcv++)
        if (curves[lcv] != NULL)
           {/*printf("free_curve_rec...\n");*/
            free_curve_rec(curves[lcv]);}
     if (num_curves > 0) c_free(curves);}

 TRACE(printf("win_break_cur_curve...7...err = %d\n",err))
 free_draw_mask_rec(&mask);
 if (err == NO_ERROR)
    update_dp_delete_roi_menu(win,1);

 return err;
}


/*------------------------------------------------------------------------
win_break_cur_curve - ???
------------------------------------------------------------------------*/

int
win_break_cur_curve(win)
 struct image_display_window *win;
{
 int err;

 if ((err = win_break_cur_curve_1(win)) != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
          "An error occurred when breaking up",
               "   the current curve !!!",NULL,0);
 return err;
}


/*------------------------------------------------------------------------
win_break_undo_cur_curve - ???
------------------------------------------------------------------------*/

int
win_break_undo_cur_curve(win)
 struct image_display_window *win;
{
 struct slice_roi_rec *breaker;
 struct roi_rec *roi;
 int err;

 breaker = win_rec_get_breaker(win->owner);
 /* FIXME!  Added final argument "0" in line below without being
    absolutely sure it's the right value.  -PWH 19990527 */
 if ((roi = get_roi_of_type(breaker,BREAKER_ROI,0)) == NULL)
     return CANCEL;
 if ((err = JoinRoiToSliceRoiRec(&(win->control.sroi.sroi_win->slice_roi),
                     roi,1,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR)
     return err;
 win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);

 return err;
}
