/****************************************************************************
count_output.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: count_output.c,v 1.7 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "text_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x)
#define PRT1(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT6(x)



#define NUM_ITEMS 12
#define NUM_FIELDS 14

/***
extern struct roi_rec *get_roi();
extern unsigned long NumberOfSliceScans();
extern unsigned long NumberOfSliceCuts();
***/


/* Functions defined in this file */
int WrCountOutputFileInfo(FILE *fid, struct input_file_rec *file,
    char **text_printing_time, struct output_text_format_rec *format,
    struct strs_rec *all_labels);
void compute_spaces(struct strs_rec *ptr, long *spaces, long total_fields,
    long num_lines);
int wr_line_token(FILE *fid, char *str, unsigned long str_len,
    unsigned long *cnt_spaces, unsigned long *num_lines, int max_line_chs);
int wr_lineup_lines(FILE *fid, struct strs_rec *ptr, long total_fields,
    long num_lines, int max_line_chs);
int count_output_label_ptrs(struct count_analysis_rec *count,
    struct strs_rec *all_labels);
int count_roi_label(struct roi_count_anal_rec *roi_count, char **label);
int SetupNegAndRejectionLine(struct strs_rec *line,
    struct slice_count_anal_rec *slice_count, long slice_num, long *num_lines,
    struct output_text_format_rec *format);
void NegAndRejectionTitle(char strs[14 ][30], unsigned long *num,
    struct output_text_format_rec *format, int is_for_all_slices);
int WrNegAndRejectionLine(FILE *fid, struct slice_count_anal_rec *all_slices,
    struct count_analysis_rec *count, struct output_text_format_rec *format);
int SetupCountValueLine1(struct strs_rec *line,
    struct slice_count_anal_rec *slice_count, long slice_num,
    double voxel_size, double pixel_area, long *num_lines);
int PrintCountOutputToFile(char *fn, struct input_file_rec *file,
    char **text_printing_time, struct output_text_format_rec *format,
    struct count_analysis_rec *count, unsigned short *status);
int file_save_count_output_to_file(struct input_file_rec *file,
    int to_printer);
int PrintCountOutputToTempFile(struct count_analysis_rec *count);
int win_save_count_output_to_file(struct image_display_window *win,
    int to_printer);



/*------------------------------------------------------------------------
WrCountOutputFileInfo - ???
------------------------------------------------------------------------*/

int
WrCountOutputFileInfo(fid,file,text_printing_time,format,all_labels)
 FILE *fid;
 struct input_file_rec *file;
 char **text_printing_time;
 struct output_text_format_rec *format;
 struct strs_rec *all_labels;
{
 char *str,*fn;
 int err;
 unsigned int lcv,num;
 float voxel_size;

 if (get_strlen(file->output.hdr.rater) == 0)
    fprintf(fid,"RATER = UNKNOWN\n");
   else fprintf(fid,"RATER = %s\n",file->output.hdr.rater);
 if (text_printing_time != NULL)
    {if (*text_printing_time == NULL)
        *text_printing_time = current_asctime();
     fprintf(fid,"PRINTING DATE : %s",*text_printing_time);}

 if (file->prog != NULL)
    {fprintf(fid,"PROGRAM : %s",file->prog->prog_name);
     fprintf(fid,"       VERSION : %s\n",file->prog->prog_id);}

 if ((err = build_fn(&str,file->dirfn,file->fn,
                     file->hdr_fn_suffix)) != NO_ERROR)
    return CANCEL;
 if ((err = concat_strs(&fn,3,str,"-",file->img_fn_suffix)) != NO_ERROR)
    {c_free(str);
     return CANCEL;}

 fprintf(fid,"INPUT FILES : 1) %s   VERSION : %s\n",fn,file->hdr.id);
 c_free(str);
 c_free(fn);

 if ((err = build_fn(&fn,file->output.dirfn,file->output.fn,
                     file->output.dat_fn_suffix)) != NO_ERROR)
    return CANCEL;
 fprintf(fid,"              2) %s   VERSION : %s\n",fn,
            file->output.hdr.id);
 c_free(fn);

 if ((err = build_fn(&fn,file->output.dirfn,file->output.fn,
                     COUNT_SUFFIX)) != NO_ERROR)
    return CANCEL;
 fprintf(fid,"OUTPUT FILE : 1) %s\n",fn);
 c_free(fn);

 fprintf(fid,"\n");
 fprintf(fid,"IMAGE INFO.\n");
 fprintf(fid,"   Default image dimension = %d * %d   Pixel size = %-d bits\n",
         (int) file->hdr.data_info.dimx,
         (int) file->hdr.data_info.dimy,
         (int) file->hdr.data_info.pixel_depth_bits);

 fprintf(fid,"   PIXEL SIZE (X,Y) = %-.4fmm,%-.4fmm   THICKNESS = %-.4fmm\n",
     file->hdr.data_info.xpixel_size,file->hdr.data_info.ypixel_size,
           format->pixel_thickness);
 voxel_size = file->hdr.data_info.xpixel_size *
              file->hdr.data_info.ypixel_size * 
              file->hdr.data_info.pixel_thickness;

 fprintf(fid,"   VOXEL = %-.4f (Cubic mm)\n",voxel_size);
 if (!(format->status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW) &&
      (format->status & OUT_FORMAT_UNIT_2D_VALID))
    {
     fprintf(fid,"   Current resized Image dimension = %ld * %ld\n",
          format->img_unit.dimx,format->img_unit.dimy);
     fprintf(fid,"   Resized PIXEL SIZE (X,Y) = %-.4fmm,%-.4fmm   VOXEL = %-.4f (Cubic mm)\n",
          format->xpixel_size,format->ypixel_size,format->voxel_size);
    }


 fprintf(fid,"   # of Slice Cuts = %ld  Total echoes = %d Scans/slice = %ld Total scans = %d\n",
           NumberOfSliceCuts(&(file->hdr.data_info)),
           file->hdr.data_info.num_echoes,
           NumberOfSliceScans(&(file->hdr.data_info)),
          (int) file->hdr.data_info.max_scans);
 for (lcv = 0; lcv < file->hdr.analysis.num_img_labels; lcv++)
    fprintf(fid,"      Image slices of type %s = %ld\n",
      file->hdr.analysis.img_labels[lcv],file->slice_info.num_sroi_wins);

 fprintf(fid,"\n");
 fprintf(fid,"COUNT ANALYSIS CONDITIONS...\n");
 num = 1;
 if (format->status & OUT_FORMAT_COUNT_NEG)
    fprintf(fid,"   %d) pixel values < 0 are counted as negative values\n",num);
   else fprintf(fid,"   %d) pixel values < 0 are counted as 0\n",num);
 num += 1;
 if (format->status & OUT_FORMAT_LT_PERCENT_MEAN)
    {fprintf(fid,"   %d) If Slice Mean > 0 then (Pixel values < %.2f%% of Mean) = 0\n",num,format->lt_percent);
     num += 1;}
 if (format->status & OUT_FORMAT_GT_PERCENT_MEAN)
    {fprintf(fid,"   %d) If Slice Mean > 0 then (Pixel values > %.2f%% of Mean) = 0\n",num,format->gt_percent);
     num += 1;}

 if (format->status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    {fprintf(fid,"   %d) If ROI Mean > 0 then (ROI pixel values < %.2f%% of Mean) = 0\n",num,format->roi_lt_percent);
     num += 1;}
 if (format->status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    {fprintf(fid,"   %d) If Roi Mean > 0 then (ROI pixel values > %.2f%% of Mean) = 0\n",num,format->roi_gt_percent);
     num += 1;}
 if (file->hdr.data_info.num_echoes > 1)
    if (format->status & OUT_FORMAT_COUNT_ALL_ECHOES)
       {fprintf(fid,"   %d) Count all echoes individually\n",num);
        num += 1;}
      else if (format->status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
       {fprintf(fid,"   %d) Count echo# = %ld only\n",num,file->count.echo_num);
        num += 1;}
      else if (format->status & OUT_FORMAT_POS_NEG_ACTIVATION_ECHOES)
       {fprintf(fid,"   %d) Counts = activation(POS echo 1,NEG echo 2)\n",num);
        num += 1;}
      else if (format->status & OUT_FORMAT_POS_NEG_ECHOES)
       {fprintf(fid,"   %d) Counts = counts(echo 1) - counts(all other echoes)\n",num);
        num += 1;}
      else
       {fprintf(fid,"   %d) Counts = Sum of counts of all echoes\n",num);
        num += 1;}

 fprintf(fid,"\n");

 if (all_labels->num_strs > 0)
    {fprintf(fid,"-- ROIS DEFINED --- total = %ld\n",all_labels->num_strs);
     for (lcv = 0; lcv < all_labels->num_strs; lcv++)
        fprintf(fid,"%d) %s\n",lcv+1,all_labels->strs[lcv]);
     fprintf(fid,"\n");
    }
 TRACE(printf("WrCountOutputFileInfo...\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
compute_spaces - ???
------------------------------------------------------------------------*/

void
compute_spaces(ptr,spaces,total_fields,num_lines)
 struct strs_rec *ptr;
 long *spaces;
 long total_fields,num_lines;
{
 long lcv,cnt,indx,len;

 for (lcv = 0; lcv < total_fields; lcv++,indx++) spaces[lcv] = 0;

 for (indx = cnt = 0; cnt < num_lines; cnt++)
    {
     for (lcv = 0; lcv < total_fields; lcv++,indx++)
        {len = strlen(ptr->strs[indx]);
         if (len > spaces[lcv]) spaces[lcv] = len;
        }
    }
}


/*------------------------------------------------------------------------
wr_line_token - ???
------------------------------------------------------------------------*/

int
wr_line_token(fid,str,str_len,cnt_spaces,num_lines,max_line_chs)
 FILE *fid;
 char *str;
 unsigned long str_len,*cnt_spaces,*num_lines;
 int max_line_chs;
{
 long len;
 char ch;

 *cnt_spaces += str_len;
 if (*cnt_spaces >= max_line_chs)
    {len = str_len + max_line_chs - *cnt_spaces;
     ch = str[len];
     str[len] = '\0';
     fprintf(fid,"%s\n",str);
     *cnt_spaces -= max_line_chs;
     str[len] = ch;
     fprintf(fid,"%s%c",&(str[len]),(char) 0x09);

     *num_lines += 1;
    }
   else
   {fprintf(fid,"%s%c",str,(char) 0x09);
    *cnt_spaces += 1;}
 return ferror(fid); 
}


/*------------------------------------------------------------------------
wr_lineup_lines - ???
------------------------------------------------------------------------*/

int
wr_lineup_lines(fid,ptr,total_fields,num_lines,max_line_chs)
 FILE *fid;
 struct strs_rec *ptr;
 long total_fields,num_lines;
 int max_line_chs;
{
 int err;
 char *str;
 int lcv,cnt,indx,max;
 long total,*spaces,loop,num,cnt_spaces;

 if (ptr->num_strs == 0)
    {return NO_ERROR;}
 total = 0;
 get_ptr_memory(&spaces,&total,total_fields,(size_t) sizeof(*spaces),&err);
 if (err != NO_ERROR) return err;
 compute_spaces(ptr,spaces,total_fields,num_lines);

 clearerr(fid);
 err = NO_ERROR;
 for (max = 0,lcv = 0; lcv < total_fields; lcv++)
    if (max < spaces[lcv]) max = spaces[lcv];
 total = 0;
 get_ptr_memory(&str,&total,max + 1,1,&err);
 if (err != NO_ERROR) return err;
 for (num = 0,indx = cnt = 0; cnt < num_lines; cnt++)
    {
     for (cnt_spaces = lcv = 0; lcv < total_fields; lcv++,indx++)
        {sprintf(str,"%s",ptr->strs[indx]);
/*
         len = strlen(str);
         str[len] = 0x09;
         str[len+1] = '\0';
*/
         set_str_len(str,spaces[lcv]);
         if ((err = wr_line_token(fid,str,spaces[lcv],&cnt_spaces,&num,
                   max_line_chs)) != NO_ERROR)
            {c_free(str);
             return err;}
        }
     fprintf(fid,"\n");
     if (cnt == 0) 
        {for (cnt_spaces = lcv = 0; lcv < total_fields; lcv++)
           {for (loop = 0; loop < spaces[lcv]; loop++)     
               str[loop] = '-';
            str[loop] = '\0';
            if ((err = wr_line_token(fid,str,spaces[lcv],&cnt_spaces,&num,
                   max_line_chs)) != NO_ERROR)
               {c_free(str);
                return err;}
           }
         fprintf(fid,"\n");
        }
     num += 1;
    }
 c_free(str);
 return err;
}


/*------------------------------------------------------------------------
count_output_label_ptrs - ???
------------------------------------------------------------------------*/

int
count_output_label_ptrs(count,all_labels)
 struct count_analysis_rec *count;
 struct strs_rec *all_labels;
{
 int err;
 unsigned long lcv,cnt;
 struct slice_count_anal_rec *slice_count;
 struct roi_count_anal_rec *roi_count;
 struct text_output_analysis_group_rec *group;

 if (count->status & TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS)
    {for (lcv = 0; lcv < count->num_slices; lcv++)
        {slice_count = &(count->slices[lcv]);
         if (!(slice_count->status1 & COUNT_VALID)) continue;
         for (cnt = 0; cnt < slice_count->num_rois; cnt++)
            {roi_count = &(slice_count->rois[cnt]);
             if (roi_count->label == NULL) 
                return CANCEL;
             if ((err = AddStrPtrToSortedStrsRec(all_labels,
                  roi_count->label,1,1)) != NO_ERROR)
                return err;
            }
        }
    }
   else
    {group = &(count->groups[0]);
     for (lcv = 0; lcv < group->num_rois; lcv++)
        if ((err = add_str_ptr_to_strs_rec(all_labels,
                       group->roi_labels[lcv])) != NO_ERROR)
           return err;
    }
 
 return NO_ERROR;
}


/*------------------------------------------------------------------------
count_roi_label - ???
------------------------------------------------------------------------*/

int
count_roi_label(roi_count,label)
 struct roi_count_anal_rec *roi_count;
 char **label;
{
 unsigned long indx;
 char *label1,ch;
 int err;

 *label = NULL;
 indx = skip_str_until_ch_in_patt(roi_count->label,"=");
 ch = roi_count->label[indx];
 roi_count->label[indx] = '\0';
 err = cp_str(&label1,roi_count->label);
 roi_count->label[indx] = ch;
 if (err != NO_ERROR) return err;

 trim_str_blanks(label1);
 if (is_blank_in_str(label1))
    {err = concat_strs(label,3,"\"",label1,"\"");
     c_free(label1);
    }
   else *label = label1;
 return err;
}


/*------------------------------------------------------------------------
SetupNegAndRejectionLine - ???
------------------------------------------------------------------------*/

int
SetupNegAndRejectionLine(line,slice_count,slice_num,num_lines,format)
 struct strs_rec *line;
 struct slice_count_anal_rec *slice_count;
 long slice_num,*num_lines;
 struct output_text_format_rec *format;
{
 unsigned int lcv,cnt,num,num1;
 struct roi_count_anal_rec *roi_count;
 char the_strs[NUM_FIELDS][50],*ptr_strs[NUM_FIELDS];
 int err;

 PRT(printf("SetupNegAndRejectionLine...slice_num = %d\n",slice_num))
 for (lcv = 0; lcv < NUM_FIELDS; lcv++) ptr_strs[lcv] = the_strs[lcv];
 num1 = 0;
 if (slice_num > 0) sprintf(the_strs[num1++],"%-ld",slice_num);
 for (cnt = 0; cnt < slice_count->num_rois; cnt++)
    {roi_count = &(slice_count->rois[cnt]);
     if ((err = count_roi_label(roi_count,&(ptr_strs[num1]))) != NO_ERROR) break;
     num = num1 + 1;
     sprintf(the_strs[num++],"%-ld",roi_count->num_pixels);
     if (format->status & OUT_FORMAT_NEG_OPTION)
        sprintf(the_strs[num++],"%-ld",roi_count->cnt_neg_val);
     if (format->status & OUT_FORMAT_COUNT_SLICE_LT_GT_PERCENT_OPTIONS)
        {if (slice_num > 0) sprintf(the_strs[num++],"%-.2f",roi_count->slice_mean);
         if (format->status & OUT_FORMAT_LT_PERCENT_MEAN)
            {sprintf(the_strs[num++],"%-ld",roi_count->cnt_smean_min_rej);
            if (slice_num > 0)
               sprintf(the_strs[num++],"%-.2f",roi_count->min_smean_threshold);}
         if (format->status & OUT_FORMAT_GT_PERCENT_MEAN)
            {sprintf(the_strs[num++],"%-ld",roi_count->cnt_smean_max_rej);
             if (slice_num > 0)
                sprintf(the_strs[num++],"%-.2f",roi_count->max_smean_threshold);}
        }
     if (format->status & OUT_FORMAT_COUNT_ROI_LT_GT_PERCENT_OPTIONS)
        {if (slice_num > 0) sprintf(the_strs[num++],"%-.2f",roi_count->roi_mean);
         if (format->status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
            {sprintf(the_strs[num++],"%-ld",roi_count->cnt_rmean_min_rej);
             if (slice_num > 0)
                sprintf(the_strs[num++],"%-.2f",roi_count->min_rmean_threshold);}
         if (format->status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
            {sprintf(the_strs[num++],"%-ld",roi_count->cnt_rmean_max_rej);
             if (slice_num > 0)
                sprintf(the_strs[num++],"%-.2f",roi_count->max_rmean_threshold);}
        }
     err = add_str_ary_to_strs_rec(line,ptr_strs,num); 
     c_free(ptr_strs[num1]); 
     if (err != NO_ERROR) break;
     *num_lines += 1;
    }
 PRT(printf("SetupNegAndRejectionLine...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
NegAndRejectionTitle - ???
------------------------------------------------------------------------*/

void
NegAndRejectionTitle(strs,num,format,is_for_all_slices)
 char strs[NUM_FIELDS][30];
 unsigned long *num;
 struct output_text_format_rec *format;
 int is_for_all_slices;
{
 *num = 0;
 PRT(printf("NegAndRejectionTitle...\n"))
 if (!is_for_all_slices) sprintf(strs[(*num)++],"S#");
 PRT(printf("NegAndRejectionTitle..1.\n"))
 sprintf(strs[(*num)++],"Roi");
 sprintf(strs[(*num)++],"Pixels");
 PRT(printf("NegAndRejectionTitle..2.\n"))
 if (format->status & OUT_FORMAT_NEG_OPTION) sprintf(strs[(*num)++],"#OfNeg");
 if (format->status & OUT_FORMAT_COUNT_SLICE_LT_GT_PERCENT_OPTIONS)
    {if (!is_for_all_slices) sprintf(strs[(*num)++],"SliceMean");
     if (format->status & OUT_FORMAT_LT_PERCENT_MEAN)
         if (!is_for_all_slices)
            {sprintf(strs[(*num)++]," #< ");
             sprintf(strs[(*num)++],"<%.1f%%",format->lt_percent);}
           else sprintf(strs[(*num)++],"#<%.1f%%SliceMean",format->lt_percent);
     if (format->status & OUT_FORMAT_GT_PERCENT_MEAN)
         if (!is_for_all_slices)
            {sprintf(strs[(*num)++]," #> ");
             sprintf(strs[(*num)++],">%.1f%%",format->gt_percent);}
           else sprintf(strs[(*num)++],"#>%.1f%%SliceMean",format->gt_percent);
    }
 PRT(printf("NegAndRejectionTitle..3.\n"))
 if (format->status & OUT_FORMAT_COUNT_ROI_LT_GT_PERCENT_OPTIONS)
    {if (!is_for_all_slices) sprintf(strs[(*num)++],"RoiMean");
     if (format->status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
         if (!is_for_all_slices)
            {sprintf(strs[(*num)++]," #< ");
             sprintf(strs[(*num)++],"<%.1f%%",format->roi_lt_percent);}
           else sprintf(strs[(*num)++],"#<%.1f%%RoiMean",format->roi_lt_percent);

     if (format->status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
        {
         if (!is_for_all_slices)
            {sprintf(strs[(*num)++]," #> ");
             sprintf(strs[(*num)++],">%.1f%%",format->roi_gt_percent);}
           else sprintf(strs[(*num)++],"#>%.1f%%RoiMean",format->roi_gt_percent);
        }
    }
}


/*------------------------------------------------------------------------
WrNegAndRejectionLine - ???
------------------------------------------------------------------------*/

int
WrNegAndRejectionLine(fid,all_slices,count,format)
 FILE *fid;
 struct slice_count_anal_rec *all_slices;
 struct count_analysis_rec *count;
 struct output_text_format_rec *format;
{
 struct slice_count_anal_rec *slice_count;
 struct strs_rec ptr;
 unsigned int lcv,num_lines,num;
 char *pstrs[NUM_FIELDS],strs[NUM_FIELDS][30];
 int err;

 PRT(printf("WrNegAndRejectionLine...\n"))
 for (lcv = 0; lcv < NUM_FIELDS;lcv++)
    pstrs[lcv] = (char *) strs[lcv];
 NegAndRejectionTitle(strs,&num,format,1);
 PRT(printf("WrNegAndRejectionLine...num = %d\n",num))
 init_strs_rec(&ptr);
 if ((err = add_str_ary_to_strs_rec(&ptr,pstrs,num)) == NO_ERROR)
    {num_lines = 1;
     PRT(printf("WrNegAndRejectionLine..1.num = %d\n",num))
     if ((err = SetupNegAndRejectionLine(&ptr,all_slices,0,&num_lines,format)) == NO_ERROR)
        {
         fprintf(fid,"\n%-d lines of negative & rejected pixel value statistics for each slice\n",num_lines - 1);
         if ((err = wr_lineup_lines(fid,&ptr,num,num_lines,120)) == NO_ERROR)
            {
             free_strs_rec(&ptr);
             NegAndRejectionTitle(strs,&num,format,0);
             if ((err = add_str_ary_to_strs_rec(&ptr,pstrs,num)) == NO_ERROR)
                {
                 PRT(printf("WrNegAndRejectionLine..3.num = %d\n",num))
                 for (num_lines = 1,lcv = 0; lcv < count->num_slices; lcv++)
                    {slice_count = &(count->slices[lcv]);
                     if (!(slice_count->status1 & COUNT_VALID)) continue;
                     if ((err = SetupNegAndRejectionLine(&ptr,slice_count,lcv+1,
                               &num_lines,format)) != NO_ERROR)
                        break;
                    }
                }
            }
        }
     if (err == NO_ERROR)
        {fprintf(fid,"\n%-d lines of negative & rejected pixel value statistics for each slice\n",num_lines - 1);
         PRT(printf("WrNegAndRejectionLine..4.num = %d\n",num))
         err = wr_lineup_lines(fid,&ptr,num,num_lines,120);}
    }
 free_strs_rec(&ptr);
 PRT(printf("WrNegAndRejectionLine..5.err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
SetupCountValueLine1 - ???
------------------------------------------------------------------------*/

int
SetupCountValueLine1(line,slice_count,slice_num,voxel_size,pixel_area,num_lines)
 struct strs_rec *line;
 struct slice_count_anal_rec *slice_count;
 long slice_num,*num_lines;
 float voxel_size,pixel_area;
{
 float total_vol,ave,countpervol,area,countperarea;
 unsigned int lcv,cnt,num_strs,start;
 struct roi_count_anal_rec *roi_count;
 char the_strs[NUM_ITEMS][50],*ptr_strs[NUM_ITEMS];
 int err;

 if (slice_num > 0)
    {num_strs = NUM_ITEMS;
     start = 0;
     sprintf(the_strs[0],"%-ld",slice_num);}
   else
    {start = 1;
     num_strs = NUM_ITEMS - 1;}
 for (lcv = 0; lcv < NUM_ITEMS; lcv++) ptr_strs[lcv] = the_strs[lcv];

 for (cnt = 0; cnt < slice_count->num_rois; cnt++)
    {roi_count = &(slice_count->rois[cnt]);
     if (roi_count->num_pixels == 0)
        {countperarea = area = total_vol = ave = countpervol = .0;}
       else
        {total_vol = voxel_size * (float) roi_count->num_pixels;
         area = pixel_area * (float) roi_count->num_pixels;
         countperarea = roi_count->total_counts / area;

         countpervol = roi_count->total_counts / total_vol;
/*
         printf("%d) voxel_size = %f tot = %d total_vol = %f\n",cnt,voxel_size,roi_count->num_pixels,total_vol);
*/
         ave = (float) (roi_count->total_counts / 
                             (double) roi_count->num_pixels);}
     if ((err = count_roi_label(roi_count,&(ptr_strs[1]))) != NO_ERROR) break;

     sprintf(the_strs[2],"%-.0f",roi_count->total_counts);
     sprintf(the_strs[3],"%-.2f",total_vol);
     sprintf(the_strs[4],"%-.2f",countpervol);
     sprintf(the_strs[5],"%-.2f",area);
     sprintf(the_strs[6],"%-.2f",countperarea);

     sprintf(the_strs[7],"%-ld",roi_count->num_pixels);
     sprintf(the_strs[8],"%-.2f",ave);
     sprintf(the_strs[9],"%-.2f",roi_count->sd);
     sprintf(the_strs[10],"%-.2f",roi_count->min);
     sprintf(the_strs[11],"%-.2f",roi_count->max);
     TRACE(printf("...total = %d num = %d  \n",line->total_strs,
                    line->num_strs))
     err = add_str_ary_to_strs_rec(line,&(ptr_strs[start]),num_strs);
     c_free(ptr_strs[1]);
     if (err != NO_ERROR) break;
     *num_lines += 1;
    }
 TRACE(printf("...SetupCountValueLine1...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
PrintCountOutputToFile - ???
------------------------------------------------------------------------*/

int
PrintCountOutputToFile(fn,file,text_printing_time,format,count,status)
 char *fn;
 struct input_file_rec *file;
 char **text_printing_time;
 struct output_text_format_rec *format;
 struct count_analysis_rec *count;
 unsigned short *status;
{
 FILE *fid;
 struct strs_rec all_labels,ptr;
 unsigned int lcv,cnt,indx,num_lines;
 struct slice_count_anal_rec *slice_count,all_slices;
 struct roi_count_anal_rec *roi_count;
 char **pstrs;
 static char *strs[NUM_ITEMS] = {"S#","Roi","Count(C)","Vol","C/Vol",
            "AREA","C/AREA","Pixels","AveC/Pixel","Std","Min","Max"};
 int err,is_neg,is_sorted;
 float pixel_area;

 TRACE(printf("PrintCountOutputToFile...fn = %s\n",fn))
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 init_strs_rec(&all_labels);
 err = count_output_label_ptrs(count,&all_labels);
 init_slice_count_anal_rec(&all_slices);
 if ((err != NO_ERROR) || (all_labels.num_strs == 0) ||
     ((err = get_ptr(&(all_slices.rois),&(all_slices.total_rois),
         all_labels.num_strs,sizeof(*(all_slices.rois)))) != NO_ERROR))
    {fclose(fid);
     free_strs_rec_ptrs(&all_labels);
     return err;}

 PRT6(printf("PrintCountOutputToFile all_labels...\n"))
 PRT6(pr_strs_rec(&all_labels);)

 all_slices.num_rois = all_slices.total_rois;
 for (lcv = 0; lcv < all_slices.num_rois; lcv++)
    init_roi_count_anal_rec(&(all_slices.rois[lcv]));
 for (lcv = 0; lcv < all_slices.num_rois; lcv++)
    if ((err = setup_roi_count_anal_rec(&(all_slices.rois[lcv]),all_labels.strs[lcv]))
             != NO_ERROR)
    {fclose(fid);
     free_strs_rec_ptrs(&all_labels);
     free_slice_count_anal_rec(&all_slices);
     return err;}

 init_strs_rec(&ptr);
 pstrs = strs;
 pixel_area = format->xpixel_size * format->ypixel_size;
 is_sorted = count->status & TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;
 if ((err = add_str_ary_to_strs_rec(&ptr,&(pstrs[1]),NUM_ITEMS - 1)) == NO_ERROR)
    {TRACE(printf("PrintCountOutputToFile...1\n"))
     for (is_neg = 0,lcv = 0; lcv < count->num_slices; lcv++)
        {slice_count = &(count->slices[lcv]);
         if (!(slice_count->status1 & COUNT_VALID)) continue;
         for (cnt = 0; cnt < slice_count->num_rois; cnt++)
            {roi_count = &(slice_count->rois[cnt]);
             if (is_sorted)
                {if ((err = FindStrInSortedStrsRec(&all_labels,roi_count->label,&indx))
                       != NO_ERROR)
                    {PRT6(printf("sort roi_count->label = %s not found\n",roi_count->label))
                     continue;}
                }
               else if (find_str_in_strs_rec(&all_labels,roi_count->label,&indx)
                       != NO_ERROR)
                {PRT6(printf("roi_count->label = %s not found\n",roi_count->label))
                 continue;}

             PRT1(printf("roi_count->label = %s ... found\n",roi_count->label))

             all_slices.rois[indx].num_pixels += roi_count->num_pixels;
             all_slices.rois[indx].total_counts += roi_count->total_counts;
             if (all_slices.rois[indx].min > all_slices.rois[indx].max)
                {all_slices.rois[indx].min = roi_count->min;
                 all_slices.rois[indx].max = roi_count->max;}
               else
                {if (roi_count->min < all_slices.rois[indx].min)
                    all_slices.rois[indx].min = roi_count->min;
                 if (roi_count->max > all_slices.rois[indx].max)
                    all_slices.rois[indx].max = roi_count->max;}
             all_slices.rois[indx].sd += roi_count->sd * roi_count->sd;
             all_slices.rois[indx].cnt_neg_val += roi_count->cnt_neg_val;
             if (roi_count->cnt_neg_val > 0) is_neg = 1;
             all_slices.rois[indx].cnt_smean_min_rej += roi_count->cnt_smean_min_rej;
             all_slices.rois[indx].cnt_smean_max_rej += roi_count->cnt_smean_max_rej;
             all_slices.rois[indx].cnt_rmean_min_rej += roi_count->cnt_rmean_min_rej;
             all_slices.rois[indx].cnt_rmean_max_rej += roi_count->cnt_rmean_max_rej;
            }
        }
     if (is_neg) format->status |= OUT_FORMAT_NEG_VALUES;
       else format->status &= ~OUT_FORMAT_NEG_VALUES;
     if (err == NO_ERROR)
         for (lcv = 0; lcv < all_labels.num_strs; lcv++)
            all_slices.rois[lcv].sd = (float)
                sqrt((double) all_slices.rois[lcv].sd);

     num_lines = 1;
     if (((err = SetupCountValueLine1(&ptr,&all_slices,0,
                   format->voxel_size,pixel_area,&num_lines)) == NO_ERROR) &&
         ((err = WrCountOutputFileInfo(fid,file,text_printing_time,format,
                         &all_labels)) == NO_ERROR))
        {fprintf(fid,"%-d lines of ROI statistics for all slices\n",num_lines - 1);
         if ((err = wr_lineup_lines(fid,&ptr,NUM_ITEMS - 1,num_lines,120)) == NO_ERROR)
            {fprintf(fid,"\n");
             free_strs_rec(&ptr);
             if ((err = add_str_ary_to_strs_rec(&ptr,pstrs,NUM_ITEMS)) == NO_ERROR)
                {for (num_lines = 1,lcv = 0; lcv < count->num_slices; lcv++)
                    {slice_count = &(count->slices[lcv]);
                     if (!(slice_count->status1 & COUNT_VALID)) continue;
                     if ((err = SetupCountValueLine1(&ptr,slice_count,lcv + 1,
                          format->voxel_size,pixel_area,&num_lines)) != NO_ERROR)
                        break;
                    }
                 if (err == NO_ERROR)
                    {fprintf(fid,"%-d lines of ROI statistics for each slice\n",
                              num_lines - 1);
                     err = wr_lineup_lines(fid,&ptr,NUM_ITEMS,num_lines,120);}
                }
            }
        }
    }
 free_strs_rec_ptrs(&all_labels);
 free_strs_rec(&ptr);
 TRACE(printf("PrintCountOutputToFile...err = %d\n",err);)
 if ((err == NO_ERROR) && 
     (format->status & OUT_FORMAT_NEG_AND_LT_GT_PERCENT_OPTIONS))
    err = WrNegAndRejectionLine(fid,&all_slices,count,format);

 free_slice_count_anal_rec(&all_slices);
 TRACE(printf("PrintCountOutputToFile...10...\n"))
 fclose(fid);
 if (err != NO_ERROR) delete_file(fn);
   else *status |= TEXT_OUTPUT_TO_FILE;
 return err;
}


/*------------------------------------------------------------------------
file_save_count_output_to_file - ???
------------------------------------------------------------------------*/

int
file_save_count_output_to_file(file,to_printer)
 struct input_file_rec *file;
 int to_printer;
{
 char *fn,*str;
 int err;

 TRACE(printf("file_save_count_output_to_file...\n"))
 if ((err = build_fn(&fn,file->output.dirfn,file->output.fn,
          COUNT_SUFFIX)) != NO_ERROR)
    return FILE_NAME_ERROR;

 file->text.file = file;
 if ((err = PrintCountOutputToFile(fn,file,
          &(file->count.text_printing_time),&(file->count.format),
          &(file->count),&(file->count.status))) == NO_ERROR)
    {if (to_printer)
       {if (concat_strs(&str,2,"lpr ",fn) == NO_ERROR)
          {
           system(str);
           c_free(str);}
       }
    }
 c_free(fn);
 TRACE(printf("file_save_count_output_to_file...end...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
PrintCountOutputToTempFile - ???
------------------------------------------------------------------------*/

int
PrintCountOutputToTempFile(count)
 struct count_analysis_rec *count;
{
 int err;

 TRACE(printf("PrintCountOutputToTempFile...1\n"))
 if ((count->status & TEXT_OUTPUT_TO_TEMP_FILE) &&
     (count->text_temp_fn != NULL))
    {delete_file(count->text_temp_fn);
     count->status &= ~TEXT_OUTPUT_TO_TEMP_FILE;}
 if (count->text_temp_fn == NULL)
    if ((err = cp_str(&(count->text_temp_fn),tmpnam(NULL))) != NO_ERROR)
       return err;

 if ((err = PrintCountOutputToFile(count->text_temp_fn,count->file,
          &(count->text_printing_time),&(count->format),
          count,&(count->status))) == NO_ERROR)
    count->status |= TEXT_OUTPUT_TO_TEMP_FILE;
    
 TRACE(printf("PrintCountOutputToTempFile...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
win_save_count_output_to_file - ???
------------------------------------------------------------------------*/

int
win_save_count_output_to_file(win,to_printer)
 struct image_display_window *win;
 int to_printer;
{
 struct img_buf_rec *img;
 int err;

 TRACE(printf("win_save_count_output_to_file...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((err = file_save_count_output_to_file(img->file,to_printer)) ==
       FILE_NAME_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Bad *.count file name !!!",
               "The operation is aborted !!!",NULL,0);
     return err;}
   else if (err == CANCEL)
    ShowMsgStrs(win->dwin->frame,0,err,0,3,
               "Unable to save the count file !!!",
               "Check your count output format !!!",
               "The operation is aborted !!!",NULL,0);
   else if (err != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when saving the count file!!!",
               "The operation is aborted !!!",NULL,0);

 return err;

}

