/****************************************************************************
display_interface.c

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: display_interface.c,v 1.9 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <unistd.h>

#include <sys/timeb.h>

#include <xview/cms.h>

#include "mri_format.h"
#include "slice_roi_rec.h"
#include "display_win.h"
#include "nria_procedures.h"


/*
#define PRT5(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT13(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT1(x) 
#define PRT2(x) 
#define PRT3(x) 
#define PRT4(x) 
#define PRT5(x) 
#define PRT6(x) 
#define PRT8(x) 
#define PRT7(x) 
#define PRT9(x) 
#define PRT10(x) 
#define PRT11(x) 
#define PRT12(x) 
#define PRT13(x) 



/* Functions defined in this file */
int win_execute_proc_to_multiple_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3, void *arg4, void *arg5, void *arg6);
int win_apply_partner_linked_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
int win_execute_proc_to_partner_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
int WinMultiEchoRunProc(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
int win_execute_proc_to_related_wins(struct image_display_window *win,
    int (*proc)(), void *arg2, void *arg3);
int win_run_proc_on_slice_roi_wins(struct slice_roi_win_rec *slice_roi_win,
    int (*proc)(), void *arg2, void *arg3);
int win_run_proc_to_all_wins(struct image_display_window *win1,
    struct image_display_window *win, int (*proc)(), unsigned long is_which,
    void *arg2, void *arg3, void *arg4);
int win_run_proc_to_all_file_wins(struct image_display_window *win,
    int (*proc)(), unsigned int is_which, void *arg2, void *arg3, void *arg4);
int WinRunProcInList(int select, struct image_display_window *win,
    int (*proc)(), void *arg1, void *arg2, void *arg3, void *arg4,
    void *arg5, void *arg6);
int win_paint_all_curves(struct image_display_window *win);
int win_repaint_all_curves(struct image_display_window *win);
int win_clear_curves(struct image_display_window *win);
int win_display_cur_curve(struct image_display_window *win);
int win_display_cur_roi(struct image_display_window *win);
int win_display_all_curves(struct image_display_window *win);
int win_redisplay_all_curves(struct image_display_window *win);
int win_display_masks_to_multiple_wins(struct image_display_window *win);
int win_display_clear_curves(struct image_display_window *win);
int win_show_row_col(struct image_display_window *win, int is_clear_label);
int win_draw_cur_roi(struct image_display_window *win);
int win_draw_processed_rois(struct image_display_window *win);
int wr_file_hdr(struct input_file_rec *file);
void ndat_err_msg(struct input_file_rec *file, int err, int is_check_exist);
int win_get_files_with_pixel_type_map(struct image_display_window *win,
    struct strs_rec *file_labels, int include_cur_file);
struct input_file_rec *win_get_file_by_name(struct image_display_window *win,
    char *output_fn);
int win_get_file_pixel_type_map(struct image_display_window *win,
    char *output_fn, int is_free_output_fn);
int win_is_file_valid(struct image_display_window *win,
    struct input_file_rec *file);
int win_is_file_img_valid(struct image_display_window *win,
    struct input_file_rec *file, struct img_buf_rec *img);
int win_scale_color_2d(struct image_display_window *win,
    struct buf_2d_rec *dest_2d, struct buf_2d_rec *src_2d);
int win_reverse_slice_rois(struct image_display_window *win);
int win_reverse_the_images(struct image_display_window *win);
int win_reverse_images(struct image_display_window *win);
int WinWidFiles(struct image_display_window *win, struct strs_rec *wids,
    struct strs_rec *result);
struct image_display_window *find_file_first_window(
   struct input_file_rec *file, unsigned long *indx, unsigned long select);
int WinFindNextEchoWin(struct image_display_window *win,
    struct image_display_window *nextwin,
    struct image_display_window **result);
struct image_display_window *WinFindAvailNextEchoWin(
   struct image_display_window *win);



/*-----------------------------------------------------------------------
win_execute_proc_to_multiple_wins - ???
-----------------------------------------------------------------------*/

int
win_execute_proc_to_multiple_wins(win,proc,arg2,arg3,arg4,arg5,arg6)
 struct image_display_window *win;
 int (*proc)();
 void *arg2,*arg3,*arg4,*arg5,*arg6;
{
 unsigned int lcv;
 struct display_win_rec *dwin;
 int err;

 if (win->num_display_wins == 0) return NO_ERROR;
 if (win->dwin != NULL)
    if ((err = proc(win,arg2,arg3,arg4,arg5,arg6)) != NO_ERROR) return err;
 if (win->num_display_wins > 1)
    {dwin = win->dwin;
     for (lcv = 0; lcv < win->num_display_wins; lcv++)
        {if ((dwin != win->dwins[lcv]) && (win->dwins[lcv] != NULL))
           {win->dwin = win->dwins[lcv];
            if ((err = proc(win,arg2,arg3,arg4,arg5,arg6)) != NO_ERROR) return err;
           }
        }
     win->dwin = dwin;
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_apply_partner_linked_wins - ???
-----------------------------------------------------------------------*/

int
win_apply_partner_linked_wins(win,proc,arg2,arg3)
 struct image_display_window *win;
 int (*proc)();
 void *arg2,*arg3;
{
 struct image_display_window *temp;
 struct list_rec *cur,*next;
 int err;

 if (win->num_display_wins > 0) 
    if ((err = win_execute_proc_to_multiple_wins(win,proc,arg2,arg3,0,0,0))
            != NO_ERROR)
       return err;
 next = cur = &(win->partner);
 do 
    {temp = next->item;
     if (temp != win)
        if (temp->num_display_wins > 0) 
           if ((err = win_execute_proc_to_multiple_wins(temp,proc,arg2,arg3,0,0,0))
                    != NO_ERROR)
              return err;
     next = next->next;}
 while (cur != next);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_execute_proc_to_partner_wins - ???
-----------------------------------------------------------------------*/

int
win_execute_proc_to_partner_wins(win,proc,arg2,arg3)
 struct image_display_window *win;
 int (*proc)();
 void *arg2,*arg3;
{
 struct image_display_window *temp;
 struct list_rec *cur,*next;
 int err;

 if (win->num_display_wins > 0) 
    if ((err = proc(win,arg2,arg3)) != NO_ERROR) return err;
 next = cur = &(win->partner);
 do 
    {temp = next->item;
     if (temp != win)
        if (temp->num_display_wins > 0)
           if ((err = proc(temp,arg2,arg3)) != NO_ERROR) return err;
     next = next->next;}
 while (cur != next);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
WinMultiEchoRunProc - ???
-----------------------------------------------------------------------*/

int
WinMultiEchoRunProc(win,proc,arg2,arg3)
     struct image_display_window *win;
     int (*proc)();
     void *arg2,*arg3;
{
  struct img_buf_rec *img,*temp_img;
  int err;

  temp_img = img = win_rec_cur_img_buf(win->owner);
  do
  {
    if (temp_img != NULL)
    {
      if ((temp_img->win != NULL) &&
	  (temp_img->win->image_display != NULL))
	if ((err = proc(temp_img->win->image_display,arg2,arg3)) !=
	    NO_ERROR)
	  return err;
      temp_img = temp_img->partner;
    }
    else
      return NO_ERROR;
  }
  while (temp_img != img);
  return NO_ERROR;
}



/*-----------------------------------------------------------------------
win_execute_proc_to_related_wins - ???
-----------------------------------------------------------------------*/

int
win_execute_proc_to_related_wins(win,proc,arg2,arg3)
 struct image_display_window *win;
 int (*proc)();
 void *arg2,*arg3;
{
 unsigned int lcv;
 int err;

 if (win->control.sroi.sroi_win == NULL) return CANCEL;
 if ((err = proc(win,arg2,arg3)) != NO_ERROR) return err;

 for (lcv = 0; lcv < win->control.sroi.sroi_win->num_wins;lcv++)
    if (win != win->control.sroi.sroi_win->wins[lcv])
       {
        if ((err = proc(win->control.sroi.sroi_win->wins[lcv],arg2,arg3))
               != NO_ERROR)
           return err;
       }
 return err;
}


/*-----------------------------------------------------------------------
win_run_proc_on_slice_roi_wins - ???
-----------------------------------------------------------------------*/

int
win_run_proc_on_slice_roi_wins(slice_roi_win,proc,arg2,arg3)
 struct slice_roi_win_rec *slice_roi_win;
 int (*proc)();
 void *arg2,*arg3;
{
 unsigned int lcv;
 int err;

 for (lcv = 0; lcv < slice_roi_win->num_wins;lcv++)
    if ((err = proc(slice_roi_win->wins[lcv],arg2,arg3)) != NO_ERROR)
       return err;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_run_proc_to_all_wins - ???

 if is_which & 1 then apply to the image_display window
 if is_which & 2 then apply to the histogram window
 if is_which & 4 then do not apply to the current window
 if is_which & 8 then do not apply to the windows that use the same slice roi
 if is_which & 0x00000010 then apply to the windows with the same window type
 if is_which & 0x00000020 then apply to the windows of all files
 if is_which & 0x00000040 then apply to the windows of same intensity
 if is_which & 0x00000080 then apply to the windows of same intensity & of same scale
 if is_which & 0x00000100 then apply to the IMAGE_WINDOWS windows
 if is_which & 0x00000200 then apply to the HISTOGRAM_WINDOW windows
 if is_which & 0x00000400 then apply to the MANY_SLICES_WINDOWS windows
 if is_which & 0x00000800 then apply to the EDITING_WINDOW windows
-----------------------------------------------------------------------*/

int
win_run_proc_to_all_wins(win1,win,proc,is_which,arg2,arg3,arg4)
 struct image_display_window *win1,*win;
 int (*proc)();
 unsigned long is_which;
 void *arg2,*arg3,*arg4;
{
 struct color_scale_rec *scale1,*scale;

 if (is_which & 0x0000001C)
    {if ((is_which & 4) && (win1 == win)) return NO_ERROR;
     if ((is_which & 8) && 
         (win1->control.sroi.sroi_win == win->control.sroi.sroi_win))
        return NO_ERROR;
     if (is_which & 0x00000010)
        if (win1->type2 != win->type2) return NO_ERROR;
    }
 if (is_which & 0x000000C0)
    if (win1->intensity != win->intensity) return NO_ERROR;
      else if (is_which & 0x00000080)
       {PRT11(printf("win_run_proc_to_all_wins same intensity\n"))
        if ((scale1 = win_cur_scale(win1)) == NULL) return NO_ERROR;
        if ((scale = win_cur_scale(win)) == NULL) return NO_ERROR;
        if (str_cmp(scale1->label,scale->label) != 0) return NO_ERROR;}

 if (is_which & 0x00000F00)
    {if (((is_which & 0x00000100) && !(win1->type2 & IMAGE_WINDOWS)) ||
         ((is_which & 0x00000200) && !(win1->type2 & HISTOGRAM_WINDOW)) ||
         ((is_which & 0x00000400) && !(win1->type2 & MANY_SLICES_WINDOWS)) ||
         ((is_which & 0x00000800) && !(win1->type2 & EDITING_WINDOW)))
        return NO_ERROR;
    }
 PRT11(printf("\nwin_run_proc_to_all_wins...win1 wid = %s  win wid = %s\n",
            win1->owner->wid,win->owner->wid))
 proc(win1,arg2,arg3,arg4);
 PRT11(printf("win_run_proc_to_all_wins\n\n"))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_run_proc_to_all_file_wins - ???
-----------------------------------------------------------------------*/

int
win_run_proc_to_all_file_wins(win,proc,is_which,arg2,arg3,arg4)
 struct image_display_window *win;
 int (*proc)();
 unsigned int is_which;
 void *arg2,*arg3,*arg4;
{
 unsigned long lcv,total_wins;
 struct image_display_window *win1;
 struct img_buf_rec *img,*img1;
 struct win_rec **wins;

 if ((img1 = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
 total_wins = win->owner->root->total_wins;
 wins = win->owner->root->wins;
 for (lcv = 0; lcv < total_wins; lcv++)
    {
     if (((img = win_rec_cur_img_buf(wins[lcv])) == NULL) ||
         ((img->file != img1->file) && !(is_which & 0x00000020)))
        continue;
     if (is_which & 1)
        if (((win1 = wins[lcv]->image_display) != NULL) &&
            (win1->num_display_wins > 0) && (win1->dwins[0] != NULL))
           win_run_proc_to_all_wins(win1,win,proc,is_which,arg2,arg3,arg4);
     if (is_which & 2)
        if (((win1 = wins[lcv]->histogram) != NULL) &&
            (win1->num_display_wins > 0) && (win1->dwins[0] != NULL))
           win_run_proc_to_all_wins(win1,win,proc,is_which,arg2,arg3,arg4);
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
WinRunProcInList - ???
-----------------------------------------------------------------------*/

int
WinRunProcInList(select,win,proc,arg1,arg2,arg3,arg4,arg5,arg6)
 int select;
 struct image_display_window *win;
 int (*proc)();
 void *arg1,*arg2,*arg3,*arg4,*arg5,*arg6;
{
 struct list_rec *next,*cur;
 int err,yes;

 PRT7(printf("WinRunProcInList...wid = %s\n",win->owner->wid))
 if (select & WIN_PARTNER)
    cur = next = &(win->partner);
   else if (select & WIN_LINK)
    cur = next = &(win->link);
   else if (select & WIN_LIST)
    cur = next = &(win->list);
   else if (select & WIN_PROC_AFTER_DP)
    cur = next = &(win->proc_after_dp);
   else if (select & WIN_OVERLAY)
    cur = next = &(win->overlay);
   else if (select & WIN_DRAW_LIST)
    cur = next = &(win->draw_list);
   else return NO_ERROR;
 PRT7(printf("WinRunProcInList...1\n"))
 do
    {if (next->item != NULL)
        if (!(select & WIN_DO_NOT_PROCESS_CUR_WIN) ||
             (next->item != win))
            {if (select & WIN_DRAW_LIST)
                {yes = !win_is_draw_list_processed(win,next);
                 PRT7(printf("WinRunProcInList yes = %d\n",yes))
                }
               else yes = 1;
             if (yes &&
                 ((err = proc(next->item,arg1,arg2,
                      arg3,arg4,arg5,arg6,next)) != NO_ERROR))
                return err;
            }
     next = next->next;
    }
 while (cur != next);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_paint_all_curves - ???
-----------------------------------------------------------------------*/

int
win_paint_all_curves(win)
 struct image_display_window *win;
{
 int err;

 if ((err = win_draw_processed_rois(win)) == NO_ERROR)
    {err = paint_curves_to_multiple_win(win,
               win->data.draw_masks,win->data.num_draw_masks,0);
    }
   else if (err == CANCEL) err = NO_ERROR;

 return err;

}


/*-----------------------------------------------------------------------
win_repaint_all_curves - ???
-----------------------------------------------------------------------*/

int
win_repaint_all_curves(win)
 struct image_display_window *win;
{
/*
 struct timeb the_time;

 ftime(&the_time);
 printf("win_repaint_all_curves sec = %d  msecs = %d\n",
                 (int) the_time.time,the_time.millitm);
*/
 PRT1(printf("win_repaint_all_curves...0\n");)
 win_clear_curves(win);
 PRT1(printf("win_repaint_all_curves...1\n");)
 win_paint_all_curves(win);
 PRT1(printf("win_repaint_all_curves...2\n");)
/*
 ftime(&the_time);
 printf("win_repaint_all_curves win_clear_curves sec = %d  msecs = %d\n",
                 (int) the_time.time,the_time.millitm);
*/
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_clear_curves - ???
-----------------------------------------------------------------------*/

int
win_clear_curves(win)
 struct image_display_window *win;
{
 PRT1(printf("win_clear_curves...1\n");)
 set_paint_status(win->data.draw_masks,win->data.num_draw_masks,
                      PAINT_ERASE);
 PRT1(printf("win_clear_curves...2\n");)
 paint_curves_to_multiple_win(win,
      win->data.draw_masks,win->data.num_draw_masks,0);
 PRT1(printf("win_clear_curves...3\n");)
 clear_draw_masks(win->data.draw_masks,win->data.num_draw_masks);
 PRT1(printf("win_clear_curves...4\n");)
 set_paint_status(win->data.draw_masks,win->data.num_draw_masks,
                      PAINT_SUPERIMPOSE);
 PRT1(printf("win_clear_curves...5\n");)
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_display_cur_curve - ???
-----------------------------------------------------------------------*/

int
win_display_cur_curve(win)
 struct image_display_window *win;
{
 if (win->control.display_options & DISPLAY_BREAKER)
    win_move_show_breaker(win);
 else win_execute_proc_to_related_wins(win,win_move_show_cur_curve,0,0);

 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_display_cur_roi - ???
-----------------------------------------------------------------------*/

int
win_display_cur_roi(win)
 struct image_display_window *win;
{
 win_execute_proc_to_related_wins(win,win_draw_cur_roi,0,0);
 win_execute_proc_to_related_wins(win,WinMultiCanvas,0,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_display_all_curves - ???
-----------------------------------------------------------------------*/

int
win_display_all_curves(win)
 struct image_display_window *win;
{
 win_paint_all_curves(win);
 WinMultiCanvas(win);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_redisplay_all_curves - ???
-----------------------------------------------------------------------*/

int
win_redisplay_all_curves(win)
 struct image_display_window *win;
{
 PRT1(printf("win_redisplay_all_curves...0\n");)
 win_repaint_all_curves(win);
 PRT1(printf("win_redisplay_all_curves...1\n");)
 WinMultiCanvas(win);
 PRT1(printf("win_redisplay_all_curves...2\n");)
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_display_masks_to_multiple_wins - ???
-----------------------------------------------------------------------*/

int
win_display_masks_to_multiple_wins(win)
 struct image_display_window *win;
{
 paint_cur_curve_to_multiple_win(win,win->data.draw_masks,
                 win->data.num_draw_masks,0);
 WinMultiCanvas(win);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_display_clear_curves - ???
-----------------------------------------------------------------------*/

int
win_display_clear_curves(win)
 struct image_display_window *win;
{
 win_clear_curves(win);
 WinMultiCanvas(win);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_show_row_col - ???
-----------------------------------------------------------------------*/

int
win_show_row_col(win,is_clear_label)
 struct image_display_window *win;
 int is_clear_label;
{
 win_display_row_col(win,win->control.last_cursorx,
                         win->control.last_cursory,1,is_clear_label);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_draw_cur_roi - ???
-----------------------------------------------------------------------*/

int
win_draw_cur_roi(win)
 struct image_display_window *win;
{
 int err;

 err = NO_ERROR;
 if ((win->control.sroi.sroi_win != NULL) &&
     (get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)) != NULL))
    {
     if (win->control.display_options & DISPLAY_FILLED_ROI)
        {
         set_paint_status(&(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),1,
               PAINT_ERASE);
         set_paint_status(&(win->data.draw_masks[DRAW_MASK_CUR_ROI]),1,
               PAINT_ERASE);
         err = paint_curves_to_multiple_win(win,win->data.draw_masks,
                   win->data.num_draw_masks,0);
         set_paint_status(&(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),1,
               PAINT_SUPERIMPOSE);

         set_paint_status(&(win->data.draw_masks[DRAW_MASK_CUR_ROI]),1,
               PAINT_SUPERIMPOSE);

         if (err != NO_ERROR) return err;
        }
     win_draw_cur_roi_rec(win);
     err = paint_curves_to_multiple_win(win,win->data.draw_masks,
                (unsigned int) 2,0);
    }
 return err;
}


/*-----------------------------------------------------------------------
win_draw_processed_rois - ???
-----------------------------------------------------------------------*/

int
win_draw_processed_rois(win)
 struct image_display_window *win;
{
 int err;
 int is_polygon;
 PRT13(struct timeb the_time;)

 PRT13(ftime(&the_time))
 PRT13(printf("win_draw_processed_rois sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 PRT12(printf("win_draw_processed_rois 0 status = %x\n",(unsigned long) win->status4))
 if (win->status4 & HIDE_ALL_ROIS) return NO_ERROR;
 PRT12(printf("win_draw_processed_rois status = %x\n",(unsigned long) win->status4))
 is_polygon = win->control.display_options & DISPLAY_FILLED_ROI;
 err = NO_ERROR;

 PRT12(printf("win_draw_processed_rois...1\n"))
 if (!win_is_slice_roi_no_roi(win))
    {
     PRT12(printf("win_draw_processed_rois...1...0\n"))
     if (is_polygon)
        {err = FillDrawSliceRoiRec(
                    &(win->data.draw_masks[DRAW_MASK_OTHER_ROIS]),
                    &(win->data.draw_masks[DRAW_MASK_CUR_ROI]),
                    &(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),
                    &(win->control.sroi.sroi_win->slice_roi),
                    win->control.sroi.localto,
                    1,win->status4);
        }
       else
        {
         PRT12(printf("win_draw_processed_rois...1...sroi_win = %u\n",
             win->control.sroi.sroi_win))
         err = DrawSliceRoiRec(
                    &(win->data.draw_masks[DRAW_MASK_OTHER_ROIS]),
                    &(win->data.draw_masks[DRAW_MASK_CUR_ROI]),
                    &(win->data.draw_masks[DRAW_MASK_CUR_CURVE]),
                    &(win->control.sroi.sroi_win->slice_roi),
                    win->control.sroi.localto,win->status4);}
    }
 PRT12(printf("win_draw_processed_rois...2\n"))

 if (win->data.selection.status & PIXEL_SELECTION_MASK_READY)
    paste_selected_pixels(win);
 PRT12(printf("win_draw_processed_rois...3\n"))
 PRT13(ftime(&the_time))
 PRT13(printf("win_draw_processed_rois sec = %d  msecs = %d end\n",
         (int) the_time.time,the_time.millitm))

 return err;
}


/*-----------------------------------------------------------------------
wr_file_hdr - ???
-----------------------------------------------------------------------*/

int
wr_file_hdr(file)
 struct input_file_rec *file;
{
 int err;
 char *fn,*reason;
 Frame *frame;

 if (file == NULL) return CANCEL;
 if ((err = build_fn(&fn,file->dirfn,file->fn,file->hdr_fn_suffix)) != 
         NO_ERROR)
    {frame = (Frame *) main_display(2,NULL,0,0);
     ShowMsgStrs(*frame,0,err,0,2,
               "NOT enough memory !!!",
               "Unable to save the file header...",NULL,0);
    }
   else if ((err = file_access(fn,2,NULL,&reason)) != NO_ERROR)
    {
     frame = (Frame *) main_display(2,NULL,0,0);
     ShowMsgStrs(*frame,0,err,0,2,
               "Error writing to the header file !!!",
               reason,NULL,0);
    }
   else if ((err = wr_the_hdr(fn,&(file->hdr))) != NO_ERROR)
    {
     frame = (Frame *) main_display(2,NULL,0,0);
     ShowMsgStrs(*frame,0,err,0,2,
               "Error writing to the header file !!!",
               fn,NULL,0);
    }
 c_free(fn);
 c_free(reason);
 return err;

}


/*-----------------------------------------------------------------------
ndat_err_msg - ???
-----------------------------------------------------------------------*/

void
ndat_err_msg(file,err,is_check_exist)
 struct input_file_rec *file;
 int err;
{
 Frame *frame;
 char *tempfn,*reason,*str,*str1;

 frame = (Frame *) main_display(2,NULL,0,0);
 str = str1 = reason = NULL;
 get_output_fn(&(file->output),&tempfn);
 concat_strs(&str,3,"Error reading ",tempfn," !!!");
 if (err == FILE_ACCESS_ERROR)
    {if (access(tempfn,F_OK) == 0)
        {file_access(tempfn,6,NULL,&reason);
         concat_strs(&str1,3,"Reason : ",reason,"...!!!");
         notice_prompt(*frame,(Event *) NULL,
                        NOTICE_MESSAGE_STRINGS,str,str1,0,
                        NOTICE_BUTTON_YES,OK,0);
        }
       else if (is_check_exist)
         notice_prompt(*frame,(Event *) NULL,
                 NOTICE_MESSAGE_STRINGS,str,"File does not exist !!!",0,
                 NOTICE_BUTTON_YES,OK,0);
    }
   else if (err == BAD_VERSION)
     notice_prompt(*frame,(Event *) NULL,
               NOTICE_MESSAGE_STRINGS,str,
                "Incompatible version of .ndat file !!!",0,
               NOTICE_BUTTON_YES,OK,0);
   else
    notice_prompt(*frame,(Event *) NULL,
               NOTICE_MESSAGE_STRINGS,str,0,
               NOTICE_BUTTON_YES,OK,0);
 c_free(reason);
 c_free(str);
 c_free(str1);
 c_free(tempfn);
}


/*-----------------------------------------------------------------------
win_get_files_with_pixel_type_map - ???
-----------------------------------------------------------------------*/

int
win_get_files_with_pixel_type_map(win,file_labels,include_cur_file)
 struct image_display_window *win;
 struct strs_rec *file_labels;
 int include_cur_file;
{
 unsigned long lcv;
 struct  prog_rec *prog;
 char *fn;
 int err;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 prog = win->owner->root->prog;
 for (lcv = 0; lcv < prog->input.num_files; lcv++)
    {if (!include_cur_file)
        if (prog->input.files[lcv] == img->file) continue;

     if (prog->input.files[lcv]->pixel_type.status & PIXEL_TYPE_DEFINED)
        {if (((err = get_output_fn(&(prog->input.files[lcv]->output),&fn))
                 != NO_ERROR) ||
             ((err = add_str_to_strs_rec(file_labels,fn)) != NO_ERROR))
            {free_strs_rec(file_labels);
             return err;}
        }
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_get_file_by_name - ???
-----------------------------------------------------------------------*/

struct input_file_rec *
win_get_file_by_name(win,output_fn)
 struct image_display_window *win;
 char *output_fn;
{
 unsigned long lcv;
 struct prog_rec *prog;
 char *fn;
 int err;

 prog = win->owner->root->prog;
 for (lcv = 0; lcv < prog->input.num_files; lcv++)
    {if ((err = get_output_fn(&(prog->input.files[lcv]->output),&fn))
                 == NO_ERROR)
        {if (str_cmp(output_fn,fn) == 0)
            {c_free(fn);
             return prog->input.files[lcv];}
         c_free(fn);
        }
       else return NULL;
    }
 return NULL;
}


/*-----------------------------------------------------------------------
win_get_file_pixel_type_map - ???
-----------------------------------------------------------------------*/

int
win_get_file_pixel_type_map(win,output_fn,is_free_output_fn)
 struct image_display_window *win;
 char *output_fn;
 int is_free_output_fn;
{
 struct input_file_rec *file;
 struct img_buf_rec *img;
 int err;
 unsigned int histo_dimx1,histo_dimy1,pixel_depth1;
 unsigned int histo_dimx2,histo_dimy2,pixel_depth2;
 unsigned short histo_type1,histo_type2;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    {if (is_free_output_fn) c_free(output_fn);
     return CANCEL;}
  err = NO_ERROR;
 if (get_strlen(output_fn) > 0)
    {if ((file = (struct input_file_rec *) win_get_file_by_name(win,output_fn)) 
               != NULL)
        {
         if (file->pixel_type.status & PIXEL_TYPE_DEFINED)
            {
             histo_type1 = file_get_def_histo_type(img->file);
             get_histo_dim(&(img->file->histo_params),
                    &histo_dimx1,&histo_dimy1,&pixel_depth1,histo_type1);
             histo_type2 = file_get_def_histo_type(file);
             get_histo_dim(&(file->histo_params),
                    &histo_dimx2,&histo_dimy2,&pixel_depth2,histo_type2);

             if ((histo_dimx1 != histo_dimx2) || (histo_dimy1 != histo_dimy2) ||
                 (pixel_depth1 != pixel_depth2) || (histo_type1 != histo_type2))
                {ShowMsgStrs(win->dwin->frame,0,0,0,3,
                   "The pixel map paramters for both the files...",
                   "are not the same !!!",
                   "NOTHING CAN BE IMPORTED !!!",NULL,0);
                 if (is_free_output_fn) c_free(output_fn);
                 return err;
                }

             free_pixel_type_rec(&(img->file->pixel_type));
             if (((err = copy_buf_2d_rec(&(img->file->pixel_type.map),
                        &(file->pixel_type.map))) != NO_ERROR) ||
                 ((err = cp_strs_rec_ptrs(&(img->file->pixel_type.order),
                        &(file->pixel_type.order))) != NO_ERROR))
                {free_pixel_type_rec(&(img->file->pixel_type));
                 ShowMsgStrs(win->dwin->frame,0,0,0,3,
                   "Error occurred when importing...",
                   "the pixel type map !!!",
                   "NOTHING CAN BE IMPORTED !!!",NULL,0);
                }
               else
                {img->file->pixel_type.status |= PIXEL_TYPE_DEFINED;
                 img->file->histo_params.map.status4 &= ~BUF_DATA_VALID;
                 img->file->output.status |= FILE_TO_BE_SAVED;
                 win_run_proc_to_all_file_wins(win,
                             WinReshowPixelTypesToScreen,3,0,0,0);
                }
            }
           else
            {notice_prompt(win->dwin->frame,(Event *) NULL,
                NOTICE_MESSAGE_STRINGS,
                "This file has no valid defined pixel type map yet !!!!",
                "NOTHING CAN BE IMPORTED !!!",
                0,
                NOTICE_BUTTON_YES," OK !",
               0);
             err = CANCEL;}
        }
    }
 if (is_free_output_fn) c_free(output_fn);
 return err;
}


/*-----------------------------------------------------------------------
win_is_file_valid - ???
-----------------------------------------------------------------------*/

int
win_is_file_valid(win,file)
 struct image_display_window *win;
 struct input_file_rec *file;
{
 unsigned long lcv;
 struct prog_rec *prog;

 prog = win->owner->root->prog;
 for (lcv = 0; lcv < prog->input.num_files; lcv++)
    if (prog->input.files[lcv] == file) return 1;
 return 0;
}


/*-----------------------------------------------------------------------
win_is_file_img_valid - ???
-----------------------------------------------------------------------*/

int
win_is_file_img_valid(win,file,img)
 struct image_display_window *win;
 struct input_file_rec *file;
 struct img_buf_rec *img;
{
 unsigned long lcv,cnt;
 struct prog_rec *prog;

 PRT5(printf("win_is_file_img_valid...win = %u file = %u img = %u\n",win,file,img))
 PRT5(printf("win->owner = %u...\n",win->owner))
 if (win->owner == NULL) return 0;
 PRT5(printf("win->owner->root = %u\n",win->owner->root))
 if (win->owner->root == NULL) return 0;
 PRT5(printf("win_is_file_img_valid...win = %u file = %u img = %u\n",win,file,img))
 prog = win->owner->root->prog;
 PRT5(printf("prog = %u\n",prog))
 if (prog == NULL) return 0;
 for (lcv = 0; lcv < prog->input.num_files; lcv++)
    if (prog->input.files[lcv] == file)
       {
 PRT5(printf("file->img.num_data = %d\n",file->img.num_data))
        for (cnt = 0; cnt < file->img.num_data; cnt++)
           if (file->img.data[cnt] == img) return 1;
        return 0;
       }
 return 0;
}


/*-----------------------------------------------------------------------
win_scale_color_2d - ???
-----------------------------------------------------------------------*/

int
win_scale_color_2d(win,dest_2d,src_2d)
 struct image_display_window *win;
 struct buf_2d_rec *dest_2d,*src_2d;
{
 unsigned long first,num_colors;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 win_first_and_num_colors(win,&first,&num_colors);
 return Scale2dPixels(dest_2d,src_2d,
          (double) first,(double) (first + num_colors - 1),
          0,(double) .0,(double) .0,0);
}


/*-----------------------------------------------------------------------
win_reverse_slice_rois - ???
-----------------------------------------------------------------------*/

int
win_reverse_slice_rois(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 unsigned long last,next;
 struct slice_roi_win_rec *sroi_win;
 struct slice_info_rec *slice_info;

 PRT8(printf("win_reverse_slice_rois...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 slice_info = &(img->file->slice_info);
 if (slice_info->num_sroi_wins <= 1) return NO_ERROR;
 PRT8(for (next = 0; next < slice_info->num_sroi_wins; next++)
         printf("%d) sroi_win = %u\n",next,slice_info->sroi_wins[next]);)
 if (slice_info->num_sroi_wins % 2)
    {next = (slice_info->num_sroi_wins + 1) / 2;
     last = next - 2;}
   else
    {next = slice_info->num_sroi_wins / 2;
     last = next - 1;}
 for (;;)
    {sroi_win = slice_info->sroi_wins[next];
     slice_info->sroi_wins[next] = slice_info->sroi_wins[last];
     slice_info->sroi_wins[last] = sroi_win;
     if (last == 0) break;
     last -= 1;
     next += 1;
    }
 PRT8(printf("win_reverse_slice_rois...1\n"))
 AssociateSlicesWithSliceRoiWinRecs(&(img->file->hdr),
        img->file->hdr.scans,img->file->hdr.num_scans,slice_info->sroi_wins,
        slice_info->num_sroi_wins);
 PRT8(for (next = 0; next < slice_info->num_sroi_wins; next++)
         printf("after %d) sroi_win = %u\n",next,slice_info->sroi_wins[next]);)
 img->file->output.status |= FILE_TO_BE_SAVED;
 win_run_proc_to_all_file_wins(win,win_get_slice_roi_win,1,0,0,0);
 win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,1,0,0,0);
 PRT8(printf("win_reverse_slice_rois...\n\n"))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_reverse_the_images - ???
-----------------------------------------------------------------------*/

int
win_reverse_the_images(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img,**imgs;
 struct hdr_scan_entry_rec *scans,*cur;
 unsigned long lcv,num_slices;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;

 ReverseHdrScans(&(img->file->hdr));
 imgs = img->file->img.data;
 for (lcv = 0; lcv < img->file->img.num_data; lcv++)
    {cur = imgs[lcv]->cur_slice;
     PRT8(printf("%d) s# = %d e# = %d sc# = %d n# = %d\n",lcv,
        cur->slice_num,cur->echo_num,cur->scan_num,cur->num);)
     LocateScanEntry(&(img->file->hdr),cur->slice_num,
             cur->scan_num,cur->echo_num,&(imgs[lcv]->cur_slice));
     PRT8(cur = imgs[lcv]->cur_slice;
        printf("after %d) s# = %d e# = %d sc# = %d n# = %d\n",lcv,
        cur->slice_num,cur->echo_num,cur->scan_num,cur->num);)
     if (imgs[lcv]->last_slice != NULL)
        {cur = imgs[lcv]->last_slice;
         LocateScanEntry(&(img->file->hdr),cur->slice_num,
             cur->scan_num,cur->echo_num,&(imgs[lcv]->last_slice));}
     if (imgs[lcv]->previous_slice != NULL)
        {cur = imgs[lcv]->previous_slice;
         LocateScanEntry(&(img->file->hdr),cur->slice_num,
             cur->scan_num,cur->echo_num,&(imgs[lcv]->previous_slice));}
    }
 num_slices = NumberOfSliceCuts(&(img->file->hdr.data_info));
 scans = img->file->hdr.scans;
 for (lcv = 0; lcv < num_slices; lcv++)
    {PRT8(printf("%d) s# = %d sroi_win = %u after = %u\n",lcv,scans[lcv].slice_num,
          img->file->slice_info.sroi_wins[lcv],
          scans[lcv].slice->slice_roi_win);)
     img->file->slice_info.sroi_wins[lcv] = 
              scans[lcv].slice->slice_roi_win;
    }
 img->file->output.status |= FILE_TO_BE_SAVED;
 ComputeScanEntryExtraInfo(&(img->file->hdr));
 RedefineHdrNumBySliceNum(&(img->file->hdr));
 win_run_proc_to_all_file_wins(win,win_multiple_set_frame_label,1,0,0,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
 win_reverse_images- ???
-----------------------------------------------------------------------*/

int
win_reverse_images(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 char *the_fn,*the_fn1,*reason;
 static char *str = "The hdr file is not updated !!!";
 int err;

 the_fn = the_fn1 = NULL;
 err = CANCEL;
 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((err = FileName(img->file,&the_fn)) != NO_ERROR) ||
     ((the_fn1 = (char *) UniqueFn("",the_fn,"")) == NULL))
    {if (err == NO_ERROR) err = CANCEL;
     notice_prompt(win->dwin->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"Error reversing images !!!",
          "probably memory error !!!",0,
          NOTICE_BUTTON_YES,FAILED,0);
     c_free(the_fn);
     c_free(the_fn1);
     return err;
    }

 if (((err = file_access(the_fn,WORLD_WRITE_MODE,NULL,&reason)) != NO_ERROR) ||
     ((err = file_access(the_fn1,WORLD_WRITE_MODE,NULL,&reason)) != NO_ERROR))
    {notice_prompt(win->dwin->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,"File Access Error !!!",
          reason,0,
          NOTICE_BUTTON_YES,FAILED,0);
     c_free(the_fn);
     c_free(the_fn1);
     c_free(reason);
     return err;
    }
 if ((err = win_reverse_the_images(win)) != NO_ERROR)
    notice_prompt(win->dwin->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,
          "Error reversing the images !!!",0,
          NOTICE_BUTTON_YES,FAILED,0);
   else if ((err = wr_the_hdr(the_fn1,&(img->file->hdr))) != NO_ERROR)
    notice_prompt(win->dwin->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,
          "Error writing the hdr file !!!",str,0,
          NOTICE_BUTTON_YES,FAILED,0);
   else if (rename(the_fn1,the_fn) != 0)
    {notice_prompt(win->dwin->frame,(Event *) NULL,
          NOTICE_MESSAGE_STRINGS,
          "Error renaming the hdr file !!!",str,0,
          NOTICE_BUTTON_YES,FAILED,0);
     err = CANCEL;}
 c_free(the_fn);
 c_free(the_fn1);
 return err;
}


/*-----------------------------------------------------------------------
WinWidFiles - ???
-----------------------------------------------------------------------*/

int
WinWidFiles(win,wids,result)
 struct image_display_window *win;
 struct strs_rec *wids,*result;
{
 unsigned long lcv;
 struct win_rec *rwin;
 struct img_buf_rec *img1;
 char *fn,*str;
 int err;

 err = NO_ERROR;
 for (lcv = 0; lcv < wids->num_strs; lcv++)
    {if (((rwin = get_win_rec_by_wid_str(win->owner,wids->strs[lcv])) != NULL) &&
         ((img1 = win_rec_cur_img_buf(rwin)) != NULL))
        {if ((err = FileName(img1->file,&fn)) == NO_ERROR)
            {if ((err = concat_strs(&str,3,wids->strs[lcv],">",fn)) == NO_ERROR)
                {if (result == NULL)
                    {c_free(wids->strs[lcv]);
                     wids->strs[lcv] = str;}
                   else
                    {if ((err = add_str_ptr_to_strs_rec(result,str)) != NO_ERROR)
                        c_free(str);
                    }
                }
             c_free(fn);
            }
         if (err != NO_ERROR) break;
        }
    }
 return err;
}


/*-----------------------------------------------------------------------
find_file_first_window - ???
-----------------------------------------------------------------------*/

struct image_display_window *
find_file_first_window(file,indx,select)
 struct input_file_rec *file;
 unsigned long *indx,select;
{
 unsigned long lcv;
 struct image_display_window *win;

 for (lcv = 0; lcv < file->img.num_data; lcv++)
    if ((file->img.data[lcv] != NULL) &&
        (file->img.data[lcv]->win != NULL))
       {if (!(select & 2))
           if (((win = file->img.data[lcv]->win->image_display) != NULL) &&
               (win->num_display_wins > 0))
              {if (indx != NULL) *indx = lcv;
               return win;}
        if (!(select & 1))
           if (((win = file->img.data[lcv]->win->histogram) != NULL) &&
               (win->num_display_wins > 0))
              {if (indx != NULL) *indx = lcv;
               return win;}
       }
 return NULL;
}


/*-----------------------------------------------------------------------
WinFindNextEchoWin - ???
-----------------------------------------------------------------------*/

int
WinFindNextEchoWin(win,nextwin,result)
 struct image_display_window *win,*nextwin,**result;
{
 if ((win != nextwin) &&
     ((struct list_rec *) find_item(&(win->partner),nextwin,0) != NULL))
    *result = win;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
WinFindAvailNextEchoWin - ???
-----------------------------------------------------------------------*/

struct image_display_window *
WinFindAvailNextEchoWin(win)
 struct image_display_window *win;
{
 struct image_display_window *win1;

 win1 = NULL;
 WinMultiEchoRunProc(win,WinFindNextEchoWin,win,&win1);
 PRT9(printf("win1 = %u\n",win1))
 PRT9(if (win1 != NULL) printf("win1 wid = %d\n",win1->owner->wid);)
 return win1;
}
