/****************************************************************************
display_msg.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: display_msg.c,v 1.8 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/timeb.h>

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/notify.h>
#include <xview/notice.h>
#include <xview/panel.h>

#include "error_constants.h"
#include "ria_define_constants.h"
#include "str_def.h"
#include "nria_procedures.h"

#include "debug.h"


#define NUM_ERROR_PROC_ARGS 15


struct win_msg_rec
{
  int option;
  struct all_win_msg_recs *all_msgs;
  Frame msg_frame;
  int (*proc)();
  long wait_timer;
  int num_args;
  void *args[NUM_ERROR_PROC_ARGS];
};

struct all_win_msg_recs
{
  unsigned long num_msgs;
  struct win_msg_rec **msgs;
};

#define ERROR_DISPLAY_PROMPT 0
#define ERROR_DISPLAY_NO_PROMPT 1
#define ERROR_DISPLAY_ALARM 2
struct error_proc_rec
{
  Frame frame,subframe;
  int err;
  int is_deallocate_strs;
  unsigned int num_strs;
  char **strs;
  struct the_error_proc_rec *err_root;
};

struct the_error_proc_rec
{
  unsigned long num_errs;
  struct error_proc_rec **errs;
};


/* Functions defined in this file */
void init_all_win_msg_recs(struct all_win_msg_recs *all_msgs);
Notify_value next_func(Xv_Window frame, Event *event, Notify_arg arg,
    Notify_event_type type);
void wr_win_strs(Canvas canvas, struct strs_rec *labels);
void show_win_strs_repaint_proc(Canvas canvas, Pixwin *pw,
    Rectlist *repaint_area);
void show_win_frame_done_proc(Frame frame);
Frame show_win_strs(Frame frame, char *strs[], unsigned int num_strs,
    int *err);
Frame error_proc1(Frame frame, int err_display_option, char *strs[],
    unsigned int num_strs, int *err);
int msg_proc(struct win_msg_rec *msg, int which);
int msg_control(struct win_msg_rec *msg, int which);
void will_not_save_err_msg(Frame frame, int err, char *msg, char *reason);
Frame ShowMsgStrs(Frame frame, int err_display_option, int err,
    long wait_timer, int n_strs, ...);



/*--------------------------------------------------------------------------
init_all_win_msg_recs - ???
--------------------------------------------------------------------------*/

void
init_all_win_msg_recs(all_msgs)
 struct all_win_msg_recs *all_msgs;
{
 all_msgs->num_msgs = 0;
 all_msgs->msgs = NULL;
}



/*--------------------------------------------------------------------------
next_func - ???

FIXME!!  This is badly broken, since its callers expect a Notify_value to
be returned, but the this function never returns a value.  Without knowing
what it is supposed to be, I can't fix it.  -PWH 19990405
--------------------------------------------------------------------------*/

Notify_value 
next_func(frame,event,arg,type)
     Xv_Window frame;
     Event *event;
     Notify_arg arg;
     Notify_event_type type;
{
  void *arg1;
  static Event event1;
  int (*proc)();

  NOPRT(printf("next_func(): event_action = %d\n",event_action(event)));
  if (event_action(event) == ACTION_OPEN)
  {
    notify_next_event_func((Notify_client) frame,
			   (Notify_event) event,arg,type);
    event_set_action(&event1,32640);
    notify_post_event((Notify_client) frame,
		      (Notify_event) &event1,NOTIFY_SAFE);
  }
  else if (event_action(event) == 32640)
  {
    arg1 = (void *) xv_get(frame,XV_KEY_DATA,1);
    if (arg1 != NULL) 
    {
      xv_set(frame,XV_KEY_DATA,1,NULL,0);
      proc = (int (*)()) xv_get(frame,XV_KEY_DATA,2);
      (void) notify_set_itimer_func((Notify_client) arg1,
				    (Notify_func) proc,ITIMER_REAL,
				    &NOTIFY_POLLING_ITIMER,
				    (struct itimerval *) 0);
    }
  }
  else
    notify_next_event_func((Notify_client) frame,
			   (Notify_event) event,arg,type);
}



/*--------------------------------------------------------------------------
wr_win_strs - ???
--------------------------------------------------------------------------*/

void
wr_win_strs(canvas,labels)
 Canvas canvas;
 struct strs_rec *labels;
{
 int y,cnt;

 TRACE(printf("\n"))
 if (labels != NULL)
    {for (y = 20,cnt = 0; cnt < labels->num_strs; cnt++)
        if (labels->strs[cnt] != NULL)
           {user_text(canvas,NULL,1,10,y,GXcopy,NULL,labels->strs[cnt]);
            TRACE(printf("%s\n",labels->strs[cnt]))
            y += labels->cur_str;}
    }
 TRACE(printf("\n"))
}


/*--------------------------------------------------------------------------
show_win_strs_repaint_proc - ???
--------------------------------------------------------------------------*/

void
show_win_strs_repaint_proc(canvas,pw,repaint_area)
 Canvas canvas;
 Pixwin *pw;
 Rectlist *repaint_area;
{
 struct strs_rec *labels;

 labels = (struct strs_rec *) xv_get(canvas,WIN_CLIENT_DATA);
 TRACE(printf("show_win_strs_repaint_proc...\n"))
 wr_win_strs(canvas,labels);

}


/*--------------------------------------------------------------------------
show_win_frame_done_proc - ???
--------------------------------------------------------------------------*/

void
show_win_frame_done_proc(frame)
 Frame frame;
{
 Frame *frame_ptr;

 frame_ptr = (Frame *) xv_get(frame,XV_KEY_DATA,100);
 *frame_ptr = 0;
}


/*--------------------------------------------------------------------------
show_win_strs - ???
--------------------------------------------------------------------------*/

Frame 
show_win_strs(frame,strs,num_strs,err)
 Frame frame;
 char *strs[];
 unsigned int num_strs;
 int *err;
{
 static Frame subframe = 0;
 static Canvas canvas = 0;
 static struct strs_rec labels;
 static int in_use = 0;
 static char first_time = 1;
 unsigned int cnt;
 int width,height,width1,height1;

 *err = NO_ERROR;
 if (first_time) 
    {first_time = 0; 
     init_strs_rec(&labels);}
   else free_strs_rec(&labels);
  for (cnt = 0; cnt < num_strs; cnt++)
     if (strs[cnt] != NULL)
        if ((*err = add_str_to_strs_rec(&labels,strs[cnt])) != NO_ERROR)
           return 0;
 if (subframe == 0)
    {
     if ((subframe = xv_create(frame,FRAME,
                          XV_LABEL,"MESSAGE...",XV_KEY_DATA,5,&in_use,
                          FRAME_INHERIT_COLORS,TRUE,
                          FRAME_CLOSED,FALSE,0)) == 0)
        {*err = CANCEL;
         subframe = 0;
         return 0;}
     xv_set(subframe,FRAME_DONE_PROC,show_win_frame_done_proc,
              XV_KEY_DATA,100,&subframe,
              FRAME_NO_CONFIRM,TRUE,0);
     if ((canvas = xv_create(subframe,CANVAS,
                   FRAME_INHERIT_COLORS,TRUE,XV_SHOW,TRUE,CANVAS_RETAINED,FALSE,
                   CANVAS_REPAINT_PROC,show_win_strs_repaint_proc,
                   WIN_CLIENT_DATA,&labels,
                   0)) == 0)
        {xv_destroy_safe(subframe);
         subframe = 0;
         *err = CANCEL;
         return 0;}
     TRACE(printf("before notify_interpose_event_func...\n"))
     notify_interpose_event_func(subframe,next_func,NOTIFY_SAFE);
     TRACE(printf("after notify_interpose_event_func...\n"))

    }
   else win_clear(canvas,NULL,1);

 get_strs_dim(canvas,labels.strs,labels.num_strs,&width,&height,&(labels.cur_str));
 if (height == 0)
    {xv_set(subframe,XV_SHOW,FALSE,0);
     return NO_ERROR;}
 width += 20;
 height += 20;
 width1 = (int) xv_get(canvas,XV_WIDTH);
 height1 = (int) xv_get(canvas,XV_HEIGHT);
 if ((width != width1) || (height != height1))
    xv_set(canvas,XV_WIDTH,width,XV_HEIGHT,height,CANVAS_WIDTH,width,
            CANVAS_HEIGHT,height,0);
 xv_set(subframe,XV_WIDTH,width,XV_HEIGHT,height,0);
 make_2_wins_adjacent(subframe,frame,0);
 if (!xv_get(subframe,XV_SHOW) || xv_get(subframe,FRAME_CLOSED))
    xv_set(subframe,FRAME_NO_CONFIRM,TRUE,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 in_use += 1;

 TRACE(printf("....from setup in_use = %d    addr in_use = %u  subframe = %u\n",in_use,&in_use,subframe))

 wr_win_strs(canvas,&labels);
 win_flush(subframe);
 TRACE(printf("before win_flush...\n"))
 return subframe;
}


/*--------------------------------------------------------------------------
error_proc1 - ???
--------------------------------------------------------------------------*/

Frame 
error_proc1(frame,err_display_option,strs,num_strs,err)
 Frame frame;
 int err_display_option;
 char *strs[];
 unsigned int num_strs;
 int *err;
{
 if (err_display_option == ERROR_DISPLAY_PROMPT)
    {*err = notice_prompt(frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS_ARRAY_PTR,strs,
            NOTICE_BUTTON_YES,OK,
            0);
     if (*err != NOTICE_FAILED) *err = NO_ERROR;
     return 0;}
   else
    return show_win_strs(frame,strs,num_strs,err);
}


/*--------------------------------------------------------------------------
msg_proc - ???
--------------------------------------------------------------------------*/

int
msg_proc(msg,which)
 struct win_msg_rec *msg;
 int which;
{
 int err;

 (void) notify_set_itimer_func((Notify_client) msg,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 PRT(printf("msg_proc...msg->wait_timer = %d\n",msg->wait_timer))
 if (msg->wait_timer > 0)
     timer_wait(msg->wait_timer);
 if (msg->proc != NULL)
    {
     err = msg->proc(msg->args[0],msg->args[1],msg->args[2],msg->args[3],
             msg->args[4],msg->args[5],msg->args[6],msg->args[7],
             msg->args[8],msg->args[9],msg->args[10],msg->args[11],
             msg->args[12],msg->args[13],msg->args[14]);
    }
   else err = NO_ERROR;
 c_free(msg);
 return err;
}


/*--------------------------------------------------------------------------
msg_control - ???
--------------------------------------------------------------------------*/

int
msg_control(msg,which)
 struct win_msg_rec *msg;
 int which;
{
 int err,*in_use;

 (void) notify_set_itimer_func((Notify_event) msg,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);

 PRT(printf("msg_control...msg->wait_timer = %d\n",msg->wait_timer))
 if (msg->wait_timer > 0)
     timer_wait(msg->wait_timer);

 DropHandleAryPtr(&(msg->all_msgs->msgs),&(msg->all_msgs->num_msgs),msg);
 if (msg->proc != NULL)
    {
     err = msg->proc(msg->args[0],msg->args[1],msg->args[2],msg->args[3],
             msg->args[4],msg->args[5],msg->args[6],msg->args[7],
             msg->args[8],msg->args[9],msg->args[10],msg->args[11],
             msg->args[12],msg->args[13],msg->args[14]);
    }
 if (msg->option & ERROR_DISPLAY_NO_PROMPT)
    {
     in_use = (int *) xv_get(msg->msg_frame,XV_KEY_DATA,5);
     TRACE(printf("---*in_use = %d  in_use = %u  subframe = %u\n",*in_use,in_use,
                   msg->msg_frame))
     *in_use -= 1;
     if (*in_use <= 0) 
        xv_set(msg->msg_frame,XV_SHOW,FALSE,0);
     msg->msg_frame = 0;}
 c_free(msg);
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
ShowMsgStrs - ???

Frame ShowMsgStrs(frame, err_display_option, err, wait_timer,
                  num_strs, str(1), ..., str(num_strs),
                  proc, num_args [,arg(1), ..., arg(num_args)] )

frame could be NULL...

  
IMPORTANT!!!!  Make sure n_strs is updated whenever you add or
   subtract strings from the string list.  n_strs MUST match the
   number of strings in the string list, and then the proc and
   num_args arguments MUST follow.

PWH 19990405  This has been converted to stdarg.h.

DRW 961113  FIXME: Added a LOT of debugging code.  Unfortunately, the
    SunOS 4.x varargs.h macros are buggy and bad at catching errors
    (i.e. they DON'T catch errors).  I'd rather move all of this to
    Solaris 2.x, and use stdarg.h code.
--------------------------------------------------------------------------*/

Frame
ShowMsgStrs(
    Frame frame,
    int err_display_option,
    int err,
    long wait_timer,
    int n_strs,
    ...)
{
 va_list args;
 static struct all_win_msg_recs all_msgs;
 static char first_time = 1;
 struct win_msg_rec *msg;
 int *in_use;
 unsigned int num_strs;
 char **strs;
 unsigned long cnt,total;
 int ok,err1;
 char str1[100];
 struct win_msg_rec temp;

 if (first_time)
    {first_time = 0;
     init_all_win_msg_recs(&all_msgs);
    }

 temp.wait_timer = wait_timer;
 /* FIXME:  The following line changes from the external type to the
    internal type of this argument.  The conversion might not be 
    necessary, but I can't tell quickly.  -PWH 19990405 */
 num_strs = n_strs;    

 if (num_strs == 0)
     return 0;

 total = 0;
 get_ptr_memory(&strs,&total,num_strs + 2,(size_t) sizeof(char *),&err1);
 if (err1) return 0;

 TRACE(printf("	Memory allocation for %u string pointers successful.\n",
	      num_strs););

 /* Start processing variable arguments */
 va_start(args, n_strs);

 for (cnt = 0; cnt < num_strs; cnt++)
 {
   /* Sixth thru nth arguments: (char *) strings to print */
   strs[cnt] = va_arg(args, char *);
   TRACE(printf("	Arg %d: \"%s\"\n", cnt + 6, strs[cnt]););
 }
 if (err != NO_ERROR)
    {sprintf(str1,"..ERROR id = %d",err);
     strs[cnt++] = str1;
     num_strs++;}

 strs[cnt] = NULL;

 /* n+1th argument: (int (*)()) pointer to routine to call __(when?)__ */
 temp.proc = (int (*)()) va_arg(args, void *);
 TRACE(printf("	Arg %d: %p = pointer to callback routine\n",
	      num_strs + 6, (void *) temp.proc););

 /* n+2th argument: (int) number of arguments to pass to callback */
 temp.num_args = va_arg(args, int);
 TRACE(printf("	Arg %d: %d = number of args for callback routine\n",
	      num_strs + 7, temp.num_args););

 if (temp.num_args >= NUM_ERROR_PROC_ARGS) {
     c_free(strs);
     va_end(args);
     /* FIXME:  Following is probably NOT a valid Frame. -PWH 19990405 */
     return CANCEL; }

 for (cnt = 0; cnt < temp.num_args; cnt++)
 {
   /* Arguments: (void *) arguments to pass to callback routine */
   temp.args[cnt] = va_arg(args, void *);
   TRACE(printf("	Arg %d: %p\n", num_strs + 8 + cnt,
		(void *) temp.args[cnt]););
 }

 for (; cnt < NUM_ERROR_PROC_ARGS; cnt++)
    temp.args[cnt] = NULL;

 /* Finished with argument list */
 va_end(args);

 if (err_display_option == ERROR_DISPLAY_PROMPT)
 {
   error_proc1(frame,err_display_option,strs,num_strs,&ok);
   c_free(strs);
   if (temp.proc != NULL)
   {
     TRACE(printf("	Calling callback routine with %d arg(s)...\n",
		  temp.num_args););
     frame = (Frame) temp.proc( temp.args[0], temp.args[1],
			       temp.args[2], temp.args[3],
			       temp.args[4], temp.args[5],
			       temp.args[6], temp.args[7],
			       temp.args[8], temp.args[9],
			       temp.args[10], temp.args[11],
			       temp.args[12], temp.args[13],
			       temp.args[14] );
     TRACE(printf("	Return value from callback routine: %p\n",
		  (void *) frame););
     return frame;
   }
   
   return 0;
 }
 else if (err_display_option & ERROR_DISPLAY_ALARM)
   if (frame != 0) win_alarm(frame,1);

 get_handle_memory(&(all_msgs.msgs),&(all_msgs.num_msgs),1,
     (size_t) sizeof(struct win_msg_rec),&err);
 if (err != NO_ERROR) return 0;
 msg = all_msgs.msgs[all_msgs.num_msgs - 1];
 *msg = temp;
 msg->option = err_display_option;
 msg->all_msgs = &all_msgs;
 msg->msg_frame = error_proc1(frame,err_display_option,strs,num_strs,&ok);
 TRACE(printf("after error_proc1...\n"))
 c_free(strs);
 if (msg->msg_frame != 0)
    {in_use = (int *) xv_get(msg->msg_frame,XV_KEY_DATA,5);
     if (*in_use == 1)
        {
         xv_set(msg->msg_frame,WIN_CLIENT_DATA,msg,0);
         xv_set(msg->msg_frame,XV_KEY_DATA,1,msg,XV_KEY_DATA,2,msg_control,0);
        }
       else
        {
         (void) notify_set_itimer_func((Notify_client) msg,
             (Notify_func) msg_control,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
        }
     TRACE(printf("ShowMsgStrs num_msgs = %d end\n",all_msgs.num_msgs))
     return msg->msg_frame;
    }
   else
    {
     DropHandleAryPtr(&(all_msgs.msgs),&(all_msgs.num_msgs),msg);
     return 0;}
}


#if 0  /* Old varargs version */
Frame
ShowMsgStrs(va_alist)
 va_dcl
{
 va_list args;
 static struct all_win_msg_recs all_msgs;
 static char first_time = 1;
 struct win_msg_rec *msg;
 int *in_use;

 Frame frame;
 int err_display_option;
 int err;
 unsigned int num_strs;
 char **strs;
 unsigned long cnt,total;
 int ok,err1;
 char str1[100];
 struct win_msg_rec temp;

 if (first_time)
    {first_time = 0;
     init_all_win_msg_recs(&all_msgs);
    }

 /* Walk down variable argument list */
 va_start(args);
 TRACE(printf("ShowMsgStrs():\n"););

 /* First argument: (Frame) parent frame */
 frame = va_arg(args,Frame);
 TRACE(printf("	Arg 1: (Frame *) %p = frame pointer\n", (void *) frame););

 /* Second argument: (int) type of dialog */
 err_display_option = (int) va_arg(args,int);
 TRACE(printf("	Arg 2: (int) %d = type of dialog\n", err_display_option););

 /* Third argument: (int) error status */
 err = (int) va_arg(args,int);
 TRACE(printf("	Arg 3: (int) %d = error status\n", err););

 /* Fourth argument: (long) ?? */
 temp.wait_timer = va_arg(args,long);
 TRACE(printf("	Arg 4: (long) %ld = wait_timer(?)\n", temp.wait_timer););

 /* Fifth argument: (uint) number of strings to print */
 num_strs = (unsigned int) va_arg(args,int);
 TRACE(printf("	Arg 5: (uint) %u = number of strings\n", num_strs););

 if (num_strs == 0)
    {va_end(args);
     return 0;}
 total = 0;
 get_ptr_memory(&strs,&total,num_strs + 2,(size_t) sizeof(char *),&err1);
 if (err1) return 0;

 TRACE(printf("	Memory allocation for %u string pointers successful.\n",
	      num_strs););
 for (cnt = 0; cnt < num_strs; cnt++)
 {
   /* Sixth thru nth arguments: (char *) strings to print */
   strs[cnt] = va_arg(args, char *);
   TRACE(printf("	Arg %d: \"%s\"\n", cnt + 6, strs[cnt]););
 }
 if (err != NO_ERROR)
    {sprintf(str1,"..ERROR id = %d",err);
     strs[cnt++] = str1;
     num_strs++;}

 strs[cnt] = NULL;

 /* n+1th argument: (int (*)()) pointer to routine to call __(when?)__ */
 temp.proc = (int (*)()) va_arg(args, void *);
 TRACE(printf("	Arg %d: %p = pointer to callback routine\n",
	      num_strs + 6, (void *) temp.proc););

 /* n+2th argument: (int) number of arguments to pass to callback */
 temp.num_args = va_arg(args, int);
 TRACE(printf("	Arg %d: %d = number of args for callback routine\n",
	      num_strs + 7, temp.num_args););

 if (temp.num_args >= NUM_ERROR_PROC_ARGS)
    {c_free(strs);
     return CANCEL;}

 for (cnt = 0; cnt < temp.num_args; cnt++)
 {
   /* Arguments: (void *) arguments to pass to callback routine */
   temp.args[cnt] = va_arg(args, void *);
   TRACE(printf("	Arg %d: %p\n", num_strs + 8 + cnt,
		(void *) temp.args[cnt]););
 }

 for (; cnt < NUM_ERROR_PROC_ARGS; cnt++)
    temp.args[cnt] = NULL;

 /* Finished with argument list */
 va_end(args);

 if (err_display_option == ERROR_DISPLAY_PROMPT)
 {
   error_proc1(frame,err_display_option,strs,num_strs,&ok);
   c_free(strs);
   if (temp.proc != NULL)
   {
     TRACE(printf("	Calling callback routine with %d arg(s)...\n",
		  temp.num_args););
     frame = (Frame) temp.proc( temp.args[0], temp.args[1],
			       temp.args[2], temp.args[3],
			       temp.args[4], temp.args[5],
			       temp.args[6], temp.args[7],
			       temp.args[8], temp.args[9],
			       temp.args[10], temp.args[11],
			       temp.args[12], temp.args[13],
			       temp.args[14] );
     TRACE(printf("	Return value from callback routine: %p\n",
		  (void *) frame););
     return frame;
   }
   
   return 0;
 }
 else if (err_display_option & ERROR_DISPLAY_ALARM)
   if (frame != 0) win_alarm(frame,1);

 get_handle_memory(&(all_msgs.msgs),&(all_msgs.num_msgs),1,
     (size_t) sizeof(struct win_msg_rec),&err);
 if (err != NO_ERROR) return 0;
 msg = all_msgs.msgs[all_msgs.num_msgs - 1];
 *msg = temp;
 msg->option = err_display_option;
 msg->all_msgs = &all_msgs;
 msg->msg_frame = error_proc1(frame,err_display_option,strs,num_strs,&ok);
 TRACE(printf("after error_proc1...\n"))
 c_free(strs);
 if (msg->msg_frame != 0)
    {in_use = (int *) xv_get(msg->msg_frame,XV_KEY_DATA,5);
     if (*in_use == 1)
        {
         xv_set(msg->msg_frame,WIN_CLIENT_DATA,msg,0);
         xv_set(msg->msg_frame,XV_KEY_DATA,1,msg,XV_KEY_DATA,2,msg_control,0);
        }
       else
        {
         (void) notify_set_itimer_func((Notify_client) msg,
             (Notify_func) msg_control,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
        }
     TRACE(printf("ShowMsgStrs num_msgs = %d end\n",all_msgs.num_msgs))
     return msg->msg_frame;
    }
   else
    {
     DropHandleAryPtr(&(all_msgs.msgs),&(all_msgs.num_msgs),msg);
     return 0;}
}
#endif


/*--------------------------------------------------------------------------
will_not_save_err_msg - ???
--------------------------------------------------------------------------*/

void
will_not_save_err_msg(frame,err,msg,reason)
 Frame frame;
 int err;
 char *msg,*reason;
{
 char str[30];

 if (err != 0)
    {sprintf(str,"..ERROR id = %d",err);
     notice_prompt(frame,(Event *) NULL,
           NOTICE_MESSAGE_STRINGS,msg,
           "HOWEVER, AN ERROR WILL HAPPEN DURING THE SAVE !!!",
           str,reason,
           "TAKE ACTION TO FIX IT BEFORE QUITTING THE PROGRAM",
           "UNLESS YOU DO NOT WANT CHANGES TO BE SAVED LATER !!!",
           NULL,
           NOTICE_BUTTON_YES,OK,
    0);
   }
  else
   notice_prompt(frame,(Event *) NULL,
      NOTICE_MESSAGE_STRINGS,msg,
       "HOWEVER, AN ERROR WILL HAPPEN DURING THE SAVE !!!",
       reason,
       "TAKE ACTION TO FIX IT BEFORE QUITTING THE PROGRAM",
       "UNLESS YOU DO NOT WANT CHANGES TO BE SAVED LATER !!!",
       NULL,
       NOTICE_BUTTON_YES,OK,
       0);
}
