/****************************************************************************
display_pixel_type_order.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: display_pixel_type_order.c,v 1.11 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRINT(x) printf(x); fflush(stdout);
#define TRACE(x) x; fflush(stdout);
*/
#define PRINT(x)
#define TRACE(x)



#define CLEAN_UP_ORDER 0
#define SETUP_ORDER 1
#define GET_ALL_ORDER_PTR 2

struct type_order_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item pixel_types,def_order,order;
    int cur_type,cur_def,cur;
   };

struct all_type_order_recs
   {
    int num_orders;
    struct type_order_rec **orders;
   };


/* Functions defined in this file */
void init_type_order_rec(struct type_order_rec *order);
void free_type_order_rec(struct type_order_rec *order);
void init_all_type_order_recs(struct all_type_order_recs *all_orders);
void order_done_proc(Frame frame);
void order_swap_proc(Panel_item item, char *str, int row, Panel_list_op op,
    Event *event);
void order_ready_proc(Panel_item item, Event *event);
void order_cancel_proc(Panel_item item, Event *event);
void order_insert_proc(Panel_item item, Event *event);
void order_delete_def_proc(Panel_item item, Event *event);
int order_save_def_proc(Panel_item item, Event *event);
void order_help_proc(Panel_item item, Event *event);
int setup_type_order_rec(struct type_order_rec *order,
    struct image_display_window *win);
struct type_order_rec *find_type_order_rec(
   struct all_type_order_recs *all_orders, struct image_display_window *win);
struct type_order_rec *find_same_type_file(
   struct all_type_order_recs *all_orders, struct image_display_window *win);
int enter_pixel_type_order(struct image_display_window *win, int status);



/*--------------------------------------------------------------------------
init_type_order_rec - ???
--------------------------------------------------------------------------*/

void
init_type_order_rec(order)
 struct type_order_rec *order;
{
 order->status = 0;
 order->win = NULL;
 order->frame = 0;
 order->cur_def = -1;
 order->cur = -1;
 order->cur_type = -1;
}


/*--------------------------------------------------------------------------
free_type_order_rec - ???
--------------------------------------------------------------------------*/

void
free_type_order_rec(order)
 struct type_order_rec *order;
{
 struct all_type_order_recs *all_orders;

 TRACE(("free_type_order_rec...\n"))
 if (order->frame != 0)
    {destroy_all_subframes(order->frame);
     xv_destroy_safe(order->frame);}
 c_free(order);
 all_orders = (struct all_type_order_recs *) 
           enter_pixel_type_order(NULL,GET_ALL_ORDER_PTR);
 DropHandleAryPtr(&(all_orders->orders),&(all_orders->num_orders),order);
}


/*--------------------------------------------------------------------------
init_all_type_order_recs - ???
--------------------------------------------------------------------------*/

void
init_all_type_order_recs(all_orders)
 struct all_type_order_recs *all_orders;
{
 all_orders->num_orders = 0;
 all_orders->orders = NULL;
}


/*--------------------------------------------------------------------------
order_done_proc - ???
--------------------------------------------------------------------------*/

void
order_done_proc(frame)
 Frame frame;
{
 struct type_order_rec *order;

 order = (struct type_order_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_type_order_rec(order);

}


/*--------------------------------------------------------------------------
order_swap_proc - ???
--------------------------------------------------------------------------*/

void
order_swap_proc(item,str,row,op,event)
 Panel_item item;
 char *str;
 int row;
 Panel_list_op op;
 Event *event;
{
 struct type_order_rec *order;
/*
 int err,cur;
 char *str1,*str2;
*/
 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 TRACE(printf("swap_proc op = %d cur = %d  cur_type = %d cur_def = %d row = %d\n",
         op,order->cur,order->cur_type,order->cur_def,row))
 if (item == order->pixel_types)
    {if (op) order->cur_type = row;
    return /*NO_ERROR*/;
    }

 if (item == order->def_order)
    list_swap(order->def_order,op,&(order->cur_def),row,str);
    else
    list_swap(order->order,op,&(order->cur),row,str);
}


/****************************
 if (item == order->def_order)
    {cur = order->cur_def;
     TRACE(printf("...cur_def...\n"))}
   else
    {cur = order->cur;
     TRACE(printf("...cur...\n"))}
 if (op) 
    {if (cur < 0) cur = row;
       else if (cur != row)
        {str2 = NULL;
         if (((str1 = (char *) xv_get(item,PANEL_LIST_STRING,cur)) != NULL) &&
             ((err = cp_str(&str2,str)) == NO_ERROR))
            {xv_set(item,PANEL_LIST_STRING,row,str1,
                         PANEL_LIST_SELECT,row,0,0);
             xv_set(item,PANEL_LIST_STRING,cur,str2,
                         PANEL_LIST_SELECT,cur,0,0);
             cur = -1;
            }
           else
            {xv_set(item,PANEL_LIST_SELECT,cur,0,0);
             cur = row;}
         c_free(str2);
        }
    }
   else
    {cur = -1;}
 TRACE(printf("swap_proc end cur = %d\n",cur))
 if (item == order->def_order)
    order->cur_def = cur;
   else order->cur = cur;
}
************************************/


/*--------------------------------------------------------------------------
order_ready_proc - ???

FIXME:  Why is almost all of this function commented out?
--------------------------------------------------------------------------*/

void
order_ready_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct type_order_rec *order;
 /*
 struct img_buf_rec *img;
 struct strs_rec list,list1,list2;
 int lcv;
 struct roi_rec *roi;
 struct slice_roi_win_rec *slice_roi_win;
 int err;
 */

 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 /*
 if ((img = win_rec_cur_img_buf(order->win->owner)) != NULL)
    {init_strs_rec(&list1);
     if ((err = list_items(&list1,order->order)) == NO_ERROR)
        {TRACE(printf("order...\n");pr_strs_rec(&list1))
         if (list1.num_strs != img->file->pixel_type.order.num_strs)
            {ShowMsgStrs(order->frame,0,NO_ERROR,0,3,
                  "Unequal # of pixel types defined !!!",
                  "The histogram must have been updated !!!",
                  "Quit and redefine the pixel type order !!!",
                   NULL,0);
             err = CANCEL;}
            else
             {
                 init_strs_rec(&list2);
                 if ((err = cp_strs_rec_ptrs(&list2,&list1)) == NO_ERROR)
                    {sort_strs_rec_ascendingly(&list);
                     sort_strs_rec_ascendingly(&list2);
                     for (lcv = 0; lcv < list.num_strs; lcv++)
                       if (str_cmp(list.strs[lcv],list2.strs[lcv]) != 0)
                          {ShowMsgStrs(order->frame,0,NO_ERROR,0,3,
                              "Different set of pixel types are defined !!!",
                              "The histogram must have been updated !!!",
                              "Quit and redefine the pixel type order !!!",
                              NULL,0);
                          err = CANCEL;
                          break;}
                    }
                 free_strs_rec_ptrs(&list2);
                }
            }
         if (err == NO_ERROR)
            {ShowMsgStrs(order->dwin->frame,1,NO_ERROR,0,2,
                     "Defining the pixel type map...",
                    PLEASE_WAIT,win_build_pixel_type_maps,1,order->win);
             free_strs_rec(&(histo->pixel_type_order));
             histo->pixel_type_order = list1;
             TRACE(printf("order...pixel_type_order\n"))
             TRACE(pr_strs_rec(&(histo->pixel_type_order)))
            }
           else free_strs_rec(&list1);
        }
     free_strs_rec(&list);
    }
 */
 free_type_order_rec(order);
 /*
 return err;
 */
}


/*--------------------------------------------------------------------------
order_cancel_proc - ???
--------------------------------------------------------------------------*/

void
order_cancel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct type_order_rec *order;

 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 free_type_order_rec(order);
}


/*--------------------------------------------------------------------------
order_insert_proc - ???
--------------------------------------------------------------------------*/

void
order_insert_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct type_order_rec *order;

 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (order->cur_type >= 0)
    list_insert(order->pixel_types,order->cur_type,
                order->def_order,&(order->cur_def));
}

/******************
 str1 = (char *) xv_get(order->pixel_types,PANEL_LIST_STRING,order->cur_type);
 TRACE(printf("...order_insert_proc cur_type = %d cur_def = %d str1 = %s\n",order->cur_type,order->cur_def,str1))
 if (find_list_item_by_str(order->def_order,str1,&indx) != NO_ERROR)
    {TRACE(printf("...order_insert_proc...1\n"))
     if (order->cur_def >= 0)
        xv_set(order->def_order,PANEL_LIST_INSERT,order->cur_def,
                          PANEL_LIST_STRING,order->cur_def,str,0);
       else
        {num_rows = (int) xv_get(order->def_order,PANEL_LIST_NROWS);
         TRACE(printf("1 num_rows = %d\n",num_rows))
         xv_set(order->def_order,PANEL_LIST_INSERT,num_rows,
                          PANEL_LIST_STRING,num_rows,str1,0);
         TRACE(printf("2 num_rows = %d\n",num_rows))}
   }
  else if (order->cur_def >= 0)
   {TRACE(printf("...order_insert_proc...2...indx = %d\n",indx))
    str = (char *) xv_get(order->def_order,PANEL_LIST_STRING,order->cur_def);
    if (str_cmp(str,str1) != 0)
       {xv_set(order->def_order,PANEL_LIST_DELETE,indx,
                  PANEL_LIST_INSERT,order->cur_def,
                  PANEL_LIST_STRING,order->cur_def,str1,0);
       }
   }
  else
   {TRACE(printf("...order_insert_proc...3...indx = %d\n",indx))
    xv_set(order->def_order,PANEL_LIST_DELETE,indx,0);
    num_rows = (int) xv_get(order->def_order,PANEL_LIST_NROWS);
    xv_set(order->def_order,PANEL_LIST_INSERT,num_rows,
                          PANEL_LIST_STRING,num_rows,str1,0);
    TRACE(printf("z num_rows = %d\n",num_rows))
   }

 update_list_client_data(order->def_order);
}
******************************/


/*--------------------------------------------------------------------------
order_delete_def_proc - ???
--------------------------------------------------------------------------*/

void
order_delete_def_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct type_order_rec *order;
 int num_rows;

 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (order->cur_def >= 0)
    {
     xv_set(order->def_order,PANEL_LIST_DELETE,order->cur_def,0);
     num_rows = (int) xv_get(order->def_order,PANEL_LIST_NROWS);
     update_list_client_data(order->def_order);
     TRACE(printf("order_delete_def_proc 1 cur_def = %d num_rows = %d\n",order->cur_def,num_rows))
     if (order->cur_def >= num_rows)
        {
         order->cur_def = -1;}
     TRACE(printf("order_delete_def_proc 2 cur_def = %d num_rows = %d\n",order->cur_def,num_rows))
    }
}


/*--------------------------------------------------------------------------
order_save_def_proc - ???
--------------------------------------------------------------------------*/

int
order_save_def_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct type_order_rec *order;
 struct strs_rec list;
 int err,err1;
 char *reason;

 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 init_strs_rec(&list);
 if ((err = list_items(&list,order->def_order)) == NO_ERROR)
    {free_strs_rec(&(order->win->owner->root->pixel_type_priority));
     order->win->owner->root->pixel_type_priority = list;
     order->win->owner->root->pixel_type_priority.status |= SAVE_STRS_REC;
     if ((err1 = win_rec_label_file_access(order->win->owner,5,2,&reason))
            != NO_ERROR)
        {will_not_save_err_msg(order->frame,err1,
               "The PIXEL TYPE PRIORITY LIST IS UPDATED !!!",
               reason);
         c_free(reason);
        }
    }
   else
    {ShowMsgStrs(order->frame,0,err,0,2,
           "The PIXEL TYPE PRIORITY LIST IS NOT UPDATED !!!",
           "AN ERROR OCCURRED DURING THE UPDATE",NULL,0);
     free_strs_rec(&list);}
 return err;
}


/*--------------------------------------------------------------------------
order_help_proc - ???
--------------------------------------------------------------------------*/

void
order_help_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct type_order_rec *order;

 order = (struct type_order_rec *) xv_get(item,PANEL_CLIENT_DATA);
 notice_prompt(order->frame,(Event *) NULL,
       NOTICE_MESSAGE_STRINGS,
       "The priority of the pixel types determines",
       "the ownership of the histogram roi boundary",
       "pixels to which pixel type they belong...",
       "In other words, the result of the pixel type",
       "counts may be different for different",
       "priority list !!!",
       NULL,
       NOTICE_BUTTON_YES,OK,
       0);
}


/*--------------------------------------------------------------------------
setup_type_order_rec - ???
--------------------------------------------------------------------------*/

int
setup_type_order_rec(order,win)
 struct type_order_rec *order;
 struct image_display_window *win;
{
 int err;
 char *str;
 int row,temp,offset;
 Rect *rr;
 Panel_item item;
 struct img_buf_rec *img;
 struct strs_rec *labels;

 TRACE(printf("setup_type_order_rec...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
     {free_type_order_rec(order);
      return err;}
 order->win = win;
 order->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,REDEFINE_PIXEL_TYPE_ORDER);
 order->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_CLOSED,FALSE,
              FRAME_NO_CONFIRM,TRUE,
              WIN_CLIENT_DATA,order,
              FRAME_DONE_PROC,order_done_proc,
              0);
 c_free(str);
 if (order->frame == 0)
    {free_type_order_rec(order);
     return CANCEL;}
 order->panel = xv_create(order->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);
 if (order->panel == 0)
    {free_type_order_rec(order);
     return CANCEL;}
 row = 5;
 offset = xv_rows(order->panel,1) - xv_rows(order->panel,0) - 10;
 item = xv_create(order->panel,PANEL_MESSAGE,
        PANEL_LABEL_STRING,"PIXEL TYPES",
        0);

 order->pixel_types = xv_create(order->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,TRUE,
        PANEL_LIST_DISPLAY_ROWS,5,
        XV_X,5,XV_Y,row+offset-7,
        PANEL_NOTIFY_PROC,order_swap_proc,
        PANEL_CLIENT_DATA,order,0);
 labels = win_rec_get_roi_labels_PTR(order->win->owner,
                    HISTOGRAM_WINDOW);
 if (labels->num_strs > 0)
    {setup_list_items(labels,order->pixel_types,0);
     order->cur_type = 0;
     xv_set(order->pixel_types,PANEL_LIST_SELECT,order->cur_type,1,0);}
   else order->cur_type = -1;

 rr = (Rect *) xv_get(order->pixel_types,XV_RECT);
 temp = row + offset;
 item = xv_create(order->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"INSERT >",        
        PANEL_NOTIFY_PROC,order_insert_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,temp,
        PANEL_CLIENT_DATA,order,0);
 temp = temp + offset;
 item = xv_create(order->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DELETE D",        
        PANEL_NOTIFY_PROC,order_delete_def_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,temp,
        PANEL_CLIENT_DATA,order,0);

 temp = temp + offset;
 xv_create(order->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SAVE D",        
        PANEL_NOTIFY_PROC,order_save_def_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,temp,
        PANEL_CLIENT_DATA,order,0);

 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(order->panel,PANEL_MESSAGE,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
        PANEL_LABEL_STRING,"DEFAULT PRIORITY (D)",
        0);

 order->def_order = xv_create(order->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,5,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row+offset-7,
        PANEL_NOTIFY_PROC,order_swap_proc,
        PANEL_CLIENT_DATA,order,0);
 setup_list_items(&(order->win->owner->root->pixel_type_priority),
            order->def_order,0);

 rr = (Rect *) xv_get(order->pixel_types,XV_RECT);
 row = rr->r_top + rr->r_height + 5;
 order->order = xv_create(order->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_LABEL_STRING,"CUR PRIORITY (C)",
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,5,
	PANEL_NOTIFY_PROC,order_swap_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,order,0);
 setup_list_items(&(img->file->pixel_type.order),order->order,0);

 rr = (Rect *) xv_get(order->order,XV_RECT);
 row += offset;
 xv_create(order->panel,PANEL_MESSAGE,
        PANEL_LABEL_STRING,"Click any 2 labels !!!",
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 row += offset;
 xv_create(order->panel,PANEL_MESSAGE,
        PANEL_LABEL_STRING,"in C & D to swap !!!",
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);

 TRACE(printf("setup_type_order_rec...1\n"))

 row += offset;
 item = xv_create(order->panel,PANEL_BUTTON,
           PANEL_CLIENT_DATA,order,
           PANEL_LABEL_STRING,"READY",
           XV_X,rr->r_left + rr->r_width,XV_Y,row,
           PANEL_NOTIFY_PROC,order_ready_proc,0);
 item = xv_create(order->panel,PANEL_BUTTON,
           PANEL_CLIENT_DATA,order,
           PANEL_LABEL_STRING,"CANCEL",
           XV_Y,row,
           PANEL_NOTIFY_PROC,order_cancel_proc,0);
 row += offset;
 xv_create(order->panel,PANEL_BUTTON,
           PANEL_CLIENT_DATA,order,
           PANEL_LABEL_STRING,"HELP",
           XV_X,rr->r_left + rr->r_width,XV_Y,row,
           PANEL_NOTIFY_PROC,order_help_proc,0);
 TRACE(printf("setup_type_order_rec...2\n"))

 window_fit(order->panel);
 rr = (Rect *) xv_get(order->panel,XV_RECT);
 xv_set(order->panel,XV_WIDTH,rr->r_left + rr->r_width - 10,
                     XV_HEIGHT,rr->r_top + rr->r_height - 10,0);
 window_fit(order->frame);
 make_2_wins_adjacent(order->frame,win->dwin->frame,0);
 win_set_mouse_at_center(order->frame);
 xv_set(order->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 TRACE(printf("setup_type_order_rec...3\n"))

 return NO_ERROR;

}


/*--------------------------------------------------------------------------
find_type_order_rec - ???
--------------------------------------------------------------------------*/

struct type_order_rec *
find_type_order_rec(all_orders,win)
 struct all_type_order_recs *all_orders;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_orders->num_orders; lcv++)
    if (all_orders->orders[lcv]->win == win)
       return all_orders->orders[lcv];
 return NULL;
}


/*--------------------------------------------------------------------------
find_same_type_file - ???
--------------------------------------------------------------------------*/

struct type_order_rec *
find_same_type_file(all_orders,win)
 struct all_type_order_recs *all_orders;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_orders->num_orders; lcv++)
    {if ((img = win_rec_cur_img_buf(all_orders->orders[lcv]->win->owner)) != NULL)
        if (img->file == f1)
           return all_orders->orders[lcv];
    }
 return NULL;
}


/*--------------------------------------------------------------------------
enter_pixel_type_order - ???
--------------------------------------------------------------------------*/

int
enter_pixel_type_order(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_type_order_recs all_orders;
 struct type_order_rec *order;
 static char first_time = 1;
 int err;

 TRACE(printf("enter_pixel_type_order...1\n"))
 err = NO_ERROR;
 if (status == GET_ALL_ORDER_PTR)
    {if (first_time) return 0;
       else return (unsigned long) &all_orders;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_ORDER)
   {if (!first_time)
       if ((order = find_type_order_rec(&all_orders,win)) != NULL)
          free_type_order_rec(order);
    return NO_ERROR;}

 if (first_time)
    {init_all_type_order_recs(&all_orders);
     first_time = 0;}
   else
    {if ((order = find_type_order_rec(&all_orders,win)) != NULL)
        {xv_set(order->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         win_set_mouse_at_center(order->frame);
         wmgr_top(order->frame);
         return NO_ERROR;}
     if ((order = find_same_type_file(&all_orders,win)) != NULL)
        free_type_order_rec(order);
/*
     if ((order = find_same_type_file(&all_orders,win)) != NULL)
        {
         order->win = win;
         order->dwin = win->dwin;
         xv_set(order->frame,XV_OWNER,win->dwin->frame,
                XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         str = win_rec_win_id_title(win->owner,REDEFINE_PIXEL_TYPE_ORDER);
         xv_set(order->frame,XV_LABEL,str,0);
         c_free(str);
         wmgr_top(order->frame);
         win_set_mouse_at_center(order->frame);

         return NO_ERROR;
        }
*/
    }
 get_handle_memory(&(all_orders.orders),&(all_orders.num_orders),1,
     (size_t) sizeof(struct type_order_rec),&err);
 if (err != NO_ERROR) return err;
 order = all_orders.orders[all_orders.num_orders - 1];
 init_type_order_rec(order);
 TRACE(printf("enter_pixel_type_order...2\n"))

 if ((err = setup_type_order_rec(order,win)) != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the pixel type order window !!!",NULL,0);
 return err;

}

