/****************************************************************************
dp_more_roi_options.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_more_roi_options.c,v 1.11 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)



#define CLEAN_UP_GA_PARAMS 0
#define SETUP_GA_PARAMS 1
#define GET_ALL_PT_PTR 2

struct more_roi_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item which_dir,left_minus,left_plus,                    
               right_minus,right_plus,rois,offset,x_msg;
   };

struct all_more_roi_recs
   {
    int num_dps;
    struct more_roi_rec **dps;
   };


/* Functions defined in this file */
void init_more_roi_rec(struct more_roi_rec *dp);
void free_more_roi_rec(struct more_roi_rec *dp);
void init_all_more_roi_recs(struct all_more_roi_recs *all_dps);
void more_roi_frame_done_proc(Frame frame);
void more_dp_rois(struct more_roi_rec *dp);
void more_dp_rois_proc(Panel_item item, Event event);
int more_roi_cur_x_msg(struct more_roi_rec *dp, char *chosen_str,
    int re_compute);
void more_select_roi_proc(Panel_item item, char *str, caddr_t client_data,
    Panel_list_op op, Event *event);
void more_xy_direction_proc(Panel_item item, int value, Event *event);
void more_move_x_proc(Panel_item item, Event *event);
int setup_more_roi_rec(struct more_roi_rec *dp,
    struct image_display_window *win);
struct more_roi_rec *find_more_roi_rec(struct all_more_roi_recs *all_dps,
    struct image_display_window *win);
int enter_more_roi_options_proc(struct image_display_window *win, int status);



/*--------------------------------------------------------------------------
init_more_roi_rec - ???
--------------------------------------------------------------------------*/

void
init_more_roi_rec(dp)
 struct more_roi_rec *dp;
{
 dp->status = 0;
 dp->win = NULL;
 dp->frame = 0;
}


/*--------------------------------------------------------------------------
free_more_roi_rec - ???
--------------------------------------------------------------------------*/

void
free_more_roi_rec(dp)
 struct more_roi_rec *dp;
{
 struct all_more_roi_recs *all_dps;

 TRACE(printf("free_more_roi_rec...dp->win->dwin = %u\n",dp->win->dwin))
 TRACE(printf("free_more_roi_rec...1\n"))
 if (dp->frame != 0)
    {xv_destroy_safe(dp->frame);
     dp->frame = 0;
    }
 c_free(dp);
 all_dps = (struct all_more_roi_recs *) 
           enter_more_roi_options_proc(NULL,GET_ALL_PT_PTR);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
 TRACE(printf("free_more_roi_rec...end\n"))
}


/*--------------------------------------------------------------------------
init_all_more_roi_recs - ???
--------------------------------------------------------------------------*/

void
init_all_more_roi_recs(all_dps)
 struct all_more_roi_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}


/*--------------------------------------------------------------------------
more_roi_frame_done_proc - ???
--------------------------------------------------------------------------*/

void
more_roi_frame_done_proc(frame)
 Frame frame;
{
 struct more_roi_rec *dp;

 dp = (struct more_roi_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_more_roi_rec(dp);
}


/*--------------------------------------------------------------------------
more_dp_rois - ???
--------------------------------------------------------------------------*/

void
more_dp_rois(dp)
 struct more_roi_rec *dp;
{
 struct strs_rec labels;
 struct img_buf_rec *img;
 struct roi_rec *roi;
 int err;

 if ((img = win_rec_cur_img_buf(dp->win->owner)) == NULL)
     return /*NO_ERROR*/;
 init_strs_rec(&labels);
 if (dp->win->control.sroi.sroi_win != NULL)
    if ((err = GetRoiLabelPtrs(&(dp->win->control.sroi.sroi_win->slice_roi),
             &labels,0,1)) != NO_ERROR)
    {free_strs_rec_ptrs(&labels);
    return /*err*/;}
 delete_all_list_items(dp->rois);
 setup_list_items(&labels,dp->rois,0);
 free_strs_rec_ptrs(&labels);
 if (((roi = get_cur_roi(&(dp->win->control.sroi.sroi_win->slice_roi))) 
          != NULL) && (roi->label != NULL))
    select_list_str_item(roi->label,dp->rois,1);

 more_roi_cur_x_msg(dp,NULL,1);
}


/*--------------------------------------------------------------------------
more_dp_rois_proc - ???
--------------------------------------------------------------------------*/

void
more_dp_rois_proc(item,event)
 Panel_item item;
 Event event;
{
 struct more_roi_rec *dp;
 Rect *rr;

 dp = (struct more_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 more_dp_rois(dp);
 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(dp->frame);
}


/*--------------------------------------------------------------------------
more_roi_cur_x_msg - ???
--------------------------------------------------------------------------*/

int
more_roi_cur_x_msg(dp,chosen_str,re_compute)
 struct more_roi_rec *dp;
 char *chosen_str;
 int re_compute;
{
 int indx;
 struct img_buf_rec *img;
 char *str1,str2[40];
 struct roi_rec *roi;
 long minx,miny,maxx,maxy;

 PRT(printf("more_roi_cur_x_msg ...\n"))
 if ((img = win_rec_cur_img_buf(dp->win->owner)) == NULL) return NO_ERROR;
 if ((((str1 = chosen_str) != NULL) ||
      ((next_selected_item(dp->rois,0,&indx) == NO_ERROR) &&
       ((str1 = (char *) xv_get(dp->rois,PANEL_LIST_STRING,indx)) != NULL))) &&
     (dp->win->control.sroi.sroi_win != NULL) &&
     ((roi = get_roi(&(dp->win->control.sroi.sroi_win->slice_roi),str1)) != NULL) &&
     (FindRoiLongMinMax(roi,dp->win->control.sroi.localto,
             &minx,&maxx,&miny,&maxy,0,0,re_compute) == NO_ERROR))
    {
     PRT(printf("more_roi_cur_x_msg ...chosen_str = %s  str1 = %s\n",chosen_str,str1))
     sprintf(str2,"LEFT X = %-ld   RIGHT X = %-ld",minx,maxx);
     xv_set(dp->x_msg,PANEL_LABEL_STRING,str2,0);
     return NO_ERROR;
    }
 PRT(printf("more_roi_cur_x_msg ...1\n"))
 xv_set(dp->x_msg,PANEL_LABEL_STRING,"LEFT X =      RIGHT X =     ",0);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
more_select_roi_proc - ???
--------------------------------------------------------------------------*/

void
more_select_roi_proc(item,str,client_data,op,event)
 Panel_item item;
 char *str;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct more_roi_rec *dp;

 dp = (struct more_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 more_roi_cur_x_msg(dp,str,1);
}


/*--------------------------------------------------------------------------
more_xy_direction_proc - ???
--------------------------------------------------------------------------*/

void
more_xy_direction_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct more_roi_rec *dp;

 dp = (struct more_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value)
    {xv_set(dp->left_plus,PANEL_LABEL_STRING,"TOP Y += OFFSET",
	XV_KEY_DATA,1,0x00000002,0);
     xv_set(dp->left_minus,PANEL_LABEL_STRING,"TOP Y -= OFFSET",
	XV_KEY_DATA,1,0x00000012,0);
     xv_set(dp->right_plus,PANEL_LABEL_STRING,"BOTTOM Y += OFFSET",
	XV_KEY_DATA,1,0x00000008,0);
     xv_set(dp->right_minus,PANEL_LABEL_STRING,"BOTTOM Y -= OFFSET",
	XV_KEY_DATA,1,0x00000018,0);
    }
   else
    {xv_set(dp->left_plus,PANEL_LABEL_STRING,"LEFT X += OFFSET",
	XV_KEY_DATA,1,0x00000001,0);
     xv_set(dp->left_minus,PANEL_LABEL_STRING,"LEFT X -= OFFSET",
	XV_KEY_DATA,1,0x00000011,0);
     xv_set(dp->right_plus,PANEL_LABEL_STRING,"RIGHT X += OFFSET",
	XV_KEY_DATA,1,0x00000004,0);
     xv_set(dp->right_minus,PANEL_LABEL_STRING,"RIGHT X -= OFFSET",
	XV_KEY_DATA,1,0x00000014,0);
    }
}


/*--------------------------------------------------------------------------
more_move_x_proc - ???
--------------------------------------------------------------------------*/

void
more_move_x_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct more_roi_rec *dp;
 struct img_buf_rec *img;
 int opr;
 long offset,indx;
 char *str1;
 struct roi_rec *roi;
 long minx,miny,maxx,maxy;

 dp = (struct more_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 opr = (int) xv_get(item,XV_KEY_DATA,1);
 offset = (int) xv_get(dp->offset,PANEL_VALUE);
 if ((img = win_rec_cur_img_buf(dp->win->owner)) == NULL)
     return /*NO_ERROR*/;
 if ((next_selected_item(dp->rois,0,&indx) == NO_ERROR) &&
     ((str1 = (char *) xv_get(dp->rois,PANEL_LIST_STRING,indx)) != NULL) &&
     (dp->win->control.sroi.sroi_win != NULL) &&
     ((roi = get_roi(&(dp->win->control.sroi.sroi_win->slice_roi),str1)) != NULL) &&
     (FindRoiLongMinMax(roi,dp->win->control.sroi.localto,
              &minx,&maxx,&miny,&maxy,0,0,1) == NO_ERROR))
    {AddOffsetToRoiXYs(roi,opr,minx,maxx,miny,maxy,offset,
             &(dp->win->control.sroi.sroi_win->slice_roi.status),
             dp->win->control.sroi.tolocal,dp->win->control.sroi.localto);
     more_roi_cur_x_msg(dp,str1,1);
     PRT(printf("more_move_x_proc str1 = %s\n",str1))
     PRT(printf("1) minx = %d miny = %d maxx = %d maxy = %d\n",minx,miny,maxx,maxy))
/*
     FindRoiLongMinMax(roi,dp->win->control.sroi.localto,
                       &minx,&maxx,&miny,&maxy,0,0,1);
     PRT(printf("2) minx = %d miny = %d  maxx = %d maxy = %d\n",minx,miny,maxx,maxy))
*/
     win_execute_proc_to_related_wins(dp->win,win_redisplay_all_curves,0,0);
    }
}


/*--------------------------------------------------------------------------
setup_more_roi_rec - ???
--------------------------------------------------------------------------*/

int
setup_more_roi_rec(dp,win)
 struct more_roi_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int temp_row,row,offset;
 Rect *rr;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) 
    {free_more_roi_rec(dp);
     return CANCEL;}
 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_more_roi_rec...1\n"))
 if (dp->frame == 0)
    {free_more_roi_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,EDIT_ROI_BOUND);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,more_roi_frame_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_more_roi_rec(dp);
     return CANCEL;}
 row = 2;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 10;
 
 dp->which_dir = xv_create(dp->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"X DIRECTION",
                                "Y DIRECTION",NULL,
	          PANEL_VALUE,0,
                  XV_X,5,XV_Y,row,
                  PANEL_NOTIFY_PROC,more_xy_direction_proc,
                  PANEL_CLIENT_DATA,dp,
                  0);
 row += offset;
 dp->offset = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"OFFSET",
        PANEL_SHOW_RANGE,FALSE,
	PANEL_VALUE,1,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,256,
	PANEL_SLIDER_WIDTH,40,
        XV_X,5,XV_Y,row,
	0);
 row += offset;
 dp->left_plus = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"LEFT X += OFFSET",
	PANEL_NOTIFY_PROC,more_move_x_proc,
	XV_KEY_DATA,1,0x00000001,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset;
 dp->left_minus = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"LEFT X -= OFFSET",
	PANEL_NOTIFY_PROC,more_move_x_proc,
	XV_KEY_DATA,1,0x00000011,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset;
 dp->right_plus = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"RIGHT X += OFFSET",
	PANEL_NOTIFY_PROC,more_move_x_proc,
	XV_KEY_DATA,1,0x00000004,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset;
 dp->right_minus = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"RIGHT X -= OFFSET",
	PANEL_NOTIFY_PROC,more_move_x_proc,
	XV_KEY_DATA,1,0x00000014,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 rr = (Rect *) xv_get(dp->offset,XV_RECT);
 xv_create(dp->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"ROIS",
                   PANEL_NOTIFY_PROC,more_dp_rois_proc,
                   XV_X,rr->r_left + rr->r_width,XV_Y,temp_row,
                   PANEL_CLIENT_DATA,dp,
                   0);
 temp_row += offset;
 dp->rois = xv_create(dp->panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,TRUE,
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_NOTIFY_PROC,more_select_roi_proc,
        XV_X,rr->r_left + rr->r_width + 2,XV_Y,temp_row,
        PANEL_CLIENT_DATA,dp,0);
 row += offset;
 dp->x_msg = xv_create(dp->panel,PANEL_MESSAGE,
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,dp,
                   0);
 more_dp_rois(dp);

 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}



/*--------------------------------------------------------------------------
find_more_roi_rec - ???
--------------------------------------------------------------------------*/

struct more_roi_rec *
find_more_roi_rec(all_dps,win)
 struct all_more_roi_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    if (all_dps->dps[lcv]->win == win)
       return all_dps->dps[lcv];
 return NULL;
}


/*--------------------------------------------------------------------------
enter_more_roi_options_proc - ???
--------------------------------------------------------------------------*/

int
enter_more_roi_options_proc(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_more_roi_recs all_dps;
 struct more_roi_rec *dp;
 static char first_time = 1;
 int err;

 TRACE(printf("more_roi_rec...0\n"))
 err = NO_ERROR;
 if (status == GET_ALL_PT_PTR)
    {if (first_time) return 0;
       else return (unsigned long) &all_dps;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_GA_PARAMS)
   {if (!first_time)
       if ((dp = find_more_roi_rec(&all_dps,win)) != NULL)
          free_more_roi_rec(dp);
    return NO_ERROR;}
 TRACE(printf("more_roi_rec...1\n"))
 if (first_time)
    {init_all_more_roi_recs(&all_dps);
     first_time = 0;}
   else
    {if ((dp = find_more_roi_rec(&all_dps,win)) != NULL)
        {
         xv_set(dp->frame,
                XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(dp->frame);
         wmgr_top(dp->frame);
         return NO_ERROR;}
    }
 TRACE(printf("more_roi_rec...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct more_roi_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_more_roi_rec(dp);
 TRACE(printf("more_roi_rec...2\n"))
 if ((err = setup_more_roi_rec(dp,win)) == NO_ERROR)
    {TRACE(printf("setup_more_roi_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the more roi options window !!!",NULL,0);
 return err;

}


