/****************************************************************************
dp_segment_echo.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_segment_echo.c,v 1.12 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "segment.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)



#define PROCESS_SLICE_NUM "PROCESS SLICE# = "

#define CLEAN_UP_DP_SEGMENT_1_ECHO_OPTIONS 0
#define SETUP_DP_SEGMENT_1_ECHO_OPTIONS 1
#define GET_ALL_DP_PTR 2

#define SEGMENT_REDEFINING_3D_PIXMAP 1

struct dp_segment_echo_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item total_slices,slice_num;
    struct hdr_scan_entry_rec *start_slice;
    struct img_rec allimgs;
    struct all_segment_rec allseg;
   };

struct all_dp_segment_echo_recs
   {
    int num_dps;
    struct dp_segment_echo_rec **dps;
   };


/* Functions defined in this file */
void init_dp_segment_echo_rec(struct dp_segment_echo_rec *dp);
void free_dp_segment_echo_rec(struct dp_segment_echo_rec *dp);
void init_all_dp_segment_echo_recs(struct all_dp_segment_echo_recs *all_dps);
void dp_segment_echo_frame_done_proc(Frame frame);
void dp_segment_echo_cancel_proc(Panel_item item, Event event);
int setup_dp_segment_echo_rec(struct dp_segment_echo_rec *dp,
    struct image_display_window *win);
struct dp_segment_echo_rec *find_dp_segment_echo_rec(
   struct all_dp_segment_echo_recs *all_dps, struct image_display_window *win);
struct dp_segment_echo_rec *find_same_dp_segment_echo_file(
   struct all_dp_segment_echo_recs *all_dps, struct image_display_window *win);
int dp_segment_echo(struct dp_segment_echo_rec *dp, int which);
int start_dp_segment_echo(struct dp_segment_echo_rec *dp);
int enter_dp_segment_echo(struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_dp_segment_echo_rec - ???
-------------------------------------------------------------------------*/

void
init_dp_segment_echo_rec(dp)
 struct dp_segment_echo_rec *dp;
{
 dp->status = 0;
 dp->win = NULL;
 dp->frame = 0;
 init_img_rec(&(dp->allimgs),NULL);
 init_all_segment_rec(&(dp->allseg));
}


/*-------------------------------------------------------------------------
free_dp_segment_echo_rec - ???
-------------------------------------------------------------------------*/

void
free_dp_segment_echo_rec(dp)
 struct dp_segment_echo_rec *dp;
{
 struct all_dp_segment_echo_recs *all_dps;

 if (dp->frame != 0)
    {xv_destroy_safe(dp->frame);
     dp->frame = 0;
    }
 if (dp->status & SEGMENT_REDEFINING_3D_PIXMAP) 
    WinRedefine3dPixmaps(dp->win);
 free_img_rec(&(dp->allimgs));
 free_all_segment_rec(&(dp->allseg));

 c_free(dp);
 all_dps = (struct all_dp_segment_echo_recs *) 
           enter_dp_segment_echo(NULL,GET_ALL_DP_PTR);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
 TRACE(printf("free_dp_segment_echo_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_dp_segment_echo_recs - ???
-------------------------------------------------------------------------*/

void
init_all_dp_segment_echo_recs(all_dps)
 struct all_dp_segment_echo_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}


/*-------------------------------------------------------------------------
dp_segment_echo_frame_done_proc - ???
-------------------------------------------------------------------------*/

void
dp_segment_echo_frame_done_proc(frame)
 Frame frame;
{
 struct dp_segment_echo_rec *dp;

 dp = (struct dp_segment_echo_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_dp_segment_echo_rec(dp);
}


/*-------------------------------------------------------------------------
dp_segment_echo_cancel_proc - ???
-------------------------------------------------------------------------*/

void
dp_segment_echo_cancel_proc(item,event)
 Panel_item item;
 Event event;
{
 struct dp_segment_echo_rec *dp;

 dp = (struct dp_segment_echo_rec *) xv_get(item,PANEL_CLIENT_DATA);
 (void) notify_set_itimer_func((Notify_client) dp,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 free_dp_segment_echo_rec(dp);
}


/*-------------------------------------------------------------------------
setup_dp_segment_echo_rec - ???
-------------------------------------------------------------------------*/

int
setup_dp_segment_echo_rec(dp,win)
 struct dp_segment_echo_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_dp_segment_echo_rec...1\n"))
 if (dp->frame == 0)
    {free_dp_segment_echo_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,PIXEL_TYPE_GROW_REGION_ANALYSIS_STR);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,dp_segment_echo_frame_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_dp_segment_echo_rec(dp);
     return CANCEL;}
 row = 3;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 10;
 dp->total_slices = xv_create(dp->panel,PANEL_SLIDER,
        PANEL_LABEL_STRING,"SLICES PROCESSED",
        PANEL_MIN_VALUE,0,
        PANEL_MAX_VALUE,
          (unsigned long) img->file->slice_info.num_sroi_wins,
        PANEL_VALUE,0,
        XV_X,5,XV_Y,row,
	PANEL_SLIDER_WIDTH,50,
        PANEL_CLIENT_DATA,dp,0);
 row += offset;
 dp->slice_num = xv_create(dp->panel,PANEL_MESSAGE,
        PANEL_LABEL_STRING,PROCESS_SLICE_NUM,
        XV_X,5,XV_Y,row,
        0);
 rr = (Rect *) xv_get(dp->slice_num,XV_RECT);
 xv_create(dp->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"CANCEL",
        XV_X,rr->r_left + rr->r_width + 30,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
        PANEL_NOTIFY_PROC,dp_segment_echo_cancel_proc,
        0);

 TRACE(printf("ok333.,..."))

 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_HEIGHT,rr->r_height - 10,XV_WIDTH,rr->r_width - 10,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_dp_segment_echo_rec - ???
-------------------------------------------------------------------------*/

struct dp_segment_echo_rec *
find_dp_segment_echo_rec(all_dps,win)
 struct all_dp_segment_echo_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    if (all_dps->dps[lcv]->win == win)
       return all_dps->dps[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
find_same_dp_segment_echo_file - ???
-------------------------------------------------------------------------*/

struct dp_segment_echo_rec *
find_same_dp_segment_echo_file(all_dps,win)
 struct all_dp_segment_echo_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    {if ((img = win_rec_cur_img_buf(all_dps->dps[lcv]->win->owner)) != NULL)
        if (img->file == f1)
           return all_dps->dps[lcv];
    }
 return NULL;
}


/*-------------------------------------------------------------------------
dp_segment_echo - ???
-------------------------------------------------------------------------*/

int
dp_segment_echo(dp,which)
 struct dp_segment_echo_rec *dp;
 int which;
{
 int done,val;
 char str[50];
 int err;
 struct img_buf_rec *img;

 TRACE(printf("dp_segment_echo...\n"))
 img = dp->allimgs.data[0];
 if (img->file->hdr.data_info.num_echoes == 1)
    /* FIXME:  Removed a final argument "0" below, since the function
       definition does not expect it.  -PWH 19990610 */
    err = segment_1_echo_1(&(img->file->histo_params),img,
			   &(img->file->pixel_type)/*,0*/);
   else err = segment_2_echo_1(&(img->file->histo_params),img,&(dp->allseg),
           &(img->file->pixel_type));
 if (err != NO_ERROR)
    done = 1;
   else
    {img->file->status |= FILE_SAVE_PIXEL_TYPE;
     img->file->output.status |= FILE_TO_BE_SAVED;
     dp->status |= SEGMENT_REDEFINING_3D_PIXMAP;
     get_next_slice("",img,1,0);
     if (img->cur_slice == dp->start_slice) done = 1;
       else done = 0;
    }
 TRACE(printf("dp_segment_2_echo...1  done = %d\n",done))
 if (done)
    {
     if (err != NO_ERROR)
        {ShowMsgStrs(dp->frame,0,err,0,2,
               "An error occured when segmenting",
               "   the slice !!!",NULL,0);
         free_histo_pixel_tissue_type_rec(
             &(img->file->histo_params));}
     (void) notify_set_itimer_func((Notify_client) dp,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
     free_dp_segment_echo_rec(dp);
    }
   else
    {val = xv_get(dp->total_slices,PANEL_VALUE) + 1;
     xv_set(dp->total_slices,PANEL_VALUE,val,0);
     sprintf(str,"%s%ld",PROCESS_SLICE_NUM,img->cur_slice->num);
     xv_set(dp->slice_num,PANEL_LABEL_STRING,str,0);}
 TRACE(printf("dp_segment_2_echo...2\n"))

 return err;
}


/*-------------------------------------------------------------------------
start_dp_segment_echo - ???
-------------------------------------------------------------------------*/

int
start_dp_segment_echo(dp)
 struct dp_segment_echo_rec *dp;
{
 struct img_buf_rec *img;
 char str[50];
 int err;

 if ((img = win_rec_cur_img_buf(dp->win->owner)) == NULL) err = CANCEL;
   else
    {init_img_rec(&(dp->allimgs),img->file);
     if ((NewImgBuf(&(dp->allimgs),
                     img->cur_slice,&err,0,0,0,0,0,0,1) != NULL) &&
         (err == NO_ERROR))
        {if (img->file->hdr.data_info.num_echoes == 1)
            err = setup_segment_1_echo(&(img->file->histo_params),
                   &(img->file->pixel_type),&(img->file->prog->win.pixel_type_priority),
                img->file->slice_info.num_sroi_wins);
           else err = setup_segment_2_echo(&(img->file->histo_params),&(dp->allseg),
                &(img->file->pixel_type),&(img->file->prog->win.pixel_type_priority),
                img->file->slice_info.num_sroi_wins,img->_2d.dimx,img->_2d.dimy);
         if (err == NO_ERROR)
            {
             win_run_proc_to_all_file_wins(dp->win,win_redisplay_all_curves,3,
					   0,0,0);
             xv_set(dp->frame,WIN_CLIENT_DATA,dp,0);
             xv_set(dp->frame,XV_KEY_DATA,1,dp,
                   XV_KEY_DATA,2,dp_segment_echo,XV_KEY_DATA,3,1,0);
             notify_interpose_event_func((Notify_client) dp->frame,
                      (Notify_func) next_func,NOTIFY_SAFE);
             dp->start_slice = dp->allimgs.data[0]->cur_slice;
             sprintf(str,"%s%ld",PROCESS_SLICE_NUM,
                            dp->allimgs.data[0]->cur_slice->num);
             xv_set(dp->slice_num,PANEL_LABEL_STRING,str,0);}
        }
    }
 if (err != NO_ERROR)
    {ShowMsgStrs(dp->frame,0,err,0,2,
               "An error occured when setting up to",
               "   segment the pixels !!!",NULL,0);
     free_dp_segment_echo_rec(dp);}
 return err;
}


/*-------------------------------------------------------------------------
enter_dp_segment_echo - ???

FIXME!  This looks like another one of those ugly kluges that compound
several separate functions via a select argument, and can't even decide
what type to return.  Rewrite it.   -PWH 19990618
-------------------------------------------------------------------------*/

int
enter_dp_segment_echo(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_dp_segment_echo_recs all_dps;
 struct dp_segment_echo_rec *dp;
 static char first_time = 1;
 int err;

 TRACE(printf("enter_dp_segment_echo...0\n"))
 err = NO_ERROR;
 if (status == GET_ALL_DP_PTR)
    {if (first_time) return 0;
       else return (unsigned long) &all_dps;}    /* FIXME: ptr as long */
  else if (status == CLEAN_UP_DP_SEGMENT_1_ECHO_OPTIONS)
   {if (!first_time)
       if ((dp = find_dp_segment_echo_rec(&all_dps,win)) != NULL)
          free_dp_segment_echo_rec(dp);
    return NO_ERROR;}
 TRACE(printf("enter_dp_segment_echo...1\n"))
 if (first_time)
    {init_all_dp_segment_echo_recs(&all_dps);
     first_time = 0;}
   else
    {if (((dp = find_dp_segment_echo_rec(&all_dps,win)) != NULL) ||
         ((dp = find_same_dp_segment_echo_file(&all_dps,win)) != NULL))
        {xv_set(dp->frame,
                XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(dp->frame);
         wmgr_top(dp->frame);
         return NO_ERROR;}
    }
 TRACE(printf("enter_dp_segment_echo...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct dp_segment_echo_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_dp_segment_echo_rec(dp);
 TRACE(printf("enter_dp_segment_echo...2\n"))
 if ((err = setup_dp_segment_echo_rec(dp,win)) == NO_ERROR)
    {TRACE(printf("setup_dp_segment_echo_rec...\n"))
     err = start_dp_segment_echo(dp);
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               PIXEL_TYPE_GROW_REGION_ANALYSIS_STR,NULL,0);
 return err;

}

