/****************************************************************************
dp_slice_scans.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_slice_scans.c,v 1.10 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



#define MEAN_SCANS 1
#define SUM_SCANS 2
#define CC_SCANS 3
#define SINGLE_SAMPLE_T_TEST 4
#define MOTION_CORRECTION 5

#define CLEAN_UP 0
#define SETUP 1
#define GET_ALL_PTR 2

struct scans_save_params_rec
   {
    Frame frame;
    char *hdr_fn,*imgfn;
    FILE *fid,*imgfid;
    Panel_item snum_item,echo_item,scan_item,show_item;
    int err,option,is_done,show;
    unsigned long lsnum,fecho,lecho,lscan;
    unsigned long csnum,cecho,cscan;
    struct hdr_scan_entry_rec *cur_scan;
    unsigned long num_slice_cuts;
    struct buf_2d_rec *slice_cuts;

    unsigned long num_scans;
    struct buf_2d_rec **scans;

    int is_ref_wave_form,is_motion_correction,is_normalized,is_result_2_echo;
    float *phases,phases_sd;
    int num_pairs,seq,pair_pts;
    double min,max,the_min,the_max;
    int save_to_same_file;
   };

struct slice_scans_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item use_r,num_phases,right_shift,show,motion_correction,normalized,
               num_pairs,seq,pair_pts,save_to_same_file,result_2_echo;
    Panel_item dir,fn;
    struct scans_save_params_rec save;
   };

struct all_slice_scans_recs
   {
    int num_ops;
    struct slice_scans_rec **ops;
   };


/* Functions defined in this file */
void init_scans_save_params_rec(struct scans_save_params_rec *save);
void free_scans_save_params_rec(struct scans_save_params_rec *save,
    Frame frame);
void init_slice_scans_rec(struct slice_scans_rec *op);
void free_slice_scans_rec(struct slice_scans_rec *op);
void init_all_slice_scans_recs(struct all_slice_scans_recs *all_ops);
void slice_scans_show_proc(Panel_item item, int value, Event *event);
void process_slice_scans_cancel_proc(Panel_item item, Event *event);
int scans_save_data(struct scans_save_params_rec *save,
    struct img_buf_rec *img);
int SaveMotionCorrection(struct scans_save_params_rec *save,
    struct img_buf_rec *img);
int SaveMotionCorrectionHdr(struct scans_save_params_rec *save,
    struct img_buf_rec *img);
int scans_save_the_data(struct scans_save_params_rec *save,
    struct img_buf_rec *img);
int slice_scans_proc(Frame frame, int which);
int process_slice_scans_done_proc(Frame frame);
int setup_scans_save_params_rec(struct slice_scans_rec *op);
int scans_fn(struct slice_scans_rec *op, int option);
int setup_slice_scans_buf(struct slice_scans_rec *op);
int process_scans_proc(Panel_item item, Event *event);
void slice_scans_frame_done_proc(Frame frame);
int setup_slice_scans_rec(struct slice_scans_rec *op,
    struct image_display_window *win);
struct slice_scans_rec *find_slice_scans_rec(
   struct all_slice_scans_recs *all_ops, struct image_display_window *win);
struct all_slice_scans_recs *enter_process_slice_scans(
   struct image_display_window *win, int status);



/*-----------------------------------------------------------------------
init_scans_save_params_rec - ???
-----------------------------------------------------------------------*/

void
init_scans_save_params_rec(save)
 struct scans_save_params_rec *save;
{
 save->frame = 0;
 save->err = NO_ERROR;
 save->err = save->is_done = 0;
 save->hdr_fn = save->imgfn = NULL;
 save->fid = save->imgfid = NULL;
 save->num_slice_cuts = 0;
 save->slice_cuts = NULL;

 save->phases = NULL;
 save->num_scans = 0;
 save->scans = NULL;
}


/*-----------------------------------------------------------------------
free_scans_save_params_rec - ???
-----------------------------------------------------------------------*/

void
free_scans_save_params_rec(save,frame)
 struct scans_save_params_rec *save;
 Frame frame;
{
 unsigned long lcv;
 char *str;

 PRT(printf("free_scans_save_params_rec err = %d is_done = %d\n",
       save->err,save->is_done))
 if ((save->err != NO_ERROR) && (save->err != CANCEL))
    {if (save->err == READ_ERROR) 
        str = "...READ INPUT_ERROR !!!..";
      else if (save->err == WRITE_ERROR) 
        str = "...WRITE OUTPUT_ERROR !!!..";
      else if (save->err == NOT_ENOUGH_HARD_DISK) 
        str = "...NOT_ENOUGH_HARD_DISK !!!..";
      else str = "...Not enough memory !!!..";
     ShowMsgStrs(frame,0,0,0,2,str,
               OPERATION_ABORTED,NULL,0);
    }

 if (save->num_slice_cuts > 0)
    {for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
        free_buf_2d_rec(&(save->slice_cuts[lcv]));
    }
 c_free(save->slice_cuts);

 if (save->num_scans > 0)
    {for (lcv = 0; lcv < save->num_scans; lcv++)
        {free_buf_2d_rec(save->scans[lcv]);
         c_free(save->scans[lcv]);}
    }
 c_free(save->scans);
 c_free(save->phases);

 if (save->fid != NULL)
    {fclose(save->fid);
     if (!save->is_done) delete_file(save->hdr_fn);}
 c_free(save->hdr_fn);
 if (save->imgfid != NULL)
    {fclose(save->imgfid);
     if (!save->is_done) delete_file(save->imgfn);}
 c_free(save->imgfn);
 init_scans_save_params_rec(save);
}


/*-----------------------------------------------------------------------
init_slice_scans_rec - ???
-----------------------------------------------------------------------*/

void
init_slice_scans_rec(op)
 struct slice_scans_rec *op;
{
 op->status = 0;
 op->win = NULL;
 op->frame = 0;
 init_scans_save_params_rec(&(op->save));
}


/*-----------------------------------------------------------------------
free_slice_scans_rec - ???
-----------------------------------------------------------------------*/

void
free_slice_scans_rec(op)
 struct slice_scans_rec *op;
{
 struct all_slice_scans_recs *all_ops;

 TRACE(printf("free_slice_scans_rec...op->win->dwin = %u\n",op->win->dwin))
 TRACE(printf("free_slice_scans_rec...1\n"))
 if (op->frame != 0)
    {xv_destroy_safe(op->frame);
     op->frame = 0;
    }
 c_free(op);
 all_ops = enter_process_slice_scans(NULL,GET_ALL_PTR);
 DropHandleAryPtr(&(all_ops->ops),&(all_ops->num_ops),op);
 TRACE(printf("free_slice_scans_rec...end\n"))
}


/*-----------------------------------------------------------------------
init_all_slice_scans_recs - ???
-----------------------------------------------------------------------*/

void
init_all_slice_scans_recs(all_ops)
 struct all_slice_scans_recs *all_ops;
{
 all_ops->num_ops = 0;
 all_ops->ops = NULL;
}


/*-----------------------------------------------------------------------
slice_scans_show_proc - ???
-----------------------------------------------------------------------*/

void
slice_scans_show_proc(item,value,event)
 Panel_item item;
 Event *event;
{
 struct slice_scans_rec *op;
 struct img_buf_rec *img;

 op = (struct slice_scans_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL) {
     process_slice_scans_done_proc(op->save.frame);
     return; }
 if (!value)
    {img->cur_slice = op->save.cur_scan;
     TRACE(printf("slice_scans_show_proc...WinNewColorMultiCanvas\n"))
     WinNewImgMultiCanvas(op->win);}
 op->save.show = value;
}


/*-----------------------------------------------------------------------
process_slice_scans_cancel_proc - ???
-----------------------------------------------------------------------*/

void
process_slice_scans_cancel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct slice_scans_rec *op;

 op = (struct slice_scans_rec *) xv_get(item,PANEL_CLIENT_DATA);
 op->save.err = CANCEL;
 process_slice_scans_done_proc(op->save.frame);
}


/*-----------------------------------------------------------------------
scans_save_data - ???
-----------------------------------------------------------------------*/

int
scans_save_data(save,img)
 struct scans_save_params_rec *save;
 struct img_buf_rec *img;
{
 double min,max,min1,max1,max2,max3;
 struct hdr_rec hdr;
 struct buf_2d_rec _2d,*fl_2d;
 struct data_info_rec *info;
 unsigned long lcv,val1,val2,depth,depth1,*indxs,type4;
 int is_scale;
 static char *pos_neg_cc_labels[] = {"+VE CORR","-VE CORR"};
 static char *pos_neg_ttest_labels[] = {"+VE T-TEST","-VE T-TEST"};
 static char *changes_labels[] = {"CHANGES"};
 char **the_labels;
 static unsigned long member_img_label_indxs[] = {0};

 PRT(printf("scans_save_data...\n"))
 init_hdr_rec(&hdr);
 if ((save->err = cp_hdr_rec(&hdr,&(img->file->hdr),1)) != NO_ERROR)
    {free_hdr_rec(&hdr);
     return save->err;}

 for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
    {MinMax2dValues(&(save->slice_cuts[lcv]),0,(double) .0,(double) .0,&min1,&max1);
     if (lcv == 0)
        {min = min1;
         max = max1;}
       else
        {if (min1 < min) min = min1;
         if (max1 > max) max = max1;}
    }
 info = &(hdr.data_info);
 info->var_use_status &= ~NUM_SCANS_USED;
 info->var_use_status &= ~INPUT_DATA_TYPE;
 PRT(printf("scans_save_data...free_hdr_scan_entry_recs\n"))
 free_hdr_scan_entry_recs(hdr.scans,hdr.num_scans);
 hdr.num_scans = 0;
 c_free(hdr.scans);
 PRT(printf("scans_save_data...min = %f max = %f\n",min,max))
 min1 = .0;
 if ((save->option == CC_SCANS) || 
     (save->option == SINGLE_SAMPLE_T_TEST))
    {is_scale = 1;
     max1 = 1000.0;
     depth1 = 16;

     if (max > .0) max2 = max;
       else max2 = .0;
     if (min < .0) max3 = -min;
       else max3 = .0;
     PRT(printf("max2 = %f max3 = %f\n",max2,max3))
     if (max2 < max3) max2 = max3;

     free_hdr_analysis_rec(&(hdr.analysis));
     indxs = member_img_label_indxs;

     if (save->is_result_2_echo)
        {PRT(printf("is_result_2_echo...\n"))
         info->num_echoes = 2;
         info->max_scans = save->num_slice_cuts * 2;
         if (save->option == CC_SCANS) the_labels = pos_neg_cc_labels;
           else the_labels = pos_neg_ttest_labels;
         info->var_use_status |= POS_NEG_ACTIVATION;
        }
       else
        {PRT(printf("is_result_1_echo...\n"))
         info->num_echoes = 1;
         info->max_scans = save->num_slice_cuts;
         info->var_use_status |= INPUT_DATA_SIGNED;
         info->var_use_status |= CHANGES_ACTIVATION;
         the_labels = changes_labels;}

     if ((save->err = hdr_image_labels(&hdr,the_labels,indxs)) != NO_ERROR)
        {free_hdr_rec(&hdr);
         return save->err;}
     
     PRT(printf("final max2 = %f max3 = %f\n",max2,max3))
    }
   else
    {
     info->max_scans = save->num_slice_cuts;
     val1 = 0xffffffff;
     if (info->pixel_depth_bits > 16)
        {max1 = (double) val1;
         depth1 = 32;}
       else
        {max1 = (double) 10000.0;
         depth1 = 16;}
     if ((min < .0) || (max > (double) val1))
        is_scale = 1;
       else
        {val2 = (unsigned long) rint(max);
         depth = find_num_bits_needed(val2);
         if (depth1 < depth) is_scale = 1;
           else is_scale = 0;
        }
     if (!is_scale)
        {max1 = max;
         min1 = min;}
    }
 PRT(printf("..min = %f max = %f min1 = %f max1 = %f is_scale = %d depth1 = %d\n",
         min,max,min1,max1,is_scale,depth1))
 info->pixel_depth_bits = depth1;
 if ((save->option == CC_SCANS) || 
     (save->option == SINGLE_SAMPLE_T_TEST))
    {if (save->is_result_2_echo)
        info->min_pixel = min1;
       else info->min_pixel = -max1;}
   else info->min_pixel = min1;
 info->max_pixel = max1;
 PRT(printf("min_pixel = %f max_pixel = %f\n",info->min_pixel,info->max_pixel))
 if ((save->err = BuildRiaHdr(&hdr,0)) == NO_ERROR)
    {
     save->err = wr_hdr(save->fid,&hdr);}
 PRT(printf("var_use_status = %x\n",info->var_use_status))
 type4 = InputDataTypeToBufType(info);
 free_hdr_rec(&hdr);
 if (save->err != NO_ERROR) return save->err;

 init_buf_2d_rec(&_2d);
 if ((save->err = SetupBuf2dRec(&_2d,save->slice_cuts[0].dimx,
        save->slice_cuts[0].dimy,depth1,type4)) != NO_ERROR)
    return save->err;
 PRT(printf("type4 = %x status4 = %x total_bytes = %d\n",type4,_2d.status4,_2d.total_bytes))

 if ((save->option == CC_SCANS) || (save->option == SINGLE_SAMPLE_T_TEST))
    fl_2d = save->scans[0];
 for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
    {if ((save->option == CC_SCANS) || (save->option == SINGLE_SAMPLE_T_TEST))
        {
         PRT(MinMax2dValues(&(save->slice_cuts[lcv]),0,(double) .0,(double) .0,&min4,&max4);
             printf("%d) slice_cuts min4 = %f max4 = %f\n",lcv,min4,max4))

         SelectAssign2d(fl_2d,&(save->slice_cuts[lcv]),
               0x00004402,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
         Scale2dValues(&_2d,fl_2d,(double) .0,max2,
                   0,(double) .0,(double) .0,min1,max1);

         PRT(MinMax2dValues(fl_2d,0,(double) .0,(double) .0,&min4,&max4);
             printf("%d) fl_2d min4 = %f max4 = %f\n",lcv,min4,max4))

         PRT(MinMax2dValues(&_2d,0,(double) .0,(double) .0,&min4,&max4);
             printf("%d) _2d min4 = %f max4 = %f max4 * max2 /max1 = %f\n",
                 lcv,min4,max4,max4 * max2/max1))

         SelectAssign2d(fl_2d,&(save->slice_cuts[lcv]),
               0x00004601,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
         PRT(MinMax2dValues(fl_2d,0,(double) .0,(double) .0,&min4,&max4);
             printf("==%d) fl_2d min4 = %f max4 = %f\n",lcv,min4,max4))

         if (save->is_result_2_echo)
            {if (fwrite(_2d.buf[0],_2d.total_bytes,1,save->imgfid) != 1)
                {save->err = WRITE_ERROR;
                 break;}
             Scale2dValues(&_2d,fl_2d,(double) .0,max2,
                   0,(double) .0,(double) .0,min1,max1);
            }
           else
            {Scale2dValues(fl_2d,fl_2d,(double) .0,max2,
                   0,(double) .0,(double) .0,min1,max1);
             PRT(MinMax2dValues(fl_2d,0,(double) .0,(double) .0,&min4,&max4);
                printf("==%d) after scale fl_2d min4 = %f max4 = %f\n",lcv,min4,max4))
             SelectAssign2d(&_2d,fl_2d,
               0x00002002,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
            }

         PRT(MinMax2dValues(&_2d,0,(double) .0,(double) .0,&min4,&max4);
             printf("==%d) _2d min4 = %f max4 = %f max4 * max2 /max1 = %f\n",
                 lcv,min4,max4,max4 * max2/max1))
        }
       else if (is_scale)
        Scale2dValues(&_2d,&(save->slice_cuts[lcv]),min,max,
                   0,(double) .0,(double) .0,min1,max1);
       else Assign2d(&_2d,&(save->slice_cuts[lcv]));
     if (fwrite(_2d.buf[0],_2d.total_bytes,1,save->imgfid) != 1)
        {save->err = WRITE_ERROR;
         break;}
    }
 free_buf_2d_rec(&_2d);
 if (save->err == NO_ERROR) save->is_done = 1;
 return save->err;
}


/*-----------------------------------------------------------------------
SaveMotionCorrection - ???
-----------------------------------------------------------------------*/

int
SaveMotionCorrection(save,img)
 struct scans_save_params_rec *save;
 struct img_buf_rec *img;
{
 struct buf_2d_rec _2d;
 struct hdr_scan_entry_rec *scan_entry;
 unsigned long lcv;

 init_buf_2d_rec(&_2d);
 if ((save->err = SetupBuf2dRec(&_2d,
       save->scans[0]->dimx,save->scans[0]->dimy,
       img->file->hdr.data_info.pixel_depth_bits,0)) != NO_ERROR)
    return save->err;
 if (save->min < .0) save->min = .0; 
 if (save->csnum == 0)
    {save->the_min = save->min;
     save->the_max = save->max;
    }
   else
    {if (save->min < save->the_min) save->the_min = save->min;
     if (save->max > save->the_max) save->the_max = save->max;}

 for (lcv = 0; lcv <= save->lscan; lcv++)
    {
     SelectAssign2d(&_2d,save->scans[lcv],0x00004402,
            (double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
     if ((save->err = LocateScanEntry(&(img->file->hdr),save->csnum,
                lcv,save->cecho,&scan_entry)) == NO_ERROR)
        if (save->save_to_same_file == 0)
           {PRT(printf("%d) scan_entry->img_addr = %u\n",lcv,scan_entry->img_addr);)
            fseek(save->imgfid,scan_entry->img_addr,0);
            if (fwrite(_2d.buf[0],_2d.total_bytes,1,save->imgfid) != 1)
               {save->err = WRITE_ERROR;
                break;}
           }
          else
           {PRT(printf("%d) same file scan_entry->img_addr = %u\n",
                   lcv,scan_entry->img_addr);)
            img->cur_slice = scan_entry;
            if ((save->err = wr_slice(img,&_2d,NULL)) != NO_ERROR)
               break;
           }
    }
 free_buf_2d_rec(&_2d);
 if (save->err == NO_ERROR) save->is_done = 1;
 return save->err;
}


/*-----------------------------------------------------------------------
SaveMotionCorrectionHdr - ???
-----------------------------------------------------------------------*/

int
SaveMotionCorrectionHdr(save,img)
 struct scans_save_params_rec *save;
 struct img_buf_rec *img;
{
 double min,max;
 struct data_info_rec *info;

 info = &(img->file->hdr.data_info);
 if (save->save_to_same_file == 0)
    {
     min = info->min_pixel;
     max = info->max_pixel;
     info->min_pixel = save->the_min;
     info->max_pixel = save->the_max;
     save->err = wr_hdr(save->fid,&(img->file->hdr));
     info->min_pixel = min;
     info->max_pixel = max;
     return save->err;
    }
   else
    {info->min_pixel = save->the_min;
     info->max_pixel = save->the_max;}

 return NO_ERROR;
}


/*-----------------------------------------------------------------------
scans_save_the_data - ???
-----------------------------------------------------------------------*/

int
scans_save_the_data(save,img)
 struct scans_save_params_rec *save;
 struct img_buf_rec *img;
{
 unsigned long lcv;

 if (save->option == MEAN_SCANS)
    {PRT(printf("scans_save_the_data...\n"))
     for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
        {PRT(MinMax2dValues(&(save->slice_cuts[lcv]),0,
                  (double) .0,(double) .0,&min4,&max4);
         printf("%d) MEAN_SCANS min4 = %f max4 = %f\n",lcv,min4,max4))
         Div2dByConstant(&(save->slice_cuts[lcv]),&(save->slice_cuts[lcv]),
            (double) (save->lscan + 1.0),0);}
    }
 if (save->option == MOTION_CORRECTION)
    return SaveMotionCorrectionHdr(save,img);
   else return scans_save_data(save,img);
}


/*-----------------------------------------------------------------------
slice_scans_proc - ???
-----------------------------------------------------------------------*/

int
slice_scans_proc(frame,which)
 Frame frame;
 int which;
{
 struct slice_scans_rec *op;
 struct img_buf_rec *img;
 struct hdr_scan_entry_rec *scan_entry;
 struct scans_save_params_rec *save;
 unsigned long indx;

 op = (struct slice_scans_rec *) xv_get(frame,WIN_CLIENT_DATA);
 save = &(op->save);
 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL) 
    return process_slice_scans_done_proc(save->frame);

 if ((save->csnum <= save->lsnum) && 
     (save->cecho < img->file->hdr.data_info.num_echoes) &&
     (save->cscan <= save->lscan))
    {/*PRT(printf("slice_scans_proc csnum = %d  cecho = %d  cscan = %d\n",
         save->csnum,save->cecho,save->cscan))*/
     indx = save->csnum * (save->lecho - save->fecho + 1) + 
            save->cecho - save->fecho;
     if (save->option == CC_SCANS)
        {if ((save->err = SliceCorrelationCoeff(img->file->img_fid,
              &(img->file->hdr),save->scans,save->num_scans - 4,
              save->csnum,save->cecho,&(save->scans[save->num_scans - 4]),4,
              save->is_ref_wave_form,save->phases,save->phases_sd,
              save->is_normalized,
              save->is_motion_correction,&(save->slice_cuts[indx]))) == NO_ERROR)
            save->cscan = save->lscan + 1;
        }
       else if (save->option == SINGLE_SAMPLE_T_TEST)
        {if ((save->err = SingleSampleTTest(img->file->img_fid,
              &(img->file->hdr),save->scans,save->num_scans - 4,
              save->csnum,save->cecho,&(save->scans[save->num_scans - 4]),4,
              save->num_pairs,save->seq,save->pair_pts,
              save->is_motion_correction,&(save->slice_cuts[indx]))) == NO_ERROR)
            save->cscan = save->lscan + 1;
        }
       else if (save->option == MOTION_CORRECTION)
        {if (((save->err = SliceMotionCorrection(img->file->img_fid,
              &(img->file->hdr),save->scans,save->num_scans - 4,
              save->csnum,save->cecho,&(save->scans[save->num_scans - 4]),4,
              &(save->min),&(save->max))) == NO_ERROR) &&
             ((save->err = SaveMotionCorrection(save,img)) == NO_ERROR))
            save->cscan = save->lscan + 1;
        }
       else if ((save->err = LocateScanEntry(&(img->file->hdr),save->csnum,
                save->cscan,save->cecho,&scan_entry)) == NO_ERROR)
        {img->cur_slice = scan_entry;
         if ((save->err = RdSlice(img,0,NULL,4)) == NO_ERROR)
            {if (save->show) WinNewImgMultiCanvas(img->win->image_display);
             /*PRT(printf("Add2ds s# = %d e# = %d sc# = %d\n",
                  save->csnum,save->cecho,save->cscan))*/
             Add2ds(&(save->slice_cuts[indx]),&(save->slice_cuts[indx]),&(img->_2d));
            }
        }
     if (save->err != NO_ERROR) return process_slice_scans_done_proc(save->frame);
     save->cscan += 1;
     if (save->cscan > save->lscan)
        {save->cscan = 0;
         save->cecho += 1;
         if (save->cecho >= save->lecho)
            {save->cecho = 0;
             save->csnum += 1;
             if (save->csnum > save->lsnum) 
                {scans_save_the_data(save,img);
                 return process_slice_scans_done_proc(save->frame);}
             xv_set(save->snum_item,PANEL_VALUE,save->csnum+1,0);
            }
         if (save->echo_item != 0)
            xv_set(save->echo_item,PANEL_VALUE,save->cecho+1,0);
        }
     if (save->scan_item != 0)
        xv_set(save->scan_item,PANEL_VALUE,save->cscan+1,0);
    }
   else return process_slice_scans_done_proc(save->frame);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
process_slice_scans_done_proc - ???
-----------------------------------------------------------------------*/

int
process_slice_scans_done_proc(frame)
 Frame frame;
{
 struct slice_scans_rec *op;
 struct img_buf_rec *img;

 PRT(printf("process_slice_scans_done_proc...\n"))
 op = (struct slice_scans_rec *) xv_get(frame,WIN_CLIENT_DATA);
 xv_set(op->frame,FRAME_BUSY,FALSE,0);
 (void) notify_set_itimer_func(frame,NOTIFY_FUNC_NULL,
             ITIMER_REAL,(struct itimerval *) 0,(struct itimerval *) 0);
 xv_destroy_safe(frame);
 free_scans_save_params_rec(&(op->save),op->frame);
 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL) return NO_ERROR;
 if (img->cur_slice != op->save.cur_scan)
    {img->cur_slice = op->save.cur_scan;
     TRACE(printf("process_slice_scans_done_proc...WinNewColorMultiCanvas\n"))
     WinNewImgMultiCanvas(op->win);}
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
setup_scans_save_params_rec - ???
-----------------------------------------------------------------------*/

int
setup_scans_save_params_rec(op)
 struct slice_scans_rec *op;
{
 struct img_buf_rec *img;
 Panel panel;
 struct scans_save_params_rec *save;
 int row,offset;
 char *str,*str1,str2[50];
 Rect *rr;

 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL)
    {free_scans_save_params_rec(&(op->save),op->frame);
     return CANCEL;}
 save = &(op->save);
 if (save->option == MEAN_SCANS) str1 = "MEAN OF SLICE SCANS...";
   else if (save->option == SUM_SCANS) str1 = "SUM OF SLICE SCANS...";
   else if (save->option == SINGLE_SAMPLE_T_TEST)
    str1 = "T-TEST OF SLICE SCANS...";
   else if (save->option == MOTION_CORRECTION) 
    str1 = "MOTION CORRECTION OF SLICE SCANS...";
   else str1 = "CC OF SLICE SCANS...";

 str = win_rec_win_id_title(op->win->owner,str1);
 save->frame = xv_create(op->frame,FRAME,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              WIN_CLIENT_DATA,op,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_CLOSED,FALSE,
              FRAME_DONE_PROC,process_slice_scans_done_proc,
              0);
 c_free(str);
 if (save->frame == 0) 
    {save->err = NOT_ENOUGH_MEMORY;
     free_scans_save_params_rec(&(op->save),op->frame);
     return NOT_ENOUGH_MEMORY;}
 (void) notify_set_itimer_func((Notify_client) save->frame,
             (Notify_func) slice_scans_proc,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
 panel = xv_create(save->frame,PANEL,0);
 if (panel == 0)
    {save->err = NOT_ENOUGH_MEMORY;
     process_slice_scans_done_proc(save->frame);
     return NOT_ENOUGH_MEMORY;}
 row = 5;
 offset = xv_rows(panel,1) - xv_rows(panel,0) - 5;
 save->snum_item = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "SLICE#",
	PANEL_VALUE,save->csnum+1,PANEL_MIN_VALUE,0,
        PANEL_MAX_VALUE,save->lsnum+1,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
	0);
 row += offset;
 if ((save->option == CC_SCANS) ||
     (save->option == SINGLE_SAMPLE_T_TEST) ||
     (save->option == MOTION_CORRECTION))
    {
     save->echo_item = 0;
     sprintf(str2,"ECHO# = %ld/TOTAL ECHOES = %d",save->cecho+1,
            img->file->hdr.data_info.num_echoes);
     xv_create(panel,PANEL_MESSAGE,
 	PANEL_LABEL_STRING, str2,
        XV_X,5,XV_Y,row,
	0);
     row += offset;
     save->scan_item = 0;
     sprintf(str2,"TOTAL SCANS = %ld",save->lscan+1);
     xv_create(panel,PANEL_MESSAGE,
 	PANEL_LABEL_STRING, str2,
        XV_X,5,XV_Y,row,
	0);
     row += offset;}
    else
    {
     save->echo_item = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "ECHO#",
	PANEL_VALUE,save->cecho+1,PANEL_MIN_VALUE,0,
        PANEL_MAX_VALUE,save->lecho + 1,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
	0);
     row += offset;
     save->scan_item = xv_create(panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "SCAN#",
	PANEL_VALUE,save->cscan+1,PANEL_MIN_VALUE,0,
                    PANEL_MAX_VALUE,save->lscan+1,
        XV_X,5,XV_Y,row,
        PANEL_SLIDER_WIDTH,50,
	0);
     save->show_item = xv_create(panel,PANEL_CHECK_BOX,
                   XV_X,20,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"SHOW SCANS PROCESSED",NULL,
                   PANEL_VALUE,save->show,
                   PANEL_NOTIFY_PROC,slice_scans_show_proc,
                   PANEL_CLIENT_DATA,op,
                   0);
     row += offset;}

 xv_create(panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "CANCEL",
        PANEL_NOTIFY_PROC,process_slice_scans_cancel_proc,
        PANEL_CLIENT_DATA,op,
        XV_X,5,XV_Y,row,
	0);

 window_fit(panel);
 rr = (Rect *) xv_get(panel,XV_RECT);
 xv_set(panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(save->frame);
 make_2_wins_adjacent(save->frame,op->frame,0);
 win_set_mouse_at_center(save->frame);
 xv_set(save->frame,XV_SHOW,TRUE,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
scans_fn - ???
-----------------------------------------------------------------------*/

int
scans_fn(op,option)
 struct slice_scans_rec *op;
 int option;
{
 int err;
 struct img_buf_rec *img;
 char *fn,*dir;
 unsigned long size;

 if (option == MOTION_CORRECTION)
    {if (xv_get(op->save_to_same_file,PANEL_VALUE))
        return NO_ERROR;
    }
 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL)
    return op->save.err = CANCEL;
 dir = (char *) xv_get(op->dir,PANEL_VALUE);
 fn = (char *) xv_get(op->fn,PANEL_VALUE);
 if (((err = open_output_file(dir,fn,img->file->hdr_fn_suffix,
        &(op->save.hdr_fn),&(op->save.fid),op->frame,0)) != NO_ERROR) ||
     ((err = open_output_file(dir,fn,img->file->img_fn_suffix,
        &(op->save.imgfn),&(op->save.imgfid),op->frame,0)) != NO_ERROR))
    free_scans_save_params_rec(&(op->save),op->frame);
 if (option == MOTION_CORRECTION)
    {size = ImageFileSize(&(img->file->hdr));
     if ((err = file_set_size(op->save.imgfid,size)) != NO_ERROR)
        {op->save.err = NOT_ENOUGH_HARD_DISK;
         free_scans_save_params_rec(&(op->save),op->frame);}
    }
 return err;
}


/*-----------------------------------------------------------------------
setup_slice_scans_buf - ???
-----------------------------------------------------------------------*/

int
setup_slice_scans_buf(op)
 struct slice_scans_rec *op;
{
 struct scans_save_params_rec *save;
 struct img_buf_rec *img;
 unsigned long lcv,num,type4,depth;
 
 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL) 
    {op->save.err = CANCEL;
     free_scans_save_params_rec(save,op->frame);
     return CANCEL;}
 save = &(op->save);
 num = NumberOfSliceCuts(&(img->file->hdr.data_info)) * 
        img->file->hdr.data_info.num_echoes;
 if ((op->save.err = get_ptr(&(save->slice_cuts),&(save->num_slice_cuts),
      num,sizeof(*(save->slice_cuts)))) != NO_ERROR)
    {free_scans_save_params_rec(save,op->frame);
     return op->save.err;}
 for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
    init_buf_2d_rec(&(save->slice_cuts[lcv]));
 type4 = InputDataTypeToBufType(&(img->file->hdr.data_info));
 if (type4 == BUF_VALUE_DOUBLE)
    depth = 8 * sizeof(double);
   else 
    {type4 = BUF_VALUE_FLOAT;
     depth = 8 * sizeof(float);}
 for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
    {if ((op->save.err = SetupBuf2dRec(&(save->slice_cuts[lcv]),
         img->file->hdr.data_info.dimx,img->file->hdr.data_info.dimy,
         depth,type4)) != NO_ERROR)
        break;
    }
 if (op->save.err != NO_ERROR) free_scans_save_params_rec(save,op->frame);
   else if ((save->option == MEAN_SCANS) || (save->option == SUM_SCANS))
    for (lcv = 0; lcv < save->num_slice_cuts; lcv++)
       Set2dByValue(&(save->slice_cuts[lcv]),(double) .0);
 return op->save.err;
}


/*-----------------------------------------------------------------------
process_scans_proc - ???
-----------------------------------------------------------------------*/

int
process_scans_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct slice_scans_rec *op;
 struct scans_save_params_rec *save;
 struct img_buf_rec *img;
 int err;
 unsigned long num_phases,right_shift;

 op = (struct slice_scans_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(op->win->owner)) == NULL) return CANCEL;
 save = &(op->save);
 save->option = (int) xv_get(item,XV_KEY_DATA,1);
 if ((err = scans_fn(op,save->option)) != NO_ERROR) return err;
 if (save->option != MOTION_CORRECTION)
    if ((err = setup_slice_scans_buf(op)) != NO_ERROR)
       return err;
 PRT(printf("option = %d...\n",save->option))
 save->lscan = NumberOfSliceScans(&(img->file->hdr.data_info)) - 1;
 if ((save->option == CC_SCANS) || (save->option == SINGLE_SAMPLE_T_TEST) || 
     (save->option == MOTION_CORRECTION))
    {PRT(printf("setup_cc_buf...\n"))
     if ((err = setup_cc_buf(&(img->file->hdr),&(save->scans),
             &(save->num_scans))) != NO_ERROR)
        {save->err = err;
         free_scans_save_params_rec(save,op->frame);
         return err;}
     save->fecho = save->lecho = img->cur_slice->echo_num;
     if (save->option == CC_SCANS)
        {save->is_normalized = (int) xv_get(op->normalized,PANEL_VALUE);
         if (op->result_2_echo == 0)
            save->is_result_2_echo = 0;
           else save->is_result_2_echo = (int) xv_get(op->result_2_echo,PANEL_VALUE);
         save->is_ref_wave_form = (int) xv_get(op->use_r,PANEL_VALUE);
         save->is_motion_correction = (int) xv_get(op->motion_correction,
                 PANEL_VALUE);
         PRT(printf("is_motion_correction = %d is_ref = %d is_normalized = %d\n",
              save->is_motion_correction,save->is_ref_wave_form,save->is_normalized))
         if (save->is_ref_wave_form)
            {num_phases = (int) xv_get(op->num_phases,PANEL_VALUE);
             right_shift = (int) xv_get(op->right_shift,PANEL_VALUE);
             PRT(printf("num_phases = %d right_shift = %d\n",num_phases,right_shift))
             if ((err = setup_ref_waveform(&(save->phases),&(save->phases_sd),
                 num_phases,right_shift,save->lscan + 1)) != NO_ERROR)
                {save->err = err;
                 free_scans_save_params_rec(save,op->frame);
                 return err;}
            }
        }
       else if (save->option == SINGLE_SAMPLE_T_TEST)
        {save->num_pairs = (int) xv_get(op->num_pairs,PANEL_VALUE);
         if (op->result_2_echo == 0)
            save->is_result_2_echo = 0;
           else save->is_result_2_echo = (int) xv_get(op->result_2_echo,PANEL_VALUE);
         save->is_motion_correction = (int) xv_get(op->motion_correction,
                 PANEL_VALUE);
         save->seq = (int) xv_get(op->seq,PANEL_VALUE);
         save->pair_pts = (int) xv_get(op->pair_pts,PANEL_VALUE);
        }
       else
        save->save_to_same_file = (int) xv_get(op->save_to_same_file,
                 PANEL_VALUE);
    }
   else
    {save->lecho = img->file->hdr.data_info.num_echoes - 1;
     save->fecho = 0;}

 save->cur_scan = img->cur_slice;
 save->show = (int) xv_get(op->show,PANEL_VALUE);
 save->lsnum = NumberOfSliceCuts(&(img->file->hdr.data_info)) - 1;
 save->csnum = 0;
 save->cecho = 0;
 save->cscan = 0;
 if ((err = setup_scans_save_params_rec(op)) != NO_ERROR)
    return err;
 xv_set(op->frame,FRAME_BUSY,TRUE,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
slice_scans_frame_done_proc - ???
-----------------------------------------------------------------------*/

void
slice_scans_frame_done_proc(frame)
 Frame frame;
{
 struct slice_scans_rec *op;

 op = (struct slice_scans_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_slice_scans_rec(op);
}


/*-----------------------------------------------------------------------
setup_slice_scans_rec - ???
-----------------------------------------------------------------------*/

int
setup_slice_scans_rec(op,win)
 struct slice_scans_rec *op;
 struct image_display_window *win;
{
 char *str,*str1;
 int max,row,offset;
 Rect *rr;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) 
    {free_slice_scans_rec(op);
     return CANCEL;}
 op->win = win;
 op->dwin = win->dwin;
 op->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 PRT(printf("setup_slice_scans_rec...1\n"))
 if (op->frame == 0)
    {free_slice_scans_rec(op);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,PROCESS_SLICE_SCANS_STR);
 xv_set(op->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,slice_scans_frame_done_proc,
              WIN_CLIENT_DATA,op,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 op->panel = xv_create(op->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (op->panel == 0)
    {free_slice_scans_rec(op);
     return CANCEL;}
 row = 2;
 offset = xv_rows(op->panel,1) - xv_rows(op->panel,0) - 10;
 if (img->file->output.dirfn == NULL) str = "";
   else str = img->file->output.dirfn;
 op->dir = xv_create(op->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"DIR :",
              PANEL_VALUE,str,
              PANEL_VALUE_DISPLAY_LENGTH,30,
              PANEL_VALUE_STORED_LENGTH,100,
              XV_X,5,XV_Y,row,
              0);
 PRT(printf("setup_slice_scans_rec...2\n"))
 if (img->file->output.fn == NULL) str = "";
   else str = img->file->output.fn;
 concat_strs(&str1,2,str,"-act");
 row += offset;
 op->fn = xv_create(op->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"fn :",
              PANEL_VALUE,str1,
              PANEL_VALUE_DISPLAY_LENGTH,30,
              PANEL_VALUE_STORED_LENGTH,100,
              XV_X,5,XV_Y,row,
              0);
 c_free(str1);
 row += offset;
 xv_create(op->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"NEW SLICE = MOTION CORRECTION",
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,op,
                   PANEL_NOTIFY_PROC,process_scans_proc,
                   XV_KEY_DATA,1,MOTION_CORRECTION,
                   0);
 row += offset - 5;
 op->save_to_same_file = xv_create(op->panel,PANEL_CHECK_BOX,
                   XV_X,20,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"SAVE TO THE SAME FILE",NULL,
                   PANEL_VALUE,0,
                   0);

 row += offset-4;
 xv_create(op->panel,PANEL_MESSAGE,
 	           PANEL_LABEL_STRING,"----------------------",
                   XV_X,15,XV_Y,row,
                   0);
 row += offset - 4;
 xv_create(op->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"NEW SLICE = MEAN OF SLICE SCANS",
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,op,
                   PANEL_NOTIFY_PROC,process_scans_proc,
                   XV_KEY_DATA,1,MEAN_SCANS,
                   0);
 row += offset;
 xv_create(op->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"NEW SLICE = SUM OF SLICE SCANS",
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,op,
                   PANEL_NOTIFY_PROC,process_scans_proc,
                   XV_KEY_DATA,1,SUM_SCANS,
                   0);
 row += offset - 3;
 PRT(printf("setup_slice_scans_rec...3\n"))
 op->show = xv_create(op->panel,PANEL_CHECK_BOX,
                   XV_X,20,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"SHOW SCANS PROCESSED",NULL,
                   PANEL_VALUE,0,
                   0);

 PRT(printf("setup_slice_scans_rec...4\n"))
 row += offset - 2;
 xv_create(op->panel,PANEL_MESSAGE,
 	           PANEL_LABEL_STRING,"----------------------",
                   XV_X,15,XV_Y,row,
                   0);
 row += offset - 10;
 op->motion_correction = xv_create(op->panel,PANEL_CHECK_BOX,
                   XV_X,15,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"MOTION CORRECTION",NULL,
                   PANEL_VALUE,0,
                   0);
/*
 row += offset - 4;
 op->result_2_echo = xv_create(op->panel,PANEL_CHECK_BOX,
                   XV_X,15,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"OUTPUT = 2 ECHO IMAGES",NULL,
                   PANEL_VALUE,0,
                   0);
*/
 op->result_2_echo = 0;
 row += offset;
 xv_create(op->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"NEW SLICE = SINGLE SAMPLE T TEST",
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,op,
                   PANEL_NOTIFY_PROC,process_scans_proc,
                   XV_KEY_DATA,1,SINGLE_SAMPLE_T_TEST,
                   0);
 row += offset - 3;
 max = NumberOfSliceScans(&(img->file->hdr.data_info));
 op->num_pairs = xv_create(op->panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "# OF PAIRS",
	PANEL_VALUE,4,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,max / 2,
	PANEL_SLIDER_WIDTH,50,
        XV_X,20,XV_Y,row,
	0);
 row += offset - 3;
 PRT(printf("setup_slice_scans_rec...5\n"))
 op->pair_pts = xv_create(op->panel,PANEL_CHECK_BOX,
                   XV_X,15,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"PAIR POINTS WITHIN EACH PAIR",NULL,
                   PANEL_VALUE,1,
                   0);
 row += offset - 3;
 PRT(printf("setup_slice_scans_rec...5\n"))
 op->seq = xv_create(op->panel,PANEL_CHECK_BOX,
 	           PANEL_LABEL_STRING, "PAIR SEQUENCE",
                   XV_X,15,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"(ACTIVATION - NO ACT.) PAIR",NULL,
                   PANEL_VALUE,1,
                   0);

 row += offset;
 xv_create(op->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"NEW SLICE = BY CORRELATION COEFFICIENT",
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,op,
                   PANEL_NOTIFY_PROC,process_scans_proc,
                   XV_KEY_DATA,1,CC_SCANS,
                   0);
 row += offset - 2;
 PRT(printf("setup_slice_scans_rec...5\n"))
 op->use_r = xv_create(op->panel,PANEL_CHECK_BOX,
                   XV_X,15,XV_Y,row,
 	           PANEL_CHOICE_STRINGS,"USE REFERENCE (R) WAVEFORMS",NULL,
                   PANEL_VALUE,1,
                   0);
 row += offset - 2;
 op->num_phases = xv_create(op->panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "# OF (R) PHASES",
	PANEL_VALUE,8,
	PANEL_MIN_VALUE,1,
	PANEL_MAX_VALUE,30,
	PANEL_SLIDER_WIDTH,50,
        XV_X,20,XV_Y,row,
	0);
 row += offset - 2;

 PRT(printf("setup_slice_scans_rec...6\n"))
 op->right_shift = xv_create(op->panel,PANEL_SLIDER,
 	PANEL_LABEL_STRING, "RIGHT SHIFT (R) BY",
	PANEL_VALUE,0,
	PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,max,
	PANEL_SLIDER_WIDTH,50,
        XV_X,20,XV_Y,row,
	0);
 row += offset - 2;
 PRT(printf("setup_slice_scans_rec...7\n"))
 op->normalized = xv_create(op->panel,PANEL_CHOICE_STACK,
 	PANEL_CHOICE_STRINGS,"UNNORMALIZED OUTPUT SLICE",
             "NORMALIZED OUTPUT SLICE",NULL,
	PANEL_VALUE,1,
        XV_X,20,XV_Y,row,
	0);
 PRT(printf("setup_slice_scans_rec...8\n"))
 window_fit(op->panel);
 rr = (Rect *) xv_get(op->panel,XV_RECT);
 xv_set(op->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(op->frame);
 make_2_wins_adjacent(op->frame,win->dwin->frame,0);
 win_set_mouse_at_center(op->frame);
 xv_set(op->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}



/*-----------------------------------------------------------------------
find_slice_scans_rec - ???
-----------------------------------------------------------------------*/

struct slice_scans_rec *
find_slice_scans_rec(all_ops,win)
 struct all_slice_scans_recs *all_ops;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_ops->num_ops; lcv++)
    if (all_ops->ops[lcv]->win == win)
       return all_ops->ops[lcv];
 return NULL;
}


/*-----------------------------------------------------------------------
enter_process_slice_scans - ???

BEWARE:  The pre-19990223 version of this function could return either
NULL, a pointer to an all_slice_scans_recs structure, or an integer error 
code.  Since the last two of these cannot be reliably distinguished and
since no one ever seems to check for an error code, I replaced the error
code by NULL.  -PWH
-----------------------------------------------------------------------*/

struct all_slice_scans_recs *
enter_process_slice_scans(
    struct image_display_window *win,
    int status)
{
 static struct all_slice_scans_recs all_ops;
 struct slice_scans_rec *op;
 static char first_time = 1;
 int err;

 TRACE(printf("slice_scans_rec...0\n"))
 err = NO_ERROR;
 if (status == GET_ALL_PTR)
    {if (first_time) return NULL;
       else return &all_ops;}
  else if (status == CLEAN_UP)
   {if (!first_time)
       if ((op = find_slice_scans_rec(&all_ops,win)) != NULL)
          free_slice_scans_rec(op);
    return NULL;}
 TRACE(printf("slice_scans_rec...1\n"))
 if (first_time)
    {init_all_slice_scans_recs(&all_ops);
     first_time = 0;}
   else
    {if ((op = find_slice_scans_rec(&all_ops,win)) != NULL)
        {
         xv_set(op->frame,
                XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(op->frame);
         wmgr_top(op->frame);
         return NULL;}
    }
 TRACE(printf("slice_scans_rec...2\n"))
 get_handle_memory(&(all_ops.ops),&(all_ops.num_ops),1,
     (size_t) sizeof(struct slice_scans_rec),&err);
 if (err != NO_ERROR) return NULL;
 op = all_ops.ops[all_ops.num_ops - 1];
 init_slice_scans_rec(op);
 TRACE(printf("slice_scans_rec...2\n"))
 if ((err = setup_slice_scans_rec(op,win)) == NO_ERROR)
    {TRACE(printf("setup_slice_scans_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the process slice scans window !!!",NULL,0);
 return NULL;

}


