/****************************************************************************
icon.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: icon.c,v 1.5 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/icon.h>


/* Functions defined in this file */
Server_image get_ria_icon_image(int select);
void get_ria_icon(Xv_Window frame);
void set_icon_label(Xv_Window frame, char *label);


/*--------------------------------------------------------------------------
get_ria_icon_image - ???
--------------------------------------------------------------------------*/

#define FREE_ICON_SERVER_IMAGE 0
#define GET_ICON_SERVER_IMAGE 1

Server_image 
get_ria_icon_image(select)
 int select;
{
 static Server_image icon = 0;
 static unsigned short icon_bits[] = {
/* Format_version=1, Width=64, Height=64, Depth=1, Valid_bits_per_item=16
 */
	0xFFFF,	0xFFFF,	0xFFFF,	0xFFFF,
	0xFFFF,	0xFFFF,	0xFFFF,	0xFFFF,
	0xFFFF,	0xF800,	0x0000,	0x7FFF,
	0xFFFF,	0xE7FF,	0xFFFC,	0x0FFF,
	0xFFFF,	0x9E00,	0x03FF,	0xC7FF,
	0xFFFF,	0x3807,	0xC01F,	0xF3FF,
	0xFFFE,	0xF3FF,	0xFF80,	0xF8FF,
	0xFFFD,	0xE7FF,	0xFFF0,	0x1CFF,
	0xFFF3,	0x8FC0,	0xB7FF,	0x0E7F,
	0xFFF7,	0x7E60,	0x21DF,	0x877F,
	0xFFCC,	0x7A20,	0x309F,	0xC33F,
	0xFF9C,	0xF638,	0x10D3,	0xE1BF,
	0xFF33,	0xC000,	0x0840,	0xF19F,
	0xFFE7,	0x0002,	0x0E21,	0x799F,
	0xFE5F,	0x0053,	0x0106,	0x78DF,
	0xFEDD,	0x80FF,	0x000D,	0x1EDF,
	0xFE98,	0x1880,	0x4C19,	0x1EDF,
	0xFE98,	0x0C8B,	0xF213,	0x0E9F,
	0xFE98,	0x060C,	0x0002,	0x069F,
	0xFED8,	0x0060,	0x0000,	0xB69F,
	0xFE59,	0xE0C0,	0x3E07,	0x86BF,
	0xFF5C,	0x00C0,	0x241C,	0x069F,
	0xFF0E,	0x0049,	0xE030,	0x06BF,
	0xFE73,	0x00F8,	0x0000,	0x0EBF,
	0xFEF9,	0x83F8,	0x6000,	0x8D3F,
	0xFEF9,	0xC331,	0xC000,	0x8E7F,
	0xFEF8,	0xE620,	0x03FF,	0x9E7F,
	0xFEFB,	0x7C00,	0x1FFF,	0xFCFF,
	0xFEFB,	0xF000,	0x7FC0,	0x7DFF,
	0xFE73,	0x3001,	0xF00F,	0xF9FF,
	0xFF01,	0xB003,	0xF800,	0x39FF,
	0xFF7C,	0xB003,	0xF800,	0x31FF,
	0xFF7E,	0x781F,	0xF880,	0x37FF,
	0xFFBF,	0x7CFF,	0x7F83,	0xF7FF,
	0xFF9F,	0x3FFE,	0x7800,	0xEFFF,
	0xFFCF,	0x7FFE,	0x7C01,	0xCFFF,
	0xFFE7,	0x3E00,	0x7FFF,	0x9FFF,
	0xFFF0,	0x1E18,	0x73FF,	0xBFFF,
	0xFFF8,	0x0381,	0xFFFF,	0x3FFF,
	0xFFFF,	0x0617,	0xBD1F,	0x3FFF,
	0xFFFF,	0xF007,	0xFDFA,	0x7FFF,
	0xFFFF,	0xF007,	0xF9B6,	0x7FFF,
	0xFFFF,	0xFE13,	0xBF35,	0xFFFF,
	0xFFFF,	0xFCC7,	0xA975,	0xFFFF,
	0xFFFF,	0xFE07,	0x19DD,	0xFFFF,
	0xFFFF,	0xFFFF,	0xFB9F,	0xFFFF,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xC000,	0x0000,	0x0000,	0x0003,
	0xFFFF,	0xFFFF,	0xFFFF,	0xFFFF,
	0xFFFF,	0xFFFF,	0xFFFF,	0xFFFF,
	0x0000,	0x0000,	0x0000,	0x0000,
	0x0000,	0x0000,	0x0000,	0x0000,
	0x0000,	0x0000,	0x0000,	0x0000,
	0x0000,	0x0000,	0x0000,	0x0000,
	0x0000,	0x0000,	0x0000,	0x0000,
	0x0000,	0x0000,	0x0000,	0x0000,
	0x0000,	0x0000,	0x0000,	0x0000,
       };

 if (select == FREE_ICON_SERVER_IMAGE)
    {if (icon != 0) xv_destroy_safe(icon);
     icon = 0;
    }
   else if (icon == 0)
    icon = (Server_image) xv_create(0,SERVER_IMAGE,
                XV_WIDTH,64,XV_HEIGHT,64,SERVER_IMAGE_BITS,icon_bits,0);
 return icon;

}


/*--------------------------------------------------------------------------
get_ria_icon - ???
--------------------------------------------------------------------------*/

void
get_ria_icon(frame)
 Xv_Window frame;
{
 Icon icon;

 icon = (Icon) xv_create(frame,ICON,
             ICON_IMAGE,get_ria_icon_image(1),0);
 xv_set(frame,FRAME_ICON,icon,NULL);
}


/*--------------------------------------------------------------------------
set_icon_label - ???
--------------------------------------------------------------------------*/

void
set_icon_label(frame,label)
 Xv_Window frame;
 char *label;
{
 Icon icon;

 icon = (Icon) xv_get(frame,FRAME_ICON);
 if (icon != 0) xv_set(icon,ICON_TRANSPARENT_LABEL,label,0);
}
