/****************************************************************************
image_view_filter.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: image_view_filter.c,v 1.11 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



#define CLEAN_UP_IMAGE_VIEW_FILTER 0
#define SETUP_GROW_ROI_MAP 1
#define GET_ALL_PT_PTR 2

struct image_view_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item view_roi,exc;
   };

struct all_image_view_recs
   {
    int num_views;
    struct image_view_rec **views;
   };



/* Functions defined in this file */
void init_image_view_rec(struct image_view_rec *view);
void free_image_view_rec(struct image_view_rec *view);
void init_all_image_view_recs(struct all_image_view_recs *all_views);
void image_view_frame_done_proc(Frame frame);
int win_trash_input_view_roi(struct image_display_window *win);
int win_view_filter_last_cursor(struct image_display_window *win);
void view_quadrant_proc(Panel_item item, int which_quadrant, Event event);
void def_view_filter_roi_proc(struct image_display_window *win);
void view_def_filter_roi_proc(Panel_item item, Event event);
void win_new_view_roi(struct image_display_window *win, int is_exc,
    int is_delete_view_roi);
void win_change_view_roi(struct image_display_window *win, int is_exc,
    int which_quadrant);
void view_apply_new_view_roi_proc(Panel_item item, Event event);
void view_delete_proc(Panel_item item, Event event);
void view_ready_proc(Panel_item item, Event event);
int setup_image_view_rec(struct image_view_rec *view,
    struct image_display_window *win);
struct image_view_rec *find_image_view_rec(
   struct all_image_view_recs *all_views, struct image_display_window *win);
struct all_image_view_recs *enter_image_view_filter(
   struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_image_view_rec - ???
-------------------------------------------------------------------------*/

void
init_image_view_rec(view)
 struct image_view_rec *view;
{
 view->status = 0;
 view->win = NULL;
 view->frame = 0;
}


/*-------------------------------------------------------------------------
free_image_view_rec - ???
-------------------------------------------------------------------------*/

void
free_image_view_rec(view)
 struct image_view_rec *view;
{
 struct all_image_view_recs *all_views;

 TRACE(printf("free_image_view_rec...view->win->dwin = %u\n",view->win->dwin))
 TRACE(printf("free_image_view_rec...1\n"))
 win_trash_input_view_roi(view->win);
 win_view_filter_last_cursor(view->win);

 if (view->frame != 0)
    {xv_destroy_safe(view->frame);
     view->frame = 0;
    }
 c_free(view);
 all_views = enter_image_view_filter(NULL,GET_ALL_PT_PTR);
 DropHandleAryPtr(&(all_views->views),&(all_views->num_views),view);
 TRACE(printf("free_image_view_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_image_view_recs - ???
-------------------------------------------------------------------------*/

void
init_all_image_view_recs(all_views)
 struct all_image_view_recs *all_views;
{
 all_views->num_views = 0;
 all_views->views = NULL;
}


/*-------------------------------------------------------------------------
image_view_frame_done_proc - ???
-------------------------------------------------------------------------*/

void
image_view_frame_done_proc(frame)
 Frame frame;
{
 struct image_view_rec *view;

 view = (struct image_view_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_image_view_rec(view);
}


/*-------------------------------------------------------------------------
win_trash_input_view_roi - ???
-------------------------------------------------------------------------*/

int
win_trash_input_view_roi(win)
 struct image_display_window *win;
{
 struct roi_rec *roi;

 PRT(printf("win_trash_input_view_roi...\n"))
 if ((roi = get_roi(&(win->control.sroi.sroi_win->slice_roi),
       IMAGE_VIEW_FILTER)) != NULL)
    {
     PRT(printf("win_trash_input_view_roi..deleted.\n"))
     delete_roi(&(win->control.sroi.sroi_win->slice_roi),roi);
     win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_view_filter_last_cursor - ???
-------------------------------------------------------------------------*/

int
win_view_filter_last_cursor(win)
 struct image_display_window *win;
{
 if (win->type2 & DISPLAY_WINDOW_3D)
    {_3d_select_cursor_proc(0, 0,win->dwin, 0, NULL,
             win->control.which_cursor);}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
view_quadrant_proc - ???
-------------------------------------------------------------------------*/

void
view_quadrant_proc(item,which_quadrant,event)
 Panel_item item;
 int which_quadrant;
 Event event;
{
 struct image_view_rec *view;
 int is_exc;

 view = (struct image_view_rec *) xv_get(item,PANEL_CLIENT_DATA);
 is_exc = (int) xv_get(view->exc,PANEL_VALUE);
 win_change_view_roi(view->win,is_exc,which_quadrant);

}

/*****************
view_quadrant_proc(item,which_quadrant,event)
 Panel_item item;
 int which_quadrant;
 Event event;
{
 struct image_view_rec *view;
 struct roi_rec *roi;
 long x1,y1,x2,y2;
 int yes,err;
 unsigned long dimx,dimy;

 view = (struct image_view_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((err = WinColorDataDims(view->win,&dimx,&dimy,NULL)) != NO_ERROR)
    return err;

 if ((roi = get_roi(&(view->win->control.sroi.sroi_win->slice_roi),
       IMAGE_VIEW_FILTER)) != NULL)
    {yes = 1;
     delete_roi(&(view->win->control.sroi.sroi_win->slice_roi),roi);}
   else yes = 0;
 if (((err = setup_more_rois(&(view->win->control.sroi.sroi_win->slice_roi),
         IMAGE_VIEW_FILTER,1)) == NO_ERROR) &&
     ((roi = get_cur_roi(&(view->win->control.sroi.sroi_win->slice_roi)))
           != NULL))
    {roi->status |= ROI_MARK_DELETE;
     if (which_quadrant == 4)
        {
         yes = 1;
         win_move_mouse_to(view->win,
            (view->win->dwin->screen.dimension.bound.left +
             view->win->dwin->screen.dimension.bound.right) / 2,
            (view->win->dwin->screen.dimension.bound.top +
             view->win->dwin->screen.dimension.bound.bottom) / 2);
         win_enable_pen_draw_mode(view->win);
         win_set_pen_type(view->win,1,DRAW_FREE_CLOSED);
         set_proc_upon_cursor_change(&(view->win->control),
                     win_trash_input_view_roi,view->win);
        }
       else 
        {
         view_quadrant_xys(dimx,dimy,&x1,&y1,&x2,&y2,which_quadrant);
         if ((err = EnterPtsIntoRoiRec(roi,(unsigned long) DRAW_RECT,
              &(view->win->control.sroi.sroi_win->slice_roi.status),NULL,1,2,
              (float) x1,(float) y1,(float) x2,(float) y2)) == NO_ERROR)
            {
             yes = 1;}
        }
    }
 TRACE(printf("view_quadrant_proc...1\n"))
 if (yes) 
    win_execute_proc_to_related_wins(view->win,win_redisplay_all_curves,0,0);
 TRACE(printf("view_quadrant_proc...2\n"))
}
*********************/


/*-------------------------------------------------------------------------
def_view_filter_roi_proc - ???
-------------------------------------------------------------------------*/

void
def_view_filter_roi_proc(win)
 struct image_display_window *win;
{
 struct roi_rec *roi;
 int yes,err;
 unsigned short status;

 if ((roi = get_roi(&(win->control.sroi.sroi_win->slice_roi),
       IMAGE_VIEW_FILTER)) != NULL)
    {yes = 1;
     delete_roi(&(win->control.sroi.sroi_win->slice_roi),roi);}
   else yes = 0;
 if (is_roi_non_empty(&(win->image_view_roi)) &&
     ((err = setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),
         IMAGE_VIEW_FILTER,1)) == NO_ERROR) &&
     ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)))
           != NULL))
    if (JoinRoiRecs(roi, &(win->image_view_roi),1,&status,1.0,1.0,
        win->control.sroi.tolocal,win->control.sroi.localto,NULL) == NO_ERROR)
       yes = 1;
 if (yes) win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
}


/*-------------------------------------------------------------------------
view_def_filter_roi_proc - ???
-------------------------------------------------------------------------*/

void
view_def_filter_roi_proc(item,event)
 Panel_item item;
 Event event;
{
 struct image_view_rec *view;

 view = (struct image_view_rec *) xv_get(item,PANEL_CLIENT_DATA);
 def_view_filter_roi_proc(view->win);
}


/*-------------------------------------------------------------------------
win_new_view_roi - ???
-------------------------------------------------------------------------*/

void
win_new_view_roi(win,is_exc,is_delete_view_roi)
 struct image_display_window *win;
 int is_exc,is_delete_view_roi;
{
 struct roi_rec *roi;
 int is_filter,yes,err;
 unsigned short status;
 unsigned long dimx,dimy;

 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR)
     return /*err*/;
 if (is_roi_non_empty(&(win->image_view_roi)))
    {is_filter = 1;
     free_roi_rec(&(win->image_view_roi));
     win->status4 &= ~VIEW_ROI_FILTER_ON;
    }
   else is_filter = 0;

 if ((roi = get_roi(&(win->control.sroi.sroi_win->slice_roi),
       IMAGE_VIEW_FILTER)) != NULL)
    {if (is_roi_non_empty(roi))
        {if (JoinRoiRecs(&(win->image_view_roi),roi,1,&status,1.0,1.0,
              NULL,NULL,win->control.sroi.localto) == NO_ERROR)
            {is_filter = 1;
             if (is_exc) win->image_view_roi.status |= ROI_EXCLUDE;}
        }
     if (is_delete_view_roi)
        {yes = 1;
         delete_roi(&(win->control.sroi.sroi_win->slice_roi),roi);}
       else yes = 0;
    }
   else yes = 0;
 if (is_filter)
    {if (is_roi_non_empty(&(win->image_view_roi)))
        {if ((err = SetupBuf2dRec(&(win->image_view_2d),dimx,dimy,(long) 1,0))
              == NO_ERROR)
            {err = FillROi(&(win->image_view_roi),NULL,
                      &(win->image_view_2d),1,1,0);
             if (err == NO_ERROR) win->status4 |= VIEW_ROI_FILTER_ON;
            }
        }
     WinNewImgMultiCanvas(win);
    }
   else if (yes) 
    win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
}


/*-------------------------------------------------------------------------
win_change_view_roi - ???
-------------------------------------------------------------------------*/

void
win_change_view_roi(win,is_exc,which_quadrant)
 struct image_display_window *win;
 int is_exc,which_quadrant;
{
 struct curve_rec *curve;
 struct curve_2d_rec *pen;
 struct roi_rec *roi;
 int is_filter,yes,err;
 long x1,y1,x2,y2;
 unsigned short status;
 unsigned long dimx,dimy;

 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR)
     return /*err*/;
 PRT(printf("win_change_view_roi is_exc = %d which_quadrant = %d\n",
        is_exc,which_quadrant))
 if (which_quadrant == 8)
    {win_new_view_roi(win,is_exc,0);
    return;
    }
 if (which_quadrant == 4)
    {yes = 0;
     PRT(printf("which_quadrant == 4\n"))
     if ((roi = get_roi(&(win->control.sroi.sroi_win->slice_roi),
           IMAGE_VIEW_FILTER)) != NULL)
        {yes = 1;
         delete_roi(&(win->control.sroi.sroi_win->slice_roi),roi);}

     if (((err = setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),
         IMAGE_VIEW_FILTER,1)) == NO_ERROR) &&
         ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)))
               != NULL))
        {roi->status |= ROI_MARK_DELETE;
         yes = 1;
         win_move_mouse_to(win,
            (win->dwin->screen.dimension.bound.left +
             win->dwin->screen.dimension.bound.right) / 2,
            (win->dwin->screen.dimension.bound.top +
             win->dwin->screen.dimension.bound.bottom) / 2);
         win_enable_pen_draw_mode(win);
         win_set_pen_type(win,1,DRAW_FREE_CLOSED);
         set_proc_upon_cursor_change(&(win->control),
                     win_trash_input_view_roi,win);
        }
     if (yes)
	 win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
     return /*NO_ERROR*/;
    }

 if (is_roi_non_empty(&(win->image_view_roi)))
    {yes = 1;
     free_roi_rec(&(win->image_view_roi));
     win->status4 &= ~VIEW_ROI_FILTER_ON;
    }
   else yes = 0;
 is_filter = 0;
 if (which_quadrant == 7)
    {if (yes) WinNewImgMultiCanvas(win);
    return /*NO_ERROR*/;}
   else if (which_quadrant == 5)
    {PRT(printf("which_quadrant == 5....1\n"))
     if (((curve = get_cur_curve(&(win->control.sroi.sroi_win->slice_roi)))
          != NULL) && is_curve_non_empty(curve) &&
         ((pen = get_cur_pen(&(win->control.sroi.sroi_win->slice_roi)))
          != NULL))
        if ((err = JoinCurveToRoiRec(&(win->image_view_roi),curve,
               pen->pen_type,1,&status,1.0,1.0,
               NULL,NULL,win->control.sroi.localto)) == NO_ERROR)
           {if (is_exc) win->image_view_roi.status |= ROI_EXCLUDE;
            is_filter = 1;
            PRT(printf("which_quadrant == 5....yes\n"))
           }
    }
   else if (which_quadrant == 6)
    {PRT(printf("which_quadrant == 6\n"))
     if (((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)))
          != NULL) && is_roi_non_empty(roi))
     if ((err = JoinRoiRecs(&(win->image_view_roi),roi,
             1,&status,1.0,1.0,NULL,NULL,win->control.sroi.localto)) == NO_ERROR)
        {if (is_exc) win->image_view_roi.status |= ROI_EXCLUDE;
         is_filter = 1;
         PRT(printf("which_quadrant == 6....1\n"))
        }
     PRT(printf("which_quadrant == 6....roi = %u\n",roi))
    }
   else
    {view_quadrant_xys(dimx,dimy,&x1,&y1,&x2,&y2,which_quadrant);
     if ((err = EnterPtsIntoRoiRec(&(win->image_view_roi),
             (unsigned long) DRAW_RECT,&status,NULL,1,2, (float) x1,(float) y1,
              (float) x2,(float) y2)) == NO_ERROR)
        {if (is_exc) win->image_view_roi.status |= ROI_EXCLUDE;
         is_filter = 1;
        }
    }
 PRT(printf("is_filter == %d....\n",is_filter))
 if (is_filter)
    if ((err = SetupBuf2dRec(&(win->image_view_2d),dimx,dimy,(long) 1,0))
                == NO_ERROR)
       {err = FillROi(&(win->image_view_roi),NULL,
                       &(win->image_view_2d),1,1,0);
        if (err == NO_ERROR)
           {yes = 1;
            PRT(printf("VIEW_ROI_FILTER_ON....\n"))
            win->status4 |= VIEW_ROI_FILTER_ON;}             
       }
 PRT(printf("win_change_view_roi 2..err = %d\n",err))

 if (yes) WinNewImgMultiCanvas(win);
 return /*NO_ERROR*/;
}


/*-------------------------------------------------------------------------
view_apply_new_view_roi_proc - ???
-------------------------------------------------------------------------*/

void
view_apply_new_view_roi_proc(item,event)
 Panel_item item;
 Event event;
{
 struct image_view_rec *view;
 int exc;

 view = (struct image_view_rec *) xv_get(item,PANEL_CLIENT_DATA);
 exc = (int) xv_get(view->exc,PANEL_VALUE);
 win_new_view_roi(view->win,exc,0);
}


/*-------------------------------------------------------------------------
view_delete_proc - ???
-------------------------------------------------------------------------*/

void
view_delete_proc(item,event)
 Panel_item item;
 Event event;
{
 struct image_view_rec *view;

 view = (struct image_view_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (is_roi_non_empty(&(view->win->image_view_roi)))
    {free_roi_rec(&(view->win->image_view_roi));
     view->win->status4 &= ~VIEW_ROI_FILTER_ON;
     WinNewImgMultiCanvas(view->win);}
}


/*-------------------------------------------------------------------------
view_ready_proc - ???
-------------------------------------------------------------------------*/

void
view_ready_proc(item,event)
 Panel_item item;
 Event event;
{
 struct image_view_rec *view;
 int exc;

 view = (struct image_view_rec *) xv_get(item,PANEL_CLIENT_DATA);
 exc = (int) xv_get(view->exc,PANEL_VALUE);
 win_new_view_roi(view->win,exc,1);
 free_image_view_rec(view);
}


/*-------------------------------------------------------------------------
setup_image_view_rec - ???
-------------------------------------------------------------------------*/

int
setup_image_view_rec(view,win)
 struct image_view_rec *view;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;
 Panel_item item;

 view->win = win;
 view->dwin = win->dwin;
 view->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_image_view_rec...1\n"))
 if (view->frame == 0)
    {free_image_view_rec(view);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,IMAGE_VIEW_FILTER);
 xv_set(view->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,image_view_frame_done_proc,
              WIN_CLIENT_DATA,view,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 view->panel = xv_create(view->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (view->panel == 0)
    {free_image_view_rec(view);
     return CANCEL;}
 row = 2;
 offset = xv_rows(view->panel,1) - xv_rows(view->panel,0) - 10;
 item = xv_create(view->panel,PANEL_MESSAGE,
        PANEL_LABEL_STRING,"VIEW ROI FILTER =",
        XV_X,5,XV_Y,row+3,
        0);
 rr = (Rect *) xv_get(item,XV_RECT);
 view->exc = xv_create(view->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"EXCLUDE",NULL,
        PANEL_VALUE,0,
        XV_X,rr->r_left + rr->r_width+2,XV_Y,row,
        0);
 rr = (Rect *) xv_get(view->exc,XV_RECT);
 view->view_roi = xv_create(view->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                      "QUADRANT 1 -<Ctrl><>[<Sh>] F1",
                      "QUADRANT 2 -<Ctrl><>[<Sh>] F2",
                      "QUADRANT 3 -<Ctrl><>[<Sh>] F3",
                      "QUADRANT 4 -<Ctrl><>[<Sh>] F4",
                      "DEFINE ROI -<Ctrl><>[<Sh>] F5",
                      "CUR REGION -<Ctrl><>[<Sh>] F6",
                      "CUR ROI -<Ctrl><>[<Sh>] F7",
                      NULL,
                  PANEL_NOTIFY_PROC,view_quadrant_proc,
                  PANEL_CLIENT_DATA,view,
                  PANEL_VALUE,0,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  0);
 row += offset;
 item = xv_create(view->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"SHOW DEFINED VIEW ROI",
        PANEL_NOTIFY_PROC,view_def_filter_roi_proc,
        PANEL_CLIENT_DATA,view,
        XV_X,5,XV_Y,row,
        0);
 rr = (Rect *) xv_get(item,XV_RECT);
 def_view_filter_roi_proc(win);
 xv_create(view->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"APPLY NEW VIEW ROI -<Ctrl><>[<Sh>] F9",
        PANEL_NOTIFY_PROC,view_apply_new_view_roi_proc,
        PANEL_CLIENT_DATA,view,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row,
        0);
 row += offset;
 xv_create(view->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"DELETE VIEW ROI -<Ctrl><>[<Sh>] F8",
        PANEL_NOTIFY_PROC,view_delete_proc,
        PANEL_CLIENT_DATA,view,
        XV_X,5,XV_Y,row,
        0);
 row += offset;
 xv_create(view->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"APPLY & HIDE NEW VIEW ROI & QUIT",
        PANEL_NOTIFY_PROC,view_ready_proc,
        PANEL_CLIENT_DATA,view,
        XV_X,5,XV_Y,row,
        0);

 window_fit(view->panel);
 rr = (Rect *) xv_get(view->panel,XV_RECT);
 xv_set(view->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(view->frame);
 make_2_wins_adjacent(view->frame,win->dwin->frame,0);
 win_set_mouse_at_center(view->frame);
 xv_set(view->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_image_view_rec - ???
-------------------------------------------------------------------------*/

struct image_view_rec *
find_image_view_rec(all_views,win)
 struct all_image_view_recs *all_views;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_views->num_views; lcv++)
    if (all_views->views[lcv]->win == win)
       return all_views->views[lcv];
 return NULL;
}

/*---------------------------------------------------------------------
enter_image_view_filter - ???

BEWARE: The pre-19990223 version of this function could return either
NULL, a pointer to an all_edge_detector_recs structure, or an integer
error code.  Since the last two of these cannot be reliably
distinguished and since no one ever seems to check for an error code,
I replaced the error code by NULL.  Of course, it is now impossible to
distinguish between NO_ERROR and NULL (=> error), but I don't think
anyone ever looks at the error code returned.  -PWH
-----------------------------------------------------------------------*/

struct all_image_view_recs *
enter_image_view_filter(
    struct image_display_window *win,
    int status)
{
 static struct all_image_view_recs all_views;
 struct image_view_rec *view;
 static char first_time = 1;
 int err;

 TRACE(printf("enter_image_view_filter...0\n"))
 err = NO_ERROR;
 if (status == GET_ALL_PT_PTR)
    {if (first_time) return NULL;
       else return &all_views;}
  else if (status == CLEAN_UP_IMAGE_VIEW_FILTER)
   {if (!first_time)
       if ((view = find_image_view_rec(&all_views,win)) != NULL)
          free_image_view_rec(view);
    return NO_ERROR;}
 TRACE(printf("enter_image_view_filter...1\n"))
 if (first_time)
    {init_all_image_view_recs(&all_views);
     first_time = 0;}
   else
    {if ((view = find_image_view_rec(&all_views,win)) != NULL)
        {
         xv_set(view->frame,
                XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(view->frame);
         wmgr_top(view->frame);
         return NO_ERROR;}
    }
 TRACE(printf("enter_image_view_filter...2\n"))
 get_handle_memory(&(all_views.views),&(all_views.num_views),1,
     (size_t) sizeof(struct image_view_rec),&err);
 if (err != NO_ERROR) return NULL;
 view = all_views.views[all_views.num_views - 1];
 init_image_view_rec(view);
 TRACE(printf("enter_image_view_filter...2\n"))
 if ((err = setup_image_view_rec(view,win)) == NO_ERROR)
    {TRACE(printf("setup_image_view_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the PT DETECTION window !!!",NULL,0);
 return NULL;
}

