/****************************************************************************
img_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: img_opr.c,v 1.8 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "typedef.h"
#include "geometry.h"
#include "common.h"
#include "output.h"
#include "input.h"
#include "ia_hdr.h"
#include "error_constants.h"

#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include <sys/timeb.h>

#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
*/
#define ERROR(x1,x2)
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)
#define PRT8(x)
#define PRT9(x)
#define PRT10(x)
#define PRT11(x)
#define PRT12(x)



/* Functions defined in this file */
int set_buf_data_type(struct buf_2d_rec *_2d, struct data_info_rec *info);
unsigned long cnt_img_buf_rec_partners(struct img_buf_rec *img);
struct img_buf_rec *pick_first_img_buf_rec_partner(struct img_buf_rec *img);
struct hdr_scan_entry_rec *pick_first_partner_slice(
   struct hdr_scan_entry_rec *slice);
void NextSliceOffset(char *action_str, int slice_offset, long cur_slice_num,
    unsigned long total_slices, long *slice_num);
int get_slice_info(char *action_str, struct img_buf_rec *img,
    int slice_offset, struct hdr_scan_entry_rec **slice_info,
    int is_locate_scan);
void get_slice(char *action_str, struct img_buf_rec *img, int slice_offset,
    int is_locate_scan);
int get_next_slice(char *action_str, struct img_buf_rec *img,
    int slice_offset, int is_locate_scan);
int get_all_next_slice_echoes(struct img_buf_rec *img,
    struct hdr_scan_entry_rec *cur_slice);
int LocateSlice(struct img_buf_rec *img, long slice_num, long scan_num,
    long echo_num);
int LocateAllSliceEchoes(struct img_buf_rec *img, long slice_num,
    long scan_num, long echo_num);
int ImgAdvanceRelative(struct img_buf_rec *img, struct img_buf_rec *ref_img);
void set_img_min_max_status(struct img_buf_rec *img);
void clear_img_min_max_status(struct img_buf_rec *img);
void GetImgSliceMinMax(struct img_buf_rec *img, struct buf_2d_rec *_2d);
void set_img_gradient_status(struct img_buf_rec *img);
void clear_img_gradient_status(struct img_buf_rec *img);
void set_img_read_status(struct img_buf_rec *img);
unsigned long total_slice_cuts(struct img_buf_rec *img);
unsigned long total_slice_scans(struct img_buf_rec *img);
char *get_img_fn(struct img_buf_rec *img);
char *get_img_label(struct img_buf_rec *img);
char *get_img_type_label(struct img_buf_rec *img);
unsigned long get_img_slice_num(struct img_buf_rec *img);
int get_img_scan_num(struct img_buf_rec *img);
long get_num_img_echoes(struct img_buf_rec *img);
int scale_all_partner_imgs(struct img_buf_rec *img, unsigned long scale_min,
    unsigned long scale_max);
int get_all_partner_img_buf_2d_recs(struct img_buf_rec *img,
    struct buf_2d_rec **_2ds);
int save_file_pixels(struct img_buf_rec *img, unsigned char *pixel_types);
void remmap_file_bufs(struct input_file_rec *file);
int ResizePosNegImg2d(struct buf_2d_rec *result, struct img_buf_rec *img,
    struct buf_2d_rec *img_2d, struct buf_2d_rec *partner_img_2d,
    struct buf_2d_rec *bitmask, struct int_bound_rec *maskbound);
int ExtractImgPosOrNegEcho(struct img_buf_rec *img, struct buf_2d_rec *_2d,
    struct buf_2d_rec *result);
int RdImgPosNegEchoes(struct img_buf_rec *img, int is_normalized,
    struct buf_2d_rec *_2d, int rd_select);
int SaveImgBufToFileBuf(struct img_buf_rec *img);
int wr_slice(struct img_buf_rec *img, struct buf_2d_rec *img_2d,
    char **err_reason);
int RdFilePixel(struct input_file_rec *file,
    struct hdr_scan_entry_rec *cur_slice, unsigned long row,
    unsigned long col, double *val);
int rd_cur_slice_data(FILE *fid, struct hdr_scan_entry_rec *cur_slice,
    struct buf_2d_rec *buf);
int RdFileSlice(FILE *fid, struct input_file_rec *file,
    struct hdr_scan_entry_rec *cur_slice, struct buf_2d_rec *buf,
    int rd_select);
int RdSliceData(struct img_buf_rec *img,
    struct hdr_scan_entry_rec *slice_info, int is_normalized,
    struct buf_2d_rec *buf, int rd_select);
int RdSlice(struct img_buf_rec *img, int is_normalized,
    struct buf_2d_rec *_2d, int rd_select);
int RdCurSliceEchoes(struct img_buf_rec *img, int is_normalized,
    int rd_select);
int LoadAllNextSliceEchoes(char *action_str, struct img_buf_rec *img,
    int slice_offset, int is_locate_scan, int rd_select);
int img_xyz_pixel_sizes(struct img_buf_rec *img, float *xpixel_size,
    float *ypixel_size, float *zpixel_size);
int is_img_2d_size_original(struct img_buf_rec *img);
int GetImgUnit2dRec(struct img_buf_rec *img, struct unit_2d_rec *unit,
    struct unit_2d_rec **unit_ptr);
int SetupImgRegParams(struct img_buf_rec *img, struct img_buf_rec *regimg,
    unsigned long select, struct file_register_rec *fco1,
    struct file_register_rec *fco2);
int UseCurrentImgRegParams(struct img_buf_rec *img,
    struct img_buf_rec *regimg);



/*--------------------------------------------------------------------------
set_buf_data_type - ???
--------------------------------------------------------------------------*/

int
set_buf_data_type(_2d,info)
 struct buf_2d_rec *_2d;
 struct data_info_rec *info;
{
 unsigned long type4;

 if (info->var_use_status & INPUT_DATA_TYPE)
    {if (info->var_use_status & INPUT_DATA_FLOAT)
        type4 = BUF_VALUE_FLOAT;
       else if (info->var_use_status & INPUT_DATA_DOUBLE)
        type4 = BUF_VALUE_DOUBLE;
       else if (info->var_use_status & INPUT_DATA_SIGNED)
        type4 = BUF_VALUE_SIGNED;
     Set2dValueType(_2d,type4);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cnt_img_buf_rec_partners - ???
--------------------------------------------------------------------------*/

unsigned long 
cnt_img_buf_rec_partners(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *temp_img;
 unsigned long num_slices;

 temp_img = img;
 num_slices = 0;
 do
    {
     if (temp_img != NULL)
        {
         num_slices += 1;
         temp_img = temp_img->partner;
        }
       else break;
    }
 while (temp_img != img);
 return num_slices;
}


/*--------------------------------------------------------------------------
pick_first_img_buf_rec_partner - ???
--------------------------------------------------------------------------*/

struct img_buf_rec *
pick_first_img_buf_rec_partner(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *temp_img;

 TRACE(printf("pick_first_img_buf_rec_partner...\n"))
 temp_img = img;
 do
    {
     if (temp_img != NULL)
        {if (temp_img->cur_slice->status & SLICE_FIRST_ECHO) break;
         temp_img = temp_img->partner;}
    }
 while (temp_img != img);
 return temp_img;
}


/*--------------------------------------------------------------------------
pick_first_partner_slice - ???
--------------------------------------------------------------------------*/

struct hdr_scan_entry_rec *
pick_first_partner_slice(slice)
 struct hdr_scan_entry_rec *slice;
{
 struct hdr_scan_entry_rec *next;

 TRACE(printf("pick_first_partner_slice...\n"))
 next = slice;
 do
    {
     if (next != NULL)
        {if (next->status & SLICE_FIRST_ECHO) break;
         next = next->partner_slice;}
    }
 while (next != slice);
 return next;
}

/************************
equate_img_bufs_slice_nums(dest,source)
 struct img_buf_rec *dest,*source;
{
 unsigned long cnt1,cnt2;
 struct img_buf_rec *img1,*img2,*temp_img;

 if ((dest == NULL) || (source == NULL)) return CANCEL;
 cnt1 = cnt_img_buf_rec_partners(dest);
 cnt2 = cnt_img_buf_rec_partners(source);
 if (cnt1 != cnt2) return CANCEL;
 img1 = pick_first_img_buf_rec_partner(dest);
 img2 = pick_first_img_buf_rec_partner(source);
 temp_img = img1;
 do
    {
     if (temp_img != NULL)
        {temp_img->cur_slice = img2->cur_slice;
         if (img2 != NULL) img2 = img2->partner;
           else break;
         img1 = img1->partner;
        }
       else break;
    }
 while (temp_img != img1);

 return NO_ERROR;
}
*****************/


/*--------------------------------------------------------------------------
NextSliceOffset - ???
--------------------------------------------------------------------------*/

void
NextSliceOffset(action_str,slice_offset,cur_slice_num,total_slices,slice_num)
 char *action_str;
 int slice_offset;
 unsigned long total_slices;
 long cur_slice_num,*slice_num;
{
 if (action_str[0]  == 'a')
    {if (slice_offset < 0) *slice_num = -slice_offset;
       else *slice_num = slice_offset;}
   else
    {
     *slice_num = cur_slice_num + slice_offset;
     *slice_num %= (long) total_slices;
     if (*slice_num < 0) *slice_num = (long) total_slices + *slice_num;
    }
 PRT(printf("slice_offset = %d cur_slice_num = %d total_slices = %d *slice_num = %d\n",
       slice_offset,cur_slice_num,total_slices,*slice_num);)
}


/*--------------------------------------------------------------------------
get_slice_info - ???
--------------------------------------------------------------------------*/

int
get_slice_info(action_str,img,slice_offset,slice_info,is_locate_scan)
 char *action_str;
 struct img_buf_rec *img;
 int slice_offset,is_locate_scan;
 struct hdr_scan_entry_rec **slice_info;
{
 int is_rel,err;
 long scan_num,slice_num;

 *slice_info = img->cur_slice;
 if ((*slice_info)->slice->view != NULL)
    {
     if (action_str[0]  == 'a') is_rel = 0;
       else is_rel = 1;
     return locate_new_plane((*slice_info)->slice->view,slice_offset,is_rel);
    }
 if (is_locate_scan)
    {PRT(printf("is_locate_scan...\n"))
     NextSliceOffset(action_str,slice_offset,(long) img->cur_slice->scan_num,
             NumberOfSliceScans(&(img->file->hdr.data_info)),&scan_num);
      slice_num = img->cur_slice->slice_num;
    }
   else
    {NextSliceOffset(action_str,slice_offset,(long) img->cur_slice->slice_num,
            NumberOfSliceCuts(&(img->file->hdr.data_info)),&slice_num);
     scan_num = img->cur_slice->scan_num;
    }
 if ((err = LocateScanEntry(&(img->file->hdr),
         slice_num,scan_num,(unsigned long) img->cur_slice->echo_num,
         slice_info)) != NO_ERROR)
    *slice_info = img->cur_slice;
 return err;

/*
 if (action_str[0]  == 'a')
    {
     for (; !((*slice_info)->status & SLICE_FIRST); )
        {*slice_info = (*slice_info)->next_slice;
         if ((*slice_info) == img->cur_slice) break;}
    }
 if (slice_offset < 0)
    for (lcv = 0; lcv > slice_offset; lcv--)
       *slice_info = (*slice_info)->prior_slice;
   else 
    for (lcv = 0; lcv < slice_offset; lcv++)
       *slice_info = (*slice_info)->next_slice;
 return NO_ERROR;
*/
}


/*--------------------------------------------------------------------------
get_slice - ???
--------------------------------------------------------------------------*/

void
get_slice(action_str,img,slice_offset,is_locate_scan)
 char *action_str;
 struct img_buf_rec *img;
 int slice_offset,is_locate_scan;
{
 struct hdr_scan_entry_rec *next_slice;

 get_slice_info(action_str,img,slice_offset,&next_slice,is_locate_scan);
 img->previous_slice = img->cur_slice;

/* if img->last_slice != img->cur_slice, the "img->cur_slice" slice will then
        be read when needed */
 img->cur_slice = next_slice;
}


/*--------------------------------------------------------------------------
get_next_slice - ???
--------------------------------------------------------------------------*/

int
get_next_slice(action_str,img,slice_offset,is_locate_scan)
 char *action_str;
 struct img_buf_rec *img;
 int slice_offset,is_locate_scan;
{
 struct img_buf_rec *temp_img;

 get_slice(action_str,img,slice_offset,is_locate_scan);

 for (temp_img = img->partner; (temp_img != img) && (temp_img != NULL);
         temp_img = temp_img->partner)
    {
     get_slice(action_str,temp_img,slice_offset,is_locate_scan);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_all_next_slice_echoes - ???
--------------------------------------------------------------------------*/

int
get_all_next_slice_echoes(img,cur_slice)
 struct img_buf_rec *img;
 struct hdr_scan_entry_rec *cur_slice;
{
 struct img_buf_rec *temp_img;

 img->cur_slice = cur_slice;
 for (temp_img = img->partner; (temp_img != img) && (temp_img != NULL);
         temp_img = temp_img->partner)
    {cur_slice = cur_slice->partner_slice;
     temp_img->cur_slice = cur_slice;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
LocateSlice - ???
--------------------------------------------------------------------------*/

int
LocateSlice(img,slice_num,scan_num,echo_num)
 struct img_buf_rec *img;
 long slice_num,scan_num,echo_num;
{
 int err;
 struct hdr_scan_entry_rec *scan_entry;

 if (slice_num < 0)
    slice_num += (long) NumberOfSliceCuts(&(img->file->hdr.data_info));
 if (scan_num < 0)
    scan_num += (long) NumberOfSliceScans(&(img->file->hdr.data_info));
 if (echo_num < 0)
    echo_num += (long) img->file->hdr.data_info.num_echoes;
 PRT2(printf("LocateSlice s# = %d scan# = %d echo# = %d\n",
      slice_num,scan_num,echo_num))
 if ((err = LocateScanEntry(&(img->file->hdr),
       slice_num,scan_num,echo_num,&scan_entry)) == NO_ERROR)
    {img->previous_slice = img->cur_slice;
     img->cur_slice = scan_entry;}

 PRT2(printf("   scan_entry s# = %d scan# = %d echo# = %d\n",
      scan_entry->slice_num,scan_entry->scan_num,scan_entry->echo_num))
 return err;
}


/*--------------------------------------------------------------------------
LocateAllSliceEchoes - ???
--------------------------------------------------------------------------*/

int
LocateAllSliceEchoes(img,slice_num,scan_num,echo_num)
 struct img_buf_rec *img;
 long slice_num,scan_num,echo_num;
{
 struct img_buf_rec *temp_img;
 struct hdr_scan_entry_rec *cur_slice;
 int err;

 if ((err = LocateSlice(img,slice_num,scan_num,echo_num)) != NO_ERROR)
    return err;
 cur_slice = img->cur_slice;
 for (temp_img = img->partner; (temp_img != img) && (temp_img != NULL);
         temp_img = temp_img->partner)
    {cur_slice = cur_slice->partner_slice;
     temp_img->cur_slice = cur_slice;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
ImgAdvanceRelative - ???
--------------------------------------------------------------------------*/

int
ImgAdvanceRelative(img,ref_img)
 struct img_buf_rec *img,*ref_img;
{
 long snum,scnum,echo_num,num_cuts,num_scans;
 int err;

 num_cuts = NumberOfSliceCuts(&(img->file->hdr.data_info));
 num_scans = NumberOfSliceScans(&(img->file->hdr.data_info));
 snum = ((long) img->cur_slice->slice_num + (long) ref_img->cur_slice->slice_num -
          (long) ref_img->previous_slice->slice_num) % num_cuts;
 echo_num = ((long) img->cur_slice->echo_num + (long) ref_img->cur_slice->echo_num -
     (long) ref_img->previous_slice->echo_num) % img->file->hdr.data_info.num_echoes;
 scnum = ((long) img->cur_slice->scan_num + (long) ref_img->cur_slice->scan_num -
          (long) ref_img->previous_slice->scan_num) % num_scans;

 PRT11(printf("\nImgAdvanceRelative img = %u cur nsnum = %d scnum = %d enum = %d\n",
        img,img->cur_slice->slice_num,img->cur_slice->scan_num,
        img->cur_slice->echo_num))
 PRT11(printf("ImgAdvanceRelative ref_img cur nsnum = %d scnum = %d enum = %d\n",
        ref_img->cur_slice->slice_num,ref_img->cur_slice->scan_num,
        ref_img->cur_slice->echo_num))
 PRT11(printf("previous_slice ref_img  nsnum = %d scnum = %d enum = %d\n",
        ref_img->previous_slice->slice_num,ref_img->previous_slice->scan_num,
        ref_img->previous_slice->echo_num))
 PRT11(printf("ImgAdvanceRelative snum = %d scnum = %d echo_num = %d\n",
        snum,scnum,echo_num))
 err = LocateSlice(img,snum,scnum,echo_num);
 PRT11(printf("img snum = %d scnum = %d echo_num = %d\n\n",
        img->cur_slice->slice_num,img->cur_slice->scan_num,img->cur_slice->echo_num))
 return err;
}


/*--------------------------------------------------------------------------
set_img_min_max_status - ???
--------------------------------------------------------------------------*/

void
set_img_min_max_status(img)
 struct img_buf_rec *img;
{
 img->_2d.status4 |= BUF_MIN_MAX_COMPUTED;
}


/*--------------------------------------------------------------------------
clear_img_min_max_status - ???
--------------------------------------------------------------------------*/

void
clear_img_min_max_status(img)
 struct img_buf_rec *img;
{
 img->_2d.status4 &= BUF_FLUSH_MIN_MAX_STATUS;
}



/*--------------------------------------------------------------------------
GetImgSliceMinMax - ???
--------------------------------------------------------------------------*/

void
GetImgSliceMinMax(img,_2d)
     struct img_buf_rec *img;
     struct buf_2d_rec *_2d;
{
  struct buf_2d_rec *buf;

  PRT(printf("GetImgSliceMinMax...1\n"));
  if (_2d != NULL)
    buf = _2d;
  else
    buf = &(img->_2d);

  if (!(buf->status4 & BUF_MIN_MAX_COMPUTED))
  {
    if (img->cur_slice->slice->min_pixel <= img->cur_slice->slice->max_pixel)
    {
      buf->minval = img->cur_slice->slice->min_pixel;
      buf->maxval = img->cur_slice->slice->max_pixel;
      PRT(printf("GetImgSliceMinMax...minval = %f max_val = %f\n",
		 buf->minval,buf->maxval));
    }
    else
    {
      MinMax2d(buf,0,(double) .0,(double) .0);
      img->cur_slice->slice->min_pixel = buf->minval;
      img->cur_slice->slice->max_pixel = buf->maxval;
      PRT(printf("GetImgSliceMinMax...slice->min = %d slice->max = %d\n",
		 buf->minval,buf->maxval));
    }
  }
}



/*--------------------------------------------------------------------------
set_img_gradient_status - ???
--------------------------------------------------------------------------*/

void
set_img_gradient_status(img)
 struct img_buf_rec *img;
{
 img->_2d.status4 |= BUF_DATA_GRADIENT;
}


/*--------------------------------------------------------------------------
clear_img_gradient_status - ???
--------------------------------------------------------------------------*/

void
clear_img_gradient_status(img)
 struct img_buf_rec *img;
{
 img->_2d.status4 &= BUF_DATA_FLUSH_GRADIENT;
}


/*--------------------------------------------------------------------------
set_img_read_status - ???
--------------------------------------------------------------------------*/

void
set_img_read_status(img)
 struct img_buf_rec *img;
{
 img->last_slice = NULL;
}


/*--------------------------------------------------------------------------
total_slice_cuts - ???
--------------------------------------------------------------------------*/

unsigned long 
total_slice_cuts(img)
 struct img_buf_rec *img;
{
 if (img == NULL) return 0;
 if (img->cur_slice->slice->view != NULL)
    return img->cur_slice->slice->view->gplane.total_planes;
 return NumberOfSliceCuts(&(img->file->hdr.data_info));
}


/*--------------------------------------------------------------------------
total_slice_scans - ???
--------------------------------------------------------------------------*/

unsigned long 
total_slice_scans(img)
 struct img_buf_rec *img;
{
 if (img == NULL) return 0;
 if (img->cur_slice->slice->view != NULL)
    return 1;
 return NumberOfSliceScans(&(img->file->hdr.data_info));
}


/*--------------------------------------------------------------------------
get_img_fn - ???
--------------------------------------------------------------------------*/

char *
get_img_fn(img)
 struct img_buf_rec *img;
{
 char *fn;

 if (get_strlen(img->file->dirfn) > 0)
    if (concat_strs(&fn,6,img->file->dirfn,"/",img->file->fn,
                 img->file->hdr_fn_suffix,
             "--",img->file->img_fn_suffix) == NO_ERROR)
        return fn;
       else return NULL;
   else if (concat_strs(&fn,4,img->file->fn,
                 img->file->hdr_fn_suffix,
             "--",img->file->img_fn_suffix) == NO_ERROR)
       return fn;
   else return NULL;
}


/*--------------------------------------------------------------------------
get_img_label - ???
--------------------------------------------------------------------------*/

char *
get_img_label(img)
 struct img_buf_rec *img;
{
 char *label;

 if (cp_str(&label,img->cur_slice->img_label) == NO_ERROR)
    return label;
   else return NULL;
}


/*--------------------------------------------------------------------------
get_img_type_label - ???
--------------------------------------------------------------------------*/

char *
get_img_type_label(img)
 struct img_buf_rec *img;
{
 char *label;

 if ((img->cur_slice->slice != NULL) && 
     (img->cur_slice->slice->view != NULL))
    {if (cp_str(&label,img->cur_slice->slice->view->id) == NO_ERROR)
        return label;
    }
   else if (cp_str(&label,img->cur_slice->img_label) == NO_ERROR)
    return label;
 return NULL;
}


/*--------------------------------------------------------------------------
get_img_slice_num - ???
--------------------------------------------------------------------------*/

unsigned long 
get_img_slice_num(img)
 struct img_buf_rec *img;
{
 if (img->cur_slice->slice->view != NULL)
    return img->cur_slice->num;
 return img->cur_slice->slice_num + 1;
}


/*--------------------------------------------------------------------------
get_img_scan_num - ???
--------------------------------------------------------------------------*/

int
get_img_scan_num(img)
 struct img_buf_rec *img;
{
 if (img->cur_slice->slice->view != NULL)
    return 1;
 return img->cur_slice->scan_num + 1;
}


/*--------------------------------------------------------------------------
get_num_img_echoes - ???
--------------------------------------------------------------------------*/

long
get_num_img_echoes(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *cur,*next;
 long cnt;

 cur = img;
 next = cur->partner;
 while (next != cur)
    {next = next->partner;
     cnt += 1;}
 return cnt;
}


/*--------------------------------------------------------------------------
scale_all_partner_imgs - ???
--------------------------------------------------------------------------*/

int
scale_all_partner_imgs(img,scale_min,scale_max)
 struct img_buf_rec *img;
 unsigned long scale_min,scale_max;
{
 struct img_buf_rec *temp_img;
 int is_scale;

 temp_img = img;
 do
    {
     if (temp_img != NULL)
        {
         if (temp_img->_2d.status4 & BUF_DATA_VALID)
            {is_scale = 1;
             if (temp_img->_2d.status4 & BUF_MIN_MAX_COMPUTED)
                if (((long) temp_img->_2d.minval == scale_min) &&
                    ((long) temp_img->_2d.maxval == scale_max))
                   is_scale = 0;
             if (is_scale)
                {Scale2dPixels(&(temp_img->_2d),&(temp_img->_2d),
                     (double) scale_min,(double) scale_max,
                     0,(double) .0,(double) .0,0);
                 set_img_read_status(temp_img);}
             temp_img = temp_img->partner;
            }
           else
            {TRACE(printf("CANCEL\n"))
             return CANCEL;}
        }
    }
 while (temp_img != img);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_all_partner_img_buf_2d_recs - ???
--------------------------------------------------------------------------*/

int
get_all_partner_img_buf_2d_recs(img,_2ds)
 struct img_buf_rec *img;
 struct buf_2d_rec **_2ds;
{
 struct img_buf_rec *temp_img;
 unsigned long num_scans;

 temp_img = img;
 num_scans = 0;
 do
    {
     if (temp_img != NULL)
        {
         if (temp_img->_2d.status4 & BUF_DATA_VALID)
            {_2ds[num_scans++] = &(temp_img->_2d);
             temp_img = temp_img->partner;}
           else
            {TRACE(printf("CANCEL\n"))
             return CANCEL;}
        }
    }
 while (temp_img != img);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
save_file_pixels - ???
--------------------------------------------------------------------------*/

int
save_file_pixels(img,pixel_types)
 struct img_buf_rec *img;
 unsigned char *pixel_types;
{
 struct hdr_scan_entry_rec *the_cur_slice,*cur_slice,*partner,*slice;
 struct buf_2d_rec _2d,slice_mask;
 int err,is_first;
 double min,max;

 init_buf_2d_rec(&_2d);
 init_buf_2d_rec(&slice_mask);
 if ((err = SetupBuf2dRec(&_2d,img->_2d.dimx,img->_2d.dimy,
          img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    {free_buf_2d_rec(&_2d);
     return err;}
 the_cur_slice = cur_slice = img->cur_slice;
 err = NO_ERROR;
 is_first = 1;
 do
    {
     slice = partner = cur_slice;
     do 
        {TRACE(printf("slice# %d  %d label = %s\n",
            slice->slice_num,
            slice->num,slice->img_label))
         img->cur_slice = slice;

         if (fseek(img->file->img_fid,(size_t) slice->img_addr,0) != 0)
            err = ILLEGAL_FILE_ADDRESS;
           else if (fread(_2d.buf[0],(size_t) _2d.total_bytes,(size_t) 1,
                 img->file->img_fid) != 1)
            err = READ_ERROR;
           else if ((err = setup_slice_mask(img,&_2d,
               &slice_mask,pixel_types)) == NO_ERROR)
            {_2d.status4 &= ~BUF_MIN_MAX_COMPUTED;
             MinMax2d(&_2d,0,(double) .0,(double) .0);
             slice->slice->min_pixel = _2d.minval;
             slice->slice->max_pixel = _2d.maxval;
             if (is_first)
                {min = _2d.minval;
                 max = _2d.maxval;
                 is_first = 0;}
               else
                {if (min > _2d.minval) min = _2d.minval;
                 if (max < _2d.maxval) max = _2d.maxval;}
             if ((err = wr_slice(img,&_2d,NULL)) == NO_ERROR)
                slice = slice->partner_slice;
            }
        }
     while ((err == NO_ERROR) && (slice != NULL) && (slice != partner));
     if (err == NO_ERROR) cur_slice = cur_slice->next_slice;
    }
 while ((err == NO_ERROR) && (cur_slice != NULL) &&
        (cur_slice != the_cur_slice));
 free_buf_2d_rec(&_2d);
 free_buf_2d_rec(&slice_mask);
 if (err == NO_ERROR)
    {img->file->hdr.data_info.min_pixel = min;
     img->file->hdr.data_info.max_pixel = max;
    }
 img->cur_slice = the_cur_slice;
 printf("save file pixels min = %f  max = %f  err= %d\n",min,max,err);
 return err;
}


/*--------------------------------------------------------------------------
remmap_file_bufs - ???
--------------------------------------------------------------------------*/

void
remmap_file_bufs(file)
 struct input_file_rec *file;
{
 unsigned long lcv;

 for (lcv = 0; lcv < file->hdr.num_scans; lcv++)
    if ((file->hdr.scans[lcv].slice != NULL) &&
        (file->hdr.scans[lcv].slice->_2d.status4 & BUF_NON_EMPTY) &&
        (file->hdr.scans[lcv].slice->_2d.prog_status2 & BUF_DATA_MMAP))
       {file->hdr.scans[lcv].slice->_2d.prog_status2 &= ~BUF_DATA_MMAP;
        mmap_buf_2d_rec(&(file->hdr.scans[lcv].slice->_2d),
                3,file->img_fid,file->hdr.scans[lcv].img_addr);
       }
}


/*--------------------------------------------------------------------------
ResizePosNegImg2d - ???
--------------------------------------------------------------------------*/

int
ResizePosNegImg2d(result,img,img_2d,partner_img_2d,bitmask,maskbound)
 struct buf_2d_rec *result,*img_2d,*partner_img_2d,*bitmask;
 struct img_buf_rec *img;
 struct int_bound_rec *maskbound;
{
 struct buf_2d_rec *pos,*neg;
 double minval,maxval,minval_set,maxval_set;
 unsigned long status4,depth;
 int err;

 if (img->cur_slice->partner_slice->echo_num < 
                 img->cur_slice->echo_num)
    {pos = partner_img_2d;
     neg = img_2d;}
   else
    {pos = img_2d;
     neg = partner_img_2d;}
 status4 = img_2d->status4;
 if (status4 & BUF_MIN_MAX_COMPUTED)
    {minval = img_2d->minval;
     maxval = img_2d->maxval;}
 if (status4 & BUF_MIN_MAX_SET)
    {minval_set = img_2d->minval_set;
     maxval_set = img_2d->maxval_set;}
 PRT7(MinMax2dValues(pos,0,(double) .0,(double) .0,&min4,&max4);
     printf(" pos min4 = %f max4 = %f\n",min4,max4))
 PRT7(MinMax2dValues(neg,0,(double) .0,(double) .0,&min4,&max4);
     printf(" neg min4 = %f max4 = %f\n",min4,max4))

 depth = img_2d->pixel_depth;
 if (((err = CombinePosNeg2d(img_2d,pos,neg)) == NO_ERROR) &&
     ((bitmask == NULL) || 
      ((err = Set2d(img_2d,0,0,bitmask,maskbound,(double) .0)) == NO_ERROR)) &&
     ((err = ResizeBuf2dRec(partner_img_2d,img_2d,img->unit.dimx,
           img->unit.dimy,&(img->unit.tolocal_mat)))
         == NO_ERROR) &&
     ((err = SetupBuf2dRec(result,partner_img_2d->dimx,
         partner_img_2d->dimy,depth,0)) == NO_ERROR))
    {
     PRT7(MinMax2dValues(partner_img_2d,0,(double) .0,(double) .0,&min4,&max4);
         printf(" pos + neg min4 = %f max4 = %f\n",min4,max4))

     if (img_2d == pos)
        {
         SelectAssign2d(result,partner_img_2d,
               0x00004408,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
         PRT7(MinMax2dValues(result,0,(double) .0,(double) .0,&min4,&max4);
             printf(" result = pos min4 = %f max4 = %f\n",min4,max4))
        }
       else
        {
         SelectAssign2d(result,partner_img_2d,
               0x00000604,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
         PRT7(MinMax2dValues(result,0,(double) .0,(double) .0,&min4,&max4);
             printf(" result = neg min4 = %f max4 = %f\n",min4,max4))
        }

     if (status4 & BUF_MIN_MAX_COMPUTED)
        {result->minval = minval;
         result->maxval = maxval;
         result->status4 |= BUF_MIN_MAX_COMPUTED;
         PRT7(printf("BUF_MIN_MAX_COMPUTED set minval = %f maxval = %f\n",minval,maxval))
        }
     if (status4 & BUF_MIN_MAX_SET)
        {result->minval_set = minval_set;
         result->maxval_set = maxval_set;
         result->status4 |= BUF_MIN_MAX_SET;
         PRT7(printf("BUF_MIN_MAX_SET set minval_set = %f maxval_set = %f\n",
                 minval_set,maxval_set))
        }
     result->status4 |= BUF_DATA_VALID;
    }
 PRT7(printf("ResizePosNegImg2d...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
ExtractImgPosOrNegEcho - ???
--------------------------------------------------------------------------*/

int
ExtractImgPosOrNegEcho(img,_2d,result)
 struct img_buf_rec *img;
 struct buf_2d_rec *_2d,*result;
{
 int is_pos;
 struct buf_2d_rec *ptr;

 PRT7(printf("ExtractImgPosOrNegEcho...\n"))
 if (img->cur_slice->echo_num < img->cur_slice->partner_slice->echo_num)
    is_pos = 1;
   else is_pos = 0;
 if (result == NULL) ptr = _2d;
   else ptr = result;
 PRT7(MinMax2dValues(_2d,0,(double) .0,(double) .0,&min4,&max4);
             printf(" _2d = pos min4 = %f max4 = %f\n",min4,max4))
 if (is_pos)
    {SelectAssign2d(ptr,_2d,
               0x00004408,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
     PRT7(MinMax2dValues(ptr,0,(double) .0,(double) .0,&min4,&max4);
          printf(" result = pos min4 = %f max4 = %f\n",min4,max4))
    }
   else
    {SelectAssign2d(ptr,_2d,
               0x00000604,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
     PRT7(MinMax2dValues(ptr,0,(double) .0,(double) .0,&min4,&max4);
             printf(" result = neg min4 = %f max4 = %f\n",min4,max4))
    }
 if ((img->status4 & IMAGE_USE_SET_MIN_MAX) &&
     (img->_2d.status4 & BUF_NON_EMPTY))
    {ptr->minval_set = img->_2d.minval_set;
     ptr->maxval_set = img->_2d.maxval_set;
     ptr->status4 |= BUF_MIN_MAX_SET;
    }
 PRT7(printf("ExtractImgPosOrNegEcho...is_pos = %d\n",is_pos))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
RdImgPosNegEchoes - ???
--------------------------------------------------------------------------*/

int
RdImgPosNegEchoes(img,is_normalized,_2d,rd_select)
 struct img_buf_rec *img;
 int is_normalized;
 struct buf_2d_rec *_2d;
 int rd_select;
{
 struct buf_2d_rec temp,local_2d,local_2d1;
 struct data_info_rec *info;
 int err;

 PRT7(printf("RdImgPosNegEchoes...\n"))
 info = &(img->file->hdr.data_info);
 init_buf_2d_rec(&local_2d);
 init_buf_2d_rec(&local_2d1);
 if (((err = SetupBuf2dRec(&local_2d,info->dimx,info->dimy,
             info->pixel_depth_bits,InputDataTypeToBufType(info))) == NO_ERROR) &&
     ((err = SetupBuf2dRec(&local_2d1,info->dimx,info->dimy,
             info->pixel_depth_bits,InputDataTypeToBufType(info))) == NO_ERROR) &&
     ((err = RdSliceData(img,img->cur_slice,
               is_normalized,&local_2d,rd_select)) == NO_ERROR) &&
     ((err = RdSliceData(img,img->cur_slice->partner_slice,
               is_normalized,&local_2d1,rd_select)) == NO_ERROR))
    {PRT7(printf("RdImgPosNegEchoes...enum = %d penum = %d\n",
            img->cur_slice->echo_num,img->cur_slice->partner_slice->echo_num))
     if (img->cur_slice->echo_num > img->cur_slice->partner_slice->echo_num)
        {temp = local_2d;
         local_2d = local_2d1;
         local_2d1 = temp;}
     if (_2d == NULL)
        err = CombinePosNeg2d(&(img->_2d),&local_2d,&local_2d1);
       else err = CombinePosNeg2d(_2d,&local_2d,&local_2d1);
    }
 free_buf_2d_rec(&local_2d);
 free_buf_2d_rec(&local_2d1);
 PRT7(printf("RdImgPosNegEchoes...err = %d\n",err))
return err;
}


/*--------------------------------------------------------------------------
SaveImgBufToFileBuf - ???
--------------------------------------------------------------------------*/

int
SaveImgBufToFileBuf(img)
 struct img_buf_rec *img;
{
 int err;
 struct data_info_rec *info;

 info = &(img->file->hdr.data_info);
 if ((img->_2d.status4 & BUF_NON_EMPTY) &&
     (img->_2d.dimx == info->dimx) && (img->_2d.dimy == info->dimy) &&
     (img->_2d.pixel_depth == info->pixel_depth_bits))
    err = copy_buf_2d_rec_content(&(img->cur_slice->slice->_2d),&(img->_2d));
   else err = CANCEL;
 return err;
}


/*--------------------------------------------------------------------------
wr_slice - ???
--------------------------------------------------------------------------*/

int
wr_slice(img,img_2d,err_reason)
 struct img_buf_rec *img;
 struct buf_2d_rec *img_2d;
 char **err_reason;
{
 FILE *tmp_fid;
 int err;
 struct buf_2d_rec *_2d;
 unsigned long indx;

 if (err_reason != NULL) *err_reason = NULL;
 if (img->cur_slice->slice->view != NULL)
    {PRT1(printf("wr_slice img->cur_slice->slice->view != NULL\n"))
     return NO_ERROR;}
   else if (FileHdrScan(&(img->file->hdr),img->cur_slice,&indx) != NO_ERROR)
    {PRT1(printf("wr_slice != NO_ERROR\n"))
     return NO_ERROR;}
 PRT1(printf("wr_slice indx = %d\n",indx))
 if (img_2d == NULL) _2d = &(img->_2d);
   else _2d = img_2d;
 err = NO_ERROR;
 fseek(img->file->img_fid,img->cur_slice->img_addr,0);
 TRACE(printf("wr_slice img->cur_slice->img_addr = %d\n",img->cur_slice->img_addr))
 if (fwrite(_2d->buf[0],(size_t) _2d->total_bytes,(size_t) 1,
         img->file->img_fid) != 1)
    {tmp_fid = img->file->img_fid;
     if ((err = reopen_file_as_read_update(&(img->file->img_fid),
               img->file->dirfn,img->file->fn,".img",err_reason)) == NO_ERROR)
        {TRACE(printf("second seek...\n");)
         fseek(img->file->img_fid,img->cur_slice->img_addr,0);
         img->file->status |= FILE_READ_WRITE;
         remmap_file_bufs(img->file);
         if (fwrite(_2d->buf[0],(size_t) _2d->total_bytes,
                           (size_t) 1,img->file->img_fid) != 1)
            {err = WRITE_ERROR;
             if (err_reason != NULL) 
                cp_str(err_reason,"NO WRITE ACCESS");
            }
           else
            {_2d->status4 &= ~BUF_MODIFIED;
             fflush(img->file->img_fid);
            }
        }
       else if ((img->file->img_fid != NULL) && (img->file->img_fid != tmp_fid))
        {img->file->status &= ~FILE_READ_WRITE;
         img->file->status |= FILE_READ;
         remmap_file_bufs(img->file);
        }
     }
    else
     {_2d->status4 &= ~BUF_MODIFIED;
      fflush(img->file->img_fid);}
 if (err == NO_ERROR)
    if ((img->cur_slice->slice->_2d.status4 & BUF_NON_EMPTY) && 
        (_2d != (struct buf_2d_rec *) &(img->cur_slice->slice->_2d)))
       if (is_same_buf_2d_rec_data_size(&(img->cur_slice->slice->_2d),_2d))
          {
           PRT1(printf("wr_slice copy_buf_2d_rec_content\n"))
           copy_buf_2d_rec_content(&(img->cur_slice->slice->_2d),_2d);}

 return err;
}


/*--------------------------------------------------------------------------
RdFilePixel - ???
--------------------------------------------------------------------------*/

int
RdFilePixel(file,cur_slice,row,col,val)
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *cur_slice;
 unsigned long row,col;
 double *val;
{
 struct data_info_rec *info;
 unsigned long first,last,row_bytes,offset,num;
 unsigned char buf[5];
 float fl;
 double dou;
 
 info = &(file->hdr.data_info);
 XFirstAndLastByteOffset(col,info->pixel_depth_bits,&first,&last);
 row_bytes = GetRowBytes(info->dimx,info->pixel_depth_bits);
 offset = cur_slice->img_addr + row * row_bytes;
 PRT12(printf("RdFilePixel 1st = %d last = %d offset = %d row_bytes = %d\n",
   first,last,offset,row_bytes))
 first += offset;
 last += offset;
 fseek(file->img_fid,first,0);
 PRT12(printf("RdFilePixel addr = %u row = %d col = %d off = %u\n",
      cur_slice->img_addr,row,col,first));
 if (info->var_use_status & INPUT_DATA_DOUBLE)
    {if (fread(&dou,sizeof(dou),1,file->img_fid) != 1)
        return READ_ERROR;
     *val = dou;}
   else if (info->var_use_status & INPUT_DATA_FLOAT)
    {if (fread(&fl,sizeof(fl),1,file->img_fid) != 1)
        return READ_ERROR;
     *val = (double) fl;}
   else
    {num = last - first + 1;
     if (num > 5) return CANCEL;
     PRT12(printf("num = %d\n",num))
     if (fread(buf,num,1,file->img_fid) != 1)
        return READ_ERROR;
/*
     PRT12(for (lcv = 0; lcv < num; lcv++)
        printf("%d) %x %d ",lcv,(unsigned long) buf[lcv],(unsigned long) buf[lcv]))
*/
     if (info->var_use_status & INPUT_DATA_SIGNED)
        {PRT12(printf("INPUT_DATA_SIGNED\n"))
         *val = DoubleMax4ByteBufValue(buf,col,info->pixel_depth_bits,2);}
       else
        *val = DoubleMax4ByteBufValue(buf,col,info->pixel_depth_bits,0);
    }
 PRT12(printf("RdFilePixel val = %f\n",*val));
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
rd_cur_slice_data - ???
--------------------------------------------------------------------------*/

int
rd_cur_slice_data(fid,cur_slice,buf)
 FILE *fid;
 struct hdr_scan_entry_rec *cur_slice;
 struct buf_2d_rec *buf;
{
 PRT10(printf("rd_cur_slice_data...status4 = %x\n",buf->status4))
 buf->status4 &= ~BUF_DATA_VALID;
 buf->status4 &= BUF_FLUSH_DATA_STATUS;
 buf->prog_status2 &= ~BUF_DATA_NEW;
 if (fseek(fid,(size_t) cur_slice->img_addr,0) != 0)
    {
     return ILLEGAL_FILE_ADDRESS;}

 if (fread(buf->buf[0],(size_t) buf->total_bytes,(size_t) 1,fid) != 1)
    {
     return READ_ERROR;}

 buf->status4 |= BUF_DATA_VALID;
 buf->prog_status2 |= BUF_DATA_NEW;
 PRT10(printf("end rd_cur_slice_data.1..status4 = %x\n",buf->status4))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
RdFileSlice - ???

if rd_select == 0 then read from buffer if exists else read from file
if rd_select & 1 then keep buffer if not exists
if rd_select & 2 then read from file even if buffer exists and replace the buffer
if rd_select & 4 then read from file & ignore the buffer even if it exists 
if rd_select & 8 then read from buffer if it exists 
--------------------------------------------------------------------------*/

int
RdFileSlice(fid,file,cur_slice,buf,rd_select)
 FILE *fid;
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *cur_slice;
 struct buf_2d_rec *buf;
 int rd_select;
{
 int err;
 unsigned long type;

 if (!(buf->status4 & BUF_NON_EMPTY)) return CANCEL;
   else if ((type = InputDataTypeToBufType(&(file->hdr.data_info))) !=
            (buf->status4 & INPUT_DATA_TYPE))
    {if ((err = SetupBuf2dRec(buf,buf->dimx,buf->dimy,
         file->hdr.data_info.pixel_depth_bits,type)) != NO_ERROR)
        return err;
    }

 PRT1(printf("RdFileSlice in num = %d echo = %d scan = %d %x\n",
          cur_slice->slice_num,cur_slice->echo_num,cur_slice->scan_num,
          (unsigned long) rd_select))
 if (cur_slice->slice->view != NULL) 
    {
     if ((cur_slice->slice->view->status & PROJECT_THE_PLANE_DATA) ==
           PROJECT_THE_PLANE_DATA)
        { /* FIXME:  The argument "file" below is ignored by the the
	     function being called here.  -PWH 19990519 */
	    if ((err = get_plane_slice_data(cur_slice->slice->view /*,file*/ ))
                     != NO_ERROR)
                return err;}
     if ((cur_slice->slice->_2d.status4 & BUF_NON_EMPTY) &&
         (cur_slice->slice->_2d.status4 & BUF_DATA_VALID))
        {
/*
         if (((err = find_file_3d(cur_slice->slice->view->file,
               cur_slice->slice->view->id,&_3d)) != NO_ERROR) ||
             ((err = _3dPlaneData(&(cur_slice->slice->view->gplane),
                  _3d,buf)) != NO_ERROR))
            return err;
*/
         if ((err = transform_plane_2d_data(&(cur_slice->slice->view->gplane),
                   &(cur_slice->slice->_2d),buf)) != NO_ERROR)
            return err;
          buf->status4 |= BUF_DATA_VALID;
          buf->prog_status2 |= BUF_DATA_NEW;
         return NO_ERROR;
        }
       else return CANCEL;
    }
 if (!(rd_select & 6) &&
      (cur_slice->slice->_2d.status4 & BUF_NON_EMPTY) &&
      (cur_slice->slice->_2d.status4 & BUF_DATA_VALID))
    {        
     PRT1(printf("RdFileSlice from buffer\n",
          cur_slice->slice_num,cur_slice->echo_num,cur_slice->scan_num))
     if ((err = copy_buf_2d_rec_content(buf,&(cur_slice->slice->_2d)))
                != NO_ERROR)
        return err;
     buf->status4 |= BUF_DATA_VALID;
     buf->prog_status2 |= BUF_DATA_NEW;
     return NO_ERROR;
    } 
 if (rd_select & 8) return CANCEL;

 if ((err = rd_cur_slice_data(fid,cur_slice,buf)) != NO_ERROR)
    return err;
 if ((rd_select & 2) ||
     ((rd_select & 1) && (buf != (struct buf_2d_rec *) &(cur_slice->slice->_2d))))
    copy_buf_2d_rec_content(&(cur_slice->slice->_2d),buf); 
 PRT1(printf("RdFileSlice end num = %d echo = %d scan = %d\n",
          cur_slice->slice_num,cur_slice->echo_num,cur_slice->scan_num))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
RdSliceData - ???
--------------------------------------------------------------------------*/

int
RdSliceData(img,slice_info,is_normalized,buf,rd_select)
 struct img_buf_rec *img;
 struct hdr_scan_entry_rec *slice_info;
 int is_normalized;
 struct buf_2d_rec *buf;
 int rd_select;
{
 int err;

 if ((err = RdFileSlice(img->file->img_fid,img->file,
                   slice_info,buf,rd_select)) != NO_ERROR)
    return err;
 PRT7(printf("RdSliceData...snum = %d enum = %d scnum = %d num = %d label = %s is_normalized = %d out\n",slice_info->slice_num,
         slice_info->echo_num,slice_info->scan_num,
         slice_info->num,slice_info->img_label,is_normalized))

 if (is_normalized || !(img->status4 & IMAGE_USE_MIN_MAX) ||
          (img->status4 & IMAGE_USE_SET_MIN_MAX))
    {
     if (!is_normalized && (img->status4 & IMAGE_USE_SET_MIN_MAX))
        {
         buf->minval_set = img->file->slice_info.min_pixel;
         buf->maxval_set = img->file->slice_info.max_pixel;
         PRT(printf("1 use set min = %d  max = %d\n",buf->min_val_set,
                  buf->max_val_set))
         buf->status4 |= BUF_MIN_MAX_SET;
        }
       else
        {PRT(printf("use global min & max\n"))
         buf->minval_set = img->file->hdr.data_info.min_pixel;
         buf->maxval_set = img->file->hdr.data_info.max_pixel;
         buf->status4 |= BUF_MIN_MAX_SET;
        }
    }
   else if (img->status4 & IMAGE_USE_SLICE_MIN_MAX)
    {PRT(printf("use slice min & max\n"))
     GetImgSliceMinMax(img,buf);
    }
 
 PRT4(if (buf->status4 & BUF_MIN_MAX_COMPUTED)
         printf("buf->status4 & BUF_MIN_MAX_COMPUTED...min = %f max = %f\n",
              buf->minval,buf->maxval);
     if (buf->status4 & BUF_MIN_MAX_SET)
         printf("buf->status4 & BUF_MIN_MAX_SET...min = %f max = %f\n",
              buf->minval_set,buf->maxval_set);)
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
RdSlice - ???
--------------------------------------------------------------------------*/

int
RdSlice(img,is_normalized,_2d,rd_select)
 struct img_buf_rec *img;
 int is_normalized;
 struct buf_2d_rec *_2d;
 int rd_select;
{
 int err,is_local;
 struct data_info_rec *info;
 struct buf_2d_rec *buf,local_2d,local_2d1,*echo1,*echo2;

 PRT5(printf("RdSlice status4 = %x\n",img->status4))
 is_local = 0;
 if ((img->unit.status2 & UNIT_2D_IN_USE) ||
     (img->status4 & (IMG_HISTO_1D | IMG_HISTO_2D)))
    {if (img->status4 & IMG_HISTO_1D)
        {if (_2d != NULL) buf = _2d;
           else buf = &(img->_2d);
         if (is_img_histo_ready(img,buf->dimx,NULL))
            {PRT5(printf("is_img_histo_ready...\n"))
             if ((err = Setup1dhistoByOptions(buf,img)) == NO_ERROR)
                if (buf == &(img->_2d))
                   img->last_slice = img->cur_slice;
             return err;}
        }
     init_buf_2d_rec(&local_2d);
     is_local = 1;
     info = &(img->file->hdr.data_info);
     if ((err = SetupBuf2dRec(&local_2d,info->dimx,info->dimy,
             info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR)
        return err;
     if ((img->status4 & IMG_HISTO_2D) ||
         ((info->var_use_status & POS_NEG_ACTIVATION) &&
          (img->unit.status2 & UNIT_2D_IN_USE) && (info->num_echoes == 2)))
        {init_buf_2d_rec(&local_2d1);
         if ((err = SetupBuf2dRec(&local_2d1,info->dimx,info->dimy,
                info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR)
            {free_buf_2d_rec(&local_2d);
             return err;}
         is_local = 2;
        }
     buf = &local_2d;
    }
   else if (_2d != NULL) buf = _2d;
   else buf = &(img->_2d);
 if (((err = RdSliceData(img,img->cur_slice,
               is_normalized,buf,rd_select)) == NO_ERROR) &&
     is_local &&
     ((is_local != 2) ||
      ((err = RdSliceData(img,img->cur_slice->partner_slice,
               is_normalized,&local_2d1,rd_select)) == NO_ERROR)))
    {if (_2d != NULL) buf = _2d;
       else buf = &(img->_2d);
     PRT5(printf("before...is_local = %d buf = %u\n",is_local,buf->buf))
     buf->status4 &= ~(BUF_DATA_VALID | BUF_MIN_MAX_COMPUTED |
                       BUF_MIN_MAX_SET);
     if (img->status4 & (IMG_HISTO_1D | IMG_HISTO_2D))
        {if (is_local == 2)
            {if (img->cur_slice->partner_slice->echo_num < 
                 img->cur_slice->echo_num)
                {echo1 = &local_2d1;
                 echo2 = &local_2d;}
               else
                {echo1 = &local_2d;
                 echo2 = &local_2d1;}
             err = Setup2dhistoByOptions(buf,echo1,echo2,img);}
           else if ((err = ComputeHisto1d(img,&local_2d,buf->dimx)) ==
                         NO_ERROR)
            err = Setup1dhistoByOptions(buf,img);
        }   
       else if (img->unit.status2 & UNIT_2D_IN_USE)
        {PRT7(printf("RdSlice...UNIT_2D_IN_USE...\n"))
         if ((info->var_use_status & POS_NEG_ACTIVATION) &&
             (info->num_echoes == 2))
            {PRT7(printf("RdSlice...UNIT_2D_IN_USE...ResizePosNegImg2d\n"))
             err = ResizePosNegImg2d(buf,img,&local_2d,&local_2d1,NULL,NULL);
            }
           else if ((err = ResizeBuf2dRec(buf,&local_2d,
             img->unit.dimx,img->unit.dimy,&(img->unit.tolocal_mat)))
                    == NO_ERROR)
            {if (local_2d.status4 & BUF_MIN_MAX_COMPUTED)
                {buf->minval = local_2d.minval;
                 buf->maxval = local_2d.maxval;
                 buf->status4 |= BUF_MIN_MAX_COMPUTED;}
             if (local_2d.status4 & BUF_MIN_MAX_SET)
                {buf->minval_set = local_2d.minval_set;
                 buf->maxval_set = local_2d.maxval_set;
                 buf->status4 |= BUF_MIN_MAX_SET;}
             buf->status4 |= BUF_DATA_VALID;
            }
        }
     PRT(printf("err = %d...buf = %u\n",err,buf->buf))
    }
 if (is_local) 
    {free_buf_2d_rec(&local_2d);
     if (is_local == 2) free_buf_2d_rec(&local_2d1);}
 
 if ((err == NO_ERROR) && (buf == &(img->_2d)))
    {PRT(printf("RdSlice last_slice = cur_slice\n"))
     if (img->move_2d.status4 & BUF_NON_EMPTY)
        {free_buf_2d_rec(&(img->move_2d));
         img->status4 &= ~IMG_MOVE_2D_VALID;}
     img->last_slice = img->cur_slice;}

 return err;
}
/*
       else if (img->file->hdr.status & GLOBAL_MIN_MAX_UNDEFINED)
        {printf("GLOBAL_MIN_MAX_UNDEFINED\n");
         if ((is_normalized) && (img->status4 & IMAGE_USE_SET_MIN_MAX))
            {TRACE(printf("2 use set min & max\n"))
             buf->min_val_set = img->file->slice_info.min_pixel;
             buf->max_val_set = img->file->slice_info.max_pixel;
             buf->status4 |= BUF_MIN_MAX_SET;
            }
           else
            {TRACE(printf("use slice min & max\n"))
             buf->status4 &= ~BUF_MIN_MAX_SET;
             if (_2d == NULL)
                {img->status4 |= IMAGE_USE_SLICE_MIN_MAX;
                 GetImgSliceMinMax(img,NULL);
                }
              else MinMax2d(buf,0,(double) .0,(double) .0);
            }
        }
*/


/*--------------------------------------------------------------------------
RdCurSliceEchoes - ???
--------------------------------------------------------------------------*/

int
RdCurSliceEchoes(img,is_normalized,rd_select)
 struct img_buf_rec *img;
 int is_normalized,rd_select;
{
 struct img_buf_rec *temp_img;
 int err;

 temp_img = img;
 err = NO_ERROR;
 do
    {
     if (temp_img != NULL)
        {
         if ((err = RdSlice(temp_img,is_normalized,NULL,rd_select)) != NO_ERROR)
            break;
         if (!(temp_img->_2d.status4 & BUF_DATA_VALID)) 
            return READ_ERROR;
         temp_img = temp_img->partner;
        }
       else break;
    }
 while (temp_img != img);
 return err;
}


/*--------------------------------------------------------------------------
LoadAllNextSliceEchoes - ???
--------------------------------------------------------------------------*/

int
LoadAllNextSliceEchoes(action_str,img,slice_offset,is_locate_scan,rd_select)
 char *action_str;
 struct img_buf_rec *img;
 int slice_offset,is_locate_scan,rd_select;
{
 get_next_slice(action_str,img,slice_offset,is_locate_scan);
 return RdCurSliceEchoes(img,0,rd_select);
}


/*--------------------------------------------------------------------------
img_xyz_pixel_sizes - ???
--------------------------------------------------------------------------*/

int
img_xyz_pixel_sizes(img,xpixel_size,ypixel_size,zpixel_size)
 struct img_buf_rec *img;
 float *xpixel_size,*ypixel_size,*zpixel_size;
{
 if (img->cur_slice->slice->view != NULL)
    if (_3d_xyz_pixel_sizes(img,xpixel_size,ypixel_size,zpixel_size) == NO_ERROR)
       return NO_ERROR;
 *xpixel_size = img->file->hdr.data_info.xpixel_size;
 *ypixel_size = img->file->hdr.data_info.ypixel_size;
 *zpixel_size = img->file->hdr.data_info.pixel_thickness;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
is_img_2d_size_original - ???
--------------------------------------------------------------------------*/

int
is_img_2d_size_original(img)
 struct img_buf_rec *img;
{
 struct data_info_rec *info;

 info = &(img->file->hdr.data_info);
 if ((img->_2d.dimx == info->dimx) && 
     (img->_2d.dimy == info->dimy))
    return 1;
   else return 0;
}


/*--------------------------------------------------------------------------
GetImgUnit2dRec - ???
--------------------------------------------------------------------------*/

int
GetImgUnit2dRec(img,unit,unit_ptr)
 struct img_buf_rec *img;
 struct unit_2d_rec *unit,**unit_ptr;
{
 struct data_info_rec *info;

 if (img->unit.status2 & UNIT_2D_IN_USE)
    *unit_ptr = &(img->unit);
   else 
    {info = &(img->file->hdr.data_info);
     setup_unit_2d_rec(unit,.0,.0,info->xpixel_size,info->ypixel_size,
            info->dimx,info->dimy,.0,.0,info->xpixel_size,info->ypixel_size);
     *unit_ptr = unit;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
SetupImgRegParams - ???

if (select & 0x00000010) use current reg-params
if (select & 1)
   the reg-params is new and always recomputed
  else it will only be computed if it doesn't exist
if (!(select & 8))
   the reg-params created is the default reg-params
  else the reg-params created is based on the img->unit & reg_img->unit

if (select & 2) S# = 0 is assumed for the slice_num
   else img->cur_slice->slice_num is used as the slice_num

if (select & 4) add and record the reg-params
--------------------------------------------------------------------------*/

int
SetupImgRegParams(img,regimg,select,fco1,fco2)
 struct img_buf_rec *img,*regimg;
 unsigned long select;
 struct file_register_rec *fco1,*fco2;
{
 struct file_register_rec *coptr1,*coptr2,co1,co2;
 struct data_info_rec *info,*info1;
 struct matrix_3d_rec matrix,mat3d;
 int err,which;
 float zratio;

 PRT8(printf("SetupImgRegParams...img->file = %u regimg->file = %u is_add = %x\n",
          img->file,regimg->file,select))
 if (img->file == regimg->file) return NO_ERROR;
 if (select & 8) 
    {if (!(img->unit.status2 & UNIT_2D_IN_USE) &&
         !(regimg->unit.status2 & UNIT_2D_IN_USE))
        which = 1;
       else which = 2;}
   else which = 1;
 if ((select & 1) ||
     ((coptr1 = find_file_register_rec(img->file,regimg->file,NULL,which)) == NULL) ||
     ((coptr2 = find_file_register_rec(regimg->file,img->file,NULL,which)) == NULL))
    {PRT8(printf("SetupImgRegParams...1\n"))
     info = &(img->file->hdr.data_info);
     info1 = &(regimg->file->hdr.data_info);
     if (select & 2) zratio = .5;
       else zratio = ((float) img->cur_slice->slice_num + .5);
     zratio *= info->pixel_thickness / info1->pixel_thickness;
     if ((select & 8) && (img->unit.status2 & UNIT_2D_IN_USE))
        {PRT8(printf("co1.co.reg.xyztoplane...img->unit.status2 & UNIT_2D_IN_USE\n"))
         setup_scale_3d_matrix(&matrix,img->unit.unitx,img->unit.unity,1.0);
         matrix_2d_to_3d(&mat3d,&(img->unit.localto_mat));
         PRT8(pr_3d_matrix(&mat3d))
         PRT8(pr_3d_matrix(&matrix))
         mult_3d_matrix(&(co1.co.reg.xyztoplane),&matrix,&mat3d);
         translate_3d_matrix(&(co1.co.reg.xyztoplane),
            -(img->unit.unitx * (float) img->unit.dimx - 1.0) / 2.0,
            -(img->unit.unity * (float) img->unit.dimy - 1.0) / 2.0,.0);
         co1.co.reg.xyztoplane.buf[2][3] = -zratio;
         PRT8(pr_3d_matrix(&(co1.co.reg.xyztoplane)))
         inverse_4d_matrix(&(co1.co.reg.planetoxyz),&(co1.co.reg.xyztoplane));
        }
       else
        {setup_4d_matrix(&(co1.co.reg.planetoxyz),
              1.0 / info->xpixel_size,.0,.0,.0,
              .0,1.0 / info->ypixel_size,.0,.0,
              .0,.0,1.0,zratio,
              .0,.0,.0,1.0);
         setup_translate_3d_matrix(&matrix,
            (info->xpixel_size * (float) info->dimx - 1.0) / 2.0,
            (info->ypixel_size * (float) info->dimy - 1.0) / 2.0,.0);
         mult_3d_matrix(&(co1.co.reg.planetoxyz),&(co1.co.reg.planetoxyz),&matrix);
         inverse_4d_matrix(&(co1.co.reg.xyztoplane),&(co1.co.reg.planetoxyz));}

     setup_vector_3d_rec(&(co1.co.reg.rotation),.0,.0,.0);

     if (select & 2) zratio = .5;
       else zratio = ((float) regimg->cur_slice->slice_num + .5);

     if ((select & 8) && (regimg->unit.status2 & UNIT_2D_IN_USE))
        {PRT8(printf("xyztoplane...regimg->unit.status2 & UNIT_2D_IN_USE\n"))
         setup_scale_3d_matrix(&matrix,regimg->unit.unitx,
                               regimg->unit.unity,1.0);
         matrix_2d_to_3d(&mat3d,&(regimg->unit.localto_mat));
         PRT8(pr_3d_matrix(&mat3d))
         PRT8(pr_3d_matrix(&matrix))
         mult_3d_matrix(&(co2.co.reg.xyztoplane),&matrix,&mat3d);
         translate_3d_matrix(&(co2.co.reg.xyztoplane),
            -(regimg->unit.unitx * (float) regimg->unit.dimx - 1.0) / 2.0,
            -(regimg->unit.unity * (float) regimg->unit.dimy - 1.0) / 2.0,.0);
         co2.co.reg.xyztoplane.buf[2][3] = -zratio;
         PRT8(pr_3d_matrix(&(co2.co.reg.xyztoplane)))
         inverse_4d_matrix(&(co2.co.reg.planetoxyz),&(co2.co.reg.xyztoplane));
        }
       else
        {setup_4d_matrix(&(co2.co.reg.planetoxyz),
             1.0 / info1->xpixel_size,.0,.0,.0,
             .0,1.0 / info1->ypixel_size,.0,.0,
             .0,.0,1.0,zratio,
             .0,.0,.0,1.0);
         setup_translate_3d_matrix(&matrix,
            (info1->xpixel_size * (float) info1->dimx - 1.0) / 2.0,
            (info1->ypixel_size * (float) info1->dimy - 1.0) / 2.0,.0);
         mult_3d_matrix(&(co2.co.reg.planetoxyz),&(co2.co.reg.planetoxyz),&matrix);
         inverse_4d_matrix(&(co2.co.reg.xyztoplane),&(co2.co.reg.planetoxyz));
        }

     setup_vector_3d_rec(&(co2.co.reg.rotation),.0,.0,.0);
     PRT8(printf("img slice_num = %f  regimg slice_num = %f\n",
           -((float) img->cur_slice->slice_num),-((float) regimg->cur_slice->slice_num)))
     co1.co.coreg = co2.co.reg;
     co2.co.coreg = co1.co.reg;

     mult_3d_matrix(&matrix,&(co2.co.reg.planetoxyz),&(co2.co.coreg.xyztoplane));
     matrix_3d_to_2d(&(co2.coregxyztoregxyz),&matrix);
     mult_3d_matrix(&matrix,&(co1.co.reg.planetoxyz),&(co1.co.coreg.xyztoplane));
     matrix_3d_to_2d(&(co1.coregxyztoregxyz),&matrix);

     PRT8(printf("co1 .planetoxyz...\n"))
     PRT8(pr_3d_matrix(&(co1.co.reg.planetoxyz)))
     PRT8(printf(" .xyztoplane...\n"))
     PRT8(pr_3d_matrix(&(co1.co.reg.xyztoplane)))
     PRT8(printf(" .coregxyztoregxyz...\n"))
     PRT8(pr_2d_matrix(&(co1.coregxyztoregxyz)))

     PRT8(printf("co2 .planetoxyz...\n"))
     PRT8(pr_3d_matrix(&(co2.co.reg.planetoxyz)))
     PRT8(printf(" .xyztoplane...\n"))
     PRT8(pr_3d_matrix(&(co2.co.reg.xyztoplane)))
     PRT8(printf(" .coregxyztoregxyz...\n"))
     PRT8(pr_2d_matrix(&(co2.coregxyztoregxyz)))

     if (select & 4)
        {if (((err = add_file_register_rec(img->file,regimg->file,
                   &co1,NULL,which)) != NO_ERROR) ||
             ((err = add_file_register_rec(regimg->file,img->file,&co2,NULL,which)) 
                  != NO_ERROR))
            return err;
        }
     if (fco1 != NULL) *fco1 = co1;
     if (fco2 != NULL) *fco2 = co2;
    }
   else
    {
     if (fco1 != NULL) *fco1 = *coptr1;
     if (fco2 != NULL) *fco2 = *coptr2;
    }
 if (select & 4)
    {if ((coptr1 = find_file_register_rec(img->file,regimg->file,NULL,which)) != NULL)
        {coptr1->co.status |= CO_REG_PARAM_IN_USE;
         PRT8(printf("CO_REG_PARAM_IN_USE...1 = %x\n",(unsigned long) coptr1->co.status))}
 
     if ((coptr2 = find_file_register_rec(regimg->file,img->file,NULL,which)) != NULL)
        {coptr2->co.status |= CO_REG_PARAM_IN_USE;
         PRT8(printf("CO_REG_PARAM_IN_USE...2 = %x\n",(unsigned long) coptr2->co.status))}
    }
 PRT8(printf("SetupImgRegParams...end\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
UseCurrentImgRegParams - ???
--------------------------------------------------------------------------*/

int
UseCurrentImgRegParams(img,regimg)
 struct img_buf_rec *img,*regimg;
{
 struct file_register_rec *fco1,*fco2;

 PRT8(printf("UseCurrentImgRegParams...\n"))
 if (((fco1 = find_file_register_rec(img->file,regimg->file,NULL,0)) == NULL) ||
     ((fco2 = find_file_register_rec(regimg->file,img->file,NULL,0)) == NULL))
    return SetupImgRegParams(img,regimg,0x0000000c,NULL,NULL);
 PRT8(printf("fco1 status = %x...fco2 status = %x\n",
     (unsigned long) fco1->co.status,(unsigned long) fco2->co.status))
 PRT8(printf("UseCurrentImgRegParams...USE CURRENT\n"))
 return NO_ERROR;
}
