/****************************************************************************
pixel_count_anal.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: pixel_count_anal.c,v 1.13 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/notify.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)


#define ANALYSIS_ERR_SHOWN 1000
#define ANALYSIS_ERR 1001
#define ANALYSIS_OUTPUT_FORMAT_ERR 1002
#define ANALYSIS_WINDOW_SETUP_ERR 1003

struct count_anal_rec
   {
    int err;
    unsigned int num_slices;
    unsigned int total_slices;
    unsigned int cnt_slice,next_slice_num;
    double slice_mean,roi_mean;
    struct input_file_rec *file;
    struct img_rec img;
    struct matrix_2d_rec *localto;
    struct draw_mask_rec mask;
   };

struct dp_anal_rec
   {
    struct image_display_window *win;
    struct dp_anal_rec **anal_addr;
    unsigned short status;
    struct count_anal_rec canal;
    Frame frame;
    Panel panel;
    Panel_item total_processed_slices,slice_num,num_rois,roi_label;
   };


/* Functions defined in this file */
void init_count_anal_rec(struct count_anal_rec *canal);
void free_count_anal_rec(struct count_anal_rec *canal);
void check_count_anal_status(struct count_anal_rec *canal);
void CA_err_msgs(struct dp_anal_rec *anal, int err_select);
void init_dp_anal_rec(struct dp_anal_rec *anal);
void free_dp_anal_rec(struct dp_anal_rec *anal);
int free_dp_anal_rec_it(struct dp_anal_rec *anal, int which);
int compute_slice_mean(struct img_buf_rec *img, int status2,
    struct count_anal_rec *canal);
int cnt_roi_count_mean_by_mask_proc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct img_buf_rec *img,
    struct roi_count_anal_rec *roi_count, unsigned short *status2);
int cnt_pixel_count_by_mask_proc(struct buf_2d_rec *_2d, unsigned long row,
    unsigned long col, struct img_buf_rec *img,
    struct roi_count_anal_rec *roi_count, unsigned short *status2);
int cnt_pixel_count_option_by_mask_proc(struct buf_2d_rec *_2d,
    unsigned long row, unsigned long col, struct img_buf_rec *img,
    struct roi_count_anal_rec *roi_count, unsigned short *status2);
int cnt_pixel_count_by_mask(struct img_buf_rec *img, struct buf_2d_rec *mask,
    struct int_bound_rec *affected, struct roi_count_anal_rec *roi_count,
    int status2, struct count_anal_rec *canal);
int win_analyze_pixel_counts(struct dp_anal_rec *anal, int which);
void cancel_count_anal_proc(Panel_item item, Event *event);
void count_anal_done_proc(Frame frame);
int setup_anal_image_buf_size(struct dp_anal_rec *anal,
    struct unit_2d_rec *unit);
int setup_dp_anal_rec(struct dp_anal_rec *anal,
    struct dp_anal_rec **anal_addr, struct image_display_window *win,
    unsigned int num_slices, int anal_status);
int win_pixel_count_analysis(struct dp_anal_rec **anal,
    struct image_display_window *win, unsigned int num_slices,
    int anal_status);



/*-------------------------------------------------------------------------
init_count_anal_rec - ???
-------------------------------------------------------------------------*/

void
init_count_anal_rec(canal)
 struct count_anal_rec *canal;
{
 canal->err = NO_ERROR;
 init_draw_mask_rec(&(canal->mask));
 init_img_rec(&(canal->img),NULL);
}


/*-------------------------------------------------------------------------
free_count_anal_rec - ???
-------------------------------------------------------------------------*/

void
free_count_anal_rec(canal)
 struct count_anal_rec *canal;
{
 free_draw_mask_rec(&(canal->mask));
 free_img_rec(&(canal->img));
}


/*-------------------------------------------------------------------------
check_count_anal_status - ???
-------------------------------------------------------------------------*/

void
check_count_anal_status(canal)
 struct count_anal_rec *canal;
{
 if ((canal->err == NO_ERROR) &&
     (canal->cnt_slice == canal->num_slices))
    {
     canal->file->output.status |= FILE_TO_BE_SAVED;
    }
}


/*-------------------------------------------------------------------------
CA_err_msgs - ???
-------------------------------------------------------------------------*/

void
CA_err_msgs(anal,err_select)
 struct dp_anal_rec *anal;
 int err_select;
{
 Frame frame;

 if (anal->canal.err == ANALYSIS_ERR_SHOWN) return;
 if (anal->frame != 0)
    frame = (Frame) xv_get(anal->frame,WIN_OWNER);
   else frame = 0;

 if (frame == 0) frame = *(main_display(2,NULL,0,0));

 switch (err_select)
    {case ANALYSIS_ERR :
        ShowMsgStrs(frame,0,anal->canal.err,0,2,
               "An error occured when analyzing the pixel counts...",
               "Operation aborted !!!",NULL,0);
        anal->canal.err = ANALYSIS_ERR_SHOWN;
        break;
     case ANALYSIS_OUTPUT_FORMAT_ERR :
        ShowMsgStrs(frame,0,anal->canal.err,0,2,
               "An error occured when setting up the text output format...",
               "Please check your text output format !!!",NULL,0);
        anal->canal.err = ANALYSIS_ERR_SHOWN;
        break;
     case ANALYSIS_WINDOW_SETUP_ERR :
        ShowMsgStrs(frame,0,anal->canal.err,0,2,
               "An error occured when setting up the count analysis window...",
               "Probably out of memory !!!",NULL,0);
        anal->canal.err = ANALYSIS_ERR_SHOWN;
        break;
    }
}


/*-------------------------------------------------------------------------
init_dp_anal_rec - ???
-------------------------------------------------------------------------*/

void
init_dp_anal_rec(anal)
 struct dp_anal_rec *anal;
{
 init_count_anal_rec(&(anal->canal));
 anal->status = 0;
 anal->frame = 0;
}


/*-------------------------------------------------------------------------
free_dp_anal_rec - ???
-------------------------------------------------------------------------*/

void
free_dp_anal_rec(anal)
 struct dp_anal_rec *anal;
{
 TRACE(printf("free_dp_anal_rec...\n"))

 if (anal->frame != 0)
    {TRACE(printf("destroy...\n"))
     xv_destroy_safe(anal->frame);}
 *(anal->anal_addr) = NULL;
 free_count_anal_rec(&(anal->canal));
 c_free(anal);
}


/*-------------------------------------------------------------------------
free_dp_anal_rec_it - ???
-------------------------------------------------------------------------*/

int
free_dp_anal_rec_it(anal,which)
 struct dp_anal_rec *anal;
 int which;
{
 (void) notify_set_itimer_func((Notify_client) anal,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 TRACE(pr_count_analysis_rec(&(anal->canal.file->count)))
 if (anal->canal.err == NO_ERROR)
    win_update_ca_options(anal->win);
 free_dp_anal_rec(anal);
 return XV_OK;
}


/*-------------------------------------------------------------------------
compute_slice_mean - ???
-------------------------------------------------------------------------*/

int
compute_slice_mean(img,status2,canal)
 struct img_buf_rec *img;
 unsigned short status2;
 struct count_anal_rec *canal;
{
 struct img_buf_rec *temp_img;
 double val;
 unsigned long row,col,num_pixels;

 canal->slice_mean = .0;
 num_pixels = 0;
 temp_img = img;
/*
 is_use = img->file->hdr.data_info.var_use_status & ACTUAL_PIXVAL_MIN_USED;
*/
 do
    {
     for (row = 0; row < temp_img->_2d.dimy; row++)
        for (col = 0; col < temp_img->_2d.dimx; col++)
           {val = temp_img->_2d.GetVal(&(temp_img->_2d),row,col);
/*
            if (is_use)
               val += (double) img->file->hdr.data_info.actual_pixval_min;
*/
            if (val < 0)
               {if (!(status2 & OUT_FORMAT_COUNT_NEG)) val = 0;}
            if (status2 & OUT_FORMAT_POS_NEG_ECHOES)
               if (temp_img != img) val = -val;
            canal->slice_mean += val;
           }
     num_pixels += (temp_img->_2d.dimy * temp_img->_2d.dimx);
     if (status2 & OUT_FORMAT_COUNT_ONCE) break;
     temp_img = temp_img->partner;
    }
 while (temp_img != img);
 canal->slice_mean /= (double) num_pixels;
 PRT1(printf("status2 = %x slice_mean = %f num_pixels = %d\n",(unsigned long) status2,canal->slice_mean,num_pixels))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cnt_roi_count_mean_by_mask_proc - ???
-------------------------------------------------------------------------*/

int
cnt_roi_count_mean_by_mask_proc(_2d,row,col,img,roi_count,status2)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 struct img_buf_rec *img;
 struct roi_count_anal_rec *roi_count;
 unsigned short *status2;
{
 struct img_buf_rec *temp_img;
 double val;

 temp_img = img;
 do
    {
     val = temp_img->_2d.GetVal(&(temp_img->_2d),row,col);
/*
     if (img->file->hdr.data_info.var_use_status & ACTUAL_PIXVAL_MIN_USED)
        val += (double) img->file->hdr.data_info.actual_pixval_min;
*/
     if (val < 0)
        {if (!(*status2 & OUT_FORMAT_COUNT_NEG)) val = 0;}
     if (*status2 & OUT_FORMAT_POS_NEG_ECHOES)
        if (temp_img != img) val = -val;
     roi_count->num_pixels += 1;
     roi_count->roi_mean += val;

     if (*status2 & OUT_FORMAT_COUNT_ONCE) break;
     temp_img = temp_img->partner;
    }
 while (temp_img != img);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cnt_pixel_count_by_mask_proc - ???
-------------------------------------------------------------------------*/

int
cnt_pixel_count_by_mask_proc(_2d,row,col,img,roi_count,status2)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 struct img_buf_rec *img;
 struct roi_count_anal_rec *roi_count;
 unsigned short *status2;
{
 struct img_buf_rec *temp_img;
 double val;

 temp_img = img;
 do
    {
     val = temp_img->_2d.GetVal(&(temp_img->_2d),row,col);
/*
     if (img->file->hdr.data_info.var_use_status & ACTUAL_PIXVAL_MIN_USED)
        val += (double) img->file->hdr.data_info.actual_pixval_min;
*/
     if (val < 0)
        {roi_count->cnt_neg_val += 1;
         if (!(*status2 & OUT_FORMAT_COUNT_NEG)) val = 0;}

     if (roi_count->min > roi_count->max)
        roi_count->min = roi_count->max = val;
       else if (roi_count->min > val) roi_count->min = val;
       else if (roi_count->max < val) roi_count->max = val;
     roi_count->num_pixels += 1;
     roi_count->total_counts += val;
     roi_count->sd += val * val;
     temp_img = temp_img->partner;
    }
 while (temp_img != img);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cnt_pixel_count_option_by_mask_proc - ???
-------------------------------------------------------------------------*/

int
cnt_pixel_count_option_by_mask_proc(_2d,row,col,img,roi_count,status2)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 struct img_buf_rec *img;
 struct roi_count_anal_rec *roi_count;
 unsigned short *status2;
{
 struct img_buf_rec *temp_img;
 double val,val1;
 static struct roi_count_anal_rec *temp = NULL;

 temp_img = img;
 do
    {
     val = temp_img->_2d.GetVal(&(temp_img->_2d),row,col);
     if (*status2 & OUT_FORMAT_POS_NEG_ACTIVATION_ECHOES)
        {if (val == 0)
            {val1 = temp_img->partner->_2d.GetVal(&(temp_img->partner->_2d),row,col);
             if (val1 != 0) val = -val1;}
        }
/*
       else if (img->file->hdr.data_info.var_use_status & ACTUAL_PIXVAL_MIN_USED)
        val += (double) img->file->hdr.data_info.actual_pixval_min;
*/
       else if (temp != roi_count)
        {
         PRT1(printf("status2 = %x num_pixels = %d\n",(unsigned long) *status2,
              roi_count->num_pixels))
        }
     if (val < 0)
        {roi_count->cnt_neg_val += 1;
         if (!(*status2 & OUT_FORMAT_COUNT_NEG)) val = 0;}

     if (*status2 & OUT_FORMAT_COUNT_OPTIONS)
        {if (*status2 & OUT_FORMAT_COUNT_LT_GT_PERCENT_OPTIONS)
            {val1 = val;
             if (*status2 & OUT_FORMAT_LT_PERCENT_MEAN)
                {if (val1 < roi_count->min_smean_threshold)
                    {roi_count->cnt_smean_min_rej += 1;
                     val = 0;}
                }
               else if (*status2 & OUT_FORMAT_GT_PERCENT_MEAN)
                {if (val1 > roi_count->max_smean_threshold) 
                    {roi_count->cnt_smean_max_rej += 1;
                     val = 0;}
                }
             if (*status2 & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
                {if (val1 < roi_count->min_rmean_threshold) 
                    {roi_count->cnt_rmean_min_rej += 1;
                     val = 0;}
                }
               else if (*status2 & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
                {if (val1 > roi_count->max_rmean_threshold) 
                    {roi_count->cnt_rmean_max_rej += 1;
                     val = 0;}
                }
            }
         if (*status2 & OUT_FORMAT_POS_NEG_ECHOES)
            if (temp_img != img) val = -val;
        }
     if (roi_count->min > roi_count->max)
        roi_count->min = roi_count->max = val;
       else if (roi_count->min > val) roi_count->min = val;
       else if (roi_count->max < val) roi_count->max = val;
     roi_count->num_pixels += 1;
     roi_count->total_counts += val;
     roi_count->sd += val * val;
     if (*status2 & OUT_FORMAT_COUNT_ONCE) 
       {if (temp != roi_count)
           {temp = roi_count;
            PRT1(printf("OUT_FORMAT_COUNT_ONCE status2 = %x num_pixels = %d\n",(unsigned long) *status2,
              roi_count->num_pixels))}
        break;
       }
     if (temp != roi_count)
        {temp = roi_count;
         PRT1(printf("not once status2 = %x num_pixels = %d\n",(unsigned long) *status2,
              roi_count->num_pixels))}
     temp_img = temp_img->partner;
    }
 while (temp_img != img);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cnt_pixel_count_by_mask - ???
-------------------------------------------------------------------------*/

int
cnt_pixel_count_by_mask(img,mask,affected,roi_count,status2,canal)
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
 struct int_bound_rec *affected;
 struct roi_count_anal_rec *roi_count;
 unsigned short status2;
 struct count_anal_rec *canal;
{
 double dval;

 roi_count->min = 0;
 roi_count->max = -1;
 PRT1(printf("cnt_pixel status2 = %x snum = %d enum = %d scnum = %d\n",
      (unsigned long) status2,img->cur_slice->slice_num,
      img->cur_slice->echo_num,img->cur_slice->scan_num))

 if (status2 & OUT_FORMAT_COUNT_LT_GT_PERCENT_OPTIONS)
    {if (status2 & OUT_FORMAT_LT_PERCENT_MEAN)
        {roi_count->slice_mean = canal->slice_mean;
         roi_count->min_smean_threshold = 
           img->file->count.format.lt_percent * roi_count->slice_mean / 100.0;}
     if (status2 & OUT_FORMAT_GT_PERCENT_MEAN)
        {roi_count->slice_mean = canal->slice_mean;
         roi_count->max_smean_threshold = 
              img->file->count.format.gt_percent * roi_count->slice_mean / 100.0;}
     PRT1(printf("slice_mean = %f min = %f max = %f\n",
          roi_count->slice_mean,roi_count->min_smean_threshold,
              roi_count->max_smean_threshold))
     if (status2 & OUT_FORMAT_COUNT_ROI_LT_GT_PERCENT_OPTIONS)
        {
         process_buf_2d_rec_by_mask(&(img->_2d),0,0,mask,affected,
           cnt_roi_count_mean_by_mask_proc,img,roi_count,&status2,0,0,0,0,0,0);
         if (roi_count->num_pixels > 0)
            roi_count->roi_mean = roi_count->roi_mean / roi_count->num_pixels;
         PRT1(printf("roi_mean = %f num_pixels = %d\n",
              roi_count->roi_mean,roi_count->num_pixels))

         roi_count->num_pixels = 0;
         if (status2 & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
            roi_count->cnt_rmean_min_rej = roi_count->roi_mean * 
                    img->file->count.format.roi_lt_percent / 100.0;
         if (status2 & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
            roi_count->cnt_rmean_max_rej = roi_count->roi_mean * 
                    img->file->count.format.roi_gt_percent / 100.0;
        }
    }
 if (status2 & OUT_FORMAT_COUNT_ECHO_AND_REJECTION_METHOD)
    {PRT1(printf("cnt_pixel_count_option_by_mask_proc...\n"))
     process_buf_2d_rec_by_mask(&(img->_2d),0,0,mask,affected,
           cnt_pixel_count_option_by_mask_proc,img,roi_count,&status2,
           0,0,0,0,0,0);}
   else 
    {PRT(printf("cnt_pixel_count_by_mask_proc...\n"))
     process_buf_2d_rec_by_mask(&(img->_2d),0,0,mask,affected,
           cnt_pixel_count_by_mask_proc,img,roi_count,&status2,0,0,0,0,0,0);}

 PRT1(printf("cnt_pixel min = %f max = %f cnt mask = %d  num_pixels = %d\n",
       roi_count->min,roi_count->max,CntNonValBuf2dRec(mask,(double) 0),
       roi_count->num_pixels))
 if (roi_count->num_pixels == 0)
    {roi_count->min = roi_count->max = 0;
     roi_count->sd = .0;}
   else if (roi_count->num_pixels == 1)
    roi_count->sd = .0;
   else
    {dval = roi_count->total_counts * roi_count->total_counts / 
            (double) roi_count->num_pixels;
     dval = (roi_count->sd - dval) / (double) (roi_count->num_pixels - 1);
     roi_count->sd = sqrt(dval);}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_analyze_pixel_counts - ???
-------------------------------------------------------------------------*/

int
win_analyze_pixel_counts(anal,which)
 struct dp_anal_rec *anal;
 int which;
{
 struct int_bound_rec affected;
 struct img_buf_rec *img;
 unsigned int cnt,num,slice_num;
 struct slice_roi_rec *slice_roi;
 char slice_num_str[10];
 struct input_file_rec *file;
 int err1;
 struct roi_rec *roi;
 struct slice_count_anal_rec *slice_count;

 TRACE(printf("win_analyze_pixel_counts...begin\n"))

 file = anal->canal.file;
 img = anal->canal.img.data[0];
 if (file->count.format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
    {if (img->file->count.echo_num != img->cur_slice->echo_num)
        LocateSlice(img,img->cur_slice->slice_num,
             img->cur_slice->scan_num,img->file->count.echo_num);}
   else LocateAllSliceEchoes(img,img->cur_slice->slice_num,
             img->cur_slice->scan_num,0);
  PRT1(printf("\nwin_analyze snum = %d enum = %d scnum = %d\n",
      img->cur_slice->slice_num,
      img->cur_slice->echo_num,img->cur_slice->scan_num))

 slice_roi = &(img->cur_slice->slice->slice_roi_win->slice_roi);
 num = img->cur_slice->num;
 slice_num = img->cur_slice->slice_num;
 if (anal->frame != 0)
    {xv_set(anal->total_processed_slices,PANEL_VALUE,
               anal->canal.cnt_slice + 1,0);
     sprintf(slice_num_str,"%d",num);
     xv_set(anal->slice_num,PANEL_VALUE,slice_num_str,0);
    }
 if (slice_roi->num_rois == 0)
    {if (anal->frame != 0)
        {xv_set(anal->num_rois,PANEL_MAX_VALUE,0,0);
         xv_set(anal->roi_label,PANEL_VALUE,"",0);}
    }
   else
    {
     if (anal->frame != 0)
        xv_set(anal->num_rois,PANEL_MAX_VALUE,slice_roi->num_rois,0);

     PRT1(printf("before setup_slice_count_anal_rec\n"))
     if ((anal->canal.err = setup_slice_count_anal_rec(&(file->count),
             slice_num)) == NO_ERROR)
        {slice_count = &(file->count.slices[slice_num]);
         PRT1(printf("before RdSlice slice_num = %d\n",slice_num))
         if (slice_count->num_rois > 0)
            if (file->count.format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
               {anal->canal.err = RdSlice(img,0,NULL,4);
                PRT1(printf("after RdSlice\n"))}
              else 
               {anal->canal.err = RdCurSliceEchoes(img,1,4);
                PRT1(printf("after RdCurSliceEchoes\n"))}
        }
     if (anal->canal.err != NO_ERROR)
        {(void) notify_set_itimer_func((Notify_client) anal,
               NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
         err1 = anal->canal.err;
         notify_set_itimer_func((Notify_client) anal,
             (Notify_func) free_dp_anal_rec_it,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
         return err1;}

     if ((slice_count->num_rois > 0) &&
         (file->count.format.status & OUT_FORMAT_COUNT_SLICE_LT_GT_PERCENT_OPTIONS))
        compute_slice_mean(img,file->count.format.status,&(anal->canal));
     for (cnt = 0; cnt < slice_count->num_rois; cnt++)
        {
         if (anal->frame != 0)
            {if (anal->num_rois)
                xv_set(anal->num_rois,PANEL_VALUE,cnt + 1,0);
             if (anal->roi_label != 0)
                {xv_set(anal->roi_label,PANEL_VALUE,
                        slice_count->rois[cnt].label,0);
                 win_flush(anal->frame);}
            }
         if ((roi = get_roi(slice_roi,slice_count->rois[cnt].label)) == NULL)
            continue;

         PRT1(printf("s#%d %d) label = %s \n",
            anal->canal.next_slice_num,cnt,roi->label))

         if (((anal->canal.err = GetFilledRoiMask(roi,anal->canal.localto,
                        &(anal->canal.mask),&affected)) != NO_ERROR) ||
             ((anal->canal.err = 
                     cnt_pixel_count_by_mask(img,
                         &(anal->canal.mask.mask._2d),&affected,
                         &(slice_count->rois[cnt]),file->count.format.status,
                         &(anal->canal))) != NO_ERROR))
            {break;}
         slice_count->status1 |= COUNT_VALID;
        }
     TRACE(printf("correct_slice_counts...\n"))
    }

 if ((anal->canal.err != NO_ERROR) ||
     (anal->canal.cnt_slice < anal->canal.num_slices))
    {anal->canal.cnt_slice += 1;
     anal->canal.next_slice_num += 1;
     if (anal->canal.next_slice_num >= anal->canal.total_slices)
        anal->canal.next_slice_num = 0;
     img->cur_slice = img->cur_slice->next_slice;
    }
 check_count_anal_status(&(anal->canal));
 if (anal->canal.err != NO_ERROR) 
    CA_err_msgs(anal,ANALYSIS_ERR);

 TRACE(printf("*****anal->canal.cnt_slice = %d anal->canal.num_slices = %d err = %d\n",
            anal->canal.cnt_slice,
            anal->canal.num_slices,anal->canal.err))
 if ((anal->canal.err != NO_ERROR) ||
     (anal->canal.cnt_slice == anal->canal.num_slices))
    {
     (void) notify_set_itimer_func((Notify_client) anal,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
     err1 = anal->canal.err;
     notify_set_itimer_func((Notify_client) anal,
             (Notify_func) free_dp_anal_rec_it,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
     return err1;}
   else return anal->canal.err;
}


/*-------------------------------------------------------------------------
cancel_count_anal_proc - ???
-------------------------------------------------------------------------*/

void
cancel_count_anal_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct dp_anal_rec *anal;

 anal = (struct dp_anal_rec *) panel_get(item,PANEL_CLIENT_DATA);
 (void) notify_set_itimer_func((Notify_client) anal,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 notify_set_itimer_func((Notify_client) anal,
             (Notify_func) free_dp_anal_rec_it,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
}


/*-------------------------------------------------------------------------
count_anal_done_proc - ???
-------------------------------------------------------------------------*/

void
count_anal_done_proc(frame)
 Frame frame;
{
 struct dp_anal_rec *anal;

 anal = (struct dp_anal_rec *) xv_get(frame,WIN_CLIENT_DATA);
 (void) notify_set_itimer_func((Notify_client) anal,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 free_dp_anal_rec(anal);
}


/*-------------------------------------------------------------------------
setup_anal_image_buf_size - ???
-------------------------------------------------------------------------*/

int
setup_anal_image_buf_size(anal,unit)
 struct dp_anal_rec *anal;
 struct unit_2d_rec *unit;
{
 struct img_buf_rec *temp,*cur;
 struct data_info_rec *info;
 int err;

 if (anal->canal.img.num_data == 0) return CANCEL;
 PRT2(printf("setup_anal_image_buf_size...\n"))
 cur = temp = anal->canal.img.data[0];
 info = &(cur->file->hdr.data_info);
 do 
    {if ((err = SetupBuf2dRec(&(temp->_2d),unit->dimx,unit->dimy,
          info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR)
        return err;
     temp->unit = *unit;
     PRT2(pr_buf_2d_rec(&(temp->_2d)))
/*
     if (info->var_use_status & INPUT_DATA_TYPE)
        set_buf_data_type(&(temp->_2d),info);
*/
     temp = temp->partner;
    }
 while (temp != cur);
 PRT2(printf("setup_anal_image_buf_size...NO_ERROR\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_dp_anal_rec - ???
-------------------------------------------------------------------------*/

int
setup_dp_anal_rec(anal,anal_addr,win,num_slices,anal_status)
 struct dp_anal_rec *anal,**anal_addr;
 struct image_display_window *win;
 unsigned int num_slices;
 unsigned short anal_status;
{
 struct img_buf_rec *img;
 int err,row,offset;
 char *str;
 Rect *rr;
 struct count_analysis_rec *count;
 struct unit_2d_rec *unit;

 anal->win = win;
 anal->anal_addr = anal_addr;
 anal->canal.num_slices = num_slices;
 anal->status = anal_status;
 img = win_rec_cur_img_buf(win->owner);
 if (img == NULL) return CANCEL;
 anal->canal.img.file = img->file;
 if (NewImgBuf(&(anal->canal.img),img->cur_slice,&err,0,0,0,0,0,0,1) == 0)
    {return err;}

 anal->canal.cnt_slice = 0;
 anal->canal.file = img->file;
 anal->canal.next_slice_num = 
           anal->canal.img.data[0]->cur_slice->slice_num;
 anal->canal.total_slices = win_total_slice_cuts(win->owner);
 if (img->unit.status2 & UNIT_2D_IN_USE)
    unit = &(img->unit);
   else unit = NULL;
 count = &(anal->canal.file->count);
 if ((err = setup_count_output_format(count,unit)) != NO_ERROR)
    {CA_err_msgs(anal,ANALYSIS_OUTPUT_FORMAT_ERR);
     return err;}

 if (!(count->format.status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW) &&
      (count->format.status & OUT_FORMAT_UNIT_2D_VALID))
    {PRT2(printf("OUT_FORMAT_UNIT_2D_VALID...\n"))
     if ((err = setup_anal_image_buf_size(anal,&(count->format.img_unit))) !=
           NO_ERROR)
        {CA_err_msgs(anal,ANALYSIS_OUTPUT_FORMAT_ERR);
         return err;}
     anal->canal.localto = &(count->format.img_unit.localto_mat);
    }
   else anal->canal.localto = NULL;
 if (anal->canal.file->count.format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
    {anal->canal.file->count.echo_num = img->cur_slice->echo_num;
     PRT1(printf("setup_dp_anal_rec...echo_num = %d\n",anal->canal.file->count.echo_num))}
 PRT2(printf("img.data[0]->_2d...\n"))
 PRT2(pr_buf_2d_rec(&(anal->canal.img.data[0]->_2d)))
 if ((err = get_draw_mask_rec(&(anal->canal.mask),
           anal->canal.img.data[0]->_2d.dimx,
           anal->canal.img.data[0]->_2d.dimy)) != NO_ERROR)
    return err;

 anal->frame = xv_create(win->dwin->frame,FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              FRAME_NO_CONFIRM,TRUE,0);
 if (anal->frame == 0) return NO_ERROR;
 str = win_rec_win_id_title(win->owner,PIXEL_TYPE_CA_STR);
 xv_set(anal->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_DONE_PROC,count_anal_done_proc,
              WIN_CLIENT_DATA,anal,
              0);
 c_free(str);

 anal->panel = xv_create(anal->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (anal->panel == 0)
    {xv_destroy_safe(anal->frame);
     anal->frame = 0;
     return NO_ERROR;}
 row = 5;
 offset = xv_rows(anal->panel,1) - xv_rows(anal->panel,0) - 10;
 anal->total_processed_slices =
     xv_create(anal->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"SLICES PROCESSED",
	PANEL_VALUE,0,PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,num_slices,
	PANEL_SLIDER_WIDTH,50,
        XV_X,5,XV_Y,row,
	0);
 row += offset;
 anal->slice_num = xv_create(anal->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"CURRENT SLICE # = ",
              PANEL_VALUE,"",
              PANEL_VALUE_STORED_LENGTH,10,
              PANEL_VALUE_DISPLAY_LENGTH,10,
        XV_X,5,XV_Y,row,
	0);

 str = "CANCEL";
 xv_create(anal->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,cancel_count_anal_proc,
                   PANEL_CLIENT_DATA,anal,
                   XV_Y,row,
                   0);

 row += offset;
 anal->num_rois =
     xv_create(anal->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"# OF ROIS PROCESSED",
	PANEL_VALUE,0,PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,0,
	PANEL_SLIDER_WIDTH,50,
        XV_X,5,XV_Y,row,
	0);
 row += offset;
 anal->roi_label = xv_create(anal->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"CURRENT ROI LABEL = ",
              PANEL_VALUE,"",
              PANEL_VALUE_STORED_LENGTH,60,
              PANEL_VALUE_DISPLAY_LENGTH,25,
        XV_X,5,XV_Y,row,
	0);
 rr = (Rect *) xv_get(anal->roi_label,XV_RECT);
 xv_set(anal->panel,XV_WIDTH,rr->r_left + rr->r_width + 5,
           XV_HEIGHT,rr->r_top + rr->r_height + 5,0);
 window_fit(anal->frame);
 make_2_wins_adjacent(anal->frame,win->dwin->frame,0);
 xv_set(anal->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 xv_set(anal->frame,WIN_CLIENT_DATA,anal,0);
 xv_set(anal->frame,XV_KEY_DATA,1,anal,
        XV_KEY_DATA,2,win_analyze_pixel_counts,XV_KEY_DATA,3,1,0);

 notify_interpose_event_func((Notify_client) anal->frame,
          (Notify_func) next_func,NOTIFY_SAFE);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_pixel_count_analysis - ???

FIXME!! See win_analysis() for an explanation of a serious problem in this
function and its users.  -PWH 19990527
-------------------------------------------------------------------------*/

int
win_pixel_count_analysis(anal,win,num_slices,anal_status)
 struct dp_anal_rec **anal;
 struct image_display_window *win;
 unsigned int num_slices;
 unsigned short anal_status;
{
 int err;

 if ((err = get_ptr(anal,NULL,(unsigned int) 1,
      (size_t) sizeof(**anal))) != NO_ERROR)
    return err;
 init_dp_anal_rec(*anal);

 TRACE(printf("format...roi_labels\n"))
 if ((err = setup_dp_anal_rec(*anal,anal,win,num_slices,
               anal_status)) != NO_ERROR)
    {CA_err_msgs(*anal,ANALYSIS_WINDOW_SETUP_ERR);
     free_dp_anal_rec(*anal);
     return err;
    }
 return NO_ERROR;
}
     

