/****************************************************************************
pixel_selection.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: pixel_selection.c,v 1.12 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "buf_2d_val_rec.h"
#include "object.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)



#define CLOSE_UPON_OWNER_REQUEST 1
struct win_pix_sel_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item lb,ub,which_region,use_pixel_values,mean_sd;
    Panel_item selected_pixel_cnt,options,label,follow_contrast;

    struct hdr_scan_entry_rec *cur_slice;
    unsigned last_lb,last_ub;
    struct buf_2d_val_rec echo;
   };

struct all_win_pix_sel_rec_recs
   {
    int num_pixs;
    struct win_pix_sel_rec **pixs;
   };

#define CLEAN_UP_PIXEL_SELECTION 0
#define SETUP_PIXEL_SELECTION 1
#define BRING_UP_PIXEL_SELECTION 2
#define UPDATE_PIXEL_SELECTION_MENU 3
#define GET_PIXEL_SELECTION_PTR 4

#define SELECTED_TO_CUR_ROI 0


/* Functions defined in this file */
void init_win_pix_sel_rec(struct win_pix_sel_rec *pixel);
void free_win_pix_sel_rec(struct win_pix_sel_rec *pixel);
void init_all_win_pix_sel_rec_recs(struct all_win_pix_sel_rec_recs *all_pixs);
int win_selected_pixel_initial_settings(struct image_display_window *win);
int win_setup_pix_sel_rec(struct image_display_window *win, unsigned int lb,
    unsigned int ub);
int whole_slice_proc(Panel_item item, Event *event);
void cur_curve_proc(Panel_item item, Event *event);
void cur_roi_proc(Panel_item item, Event *event);
void all_rois_proc(Panel_item item, Event *event);
void notify_which_region_proc(Panel_item item, Event *event);
int pixel_mean_sd(struct win_pix_sel_rec *pixel);
int pixel_mean_sd_proc(Panel_item item, Event *event);
void set_which_region_proc(Panel_item item, int value, Event *event);
int define_lb_ub(struct win_pix_sel_rec *pixel);
void use_which_value_proc(Panel_item item, int value, Event *event);
void pix_sel_help_proc(Panel_item item, Event *event);
void validate_item_values(struct win_pix_sel_rec *pixel, Panel_item item);
int notify_pixel_proc(Panel_item item, int value, Event *event);
void pix_sel_done_proc(Frame frame);
void follow_contrast_proc(Panel_item item, Event *event);
int pixel_roi_to_histo_roi_proc(struct display_win_rec *dwin, char *label);
/* FIXME:  Should that be *event in the next two lines? -PWH 19990421 */
int pix_sel_make_histo_roi_proc(Panel_item item, Event event);
int pix_sel_add_to_cur_roi_proc(Panel_item item, Event event);
int pixel_map_options_proc(Panel_item item, Event event);
int pixel_setup_buf_2d_val_rec(struct win_pix_sel_rec *pixel);
int setup_pix_sel_proc(struct win_pix_sel_rec *pixel,
    struct image_display_window *win);
struct win_pix_sel_rec *find_win_pix_sel_rec(
   struct all_win_pix_sel_rec_recs *all_pixs,
    struct image_display_window *win);
void update_pix_sel_menu(struct win_pix_sel_rec *pixel);
void update_menus(struct image_display_window *win);
int setup_shared_and_pixel_selected_buf(struct image_display_window *win);
int win_and_selected_pixels(struct image_display_window *win);
void select_the_pixel_values(struct win_pix_sel_rec *pixel,
    struct buf_2d_rec *mask, unsigned long lb, unsigned long ub,
    unsigned long value);
void select_pixel_values(struct win_pix_sel_rec *pixel,
    struct buf_2d_rec *mask);
int win_slice_select_pixels(struct image_display_window *win);
int win_select_pixels(struct image_display_window *win);
int copy_selected_data(struct image_display_window *win);
int paste_selected_pixels(struct image_display_window *win);
void setup_pixel_selection(struct image_display_window *win);


/* (Known) local functions */
static struct all_win_pix_sel_rec_recs *enter_pixel_selection(
    struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_win_pix_sel_rec - ???
-------------------------------------------------------------------------*/

void
init_win_pix_sel_rec(pixel)
 struct win_pix_sel_rec *pixel;
{
 pixel->status = 0;
 pixel->win = NULL;
 pixel->frame = 0;
 pixel->cur_slice = NULL;
 init_buf_2d_val_rec(&(pixel->echo));
}


/*-------------------------------------------------------------------------
free_win_pix_sel_rec - ???
-------------------------------------------------------------------------*/

void
free_win_pix_sel_rec(pixel)
 struct win_pix_sel_rec *pixel;
{
 struct all_win_pix_sel_rec_recs *all_pixs;

 if (pixel->frame != 0)
    {xv_destroy_safe(pixel->frame);
     destroy_all_subframes(pixel->frame);}

 pixel->win->data.selection.status &= ~PIXEL_SELECTION_MASK_READY;
 pixel->win->data.selection.status &= ~PIXEL_SELECTION_LB_UB_SET;
 free_buf_2d_val_rec(&(pixel->echo));

 win_execute_proc_to_partner_wins(pixel->win,win_free_pixel_selection_rec,0,0);
 win_execute_proc_to_partner_wins(pixel->win,win_redisplay_all_curves,0,0);
 c_free(pixel); 

 all_pixs = enter_pixel_selection(NULL,GET_PIXEL_SELECTION_PTR);
 DropHandleAryPtr(&(all_pixs->pixs),&(all_pixs->num_pixs),pixel);
 TRACE(printf("free_win_pix_sel_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_win_pix_sel_rec_recs - ???
-------------------------------------------------------------------------*/

void
init_all_win_pix_sel_rec_recs(all_pixs)
 struct all_win_pix_sel_rec_recs *all_pixs;
{
 all_pixs->num_pixs = 0;
 all_pixs->pixs = NULL;
}


/*-------------------------------------------------------------------------
win_selected_pixel_initial_settings - ???
-------------------------------------------------------------------------*/

int
win_selected_pixel_initial_settings(win)
 struct image_display_window *win;
{
 struct list_rec *next,*cur;
 struct image_display_window *first;
 struct buf_2d_rec *_2d;
 int err;

 cur = next = head_list(&(win->partner));
 if ((_2d = win_rec_cur_data_buf(win->owner,win->type2)) == NULL)
    return CANCEL;
 if (next != NULL)
    do
       {
        if ((first = list_item(next,0)) != NULL)
           {if ((err = SetupBuf2dRec(&(first->data.selection.selected_pixel),
                _2d->dimx,_2d->dimy,1,0)) != NO_ERROR)
               return err;
            first->data.selection.selected_pixel.status4 &= ~BUF_DATA_VALID;
            first->data.selection.status &= ~PIXEL_SELECTION_MASK_READY;
            first->data.selection.status |= PIXEL_SELECTION_SETUP_OK;
            TRACE(pr_buf_2d_rec(&(first->data.selection.selected_pixel)));}
        next = next->next;
       }
    while (cur != next);

 TRACE(printf("win_selected_pixel_initial_settings\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_setup_pix_sel_rec - ???
-------------------------------------------------------------------------*/

int
win_setup_pix_sel_rec(win,lb,ub)
 struct image_display_window *win;
 unsigned int lb,ub;
{
 struct pixel_selection_rec *selection;
 struct buf_2d_rec *_2d;
 int err;
 struct image_display_window **wins;

 if ((_2d = win_rec_cur_data_buf(win->owner,win->type2)) == NULL)
    return CANCEL;
 wins = win->control.sroi.sroi_win->wins;
 if ((err = win_selected_pixel_initial_settings(win)) != NO_ERROR) return err;

 selection = &(win->data.selection);
 selection->lb = lb;
 selection->ub = ub;
 selection->status |= PIXEL_SELECTION_LB_UB_SET | PIXEL_SELECTION_LB_UB_EXIST;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
whole_slice_proc - ???
-------------------------------------------------------------------------*/

int
whole_slice_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;
 unsigned int lb,ub;
 int err;

 TRACE(printf("whole_slice_proc...\n"))
 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;

 TRACE(printf("whole_slice_proc..begin 1\n"))
 lb = (unsigned int) xv_get(pixel->lb,PANEL_VALUE);
 ub = (unsigned int) xv_get(pixel->ub,PANEL_VALUE);
 win->data.selection.status = PIXEL_SELECTION_WHOLE_SLICE;

 if ((err = win_setup_pix_sel_rec(win,lb,ub)) != NO_ERROR) return err;
 if (!(pixel->status & PIXEL_SELECTION_WHOLE_SLICE))
    {InitBuf2dRecData(&(pixel->win->data.selection.selected_pixel),(double) .0);
     pixel->last_lb = 1;
     pixel->last_ub = 0;}
 pixel->status &= ~PIXEL_SELECTION_MASK_READY;
 pixel->status |= PIXEL_SELECTION_WHOLE_SLICE;

 win_execute_proc_to_partner_wins(win,win_slice_select_pixels,0,0);
 TRACE(printf("whole_slice_proc...\n"))
 win_and_selected_pixels(win);
 update_menus(win);

 win_execute_proc_to_partner_wins(win,win_redisplay_all_curves,0,0);
 TRACE(printf("whole_slice_proc..end\n"))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cur_curve_proc - ???
-------------------------------------------------------------------------*/

void
cur_curve_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 struct roi_rec *roi;
 struct curve_2d_rec *pen;
 struct curve_rec *cur_curve;
 struct image_display_window *win;
 unsigned int lb,ub;
 int err;

 TRACE(printf("cur_curve_proc...begin\n"))

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;

 if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)))
            == NULL) return;
 if ((pen = get_cur_pen(&(win->control.sroi.sroi_win->slice_roi)))
            == NULL) return;
 cur_curve = get_cur_curve(&(win->control.sroi.sroi_win->slice_roi));
 if (cur_curve == NULL) return;

 lb = (unsigned int) xv_get(pixel->lb,PANEL_VALUE);
 ub = (unsigned int) xv_get(pixel->ub,PANEL_VALUE);

 win->data.selection.status = PIXEL_SELECTION_CUR_CURVE;
 TRACE(printf("cur_curve_proc...1\n"))
 if ((err = win_setup_pix_sel_rec(win,lb,ub)) != NO_ERROR)
     return /*err*/;
 if (!(pixel->status & PIXEL_SELECTION_CUR_CURVE))
    {InitBuf2dRecData(&(pixel->win->data.selection.selected_pixel),(double) .0);
     pixel->last_lb = 1;
     pixel->last_ub = 0;}
 pixel->status &= ~PIXEL_SELECTION_MASK_READY;
 pixel->status |= PIXEL_SELECTION_CUR_CURVE;

 xv_set(pixel->frame,FRAME_BUSY,TRUE,0);
 win_execute_proc_to_partner_wins(win,win_select_pixels,0,0);
 win_and_selected_pixels(win);
 TRACE(printf("cur_curve_proc...3\n"))
 update_menus(win);
 xv_set(pixel->frame,FRAME_BUSY,FALSE,0);
 win_execute_proc_to_partner_wins(win,win_redisplay_all_curves,0,0);

 TRACE(printf("cur_curve_proc...end\n"))
}


/*-------------------------------------------------------------------------
cur_roi_proc - ???
-------------------------------------------------------------------------*/

void
cur_roi_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 struct roi_rec *roi;
 struct image_display_window *win;
 unsigned int lb,ub;
 int err;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;
 if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi))) == NULL)
     return;
 TRACE(printf("cur_roi_proc after get_cur_roi...\n"))
 lb = (unsigned int) xv_get(pixel->lb,PANEL_VALUE);
 ub = (unsigned int) xv_get(pixel->ub,PANEL_VALUE);
 win->data.selection.status = PIXEL_SELECTION_CUR_ROI;
 if ((err = win_setup_pix_sel_rec(win,lb,ub)) != NO_ERROR)
     return /*err*/;
 if (!(pixel->status & PIXEL_SELECTION_CUR_ROI))
    {InitBuf2dRecData(&(pixel->win->data.selection.selected_pixel),(double) .0);
     pixel->last_lb = 1;
     pixel->last_ub = 0;}
 pixel->status &= ~PIXEL_SELECTION_MASK_READY;
 pixel->status |= PIXEL_SELECTION_CUR_ROI;

 xv_set(pixel->frame,FRAME_BUSY,TRUE,0);
 win_execute_proc_to_partner_wins(win,win_select_pixels,0,0);
 win_and_selected_pixels(win);
 update_menus(win);
 xv_set(pixel->frame,FRAME_BUSY,FALSE,0);

 win_execute_proc_to_partner_wins(win,win_redisplay_all_curves,0,0);
 TRACE(printf("cur_roi_proc after win_setup_pix_sel_rec..4.\n"))
}


/*-------------------------------------------------------------------------
all_rois_proc - ???
-------------------------------------------------------------------------*/

void
all_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;
 unsigned int lb,ub;
 int err;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;
 TRACE(printf("all_rois_proc ...\n"))
 if (!win_is_slice_roi_non_empty(win))
     return /*CANCEL*/;
 lb = (unsigned int) xv_get(pixel->lb,PANEL_VALUE);
 ub = (unsigned int) xv_get(pixel->ub,PANEL_VALUE);
 win->data.selection.status = PIXEL_SELECTION_ALL_ROIS;
 if ((err = win_setup_pix_sel_rec(win,lb,ub)) != NO_ERROR)
     return /*err*/;
 xv_set(pixel->frame,FRAME_BUSY,TRUE,0);
 if (!(pixel->status & PIXEL_SELECTION_ALL_ROIS))
    {InitBuf2dRecData(&(pixel->win->data.selection.selected_pixel),(double) .0);
     pixel->last_lb = 1;
     pixel->last_ub = 0;}
 pixel->status &= ~PIXEL_SELECTION_MASK_READY;
 pixel->status |= PIXEL_SELECTION_ALL_ROIS;

 win_execute_proc_to_partner_wins(win,win_select_pixels,0,0);
 win_and_selected_pixels(win);
 update_menus(win);
 xv_set(pixel->frame,FRAME_BUSY,FALSE,0);
 win_execute_proc_to_partner_wins(win,win_redisplay_all_curves,0,0);
}


/*-------------------------------------------------------------------------
notify_which_region_proc - ???
-------------------------------------------------------------------------*/

void
notify_which_region_proc(item,event)
 Panel_item item;
 Event *event;
{
 int val;
 struct win_pix_sel_rec *pixel;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 val = (int) xv_get(pixel->which_region,PANEL_VALUE);
 if (val == 0) whole_slice_proc(item,event);
   else if (val == 1) cur_curve_proc(item,event);
   else if (val == 2) cur_roi_proc(item,event);
   else if (val == 3) all_rois_proc(item,event);
}


/*-------------------------------------------------------------------------
pixel_mean_sd - ???
-------------------------------------------------------------------------*/

int
pixel_mean_sd(pixel)
 struct win_pix_sel_rec *pixel;
{
 int err;
 int is_color_data,which_region;
 struct buf_2d_rec *the_2d,color_2d,*mask_2d;
 struct img_buf_rec *img;
 struct draw_mask_rec mask;
 struct int_bound_rec *bound_area,affected;
 struct color_data_rec *color_data;
 double mean,sd;
 char str[100];

 if ((img = win_rec_cur_img_buf(pixel->win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(pixel->win)) == NULL) return CANCEL;
 which_region = (int) xv_get(pixel->which_region,PANEL_VALUE);
 xv_set(pixel->mean_sd,PANEL_LABEL_STRING,"",0);
 TRACE(printf("pixel_mean_sd...\n");fflush(stdout))
 if (which_region)
    {init_draw_mask_rec(&mask);
     TRACE(printf("pixel_mean_sd...1\n");fflush(stdout))
     if ((err = GetRoiMask(&(pixel->win->control.sroi.sroi_win->slice_roi),
         pixel->win->control.sroi.localto,
         img->_2d.dimx,img->_2d.dimy,&mask,&affected,which_region,
         &(pixel->win->image_view_roi))) != NO_ERROR)
        {
         return err;}
     TRACE(printf("pixel_mean_sd...1\n");fflush(stdout))
     mask_2d = &(mask.mask._2d);
     bound_area = &affected;
    }
   else
    {bound_area = NULL;
     mask_2d = NULL;}
 is_color_data = (int) xv_get(pixel->use_pixel_values,PANEL_VALUE,0);
 TRACE(printf("pixel_mean_sd...2\n");fflush(stdout))
 if (is_color_data)
    {init_buf_2d_rec(&color_2d);
     if ((err = copy_buf_2d_rec(&color_2d,&(color_data->_2d)))
                   != NO_ERROR)
        return err;
     WinMapActualColorData(pixel->win,NULL,&color_2d);
     the_2d = &color_2d;
    }    
   else
    the_2d = &(img->_2d);
 TRACE(printf("pixel_mean_sd...3\n");fflush(stdout))
 _2dMeanAndSd(the_2d,mask_2d,bound_area,&mean,&sd);
 sprintf(str,"%-.2f/%-.2f",mean,sd);
 xv_set(pixel->mean_sd,PANEL_LABEL_STRING,str,0);
 if (is_color_data)
    free_buf_2d_rec(&color_2d);
 return err;
}


/*-------------------------------------------------------------------------
pixel_mean_sd_proc - ???
-------------------------------------------------------------------------*/

int
pixel_mean_sd_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 int err;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((err = pixel_mean_sd(pixel)) != NO_ERROR)
    ShowMsgStrs(pixel->win->dwin->frame,0,err,0,2,
          "An error occurred when computing the mean & sd",
          OPERATION_ABORTED,NULL,0);
 return err;
}


/*-------------------------------------------------------------------------
set_which_region_proc - ???
-------------------------------------------------------------------------*/

void
set_which_region_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct win_pix_sel_rec *pixel;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 xv_set(pixel->mean_sd,PANEL_LABEL_STRING,"",0);
}


/*-------------------------------------------------------------------------
define_lb_ub - ???
-------------------------------------------------------------------------*/

int
define_lb_ub(pixel)
 struct win_pix_sel_rec *pixel;
{
 struct img_buf_rec *img;
 int lb,ub,err,use_color_value;
 char *str;
 unsigned long first,num_colors;

 use_color_value = (int) xv_get(pixel->use_pixel_values,PANEL_VALUE);
 if ((img = win_rec_cur_img_buf(pixel->win->owner)) == NULL) return CANCEL;
 win_first_and_num_colors(pixel->win,&first,&num_colors);

 if (pixel->win->data.selection.status & PIXEL_SELECTION_LB_UB_EXIST)
    lb = pixel->win->data.selection.lb;
   else if (use_color_value)
    lb = first;
   else lb = 0;

 if (pixel->win->data.selection.status & PIXEL_SELECTION_LB_UB_EXIST)
    ub = pixel->win->data.selection.ub;
   else if (use_color_value)
    ub = first + num_colors - 1;
   else ub = num_bit_values(img->_2d.pixel_depth) - 1;
 if (use_color_value)
    {str = "LB COLOR";
     xv_set(pixel->lb,
	PANEL_LABEL_STRING,str,
	PANEL_VALUE, (int) lb,
	PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,first + num_colors - 1,
	0);
     str = "UB COLOR";
     xv_set(pixel->ub,
	PANEL_LABEL_STRING,str,
	PANEL_VALUE, (int) ub,
	PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,first + num_colors - 1,
	0);
    }
   else
    {
     if (!(img->_2d.status4 & BUF_MIN_MAX_COMPUTED))
        MinMax2d(&(img->_2d),0,(double) .0,(double) .0);
     make_int_in_range(&lb,(long) img->_2d.minval,(long) img->_2d.maxval);
     make_int_in_range(&ub,(long) img->_2d.minval,(long) img->_2d.maxval);

     str = "LB PIXEL";
     xv_set(pixel->lb,
	PANEL_LABEL_STRING,str,
	PANEL_VALUE, (int) lb,
	PANEL_MIN_VALUE,(long) img->_2d.minval,
	PANEL_MAX_VALUE,(long) img->_2d.maxval,
	0);
     str = "UB PIXEL";
     xv_set(pixel->ub,
	PANEL_LABEL_STRING,str,
	PANEL_VALUE, (int) ub,
	PANEL_MIN_VALUE,(long) img->_2d.minval,
	PANEL_MAX_VALUE,(long) img->_2d.maxval,
	0);
    }
 if ((pixel->win->data.selection.selected_pixel.status4 & BUF_NON_EMPTY) &&
     (pixel->win->data.selection.selected_pixel.status4 & BUF_DATA_VALID))
    {
     InitBuf2dRecData(&(pixel->win->data.selection.share->_2d),(double) .0);
     InitBuf2dRecData(&(pixel->win->data.selection.selected_pixel),(double) .0);
     pixel->last_lb = 1;
     pixel->last_ub = 0;

     win_and_selected_pixels(pixel->win);

     update_menus(pixel->win);

     win_execute_proc_to_partner_wins(pixel->win,win_redisplay_all_curves,0,0);
     pixel->win->data.selection.status &= ~PIXEL_SELECTION_MASK_READY;
     pixel->win->data.selection.status &= ~(PIXEL_SELECTION_WHOLE_SLICE |
                   PIXEL_SELECTION_GET_OPTION);
     pixel->win->data.selection.status &= ~PIXEL_SELECTION_LB_UB_SET;
     free_buf_2d_val_rec(&(pixel->echo));
     pixel->win->data.num_draw_masks = INIT_TOTAL_DRAW_MASKS;
    }
 if ((err = pixel_setup_buf_2d_val_rec(pixel)) != NO_ERROR)
    free_win_pix_sel_rec(pixel);

 return err;
}


/*-------------------------------------------------------------------------
use_which_value_proc - ???
-------------------------------------------------------------------------*/

void
use_which_value_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct win_pix_sel_rec *pixel;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value == 0)
    xv_set(pixel->follow_contrast,PANEL_INACTIVE,TRUE,0);
   else xv_set(pixel->follow_contrast,PANEL_INACTIVE,FALSE,0);
 pixel->win->data.selection.status &= ~PIXEL_SELECTION_LB_UB_EXIST;
 define_lb_ub(pixel);
}


/*-------------------------------------------------------------------------
pix_sel_help_proc - ???
-------------------------------------------------------------------------*/

void
pix_sel_help_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 char *fn;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 fn = (char *) get_prog_def_fn(pixel->win->owner->root->prog,
              PIXEL_SELECTION_HELP_FN);
 enter_display_text_file(pixel->frame,1,NULL,fn);
 c_free(fn);
}


/*-------------------------------------------------------------------------
validate_item_values - ???
-------------------------------------------------------------------------*/

void
validate_item_values(pixel,item)
 struct win_pix_sel_rec *pixel;
 Panel_item item;
{
 int val,value;

 value = (int) xv_get(item,PANEL_VALUE);
 if (item == pixel->lb)
    {val = (int) xv_get(pixel->ub,PANEL_VALUE);
     if (value > val) xv_set(pixel->ub,PANEL_VALUE,value,0);
        else value = val; 
    }
   else if (item == pixel->ub)
    {val = (int) xv_get(pixel->lb,PANEL_VALUE);
     if (value < val) xv_set(pixel->lb,PANEL_VALUE,value,0);
        else value = val; 
    }

}


/*-------------------------------------------------------------------------
notify_pixel_proc - ???
-------------------------------------------------------------------------*/

int
notify_pixel_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;

 TRACE(printf("notify_pixel_proc...begin"))
 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;
 validate_item_values(pixel,item);
 TRACE(printf("notify_pixel_proc...begi 1n\n"))
 win->data.selection.lb = (unsigned int) xv_get(pixel->lb,PANEL_VALUE);
 win->data.selection.ub = (unsigned int) xv_get(pixel->ub,PANEL_VALUE);
 win->data.selection.status |= PIXEL_SELECTION_LB_UB_SET |
                              PIXEL_SELECTION_LB_UB_EXIST;

 if (win->data.selection.status & PIXEL_SELECTION_WHOLE_SLICE)
    {xv_set(pixel->frame,FRAME_BUSY,TRUE,0);
     win_slice_select_pixels(win);}
   else if (win->data.selection.status & PIXEL_SELECTION_GET_OPTION) 
    {xv_set(pixel->frame,FRAME_BUSY,TRUE,0);
     win_select_pixels(win);}
   else
     {
      return CANCEL;}
 win_and_selected_pixels(win);
 update_menus(win);
 xv_set(pixel->frame,FRAME_BUSY,FALSE,0);
 win_execute_proc_to_partner_wins(win,win_redisplay_all_curves,0,0);
 TRACE(printf("notify_pixel_proc...end"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
pix_sel_done_proc - ???
-------------------------------------------------------------------------*/

void
pix_sel_done_proc(frame)
 Frame frame;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;

 pixel = (struct win_pix_sel_rec *) xv_get(frame,WIN_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;
 free_win_pix_sel_rec(pixel);

}

/****************
pix_sel_quit_proc(item,event)
 Panel_item item;
 Event event;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;
 free_win_pix_sel_rec(pixel);
}
*****************/


/*-------------------------------------------------------------------------
follow_contrast_proc - ???
-------------------------------------------------------------------------*/

void
follow_contrast_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct win_pix_sel_rec *pixel;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 pixel->win->data.selection.status &= ~PIXEL_SELECTION_LB_UB_EXIST;
 define_lb_ub(pixel);
 notify_which_region_proc(item,event);
}


/*-------------------------------------------------------------------------
pixel_roi_to_histo_roi_proc - ???
-------------------------------------------------------------------------*/

int
pixel_roi_to_histo_roi_proc(dwin,label)
 struct display_win_rec *dwin;
 char *label;
{
 struct all_win_pix_sel_rec_recs *all_pixs;
 struct win_pix_sel_rec *pixel;
 int option;
 struct image_display_window *win;

 win = dwin->owner;
 win->dwin = dwin;
 if (!(win->data.selection.status & PIXEL_SELECTION_MASK_READY) ||
     (win->data.selection.share == NULL) ||
     !(win->data.selection.share->_2d.status4 & BUF_DATA_VALID))
    return CANCEL;
 all_pixs = enter_pixel_selection(NULL,GET_PIXEL_SELECTION_PTR);
 if ((pixel = find_win_pix_sel_rec(all_pixs,win)) == NULL) return CANCEL;

 option = xv_get(pixel->options,PANEL_VALUE);
 return win_mask_to_histo_roi(win,&(win->data.selection.share->_2d),
            NULL,label,option,pixel->frame);
}


/*-------------------------------------------------------------------------
pix_sel_make_histo_roi_proc - ???
-------------------------------------------------------------------------*/

int
pix_sel_make_histo_roi_proc(item,event)
 Panel_item item;
 Event event;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;
 struct img_buf_rec *img;
 struct strs_rec *roi_labels;
 Panel panel;

 TRACE(printf("pix_sel_make_histo_roi_proc ...\n"))
 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;

 if (!(win->data.selection.status & PIXEL_SELECTION_MASK_READY)) return CANCEL;
 if (!(win->data.selection.selected_pixel.status4 & BUF_DATA_VALID))
    return CANCEL;
 TRACE(printf("pix_sel_make_histo_roi_proc .1..\n"))

 panel = (Panel) xv_get(item,XV_OWNER);

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 roi_labels = win_rec_pixel_types_PTR(win->owner);
 if (roi_labels == NULL) return CANCEL;
 if ((int) xv_get(pixel->label,PANEL_VALUE))
    {
     return setup_label_roi(pixel->win,pixel->frame,
                pixel_roi_to_histo_roi_proc,pixel->dwin,NULL,NULL,
                "PIXEL SELECTION : LABEL - CUR ROI TO HISTO-ROI",
                (unsigned short) HISTOGRAM_WINDOW);}
   else return pixel_roi_to_histo_roi_proc(pixel->dwin,HISTO_ROI);
}


/*-------------------------------------------------------------------------
pix_sel_add_to_cur_roi_pro - ???
-------------------------------------------------------------------------*/

int
pix_sel_add_to_cur_roi_proc(item,event)
 Panel_item item;
 Event event;
{
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;
 struct roi_rec *roi;
 struct curve_rec **curves;
 unsigned int num_curves,total_curves;
 int err;

 TRACE(printf("pix_sel_add_to_cur_roi_proc ...\n"))
 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win = pixel->win;
 win->dwin = pixel->dwin;

 if (!(win->data.selection.status & PIXEL_SELECTION_MASK_READY) ||
     (win->data.selection.share == NULL) ||
     !(win->data.selection.share->_2d.status4 & BUF_DATA_VALID))
    return CANCEL;
 TRACE(printf("pix_sel_add_to_cur_roi_proc .1..\n"))
 if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)))
            == NULL)
    if (setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),
             SCRATCH_STR,1) == NO_ERROR)
       if ((roi = get_cur_roi(&(win->control.sroi.sroi_win->slice_roi)))
            == NULL) return CANCEL;

 TRACE(printf("pix_sel_add_to_cur_roi_proc scan_objects .1..\n"))
 if ((err = scan_objects(&(win->data.selection.share->_2d),NULL,
         &curves,&total_curves,&num_curves,1,1)) == NO_ERROR)
    {TRACE(printf("add_to_cur_roi_proc append_curves_to_roi_rec .1..\n"))
     err = append_curves_to_roi_rec(roi,curves,num_curves,
                        &(win->control.sroi.sroi_win->slice_roi.status));}
 TRACE(printf("pix_sel_add_to_cur_roi_proc scan_objects .2..\n"))

 if ((err != NO_ERROR) && (num_curves > 0))
    {
     ShowMsgStrs(pixel->frame,0,NO_ERROR,0,1,
               "An error occured !!! -- unable to create ROI !!!",NULL,0);
     free_curve_recs(curves,num_curves);}
 c_free(curves);

 win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
 TRACE(printf(" pix_sel_add_to_cur_roi_proc..4.\n"))

 return err;

}


/*-------------------------------------------------------------------------
pixel_map_options_proc - ???
-------------------------------------------------------------------------*/

int
pixel_map_options_proc(item,event)
 Panel_item item;
 Event event;
{
 struct win_pix_sel_rec *pixel;
 int value;

 pixel = (struct win_pix_sel_rec *) xv_get(item,PANEL_CLIENT_DATA);
 value = (int) xv_get(pixel->options,PANEL_VALUE);
 if (value == SELECTED_TO_CUR_ROI) 
    return pix_sel_add_to_cur_roi_proc(item,event);
   else return pix_sel_make_histo_roi_proc(item,event);
}


/*-------------------------------------------------------------------------
pixel_setup_buf_2d_val_rec - ???
-------------------------------------------------------------------------*/

int
pixel_setup_buf_2d_val_rec(pixel)
 struct win_pix_sel_rec *pixel;
{
 struct img_buf_rec *img;
 struct buf_2d_rec _2d;
 int err;
 unsigned long first,num_colors;
 struct color_data_rec *color_data;

 if ((img = win_rec_cur_img_buf(pixel->win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(pixel->win)) == NULL) return CANCEL;
 win_first_and_num_colors(pixel->win,&first,&num_colors);
 if (xv_get(pixel->use_pixel_values,PANEL_VALUE) == 0)
    {
     if (!(img->_2d.status4 & BUF_MIN_MAX_COMPUTED))
        MinMax2d(&(img->_2d),0,(double) .0,(double) .0);
     err = setup_buf_2d_val_rec(&(pixel->echo),&(img->_2d),
           (long) img->_2d.minval,(long) img->_2d.maxval);
/*
     err = setup_buf_2d_val_rec(&(pixel->echo),&(img->_2d),
           0,num_colors - 1);
*/
    }
   else
    {init_buf_2d_rec(&_2d);
     if ((err = copy_buf_2d_rec(&_2d,&(color_data->_2d))) 
            != NO_ERROR) 
        return err;
     WinMapActualColorData(pixel->win,NULL,&_2d);
     err = setup_buf_2d_val_rec(&(pixel->echo),&_2d,first,first + num_colors - 1);
     free_buf_2d_rec(&_2d);
    }
 TRACE(printf("pixel_setup_buf_2d_val_rec...err = %d\n",err))
 if (err == NO_ERROR) pixel->cur_slice = img->cur_slice;
 return err;
}


/*-------------------------------------------------------------------------
setup_pix_sel_proc - ???
-------------------------------------------------------------------------*/

int
setup_pix_sel_proc(pixel,win)
 struct win_pix_sel_rec *pixel;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 char *label1;
 Rect *rr;
 struct img_buf_rec *img;
 Panel_item item;

 TRACE(printf("setup_pix_sel_proc...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 pixel->win = win;
 pixel->dwin = win->dwin;
 pixel->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              0);
 if (pixel->frame == 0)
     return CANCEL;  /* FIXME:  Guessed at proper value.  -PWH 19990421 */
 label1 = (char *) win_rec_win_id_title(win->owner,PIXEL_SELECTION);

 xv_set(pixel->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,label1,
              FRAME_NO_CONFIRM,TRUE,
              WIN_CLIENT_DATA,pixel,
              FRAME_DONE_PROC,pix_sel_done_proc,
              0);
 c_free(label1);

 pixel->panel = xv_create(pixel->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               XV_FONT,pixel->dwin->font,
               0);
 if (pixel->panel == 0)
    {free_win_pix_sel_rec(pixel);
     return 0;}

 row = 0;
 offset = xv_rows(pixel->panel,1) - xv_rows(pixel->panel,0) - 10;
 str = "FOLLOW CONTRAST & UPDATE COLOR VALUES";
 pixel->follow_contrast = xv_create(pixel->panel,PANEL_BUTTON,
	           PANEL_LABEL_STRING, str,
                   XV_X,5,XV_Y,row,
                   PANEL_NOTIFY_PROC,follow_contrast_proc,
                   PANEL_CLIENT_DATA,pixel,
                   0);
/*
 str = "CANCEL";
 xv_create(pixel->panel,PANEL_BUTTON,
	           PANEL_LABEL_STRING, str,
                   XV_Y,row,
                   PANEL_NOTIFY_PROC,pix_sel_quit_proc,
                   PANEL_CLIENT_DATA,pixel,
                   0);
*/

 row += offset;
 pixel->use_pixel_values = xv_create(pixel->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"USE PIXEL VALUES",
                                "USE COLOR VALUES",NULL,
 	          PANEL_VALUE,1,
                  XV_X,5,XV_Y,row,
                  PANEL_NOTIFY_PROC,use_which_value_proc,
                  PANEL_CLIENT_DATA,pixel,
                  0);
 str = "HELP";
 xv_create(pixel->panel,PANEL_BUTTON,
	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,pix_sel_help_proc,
                   XV_Y,row,
                   PANEL_CLIENT_DATA,pixel,
                   0);
 row += offset;
 pixel->lb = xv_create(pixel->panel,PANEL_SLIDER,
	PANEL_SLIDER_WIDTH,100,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,notify_pixel_proc,
        PANEL_CLIENT_DATA,pixel,
	0);

 row += offset;
 pixel->ub = xv_create(pixel->panel,PANEL_SLIDER,
	PANEL_SLIDER_WIDTH,100,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,notify_pixel_proc,
        PANEL_CLIENT_DATA,pixel,
	0);

 row += offset;
 item =  xv_create(pixel->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, "SCAN",
                   XV_X,5,XV_Y,row,
                   PANEL_NOTIFY_PROC,notify_which_region_proc,
                   PANEL_CLIENT_DATA,pixel,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);
 pixel->which_region = xv_create(pixel->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,WHOLE_SLICE_STR,
                           CUR_CURVE_STR,CUR_ROI_STR,
                           ALL_ROIS_STR,VIEW_FILTER_ROI_STR,NULL,
                  PANEL_NOTIFY_PROC,set_which_region_proc,
                  PANEL_VALUE,0,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  PANEL_CLIENT_DATA,pixel,
                  0);
 rr = (Rect *) xv_get(pixel->which_region,XV_RECT);

 xv_create(pixel->panel,PANEL_BUTTON,
 	PANEL_LABEL_STRING, "MEAN/SD",
        PANEL_CLIENT_DATA,pixel,
        PANEL_NOTIFY_PROC,pixel_mean_sd_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);

 pixel->mean_sd = xv_create(pixel->panel,PANEL_MESSAGE,
 	PANEL_LABEL_STRING, "        ",
        XV_Y,row,
        0);

 row += offset;
 pixel->selected_pixel_cnt = xv_create(pixel->panel,PANEL_TEXT,
                       PANEL_LABEL_STRING,"SELECTED PIXELS =",
                       PANEL_VALUE_DISPLAY_LENGTH,10,
                       PANEL_VALUE_STORED_LENGTH,12,
                       PANEL_VALUE,"UNKNOWN",
                       XV_X,0,XV_Y,row,
                       0);

 row += offset;
 pixel->label = xv_create(pixel->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"LABEL HISTO-ROI",NULL,
        PANEL_VALUE,0,
        XV_X,5,XV_Y,row,
        0);

 row += offset;
 xv_create(pixel->panel,PANEL_BUTTON,
                       PANEL_LABEL_STRING,"MAP",
                  XV_X,5,XV_Y,row,
                  PANEL_CLIENT_DATA,pixel,
                  PANEL_NOTIFY_PROC,pixel_map_options_proc,0);

 if (img->file->hdr.data_info.num_echoes == 2)
    pixel->options = xv_create(pixel->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                      "SELECTED -> CUR ROI",
                      "SELECTED -> HISTO ROI POINTS",
                      "SELECTED -> HISTO ROI - CONVEX REGION",
                      "SELECTED -> HISTO ROI - RANGE REGION",
                      NULL,
                  PANEL_VALUE,1,
                  XV_Y,row,
                  0);
   else
    pixel->options = xv_create(pixel->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,
                      "SELECTED -> CUR ROI",
                      "SELECTED -> HISTO ROI",
                      NULL,
                  PANEL_VALUE,1,
                  XV_Y,row,
                  0);

 define_lb_ub(pixel);

 window_fit(pixel->panel);
 rr = (Rect *) xv_get(pixel->panel,XV_RECT);
 xv_set(pixel->panel,XV_HEIGHT,rr->r_height - 10,
                 XV_WIDTH,rr->r_width - 5,0);
 window_fit(pixel->frame);
 make_2_wins_adjacent(pixel->frame,win->dwin->frame,0);
 win_set_mouse_at_center(pixel->frame);
 xv_set(pixel->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 TRACE(printf("setup_pix_sel_proc...END\n"))

 return NO_ERROR;  /* FIXME: Guessed at return value.  -PWH 19990421 */

}


/*-------------------------------------------------------------------------
find_win_pix_sel_rec - ???
-------------------------------------------------------------------------*/

struct win_pix_sel_rec *
find_win_pix_sel_rec(all_pixs,win)
 struct all_win_pix_sel_rec_recs *all_pixs;
 struct image_display_window *win;
{
 unsigned lcv;

 for (lcv = 0; lcv < all_pixs->num_pixs; lcv++)
    if (all_pixs->pixs[lcv]->win == win)
       return all_pixs->pixs[lcv];

 return NULL;
}


/*-------------------------------------------------------------------------
update_pix_sel_menu - ???
-------------------------------------------------------------------------*/

void
update_pix_sel_menu(pixel)
 struct win_pix_sel_rec *pixel;
{
 char str1[10];

 TRACE(printf("update_pix_sel_menu\n"))
 xv_set(pixel->lb,PANEL_VALUE,(int) pixel->win->data.selection.lb,0);
 xv_set(pixel->ub,PANEL_VALUE,(int) pixel->win->data.selection.ub,0);
 if (!(pixel->win->data.selection.selected_pixel.status4 &
            BUF_DATA_VALID) ||
      (pixel->win->data.selection.share == NULL))
     xv_set(pixel->selected_pixel_cnt,PANEL_VALUE,"UNKNOWN",0);
   else
    {sprintf(str1,"%d",CntNonValBuf2dRec(
                 &(pixel->win->data.selection.share->_2d),(double) 0));
     xv_set(pixel->selected_pixel_cnt,PANEL_VALUE,str1,0);
    }
 TRACE(printf("update_pix_sel_menu end...\n"))

}


/*-------------------------------------------------------------------------
update_menus - ???
-------------------------------------------------------------------------*/

void
update_menus(win)
 struct image_display_window *win;
{
 struct list_rec *next,*cur;
 struct image_display_window *first;

 cur = next = head_list(&(win->partner));
 if (next != NULL)
    do
       {if ((first = list_item(next,0)) != NULL)
           enter_pixel_selection(first,UPDATE_PIXEL_SELECTION_MENU);
        next = next->next;
       }
    while (cur != next);
}


/*-------------------------------------------------------------------------
setup_shared_and_pixel_selected_buf - ???
-------------------------------------------------------------------------*/

int
setup_shared_and_pixel_selected_buf(win)
 struct image_display_window *win;
{
 struct list_rec *next,*cur;
 struct image_display_window *first;
 struct shared_buf_2d_rec *share;
 int cnt,err;
 unsigned long total;

 if (!(win->data.selection.selected_pixel.status4 & BUF_DATA_VALID))
    return CANCEL;

 share = NULL;
 cur = next = head_list(&(win->partner));
 if (next != NULL)
    do
       {if ((first = list_item(next,0)) != NULL)
           if (first->data.selection.share != NULL)
              {share = first->data.selection.share;
               break;}
        next = next->next;
       }
    while (cur != next);

 if (share == NULL)
    {total = 0;
     get_ptr_memory(&share,&total,(size_t) 1,
         (size_t) sizeof(struct shared_buf_2d_rec),&err);
     if (err != NO_ERROR) return err;
     init_shared_buf_2d_rec(share);
    }
 cnt = 0;
 cur = next = head_list(&(win->partner));
 if (next != NULL)
    do
      {if ((first = list_item(next,0)) != NULL)
          {cnt += 1;
           first->data.selection.share = share;}
       next = next->next;
      }
    while (cur != next);
 share->in_use = cnt;
 if ((err = SetupBuf2dRec(&(share->_2d),
          win->data.selection.selected_pixel.dimx,
          win->data.selection.selected_pixel.dimy,1,0)) != NO_ERROR)
    return err;

 if ((err = copy_buf_2d_rec_content(&(win->data.selection.share->_2d),
           &(win->data.selection.selected_pixel))) == NO_ERROR)
    win->data.selection.share->_2d.status4 |= BUF_DATA_VALID;
   else win->data.selection.share->_2d.status4 &= ~BUF_DATA_VALID;
 return err;
}


/*-------------------------------------------------------------------------
win_and_selected_pixels - ???
-------------------------------------------------------------------------*/

int
win_and_selected_pixels(win)
 struct image_display_window *win;
{
 int first_time;
 struct list_rec *next,*cur;
 struct image_display_window *first;
 int err;

 first_time = 1;

 if (!(win->data.selection.selected_pixel.status4 & BUF_DATA_VALID))
    return CANCEL;
 if ((err = setup_shared_and_pixel_selected_buf(win)) != NO_ERROR) return err;
 cur = next = head_list(&(win->partner));
 if (next != NULL)
    do
       {if ((first = list_item(next,0)) != NULL)
           {if (first != win)
               if (first->data.selection.selected_pixel.status4 & BUF_DATA_VALID)
                  {
                   AndBitmaps(&(win->data.selection.share->_2d),
                       &(win->data.selection.share->_2d),
                       &(first->data.selection.selected_pixel));
                  }
            first->data.selection.status |=  PIXEL_SELECTION_MASK_READY;}
        next = next->next;
       }
    while (cur != next);
 win->data.selection.selected_pixel_of_this_slice = win->control.sroi.sroi_win;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
select_the_pixel_value - ???
-------------------------------------------------------------------------*/

void
select_the_pixel_values(pixel,mask,lb,ub,value)
 struct win_pix_sel_rec *pixel;
 struct buf_2d_rec *mask;
 unsigned long lb,ub,value;
{
 struct buf_2d_rec *_2d;
 unsigned long lcv,cnt,x,y;
 struct val_rec *vals;
 unsigned long num_vals;

 _2d = &(pixel->win->data.selection.selected_pixel);
 find_val_recs(&(pixel->echo),lb,ub,&vals,&num_vals);
 TRACE(printf("select_the_pixel_values lb = %d ub = %d value = %d num_vals = %d\n",
               lb,ub,value,num_vals))
 if (num_vals > 0)
    {TRACE(printf("mask = %u vals[0] = %d\n",mask,vals[0].value))
     TRACE(printf("select_the_pixel_values val = %d\n",
               vals[num_vals - 1].value))
/*
     for (lcv = 0; lcv < num_vals; lcv++)
        printf("%d) num_coords = %d %d\n",lcv,(long) vals[lcv].num_coords,
             vals[lcv].value);
*/
    }

 if (mask == NULL)
    {
     for (lcv = 0; lcv < num_vals; lcv++)
        {
         for (cnt = 0; cnt < vals[lcv].num_coords; cnt++)
            {x = vals[lcv].coords[cnt].x;
             y = vals[lcv].coords[cnt].y;
             _2d->SetVal(_2d,y,x,(double) value);
            }
        }
    }
   else
    {for (lcv = 0; lcv <= num_vals; lcv++)
        for (cnt = 0; cnt < vals[lcv].num_coords; cnt++)
           {x = vals[lcv].coords[cnt].x;
            y = vals[lcv].coords[cnt].y;
            if (mask->GetVal(mask,y,x) != .0)
               _2d->SetVal(_2d,y,x,(double) value);
           }
    }
 _2d->status4 |= BUF_DATA_VALID;
}


/*-------------------------------------------------------------------------
select_pixel_values - ???
-------------------------------------------------------------------------*/

void
select_pixel_values(pixel,mask)
 struct win_pix_sel_rec *pixel;
 struct buf_2d_rec *mask;
{
 long lb,ub;

 TRACE(printf("select_pixel_values pix last_lb = %d  last_ub = %d\n",pixel->last_lb,pixel->last_ub))
 TRACE(printf(" selection lb = %d  ub = %d\n",pixel->win->data.selection.lb,pixel->win->data.selection.ub))
 if (pixel->last_lb > pixel->last_ub)
    {
     select_the_pixel_values(pixel,mask,pixel->win->data.selection.lb,
          pixel->win->data.selection.ub,1);
    }
   else
    {
     if (pixel->last_lb != pixel->win->data.selection.lb)
        {if (pixel->last_lb < pixel->win->data.selection.lb)
            select_the_pixel_values(pixel,mask,pixel->last_lb,
                pixel->win->data.selection.lb - 1,0);
          else 
           {ub = pixel->last_lb - 1;
            if (ub > pixel->win->data.selection.ub)
               ub = pixel->win->data.selection.ub;
            select_the_pixel_values(pixel,mask,pixel->win->data.selection.lb,
                ub,1);}
        }
     if (pixel->last_ub != pixel->win->data.selection.ub)
        {if (pixel->last_ub > pixel->win->data.selection.ub)
            select_the_pixel_values(pixel,mask,
                pixel->win->data.selection.ub + 1,pixel->last_ub,0);
          else 
           {lb = pixel->last_ub + 1;
            if (lb < pixel->win->data.selection.lb) 
               lb = pixel->win->data.selection.lb;
            select_the_pixel_values(pixel,mask,
                lb,pixel->win->data.selection.ub,1);
           }
        }
    }
 pixel->last_lb = pixel->win->data.selection.lb;
 pixel->last_ub = pixel->win->data.selection.ub;
}


/*-------------------------------------------------------------------------
win_slice_select_pixels - ???
-------------------------------------------------------------------------*/

int
win_slice_select_pixels(win)
 struct image_display_window *win;
{
 struct win_pix_sel_rec *pixel;
 struct all_win_pix_sel_rec_recs *all_pixs;

 all_pixs = enter_pixel_selection(win,GET_PIXEL_SELECTION_PTR);
 if ((pixel = find_win_pix_sel_rec(all_pixs,win)) == NULL)
    return NO_ERROR;

 TRACE(printf("win_slice_select_pixels...\n"))
 if (!(pixel->win->data.selection.status & PIXEL_SELECTION_LB_UB_SET))
    return NO_ERROR;
 TRACE(printf("win label = %s PIXEL_SELECTION_LB_UB_SET set...\n",
        pixel->win->dwin->frame_label))
 select_pixel_values(pixel,NULL);

 TRACE(printf("win_slice_select_pixels...END\n"))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_select_pixels - ???
-------------------------------------------------------------------------*/

int
win_select_pixels(win)
 struct image_display_window *win;
{
 int err;
 struct win_pix_sel_rec *pixel;
 struct all_win_pix_sel_rec_recs *all_pixs;
 struct buf_2d_rec *_2d;
 struct int_bound_rec affected;
 struct draw_mask_rec mask;
 struct roi_rec *roi;
 struct curve_rec *curve;
 struct curve_2d_rec *pen;
 struct slice_roi_rec *slice_roi;

 all_pixs = enter_pixel_selection(NULL,GET_PIXEL_SELECTION_PTR);
 if ((pixel = find_win_pix_sel_rec(all_pixs,win)) == NULL) return CANCEL;
 if (!(win->data.selection.status & PIXEL_SELECTION_LB_UB_SET))
    return NO_ERROR;
 TRACE(printf("win label = %s PIXEL_SELECTION_LB_UB_SET not set...\n",
        win->dwin->frame_label))

 if ((_2d = win_rec_cur_data_buf(win->owner,win->type2)) == NULL)
    return CANCEL;
 slice_roi = &(win->control.sroi.sroi_win->slice_roi);
 if ((roi = get_cur_roi(slice_roi)) == NULL) return CANCEL;
 if ((pen = get_cur_pen(slice_roi)) == NULL) return CANCEL;
 if ((curve = get_cur_curve(slice_roi)) == NULL) return CANCEL;

 init_draw_mask_rec(&mask);
 if ((err = get_draw_mask_rec(&mask,
       win->data.selection.selected_pixel.dimx,
       win->data.selection.selected_pixel.dimy)) != NO_ERROR)
    {free_draw_mask_rec(&mask);
     return err;}
 if (win->data.selection.status & PIXEL_SELECTION_CUR_CURVE)
    {float_to_int_bound_rec(&affected,&(curve->fl_bound));
     err = GetFilledCurveMask(curve,win->control.sroi.localto,
                pen->pen_type,&mask,&affected);
    }
   else if (win->data.selection.status & PIXEL_SELECTION_CUR_ROI)
    {
     FindRoiLongMinMax(roi,win->control.sroi.localto,
           &(affected.left),&(affected.right),
           &(affected.top),&(affected.bottom),0,0,0);
     err = GetFilledRoiMask(roi,win->control.sroi.localto,&mask,&affected);
    }
   else if (win->data.selection.status & PIXEL_SELECTION_ALL_ROIS)
    err = GetFilledAllRoisMask(slice_roi,win->control.sroi.localto,&mask);

 if (err != NO_ERROR)
    {free_draw_mask_rec(&mask);
     return err;}

 select_pixel_values(pixel,&(mask.mask._2d));

 free_draw_mask_rec(&mask);
 TRACE(printf("win_select_pixels...end\n"))
 return NO_ERROR;

}


/*-------------------------------------------------------------------------
copy_selected_data - ???
-------------------------------------------------------------------------*/

int
copy_selected_data(win)
 struct image_display_window *win;
{
 int err;

 if (win->data.selection.share != NULL)
    {
     if ((err = copy_buf_2d_rec(
           &(win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].mask._2d),
           &(win->data.selection.share->_2d))) != NO_ERROR) return err;
     win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].mask._2d.status4 |=
              BUF_DATA_VALID;
     win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].paint_status |=
                 PAINTED;
     win->data.num_draw_masks = TOTAL_DRAW_MASKS;
    }
 return err;
}


/*-------------------------------------------------------------------------
paste_selected_pixels - ???
-------------------------------------------------------------------------*/

int
paste_selected_pixels(win)
 struct image_display_window *win;
{
 int err;
 struct win_pix_sel_rec *pixel;
 struct all_win_pix_sel_rec_recs *all_pixs;
 struct img_buf_rec *img;

 all_pixs = enter_pixel_selection(NULL,GET_PIXEL_SELECTION_PTR);
 if ((pixel = find_win_pix_sel_rec(all_pixs,win)) == NULL) return CANCEL;
 if ((img = win_rec_cur_img_buf(pixel->win->owner)) == NULL) return CANCEL;
 if (pixel->cur_slice == img->cur_slice) 
    {copy_selected_data(pixel->win);
     return NO_ERROR;}
 xv_set(pixel->frame,FRAME_BUSY,TRUE,0);

 if ((err = pixel_setup_buf_2d_val_rec(pixel)) != NO_ERROR) return err;
 win->data.num_draw_masks = INIT_TOTAL_DRAW_MASKS;
 InitBuf2dRecData(&(pixel->win->data.selection.selected_pixel),(double) .0);
 pixel->last_lb = 1;
 pixel->last_ub = 0;

 if (win->data.selection.status & PIXEL_SELECTION_WHOLE_SLICE)
     win_execute_proc_to_partner_wins(win,win_slice_select_pixels,0,0);
 else
     win_execute_proc_to_partner_wins(win,win_select_pixels,0,0);
 win_and_selected_pixels(win);
 update_menus(win);
 copy_selected_data(win);
 xv_set(pixel->frame,FRAME_BUSY,FALSE,0);
 return err;
}


/*-----------------------------------------------------------------------
setup_pixel_selection - ???

A wrapper for enter_pixel_selection, so that external users do not need
to know anything about internal data structures.
-----------------------------------------------------------------------*/

void
setup_pixel_selection(
    struct image_display_window *win)
{
    enter_pixel_selection(win, SETUP_PIXEL_SELECTION);
    return;
}


/*------------------------------------------------------------------------
enter_pixel_selection - ???

BEWARE: The pre-19990224 version of this function could return either
NULL, a pointer to a structure, or an integer error code.  Since the
last two of these cannot be reliably distinguished and since no one
ever seems to check for an error code, I replaced the error code by
NULL.  Of course, it is now impossible to distinguish between NO_ERROR
and NULL (=> error), but I don't think anyone ever looks at the error
code returned.  -PWH
-------------------------------------------------------------------------*/

static struct all_win_pix_sel_rec_recs *
enter_pixel_selection(
    struct image_display_window *win,
    int status)
{
 static struct all_win_pix_sel_rec_recs all_pixs;
 struct win_pix_sel_rec *pixel;
 static char first_time = 1;
 int err;

 if (status == GET_PIXEL_SELECTION_PTR)
    {if (first_time) return NULL;
       else return &all_pixs;}
 else if (status == CLEAN_UP_PIXEL_SELECTION)
   {if (!first_time)
       if ((pixel = find_win_pix_sel_rec(&all_pixs,win)) != 0)
          free_win_pix_sel_rec(pixel);
    return NO_ERROR;}
 else if (status == UPDATE_PIXEL_SELECTION_MENU)
   {if (!first_time)
       if ((pixel = find_win_pix_sel_rec(&all_pixs,win)) != NULL)
          update_pix_sel_menu(pixel);
     return NO_ERROR;}

 if (first_time)
    {init_all_win_pix_sel_rec_recs(&all_pixs);
     first_time = 0;}
 else
    {if ((pixel = find_win_pix_sel_rec(&all_pixs,win)) != NULL)
        {xv_set(pixel->frame,XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(pixel->frame);
         wmgr_top(pixel->frame);
         pixel->dwin = win->dwin;
         return NO_ERROR;}
    }
 get_handle_memory(&(all_pixs.pixs),&(all_pixs.num_pixs),1,
     (size_t) sizeof(struct win_pix_sel_rec),&err);
 if (err != NO_ERROR) return NULL;    /* Was: return err */
 pixel = all_pixs.pixs[all_pixs.num_pixs - 1];
 init_win_pix_sel_rec(pixel);
 if ((err = setup_pix_sel_proc(pixel,win)) == NO_ERROR)
    {TRACE(printf("setup_pix_sel_proc...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               PIXEL_SELECTION,NULL,0);
 return NULL;    /* Was:  return err */
}
