/****************************************************************************
pixel_type.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: pixel_type.c,v 1.9 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT4(x)
#define PRT5(x)


/* Functions defined in this file */
int Get1dHistoMapMaskByMask(struct buf_2d_rec *mask,
     struct int_bound_rec *affected, struct buf_2d_rec *_2d,
     struct buf_2d_rec *histo_mask);
int Get2dHistoMapMaskByMask(struct buf_2d_rec *mask,
     struct int_bound_rec *affected, struct buf_2d_rec *_2dx,
     struct buf_2d_rec *_2dy, struct buf_2d_rec *histo_mask);
int get_1d_histo_map_mask(struct buf_2d_rec *_2d,
     struct buf_2d_rec *histo_mask);
int get_2d_histo_map_mask(struct buf_2d_rec *_2dx, struct buf_2d_rec *_2dy,
     struct buf_2d_rec *histo_mask);
int GetHistoMapMask(struct img_buf_rec *img, struct buf_2d_rec *histo_mask,
     struct buf_2d_rec *mask, struct int_bound_rec *affected);
int GetHistoRoiMask(struct img_buf_rec *img, struct draw_mask_rec *mask,
     struct int_bound_rec *affected, int option,
     struct roi_rec *image_view_roi);
int Get1dMapByMask(struct buf_2d_rec *mask, struct int_bound_rec *affected,
     struct buf_2d_rec *pixel_type_map, struct buf_2d_rec *result_map);
int Get2dMapByMask(struct buf_2d_rec *mask, struct int_bound_rec *affected,
     struct buf_2d_rec *_2dx, struct buf_2d_rec *_2dy,
     struct buf_2d_rec *pixel_type_map, struct buf_2d_rec *result_map);
int get_1d_map(struct buf_2d_rec *pixel_type_map,
     struct buf_2d_rec *result_map);
int get_2d_map(struct buf_2d_rec *_2dx, struct buf_2d_rec *_2dy,
     struct buf_2d_rec *pixel_type_map, struct buf_2d_rec *result_map);
int Get1dMapByMaskPick(struct buf_2d_rec *mask,
     struct int_bound_rec *affected, struct buf_2d_rec *pixel_type_map,
     struct buf_2d_rec *result_map, char *picks, unsigned long num_picks);
int Get2dMapByMask_pick(struct buf_2d_rec *mask,
     struct int_bound_rec *affected, struct buf_2d_rec *_2dx,
     struct buf_2d_rec *_2dy, struct buf_2d_rec *pixel_type_map,
     struct buf_2d_rec *result_map, char *picks);
int Get1dMapPick(struct buf_2d_rec *pixel_type_map,
     struct buf_2d_rec *result_map, char *picks, unsigned long num_picks);
int get_2d_map_pick(struct buf_2d_rec *_2dx, struct buf_2d_rec *_2dy,
     struct buf_2d_rec *pixel_type_map, struct buf_2d_rec *result_map,
     char *picks);
int get_map(struct img_buf_rec *img, struct buf_2d_rec *slice_map,
     struct buf_2d_rec *mask, struct int_bound_rec *affected,
     struct buf_2d_rec *pixel_type_map);
struct buf_2d_rec *get_cur_slice_map(struct input_file_rec *file,
     struct hdr_scan_entry_rec *cur_slice);
struct buf_2d_rec *get_img_pixel_type_map(struct img_buf_rec *img);
int IsAllPixelTypeMapReady(struct pixel_type_rec *pixel_type,
     struct hdr_rec *hdr);
int is_all_pixel_type_map_ready(struct input_file_rec *file);
int setup_cur_slice_map(struct buf_2d_rec *slice_map,
     struct buf_2d_rec **slice_map_ptr, struct input_file_rec *file,
     struct hdr_scan_entry_rec *cur_slice);
int SetupThresholdingPixelTypeMaps(struct input_file_rec *file);
int SetupGrowRegionPixelTypeMaps(struct input_file_rec *file);
int SetupAllSliceMaps(struct input_file_rec *file, int *is_ready);
struct buf_2d_rec *get_histo_map(struct img_buf_rec *img);
char *GetHistoPixelTypeLabel(struct img_buf_rec *img, unsigned int x,
     unsigned int y, int win_type2);
char *get_pixel_type_label(struct img_buf_rec *img, unsigned int x,
     unsigned int y);
int set_map(struct buf_2d_rec *dest, struct buf_2d_rec *src);
int build_histo_pixel_type_map(struct histo_params_rec *histo);
int get_histo_map_from_pixel_type_map(struct histo_params_rec *histo,
     struct pixel_type_rec *pixel_type);
int build_pixel_type_map(struct histo_params_rec *histo,
     struct pixel_type_rec *pixel_type);
int get_slice_mask(struct img_buf_rec *img, struct buf_2d_rec *img_2d,
     struct buf_2d_rec *slice_mask, unsigned char *selected);
int setup_slice_mask(struct img_buf_rec *img, struct buf_2d_rec *img_2d,
     struct buf_2d_rec *slice_mask, unsigned char *selected);



/*--------------------------------------------------------------------------
Get1dHistoMapMaskByMask - ???
--------------------------------------------------------------------------*/

int
Get1dHistoMapMaskByMask(mask,affected,_2d,histo_mask)
 struct buf_2d_rec *mask,*_2d,*histo_mask;
 struct int_bound_rec *affected;
{
 unsigned int row,col,col_bit,indx,start_bit,end_bit,cnt;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char source_byte;
 unsigned int start_byte,start_col_bit,stop_byte,valuex;
 unsigned int left,right,top,bottom;
 struct int_bound_rec bound;
 double val;

 setup_int_bound_rec(&bound,0,0,mask->dimx - 1,mask->dimy - 1);
 if (affected == NULL)
    valid_bound(&bound,&bound,&left,&right,&top,&bottom);
   else valid_bound(affected,&bound,&left,&right,&top,&bottom);

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if (source_byte = mask->buf[row][col])
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & _1_bit[cnt])
                  {val = _2d->GetVal(_2d,row,indx);
                   valuex = ULongRound(val);
                   histo_mask->SetVal(histo_mask,0,valuex,(double) 1);
                  }
            }
    }
 histo_mask->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
Get2dHistoMapMaskByMask - ???
--------------------------------------------------------------------------*/

int
Get2dHistoMapMaskByMask(mask,affected,_2dx,_2dy,histo_mask)
 struct buf_2d_rec *mask,*_2dx,*_2dy,*histo_mask;
 struct int_bound_rec *affected;
{
 unsigned int row,col,col_bit,indx,start_bit,end_bit,cnt;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char source_byte;
 unsigned int start_byte,start_col_bit,stop_byte,valuex,valuey;
 unsigned int left,right,top,bottom;
 struct int_bound_rec bound;
 double val;

 TRACE(printf("Get2dHistoMapMaskByMask...begin\n"))
 setup_int_bound_rec(&bound,0,0,mask->dimx - 1,mask->dimy - 1);
 if (affected == NULL)
    valid_bound(&bound,&bound,&left,&right,&top,&bottom);
   else valid_bound(affected,&bound,&left,&right,&top,&bottom);

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if (source_byte = mask->buf[row][col])
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & _1_bit[cnt])
                  {val = _2dx->GetVal(_2dx,row,indx);
                   valuex = ULongRound(val);
                   val = _2dy->GetVal(_2dy,row,indx);
                   valuey = ULongRound(val);
                   histo_mask->SetVal(histo_mask,valuey,valuex,(double) 1.0);
                  }
            }
    }
 histo_mask->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
get_1d_histo_map_mask - ???
--------------------------------------------------------------------------*/

int
get_1d_histo_map_mask(_2d,histo_mask)
 struct buf_2d_rec *_2d,*histo_mask;
{
 unsigned int row,col;
 unsigned int valuex;
 double val;

 for (row = 0; row < _2d->dimy; row++)
    {
     for (col = 0; col < _2d->dimx; col++)
        {val = _2d->GetVal(_2d,row,col);
         valuex = ULongRound(val);
         histo_mask->SetVal(histo_mask,0,valuex,(double) 1.0);
        }
    }
 TRACE(printf("get_1d_histo_map_mask...end\n"))
 histo_mask->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
get_2d_histo_map_mask - ???
--------------------------------------------------------------------------*/

int
get_2d_histo_map_mask(_2dx,_2dy,histo_mask)
 struct buf_2d_rec *_2dx,*_2dy,*histo_mask;
{
 unsigned int row,col;
 unsigned int valuex,valuey;
 double val;

 for (row = 0; row < _2dx->dimy; row++)
    {
     for (col = 0; col < _2dx->dimx; col++)
        {val = _2dx->GetVal(_2dx,row,col);
         valuex = ULongRound(val);
         val = _2dy->GetVal(_2dy,row,col);
         valuey = ULongRound(val);
         histo_mask->SetVal(histo_mask,valuey,valuex,(double) 1.0);
        }
    }
 TRACE(printf("get_2d_map...end\n"))
 histo_mask->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
GetHistoMapMask - ???
--------------------------------------------------------------------------*/

int
GetHistoMapMask(img,histo_mask,mask,affected)
 struct img_buf_rec *img;
 struct buf_2d_rec *histo_mask,*mask;
 struct int_bound_rec *affected;
{
 unsigned int cnt,histo_dimx,histo_dimy,pixel_depth;
 struct img_buf_rec *img1;
 int err;
 unsigned short status2;

 if ((img1 = pick_first_img_buf_rec_partner(img)) == NULL) return CANCEL;
 if (img->file->hdr.data_info.num_echoes == 2) 
    cnt = cnt_img_buf_rec_partners(img1);
   else cnt = 1;
 if (cnt != img1->file->hdr.data_info.num_echoes) return CANCEL;
 status2 = file_get_def_histo_type(img->file);
 get_histo_dim(&(img->file->histo_params),
                  &histo_dimx,&histo_dimy,&pixel_depth,status2);
  if ((histo_dimx == 0) || (histo_dimy == 0) || (pixel_depth == 0))
    return CANCEL;

 if (!(histo_mask->status4 & BUF_NON_EMPTY) ||
     (histo_mask->dimx != img1->_2d.dimx) ||
     (histo_mask->dimy != img1->_2d.dimy) ||
     (histo_mask->pixel_depth != 1))
    {if ((err = SetupBuf2dRec(histo_mask,histo_dimx,histo_dimy,1,1))
            != NO_ERROR)
        return err;}

 switch (cnt)
    {
     case 2 :
        if (((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
                (double) .0,(double) (histo_dimx - 1),
                0,(double) .0, (double) .0,0)) != NO_ERROR) ||
            ((err = Scale2dPixels(&(img1->partner->_2d),&(img1->partner->_2d),
                (double) .0,(double) (histo_dimy - 1),
                 0,(double) .0, (double) .0,0)) != NO_ERROR))
           return err;
        if (mask != NULL)
           err = Get2dHistoMapMaskByMask(mask,affected,
                    &(img1->_2d),&(img1->partner->_2d),histo_mask);
          else err = get_2d_histo_map_mask(&(img1->_2d),&(img1->partner->_2d),
                          histo_mask);
        break;
     default :
        if ((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
              (double) .0,(double) (histo_dimx - 1),
              0,(double) .0,(double) .0,0)) != NO_ERROR)
           return err;
        if (mask != NULL)
           err = Get1dHistoMapMaskByMask(mask,affected,
                       &(img->_2d),histo_mask);
          else err = get_1d_histo_map_mask(&(img->_2d),histo_mask);
        break;
   }
 return err;
}


/*--------------------------------------------------------------------------
GetHistoRoiMask - ???
--------------------------------------------------------------------------*/

int
GetHistoRoiMask(img,mask,affected,option,image_view_roi)
 struct img_buf_rec *img;
 struct draw_mask_rec *mask;
 struct int_bound_rec *affected;
 int option;
 struct roi_rec *image_view_roi;
{
 struct slice_roi_win_rec *slice_roi_win;
 struct roi_rec *roi;
 struct curve_rec *curve;
 long minx,maxx,miny,maxy,col,lcv;
 int err;
 struct curve_2d_rec *pen;
 unsigned short histo_type;

 histo_type = file_get_def_histo_type(img->file);
 slice_roi_win = (struct slice_roi_win_rec *)
          GetHistoSliceRoiWinRec(&(img->file->histo_params),histo_type);
 apply_to_slice_roi_rec(&(slice_roi_win->slice_roi),set_curve_or,
			0,0,0,0,0,0,0,0,0);
 if (img->file->hdr.data_info.num_echoes == 2)
    return GetRoiMask(&(slice_roi_win->slice_roi),NULL,
             img->_2d.dimx,img->_2d.dimy,
             mask,affected,option,image_view_roi);
   else
    {
     if ((err = get_draw_mask_rec(mask,img->_2d.dimx,img->_2d.dimy)) != 
                NO_ERROR)
        return err;
     if (option == ALL_ROIS)
        {
         for (lcv = 0; lcv < slice_roi_win->slice_roi.num_rois; lcv++)
            {roi = slice_roi_win->slice_roi.rois[lcv];
             if (is_roi_non_empty(roi)) continue;
             FindRoiLongMinMax(roi,NULL,&minx,&maxx,&miny,&maxy,0,0,0);
             if ((minx > maxx) || (miny > maxy)) continue;
             for (col = minx; col <= maxx; col++)
                mask->mask._2d.SetVal(&(mask->mask._2d),0,col,(double) 1.0);
            }
         return NO_ERROR;
        }
       else if (option == CUR_CURVE)
        {if (((curve = get_cur_curve(&(slice_roi_win->slice_roi))) == NULL) ||
             !is_curve_non_empty(curve) ||
             ((pen = get_cur_pen(&(slice_roi_win->slice_roi))) == NULL))
            return NO_ERROR;
         FindCurveLongMinMax(curve,NULL,
                 &minx,&maxx,&miny,&maxy,pen->pen_type,0,0,0);
        }
       else
        {if (((roi = get_cur_roi(&(slice_roi_win->slice_roi))) == NULL) ||
                !is_roi_non_empty(roi))
            return NO_ERROR;
         FindRoiLongMinMax(roi,NULL,&minx,&maxx,&miny,&maxy,0,0,0);}

     if ((minx > maxx) || (miny > maxy))
        return NO_ERROR;
     printf("minx = %ld  maxx = %ld\n",minx,maxx);
     for (col = minx; col <= maxx; col++)
        mask->mask._2d.SetVal(&(mask->mask._2d),0,col,(double) 1.0);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
Get1dMapByMask - ???
--------------------------------------------------------------------------*/

int
Get1dMapByMask(mask,affected,pixel_type_map,result_map)
 struct buf_2d_rec *mask,*pixel_type_map,*result_map;
 struct int_bound_rec *affected;
{
 return assign_buf_2d_rec_by_mask(result_map,
                          pixel_type_map,0,0,mask,affected);
}


/******************
 unsigned int row,col,col_bit,indx,start_bit,end_bit,cnt;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char source_byte;
 unsigned int start_byte,start_col_bit,stop_byte,valuex;
 unsigned int left,right,top,bottom;
 struct int_bound_rec bound;
 double val;

 setup_int_bound_rec(&bound,0,0,mask->dimx - 1,mask->dimy - 1);
 if (affected == NULL)
    valid_bound(&bound,&bound,&left,&right,&top,&bottom);
   else valid_bound(affected,&bound,&left,&right,&top,&bottom);

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if (source_byte = mask->buf[row][col])
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & _1_bit[cnt])
                  {val = _2d->GetVal(_2d,row,indx);
                   valuex = ULongRound(val);
                   val = pixel_type_map->GetVal(pixel_type_map,0,valuex);
                   result_map->SetVal(result_map,row,indx,val);
                  }
            }
    }
 result_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}
************************/


/*--------------------------------------------------------------------------
Get2dMapByMask - ???
--------------------------------------------------------------------------*/

int
Get2dMapByMask(mask,affected,_2dx,_2dy,pixel_type_map,result_map)
 struct buf_2d_rec *mask,*_2dx,*_2dy,*pixel_type_map,*result_map;
 struct int_bound_rec *affected;
{
 unsigned int row,col,col_bit,indx,start_bit,end_bit,cnt;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char source_byte;
 unsigned int start_byte,start_col_bit,stop_byte,valuex,valuey;
 unsigned int left,right,top,bottom;
 struct int_bound_rec bound;
 double val;

 TRACE(printf("Get2dMapByMask...begin\n"))
 setup_int_bound_rec(&bound,0,0,mask->dimx - 1,mask->dimy - 1);
 if (affected == NULL)
    valid_bound(&bound,&bound,&left,&right,&top,&bottom);
   else valid_bound(affected,&bound,&left,&right,&top,&bottom);
 TRACE(printf("Get2dMapByMask...1\n"))

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if (source_byte = mask->buf[row][col])
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & _1_bit[cnt])
                  {val = _2dx->GetVal(_2dx,row,indx);
                   valuex = ULongRound(val);
                   val = _2dy->GetVal(_2dy,row,indx);
                   valuey = ULongRound(val);
                   val = pixel_type_map->GetVal(pixel_type_map,valuey,valuex);
                   result_map->SetVal(result_map,row,indx,val);
                  }
            }
    }
 result_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
get_1d_map - ???
--------------------------------------------------------------------------*/

int
get_1d_map(pixel_type_map,result_map)
 struct buf_2d_rec *pixel_type_map,*result_map;
{
 return copy_buf_2d_rec_content(result_map,pixel_type_map);
}


/****************
 unsigned int row,col;
 unsigned int valuex,value;

 TRACE(printf("get_1d_map..._2d = %d %d pixel_type_map = %d %d result_map = %d %d\n",_2d->pixel_depth,_2d->total_bytes,
 pixel_type_map->pixel_depth,pixel_type_map->total_bytes,
 result_map->pixel_depth,result_map->total_bytes))

 TRACE(printf("dimx = %d dimy = %d\n",_2d->dimx,_2d->dimy))

 for (row = 0; row < _2d->dimy; row++)
    {
     for (col = 0; col < _2d->dimx; col++)
        {val = _2d->GetVal(_2d,row,col);
         valuex = ULongRound(val);
         val = pixel_type_map->GetVal(pixel_type_map,0,valuex);
         result_map->SetVal(result_map,row,col,val);
        }
    }
 TRACE(printf("get_1d_map...end\n"))
 result_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}
******************/


/*--------------------------------------------------------------------------
get_2d_map - ???
--------------------------------------------------------------------------*/

int
get_2d_map(_2dx,_2dy,pixel_type_map,result_map)
 struct buf_2d_rec *_2dx,*_2dy,*pixel_type_map,*result_map;
{
 unsigned int row,col;
 unsigned int valuex,valuey;
 double val;

 TRACE(printf("get_2d_map...\n"))
 TRACE(pr_buf_2d_rec(_2dx))
 TRACE(pr_buf_2d_rec(_2dy))
 TRACE(pr_buf_2d_rec(pixel_type_map))
 TRACE(pr_buf_2d_rec(result_map))
 for (row = 0; row < _2dx->dimy; row++)
    {
     for (col = 0; col < _2dx->dimx; col++)
        {val = _2dx->GetVal(_2dx,row,col);
         valuex = ULongRound(val);
         val = _2dy->GetVal(_2dy,row,col);
         valuey = ULongRound(val);
         val = pixel_type_map->GetVal(pixel_type_map,valuey,valuex);
         result_map->SetVal(result_map,row,col,val);
        }
    }
 TRACE(printf("get_2d_map...end\n"))

 result_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
Get1dMapByMaskPick - ???
--------------------------------------------------------------------------*/

int
Get1dMapByMaskPick(mask,affected,pixel_type_map,result_map,picks,num_picks)
 struct buf_2d_rec *mask,*pixel_type_map,*result_map;
 struct int_bound_rec *affected;
 char *picks;
 unsigned long num_picks;
{
 int err;

 if (picks == NULL) return NO_ERROR;
 if ((err = PickAssign2d(result_map,pixel_type_map,
            pixel_type_map,0,0,mask,affected,picks,num_picks)) == NO_ERROR)
    result_map->status4 |= BUF_DATA_VALID;
 return err;
}


/*--------------------------------------------------------------------------
Get2dMapByMask_pick - ???
--------------------------------------------------------------------------*/

int
Get2dMapByMask_pick(mask,affected,_2dx,_2dy,pixel_type_map,result_map,picks)
 struct buf_2d_rec *mask,*_2dx,*_2dy,*pixel_type_map,*result_map;
 struct int_bound_rec *affected;
 char *picks;
{
 unsigned int row,col,col_bit,indx,start_bit,end_bit,cnt;
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 unsigned char source_byte;
 unsigned int start_byte,start_col_bit,stop_byte,valuex,valuey;
 unsigned int left,right,top,bottom;
 struct int_bound_rec bound;
 double val;

 TRACE(printf("Get2dMapByMask...begin\n"))
 if (picks == NULL) return NO_ERROR;
 setup_int_bound_rec(&bound,0,0,mask->dimx - 1,mask->dimy - 1);
 if (affected == NULL)
    valid_bound(&bound,&bound,&left,&right,&top,&bottom);
   else valid_bound(affected,&bound,&left,&right,&top,&bottom);
 TRACE(printf("Get2dMapByMask...1\n"))

 start_byte = left / 8;
 start_col_bit = start_byte * 8;
 stop_byte = right / 8 + 1;
 for (row = top; row <= bottom; row++)
    {
     start_bit = left - start_col_bit;
     end_bit = 8;
     for (col_bit = start_col_bit,col = start_byte;
             col < stop_byte; col++,col_bit += 8,start_bit = 0)
        if (source_byte = mask->buf[row][col])
           {
            if ((col_bit + 8) > right) end_bit = right - col_bit + 1;
            for (indx = col_bit + start_bit,cnt = start_bit;
                                cnt < end_bit; cnt++,indx++)
               if (source_byte & _1_bit[cnt])
                  {val = _2dx->GetVal(_2dx,row,indx);
                   valuex = ULongRound(val);
                   val = _2dy->GetVal(_2dy,row,indx);
                   valuey = ULongRound(val);
                   val = pixel_type_map->GetVal(pixel_type_map,valuey,valuex);
                   valuex = ULongRound(val);
                   if (picks[valuex])
                      result_map->SetVal(result_map,row,indx,val);
                  }
            }
    }
 result_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
Get1dMapPick - ???
--------------------------------------------------------------------------*/

int
Get1dMapPick(pixel_type_map,result_map,picks,num_picks)
 struct buf_2d_rec *pixel_type_map,*result_map;
 char *picks;
 unsigned long num_picks;
{
 int err;

 if (picks == NULL) return NO_ERROR;
 /* FIXME!!!:  The following call to PickAssign2d is not consistent with
    the definition of that function and cannot be fixed until the context
    here and there is thoroughly understood.  For the moment, just report
    an error and skip the function.  -PWH 19990301 */
#if 0
 err = PickAssign2d(result_map, pixel_type_map,0,0,NULL,NULL,picks);
#else
 err = PROGRAM_ERROR;
#endif
 if (err == NO_ERROR)
    result_map->status4 |= BUF_DATA_VALID;
 return err;
}


/*--------------------------------------------------------------------------
get_2d_map_pick - ???
--------------------------------------------------------------------------*/

int
get_2d_map_pick(_2dx,_2dy,pixel_type_map,result_map,picks)
 struct buf_2d_rec *_2dx,*_2dy,*pixel_type_map,*result_map;
 char *picks;
{
 unsigned int row,col;
 unsigned int valuex,valuey;
 double val;

 if (picks == NULL) return NO_ERROR;
 for (row = 0; row < _2dx->dimy; row++)
    {
     for (col = 0; col < _2dx->dimx; col++)
        {val = _2dx->GetVal(_2dx,row,col);
         valuex = ULongRound(val);
         val = _2dy->GetVal(_2dy,row,col);
         valuey = ULongRound(val);
         val = pixel_type_map->GetVal(pixel_type_map,valuey,valuex);
         valuex = ULongRound(val);
         if (picks[valuex]) result_map->SetVal(result_map,row,col,val);
        }
    }
 TRACE(printf("get_2d_map...end\n"))
 result_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_map - ???
--------------------------------------------------------------------------*/

int
get_map(img,slice_map,mask,affected,pixel_type_map)
 struct img_buf_rec *img;
 struct buf_2d_rec *slice_map,*mask,*pixel_type_map;
 struct int_bound_rec *affected;
{
 unsigned int cnt;
 struct img_buf_rec *img1;
 int err;

 PRT5(printf("get_map img = %u\n",img))
 if ((img1 = pick_first_img_buf_rec_partner(img)) == NULL) return CANCEL;
 cnt = cnt_img_buf_rec_partners(img1);
 if (cnt != img1->file->hdr.data_info.num_echoes) return CANCEL;

 if (!(slice_map->status4 & BUF_NON_EMPTY) ||
     (slice_map->dimx != img1->_2d.dimx) ||
     (slice_map->dimy != img1->_2d.dimy) ||
     (slice_map->pixel_depth != img1->_2d.pixel_depth))
    {
     PRT5(printf("pixel_depth = %d\n",pixel_type_map->pixel_depth))
     if ((err = SetupBuf2dRec(slice_map,img1->_2d.dimx,
                  img1->_2d.dimy,pixel_type_map->pixel_depth,0)) != NO_ERROR)
        return err;
     PRT5(printf("reinit slice_map dimx = %d dimy = %d dep = %d tot = %d\n",
       slice_map->dimx,slice_map->dimy,slice_map->pixel_depth,
                  slice_map->total_bytes))
     if (mask != NULL)
        InitBuf2dRecData(slice_map,(double) .0);
    }
 PRT5(printf("get_map img = %u....cnt = %d\n",img,cnt))

 if ((err = RdCurSliceEchoes(img1,1,4)) == NO_ERROR)
    {
     switch (cnt)
        {case 2 :
          PRT5(printf("get_map %s slice_num = %d  %s partner = %d\n",
            img1->cur_slice->img_label,img1->cur_slice->slice_num,
            img1->partner->cur_slice->img_label,img1->partner->cur_slice->slice_num))
           if (((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
                   (double) .0, (double) (pixel_type_map->dimx - 1),
                   0, (double) .0, (double) .0,0)) != NO_ERROR) ||
               ((err = Scale2dPixels(&(img1->partner->_2d),
                    &(img1->partner->_2d),
                   (double) .0, (double) (pixel_type_map->dimy - 1),
                   0, (double) .0, (double) .0,0)) != NO_ERROR))
              return err;

            PRT5(printf("img1->cur_slice->img_label = %s pertner = %s %d %d\n",
            img1->cur_slice->img_label, img1->partner->cur_slice->img_label,
            img1->cur_slice->num,img1->partner->cur_slice->num))

           if (mask != NULL)
              err = Get2dMapByMask(mask,affected,
                   &(img1->_2d),&(img1->partner->_2d),pixel_type_map,slice_map);
            else err = get_2d_map(&(img1->_2d),&(img1->partner->_2d),
                          pixel_type_map,slice_map);
           break;
         default :
           if ((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
                  (double) .0,(double) (pixel_type_map->dimx - 1),
                  0,(double) .0,(double) .0,0)) != NO_ERROR)
              return err;
           if (mask != NULL)
              {if ((err = assign_buf_2d_rec_by_mask(slice_map,
                          pixel_type_map,0,0,mask,affected)) == NO_ERROR)
                  slice_map->status4 |= BUF_DATA_VALID;
              }
             else if ((err = copy_buf_2d_rec_content(slice_map,pixel_type_map))
                            == NO_ERROR)
              slice_map->status4 |= BUF_DATA_VALID;
           break;
        }
    }
 PRT5(printf("get_map end err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
get_cur_slice_map - ???
--------------------------------------------------------------------------*/

struct buf_2d_rec *
get_cur_slice_map(file,cur_slice)
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *cur_slice;
{
 struct buf_2d_rec *pixel_type_map;
 struct img_rec img;
 int err;
 long sl_num;

 PRT5(printf("get_cur_slice_map pixel_type.status = %x cur_slice->slice_num = %d num_strs = %d\n",
       (unsigned long) file->pixel_type.status,(long) cur_slice->slice_num,
       file->pixel_type.order.num_strs))
 if (file->pixel_type.order.num_strs == 0) return NULL;
 if ((cur_slice->status & SLICE_HISTOGRAM_1D) ||
     (cur_slice->status & SLICE_HISTOGRAM_2D))
    return NULL;
 if ((file->hdr.data_info.num_echoes != 2) ||
     (file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    {
     PRT5(printf("get_cur_slice_map file->slice_info.num_sroi_wins = %d\n",
             file->slice_info.num_sroi_wins))
     if ((cur_slice->slice_num < 0) ||
         (cur_slice->slice_num >= file->slice_info.num_sroi_wins))
        return NULL;
     PRT5(printf("pixel_type.status = %x  num_slice_maps = %d\n",(unsigned long)
             file->pixel_type.status,file->pixel_type.num_slice_maps))

     sl_num = cur_slice->slice_num;
     if ((sl_num < file->pixel_type.num_slice_maps) &&
         (file->pixel_type.slice_maps[sl_num] != NULL) &&
         (file->pixel_type.slice_maps[sl_num]->status4 & BUF_DATA_VALID))
        {PRT5(printf("get_cur_slice_map... \n");
              pr_buf_2d_rec(file->pixel_type.slice_maps[sl_num]))
         PRT5(MinMax2dValues(file->pixel_type.slice_maps[sl_num],
                   0,(double) .0,(double) .0,
                    &min4,&max4);
          printf("sl_num = %d min4 = %f max4 = %f\n",
              sl_num,min4,max4);)
         return file->pixel_type.slice_maps[sl_num];}
       else if (file->pixel_type.status & PIXEL_TYPE_PIXMAP_HDR_VALID)
        {PRT5(printf("PIXEL_TYPE_PIXMAP_HDR_VALID max_slices = %d sl_num = %d pixmap_offsets = %u\n",
            file->pixel_type.pixmap_hdr.max_slices,sl_num,
            file->pixel_type.pixmap_hdr.pixmap_offsets[sl_num]))
         if ((sl_num >= file->pixel_type.pixmap_hdr.max_slices) ||
             (file->pixel_type.pixmap_hdr.pixmap_offsets[sl_num] == 0)) 
            return NULL;

         PRT5(printf("num_slice_maps = %d  max_slices = %d \n",
         file->pixel_type.num_slice_maps,file->pixel_type.pixmap_hdr.max_slices);)

         if (file->pixel_type.num_slice_maps != file->slice_info.num_sroi_wins)
            {PRT5(printf("rd_file_pixmap_for_slice_num...1\n"))
             err = rd_file_pixmap_for_slice_num(file->output.dirfn,file->output.fn,
              PIXMAP_SUFFIX,&(file->pixel_type),
              file->slice_info.num_sroi_wins,NULL,sl_num);}
           else err = rd_file_pixmap_for_slice_num(
              file->output.dirfn,file->output.fn,PIXMAP_SUFFIX,&(file->pixel_type),
              file->slice_info.num_sroi_wins,
               file->pixel_type.slice_maps[sl_num],sl_num);
         if (err == NO_ERROR)
            return file->pixel_type.slice_maps[sl_num];
        }
     PRT5(printf("===file->pixel_type.status = %x\n",(unsigned long)
             file->pixel_type.status))

     return NULL;
    }

 PRT5(printf("thresholding file->pixel_type.map.status4 = %x slice_map.status4 = %x\n",
          (unsigned long) file->pixel_type.map.status4,
          (unsigned long) file->pixel_type.slice_map.status4))

 if ((file->pixel_type.slice_roi_win == 
     cur_slice->slice->slice_roi_win) &&
     (file->pixel_type.slice_map.status4 & BUF_DATA_VALID))
    {PRT5(printf("get_cur_slice_map..old.2 echo computed\n"))
     return &(file->pixel_type.slice_map);}

 init_img_rec(&img,file);
 if (NewImgBuf(&img,cur_slice,&err,0,0,0,0,0,0,1) == NULL)
    {free_img_rec(&img);
     PRT5(printf("get_cur_slice_map..err = %d NewImgBuf == NULL\n",err))
     return NULL;}
 pixel_type_map = &(img.data[0]->file->pixel_type.map);
 if (!(pixel_type_map->status4 & BUF_NON_EMPTY)) return NULL;

 PRT5(printf("get_map...\n"))
 err = get_map(img.data[0],&(file->pixel_type.slice_map),
          NULL,NULL,pixel_type_map);
 free_img_rec(&img);
 if ((err == NO_ERROR) && (file->pixel_type.slice_map.status4 & BUF_DATA_VALID))
    {
     PRT5(MinMax2dValues(&(file->pixel_type.slice_map),0,(double) .0,(double) .0,
                    &min4,&max4);
          printf("get_cur_slice_map new depth = %d min4 = %f max4 = %f\n",
              file->pixel_type.slice_map.pixel_depth,min4,max4);)
     file->pixel_type.slice_roi_win = cur_slice->slice->slice_roi_win;
     return &(file->pixel_type.slice_map);}
   else
    {PRT5(printf("new get_cur_slice_map...NULL\n"))
     return NULL;}
}


/*--------------------------------------------------------------------------
get_img_pixel_type_map - ???
--------------------------------------------------------------------------*/

struct buf_2d_rec *
get_img_pixel_type_map(img)
 struct img_buf_rec *img;
{
 if (img == NULL) return NULL;
 if ((img->file->hdr.data_info.num_echoes == 2) &&
     !(img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    {if (!(img->file->pixel_type.map.status4 & BUF_DATA_VALID)) 
        return NULL;
       else return &(img->file->pixel_type.map);
    }
   else
    return get_cur_slice_map(img->file,img->cur_slice);
}


/*--------------------------------------------------------------------------
IsAllPixelTypeMapReady - ???

 0 = pixel types for all slices are not defined
 1 = some is defined
 2 = all defined
--------------------------------------------------------------------------*/

int
IsAllPixelTypeMapReady(pixel_type,hdr)
 struct pixel_type_rec *pixel_type;
 struct hdr_rec *hdr;
{
 long lcv;
 struct pixmap_hdr_rec *pixhdr;
 long num_slices;
 int yes;

 TRACE(printf("IsAllPixelTypeMapReady num_slice_maps = %d\n",
             pixel_type->num_slice_maps);)
 if (pixel_type->order.num_strs == 0) return 0;
 num_slices = NumberOfSliceCuts(&(hdr->data_info));
 TRACE(printf("IsAllPixelTypeMapReady num_slices = %d\n",
             num_slices);)
 if ((hdr->data_info.num_echoes == 2) &&
     !(pixel_type->status & PIXMAP_METHOD_DEFINED))
    {
     TRACE(printf("IsAllPixelTypeMapReady partitioned\n");)
     if (pixel_type->map.status4 & BUF_DATA_VALID)
        return 2;
    }
   else if (pixel_type->num_slice_maps == num_slices)
    {pixhdr = &(pixel_type->pixmap_hdr);
     TRACE(if (pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID)
        printf("PIXEL_TYPE_PIXMAP_HDR_VALID...\n");)
     TRACE(printf("IsAllPixelTypeMapReady pixmap\n");)
     for (yes = 0,lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
        if (!(pixel_type->slice_maps[lcv]->status4 & BUF_DATA_VALID)) 
           {TRACE(printf("lcv = %d\n",lcv);)
            if ((pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID) &&
                (lcv < pixhdr->max_slices) &&
                (pixhdr->pixmap_offsets[lcv] != 0))
               {yes = 1;
                continue;}
            break;}
          else yes = 1;
     if (lcv == pixel_type->num_slice_maps) return 2;
     TRACE(printf("IsAllPixelTypeMapReady lcv = %d\n",lcv);)
     if (yes) return 1;
     for (lcv++; lcv < pixel_type->num_slice_maps; lcv++)
        if (!(pixel_type->slice_maps[lcv]->status4 & BUF_DATA_VALID)) 
           {
            if ((pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID) &&
                (lcv < pixhdr->max_slices) &&
                (pixhdr->pixmap_offsets[lcv] != 0))
               return 1;
           }
          else return 1;
    }
 return 0;
}


/*--------------------------------------------------------------------------
is_all_pixel_type_map_ready - ???
--------------------------------------------------------------------------*/

int
is_all_pixel_type_map_ready(file)
 struct input_file_rec *file;
{
 return IsAllPixelTypeMapReady(&(file->pixel_type),&(file->hdr));
}


/*--------------------------------------------------------------------------
setup_cur_slice_map - ???
--------------------------------------------------------------------------*/

int
setup_cur_slice_map(slice_map,slice_map_ptr,file,cur_slice)
 struct buf_2d_rec *slice_map,**slice_map_ptr;
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *cur_slice;
{
 struct buf_2d_rec *pixel_type_map;

 if ((pixel_type_map = get_cur_slice_map(file,cur_slice)) == NULL)
    return CANCEL;

 if (file->hdr.data_info.num_echoes != 2)
    {
     if (slice_map_ptr != NULL)
        {*slice_map_ptr = pixel_type_map;
         return NO_ERROR;}
    }
   else
    if (slice_map_ptr != NULL) *slice_map_ptr = slice_map;
 return copy_buf_2d_rec(slice_map,pixel_type_map);
}


/*--------------------------------------------------------------------------
SetupThresholdingPixelTypeMaps - ???
--------------------------------------------------------------------------*/

int
SetupThresholdingPixelTypeMaps(file)
 struct input_file_rec *file;
{
 unsigned long num_slices,lcv;
 struct pixel_type_rec *pixel_type;
 struct hdr_scan_entry_rec *cur_slice;
 int err,is_init;
 struct img_rec img;

 num_slices = NumberOfSliceCuts(&(file->hdr.data_info));
 PRT4(printf("SetupThresholdingPixelTypeMaps...\n"))
 pixel_type = &(file->pixel_type);
 err = NO_ERROR;
 if (pixel_type->num_slice_maps != num_slices)
    if ((err = setup_pixel_type_maps(pixel_type,num_slices)) != NO_ERROR)
       return err;
 pixel_type->pixmap_hdr.status &= ~PIXEL_TYPE_SETUP_METHOD;
 for (is_init = 1,lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
    {if (is_init)
        {is_init = 0;
         init_img_rec(&img,file);
         if ((err = LocateScanEntry(&(file->hdr),
                       lcv,0,0,&cur_slice)) == NO_ERROR)
            if (NewImgBuf(&img,cur_slice,&err,0,0,0,0,0,0,1) == NULL)
               {if (err == NO_ERROR) err = CANCEL;
                break;}
        }
       else if ((err = LocateScanEntry(&(file->hdr),
                       lcv,0,0,&cur_slice)) == NO_ERROR)
        get_all_next_slice_echoes(img.data[0],cur_slice);
     err = get_map(img.data[0],pixel_type->slice_maps[lcv],
                      NULL,NULL,&(file->pixel_type.map));
     PRT4(printf("is_compute %d) err = %d slice_num = %d  %d\n",lcv,err,cur_slice->slice_num,img.data[0]->cur_slice->slice_num);
            MinMax2dValues(pixel_type->slice_maps[lcv],0,(double) .0,(double) .0,
                    &min4,&max4);
     printf("%d) depth = %d min4 = %f max4 = %f\n",lcv,
              pixel_type->slice_maps[lcv]->pixel_depth,min4,max4);)

     if (err != NO_ERROR) break;
    }
 if (!is_init)
    free_img_rec(&img);
 return err;
}


/*--------------------------------------------------------------------------
SetupGrowRegionPixelTypeMaps - ???
--------------------------------------------------------------------------*/

int
SetupGrowRegionPixelTypeMaps(file)
 struct input_file_rec *file;
{
 unsigned long num_slices,lcv;
 struct pixel_type_rec *pixel_type;
 int err;

 PRT4(printf("SetupGrowRegionPixelTypeMaps...\n"))
 if (!(file->pixel_type.status & PIXEL_TYPE_PIXMAP_HDR_VALID))
    {PRT4(printf("SetupGrowRegionPixelTypeMaps...not PIXEL_TYPE_PIXMAP_HDR_VALID\n"))
     return CANCEL;}
 num_slices = NumberOfSliceCuts(&(file->hdr.data_info));
 pixel_type = &(file->pixel_type);
 err = NO_ERROR;
 if (pixel_type->num_slice_maps != num_slices)
    if ((err = setup_pixel_type_maps(pixel_type,num_slices)) != NO_ERROR)
       return err;
 PRT4(printf("SetupGrowRegionPixelTypeMaps...1\n"))

 for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
    {if (!(pixel_type->slice_maps[lcv]->status4 & BUF_NON_EMPTY))
        if ((err = rd_file_pixmap_for_slice_num(
              file->output.dirfn,file->output.fn,PIXMAP_SUFFIX,pixel_type,
              num_slices,pixel_type->slice_maps[lcv],lcv)) != NO_ERROR)
           break;
    }
 PRT4(printf("SetupGrowRegionPixelTypeMaps...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
SetupAllSliceMaps - ???
--------------------------------------------------------------------------*/

int
SetupAllSliceMaps(file,is_ready)
 struct input_file_rec *file;
 int *is_ready;
{
 struct pixel_type_rec *pixel_type;
 int err;

 pixel_type = &(file->pixel_type);
 PRT5(printf("SetupAllSliceMaps num_slice_maps = %d num_strs = %d\n",
             pixel_type->num_slice_maps,pixel_type->order.num_strs);)
 if ((*is_ready = IsAllPixelTypeMapReady(pixel_type,&(file->hdr))) == 0)
    return NO_ERROR;

 PRT5(printf("IsAllPixelTypeMapReady *is_ready = %d \n",
             *is_ready);)
 if ((file->hdr.data_info.num_echoes == 2) &&
     !(pixel_type->status & PIXMAP_METHOD_DEFINED))
    {
     PRT5(printf("IsAllPixelTypeMapReady partitioned\n");)
     if ((err = SetupThresholdingPixelTypeMaps(file)) != NO_ERROR)
        return err;
    }
   else err = SetupGrowRegionPixelTypeMaps(file);
 if (err == NO_ERROR)
    *is_ready = IsAllPixelTypeMapReady(pixel_type,&(file->hdr));
 PRT5(printf("SetupAllSliceMaps err = %d *is_ready = %d\n",err,*is_ready);)

 return err;

}


/*--------------------------------------------------------------------------
get_histo_map - ???
--------------------------------------------------------------------------*/

struct buf_2d_rec *
get_histo_map(img)
 struct img_buf_rec *img;
{
 int err;
 struct buf_2d_rec *pixel_type_map;

 TRACE(printf("\nget_histo_map...\n"))
 if ((img->file->hdr.data_info.num_echoes != 2) ||
     (img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    return NULL;

 if ((pixel_type_map = get_img_pixel_type_map(img)) == NULL) return NULL;
 TRACE(printf("\nget_histo_map...1\n"))

 if (!(img->file->histo_params.map.status4 & BUF_DATA_VALID))
    {TRACE(printf("redefine histo map...\n"))
     if ((err = get_histo_map_from_pixel_type_map(&(img->file->histo_params),
               &(img->file->pixel_type))) != NO_ERROR)
        return NULL;
    }

 if (img->file->histo_params.map.status4 & BUF_DATA_VALID)
    return &(img->file->histo_params.map);
   else return NULL;

}


/*--------------------------------------------------------------------------
GetHistoPixelTypeLabel - ???
--------------------------------------------------------------------------*/

char *
GetHistoPixelTypeLabel(img,x,y,win_type2)
 struct img_buf_rec *img;
 unsigned int x,y;
 unsigned short win_type2;
{
 unsigned int cnt;
 unsigned int valuex,valuey;
 double value;
 char *str;
 int err;
 unsigned int status2;
 struct img_buf_rec *img1;

 TRACE(printf("GetHistoPixelTypeLabel...begin\n"))
 if (img == NULL) return NULL;
 if (!(img->file->histo_params.status2 & HISTO_TYPE)) return NULL;
 if ((img1 = pick_first_img_buf_rec_partner(img)) == NULL) return NULL;
 cnt = img1->file->hdr.data_info.num_echoes;

 status2 = file_get_def_histo_type(img1->file);
 if (((status2 & HISTO_1D) && (win_type2 & HISTOGRAM_1D_WINDOWS)) ||
     ((status2 & HISTO_MULTI_D) && (win_type2 & HISTOGRAM_MULTI_D_WINDOW)))
    {
     if (!(img1->file->pixel_type.status & HISTO_AND_PIXEL_TYPE_RELATED))
        {if ((err = cp_str(&str,"UNKNOWN")) == NO_ERROR) return str;
           else return NULL;}
    }
  else return NULL;

 if (!(img1->file->histo_params.map.status4 & BUF_DATA_VALID))
    if ((err = build_histo_pixel_type_map(&(img1->file->histo_params)))
         != NO_ERROR) return NULL;
 if (!(img1->file->histo_params.map.status4 & BUF_DATA_VALID))
    return NULL;
 switch (cnt)
    {case 1 :
        valuex = x;
        valuey = 0;
        break;
     case 2 :
        valuex = x;
        valuey = y;
        break;
     default :
        return NULL;
    }
 value = img1->file->histo_params.map.GetVal(&(img1->file->histo_params.map),
             valuey,valuex);
 TRACE(printf("GetHistoPixelTypeLabel...cnt = %d value = %f x = %d y = %d valuex = %d valuey = %d\n",cnt,value,x,y,valuex,valuey))

 valuex = ULongRound(value);
 if (valuex > img1->file->pixel_type.order.num_strs) return NULL;
 if (valuex == 0) 
    {if ((err = cp_str(&str,"UNKNOWN")) != NO_ERROR) return NULL;}
   else if ((err = cp_str(&str,img1->file->pixel_type.order.strs[valuex - 1]))
           != NO_ERROR) return NULL;
 TRACE(printf("GetHistoPixelTypeLabel...str = %s\n",str))
 return str;
}


/*--------------------------------------------------------------------------
get_pixel_type_label - ???
--------------------------------------------------------------------------*/

char *
get_pixel_type_label(img,x,y)
 struct img_buf_rec *img;
 unsigned int x,y;
{
 double valuex,valuey,value;
 unsigned long row,col,indx;
 struct buf_2d_rec *slice_map;
 struct hdr_scan_entry_rec *first;
 char *str;
 int err;

 PRT2(printf("get_pixel_type_label...num_strs = %d status = %x\n",
      img->file->pixel_type.order.num_strs,
      (unsigned long) img->file->pixel_type.status))
 if (img == NULL) return NULL;
 if ((img->file->hdr.data_info.num_echoes != 2) ||
     (img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    {if ((slice_map = get_cur_slice_map(img->file,img->cur_slice)) == NULL) 
        return NULL;
     value = slice_map->GetVal(slice_map,y,x);
     PRT2(printf("==get_pixel_type_label...value = %f x = %d y = %d \n",value,x,y))
    }
   else
    {if (!(img->file->pixel_type.map.status4 & BUF_DATA_VALID)) return NULL;
     first = pick_first_partner_slice(img->cur_slice);
     if ((RdFilePixel(img->file,first,y,x,&valuex) != NO_ERROR) ||
         (RdFilePixel(img->file,first->partner_slice,y,x,&valuey) != NO_ERROR))
        return NULL;
/*
     num_bytes = img->file->hdr.data_info.pixel_depth_bits / 8;
     offset = num_bytes * (x + y * img->file->hdr.data_info.dimx);

     img_addr = first->img_addr + offset;
     fseek(img->file->img_fid,img_addr,0);
     if (fread(&valuex,(size_t) num_bytes,(size_t) 1,
                           img->file->img_fid) != 1)
        return NULL;
     valuex >>= (4 - num_bytes) * 8;
     img_addr = first->partner_slice->img_addr + offset;
     fseek(img->file->img_fid,img_addr,0);
     if (fread(&valuey,(size_t) num_bytes,(size_t) 1,
                           img->file->img_fid) != 1)
       return NULL;
     valuey >>= (4 - num_bytes) * 8;
*/
     valuex = ScaleVal(valuex,img->file->hdr.data_info.min_pixel,
                img->file->hdr.data_info.max_pixel,
                (double) .0,(double) (img->file->pixel_type.map.dimx - 1));
     valuey = ScaleVal(valuey,
                img->file->hdr.data_info.min_pixel,
                img->file->hdr.data_info.max_pixel,
                (double) .0,(double) (img->file->pixel_type.map.dimy - 1));
     row = ULongRound(valuey);
     col = ULongRound(valuex);
     value = img->file->pixel_type.map.GetVal(&(img->file->pixel_type.map),
                       row,col);
     PRT2(printf("histo row = %d col = %d...value = %f x = %d y = %d valuex = %f valuey = %f\n",row,col,value,x,y,valuex,valuey))
    }

 indx = ULongRound(value);
 PRT2(printf("get_pixel_type_label...indx = %d\n",indx))
 if (indx > img->file->pixel_type.order.num_strs) return NULL;
 if (indx == 0) 
    {if ((err = cp_str(&str,"UNKNOWN")) != NO_ERROR) return NULL;}
   else if ((err = cp_str(&str,img->file->pixel_type.order.strs[indx - 1]))
           != NO_ERROR) return NULL;
 PRT2(printf("get_pixel_type_label...str = %s\n",str))
 return str;
}


/*--------------------------------------------------------------------------
set_map - ???
--------------------------------------------------------------------------*/

int
set_map(dest,src)
 struct buf_2d_rec *dest,*src;
{
 unsigned int row,col,x,y,old_max,new_max,old_max1,new_max1;
 double val;

 old_max = dest->dimy - 1;
 new_max = src->dimy - 1;
 old_max1 = dest->dimx - 1;
 new_max1 = src->dimx - 1;
 for (row = 0; row < dest->dimy; row++)
    {y = (long) ScaleVal((double) row,(double) .0,(double) old_max,
                  (double) 0,(double) new_max);
     for (col = 0; col < dest->dimx; col++)
        {x = (long) ScaleVal((double) col,(double) .0,(double) old_max1,
                    (double) .0,(double) new_max1);
         val = src->GetVal(src,y,x);
         dest->SetVal(dest,row,col,val);
        }
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
build_histo_pixel_type_map - ???
--------------------------------------------------------------------------*/

int
build_histo_pixel_type_map(histo)
 struct histo_params_rec *histo;
{
 unsigned long lcv,pixel_depth,dimx1,dimy1;
 struct roi_rec *roi;
 int err;
 struct draw_mask_rec mask1;
 struct int_bound_rec affected;
 struct slice_roi_win_rec *slice_roi_win;
 unsigned int num_echoes;
 unsigned short status2,histo_type;

 histo_type = file_get_def_histo_type(histo->file);
 slice_roi_win = (struct slice_roi_win_rec *) 
              GetHistoSliceRoiWinRec(histo,histo_type);

 TRACE(printf("build_histo_pixel_type_map1 histo->pixel_type_order.num_strs = %d\n",histo->pixel_type_order.num_strs))
 TRACE(printf("slice_roi.dimx = %d  slice_roi.dimy = %d\n",
    slice_roi_win->slice_roi.dimx,slice_roi_win->slice_roi.dimy))

 if (histo->pixel_type_order.num_strs == 0) return CANCEL;
 if (slice_roi_win->slice_roi.num_rois == 0) return CANCEL;
 if (histo->file == NULL) return CANCEL;

 status2 = file_get_def_histo_type(histo->file);
 get_histo_dim(&(histo->file->histo_params),
                  &dimx1,&dimy1,&pixel_depth,status2);
 pixel_depth = find_num_bits_needed(histo->pixel_type_order.num_strs + 1);
 TRACE(printf("build_histo_pixel_type_map pixel_depth = %d\n",pixel_depth))

 init_draw_mask_rec(&mask1);

 TRACE(printf("build_histo_pixel_type_map1...2\n"))
 if (((err = get_draw_mask_rec(&mask1,dimx1,dimy1))  != NO_ERROR) ||
     ((err = SetupBuf2dRec(&(histo->map),dimx1,dimy1,pixel_depth,0)) 
              != NO_ERROR))
    {free_draw_mask_rec(&mask1);
     return err;}
 InitBuf2dRecData(&(histo->map),(double) .0);
 histo->map.status4 &= ~BUF_DATA_VALID;
 num_echoes = histo->file->hdr.data_info.num_echoes;

 TRACE(printf("build_histo_pixel_type_map1...num_echoes = %d\n",num_echoes))
 TRACE(pr_strs_rec(&(histo->pixel_type_order)))
 err = NO_ERROR;
 for (lcv = histo->pixel_type_order.num_strs; lcv > 0; )
    {lcv--;
     if ((roi = get_roi(&(slice_roi_win->slice_roi),
                     histo->pixel_type_order.strs[lcv])) != NULL)
        {
         TRACE(printf("build_histo_pixel_type_map1...lcv = %d\n",lcv))
         FindRoiLongMinMax(roi,NULL,&(affected.left),&(affected.right),
              &(affected.top),&(affected.bottom),0,0,0);
         TRACE(pr_int_bound_rec(&affected))
         if (num_echoes == 1)
            {affected.top = 0;
             affected.bottom = mask1.mask._2d.dimy - 1;

             TRACE(printf("Set2dByArea...lcv = %d\n",lcv))
             Set2dByArea(&(mask1.mask._2d),affected.left,0,
                    affected.left,affected.bottom,(double) 1.0);
             Set2dByArea(&(mask1.mask._2d),affected.right,0,
                    affected.right,affected.bottom,(double) 1.0);
             Set2dByArea(&(mask1.mask._2d),affected.left,0,
                    affected.right,1,(double) 1.0);
             Set2dByArea(&(mask1.mask._2d),affected.left,affected.bottom - 1,
                    affected.right,affected.bottom,(double) 1.0);
            }
           else err = FillDrawRoiRec(&mask1,NULL,roi,NULL);
         if (err == NO_ERROR)
            {
             Set2d(&(histo->map),0,0,&(mask1.mask._2d),
                      &affected,(double) (lcv + 1));
            }
        }
    }
 TRACE(printf("build_histo_pixel_type_map1...5\n"))
 free_draw_mask_rec(&mask1);
 histo->map.status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_histo_map_from_pixel_type_map - ???
--------------------------------------------------------------------------*/

int
get_histo_map_from_pixel_type_map(histo,pixel_type)
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
{
 int err;
 unsigned int pixel_depth,dimx1,dimy1;

 if ((pixel_type->status & PIXEL_TYPE_DEFINED) &&
     (pixel_type->map.status4 & BUF_DATA_VALID))
    {TRACE(printf("get_histo_map_from_pixel_type_map...ok...\n"))
     get_histo_dim(histo,&dimx1,&dimy1,&pixel_depth,histo->status2);

     pixel_depth = find_num_bits_needed(pixel_type->order.num_strs + 1);
     if ((err = SetupBuf2dRec(&(histo->map),dimx1,dimy1,pixel_depth,0)) 
              != NO_ERROR)
        return err;
     set_map(&(histo->map),&(pixel_type->map));
     histo->map.status4 |= BUF_DATA_VALID;
     return NO_ERROR;}
   
 return CANCEL;
}


/*--------------------------------------------------------------------------
build_pixel_type_map - ???
--------------------------------------------------------------------------*/

int
build_pixel_type_map(histo,pixel_type)
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
{
 unsigned int pixel_depth,dimx,dimy;
 unsigned short status2;
 int err;

 TRACE(printf("build_pixel_type_map...1\n"))
 if ((err = build_histo_pixel_type_map(histo)) != NO_ERROR) return err;

 status2 = file_get_def_histo_type(histo->file);
 get_histo_dim(&(histo->file->histo_params),
                  &dimx,&dimy,&pixel_depth,status2);
 TRACE(printf("build_pixel_type_map..2\n"))
 if ((dimx == 0) || (dimy == 0)) return CANCEL;
 pixel_depth = find_num_bits_needed(histo->pixel_type_order.num_strs + 1);
 TRACE(printf("build_histo_pixel_type_map pixel_depth = %d\n",pixel_depth))

 if ((err = SetupBuf2dRec(&(pixel_type->map),dimx,dimy,
              pixel_depth,0)) != NO_ERROR)
    return err;
 TRACE(pr_buf_2d_rec(&(pixel_type->map)))
 TRACE(printf("build_pixel_type_map..3\n"))

 InitBuf2dRecData(&(pixel_type->map),(double) .0);
 pixel_type->map.status4 &= ~BUF_DATA_VALID;
 pixel_type->status &= ~PIXEL_TYPE_DEFINED;
 pixel_type->status &= ~PIXEL_TYPE_AND_ANALYSIS_RELATED;
 TRACE(printf("build_pixel_type_map..3..1\n"))
 str_dealloc_and_cpy(&(pixel_type->slice_map_data_creation_date),
                     current_asctime());
 TRACE(printf("build_pixel_type_map..4\n"))
 if ((err = cp_strs_rec(&(pixel_type->order),
           &(histo->pixel_type_order))) == NO_ERROR)
    {
     set_map(&(pixel_type->map),&(histo->map));
     histo->file->pixel_type.slice_roi_win = NULL;
     pixel_type->map.status4 |= BUF_DATA_VALID;
     pixel_type->status |= PIXEL_TYPE_DEFINED | PIXEL_TYPE_3D_REDEFINED |
                    HISTO_AND_PIXEL_TYPE_RELATED;
    }
 TRACE(printf("build_pixel_type_map..err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
get_slice_mask - ???
--------------------------------------------------------------------------*/

int
get_slice_mask(img,img_2d,slice_mask,selected)
 struct img_buf_rec *img;
 struct buf_2d_rec *img_2d,*slice_mask;
 unsigned char *selected;
{
 int err;
 struct buf_2d_rec *slice_map;

 if ((img->file->hdr.data_info.num_echoes == 2) &&
     !(img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    if (!(img->file->pixel_type.map.status4 & BUF_DATA_VALID))
       {if ((err = build_pixel_type_map(&(img->file->histo_params),
              &(img->file->pixel_type))) != NO_ERROR)
        return err;
       }
 if ((slice_map = get_cur_slice_map(img->file,img->cur_slice)) == NULL)
    return CANCEL;
 if ((err = SetupBuf2dRec(slice_mask,img->_2d.dimx,img->_2d.dimy,1,0)) == 
                NO_ERROR)
    {InitBuf2dRecData(slice_mask,(double) .0);
     if ((err = select_2d_by_val(slice_map,slice_mask,selected)) == NO_ERROR)
        {
         NotBitmap(slice_mask,slice_mask);
         if (img_2d != NULL)
            {Set2d(img_2d,0,0,slice_mask,NULL,(double) .0);
            }
           else Set2d(&(img->_2d),0,0,slice_mask,NULL,(double) .0);
        }
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
setup_slice_mask - ???
--------------------------------------------------------------------------*/

int
setup_slice_mask(img,img_2d,slice_mask,selected)
 struct img_buf_rec *img;
 struct buf_2d_rec *img_2d,*slice_mask;
 unsigned char *selected;
{
 int err;
 struct buf_2d_rec slice_map,*slice_map_ptr;

 if ((img->file->hdr.data_info.num_echoes == 2) &&
     !(img->file->pixel_type.status & PIXMAP_METHOD_DEFINED))
    if (!(img->file->pixel_type.map.status4 & BUF_DATA_VALID))
       {if ((err = build_pixel_type_map(&(img->file->histo_params),
              &(img->file->pixel_type))) != NO_ERROR)
        return err;
       }

 init_buf_2d_rec(&slice_map);
 if ((err = setup_cur_slice_map(&slice_map,&slice_map_ptr,
            img->file,img->cur_slice)) != NO_ERROR)
    return err;
 if ((err = SetupBuf2dRec(slice_mask,img->_2d.dimx,img->_2d.dimy,1,0)) == 
                NO_ERROR)
    {InitBuf2dRecData(slice_mask,(double) .0);
     if ((err = select_2d_by_val(slice_map_ptr,slice_mask,selected)) == NO_ERROR)
        {
         NotBitmap(slice_mask,slice_mask);
         if (img_2d != NULL)
            {Set2d(img_2d,0,0,slice_mask,NULL,(double) .0);
            }
           else Set2d(&(img->_2d),0,0,slice_mask,NULL,(double) .0);
        }
    }
 free_buf_2d_rec(&slice_map);
 return NO_ERROR;
}


