/****************************************************************************
pixel_type_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: pixel_type_rec.c,v 1.8 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <unistd.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



/* Functions defined by this file */
void init_pixel_type_rec(struct pixel_type_rec *pixel_type);
void free_pixel_type_rec(struct pixel_type_rec *pixel_type);
void exit_pixel_type_cnt_rec(struct pixel_type_cnt_rec **ptr);
void init_pixel_type_cnt_rec(struct pixel_type_cnt_rec *ptr);
int SetPixmapSetupMethod(struct pixel_type_rec *pixel_type);
int AutoRdFilePixmapHdr1(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type);
int rd_file_pixmap_slices(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, long num_slices);
int rd_file_pixmap_for_slice_num(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, long num_slices,
    struct buf_2d_rec *slice_map, int slice_num);
int rd_file_pixmap(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, long num_slices);



/*-------------------------------------------------------------------------
init_pixel_type_rec - ???
-------------------------------------------------------------------------*/

void
init_pixel_type_rec(pixel_type)
 struct pixel_type_rec *pixel_type;
{
 init_strs_rec(&(pixel_type->order));
 pixel_type->status = 0;
 init_buf_2d_rec(&(pixel_type->map));
 pixel_type->slice_roi_win = NULL;
 init_buf_2d_rec(&(pixel_type->slice_map));
 pixel_type->slice_map_data_creation_date = NULL;

 init_strs_rec(&(pixel_type->grow_order));
 pixel_type->total_slice_maps = pixel_type->num_slice_maps = 0;
 pixel_type->slice_maps = NULL;
 init_pixmap_hdr_rec(&(pixel_type->pixmap_hdr));
}



/*-------------------------------------------------------------------------
free_pixel_type_rec - ???
-------------------------------------------------------------------------*/

void
free_pixel_type_rec(pixel_type)
 struct pixel_type_rec *pixel_type;
{
 unsigned int lcv;

 free_strs_rec(&(pixel_type->order));
 free_buf_2d_rec(&(pixel_type->map));
 free_buf_2d_rec(&(pixel_type->slice_map));
 c_free(pixel_type->slice_map_data_creation_date);

 if (pixel_type->total_slice_maps > 0)
    {for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
        {free_buf_2d_rec(pixel_type->slice_maps[lcv]);
         c_free(pixel_type->slice_maps[lcv]);}
     c_free(pixel_type->slice_maps);}
 free_strs_rec(&(pixel_type->grow_order));

 free_pixmap_hdr_rec(&(pixel_type->pixmap_hdr));

 init_pixel_type_rec(pixel_type);
}


/*-------------------------------------------------------------------------
exit_pixel_type_cnt_rec - ???
-------------------------------------------------------------------------*/

void
exit_pixel_type_cnt_rec(ptr)
 struct pixel_type_cnt_rec **ptr;
{
 TRACE(printf("exit_pixel_type_cnt_rec...\n"))
 if ((*ptr) != NULL)
    {c_free((*ptr)->pixel_type_cnts);
     free_ptr(&ptr);
    }
 TRACE(printf("exit_pixel_type_cnt_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_pixel_type_cnt_rec - ???
-------------------------------------------------------------------------*/

void
init_pixel_type_cnt_rec(ptr)
 struct pixel_type_cnt_rec *ptr;
{
 ptr->status = 0;
 ptr->num_pixel_type_cnts = 0;
 ptr->pixel_type_cnts = NULL;
}


/*-------------------------------------------------------------------------
SetPixmapSetupMethod - ???
-------------------------------------------------------------------------*/

int
SetPixmapSetupMethod(pixel_type)
 struct pixel_type_rec *pixel_type;
{
 PRT(printf("SetPixmapSetupMethod...pixel_type->status = %x status = %x\n",
     (unsigned long) pixel_type->status,
     (unsigned long) pixel_type->pixmap_hdr.status))
 pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
 if (pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID)
    {if (pixel_type->pixmap_hdr.status & PIXEL_TYPE_SETUP_USER)
        pixel_type->status |= PIXEL_TYPE_USER_SETUP;
       else if (pixel_type->pixmap_hdr.status & PIXEL_TYPE_SETUP_2D_PARTITION)
        pixel_type->status |= PIXEL_TYPE_2D_PARTITION_SETUP;
       else pixel_type->status |= PIXEL_TYPE_GROW_REGION;
    }
 PRT(printf("SetPixmapSetupMethod...after pixel_type->status = %x\n",
     (unsigned long) pixel_type->status))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
AutoRdFilePixmapHdr1 - ???
-------------------------------------------------------------------------*/

int
AutoRdFilePixmapHdr1(dir,fn,suffix,pixel_type)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
{
 int err;
 struct strs_rec order;
 struct pixmap_hdr_rec pixmap_hdr;

 PRT(printf("AutoRdFilePixmapHdr...\n"))
 init_pixmap_hdr_rec(&pixmap_hdr);
 if ((err = RdThePixmapHdr(dir,fn,suffix,&pixmap_hdr)) == NO_ERROR)
    {init_strs_rec(&order);
     if ((err = cp_strs_rec(&order,&(pixmap_hdr.order))) == NO_ERROR)
        {free_strs_rec(&(pixel_type->order));
         pixel_type->pixmap_hdr = pixmap_hdr;
         pixel_type->status |= PIXEL_TYPE_PIXMAP_HDR_VALID;
         SetPixmapSetupMethod(pixel_type);
         pixel_type->order = order;
        }
       else free_strs_rec(&order);
     TRACE(printf("AutoRdFilePixmapHdr...\n"))
     TRACE(pr_strs_rec(&(pixel_type->pixmap_hdr.order));)
    }
 if (err != NO_ERROR) free_pixmap_hdr_rec(&pixmap_hdr);
 PRT(printf("AutoRdFilePixmapHdr...err = %d\n",err))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
rd_file_pixmap_slices - ???
-------------------------------------------------------------------------*/

int
rd_file_pixmap_slices(dir,fn,suffix,pixel_type,num_slices)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 long num_slices;
{
 int err;
 char *fn1;
 unsigned long lcv;

 TRACE(printf("rd_file_pixmap_slices...\n");)
 fn1 = NULL;
 if ((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR)
    if (access(fn1,F_OK) != 0)
       {err = FILE_NOT_EXIST;}
      else
       {if (!(pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID))
           {
            if ((err = RdPixmapHdr(fn1,&(pixel_type->pixmap_hdr))) == 
                 NO_ERROR)
               pixel_type->status |= PIXEL_TYPE_PIXMAP_HDR_VALID;
           }
        if (err == NO_ERROR)
           {
            if (pixel_type->num_slice_maps == 0)
               {if ((err = get_handle(&(pixel_type->slice_maps),
                    &(pixel_type->num_slice_maps),
                    (unsigned long) num_slices,
                    (size_t) sizeof(**(pixel_type->slice_maps)))) == NO_ERROR)
                   for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
                      init_buf_2d_rec(pixel_type->slice_maps[lcv]);
               }
            if (err == NO_ERROR)
               err = rd_pixmap_slices(fn1,&(pixel_type->pixmap_hdr),
                   pixel_type->slice_maps,pixel_type->num_slice_maps);
           }
       }
 c_free(fn1);
 TRACE(printf("rd_file_pixmap_slices...err = %d end\n",err);)
 return err;
}


/*-------------------------------------------------------------------------
rd_file_pixmap_for_slice_num - ???
-------------------------------------------------------------------------*/

int
rd_file_pixmap_for_slice_num(dir,fn,suffix,pixel_type,num_slices,
                             slice_map,slice_num)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 long num_slices;
 struct buf_2d_rec *slice_map;
 int slice_num;
{
 int err;
 char *fn1;
 unsigned long lcv,total;

 TRACE(printf("rd_file_pixmap_for_slice_num...1\n"))
 if (!(pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID)) return NOT_FOUND;
 TRACE(printf("rd_file_pixmap_for_slice_num...2\n"))
 fn1 = NULL;
 if ((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR)
    if (access(fn1,F_OK) != 0)
       {err = FILE_NOT_EXIST;}
      else
       {if (!(pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID))
           {
            if ((err = RdPixmapHdr(fn1,&(pixel_type->pixmap_hdr))) == 
                 NO_ERROR)
               pixel_type->status |= PIXEL_TYPE_PIXMAP_HDR_VALID;
           }
        if (err == NO_ERROR)
           if (slice_map != NULL)
              err = rd_pixmap_for_slice_num(fn1,
                     &(pixel_type->pixmap_hdr),slice_map,slice_num);
             else
              {if (pixel_type->num_slice_maps < num_slices)
                  {
                   for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
                      free_buf_2d_rec(pixel_type->slice_maps[lcv]);
                   total = num_slices - pixel_type->num_slice_maps;
                   if ((err = get_handle(&(pixel_type->slice_maps),
                       &(pixel_type->num_slice_maps),total,
                       (size_t) sizeof(**(pixel_type->slice_maps)))) == NO_ERROR)
                      for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
                        init_buf_2d_rec(pixel_type->slice_maps[lcv]);
                  }
               if (err == NO_ERROR)
                  err = rd_pixmap_for_slice_num(fn1,&(pixel_type->pixmap_hdr),
                     pixel_type->slice_maps[slice_num],slice_num);
              }
       }
 c_free(fn1);
 TRACE(printf("rd_file_pixmap_for_slice_num...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
rd_file_pixmap - ???
-------------------------------------------------------------------------*/

int
rd_file_pixmap(dir,fn,suffix,pixel_type,num_slices)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 long num_slices;
{
 int err;
 struct pixmap_hdr_rec pixmap_hdr;

 TRACE(printf("rd_file_pixmap...\n"))
 init_pixmap_hdr_rec(&pixmap_hdr);
 if ((err = RdThePixmapHdr(dir,fn,suffix,&pixmap_hdr)) == NO_ERROR)
    {free_pixmap_hdr_rec(&(pixel_type->pixmap_hdr));
     pixel_type->pixmap_hdr = pixmap_hdr;
     pixel_type->status |= PIXEL_TYPE_PIXMAP_HDR_VALID;
     err = rd_file_pixmap_slices(dir,fn,suffix,pixel_type,num_slices);}
   else free_pixmap_hdr_rec(&pixmap_hdr);
 return err;
}

