/****************************************************************************
polarity.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: polarity.c,v 1.7 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>

#include "mri_format.h"
#include "edge.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT1(x)
#define PRT(x) x; fflush(stdout);
*/
#define PRT(x)
#define TRACE(x)
#define PRT1(x) x; fflush(stdout);



struct stack_xy_rec
   {
    unsigned short x,y;
    unsigned char edge;
   };

struct val_indx_rec
   {long val,diff_val;
    unsigned char edge_indx;
    unsigned short x,y;
   };


/* Functions defined in this file */
int sort_val_indx_rec(struct val_indx_rec *v1, struct val_indx_rec *v2);
void pt_1_echo_polarity(struct buf_2d_rec *_2d, long row, long col,
    unsigned long *dire_edge);
void setup_1_echo_image_polarity(struct buf_2d_rec *_2d,
    struct buf_2d_rec *direction);
void pt_2_echo_polarity(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    long row, long col, unsigned long *dire_edge);
void setup_2_echo_image_polarity(struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2, struct buf_2d_rec *direction);
int diff_2d_val(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    int num_echoes, int y, int x, int y1, int x1);
int image_polarity(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    int num_echoes, long max_diff_val);
int win_image_polarity(struct image_display_window *win);
int pt_polarity(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    int num_echoes, long max_diff_val, long row, long col,
    struct buf_2d_rec *direction_mask, struct int_bound_rec *bound_area,
    float *ave1, float *ave2);



/*------------------------------------------------------------------------
sort_val_indx_rec - ???
------------------------------------------------------------------------*/

int
sort_val_indx_rec(v1,v2)
 struct val_indx_rec *v1,*v2;
{
 if (v1->diff_val > v2->diff_val) return 1;
 if (v1->diff_val < v2->diff_val) return -1;
 return 0;
}


/*------------------------------------------------------------------------
pt_1_echo_polarity - ???
------------------------------------------------------------------------*/

void
pt_1_echo_polarity(_2d,row,col,dire_edge)
 struct buf_2d_rec *_2d;
 long row,col;
 unsigned long *dire_edge;
{
 long diff_val,val,val1,vals[8],lcv,cnt,next,x1,y1,min;
 unsigned char edge;

 if (col == 0) edge = _EdgeBit670;
   else edge = 0;
 if (col == (_2d->dimx - 1)) edge |= _EdgeBit234;
 if (row == 0) edge |= _EdgeBit012;
 if (row == (_2d->dimy - 1)) edge |= _EdgeBit456;
 val = get_1d_buf_value(_2d->buf[row],col,_2d->pixel_depth);
 for (cnt = 0,lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++,cnt++)
    {next = _0Edge[edge][lcv];
     x1 = col + neighbor_Offset[next][0];
     y1 = row + neighbor_Offset[next][1];
     val1 = get_1d_buf_value(_2d->buf[y1],x1,_2d->pixel_depth);
     diff_val = val1 - val;
     if (diff_val < 0) diff_val = -diff_val;
     vals[cnt] = diff_val;
    }
 min = vals[0];
 for (lcv = 1; lcv < cnt; lcv++)
    if (min > vals[lcv]) min = vals[lcv];
 *dire_edge = edge;
 *dire_edge <<= 8;
 for (lcv = 0; lcv < cnt; lcv++)
    if (min == vals[lcv])
       *dire_edge |= _EdgeBit[_0Edge[edge][lcv+1]];
}


/*------------------------------------------------------------------------
setup_1_echo_image_polarity - ???
------------------------------------------------------------------------*/

void
setup_1_echo_image_polarity(_2d,direction)
 struct buf_2d_rec *_2d,*direction;
{
 long row,col;
 unsigned long dire_edge;

 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       {pt_1_echo_polarity(_2d,row,col,&dire_edge);
        set_1d_buf_value(direction->buf[row],col,direction->pixel_depth,dire_edge);}
}


/*------------------------------------------------------------------------
pt_2_echo_polarity - ???
------------------------------------------------------------------------*/

void
pt_2_echo_polarity(_2d1,_2d2,row,col,dire_edge)
 struct buf_2d_rec *_2d1,*_2d2;
 long row,col;
 unsigned long *dire_edge;
{
 long val1,val2,val,lcv,cnt,next,x1,y1;
/*
 float vals[8],min,diff_val1,diff_val2;
*/
 long vals[8],min,diff_val1,diff_val2;
 unsigned char edge;

 if (col == 0) edge = _EdgeBit670;
   else edge = 0;
 if (col == (_2d1->dimx - 1)) edge |= _EdgeBit234;
 if (row == 0) edge |= _EdgeBit012;
 if (row == (_2d1->dimy - 1)) edge |= _EdgeBit456;
 val1 = get_1d_buf_value(_2d1->buf[row],col,_2d1->pixel_depth);
 val2 = get_1d_buf_value(_2d2->buf[row],col,_2d2->pixel_depth);
 for (cnt = 0,lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++,cnt++)
    {next = _0Edge[edge][lcv];
     x1 = col + neighbor_Offset[next][0];
     y1 = row + neighbor_Offset[next][1];
     val = get_1d_buf_value(_2d1->buf[y1],x1,_2d1->pixel_depth);
     diff_val1 = val1 - val;
     val = get_1d_buf_value(_2d2->buf[y1],x1,_2d2->pixel_depth);
     diff_val2 = val2 - val;

     if (diff_val1 < 0) diff_val1 = -diff_val1;
     if (diff_val2 < 0) diff_val2 = -diff_val2;
     vals[cnt] = diff_val1 + diff_val2;
/*
     diff_val1 = diff_val1 * diff_val1;
     diff_val2 = diff_val2 * diff_val2;
     vals[cnt] = (float) sqrt((double) (diff_val1 + diff_val2));
*/
    }
 min = vals[0];
 for (lcv = 1; lcv < cnt; lcv++)
    if (min > vals[lcv]) min = vals[lcv];
 *dire_edge = edge;
 *dire_edge <<= 8;
 for (lcv = 0; lcv < cnt; lcv++)
    if (min == vals[lcv])
       *dire_edge |= _EdgeBit[_0Edge[edge][lcv+1]];
}


/*------------------------------------------------------------------------
setup_2_echo_image_polarity - ???
------------------------------------------------------------------------*/

void
setup_2_echo_image_polarity(_2d1,_2d2,direction)
 struct buf_2d_rec *_2d1,*_2d2,*direction;
{
 long row,col;
 unsigned long dire_edge;

 for (row = 0; row < _2d1->dimy; row++)
    for (col = 0; col < _2d1->dimx; col++)
       {pt_2_echo_polarity(_2d1,_2d2,row,col,&dire_edge);
        set_1d_buf_value(direction->buf[row],col,direction->pixel_depth,dire_edge);}
}


/*------------------------------------------------------------------------
diff_2d_val - ???
------------------------------------------------------------------------*/

int
diff_2d_val(_2d1,_2d2,num_echoes,y,x,y1,x1)
 struct buf_2d_rec *_2d1,*_2d2;
 int num_echoes;
{
 long val1,val2,v1,v2;

 val1 = get_1d_buf_value(_2d1->buf[y],x,_2d1->pixel_depth);
 v1 = get_1d_buf_value(_2d1->buf[y1],x1,_2d1->pixel_depth);
 val1 -= v1;
 if (val1 < 0) val1 = -val1;
 if (num_echoes == 2)
    {val2 = get_1d_buf_value(_2d2->buf[y],x,_2d2->pixel_depth);
     v2 = get_1d_buf_value(_2d2->buf[y1],x1,_2d2->pixel_depth);
     val2 -= v2;
     if (val2 < 0) val2 = -val2;
     return val1 + val2;
    }
   else return val1;
}


/*------------------------------------------------------------------------
image_polarity - ???
------------------------------------------------------------------------*/

int
image_polarity(_2d1,_2d2,num_echoes,max_diff_val)
 struct buf_2d_rec *_2d1,*_2d2;
 int num_echoes;
 long max_diff_val;
{
 long val,val1,val2,row,col,lcv,cnt,next,x,y,x1,y1,x2,y2;
 float ave1,ave2;
 struct buf_2d_rec all_mask,mask,mask1,direction;
 int err,ok;
 unsigned long all,tot_regions,total_elems,cur,num_elems,num_subs,total_subs;
 struct stack_xy_rec *stack,*subs;
 unsigned char edge,edge1;
 unsigned long dire;

 TRACE(printf("image_polarity...\n");)
 init_buf_2d_rec(&direction);
 init_buf_2d_rec(&all_mask);
 init_buf_2d_rec(&mask);
 init_buf_2d_rec(&mask1);
 if (((err = SetupBuf2dRec(&direction,_2d1->dimx,_2d1->dimy,16,0)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&all_mask,_2d1->dimx,_2d1->dimy,1,1)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&mask,_2d1->dimx,_2d1->dimy,1,1)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&mask1,_2d1->dimx,_2d1->dimy,1,1)) != NO_ERROR))
    {free_buf_2d_rec(&direction);
     free_buf_2d_rec(&all_mask);
     free_buf_2d_rec(&mask);
     free_buf_2d_rec(&mask1);
     return err;}
 if (num_echoes == 2) setup_2_echo_image_polarity(_2d1,_2d2,&direction);
   else setup_1_echo_image_polarity(_2d1,&direction);

 total_elems = num_elems = 0;
 num_subs = total_subs = 0;
 tot_regions = 0;
 for (row = 0; (row < _2d1->dimy) && (err == NO_ERROR); row++)
    for (col = 0; (col < _2d1->dimx) && (err == NO_ERROR); col++)
       if (get_1d_buf_value(all_mask.buf[row],col,all_mask.pixel_depth) == 0)
          {tot_regions += 1;
           num_elems = 1;
           if (num_elems >= total_elems)
              if ((err = get_ptr(&stack,&total_elems,20000,
                         (size_t) sizeof(*stack))) !=  NO_ERROR)
                 break;
           stack[0].x = col;
           stack[0].y = row;
           set_1d_buf_value(mask.buf[row],col,mask.pixel_depth,1);
           for (cur = 0; cur < num_elems; cur++)
              {x = stack[cur].x;
               y = stack[cur].y;
               dire = get_1d_buf_value(direction.buf[y],x,
                                       direction.pixel_depth);
               edge = dire & 0x000000ff;
               stack[cur].edge = edge | (dire >> 8);
               edge = ~edge;
               for (lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++)
                  {next = _0Edge[edge][lcv];
                   x1 = x + neighbor_Offset[next][0];
                   y1 = y + neighbor_Offset[next][1];
                   if (get_1d_buf_value(mask.buf[y1],x1,
                            mask.pixel_depth) == 0)
                      {set_1d_buf_value(mask.buf[y1],x1,
                            mask.pixel_depth,1);
                       if (num_elems >= total_elems)
                          if ((err = get_ptr(&stack,&total_elems,20000,
                              (size_t) sizeof(*stack))) !=  NO_ERROR)
                             break;
                       stack[num_elems].x = x1;
                       stack[num_elems].y = y1;
                       num_elems += 1;
                      }
                  }
               if (err != NO_ERROR) break;
              }
           if (err != NO_ERROR) break;
           num_subs = 0;
           for (cur = 0; cur < num_elems; cur++)
              {x = stack[cur].x;
               y = stack[cur].y;
               edge = stack[cur].edge;
               for (lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++)
                  {next = _0Edge[edge][lcv];
                   x1 = x + neighbor_Offset[next][0];
                   y1 = y + neighbor_Offset[next][1];
                   if ((get_1d_buf_value(all_mask.buf[y1],x1,
                            all_mask.pixel_depth) == 0) && 
                       (get_1d_buf_value(mask.buf[y1],x1,
                            mask.pixel_depth) == 0) &&
                       (get_1d_buf_value(mask1.buf[y1],x1,
                            mask1.pixel_depth) == 0))
                      {
                       if ((max_diff_val == 0) ||
                           (diff_2d_val(_2d1,_2d2,num_echoes,y,x,y1,x1) > max_diff_val))
                          {dire = get_1d_buf_value(direction.buf[y1],x1,
                                       direction.pixel_depth);
                           edge1 = dire & 0x000000ff;
                           edge1 = ~edge1;
                           for (ok = 0,cnt = 1; cnt <= (unsigned long)_0Edge[edge1][0]; cnt++)
                              {next = _0Edge[edge1][cnt];
                               x2 = x1 + neighbor_Offset[next][0];
                               y2 = y1 + neighbor_Offset[next][1];
                               if (get_1d_buf_value(mask.buf[y2],x2,
                                      mask.pixel_depth))
                                 {ok = 1;
                                  break;}
                              }
                           if (!ok) continue;
                          }
                       set_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth,1);
                       if (num_subs >= total_subs)
                          if ((err = get_ptr(&subs,&total_subs,20000,
                              (size_t) sizeof(*subs))) !=  NO_ERROR)
                             break;
                       subs[num_subs].x = x1;
                       subs[num_subs].y = y1;
                       num_subs += 1;
                      }
                   }
                if (err != NO_ERROR) break;
               }
           if (err != NO_ERROR) break;
           for (cur = 0; cur < num_subs; cur++)
              {x = subs[cur].x;
               y = subs[cur].y;
               if (num_elems >= total_elems)
                  if ((err = get_ptr(&stack,&total_elems,20000,
                              (size_t) sizeof(*stack))) !=  NO_ERROR)
                     break;
               set_1d_buf_value(mask.buf[y],x,mask.pixel_depth,1);
               stack[num_elems].x = x;
               stack[num_elems].y = y;
               num_elems += 1;
               dire = get_1d_buf_value(direction.buf[y],x,
                                       direction.pixel_depth);
               edge = dire & 0x000000ff;
               edge = ~edge;
               for (lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++)
                  {next = _0Edge[edge][lcv];
                   x1 = x + neighbor_Offset[next][0];
                   y1 = y + neighbor_Offset[next][1];
                   if ((get_1d_buf_value(all_mask.buf[y1],x1,
                            all_mask.pixel_depth) == 0) &&
                       (get_1d_buf_value(mask.buf[y1],x1,
                            mask.pixel_depth) == 0) &&
                       (get_1d_buf_value(mask1.buf[y1],x1,
                            mask1.pixel_depth) == 0))
                      {set_1d_buf_value(mask1.buf[y1],x1,
                            mask1.pixel_depth,1);
                       if (num_subs >= total_subs)
                          if ((err = get_ptr(&subs,&total_subs,20000,
                              (size_t) sizeof(*subs))) !=  NO_ERROR)
                             break;
                       subs[num_subs].x = x1;
                       subs[num_subs].y = y1;
                       num_subs += 1;
                      }
                  }
               if (err != NO_ERROR) break;

               edge = dire & 0x000000ff;
               edge = edge | (dire >> 8);
               for (lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++)
                  {next = _0Edge[edge][lcv];
                   x1 = x + neighbor_Offset[next][0];
                   y1 = y + neighbor_Offset[next][1];
                   if ((get_1d_buf_value(all_mask.buf[y1],x1,
                            all_mask.pixel_depth) == 0) &&
                       (get_1d_buf_value(mask.buf[y1],x1,
                            mask.pixel_depth) == 0) &&
                       (get_1d_buf_value(mask1.buf[y1],x1,
                            mask1.pixel_depth) == 0))
                      {if ((max_diff_val == 0) ||
                           (diff_2d_val(_2d1,_2d2,num_echoes,y,x,y1,x1) > max_diff_val))
                          {dire = get_1d_buf_value(direction.buf[y1],x1,
                                       direction.pixel_depth);
                           edge1 = dire & 0x000000ff;
                           edge1 = ~edge1;
                           for (ok = 0,cnt = 1; cnt <= (unsigned long)_0Edge[edge1][0]; cnt++)
                              {next = _0Edge[edge1][cnt];
                               x2 = x1 + neighbor_Offset[next][0];
                               y2 = y1 + neighbor_Offset[next][1];
                               if (get_1d_buf_value(mask.buf[y2],x2,mask.pixel_depth))
                                  {ok = 1;
                                   break;}
                              }
                           if (!ok) continue;
                          }

                       set_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth,1);
                       if (num_subs >= total_subs)
                          if ((err = get_ptr(&subs,&total_subs,20000,
                              (size_t) sizeof(*subs))) !=  NO_ERROR)
                             break;
                       subs[num_subs].x = x1;
                       subs[num_subs].y = y1;
                       num_subs += 1;
                      }
                  }
               if (err != NO_ERROR) break;
              }
           if (err != NO_ERROR) break;

           ave1 = .0;
           ave2 = .0;
            for (cur = 0; cur < num_elems; cur++)
              {x = stack[cur].x;
               y = stack[cur].y;
               PRT(if (get_1d_buf_value(all_mask.buf[y],x,
                            all_mask.pixel_depth))
                  {printf("dup %d/%d\n",y,x);
                  })
               val = get_1d_buf_value(_2d1->buf[y],x,_2d1->pixel_depth);
               ave1 += (float) val;
               if (num_echoes == 2) 
                  {val = get_1d_buf_value(_2d2->buf[y],x,_2d2->pixel_depth);
                   ave2 += (float) val;}
              }
           ave1 = ave1 / (float) num_elems;
           val1 = (long) ave1;
           if (num_echoes == 2) 
              {ave2 = ave2 / (float) num_elems;
               val2 = (long) ave2;}
           for (cur = 0; cur < num_elems; cur++)
              {x = stack[cur].x;
               y = stack[cur].y;
               set_1d_buf_value(all_mask.buf[y],x,all_mask.pixel_depth,1);
               set_1d_buf_value(mask.buf[y],x,mask.pixel_depth,0);
               set_1d_buf_value(_2d1->buf[y],x,_2d1->pixel_depth,val1);
               if (num_echoes == 2) 
                  set_1d_buf_value(_2d2->buf[y],x,_2d2->pixel_depth,val2);
              }
           for (cur = 0; cur < num_subs; cur++)
              {x = subs[cur].x;
               y = subs[cur].y;
               set_1d_buf_value(mask1.buf[y],x,mask1.pixel_depth,0);}
           TRACE(printf(" ---- cnt(mask) = %d cnt(mask1) = %d all_mask = %d\n",
                 cnt_non_val_buf_2d_rec(&mask,0),
                 cnt_non_val_buf_2d_rec(&mask1,0),
                 cnt_non_val_buf_2d_rec(&all_mask,0));)
           all += num_elems;
          }
 TRACE(printf("image_polarity...all = %d tot_regions = %d end\n",all,tot_regions);)

 if (total_elems > 0)
    c_free(stack);
 if (total_subs > 0)
    c_free(subs);
 free_buf_2d_rec(&direction);
 free_buf_2d_rec(&all_mask);
 free_buf_2d_rec(&mask);
 free_buf_2d_rec(&mask1);
 return err;
}


/*------------------------------------------------------------------------
win_image_polarity - ???
------------------------------------------------------------------------*/

int
win_image_polarity(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->file->hdr.data_info.num_echoes == 2)
    {if ((err = image_polarity(&(img->_2d),&(img->partner->_2d),2,2)) == NO_ERROR)
        {WinNewColorMultiCanvas(win);
         if ((img->partner->win != NULL) &&
             (img->partner->win->image_display != NULL))
            WinNewColorMultiCanvas(img->partner->win->image_display);
        }
    }
   else if ((err = image_polarity(&(img->_2d),NULL,1,2)) == NO_ERROR)
    WinNewColorMultiCanvas(win);
 return err;
}


/*------------------------------------------------------------------------
pt_polarity - ???
------------------------------------------------------------------------*/

int
pt_polarity(_2d1,_2d2,num_echoes,max_diff_val,row,col,direction_mask,bound_area,ave1,ave2)
 struct buf_2d_rec *_2d1,*_2d2,*direction_mask;
 int num_echoes;
 long row,col,max_diff_val;
 struct int_bound_rec *bound_area;
 float *ave1,*ave2;
{
 long val,lcv,cnt,next,x,y,x1,y1,x2,y2;
 struct buf_2d_rec mask,mask1;
 int err,ok;
 unsigned long total_elems,cur,num_elems,num_subs,total_subs;
 struct stack_xy_rec *stack,*subs;
 unsigned char edge,edge1;
 unsigned long dire;

 PRT1(printf("pt_polarity...num_echoes = %d _2d1 = %p _2d2 = %p\n",
             num_echoes,_2d1,_2d2);)
 init_buf_2d_rec(&mask);
 init_buf_2d_rec(&mask1);
 if (((err = SetupBuf2dRec(&mask,_2d1->dimx,_2d1->dimy,1,1)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&mask1,_2d1->dimx,_2d1->dimy,1,1)) != NO_ERROR))
    {
     free_buf_2d_rec(&mask);
     free_buf_2d_rec(&mask1);
     return err;}

 total_elems = 0;
 num_subs = total_subs = 0;
 num_elems = 1;
 while (1)
    {if ((err = get_ptr(&stack,&total_elems,10000,
                         (size_t) sizeof(*stack))) ==  NO_ERROR)
        {
         stack[0].x = col;
         stack[0].y = row;
         set_1d_buf_value(mask.buf[row],col,mask.pixel_depth,1);
         for (cur = 0; cur < num_elems; cur++)
            {x = stack[cur].x;
             y = stack[cur].y;
             if (num_echoes == 2) pt_2_echo_polarity(_2d1,_2d2,y,x,&dire);
               else pt_1_echo_polarity(_2d1,y,x,&dire);
	     edge = dire & 0x000000ff;
	     stack[cur].edge = edge | (dire >> 8);
	     edge = ~edge;
	     for (lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++)
		{next = _0Edge[edge][lcv];
		 x1 = x + neighbor_Offset[next][0];
		 y1 = y + neighbor_Offset[next][1];
		 if (get_1d_buf_value(mask.buf[y1],x1,mask.pixel_depth) == 0)
		    {set_1d_buf_value(mask.buf[y1],x1,mask.pixel_depth,1);
		     if (num_elems >= total_elems)
			if ((err = get_ptr(&stack,&total_elems,10000,
			    (size_t) sizeof(*stack))) !=  NO_ERROR)
			   break;
		     stack[num_elems].x = x1;
		     stack[num_elems].y = y1;
		     num_elems += 1;
		    }
		}
	     if (err != NO_ERROR) break;
            }
	 if (err != NO_ERROR) break;
	 num_subs = 0;
	 for (cur = 0; cur < num_elems; cur++)
	    {x = stack[cur].x;
             y = stack[cur].y;
	     edge = stack[cur].edge;
	     for (lcv = 1; lcv <= (unsigned long) _0Edge[edge][0]; lcv++)
		{next = _0Edge[edge][lcv];
		 x1 = x + neighbor_Offset[next][0];
		 y1 = y + neighbor_Offset[next][1];
		 if ((get_1d_buf_value(mask.buf[y1],x1,
				mask.pixel_depth) == 0) &&
		     (get_1d_buf_value(mask1.buf[y1],x1,
				mask1.pixel_depth) == 0))
		    {
                     if ((max_diff_val == 0) ||
		         (diff_2d_val(_2d1,_2d2,num_echoes,y,x,y1,x1) > max_diff_val))
		        {if (num_echoes == 2) pt_2_echo_polarity(_2d1,_2d2,y1,x1,&dire);
		           else pt_1_echo_polarity(_2d1,y1,x1,&dire);
		         edge1 = dire & 0x000000ff;
		         edge1 = ~edge1;
		         for (ok = 0,cnt = 1; cnt <= (unsigned long)_0Edge[edge1][0]; cnt++)
			    {next = _0Edge[edge1][cnt];
			     x2 = x1 + neighbor_Offset[next][0];
			     y2 = y1 + neighbor_Offset[next][1];
			     if (get_1d_buf_value(mask.buf[y2],x2,
				      mask.pixel_depth))
			        {ok = 1;
			         break;}
			    }
		         if (!ok)  continue;
                        }

		     set_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth,1);
		     if (num_subs >= total_subs)
			if ((err = get_ptr(&subs,&total_subs,20000,
				  (size_t) sizeof(*subs))) !=  NO_ERROR)
			   break;
		     subs[num_subs].x = x1;
		     subs[num_subs].y = y1;
		     num_subs += 1;
		    }
		}
	     if (err != NO_ERROR) break;
            }
         if (err != NO_ERROR) break;
	 for (cur = 0; cur < num_subs; cur++)
	    {x = subs[cur].x;
	     y = subs[cur].y;
	     if (num_elems >= total_elems)
		if ((err = get_ptr(&stack,&total_elems,10000,
				  (size_t) sizeof(*stack))) !=  NO_ERROR)
	     break;
	     set_1d_buf_value(mask.buf[y],x,mask.pixel_depth,1);
	     stack[num_elems].x = x;
	     stack[num_elems].y = y;
	     num_elems += 1;
	     if (num_echoes == 2) pt_2_echo_polarity(_2d1,_2d2,y,x,&dire);
	       else pt_1_echo_polarity(_2d1,y,x,&dire);
	     edge = dire & 0x000000ff;
	     edge = ~edge;
	     for (lcv = 1; lcv <= (unsigned long) _0Edge[edge][0]; lcv++)
		{next = _0Edge[edge][lcv];
		 x1 = x + neighbor_Offset[next][0];
		 y1 = y + neighbor_Offset[next][1];
		 if ((get_1d_buf_value(mask.buf[y1],x1,mask.pixel_depth) == 0) &&
		     (get_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth) == 0))
		    {set_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth,1);
		     if (num_subs >= total_subs)
			if ((err = get_ptr(&subs,&total_subs,10000,
				  (size_t) sizeof(*subs))) !=  NO_ERROR)
			   break;
		     subs[num_subs].x = x1;
		     subs[num_subs].y = y1;
		     num_subs += 1;
		    }
		}
	     if (err != NO_ERROR) break;
    
	     edge = dire & 0x000000ff;
	     edge = edge | (dire >> 8);
	     for (lcv = 1; lcv <= (unsigned long)_0Edge[edge][0]; lcv++)
		{next = _0Edge[edge][lcv];
		 x1 = x + neighbor_Offset[next][0];
		 y1 = y + neighbor_Offset[next][1];
		 if ((get_1d_buf_value(mask.buf[y1],x1,mask.pixel_depth) == 0) &&
		     (get_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth) == 0))
                    {if ((max_diff_val == 0) ||
		         (diff_2d_val(_2d1,_2d2,num_echoes,y,x,y1,x1) > max_diff_val))
		        {if (num_echoes == 2) pt_2_echo_polarity(_2d1,_2d2,y1,x1,&dire);
		           else pt_1_echo_polarity(_2d1,y1,x1,&dire);
		         edge1 = dire & 0x000000ff;
		         edge1 = ~edge1;
		         for (ok = 0,cnt = 1; cnt <= (unsigned long)_0Edge[edge1][0]; cnt++)
			    {next = _0Edge[edge1][cnt];
			     x2 = x1 + neighbor_Offset[next][0];
			     y2 = y1 + neighbor_Offset[next][1];
			     if (get_1d_buf_value(mask.buf[y2],x2,mask.pixel_depth))
			        {ok = 1;
			         break;}
			    }
		         if (!ok) continue;
                        }

		     set_1d_buf_value(mask1.buf[y1],x1,mask1.pixel_depth,1);
		     if (num_subs >= total_subs)
			if ((err = get_ptr(&subs,&total_subs,10000,
				 (size_t) sizeof(*subs))) !=  NO_ERROR)
			   break;
		     subs[num_subs].x = x1;
		     subs[num_subs].y = y1;
		     num_subs += 1;
		    }
		}
	     if (err != NO_ERROR) break;
	    }
	 if (err != NO_ERROR) break;
    
         if ((ave1 != NULL) && (ave2 != NULL))
	    {*ave1 = .0;
	     *ave2 = .0;
	     for (cur = 0; cur < num_elems; cur++)
	        {x = stack[cur].x;
	         y = stack[cur].y;
	         val = get_1d_buf_value(_2d1->buf[y],x,_2d1->pixel_depth);
	         *ave1 += (float) val;
	         if (num_echoes == 2) 
		    {val = get_1d_buf_value(_2d2->buf[y],x,_2d2->pixel_depth);
		    *ave2 += (float) val;}
	        }
	     *ave1 = *ave1 / (float) num_elems;
	     if (num_echoes == 2) 
	     *ave2 = *ave2 / (float) num_elems;
	    }
	 bound_area->left = bound_area->right = stack[0].x;
	 bound_area->top = bound_area->bottom = stack[0].y;
         TRACE(printf("num_elems = %d num_subs = %d\n",num_elems,num_subs);)

	 for (cur = 0; cur < num_elems; cur++)
	    {x = stack[cur].x;
	     y = stack[cur].y;
	     if (x < bound_area->left) bound_area->left = x;
	     if (x > bound_area->right) bound_area->right = x;
	     if (y < bound_area->top) bound_area->top = y;
	     if (y > bound_area->bottom) bound_area->bottom = y;
	     set_1d_buf_value(direction_mask->buf[y],x,direction_mask->pixel_depth,1);
	    }
	}
     if (1) break;
    }
 if (total_elems > 0)
    c_free(stack);
 if (total_subs > 0)
    c_free(subs);
 free_buf_2d_rec(&mask);
 free_buf_2d_rec(&mask1);
 return err;
}
