/****************************************************************************
process_draw.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: process_draw.c,v 1.11 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* This file might actually use the time for something useful.
   -PWH 19990407 */
#include <time.h>

/* FIXME:  Not needed?
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/notify.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT4(x)
#define PRT5(x)
#define PRT7(x)



/* Functions defined in this file */
int win_move_mouse_to_cur_pt(struct image_display_window *win);
int WinDeleteCurPts(struct image_display_window *win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts);
void WinEraseAndDisplayPts(struct image_display_window *win, int use_start_pt,
    unsigned long start_pt, unsigned long num_pts);
int win_delete_cur_roi_curve(struct image_display_window *win);
int win_enter_cur_pt(struct image_display_window *win, int x, int y);
int move_screen(struct image_display_window *win, int x, int y,
    int move_to_cur_pt);
void process_loc_drag(struct image_display_window *win, int *x, int *y,
    Event *event);
int process_drag(Xv_Window canvas, struct image_display_window *win,
    Event *event, int *is_display_data, int *first, int *x, int *y, int *x1,
    int *y1, int *err);
int process_loc_move(Xv_Window canvas, Event *event, int must_display_loc);
int win_close_cur_and_edit_next_curve(struct image_display_window *win);
int process_up_event_xy(struct image_display_window *win, int x, int y);
int process_up_event(struct image_display_window *win, int x, int y);
int win_perpendicular_pt(struct image_display_window *win, int *newx,
    int *newy);
void process_draw_proc(Xv_Window canvas, Event *event);



/*-------------------------------------------------------------------------
win_move_mouse_to_cur_pt - ???
-------------------------------------------------------------------------*/

int
win_move_mouse_to_cur_pt(win)
 struct image_display_window *win;
{
 unsigned int x,y;
 int err;

 if ((err = win_get_cur_pt(win,&x,&y)) == NO_ERROR)
    return win_move_mouse_to(win,x,y);
 return err;
}


/*-------------------------------------------------------------------------
WinDeleteCurPts - ???
-------------------------------------------------------------------------*/

int
WinDeleteCurPts(win,use_start_pt,start_pt,num_pts)
 struct image_display_window *win;
 int use_start_pt;
 unsigned long start_pt,num_pts;
{
 struct slice_roi_rec *slice_roi;
 char *cur_roi_label;

 if (win_get_cur_slice_roi_rec(win,&slice_roi,&cur_roi_label) != NO_ERROR)
    return CANCEL;
 DeleteSliceRoiCurPts(slice_roi,use_start_pt,start_pt,num_pts);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinEraseAndDisplayPts - ???
-------------------------------------------------------------------------*/

void
WinEraseAndDisplayPts(win,use_start_pt,start_pt,num_pts)
 struct image_display_window *win;
 int use_start_pt;
 unsigned long start_pt,num_pts;
{

 PRT(printf("WinErases...use_start_pt = %d start_pt = %d num_pts = %d\n",
             use_start_pt,start_pt,num_pts);)
 WinDrawCurrentLine(win,use_start_pt,start_pt,num_pts,1,9);
 WinDeleteCurPts(win,use_start_pt,start_pt,num_pts);
 PRT(printf("WinEraseA  end...num = %d\n",
         num_curve_pts(get_cur_curve(
            &(win->control.sroi.sroi_win->slice_roi))) );)
}


/*-------------------------------------------------------------------------
win_delete_cur_roi_curve - ???
-------------------------------------------------------------------------*/

int
win_delete_cur_roi_curve(win)
 struct image_display_window *win;
{
 struct slice_roi_rec *slice_roi;
 char *cur_roi_label;

 if (win->control.display_options & DISPLAY_BREAKER)
    win_delete_breaker(win);
   else
    {if (!win_is_non_empty_roi(win,NULL)) return CANCEL;
     if (win_get_cur_slice_roi_rec(win,&slice_roi,&cur_roi_label) != NO_ERROR)
        return CANCEL;
     delete_cur_roi_curve(slice_roi);
     init_input_pt_state(&(win->control));
     win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
    }

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_enter_cur_pt - ???
-------------------------------------------------------------------------*/

int
win_enter_cur_pt(win,x,y)
 struct image_display_window *win;
 int x,y;
{
 char *cur_roi_label;
 struct slice_roi_rec *slice_roi;
 unsigned long num_pts;
 long x1,y1,x2,y2,dist;
 struct curve_rec *curve;
 struct matrix_2d_rec matrix;
 float rad;

 PRT4(printf("win_get_cur_xy x = %d y = %d\n",x,y))
 if (win_get_cur_slice_roi_rec(win,&slice_roi,&cur_roi_label) != NO_ERROR)
    return NO_ERROR;
 if (win->control.display_options & SET_MAX_INPUT_PTS)
    {PRT4(printf("SET_MAX_INPUT_PTS...\n");)
     num_pts = num_curve_pts(get_cur_curve(slice_roi));
     if (num_pts >= win->control.max_input_pts)
        {WinEraseAndDisplayPts(win,0,0,1);
         win->control.num_display_cur_pts = num_curve_pts(get_cur_curve(
            slice_roi));
        }
       else win->control.num_display_cur_pts = num_pts - 1;
    }
   else if (win->control.pen_type & DRAW_MODE_BACKSPACE_ALL)
    {num_pts = num_curve_pts(get_cur_curve(slice_roi));
     win->control.num_display_cur_pts = 0;
     PRT5(printf("DRAW_MODE_BACKSPACE_ALL...num_pts = %d\n",num_pts);)
     if (win->control.pen_type & DRAW_CIRCLE_OR_ELLIPSE)
        {if (win->control.pen_type & DRAW_ELLIPSE)
            {PRT4(printf("DRAW_ELLIPSE...\n");)
             if (num_pts > 0)
                {
                 curve = get_cur_curve(slice_roi);
                 win_get_cur_pt_by_indx(win,0,&x1,&y1);
                 WinEraseAndDisplayPts(win,1,0,num_pts);
                 if ((x1 == x) || (y1 == y))
                    curve->status &= ~CURVE_MATRIX_IN_USE;
                   else
                    {if (x < x1) x = x1 + x1 - x;
                     if (y < y1) y = y1 + y1 - y;
                     rad = (float) Atan2((double) (x - x1),(double) (y - y1));
                     PRT4(printf("rad = %f\n",rad))
                     setup_rotate_2d_matrix_from_xy(&matrix,rad,
                          (float) x1,(float) y1);
                     set_curve_matrix(curve,&matrix,0,&(slice_roi->status));
                   }
                 PRT4(printf("after  x1 = %d y1 = %d x = %d  y = %d num_pts = %d\n",
                         x1,y1,x,y,
                      num_curve_pts(get_cur_curve(slice_roi)) ))
                 EnterCurveXY(curve,(float) x1,(float) y1,&(slice_roi->status),
                     win->control.sroi.tolocal,0,1,0);
                 EnterCurveXY(curve,(float) x,(float) y,&(slice_roi->status),
                    win->control.sroi.tolocal,0,1,1);
                 PRT4(printf("1 curve->status = %x num_pts = %d\n",
                         (unsigned long) curve->status,
                      num_curve_pts(get_cur_curve(slice_roi) ) ))
                 win->control.must_display = 1;
                 return NO_ERROR;
                }
            }
           else if (num_pts > 1)
            {win_get_cur_pt_by_indx(win,0,&x1,&y1);
             win_get_cur_pt_by_indx(win,1,&x2,&y2);
             if (win->control.pen_type & DRAW_CIRCLE)
                {dist = (int) ULongRound(
                          (double) distance((float) x1,(float) y1,
                          (float) x,(float) y));
                 if (dist == (x2 - x1))
                    {TRACE(printf("same CIRCLE...\n");)
                     return NO_ERROR;}
                 y = y1 + dist;
                 x = x1 + dist;
                 WinEraseAndDisplayPts(win,0,0,num_pts);
                 EnterSliceRoiRecPt(slice_roi,
                      win->control.sroi.tolocal,cur_roi_label,
                      win->control.pen_type,0,(float) x1,(float) y1);
                }
            }
           else 
            {PRT4(printf("must_display = %d num_display_cur_pts = %d\n",
               win->control.must_display,win->control.num_display_cur_pts))
             WinDrawCurrentLine(win,1,0,1,1,1);}
        }
       else if (num_pts > 1) WinEraseAndDisplayPts(win,0,0,1);
    }
 EnterSliceRoiRecPt(slice_roi,win->control.sroi.tolocal,cur_roi_label,
               win->control.pen_type,0,(float) x,(float) y);
 win->control.must_display = 1;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
move_screen - ???
-------------------------------------------------------------------------*/

int
move_screen(win,x,y,move_to_cur_pt)
 struct image_display_window *win;
 int x,y,move_to_cur_pt;
{
 int in_x,in_y,left,top,move_offset_x,move_offset_y,err;
 unsigned long dimx,dimy;

 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;
 in_x = in_y = 0;
 move_offset_x = (win->dwin->screen.dimension.bound.right - 
                          win->dwin->screen.dimension.bound.left) / 2;
 move_offset_y = (win->dwin->screen.dimension.bound.bottom - 
                          win->dwin->screen.dimension.bound.top) / 2;
 if (x == win->dwin->screen.dimension.bound.left)
    {
     if ((win->dwin->screen.dimension.bound.left > 0) && (move_offset_x > 0))
        {
         left = win->dwin->screen.dimension.bound.left - move_offset_x;
         if (left < 0) left = 0;
         in_x = 1;}
    }
   else if (x == win->dwin->screen.dimension.bound.right)
    {left = dimx -
            win->dwin->screen.dimension.bound.right - 1;
     if ((left > 0) && (move_offset_x > 0))
        {if (left > move_offset_x)
            left = win->dwin->screen.dimension.bound.left + move_offset_x;
           else left += win->dwin->screen.dimension.bound.left;
         in_x = 1;}
    }

 if (y == win->dwin->screen.dimension.bound.top)
    {if ((win->dwin->screen.dimension.bound.top > 0) && (move_offset_y > 0))
        {top = win->dwin->screen.dimension.bound.top - move_offset_y;
         if (top < 0) top = 0;
         in_y = 1;}
    }
   else if (y == win->dwin->screen.dimension.bound.bottom)
    {top = dimy - win->dwin->screen.dimension.bound.bottom - 1;
     if ((top > 0)  && (move_offset_y > 0))
        {if (top > move_offset_y)
            top = win->dwin->screen.dimension.bound.top + move_offset_y;
           else top += win->dwin->screen.dimension.bound.top;
         in_y = 1;}
    }

 if (in_x || in_y)
    {
     TRACE(printf("in_x = %d in_y = %d\n",in_x,in_y))
     TRACE(printf("\n\nleft = %d top = %d right = %d bottom = %d\n",
        win->dwin->screen.dimension.bound.left,
        win->dwin->screen.dimension.bound.top,
        win->dwin->screen.dimension.bound.right,
        win->dwin->screen.dimension.bound.bottom))
     if (in_x)
        {move_offset_x = win->dwin->screen.dimension.bound.right - 
                         win->dwin->screen.dimension.bound.left;
         win->dwin->screen.dimension.bound.right = left + move_offset_x;
         if (win->dwin->screen.dimension.bound.right >= dimx)
            {win->dwin->screen.dimension.bound.right = dimx - 1;
             win->dwin->screen.dimension.bound.left = 
                   win->dwin->screen.dimension.bound.right - move_offset_x;}
           else win->dwin->screen.dimension.bound.left = left;
        }
     if (in_y)
        {move_offset_y = win->dwin->screen.dimension.bound.bottom - 
                         win->dwin->screen.dimension.bound.top;
         win->dwin->screen.dimension.bound.bottom = top + move_offset_y;
         if (win->dwin->screen.dimension.bound.bottom >= dimy)
            {win->dwin->screen.dimension.bound.bottom = dimy - 1;
             win->dwin->screen.dimension.bound.top = 
                   win->dwin->screen.dimension.bound.bottom - move_offset_y;}
           else win->dwin->screen.dimension.bound.top = top;
        }

     TRACE(printf("left = %d top = %d right = %d bottom = %d\n",
        win->dwin->screen.dimension.bound.left,
        win->dwin->screen.dimension.bound.top,
        win->dwin->screen.dimension.bound.right,
        win->dwin->screen.dimension.bound.bottom))
     WinColorCanvas(win);

     if (move_to_cur_pt)
        {if (win_move_mouse_to_cur_pt(win) != NO_ERROR)
            win_move_mouse_to(win,x,y);
        }
       else win_move_mouse_to(win,x,y);

    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
process_loc_drag - ???
-------------------------------------------------------------------------*/

void
process_loc_drag(win,x,y,event)
 struct image_display_window *win;
 int *x,*y;
 Event *event;
{
 int num,in;

 TRACE(printf("process_loc_drag...pen_type = %x...first_pt = %x x = %d y = %d\n",
           (unsigned long) win->control.pen_type,
           (unsigned long) win->control.first_pt,*x,*y);)
 switch (win->control.pen_type)
    {
     case DRAW_FREE :
     case DRAW_FREE_CLOSED :
     case DRAW_LINE :
     case DRAW_POLYGON :
     case DRAW_CIRCLE :
     case DRAW_ELLIPSE :
     case DRAW_RECT :
        if (win->control.first_pt & EXPECT_SECOND_PT)
           {
            if (win->control.first_pt & EXPECT_LAST_PT)
               if ((win->control.lastx != *x) ||
                   (win->control.lasty != *y))
                  {win->control.first_pt &= ~EXPECT_LAST_PT;}
 
            if ((win->control.pen_type == DRAW_FREE) ||
                (win->control.pen_type == DRAW_FREE_CLOSED))
               {if (event_shift_is_down(event) &&
                    event_ctrl_is_down(event)) in = 1;
                  else in = 0;
               }
              else in = 1;
               
            if (in)
               {
                num = win_num_cur_curve_pts(win);
                if (win->control.first_pt & DELETE_PREVIOUS_PT)
                   {
                    if (num > 1)
                      {TRACE(
                          printf("process_loc_drag...PREVIOUS_PT_DELETED...\n"))
                       WinEraseAndDisplayPts(win,0,0,1);
                       win->control.first_pt |= PREVIOUS_PT_DELETED;
                      }
                   }
                  else win->control.first_pt |= DELETE_PREVIOUS_PT;
               if ((win->control.pen_type == DRAW_LINE) ||
                   (win->control.pen_type == DRAW_POLYGON))
                  if ((num >= 2) &&
                     event_meta_is_down(event) &&
                     event_ctrl_is_down(event))
                     {
                      win_perpendicular_pt(win,x,y);
                      win_right_angle_dist(win,*x,*y,1);
                      win->control.first_pt |= ANGLE_PT;
                     }
               }

            TRACE(printf("win_enter_cur_pt...1..x = %d y = %d\n",*x,*y);)
            PRT1(printf("win_enter_cur_pt...1..\n");)

            win->control.lastx = *x;
            win->control.lasty = *y;
            win_enter_cur_pt(win,*x,*y);
           }
          else if (win->control.first_pt & EXPECT_FIRST_PT)
           {
            win->control.first_pt = FIRST_PT;
            if ((win->control.pen_type == DRAW_LINE) ||
                (win->control.pen_type == DRAW_POLYGON))
               if ((win_num_cur_curve_pts(win) >= 2) &&
                   event_meta_is_down(event) &&
                   event_ctrl_is_down(event))
                  {
                   win_perpendicular_pt(win,x,y);
                   win_right_angle_dist(win,*x,*y,1);
                   win->control.first_pt = ANGLE_PT |
                                 EXPECT_SECOND_PT | DELETE_PREVIOUS_PT;
                  }
            TRACE(printf("win_enter_cur_pt...2..x = %d y = %d\n",*x,*y);)
            PRT1(printf("win_enter_cur_pt...2..\n");)
            win_enter_cur_pt(win,*x,*y);
           }
          else
           {
            if ((win->control.pen_type == DRAW_FREE) ||
                (win->control.pen_type == DRAW_FREE_CLOSED))
               win->control.first_pt = EXPECT_SECOND_PT;
              else
               {if ((win->control.pen_type == DRAW_LINE) ||
                    (win->control.pen_type == DRAW_POLYGON))
                   {if ((win_num_cur_curve_pts(win) >= 2) &&
                        event_meta_is_down(event) &&
                        event_ctrl_is_down(event))
                      {
                       win_perpendicular_pt(win,x,y);
                       win_right_angle_dist(win,*x,*y,1);
                       win->control.first_pt = ANGLE_PT |
                                 EXPECT_SECOND_PT | DELETE_PREVIOUS_PT;
                      }
                     else win->control.first_pt = EXPECT_SECOND_PT | 
                               DELETE_PREVIOUS_PT;
                   }
                  else win->control.first_pt = EXPECT_SECOND_PT | 
                               DELETE_PREVIOUS_PT;
               }
            win->control.lastx = *x;
            win->control.lasty = *y;
            TRACE(printf("win_enter_cur_pt...3..x = %d y = %d\n",*x,*y);)
            PRT1(printf("win_enter_cur_pt...3..\n");)
            win_enter_cur_pt(win,*x,*y);
           }
       break;
    case DRAW_POINT :
       TRACE(printf("win_enter_cur_pt...4..x = %d y = %d\n",*x,*y);)
       PRT1(printf("win_enter_cur_pt...4..\n");)
       win_enter_cur_pt(win,*x,*y);
       break;
    default :
       return;
   };
 TRACE(printf("process_loc_drag...end\n"))
}


/*-------------------------------------------------------------------------
process_drag - ???
-------------------------------------------------------------------------*/

int
process_drag(canvas,win,event,is_display_data,first,x,y,x1,y1,err)
 Xv_Window canvas;
 struct image_display_window *win;
 Event *event;
 int *is_display_data,*first,*x,*y,*x1,*y1,*err;
{
 static Event event1,event2;
 int must_process,time,first_time;
 long x2,y2;
 int x3,y3,same;
 Xv_Window win1;

 xv_set(canvas,WIN_IGNORE_EVENTS,LOC_MOVE,0,0);
 first_time = 1;
 *err = 0;
 event2 = event1 = *event;
 must_process = 0;
 TRACE(printf("process_drag ...begin...\n"))
 time = 0;
 x3 = event_x(event);
 y3 = event_y(event);
 do
    {
     if ((*first || (*x != *x1) || (*y != *y1)) &&
         (win->control.status & DRAW_ENABLED))
        {*first = 0;
         if (!(win->control.pen_type & DRAW_LINE) &&
             !(win->control.pen_type & DRAW_POLYGON) &&
             !(win->control.pen_type & DRAW_RECT) &&
             !(win->control.pen_type & DRAW_CIRCLE_OR_ELLIPSE))
            {
             TRACE(printf("process_drag 5\n");)
             process_loc_drag(win,x,y,&event1);
             TRACE(printf("process_drag 6\n"))
             if (*is_display_data == 0) *is_display_data = 1;
            }
           else must_process = 1;
        }
       else if ((*x == *x1) && (*y == *y1))
        {
         if ((*x == win->dwin->screen.dimension.bound.left) ||
             (*x == win->dwin->screen.dimension.bound.right) ||
             (*y == win->dwin->screen.dimension.bound.top) ||
             (*y == win->dwin->screen.dimension.bound.bottom))
            {if (must_process)
                {TRACE(printf("process_drag 4\n"))
                 process_loc_drag(win,x,y,&event1);
                 TRACE(printf("process_drag 4\n"))
                 if (*is_display_data == 0) *is_display_data = 1;
                 must_process = 0;
                }
             move_screen(win,*x,*y,0);
             win_flush_input(canvas);

             *err = 1;}
        }
    if (*err == 0)
       {same = 0;
        while (*err != 5)
           if ((win1 = xv_input_readevent(canvas,&event1,FALSE, FALSE,NULL))
                    != 0)
              {
               if (event_action(&event1) != LOC_DRAG)
                  {*err += 1;
                  }
                 else
                  {x2 = event_x(&event1);
                   y2 = event_y(&event1);
                   if ((*err = dwin_get_coord_xy_from_event(win->dwin,
                            &event1,&x2,&y2)) != NO_ERROR)
                      return *err;
                   event2 = event1;
                   if ((x2 == *x) && (y2 == *y))
                      if (same == 10)
                         {*err += 1;
                          same = 0;
                          break;}
                        else
                         {same += 1;
                          continue;}
                   *x1 = *x;
                   *y1 = *y;

                   *x = x2;
                   *y = y2;
                   same = 0;
                   break;
                  }
               time += 1;
              }
             else
              {*err += 1;
               win_flush(canvas);
              }
        }
    }
 while (*err == 0);
 if (must_process)
    {TRACE(printf("process_drag 1\n"))
     process_loc_drag(win,x,y,&event2);
     TRACE(printf("process_drag 2\n"))
     if (*is_display_data == 0) *is_display_data = 1;
    }
 TRACE(printf("process_drag ...end...must_process = %d  *x = %d   *y = %d   time = %d\n",must_process,*x,*y,time))
 xv_set(canvas,WIN_CONSUME_EVENTS,LOC_MOVE,0,0);
 *err = 0;
 return *err;
}


/*-------------------------------------------------------------------------
process_loc_move - ???
-------------------------------------------------------------------------*/

int
process_loc_move(canvas,event,must_display_loc)
 Xv_Window canvas;
 Event *event;
 int must_display_loc;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 long x,y;
 int err;
 static Event event1;

 win1 = (struct display_win_rec *) xv_get(canvas,WIN_CLIENT_DATA);
 win = win1->owner;
 win->dwin = win1;
 event1 = *event;
 while (xv_input_readevent(canvas,&event1,FALSE,FALSE,NULL) != 0)
    {
     if (event_action(event) != LOC_MOVE)
        {
         win_flush_input(canvas);
         break;
        }
     must_display_loc = 1;
    }
 if (must_display_loc)
    {if ((err = dwin_get_coord_xy_from_event(win1,&event1,&x,&y)) != NO_ERROR)
        return err;
     win_display_row_col(win,x,y,1,1);}
 if (event_shift_is_down(event))
    {if ((err = dwin_get_coord_xy_from_event(win1,&event1,&x,&y)) != NO_ERROR)
        return err;
     if ((x == win->dwin->screen.dimension.bound.left) ||
         (x == win->dwin->screen.dimension.bound.right) ||
         (y == win->dwin->screen.dimension.bound.top) ||
         (y == win->dwin->screen.dimension.bound.bottom))
        {move_screen(win,x,y,0);
         win_flush_input(canvas);
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_close_cur_and_edit_next_curve - ???
-------------------------------------------------------------------------*/

int
win_close_cur_and_edit_next_curve(win)
 struct image_display_window *win;
{
 PRT(printf("win_close_cur_and_edit_next_curve...\n");)
 if (win->control.first_pt != EXPECT_FIRST_PT)
    {
     if ((win->control.pen_type == DRAW_FREE_CLOSED) ||
         (win->control.pen_type == DRAW_POLYGON))
        {
         win_loop_cur_curve(win,0);}
       else if (win->control.last_command_key == CTRL_COMMAND_KEY)
        {
         if (win->control.pen_type & DRAW_FORCE_CLOSED)
            {
        PRT(printf("win_close_cur_and_edit_next_curve...win_loop_cur_curve\n");)
             win_loop_cur_curve(win,1);}
        }
     if (win->control.proc_upon_input_done != NULL)
        win->control.proc_upon_input_done(win->control.proc_arg,
               win->control.last_command_key);
     win_next_curve(win);
     PRT(printf("after...win_next_curve\n");)
     win->control.first_pt = EXPECT_FIRST_PT;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
process_up_event_xy - ???
-------------------------------------------------------------------------*/

int
process_up_event_xy(win,x,y)
 struct image_display_window *win;
 int x,y;
{
 int err;

 PRT(printf("process_up_event(...\n"))
 if (win->control.pen_type & DRAW_MODE)
    {
     if (win->control.first_pt & EXPECT_SECOND_PT)
        {
         if ((win->control.lastx != x) ||
                (win->control.lasty != y))
            {
             win->control.first_pt = EXPECT_SECOND_PT;
             return 0;}
         if (!(win->control.first_pt & EXPECT_LAST_PT))
            {win->control.first_pt = EXPECT_SECOND_PT | EXPECT_LAST_PT;
             return 0;}
        }
     if (win->control.first_pt & FIRST_PT)
        {win->control.lastx = x;
         win->control.lasty = y;
         win->control.first_pt = EXPECT_SECOND_PT | EXPECT_LAST_PT;
         return 0;}
       else if (!(win->control.first_pt & EXPECT_LAST_PT))
        {
         return 0;}
    }
   else return 0;
 if (win->control.display_options & DISPLAY_BREAKER)
    {if (win->control.last_command_key == CTRL_COMMAND_KEY)
        {if (!(win->control.pen_type == DRAW_POINT))
            win_loop_cur_curve(win,1);}
       else
        {
         break_the_region(win);}
     return 1;}

 if (win->control.first_pt & ANGLE_PT)
   clear_label_area(win,&(win->dwin->right_angle_label_area),
          0,WIN_RIGHT_ANGLE_LABEL_PAINTED);
 err = win_close_cur_and_edit_next_curve(win);
 return 1;
}


/*-------------------------------------------------------------------------
process_up_event - ???
-------------------------------------------------------------------------*/

int
process_up_event(win,x,y)
 struct image_display_window *win;
 int x,y;
{
 int err;

 err = process_up_event_xy(win,x,y);
/*
 if ((err == NO_ERROR) && (win->draw_list.item != NULL))
    err = WinRunProcInList(WIN_DRAW_LIST,win,process_up_event_xy,x,y);
*/
 return err;
}


/*-------------------------------------------------------------------------
win_perpendicular_pt - ???
-------------------------------------------------------------------------*/

int
win_perpendicular_pt(win,newx,newy)
 struct image_display_window *win;
 int *newx,*newy;
{
 long x0,y0,x1,y1;
 double x,y;
 int err;
 struct slice_roi_rec *slice_roi;

 win_get_cur_slice_roi_rec(win,&slice_roi,NULL);
 if ((err = GetCurveLast2LongPts(get_cur_curve(slice_roi),
      &x0,&y0,&x1,&y1,win->control.sroi.localto)) != NO_ERROR)
    return err;
 perpendicular_pt((double) x0,(double) y0,
                         (double) x1,(double) y1,
                         (double) *newx,(double) *newy,&x,&y);
 *newx = (int) ULongRound(x);
 *newy = (int) ULongRound(y);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
process_draw_proc - ???
-------------------------------------------------------------------------*/

void
process_draw_proc(canvas,event)
 Xv_Window canvas;
 Event *event;
{
 long x,y,x1,y1,first,num;
 int is_display_data;
 time_t the_time,temp_time;
 static Event next_event;
 int err;
 struct display_win_rec *win1;
 struct image_display_window *win;
 int is_display_row_col;
 struct slice_roi_rec *slice_roi;

 win1 = (struct display_win_rec *) xv_get(canvas,WIN_CLIENT_DATA);
 win = win1->owner;
 win->dwin = win1;
 time(&the_time);
 temp_time = the_time;
 is_display_data = 0;
 err = 0;

 win_get_cur_slice_roi_rec(win,&slice_roi,NULL);
 if (LongCurPt(slice_roi,&x1,&y1,win->control.sroi.localto) == NO_ERROR)
    first = 0;
   else first = 1;

 if ((err = dwin_get_coord_xy_from_event(win1,event,&x,&y)) != NO_ERROR)
     return /*err*/;
 is_display_row_col = 1;

 do
    {
     if (event_ctrl_is_down(event))
        win->control.last_command_key = CTRL_COMMAND_KEY;
       else win->control.last_command_key = 0;

     if (event_is_up(event))
        {if ((win->control.status & DRAW_ENABLED) &&
             (event_action(event) == ACTION_SELECT))
            if (process_up_event(win,x,y)) 
		return;
         win_display_row_col(win,x,y,1,1);
         break;
        }

     switch (event_action(event))
        {
         case ACTION_SELECT :
            process_loc_drag(win,&x,&y,event);
            if (is_display_data == 0) is_display_data = 1;
            break;
         case LOC_DRAG :
            process_drag(canvas,win,event,&is_display_data,
                         &first,&x,&y,&x1,&y1,&err);
            break;
         default :
            err = 1;
            break;
        }
     first = 0;
     if (is_display_data)
        {time(&the_time);
             /* FIXME:  time_t is not necessarily seconds.  -PWH 19990407 */
             if (the_time > (temp_time + 2)) is_display_data = 2;
         if (is_display_data == 2)
            {
             num = num_curve_pts(get_cur_curve(slice_roi));
             PRT2(printf("is_display_data == 2 ...num_display_cur_pts = %d num = %d\n",
                  win->control.num_display_cur_pts,num);)
             num -= win->control.num_display_cur_pts;
             if (num > 0)
                WinDrawCurrentLine(win,1,win->control.num_display_cur_pts,
                       num,0,1);
             TRACE(printf("...2..must_display = %d\n",win->control.must_display);)

             is_display_row_col = 0;
             is_display_data = 0;
             temp_time = the_time;}
        }
     if (is_display_row_col == 10)
        {is_display_row_col = 0;
         TRACE(printf("process_draw_proc...3\n"))
         win_display_row_col(win,x,y,1,1);
         TRACE(printf("process_draw_proc ...4\n"))}

     if (!err &&
         xv_input_readevent(canvas,&next_event,FALSE,FALSE,NULL) != 0)
        {event = &next_event;    
         x1 = x;
         y1 = y;
         if ((err = dwin_get_coord_xy_from_event(win1,event,&x,&y)) != NO_ERROR)
	     return /*err*/;}
        else
         {err = 1;}
    }
 while (err == NO_ERROR);

 if (win->control.must_display)
    {
     num = num_curve_pts(get_cur_curve(slice_roi));
     PRT2(printf("must_display ...num_display_cur_pts = %d num = %d\n",
                  win->control.num_display_cur_pts,num);)
     num -= win->control.num_display_cur_pts;
     if (num > 0)
        WinDrawCurrentLine(win,1,win->control.num_display_cur_pts,num,0,1);
       else win->control.must_display = 0;
     TRACE(printf("...6..must_display = %d\n",win->control.must_display);)
    }

 win_display_row_col(win,x,y,1,1);
 TRACE(printf("\nend...\n"))

 return /*NO_ERROR*/;
}


