/****************************************************************************
save_data_file.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: save_data_file.c,v 1.12 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/notify.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



#define CLEAN_UP_DATA_FILE_REC 0
#define SETUP_DATA_FILE_REC 1
#define GET_ALL_DATA_PTR 2

struct data_file_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    struct input_file_rec *file;
    Frame frame;
    Panel panel;
    Panel_item dir,fn,save_whch,def;
    char *last_dir,*last_fn;
   };

struct all_data_file_recs
   {
    int num_datas;
    struct data_file_rec **datas;
   };


/* Functions defined in this file */
void init_data_file_rec(struct data_file_rec *data);
void free_data_file_rec(struct data_file_rec *data);
void init_all_data_file_recs(struct all_data_file_recs *all_datas);
void data_file_rec_done_proc(Frame frame);
int ReloadFilePixmap(char *dir, char *fn, char *suffix,
    struct input_file_rec *file);
int win_rd_pixmap(struct image_display_window *win);
int win_rd_dat_output(struct image_display_window *win);
int rd_file_slice_rois(struct input_file_rec *file,
    struct image_display_window *win, char *fn, int is_free_fn,
    int use_output_file_rec_fn, int is_rd_all, long slice_num);
void dp_def_fn_proc(struct data_file_rec *data);
void update_output_fn(struct data_file_rec *data);
void chage_def_proc(Panel_item item, Event *event);
void save_last_dir_proc(Panel_item item, Event *event);
void last_fn_proc(Panel_item item, Event *event);
void reload_file_slice_rois_proc(Panel_item item, Event *event);
void reload_slice_rois_proc(Panel_item item, Event *event);
void reload_cur_slice_rois_proc(Panel_item item, Event *event);
void reload_pixmap_proc(Panel_item item, Event *event);
void discard_and_load_proc(Panel_item item, Event *event);
void save_binary_proc(Panel_item item, Event *event);
void save_data_proc(Panel_item item, Event *event);
void get_save_data_fn_proc(struct data_file_rec *data, char *dir, char *fn);
void get_fn_proc(Panel_item item, Event *event);
void save_the_data_proc(Panel_item item, Event *event);
int setup_data_file_rec(struct data_file_rec *data,
    struct image_display_window *win);
struct data_file_rec *find_data_file_rec(struct all_data_file_recs *all_datas,
    struct image_display_window *win, struct display_win_rec *dwin);
struct data_file_rec *find_same_data_file(
   struct all_data_file_recs *all_datas, struct image_display_window *win);
void setup_enter_data_file_rec(struct image_display_window *win);


/* (Known) local functions */
static struct all_data_file_recs *enter_data_file_rec(
    struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_data_file_rec - ???
-------------------------------------------------------------------------*/

void
init_data_file_rec(data)
 struct data_file_rec *data;
{
 data->status = 0;
 data->win = NULL;
 data->frame = 0;
 data->last_dir = data->last_fn = NULL;
}


/*-------------------------------------------------------------------------
free_data_file_rec - ???
-------------------------------------------------------------------------*/

void
free_data_file_rec(data)
 struct data_file_rec *data;
{
 struct all_data_file_recs *all_datas;

 TRACE(printf("free_data_file_rec...\n"))
 if (data->frame != 0)
    {destroy_all_subframes(data->frame);
     xv_destroy_safe(data->frame);
    }
 c_free(data->last_dir);
 c_free(data->last_fn);
 c_free(data);
 TRACE(printf("free_data_file_rec...\n"))
 all_datas = enter_data_file_rec(NULL,GET_ALL_DATA_PTR);
 DropHandleAryPtr(&(all_datas->datas),&(all_datas->num_datas),data);
 TRACE(printf("free_data_file_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_data_file_recs - ???
-------------------------------------------------------------------------*/

void
init_all_data_file_recs(all_datas)
 struct all_data_file_recs *all_datas;
{
 all_datas->num_datas = 0;
 all_datas->datas = NULL;
}


/*-------------------------------------------------------------------------
data_file_rec_done_proc - ???
-------------------------------------------------------------------------*/

void
data_file_rec_done_proc(frame)
 Frame frame;
{
 struct data_file_rec *data;

 data = (struct data_file_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_data_file_rec(data);
}


/*-------------------------------------------------------------------------
ReloadFilePixmap - ???
-------------------------------------------------------------------------*/

int
ReloadFilePixmap(dir,fn,suffix,file)
 char *dir,*fn,*suffix;
 struct input_file_rec *file;
{
 struct pixel_type_rec *pixel_type;
 unsigned long lcv,num_slices;
 int err;

 PRT(printf("ReloadFilePixmap...\n"))
 pixel_type = &(file->pixel_type);
 if ((err = AutoRdFilePixmapHdr1(dir,fn,suffix,&(file->pixel_type))) == NO_ERROR)
    {num_slices = NumberOfSliceCuts(&(file->hdr.data_info));
     PRT(printf("ReloadFilePixmap...1\n"))
     if ((err = rd_file_pixmap_slices(dir,fn,suffix,pixel_type,
               num_slices)) != NO_ERROR)
        {PRT(printf("ReloadFilePixmap...new loaded\n"))
         for (lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
            free_buf_2d_rec(pixel_type->slice_maps[lcv]);
         pixel_type->num_slice_maps = 0;
        }
       else 
        {PRT(printf("ReloadFilePixmap...new loaded\n"))}
     Redefine3dPixmaps(file);
    }
 PRT(printf("ReloadFilePixmap...err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
win_rd_pixmap - ???
-------------------------------------------------------------------------*/

int
win_rd_pixmap(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 ReloadFilePixmap(img->file->output.dirfn,img->file->output.fn,
              PIXMAP_SUFFIX,img->file);
 win_run_proc_to_all_file_wins(win,WinReshowPixelTypesToScreen,3,0,0,0);
 win_run_proc_to_all_file_wins(win,win_multiple_set_frame_label,3,0,0,0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_rd_dat_output - ???
-------------------------------------------------------------------------*/

int
win_rd_dat_output(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;
 char *fn,*reason;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 get_output_fn(&(img->file->output),&fn);
 if ((err = file_access(fn,12,NULL,&reason)) != NO_ERROR)
    {
     ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Error reading from the .ndat file !!!",
               reason,NULL,0);
    }
   else if ((err = rd_dat_output(&(img->file->output))) != NO_ERROR)
    ndat_err_msg(img->file,err,1);
   else
    {
     ReloadFilePixmap(img->file->output.dirfn,img->file->output.fn,
              PIXMAP_SUFFIX,img->file);
     win_run_proc_to_all_file_wins(win,WinReshowPixelTypesToScreen,3,0,0,0);
     win_run_proc_to_all_file_wins(win,win_multiple_set_frame_label,3,0,0,0);
     win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,3,0,0,0);
    }

 c_free(fn);
 c_free(reason);
 return err;
}


/*-------------------------------------------------------------------------
rd_file_slice_rois - ???
-------------------------------------------------------------------------*/

int
rd_file_slice_rois(file,win,fn,is_free_fn,use_output_file_rec_fn,is_rd_all,
                   slice_num)
 struct input_file_rec *file;
 struct image_display_window *win;
 char *fn;
 int is_free_fn,use_output_file_rec_fn;
 int is_rd_all;
 long slice_num;
{
 static char *msg = "Error loading the slice rois from the ndat file !!!";
 int err;

 if (use_output_file_rec_fn) 
    err = rd_dat_slice_rois(&(file->output),is_rd_all,slice_num);
   else
    {if (is_rd_all &&
         ((err = rd_dat_file_slice_rois(fn,file)) == NO_ERROR))
        file->output.status |= FILE_TO_BE_SAVED;
       else
        if ((err = rd_file_slice_roi_rec(fn,file,slice_num)) == NO_ERROR)
           file->output.status |= FILE_TO_BE_SAVED;
    }
 if (err != NO_ERROR)
    if (use_output_file_rec_fn)
        ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,2,
               msg,OPERATION_ABORTED,NULL,0);
       else ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,3,
               msg,fn,OPERATION_ABORTED,NULL,0);
 if (is_rd_all)
     win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,1,0,0,0);
 else
     win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
 if (!use_output_file_rec_fn && is_free_fn) c_free(fn);
 return err;
}


/*-------------------------------------------------------------------------
dp_def_fn_proc - ???
-------------------------------------------------------------------------*/

void
dp_def_fn_proc(data)
 struct data_file_rec *data;
{
 char *dir,*fn,*the_fn,*str;
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 if (img->file->output.dirfn == NULL)
    dir = "";
   else dir = img->file->output.dirfn;
 if (img->file->output.fn == NULL)
    fn = "";
   else fn = img->file->output.fn;
 str = the_fn = NULL;
 if (((err = build_fn(&the_fn,dir,fn,"")) == NO_ERROR) &&
     ((err = concat_strs(&str,2,"DEF : ",the_fn)) == NO_ERROR))
    xv_set(data->def,PANEL_LABEL_STRING,str,0);
   else xv_set(data->def,PANEL_LABEL_STRING,"DEF : ERROR setting up def. filename",0);
 c_free(str);
 c_free(the_fn);
}


/*-------------------------------------------------------------------------
update_output_fn - ???
-------------------------------------------------------------------------*/

void
update_output_fn(data)
 struct data_file_rec *data;
{
 struct img_buf_rec *img;
 char *fn,*dir;

 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 TRACE(printf("in dir = %s fn = %s\n",data->dir,img->file->output.fn);)
 fn = (char *) xv_get(data->fn,PANEL_VALUE);
 if (get_strlen(fn) > 0)
    str_dealloc_and_cpy(&(img->file->output.fn),fn);
   else if (img->file->output.fn != NULL)
    xv_set(data->fn,PANEL_VALUE,img->file->output.fn,0);
 dir = (char *) xv_get(data->dir,PANEL_VALUE);
 if (get_strlen(dir) > 0)
    str_dealloc_and_cpy(&(img->file->output.dirfn),dir);
   else if (img->file->output.dirfn != NULL)
    xv_set(data->dir,PANEL_VALUE,img->file->output.dirfn,0);
 TRACE(printf("out dir = %s fn = %s\n",data->dir,img->file->output.fn);)
}


/*-------------------------------------------------------------------------
chage_def_proc - ???
-------------------------------------------------------------------------*/

void
chage_def_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 update_output_fn(data);
 dp_def_fn_proc(data);
}


/*-------------------------------------------------------------------------
save_last_dir_proc - ???
-------------------------------------------------------------------------*/

void
save_last_dir_proc(item,event)
 Panel_item item;
 Event *event;
{
 char *dir;
 struct data_file_rec *data;
 struct img_buf_rec *img;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 cp_str(&dir,(char *) xv_get(data->dir,PANEL_VALUE));
 if ((int) xv_get(item,XV_KEY_DATA,1))
    xv_set(data->dir,PANEL_VALUE,data->last_dir,NULL);
   else xv_set(data->dir,PANEL_VALUE,img->file->output.dirfn,NULL);
 if ((get_strlen(dir) != 0) && 
     (str_cmp(data->last_dir,img->file->output.dirfn) != 0))
    {c_free(data->last_dir);
     data->last_dir = dir;}
   else c_free(dir);
}


/*-------------------------------------------------------------------------
last_fn_proc - ???
-------------------------------------------------------------------------*/

void
last_fn_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 char *fn;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 cp_str(&fn,(char *) xv_get(data->fn,PANEL_VALUE));
 if ((int) xv_get(item,XV_KEY_DATA,1))
    xv_set(data->fn,PANEL_VALUE,data->last_fn,NULL);
   else xv_set(data->fn,PANEL_VALUE,img->file->output.fn,NULL);
 if ((get_strlen(fn) != 0) && 
     (str_cmp(data->last_fn,img->file->output.fn) != 0))
    {c_free(data->last_fn);
     data->last_fn = fn;}
   else c_free(fn);
}


/*-------------------------------------------------------------------------
reload_file_slice_rois_proc - ???
-------------------------------------------------------------------------*/

void
reload_file_slice_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 char *str,*fn,*dir;
 int err;
 int is_free_fn,use_output_file_rec_fn;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 fn = (char *) xv_get(data->fn,PANEL_VALUE);
 str = NULL;
 if (get_strlen(fn) == 0)
    {xv_set(data->dir,PANEL_VALUE,img->file->output.dirfn,0);
     xv_set(data->fn,PANEL_VALUE,img->file->output.fn,0);
     use_output_file_rec_fn = 1;
     is_free_fn = 0;
    }
   else
    {dir = (char *) xv_get(data->dir,PANEL_VALUE);
     if ((err = build_fn(&str,dir,fn,".ndat")) != NO_ERROR) 
         {ShowMsgStrs(data->frame,0,NO_ERROR,0,2,
               "Unable to setup the ndat fn !!!",OPERATION_ABORTED,NULL,0);
	 return /*err*/;}
     is_free_fn = 1;
     use_output_file_rec_fn = 0;
    }
 ShowMsgStrs(data->frame,1,NO_ERROR,0,2,
          "Loading the slice rois from the given ndat file !!!",
          PLEASE_WAIT,rd_file_slice_rois,7,
          img->file,data->win,str,is_free_fn,use_output_file_rec_fn,1,0);

}


/*-------------------------------------------------------------------------
reload_slice_rois_proc - ???
-------------------------------------------------------------------------*/

void
reload_slice_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 ShowMsgStrs(data->frame,1,NO_ERROR,0,2,
               "Reloading all rois from the same ndat file !!!",
               PLEASE_WAIT,rd_file_slice_rois,7,
               img->file,data->win,NULL,0,1,1,0);
}


/*-------------------------------------------------------------------------
reload_cur_slice_rois_proc - ???
-------------------------------------------------------------------------*/

void
reload_cur_slice_rois_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 long slice_num;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 /*slice_num = img->cur_slice->slice->image_type_indx;*/
 slice_num = img->cur_slice->slice_num;
 ShowMsgStrs(data->frame,1,NO_ERROR,0,2,
               "Reloading current slice rois from the same ndat file !!!",
               PLEASE_WAIT,rd_file_slice_rois,7,
               img->file,data->win,NULL,0,1,0,slice_num);
}


/*-------------------------------------------------------------------------
reload_pixmap_proc - ???
-------------------------------------------------------------------------*/

void
reload_pixmap_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 int err;
 char *fn;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 if (img->win->image_display == NULL)
     return /*CANCEL*/;
 if ((err = get_output_fn(&(img->file->output),&fn)) != NO_ERROR)
    {
     ShowMsgStrs(data->frame,0,err,0,1,
               "Error setting up the file name !!!",NULL,0);
     return /*err*/;
    }
 ShowMsgStrs(data->frame,1,NO_ERROR,0,4,
               "Reloading the .pixmap file",
               fn,"The current pixel type maps are discarded !!!",
               PLEASE_WAIT,win_rd_pixmap,1,img->win->image_display);
}


/*-------------------------------------------------------------------------
discard_and_load_proc - ???
-------------------------------------------------------------------------*/

void
discard_and_load_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 char *str,*fn,*dir;
 int err;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 fn = (char *) xv_get(data->fn,PANEL_VALUE);
 if (get_strlen(fn) > 0)
    str_dealloc_and_cpy(&(img->file->output.fn),fn);
   else if (img->file->output.fn != NULL)
    xv_set(data->fn,PANEL_VALUE,img->file->output.fn,0);
 dir = (char *) xv_get(data->dir,PANEL_VALUE);
 if (get_strlen(dir) > 0)
    str_dealloc_and_cpy(&(img->file->output.dirfn),dir);
   else if (img->file->output.dirfn != NULL)
    xv_set(data->dir,PANEL_VALUE,img->file->output.dirfn,0);

 if ((err = get_output_fn(&(img->file->output),&fn)) != NO_ERROR)
    {
     ShowMsgStrs(data->frame,0,err,0,1,
               "Bad .ndat file name !!!",NULL,0);
     return /*err*/;
    }
 dp_def_fn_proc(data);
 concat_strs(&str,2,"Reloading the %s .ndat file",fn);
 ShowMsgStrs(data->frame,1,NO_ERROR,0,5,
               str,"The new editings are discarded !!!",
               ".pixmap will be loaded if exists;",
               "otherwise, the old .pixmap will still be intact",
               PLEASE_WAIT,win_rd_dat_output,1,data->win);
 c_free(fn);
 c_free(str);
}


/*-------------------------------------------------------------------------
save_binary_proc - ???
-------------------------------------------------------------------------*/

void
save_binary_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 wr_bin_proc(0,0,data->dwin,0,NULL,0);
 return;
}


/*-------------------------------------------------------------------------
save_data_proc - ???
-------------------------------------------------------------------------*/

void
save_data_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 char str[100],*fn;
 int err;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 if ((err = get_output_fn(&(img->file->output),&fn)) != NO_ERROR)
    {
     ShowMsgStrs(data->frame,0,err,0,1,
               "Bad .ndat file name !!!",NULL,0);
     return /*err*/;
    }
 if (get_strlen(fn) > 60) set_str_len(fn,60);
 sprintf(str,"Saving the %s .ndat file",fn);
 ShowMsgStrs(data->frame,1,NO_ERROR,0,2,
               str,PLEASE_WAIT,AutoSaveDatOutput,2,&(img->file->output),0);
}


/*-------------------------------------------------------------------------
get_save_data_fn_proc - ???
-------------------------------------------------------------------------*/

void
get_save_data_fn_proc(data,dir,fn)
 struct data_file_rec *data;
 char *dir,*fn;
{
 xv_set(data->dir,PANEL_VALUE,dir,0);
 drop_suffix(fn);
 xv_set(data->fn,PANEL_VALUE,fn,0);
}


/*-------------------------------------------------------------------------
get_fn_proc - ???
-------------------------------------------------------------------------*/

void
get_fn_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 struct img_buf_rec *img;
 char *filter,*str,*fn;
 int val;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 str = win_rec_win_id_title(data->win->owner,"SAVE DATA - GET FN...");
 val = (int) xv_get(data->save_whch,PANEL_VALUE);
 if (val & 1) filter = "*.ndat";
   else filter = "*.ntxt";
 if (img->file->output.fn == NULL) fn = "";
   else fn = img->file->output.fn;

 ask_files(1,data->frame,str,
       NULL,1,0,get_save_data_fn_proc,data,
       NULL,NULL,1,filter,1,0,5,285,NULL,NULL,1,
       data->win->owner->root->prog->defaults.whch.dat_dir,NULL,NULL,
       "FN",fn,NULL,NULL
      );
 c_free(str);
}


/*-------------------------------------------------------------------------
save_the_data_proc - ???
-------------------------------------------------------------------------*/

void
save_the_data_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct data_file_rec *data;
 int val;
 struct img_buf_rec *img;

 data = (struct data_file_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(data->win->owner)) == NULL)
     return /*CANCEL*/;
 val = (int) xv_get(data->save_whch,PANEL_VALUE);
 if (val & 1) save_data_proc(item,event);
 if (val & 2) 
    text_output_proc(0,0,data->dwin,0,NULL,
               VALUE_SAVE_TEXT_TO_FILE);
 if (val & 4) save_pixel_types(img->file,data->frame,1);
}


/*-------------------------------------------------------------------------
setup_data_file_rec - ???
-------------------------------------------------------------------------*/

int
setup_data_file_rec(data,win)
 struct data_file_rec *data;
 struct image_display_window *win;
{
 char *str,*fn,*dir;
 Panel_item item;
 struct img_buf_rec *img;
 int row,offset;
 Rect *rr;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 data->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 if (data->frame == 0) return CANCEL;
 data->win = win;
 data->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,SAVE_DATA);
 xv_set(data->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,data_file_rec_done_proc,
              WIN_SHOW,FALSE,
              WIN_CLIENT_DATA,data,
              0);
 c_free(str);
 data->panel = xv_create(data->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (data->panel == 0)
    {free_data_file_rec(data);
     return CANCEL;}

 row = 5;
 offset = xv_rows(data->panel,1) - xv_rows(data->panel,0) - 10;

 xv_create(data->panel,PANEL_MESSAGE,
              PANEL_LABEL_STRING,"Suffix .? is always assumed for fn !!!",
              XV_X,5,XV_Y,row,
              0);
 row += offset - 8;
 data->save_whch = xv_create(data->panel,PANEL_TOGGLE,
	PANEL_LABEL_STRING,"? =",   
        PANEL_CHOICE_STRINGS,"*.ndat","*.ntxt/*.count","*.pixmap",0,     
        PANEL_VALUE,1,
        XV_X,15,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 row += offset;

 data->def = xv_create(data->panel,PANEL_MESSAGE,
        XV_X,10,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 dp_def_fn_proc(data);
 row += offset - 5;

 item = xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"Change DEF",        
        PANEL_NOTIFY_PROC,chage_def_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 rr = (Rect *) xv_get(item,XV_RECT);

 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"GET *.ndat or *.ntxt fn",        
        PANEL_NOTIFY_PROC,get_fn_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 row += offset;

 if (img->file->output.dirfn == NULL)
    dir = "";
   else dir = img->file->output.dirfn;
 if (img->file->output.fn == NULL)
    fn = "";
   else fn = img->file->output.fn;
 data->dir = xv_create(data->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"DIR :",
              PANEL_VALUE,dir,
              PANEL_VALUE_DISPLAY_LENGTH,25,
              PANEL_VALUE_STORED_LENGTH,100,
              XV_X,5,XV_Y,row,
              0);
 cp_str(&(data->last_dir),dir);
 rr = (Rect *) xv_get(data->dir,XV_RECT);
 item = xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"LAST",        
        PANEL_NOTIFY_PROC,save_last_dir_proc,
        XV_KEY_DATA,1,1,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 rr = (Rect *) xv_get(item,XV_RECT);
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DEF",        
        PANEL_NOTIFY_PROC,save_last_dir_proc,
        XV_KEY_DATA,1,0,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 row += offset;
 cp_str(&(data->last_fn),fn);
 data->fn = xv_create(data->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"fn :",
              PANEL_VALUE,fn,
              PANEL_VALUE_DISPLAY_LENGTH,25,
              PANEL_VALUE_STORED_LENGTH,100,
              XV_X,5,XV_Y,row,
              0);
 rr = (Rect *) xv_get(data->fn,XV_RECT);
 item = xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"LAST",        
        PANEL_NOTIFY_PROC,last_fn_proc,
        XV_KEY_DATA,1,1,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 rr = (Rect *) xv_get(item,XV_RECT);
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DEF",        
        PANEL_NOTIFY_PROC,last_fn_proc,
        XV_KEY_DATA,1,0,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 row += offset;
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,LOAD_FILE_SLICE_ROIS,        
        PANEL_NOTIFY_PROC,reload_file_slice_rois_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 row += offset;
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,RELOAD_SLICE_ROIS,        
        PANEL_NOTIFY_PROC,reload_slice_rois_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 row += offset;
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,RELOAD_CUR_SLICE_ROIS,        
        PANEL_NOTIFY_PROC,reload_cur_slice_rois_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 row += offset;
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,RELOAD_PIXMAP,        
        PANEL_NOTIFY_PROC,reload_pixmap_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);

 row += offset;
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,LOAD_DAT_FILE,        
        PANEL_NOTIFY_PROC,discard_and_load_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 if (!(win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS))
    {row += offset;
     xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,OUTPUT_BIN,        
        PANEL_NOTIFY_PROC,save_binary_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);}

 row += offset;
 str = "SAVE DATA - S";
 xv_create(data->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,str,        
        PANEL_NOTIFY_PROC,save_the_data_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,data,0);
 window_fit(data->panel);
 rr = (Rect *) xv_get(data->panel,XV_RECT);
 xv_set(data->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);

 window_fit(data->frame);
 make_2_wins_adjacent(data->frame,win->dwin->frame,0);
 win_set_mouse_at_center(data->frame);
 xv_set(data->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_data_file_rec - ???
-------------------------------------------------------------------------*/

struct data_file_rec *
find_data_file_rec(all_datas,win,dwin)
 struct all_data_file_recs *all_datas;
 struct image_display_window *win;
 struct display_win_rec *dwin;
{
 int lcv;

 for (lcv = 0; lcv < all_datas->num_datas; lcv++)
    if ((all_datas->datas[lcv]->win == win) &&
        (all_datas->datas[lcv]->dwin == dwin))
       return all_datas->datas[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
find_same_data_file - ???
-------------------------------------------------------------------------*/

struct data_file_rec *
find_same_data_file(all_datas,win)
 struct all_data_file_recs *all_datas;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_datas->num_datas; lcv++)
    {if ((img = win_rec_cur_img_buf(all_datas->datas[lcv]->win->owner)) != NULL)
        if (img->file == f1)
           return all_datas->datas[lcv];
    }
 return NULL;
}


/*-----------------------------------------------------------------
setup_enter_data_file_rec - ???

Wrapper for external users that don't need to know the internal
data structures.
------------------------------------------------------------------*/

void 
setup_enter_data_file_rec(
    struct image_display_window *win)
{
    enter_data_file_rec(win, SETUP_DATA_FILE_REC);
    return;
}


/*------------------------------------------------------------------
enter_data_file_rec - ???

NOTE: The pre-19990223 version of this function could return either
NULL, a pointer to a structure, or an integer error code.  Since the
last two of these cannot be reliably distinguished and since no one
ever seems to check for an error code, I replaced the error code by
NULL.  Of course, it is now impossible to distinguish between NO_ERROR
and NULL (=> error), but I don't think anyone ever looks at the error
code returned.  -PWH
-------------------------------------------------------------------*/

static struct all_data_file_recs *
enter_data_file_rec(
    struct image_display_window *win,
    int status)
{
 static struct all_data_file_recs all_datas;
 struct data_file_rec *data;
 static char first_time = 1;
 int err;
 char *str;

 err = NO_ERROR;
 if (status == GET_ALL_DATA_PTR)
    {if (first_time) return NULL;
       else return &all_datas;}
 else if (status == CLEAN_UP_DATA_FILE_REC)
   {if (!first_time)
       if ((data = find_data_file_rec(&all_datas,win,win->dwin)) != NULL)
          free_data_file_rec(data);
    return NO_ERROR;}
 if (first_time)
    {init_all_data_file_recs(&all_datas);
     first_time = 0;}
 else
    {if ((data = find_data_file_rec(&all_datas,win,win->dwin)) != NULL)
        {xv_set(data->frame,XV_SHOW,TRUE,WIN_ALARM,0);
         win_set_mouse_at_center(data->frame);
         wmgr_top(data->frame);
         return NO_ERROR;}

     if ((data = find_same_data_file(&all_datas,win)) != NULL)
        {
         data->win = win;
         data->dwin = win->dwin;
         xv_set(data->frame,XV_OWNER,win->dwin->frame,XV_SHOW,TRUE,WIN_ALARM,0);
         str = win_rec_win_id_title(win->owner,SAVE_DATA);
         xv_set(data->frame,XV_LABEL,str,0);
         c_free(str);
         wmgr_top(data->frame);
         win_set_mouse_at_center(data->frame);

         return NO_ERROR;
        }
    }
 get_handle_memory(&(all_datas.datas),&(all_datas.num_datas),1,
     (size_t) sizeof(struct data_file_rec),&err);
 if (err != NO_ERROR) return NULL;    /* Was: return err */
 data = all_datas.datas[all_datas.num_datas - 1];
 init_data_file_rec(data);
 if ((err = setup_data_file_rec(data,win)) != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the SAVE DATA window !!!",NULL,0);
 return NULL;    /* Was: return err */

}

