/****************************************************************************
screen_data_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: screen_data_rec.c,v 1.7 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <X11/Xlib.h>
#include <X11/Xutil.h>         /* For XDestroyImage */

#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
*/

#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)


/* Functions defined in this file */
int get_pixel_pattern(unsigned char ***mask, unsigned int ***value,
    unsigned int num_rows, unsigned int num_cols);
int setup_screen_pixel_desc_rec1(struct pixel_desc_rec *pixel,
    struct pixel_desc_rec *last_pixel, unsigned int num_rows,
    unsigned int num_cols);
int assign_screen_pixel_desc_rec(struct pixel_desc_rec *pixel,
    struct pixel_desc_rec *last_pixel, unsigned int num_rows,
    unsigned int num_cols, unsigned char **mask, unsigned int **value);
void swap_screen_dimension(struct int_region_rect *dimension1,
    struct int_region_rect *dimension2);
void init_screen_data_rec(struct screen_data_rec *screen);
int setup_def_screen_data_rec(struct screen_data_rec *screen,
    struct int_rect_rec *limitrr, unsigned int left, unsigned int top,
    unsigned int width, unsigned int height, int magx, int magy,
    int is_same_magxy);
int redefine_def_dimension(struct screen_data_rec *screen);
void free_screen_data_rec(struct screen_data_rec *screen);
int setup_screen_dimension(struct int_region_rect *dim,
    struct int_region_rect *last_dim, struct pixel_desc_rec *pixel,
    struct pixel_desc_rec *last_pixel, int HowToDefine, int CenterIt,
    int centerx, int centery);
int SetScreenMagXY(struct screen_data_rec *screen, unsigned long magx,
    unsigned long magy);
int ScaleViewDimXY(struct int_region_rect *dim, unsigned long dimx,
    unsigned long dimy);
int ScaleViewScreenDimXY(struct screen_data_rec *screen, unsigned long dimx,
    unsigned long dimy, unsigned long use_magxy, unsigned long magx,
    unsigned long magy);


/*--------------------------------------------------------------------------
get_pixel_pattern - ???
--------------------------------------------------------------------------*/

int
get_pixel_pattern(mask,value,num_rows,num_cols)
 unsigned char ***mask;
 unsigned int ***value;
 unsigned int num_rows,num_cols;
{
 unsigned int total,row,col;
 int err;

 total = 0;
 get_handle_memory(mask,&total,num_rows,
                (size_t) (num_cols * sizeof(unsigned char)),&err);
 if (err != NO_ERROR) return err;
 total = 0;
 get_handle_memory(value,&total,num_rows,
                (size_t) (num_cols * sizeof(unsigned int)),&err);
 if (err != NO_ERROR) free_handle_memory(mask,(unsigned int) num_rows);
   else
    {
     for (row = 0; row < num_rows; row++)
        for (col = 0; col < num_cols; col++)
           {(*mask)[row][col] = 1;
            (*value)[row][col] = 1;}
    }
 return err;
}


/*--------------------------------------------------------------------------
setup_screen_pixel_desc_rec1 - ???
--------------------------------------------------------------------------*/

int
setup_screen_pixel_desc_rec1(pixel,last_pixel,num_rows,num_cols)
 struct pixel_desc_rec *pixel,*last_pixel;
 unsigned int num_rows,num_cols;
{
 unsigned char **mask;
 unsigned int **value;
 int err;
 struct pixel_desc_rec temp_pixel;

 TRACE(printf("setup_screen_pixel_desc_rec1.num_rows = %d num_cols = %d..\n",
            num_rows,num_cols))
 if ((err = get_pixel_pattern(&mask,&value,num_rows,num_cols)) != NO_ERROR)
    return err;
 init_pixel_desc_rec(&temp_pixel,pixel->def_magx,pixel->def_magy);
 if ((err = setup_pixel_desc_rec(&temp_pixel,num_cols,num_rows,mask,value))
                != NO_ERROR)
    {free_pixel_desc_rec(&temp_pixel);
     return err;}
 if (last_pixel != NULL)
    {/* copy_pixel_desc_rec(last_pixel,pixel);*/
     free_pixel_desc_rec(last_pixel);
     *last_pixel = *pixel;
    }
   else free_pixel_desc_rec(pixel);
 *pixel = temp_pixel;

 free_handle_memory(mask,(unsigned int) num_rows);
 free_handle_memory(value,(unsigned int) num_rows);
 return err;

}


/*--------------------------------------------------------------------------
assign_screen_pixel_desc_rec - ???
--------------------------------------------------------------------------*/

int
assign_screen_pixel_desc_rec(pixel,last_pixel,num_rows,num_cols,mask,value)
 struct pixel_desc_rec *pixel,*last_pixel;
 unsigned int num_rows,num_cols;
 unsigned char **mask;
 unsigned int **value;
{
 copy_pixel_desc_rec(last_pixel,pixel);
 free_pixel_desc_rec(pixel);
 return setup_pixel_desc_rec(pixel,num_cols,num_rows,mask,value);
}


/*--------------------------------------------------------------------------
swap_screen_dimension - ???
--------------------------------------------------------------------------*/

void
swap_screen_dimension(dimension1,dimension2)
 struct int_region_rect *dimension1,*dimension2;
{
 struct int_region_rect dim;

 dim = *dimension1;
 *dimension1 = *dimension2;
 *dimension2 = dim;
}


/*--------------------------------------------------------------------------
init_screen_data_rec - ???
--------------------------------------------------------------------------*/

void
init_screen_data_rec(screen)
 struct screen_data_rec *screen;
{
 screen->status = 0;
 init_buf_2d_rec(&(screen->_2d));
 screen->im = NULL;
 init_pixel_desc_rec(&(screen->pixel),0,0);
 init_pixel_desc_rec(&(screen->last_pixel),0,0);
}


/*--------------------------------------------------------------------------
setup_def_screen_data_rec - ???
--------------------------------------------------------------------------*/

int
setup_def_screen_data_rec(screen,limitrr,
                     left,top,width,height,magx,magy,is_same_magxy)
 struct screen_data_rec *screen;
 struct int_rect_rec *limitrr;
 unsigned int left,top,width,height;
 int magx,magy,is_same_magxy;
{
 int size,size1,size2,def_width,def_height;
 int err;

 if (magx > MAX_MAGNIFY_PIXEL_DIM) magx = MAX_MAGNIFY_PIXEL_DIM;
 if (magy > MAX_MAGNIFY_PIXEL_DIM) magy = MAX_MAGNIFY_PIXEL_DIM;
 if (is_same_magxy)
    if (magx > magy) magx = magy;
      else if (magy > magx) magy = magx;

 setup_int_rect_rec(&(screen->def_dimension.limitboundrect),
          left,top,width,height);
 screen->def_dimension.limitrr = *limitrr;

 PRT(printf(" l = %d t = %d r = %d b = %d  magx = %d magy = %d\n",left,top,
          left + width - 1,top + height - 1,magx,magy))
 if (width > limitrr->width)
    {magx = 1;
     if (is_same_magxy) magy = 1;
     if (width > 512) size = 512;
       else size = width;
     if (size > limitrr->width) size = limitrr->width;
     left = left + (width - size) / 2;
     width = size;
     def_width = 0;
    }
   else def_width = 1;
 if (height > limitrr->height)
    {
     if (height > 512) size = 512;
       else size = height;
     if (size > limitrr->height) size = limitrr->height;
     top = top + (height - size) / 2;
     height = size;
     def_height = 0;
    }
   else def_height = 1;

 size = magx * width;
 size1 = magy * height;
 if (size > limitrr->width)
    {if (is_same_magxy) 
        {if (width < height) size2 = width;
           else size2 = height;
         if (limitrr->width < limitrr->height)
            magx = magy = limitrr->width / size2;
           else        
            magx = magy = limitrr->height / size2;
        }
       else magx = limitrr->width / size2;
    }
   else if (size < 256)
    {if (is_same_magxy) 
        {if (size < size1) magx = magy = 256 / size;
           else magx = magy = 256 / size1;}
       else magx = magy = 256 / size;
    }
           
 size = magx * width;
 size1 = magy * height;
 if (size1 > limitrr->height)
    {if (is_same_magxy) 
        {if (width < height) size2 = width;
           else size2 = height;
         if (limitrr->width < limitrr->height)
            magx = magy = limitrr->width / size2;
           else        
            magx = magy = limitrr->height / size2;
        }
       else magy = limitrr->height / size1;
    }
   else if (size1 < 256)
    {if (is_same_magxy) 
        {if (size < size1) magx = magy = 256 / size;
           else magx = magy = 256 / size1;}
       else magx = magy = 256 / size1;
    }
 
 PRT(printf("after l = %d t = %d r = %d b = %d  magx = %d magy = %d\n",left,top,
          left + width - 1,top + height - 1,magx,magy))

 setup_int_rect_rec(&(screen->def_dimension.magrect),
                magx,magy,
                MAX_MAGNIFY_PIXEL_DIM,MAX_MAGNIFY_PIXEL_DIM);
 setup_int_bound_rec(&(screen->def_dimension.bound),
                  left,top,left + width - 1,top + height - 1);
 setup_int_rect_rec(&(screen->def_dimension.rr),
        limitrr->left,limitrr->top,
        (int) width * magx,
        height * magy);
 TRACE(pr_int_region_rect(&(screen->def_dimension)))

 screen->dimension = screen->def_dimension;
 screen->last_dimension = screen->dimension;
 screen->def_mag_fac = magx;
 err = setup_screen_pixel_desc_rec1(&(screen->pixel),&(screen->last_pixel),
           screen->dimension.magrect.left,screen->dimension.magrect.top);
 return err;
}


/*--------------------------------------------------------------------------
redefine_def_dimension - ???
--------------------------------------------------------------------------*/

int
redefine_def_dimension(screen)
 struct screen_data_rec *screen;
{
 struct int_region_rect *dim;
 long height,width;

 dim = &(screen->def_dimension);
 width = dim->limitboundrect.width * dim->magrect.left;
 height = dim->limitboundrect.height * dim->magrect.top;
 PRT2(printf("after redefine_def_dimension...def_dimension\n"))
 PRT2(pr_int_region_rect(&(screen->def_dimension)))
 PRT2(printf("redefine_def_dimension width = %d height = %d\n",width,height))
 PRT2(printf("width = %d height = %d\n",dim->limitrr.width,dim->limitrr.height))
 if ((dim->limitrr.width >= width) && (dim->limitrr.height >= height))
    {PRT2(printf("redefine_def_dimension smaller...\n"))
     setup_int_bound_rec(&(dim->bound),
         dim->limitboundrect.left,dim->limitboundrect.top,
         dim->limitboundrect.left + dim->limitboundrect.width - 1,
         dim->limitboundrect.top + dim->limitboundrect.height - 1);
     dim->rr.width = width;
     dim->rr.height = height;
     dim->rr.left = dim->rr.top = 0;
    }
   else if ((dim->limitrr.width >= dim->rr.width) && 
            (dim->limitrr.height >= dim->rr.height))
    {PRT2(printf("redefine_def_dimension ok...\n"))
     return NO_ERROR;}
   else
    {PRT2(printf("redefine_def_dimension readjust...\n"))
     width = dim->limitrr.width / dim->magrect.left;
     if (width <= 0) width = 1;
     height = dim->limitrr.height / dim->magrect.top;
     if (height <= 0) height = 1;
     dim->bound.right = dim->bound.left + width - 1;
     dim->bound.bottom = dim->bound.top + height - 1;
     dim->rr.width = width * dim->magrect.left;
     dim->rr.height = height * dim->magrect.top;
    }
 PRT2(printf("after readjust...def_dimension\n"))
 PRT2(pr_int_region_rect(&(screen->def_dimension)))
 screen->last_dimension = screen->dimension;
 screen->dimension = screen->def_dimension;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
free_screen_data_rec - ???
--------------------------------------------------------------------------*/

void
free_screen_data_rec(screen)
 struct screen_data_rec *screen;
{
 free_buf_2d_rec(&(screen->_2d));
 free_pixel_desc_rec(&(screen->pixel));
 free_pixel_desc_rec(&(screen->last_pixel));
 if (screen->im != NULL)
    {screen->im->data = NULL;
     XDestroyImage(screen->im);
     screen->im = NULL;}
 init_screen_data_rec(screen);
}


/*--------------------------------------------------------------------------
setup_screen_dimension - ???
--------------------------------------------------------------------------*/

int
setup_screen_dimension(dim,last_dim,pixel,last_pixel,
                       HowToDefine,CenterIt,centerx,centery)
 struct int_region_rect *dim,*last_dim;
 struct pixel_desc_rec *pixel,*last_pixel;
 int HowToDefine,CenterIt,centerx,centery;
{
 int err;

 *last_dim = *dim;
 define_dimension(dim,HowToDefine,CenterIt,centerx,centery);

 TRACE(pr_int_region_rect(dim))

 if (!(pixel->mask.status4 & BUF_NON_EMPTY) ||
      (dim->magrect.left != pixel->mask.dimx) ||
      (dim->magrect.top != pixel->mask.dimy))
    err = setup_screen_pixel_desc_rec1(pixel,last_pixel,
           dim->magrect.left,dim->magrect.top);
   else err = NO_ERROR;
 TRACE(printf("after mask.dimx = %d pixel->mask.dimy = %d\n\n",
         pixel->mask.dimx,pixel->mask.dimy))
 return err;
}


/******************
redefine_def_dimension_bound(screen,left,top,width,height,is_set_cur_bound)
 struct screen_data_rec *screen;
 int left,top,width,height,is_set_cur_bound;
{
 PRT(printf("redefine_def_dimension_bound...def_dimension\n"))
 PRT(pr_int_region_rect(&(screen->def_dimension)))

 PRT(printf("redefine_def_dimension_bound...dimension\n"))
 PRT(pr_int_region_rect(&(screen->dimension)))


 PRT(printf("after...def_dimension\n"))
 PRT(pr_int_region_rect(&(screen->def_dimension)))

 PRT(printf("after...dimension\n"))
 PRT(pr_int_region_rect(&(screen->dimension)))
 struct int_bound_rec bound,screen_bound;
 struct int_rect_rec *screen_rect;
 int width,max,size,height,left1,top1,right1,bottom1;

 screen_rect = &(screen->def_dimension.limitrr);
 width = right - left + 1;
 size = width * screen->dimension.magrect.leftafter;
 if (size > screen_rect->width)
    {screen->dimension.magrect.left = 1;
     if (width > screen_rect->width) right = left + screen_rect->width - 1;
    }
 height = bottom - top + 1;
 size = height * screen->dimension.magrect.top;
 if (size > screen_rect->height)
    {screen->dimension.magrect.top = 1;
     if (height > screen_rect->height) bottom = top + screen_rect->height - 1;
    }
 setup_int_bound_rec(&bound,left,top,right,bottom);
 int_rect_to_bound(&screen_bound,screen_rect);
 valid_bound(&bound,&screen_bound,&left1,&right1,&top1,&bottom1);

 setup_int_bound_rec(&(screen->def_dimension.bound),left1,top1,right1,bottom1);
 setup_int_bound_rec(&(screen->def_dimension.bound),left1,top1,right1,bottom1);
 if (is_set_cur_bound)
    {screen->last_dimension.bound = screen->def_dimension.bound;
     screen->dimension.bound = screen->def_dimension.bound;
    }
}
**************/


/*--------------------------------------------------------------------------
SetScreenMagXY - ???
--------------------------------------------------------------------------*/

int
SetScreenMagXY(screen,magx,magy)
 struct screen_data_rec *screen;
 unsigned long magx,magy;
{
 int err;

 if ((magx == screen->dimension.magrect.left) &&
     (magy == screen->dimension.magrect.top))
    return NO_ERROR;
 if (magx < screen->dimension.magrect.width)
    screen->dimension.magrect.left = magx;
   else 
    screen->dimension.magrect.left = screen->dimension.magrect.width;
 if (magy < screen->dimension.magrect.height)
    screen->dimension.magrect.top = magy;
   else 
    screen->dimension.magrect.top = screen->dimension.magrect.height;
 if (!(screen->pixel.mask.status4 & BUF_NON_EMPTY) ||
      (screen->dimension.magrect.left != screen->pixel.mask.dimx) ||
      (screen->dimension.magrect.top != screen->pixel.mask.dimy))
    err = setup_screen_pixel_desc_rec1(&(screen->pixel),&(screen->last_pixel),
           screen->dimension.magrect.left,screen->dimension.magrect.top);
   else err = NO_ERROR;
 return err;
}


/*--------------------------------------------------------------------------
ScaleViewDimXY - ???
--------------------------------------------------------------------------*/

int
ScaleViewDimXY(dim,dimx,dimy)
 struct int_region_rect *dim;
 unsigned long dimx,dimy;
{
 float ratio,diff,centerx,centery;
 long width;

 width = dim->bound.right - dim->bound.left + 1;

 if (width == dim->limitboundrect.width)
    {dim->bound.left = 0;
     dim->bound.right = dimx - 1;
     PRT(printf("====ScaleViewDimXY...bound.left = %d right = %d\n",
          dim->bound.left,dim->bound.right))}
   else 
    {ratio = (float) dimx / (float) dim->limitboundrect.width;
     diff = (float) width * ratio / 2.0;
     centerx = (float) (dim->bound.right + dim->bound.left) / 2.0 * ratio;
     dim->bound.left = (long) floor((double) (centerx - diff));
     if (dim->bound.left < 0) dim->bound.left = 0;
     dim->bound.right = (long) floor((double) (centerx + diff + .5));
     if (dim->bound.right >= dimx) dim->bound.right = dimx - 1;
     PRT(printf("ScaleViewDimXY...bound.left = %d right = %d\n",
          dim->bound.left,dim->bound.right))
    }

 width = dim->bound.bottom - dim->bound.top + 1;
 if (width == dim->limitboundrect.height)
    {dim->bound.top = 0;
     dim->bound.bottom = dimy - 1;
     PRT(printf("===ScaleViewDimXY...bound.top = %d bottom = %d\n",
          dim->bound.top,dim->bound.bottom))}
   else 
    {ratio = (float) dimy / (float) dim->limitboundrect.height;
     diff = (float) width * ratio / 2.0;
     centery = (float) (dim->bound.bottom + dim->bound.top) / 2.0 * ratio;
     dim->bound.top = (long) floor((double) (centery - diff));
     diff = (float) floor((double) (centery - diff));

     if (dim->bound.top < 0) dim->bound.top = 0;
     dim->bound.bottom = (long) floor((double) (centery + diff + .5));
     if (dim->bound.bottom >= dimy) dim->bound.bottom = dimy - 1;
     PRT(printf("ScaleViewDimXY...bound.top = %d bottom = %d\n",
          dim->bound.top,dim->bound.bottom))
    }
 dim->limitboundrect.width = dimx;
 dim->limitboundrect.height = dimy;

 dim->rr.width = (dim->bound.right - dim->bound.left + 1) * 
                  dim->magrect.left;
 dim->rr.height = (dim->bound.bottom - dim->bound.top + 1) * 
                   dim->magrect.top;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
ScaleViewScreenDimXY - ???
--------------------------------------------------------------------------*/

int
ScaleViewScreenDimXY(screen,dimx,dimy,use_magxy,magx,magy)
 struct screen_data_rec *screen;
 unsigned long dimx,dimy,use_magxy,magx,magy;
{
 int err;

 PRT2(printf("ScaleViewScreenDimXY...dimx = %d dimy = %d\n",dimx,dimy))
 PRT2(printf("...use_magxy = %d magx = %d magy = %d\n",use_magxy,magx,magy))
 PRT2(pr_int_region_rect(&(screen->dimension)))
 if (use_magxy)
    {if ((err = SetScreenMagXY(screen,magx,magy)) != NO_ERROR) return err;
    }
 ScaleViewDimXY(&(screen->dimension),dimx,dimy);
 ScaleViewDimXY(&(screen->def_dimension),dimx,dimy);
 ScaleViewDimXY(&(screen->last_dimension),dimx,dimy);
 PRT2(printf("after ScaleViewScreenDimXY...\n"))
 PRT2(pr_int_region_rect(&(screen->dimension)))
 redefine_def_dimension(screen);
 return NO_ERROR;
}
