/****************************************************************************
segment_1_echo.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: segment_1_echo.c,v 1.10 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "segment.h"
#include "edge.h"
#include "nria_procedures.h"

/*
#define PRINT(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRINT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)



struct sort_resolve_list_rec
   {
    struct pixel_neighbor_type_rec *pix_neigh;
    struct stack_xy_rec *xy;
   };


/* Functions defined in this file */
void init_type_val_rec(struct type_val_rec *set);
void free_type_val_rec(struct type_val_rec *set);
void init_the_type_val_rec(struct the_type_val_rec *all);
void free_the_type_val_rec(struct the_type_val_rec *all);
void free_stack_xy_rec(struct stack_xy_rec *top);
void init_stack_list_rec(struct stack_list_rec *list);
void init_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *resolve_ptr);
void free_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *resolve_ptr,
    int is_free_lists);
int sort_1_echo_stack_list_rec_ptr_proc(struct stack_list_rec **list1,
    struct stack_list_rec **list2);
int setup_stack_xy_rec(struct stack_list_rec *list, long x, long y,
    struct stack_xy_rec **xy);
int cp_stack_list_rec(struct stack_list_rec *dest, struct stack_list_rec *src);
int cp_pixel_stack_rec_ptr_content(struct pixel_stack_rec_ptr *dest,
    struct pixel_stack_rec_ptr *src);
int cp_pixel_stack_rec_ptrs(struct pixel_stack_rec_ptr *dest_ptr,
    struct pixel_stack_rec_ptr *src);
int setup_1_echo_stack_list_rec(struct pixel_stack_rec_ptr *resolve, long val,
    struct stack_list_rec **list, long add_max_items);
long cnt_stack_xy_rec(struct stack_xy_rec *top);
long cnt_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *resolve);
int find_stack_xy_rec_1(struct stack_xy_rec *top, struct stack_xy_rec *item,
    unsigned long *indx);
int find_stack_xy_rec_ptr(struct pixel_stack_rec_ptr *resolve,
    struct stack_xy_rec *item);
int find_stack_xy_rec_by_xy(struct stack_xy_rec *top, long x, long y,
    struct stack_xy_rec **item);
int find_stack_xy_rec_ptr_by_xy(struct pixel_stack_rec_ptr *resolve,
    long x, long y, struct stack_xy_rec **item);
void pr_stack_xy_rec(struct stack_xy_rec *top);
void pr_stack_list_rec(struct stack_list_rec *list, int pr_xy, int num_echoes);
void pr_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *ptr, int pr_xy,
    int num_echoes);
void pr_type_val_rec(struct type_val_rec *set, int num_echoes);
void pr_the_type_val_rec(struct the_type_val_rec *all, int num_echoes);
int find_1_echo_pixel_stack_rec(struct pixel_stack_rec_ptr *resolve, long lb,
    long ub, struct stack_list_rec ***lists, unsigned long *total_lists,
    unsigned long *num_lists, unsigned long *lbindx, unsigned long *ubindx);
int drop_empty_stack_lists(struct pixel_stack_rec_ptr *resolve);
int drop_empty_pixel_stack_rec_list_ptrs(struct pixel_stack_rec_ptr *resolve);
int search_type_lb_proc(struct pixel_tissue_type_rec *type1,
    struct pixel_tissue_type_rec *type2);
int search_type_ub_proc(struct pixel_tissue_type_rec *type1,
    struct pixel_tissue_type_rec *type2);
int sort_type_lb_ub_proc(const void *type1, const void *type2);
int search_type_lb_proc_1(const void *type1, const void *type2);
int search_type_ub_proc_1(const void *type1, const void *type2);
int sort_type_ub_lb_proc(const void *type1, const void *type2);
int find_type(struct pixel_tissue_type_rec *types, unsigned int num_types,
    struct roi_rec *roi, int set_cur, unsigned int *cur_type);
int sort_range_indx_rec_proc(const void *rec1, const void *rec2);
int setup_segment_rois(struct pixel_tissue_type_rec **types,
    unsigned long *total_types, unsigned long *num_types,
    struct strs_rec *order, struct slice_roi_rec *slice_roi, int is_xdim,
    long the_lb, long the_ub);
int _1_echo_statistics(struct pixel_type_ave_rec *type_aves,
    long num_type_aves, struct buf_2d_rec *_2d_types,
    struct buf_2d_rec *image_mask,
    struct pixel_neighbor_type_rec **pix_neighs,
    struct stack_list_rec *resolve, struct buf_2d_rec *neigh_2d);
int sort_type_conn_fac_rec_proc(const void *type1, const void *type2);
void incompatible_type_by_neighbors(struct neighbor_type_rec *neigh,
    struct type_val_rec *cur_pix, long x, long y, struct buf_2d_rec *neigh_2d);
int neighbor_weights(struct neighbor_type_rec *neigh,
    struct type_val_rec *cur_pix, long x, long y, struct buf_2d_rec *neigh_2d,
    struct buf_2d_rec *image_mask);
int compute_1_echo_weights(struct neighbor_type_rec *neigh,
    struct buf_2d_rec *_2d, long x, long y);
void check_done_neighs(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve);
int setup_neighbor_type_rec(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2, struct buf_2d_rec *image_mask, int num_echoes);
int update_neighs(struct neighbor_type_rec *neigh,
    struct buf_2d_rec *neigh_2d, long row, long col, long type);
void free_neighbor_type_rec(struct buf_2d_rec *neigh_2d);
int solve_1_echo_shared_pixel_types(struct pixel_type_ave_rec *type_aves,
    long num_type_aves, struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *image_mask);
void check_weights(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve);
int segment_pixel_map(struct buf_2d_rec *pixel_map,
    struct buf_2d_rec *neigh_2d, struct buf_2d_rec *image_mask);
int sort_1_echo_type_val_rec_proc(struct type_val_rec **set1,
    struct type_val_rec **set2);
void cnt_2d_types(struct buf_2d_rec *_2d_types);
int setup_1_echo_types(struct the_type_val_rec *all,
    struct buf_2d_rec *_2d_types, struct buf_2d_rec *_2d,
    struct pixel_tissue_type_rec *types, unsigned long num_types);
void restore_1_echo_segment_params(struct pixel_tissue_type_rec *types,
    unsigned long num_types);
int sort_resolve_list_rec_proc(const void *ptr1, const void *ptr2);
int sort_resolve_list(struct pixel_stack_rec_ptr *resolve,
    struct buf_2d_rec *neigh_2d, int is_pr);
int segment_1_echo_pixels(struct pixel_tissue_type_rec *types,
    unsigned long num_types, struct buf_2d_rec *_2d,
    struct buf_2d_rec *pixel_map, struct histo_params_rec *histo, int option);
int setup_1_echo_histo_pixel_type_order(struct histo_params_rec *histo);
int setup_pixel_type_order(struct pixel_type_rec *pixel_type,
    struct histo_params_rec *histo);
int setup_pixel_type_maps(struct pixel_type_rec *pixel_type,
    unsigned long num_slice_maps);
int setup_segment_1_echo(struct histo_params_rec *histo,
    struct pixel_type_rec *pixel_type, struct strs_rec *priority,
    unsigned long num_slice_maps);



/*--------------------------------------------------------------------------
init_type_val_rec - ???
--------------------------------------------------------------------------*/

void
init_type_val_rec(set)
 struct type_val_rec *set;
{
 set->num_types = 0;
 set->types =  NULL;
}


/*--------------------------------------------------------------------------
free_type_val_rec - ???
--------------------------------------------------------------------------*/

void
free_type_val_rec(set)
 struct type_val_rec *set;
{
 if (set->num_types > 0)
    c_free(set->types);
}


/*--------------------------------------------------------------------------
init_the_type_val_rec - ???
--------------------------------------------------------------------------*/

void
init_the_type_val_rec(all)
 struct the_type_val_rec *all;
{
 all->total_sets = all->num_sets = 0;
 all->sets =  NULL;
}


/*--------------------------------------------------------------------------
free_the_type_val_rec - ???
--------------------------------------------------------------------------*/

void
free_the_type_val_rec(all)
 struct the_type_val_rec *all;
{
 long lcv;

 if (all->total_sets > 0)
    {for (lcv = 0; lcv < all->num_sets; lcv++)
        free_type_val_rec(all->sets[lcv]);
     free_handle_memory(all->sets,all->total_sets);}
}


/*--------------------------------------------------------------------------
free_stack_xy_rec - ???
--------------------------------------------------------------------------*/

void
free_stack_xy_rec(top)
 struct stack_xy_rec *top;
{
 struct stack_xy_rec *next;

 while (top != NULL)
    {next = top->next;
     c_free(top);
     top = next;}
}


/*--------------------------------------------------------------------------
init_stack_list_rec - ???
--------------------------------------------------------------------------*/

void
init_stack_list_rec(list)
 struct stack_list_rec *list;
{
 list->status = 0;
 list->top.next = list->top.last = NULL;
 list->bot = NULL;
}


/*--------------------------------------------------------------------------
init_pixel_stack_rec_ptr - ???
--------------------------------------------------------------------------*/

void
init_pixel_stack_rec_ptr(resolve_ptr)
 struct pixel_stack_rec_ptr *resolve_ptr;
{
 resolve_ptr->total_lists = resolve_ptr->num_lists = 0;
 resolve_ptr->lists = NULL;
}


/*--------------------------------------------------------------------------
free_pixel_stack_rec_ptr - ???
--------------------------------------------------------------------------*/

void
free_pixel_stack_rec_ptr(resolve_ptr,is_free_lists)
 struct pixel_stack_rec_ptr *resolve_ptr;
 int is_free_lists;
{
 unsigned long lcv;

 if (resolve_ptr == NULL)
     return /*NO_ERROR*/;
 if (resolve_ptr->total_lists > 0)
    {if (is_free_lists)
        {for (lcv = 0; lcv < resolve_ptr->num_lists; lcv++)
            {free_stack_xy_rec(resolve_ptr->lists[lcv]->top.next);
             c_free(resolve_ptr->lists[lcv]);}
        }
     c_free(resolve_ptr->lists);}
 init_pixel_stack_rec_ptr(resolve_ptr);
}

/*****************
setup_pixel_stack_rec_ptr(growns,num_types)
 struct pixel_stack_rec_ptr **growns;
 unsigned long num_types;
{
 unsigned long num,lcv;
 int err;

 num = 0;
 if ((err = get_ptr(growns,&num,num_types,sizeof(**growns))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < num; lcv++)
    init_pixel_stack_rec_ptr(&((*growns)[lcv]));
 return NO_ERROR;
}
***************/


/*--------------------------------------------------------------------------
sort_1_echo_stack_list_rec_ptr_proc - ???
--------------------------------------------------------------------------*/

int
sort_1_echo_stack_list_rec_ptr_proc(list1,list2)
 struct stack_list_rec **list1,**list2;
{
 if ((*list1)->valx > (*list2)->valx) return 1;
 if ((*list1)->valx < (*list2)->valx) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
setup_stack_xy_rec - ???
--------------------------------------------------------------------------*/

int
setup_stack_xy_rec(list,x,y,xy)
 struct stack_list_rec *list;
 long x,y;
 struct stack_xy_rec **xy;
{
 int err;
 long total;
/*
 TRACE(printf("setup_stack_xy_rec y = %d x = %d\n",y,x))
*/
 total = 0;
 *xy = NULL;
 if ((err = get_ptr(xy,&total,(unsigned long) 1,(size_t) sizeof(**xy))) != NO_ERROR)
    return err;
 (*xy)->x = x;
 (*xy)->y = y;
 (*xy)->next = NULL;
 if (list->top.next == NULL)
    {list->top.next = *xy;
     (*xy)->last = &(list->top);}
   else (*xy)->last = list->bot;
 if (list->bot != NULL)
    list->bot->next = *xy;
 list->bot = *xy;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cp_stack_list_rec - ???
--------------------------------------------------------------------------*/

int
cp_stack_list_rec(dest,src)
 struct stack_list_rec *dest,*src;
{
 int err;
 struct stack_xy_rec *top,*item;
 unsigned long total;

 dest->valx = src->valx;
 dest->valy = src->valy;
 dest->top.next = dest->top.last = NULL;
 dest->bot = NULL;
 for (top = src->top.next;top != NULL; top = top->next)
    {total = 0; 
     if ((err = get_ptr(&item,&total,1,sizeof(*item))) != NO_ERROR)
        return err;
     item->x = top->x;
     item->y = top->y;
     if (dest->top.next == NULL)
        {dest->top.next = item;
         item->last = &(dest->top);}
      else item->last = dest->bot;
     if (dest->bot != NULL)
        dest->bot->next = item;
     dest->bot = item;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cp_pixel_stack_rec_ptr_content - ???
--------------------------------------------------------------------------*/

int
cp_pixel_stack_rec_ptr_content(dest,src)
 struct pixel_stack_rec_ptr *dest,*src;
{
 long lcv;
 int err;

 free_pixel_stack_rec_ptr(dest,1);
 PRINT(printf("cp_pixel_stack_rec..dest->total_lists = %d\n",dest->total_lists))
 if ((err = get_handle(&(dest->lists),&(dest->total_lists),src->num_lists,
        sizeof(**(dest->lists)))) != NO_ERROR)
    return err;
 dest->num_lists = dest->total_lists;
 for (lcv = 0; lcv < dest->num_lists; lcv++)
    init_stack_list_rec(dest->lists[lcv]);
 PRINT(printf("cp_pixel_stack_rec..1\n"))
 for (lcv = 0; lcv < dest->num_lists; lcv++)
    if ((err = cp_stack_list_rec(dest->lists[lcv],src->lists[lcv])) !=
          NO_ERROR)
       return err;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cp_pixel_stack_rec_ptrs - ???
--------------------------------------------------------------------------*/

int
cp_pixel_stack_rec_ptrs(dest_ptr,src)
 struct pixel_stack_rec_ptr *dest_ptr,*src;
{
 unsigned long lcv,num;
 int err;

 TRACE(printf("cp_pixel_stack_rec_ptrs...dest_ptr = %u src = %u\n",dest_ptr,src))
 TRACE(printf("  total_lists = %d num_lists = %d  src num_lists = %d\n",
            dest_ptr->total_lists,dest_ptr->num_lists,src->num_lists))
 if ((src->num_lists + dest_ptr->num_lists) >= dest_ptr->total_lists)
    if ((err = get_ptr(&(dest_ptr->lists),&(dest_ptr->total_lists),
                             src->num_lists,sizeof(*(dest_ptr->lists)))) != NO_ERROR)
       return err;
 TRACE(printf("cp_pixel_stack_rec_ptrs...num_lists = %d\n",dest_ptr->num_lists))
 for (lcv = dest_ptr->num_lists,num = 0; num < src->num_lists; num++,lcv++)
    dest_ptr->lists[lcv] = src->lists[num];
 dest_ptr->num_lists = lcv;
 TRACE(printf("cp_pixel_stack_rec_ptrs...end\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
setup_1_echo_stack_list_rec - ???
--------------------------------------------------------------------------*/

int
setup_1_echo_stack_list_rec(resolve,val,list,add_max_items)
 struct pixel_stack_rec_ptr *resolve;
 long val;
 struct stack_list_rec **list;
 long add_max_items;
{
 struct stack_list_rec key,*the_key,*item;
 long indx,lcv,last;
 int err;

/* TRACE(printf("setup_1_echo_stack_list_rec...1\n"))*/
 if (resolve->num_lists > 0)
    {the_key = &key;
     key.valx = val;
     if (obj_binary_search(resolve->lists,resolve->num_lists,
          sizeof(*(resolve->lists)),
          &the_key,sort_1_echo_stack_list_rec_ptr_proc,&indx) == NO_ERROR)
        {*list = resolve->lists[indx];
         return NO_ERROR;}
    }
   else indx = 0;
 *list = NULL;
 if (resolve->num_lists >= resolve->total_lists)
    {
     if ((err = get_ptr(&(resolve->lists),&(resolve->total_lists),add_max_items,
            (size_t) sizeof(*(resolve->lists)))) != NO_ERROR)
        return err;
    }
 lcv = 0;
 if ((err = get_ptr(&item,&lcv,1,(size_t) sizeof(*item))) != NO_ERROR)
    return err;
 *list = item;
 init_stack_list_rec(item);
 if (resolve->num_lists > 0)
    {last = resolve->num_lists - 1;
     for (lcv = resolve->num_lists; lcv > indx; )
        {resolve->lists[lcv] = resolve->lists[last];
         lcv = last;
         last -= 1;}
    }
 resolve->lists[indx] = item;
 resolve->lists[indx]->valx = val;
 resolve->num_lists++;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cnt_stack_xy_rec - ???
--------------------------------------------------------------------------*/

long
cnt_stack_xy_rec(top)
 struct stack_xy_rec *top;
{
 long cnt;

 for (cnt = 0;top != NULL; top = top->next)
    cnt += 1;
 return cnt;
}


/*--------------------------------------------------------------------------
cnt_pixel_stack_rec_ptr - ???
--------------------------------------------------------------------------*/

long
cnt_pixel_stack_rec_ptr(resolve)
 struct pixel_stack_rec_ptr *resolve;
{
 long lcv,total;

 for (total = 0,lcv = 0; lcv < resolve->num_lists; lcv++)
    {
     total += cnt_stack_xy_rec(resolve->lists[lcv]->top.next);
    }
 return total;
}


/*--------------------------------------------------------------------------
find_stack_xy_rec_1 - ???
--------------------------------------------------------------------------*/

int
find_stack_xy_rec_1(top,item,indx)
 struct stack_xy_rec *top,*item;
 unsigned long *indx;
{
 unsigned long cnt;

 for (cnt = 0;top != NULL; top = top->next,cnt++)
    if (top == item)
       {*indx = cnt;
        return 1;}
 return 0;
}


/*--------------------------------------------------------------------------
find_stack_xy_rec_ptr - ???
--------------------------------------------------------------------------*/

int
find_stack_xy_rec_ptr(resolve,item)
 struct pixel_stack_rec_ptr *resolve;
 struct stack_xy_rec *item;
{
 unsigned long lcv,indx;

 for (lcv = 0; lcv < resolve->num_lists; lcv++)
    {
     if (find_stack_xy_rec_1(resolve->lists[lcv]->top.next,item,&indx)) 
        {printf("#%ld top = %p vx = %ld vy = %ld indx = %ld total = %ld item = %p  found\n",
              lcv,resolve->lists[lcv]->top.next,(long) resolve->lists[lcv]->valx,
                 (long) resolve->lists[lcv]->valy,indx,
             cnt_stack_xy_rec(resolve->lists[lcv]->top.next),item);
         pr_stack_xy_rec(resolve->lists[lcv]->top.next);
         printf("\n");
         return 1;}
    }
 if (lcv == resolve->num_lists)
    {printf("find_stack_xy_rec_ptr item = %p  not found\n",item);
     return 0;}
}


/*--------------------------------------------------------------------------
find_stack_xy_rec_by_xy - ???
--------------------------------------------------------------------------*/

int
find_stack_xy_rec_by_xy(top,x,y,item)
 struct stack_xy_rec *top,**item;
 long x,y;
{
 unsigned long cnt;

 *item = NULL;
 for (cnt = 0;top != NULL; top = top->next,cnt++)
    if ((top->x == x) && (top->y == y))
       {*item = top;
        return 1;}
 return 0;
}


/*--------------------------------------------------------------------------
find_stack_xy_rec_ptr_by_xy - ???
--------------------------------------------------------------------------*/

int
find_stack_xy_rec_ptr_by_xy(resolve,x,y,item)
 struct pixel_stack_rec_ptr *resolve;
 long x,y;
 struct stack_xy_rec **item;
{
 unsigned long lcv;

 for (lcv = 0; lcv < resolve->num_lists; lcv++)
    {
     if (find_stack_xy_rec_by_xy(resolve->lists[lcv]->top.next,x,y,item)) 
        {printf("#%ld top = %p vx = %ld item = %p  %ld/%ld found\n",
              lcv,resolve->lists[lcv]->top.next,(long) resolve->lists[lcv]->valx,*item,y,x);
         pr_stack_xy_rec(resolve->lists[lcv]->top.next);
         printf("\n");
         return 1;}
    }
 return 0;
}


/*--------------------------------------------------------------------------
pr_stack_xy_rec - ???
--------------------------------------------------------------------------*/

void
pr_stack_xy_rec(top)
 struct stack_xy_rec *top;
{
 long cnt;

 cnt = 0;
 for (;top != NULL; top = top->next)
    {printf("%ld) node = %p y/x = %ld/%ld last = %p next = %p\n",
           cnt,top,(long) top->y,(long) top->x,top->last,top->next);
     cnt += 1;}
}


/*--------------------------------------------------------------------------
pr_stack_list_rec - ???
--------------------------------------------------------------------------*/

void
pr_stack_list_rec(list,pr_xy,num_echoes)
 struct stack_list_rec *list;
 int num_echoes;
{
 if (num_echoes == 1)
    printf("list = %p valx = %ld head = %p last = %p top = %p bot = %p cnt = %ld...\n",list,
      (long) list->valx,&(list->top),list->top.last,
      list->top.next,list->bot,cnt_stack_xy_rec(list->top.next));
   else printf("list = %p valx = %ld valy = %ld top = %p bot = %p cnt = %ld...\n",
	       list, (long) list->valx,(long) list->valy,
	       list->top.next,list->bot,cnt_stack_xy_rec(list->top.next));
 if (pr_xy) pr_stack_xy_rec(list->top.next);
}


/*--------------------------------------------------------------------------
pr_pixel_stack_rec_ptr - ???
--------------------------------------------------------------------------*/

void
pr_pixel_stack_rec_ptr(ptr,pr_xy,num_echoes)
 struct pixel_stack_rec_ptr *ptr;
 int pr_xy;
 int num_echoes;
{
 long lcv,total;

 printf("pr_pixel_stack_rec_ptr...num_lists = %ld\n",ptr->num_lists);
 for (total = 0,lcv = 0; lcv < ptr->num_lists; lcv++)
    {printf("%ld) ",lcv);
    pr_stack_list_rec(ptr->lists[lcv],pr_xy,num_echoes);
     total += cnt_stack_xy_rec(ptr->lists[lcv]->top.next);
    }
 printf("pr_pixel_stack_rec_ptr...total = %ld end\n",total);
}


/*--------------------------------------------------------------------------
pr_type_val_rec - ???
--------------------------------------------------------------------------*/

void
pr_type_val_rec(set,num_echoes)
 struct type_val_rec *set;
 int num_echoes;
{
 long lcv;

 if (num_echoes == 1)
    printf("%p val = %ld ",set,(long) set->valx);
   else printf("%p valy/valx = %ld/%ld",set,(long) set->valx,(long) set->valy);
 for (lcv = 0; lcv < (unsigned long) set->num_types; lcv++)
    printf("%ld) %-ld/%ld  ",lcv,(unsigned long) set->types[lcv].indx,
        (unsigned long) set->types[lcv].dist);
 printf("\n");
}


/*--------------------------------------------------------------------------
pr_the_type_val_rec - ???
--------------------------------------------------------------------------*/

void
pr_the_type_val_rec(all,num_echoes)
 struct the_type_val_rec *all;
 int num_echoes;
{
 long lcv;

 printf("pr_the_type_val_rec...total_sets = %ld num_sets = %ld\n",
	all->total_sets,all->num_sets);

 for (lcv = 0; lcv < all->num_sets; lcv++)
    {printf("%ld) ",lcv);
    pr_type_val_rec(all->sets[lcv],num_echoes);
    }
 printf("pr_the_type_val_rec..end\n\n");
}


/*--------------------------------------------------------------------------
find_1_echo_pixel_stack_rec - ???
--------------------------------------------------------------------------*/

int
find_1_echo_pixel_stack_rec(resolve,lb,ub,lists,total_lists,num_lists,lbindx,ubindx)
 struct pixel_stack_rec_ptr *resolve;
 long lb,ub;
 struct stack_list_rec ***lists;
 unsigned long *total_lists,*num_lists,*lbindx,*ubindx;
{
 struct stack_list_rec key,*the_key;
 unsigned long lcv,cnt;
 int err;

 *num_lists = 0;
 if (resolve->num_lists == 0) return NO_ERROR;
 the_key = &key;
 key.valx = lb;
 obj_binary_search(resolve->lists,resolve->num_lists,sizeof(*(resolve->lists)),
          &the_key,sort_1_echo_stack_list_rec_ptr_proc,lbindx);
 if (*lbindx >= resolve->num_lists) 
    {TRACE(printf("*lbindx = %d >= resolve->num_lists = %d\n",*lbindx,resolve->num_lists))
     return NO_ERROR;}
   else if (*lbindx < 0) 
    *lbindx = 0;

 key.valx = ub;
 obj_binary_search(resolve->lists,resolve->num_lists,sizeof(*(resolve->lists)),
          &the_key,sort_1_echo_stack_list_rec_ptr_proc,ubindx);
 if (*ubindx >= resolve->num_lists) 
    *ubindx = resolve->num_lists - 1;
   else if (*ubindx < 0) 
    {TRACE(printf("*ubindx = %d < 0\n",*ubindx))
     return NO_ERROR;}
 if (*lbindx == *ubindx)
    {if ((resolve->lists[*lbindx]->valx < lb) || (resolve->lists[*lbindx]->valx > ub))
        {TRACE(printf("=====lb = %d ub = %d lbindx = %d ubindx = %d  val = %d\n",
            lb,ub,*lbindx,*ubindx,(long) resolve->lists[*lbindx]->valx);)
         return NO_ERROR;}
    }
   else if (*lbindx > *ubindx) 
    {TRACE(printf("*lbindx = %d > *ubindx = %d\n",*lbindx,*ubindx))
     return NO_ERROR;}

 cnt = *ubindx - *lbindx + 1;
 if (cnt > *total_lists)
    {lcv = cnt - *total_lists;
     if ((err = get_ptr(lists,total_lists,lcv,(size_t) sizeof(**lists))) != NO_ERROR)
        {TRACE(printf("find_1_echo_stack_lists err = %d\n",err))
         return err;}
    }
 *num_lists = cnt;
 for (cnt = 0,lcv = *lbindx; lcv <= *ubindx; lcv++)
    {(*lists)[cnt] = resolve->lists[lcv];
     cnt++;
    }
 TRACE(
    printf("yes lb = %d ub = %d lbindx = %d ubindx = %d lbv = %d  ubv = %d",
        lb,ub,*lbindx,*ubindx,(long) (*lists)[0]->valx,
       (long) (*lists)[*num_lists - 1]->valx);
    if (*lbindx > 0) 
       printf(" lastv = %d",(long) resolve->lists[*lbindx - 1]->valx);
    if (*ubindx < (resolve->num_lists - 1)) 
       printf(" nextv = %d",(long) resolve->lists[*ubindx + 1]->valx);
    if ((*lbindx >= 0) || (*ubindx < (resolve->num_lists - 1))) 
       printf(" numlists = %d\n",resolve->num_lists);
    printf("\n");
   )
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
drop_empty_stack_lists - ???
--------------------------------------------------------------------------*/

int
drop_empty_stack_lists(resolve)
 struct pixel_stack_rec_ptr *resolve;
{
 unsigned long lcv,cnt;

 TRACE(printf("drop_empty_stack_lists resolve->num_lists = %d\n",resolve->num_lists))
 for (cnt = lcv = 0; lcv < resolve->num_lists; lcv++)
    {if (resolve->lists[lcv]->top.next == NULL)
        {c_free(resolve->lists[lcv]);
         continue;}
     if (cnt != lcv) resolve->lists[cnt] = resolve->lists[lcv];
     cnt++;
    }
 resolve->num_lists = cnt;
 TRACE(printf("drop_empty_stack_lists resolve->num_lists = %d end\n",
        resolve->num_lists))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
drop_empty_pixel_stack_rec_list_ptrs - ???
--------------------------------------------------------------------------*/

int
drop_empty_pixel_stack_rec_list_ptrs(resolve)
 struct pixel_stack_rec_ptr *resolve;
{
 unsigned long lcv,cnt;

 TRACE(printf("drop_empty_pixel_stack_rec_list_ptrs resolve->num_lists = %d\n",resolve->num_lists))
 for (cnt = lcv = 0; lcv < resolve->num_lists; lcv++)
    {if (resolve->lists[lcv]->top.next == NULL) continue;
     if (cnt != lcv) resolve->lists[cnt] = resolve->lists[lcv];
     cnt++;
    }
 resolve->num_lists = cnt;
 TRACE(printf("drop_empty_pixel_stack_rec_list_ptrs resolve->num_lists = %d end\n",
        resolve->num_lists))
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
search_type_lb_proc - ???
--------------------------------------------------------------------------*/

int
search_type_lb_proc(type1,type2)
 struct pixel_tissue_type_rec *type1,*type2;
{
 if (type1->abs_lb > type2->abs_lb) return 1;
 if (type1->abs_lb < type2->abs_lb) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
search_type_ub_proc - ???
--------------------------------------------------------------------------*/

int
search_type_ub_proc(type1,type2)
 struct pixel_tissue_type_rec *type1,*type2;
{
 if (type1->abs_ub > type2->abs_ub) return 1;
 if (type1->abs_ub < type2->abs_ub) return -1;
 return 0;
}

/**************
int sort_type_lb_ub_proc(type1,type2)
 struct pixel_tissue_type_rec *type1,*type2;
{
 int res;

 if ((res = search_type_lb_proc(type1,type2)) != 0)
    return res;
 return search_type_ub_proc(type1,type2);
}
***************/


/*--------------------------------------------------------------------------
sort_type_lb_ub_proc - ???
--------------------------------------------------------------------------*/

int 
sort_type_lb_ub_proc(type1,type2)
 const void *type1,*type2;
{
 int res;

 if ((res = search_type_lb_proc(type1,type2)) != 0)
    return res;
 return search_type_ub_proc(type1,type2);
}

/************
search_type_lb_proc_1(type1,type2)
 struct pixel_tissue_type_rec *type1,*type2;
{
 if (type1->abs_lb < type2->abs_lb) return 1;
 if (type1->abs_lb > type2->abs_lb) return -1;
 return 0;
}
***********/


/*--------------------------------------------------------------------------
search_type_lb_proc_1 - ???
--------------------------------------------------------------------------*/

int
search_type_lb_proc_1(type1,type2)
 const void *type1,*type2;
{
 if (((struct pixel_tissue_type_rec *) type1)->abs_lb < 
     ((struct pixel_tissue_type_rec *) type2)->abs_lb) return 1;
 if (((struct pixel_tissue_type_rec *) type1)->abs_lb > 
     ((struct pixel_tissue_type_rec *) type2)->abs_lb) return -1;
 return 0;
}

/***************
search_type_ub_proc_1(type1,type2)
 struct pixel_tissue_type_rec *type1,*type2;
{
 if (type1->abs_ub < type2->abs_ub) return 1;
 if (type1->abs_ub > type2->abs_ub) return -1;
 return 0;
}
**************/


/*--------------------------------------------------------------------------
search_type_ub_proc_1 - ???
--------------------------------------------------------------------------*/

int
search_type_ub_proc_1(type1,type2)
 const void *type1,*type2;
{
 if (((struct pixel_tissue_type_rec *) type1)->abs_ub <
     ((struct pixel_tissue_type_rec *) type2)->abs_ub) return 1;
 if (((struct pixel_tissue_type_rec *) type1)->abs_ub > 
     ((struct pixel_tissue_type_rec *) type2)->abs_ub) return -1;
 return 0;
}

/************
sort_type_ub_lb_proc(type1,type2)
 struct pixel_tissue_type_rec *type1,*type2;
{
 int res;

 if ((res = search_type_ub_proc_1(type1,type2)) != 0)
    return res;
 return search_type_lb_proc_1(type1,type2);

}
**************/


/*--------------------------------------------------------------------------
sort_type_ub_lb_proc - ???
--------------------------------------------------------------------------*/

int
sort_type_ub_lb_proc(type1,type2)
 const void *type1,*type2;
{
 int res;

 if ((res = search_type_ub_proc_1(type1,type2)) != 0)
    return res;
 return search_type_lb_proc_1(type1,type2);
}


/*--------------------------------------------------------------------------
find_type - ???
--------------------------------------------------------------------------*/

int
find_type(types,num_types,roi,set_cur,cur_type)
 struct pixel_tissue_type_rec *types;
 unsigned int num_types;
 struct roi_rec *roi;
 int set_cur;
 unsigned int *cur_type;
{
 unsigned int lcv;

 for (lcv = 0; lcv < num_types; lcv++)
    if (str_cmp(types[lcv].roi_label,roi->label) == 0)
       {if (set_cur) *cur_type = lcv;
        return NO_ERROR;}
 return NOT_FOUND;
}

/***************
sort_range_indx_rec_proc(rec1,rec2)
 struct range_indx_rec *rec1,*rec2;
{
 if (rec1->range > rec2->range) return 1;
 if (rec1->range < rec2->range) return -1;
 if (rec1->indx == rec2->indx) return 0;
 if ((rec2->lb >= rec1->lb) && (rec2->lb <= rec1->ub) &&
     (rec2->ub >= rec1->lb) && (rec2->ub <= rec1->ub))
    return 1;
 if ((rec1->lb >= rec2->lb) && (rec1->lb <= rec2->ub) &&
     (rec1->ub >= rec2->lb) && (rec1->ub <= rec2->ub))
    return -1;
 if (rec1->lb < rec2->lb)
    return 1;

 return 0;
}
************/


/*--------------------------------------------------------------------------
sort_range_indx_rec_proc - ???
--------------------------------------------------------------------------*/

int
sort_range_indx_rec_proc(rec1,rec2)
 const void *rec1,*rec2;
{
 if (((struct range_indx_rec *) rec1)->range > 
     ((struct range_indx_rec *) rec2)->range) return 1;
 if (((struct range_indx_rec *) rec1)->range < 
     ((struct range_indx_rec *) rec2)->range) return -1;
 if (((struct range_indx_rec *) rec1)->indx == 
     ((struct range_indx_rec *) rec2)->indx) return 0;
 if ((((struct range_indx_rec *) rec2)->lb >= 
      ((struct range_indx_rec *) rec1)->lb) &&
     (((struct range_indx_rec *) rec2)->lb <=
      ((struct range_indx_rec *) rec1)->ub) &&
     (((struct range_indx_rec *) rec2)->ub >= 
      ((struct range_indx_rec *) rec1)->lb) && 
     (((struct range_indx_rec *) rec2)->ub <= 
      ((struct range_indx_rec *) rec1)->ub))
    return 1;
 if ((((struct range_indx_rec *) rec1)->lb >= 
      ((struct range_indx_rec *) rec2)->lb) &&
     (((struct range_indx_rec *) rec1)->lb <= 
      ((struct range_indx_rec *) rec2)->ub) &&
     (((struct range_indx_rec *) rec1)->ub >= 
      ((struct range_indx_rec *) rec2)->lb) && 
     (((struct range_indx_rec *) rec1)->ub <= 
      ((struct range_indx_rec *) rec2)->ub))
    return -1;
 if (((struct range_indx_rec *) rec1)->lb < 
     ((struct range_indx_rec *) rec2)->lb)
    return 1;

 return 0;
}


/*--------------------------------------------------------------------------
setup_segment_rois - ???
--------------------------------------------------------------------------*/

int
setup_segment_rois(types,total_types,num_types,order,slice_roi,is_xdim,the_lb,the_ub)
 struct pixel_tissue_type_rec **types;
 unsigned long *total_types,*num_types;
 struct strs_rec *order;
 struct slice_roi_rec *slice_roi;
 int is_xdim;
 long the_lb,the_ub;
{
 struct pixel_tissue_type_rec temp_type;
 struct roi_rec *roi;
 long lcv,indx,cnt,next,num,time,ub,lb;
 unsigned long total;
 int err;
 struct int_bound_rec affected;
 struct pixel_tissue_type_rec *type;
 struct range_indx_rec *ranges;

 PRINT(printf("setup_segment_rois...order->num_strs = %d\n",order->num_strs))
 *num_types = *total_types = 0;
 err = NO_ERROR;
 if ((err = get_ptr(types,total_types,
            order->num_strs,(size_t) sizeof(**types))) != NO_ERROR)
    return err;
 *num_types = order->num_strs;
 for (lcv = 0; lcv < order->num_strs; lcv++)
    init_pixel_tissue_type_rec(&((*types)[lcv]));
 for (lcv = 0; lcv < order->num_strs; lcv++)
    {if (((roi = get_roi(slice_roi,order->strs[lcv])) == NULL) ||
         !is_roi_non_empty(roi))
        return CANCEL;
     TRACE(printf("== %d) roi->label = %s\n",lcv,roi->label))
     type = &((*types)[lcv]);
     if ((err = cp_str(&(type->roi_label),roi->label)) != NO_ERROR)
        return err;
     apply_to_roi_rec(roi,set_curve_bound_computed_status,0,0,0,0,0,0,0,0,0);

     FindRoiLongMinMax(roi,NULL,
                 &(affected.left),&(affected.right),
                 &(affected.top),&(affected.bottom),0,0,0);

     PRINT(pr_int_bound_rec(&affected))
     if (is_xdim)
        {type->actual_lb = type->abs_lb = affected.left;
         type->actual_ub = type->abs_ub = affected.right;}
       else 
        {type->actual_lb = type->abs_lb = affected.top;
         type->actual_ub = type->abs_ub = affected.bottom;}

     if (roi->status & HISTO_EDITED_ROI)
     type->status |= PIXEL_TISSUE_TYPE_GROW_REGION_DONE;
    }

 PRINT(printf("setup_segment_rois... *num_types = %d\n",*num_types))
 if (*num_types > 1)
    {total = 0;
     if ((err = get_ptr(&ranges,&total,*num_types * 2,
                         (size_t) sizeof(*ranges))) == NO_ERROR)
        {
         if (*num_types > 1)
            qsort(*types,*num_types,sizeof(**types),sort_type_lb_ub_proc);

         PRINT(for (lcv = 0; lcv < *num_types; lcv++)
            {printf("===%d) %s abs lb = %d  ub = %d  actual lb = %d  ub = %d\n",
                     lcv,(*types)[lcv].roi_label,
                      (*types)[lcv].abs_lb,(*types)[lcv].abs_ub,
                      (*types)[lcv].actual_lb,(*types)[lcv].actual_ub);})

         for (cnt = lcv = 0; lcv < *num_types; lcv++)
            {ranges[cnt].indx = lcv;
             ranges[cnt].lb = (*types)[lcv].abs_lb;
             ranges[cnt].ub = (*types)[lcv].abs_ub;
             ranges[cnt++].range = (*types)[lcv].abs_lb;

             ranges[cnt].indx = lcv;
             ranges[cnt].lb = (*types)[lcv].abs_lb;
             ranges[cnt].ub = (*types)[lcv].abs_ub;
             ranges[cnt++].range = (*types)[lcv].abs_ub;
            }

         qsort(ranges,total,sizeof(*ranges),sort_range_indx_rec_proc);
         PRINT(for (cnt = 0; cnt < total; cnt++)
            {printf("%d) indx = %d range = %d lb = %d ub = %d\n",
                 cnt,ranges[cnt].indx,ranges[cnt].range,ranges[cnt].lb,ranges[cnt].ub);})

         for (lcv = 0; lcv < *num_types; lcv++)
            {for (cnt = 0; cnt < total; cnt++)
                if (ranges[cnt].indx == lcv) break;
             lb = ranges[cnt].range;
             (*types)[lcv].actual_lb = num = cnt;
             for (indx = cnt + 1; indx < total; indx++)
                {if (lcv == ranges[indx].indx) break;
                 if (lcv > ranges[indx].indx)
                    {num = indx;
                     lb = ranges[indx].range + 1;}
                }
             (*types)[lcv].actual_ub = indx;
             (*types)[lcv].abs_lb = lb;
             if (((*types)[lcv].actual_lb + 1) != indx)
                {for (num++; num < total; num++)
                    {if (lcv == ranges[num].indx)
                        {ub = ranges[num].range;
                         break;}
                     if (lcv < ranges[num].indx)
                        {for (time = 0,next = (*types)[lcv].actual_lb + 1;
                              next < indx; next++)
                            if (ranges[next].range == ranges[num].range) time++;
                         if (time != 2)
                            {ub = ranges[num].range - 1;
                             break;}
                        }
                    }
                }
               else ub = ranges[indx].range;

             (*types)[lcv].abs_ub = ub;
            }

         PRINT(for (lcv = 0; lcv < *num_types; lcv++)
            {printf("%d) %s abs lb = %d  ub = %d  actual lb = %d  ub = %d\n",
                     lcv,(*types)[lcv].roi_label,
                      (*types)[lcv].abs_lb,(*types)[lcv].abs_ub,
                      (*types)[lcv].actual_lb,(*types)[lcv].actual_ub);})

         cnt = total - 1;
         for (lcv = 0; lcv < *num_types; lcv++)
            {
             if ((*types)[lcv].actual_lb == 0) (*types)[lcv].ext_lb = the_lb;
               else
                {indx = (*types)[lcv].actual_lb;
                 if (ranges[indx].range != (*types)[lcv].abs_lb)
                    (*types)[lcv].ext_lb = ranges[indx].range;
                   else (*types)[lcv].ext_lb = ranges[indx - 1].range + 1;
                }
             if ((*types)[lcv].actual_ub == cnt) (*types)[lcv].ext_ub = the_ub;
               else
                {indx = (*types)[lcv].actual_ub;
                 if (ranges[indx].range != (*types)[lcv].abs_ub)
                    (*types)[lcv].ext_ub = ranges[indx].range;
                   else (*types)[lcv].ext_ub = ranges[indx + 1].range - 1;
                }
            }
         c_free(ranges);
         if (*num_types > 1)
            qsort((*types),*num_types,sizeof(*((*types))),
                sort_type_lb_ub_proc);
         for (lcv = 0; lcv < *num_types; lcv++)
            {
             if ((*types)[lcv].status & PIXEL_TISSUE_TYPE_GROW_REGION_DONE)
                {(*types)[lcv].ext_lb = (*types)[lcv].abs_lb;
                 (*types)[lcv].ext_ub = (*types)[lcv].abs_ub;}

             (*types)[lcv].actual_lb = (*types)[lcv].abs_lb;
             (*types)[lcv].actual_ub = (*types)[lcv].abs_ub;}
         
         PRT1(for (lcv = 0; lcv < *num_types; lcv++)
            {printf("bef %d) %s abs lb = %d  ub = %d  actual lb = %d  ub = %d  ext lb = %d  ub = %d\n",
                     lcv,(*types)[lcv].roi_label,
                      (*types)[lcv].abs_lb,(*types)[lcv].abs_ub,
                      (*types)[lcv].actual_lb,(*types)[lcv].actual_ub,
                      (*types)[lcv].ext_lb,(*types)[lcv].ext_ub);})

         for (lcv = 0; lcv < *num_types; lcv++)
            {for (cnt = lcv; cnt < *num_types; cnt++)
                {if (str_cmp(order->strs[lcv],(*types)[cnt].roi_label) == 0)
                    {if (lcv == cnt) break;
                     temp_type = (*types)[lcv];
                     (*types)[lcv] = (*types)[cnt];
                     (*types)[cnt] = temp_type;
                     break;}
                }
            }
         PRT1(for (lcv = 0; lcv < *num_types; lcv++)
            {printf("aft %d) %s abs lb = %d  ub = %d  actual lb = %d  ub = %d  ext lb = %d  ub = %d\n",
                     lcv,(*types)[lcv].roi_label,
                      (*types)[lcv].abs_lb,(*types)[lcv].abs_ub,
                      (*types)[lcv].actual_lb,(*types)[lcv].actual_ub,
                      (*types)[lcv].ext_lb,(*types)[lcv].ext_ub);})

        }
    }
 TRACE(printf("setup_segment_rois...err = %d\n\n\n",err))

 return err;
}


/*--------------------------------------------------------------------------
_1_echo_statistics - ???
--------------------------------------------------------------------------*/

int
_1_echo_statistics(type_aves,num_type_aves,_2d_types,image_mask,pix_neighs,resolve,neigh_2d)
 struct pixel_type_ave_rec *type_aves;
 long num_type_aves;
 struct buf_2d_rec *_2d_types,*image_mask;
 struct pixel_neighbor_type_rec **pix_neighs;
 struct stack_list_rec *resolve;
 struct buf_2d_rec *neigh_2d;
{
 long lcv,row,col,total;
 struct type_val_rec *pix;
 struct stack_list_rec *list;
 struct stack_xy_rec *xy;
 int err;

 PRINT(printf("_1_echo_statistics...num_type_aves = %d _2d_types = %u\n",num_type_aves,_2d_types))
 total = 0;
 *pix_neighs = 0;
 if ((err = get_ptr(pix_neighs,&total,neigh_2d->dimx * neigh_2d->dimy,
                (size_t) sizeof(**pix_neighs))) != NO_ERROR)
    return err;
 PRINT(printf("_1_echo_statistics...\n"))

 for (lcv = 0,row = 0; row < _2d_types->dimy; row++)
    for (col = 0; col < _2d_types->dimx; col++,lcv++)
       {
        set_1d_buf_value(neigh_2d->buf[row],col,neigh_2d->pixel_depth,
                   &((*pix_neighs)[lcv]));
        (*pix_neighs)[lcv].neigh = NULL;
        if ((image_mask != NULL) && (image_mask->status4 & BUF_NON_EMPTY))
           {if (get_1d_buf_value(image_mask->buf[row],col,image_mask->pixel_depth) == 0)
               {(*pix_neighs)[lcv].pix = NULL;
                continue;}
           }
        pix = (struct type_val_rec *) get_1d_buf_value(
                  _2d_types->buf[row],col,_2d_types->pixel_depth);
        (*pix_neighs)[lcv].pix = pix;
        if (pix->num_types == 1)
           {
            type_aves[pix->types[0].indx].x += (float) pix->valx;                  
            type_aves[pix->types[0].indx].num_freqs += 1;
           }
          else
           {
            if (((err = setup_1_echo_stack_list_rec(resolve,(long) pix->valx,&list,50)) != NO_ERROR) ||
                ((err = setup_stack_xy_rec(list,col,row,&xy)) != NO_ERROR))
               return err; 
            xy->pix_neigh = &((*pix_neighs)[lcv]);
           }
       }

 PRT3(printf("_1_echo_statistics...1..err = %d\n",err))
 for (lcv = 0; lcv < num_type_aves; lcv++)
    {type_aves[pix->types[0].indx].y = type_aves[pix->types[0].indx].x;
     PRT3(printf("%d) compute_stat...x = %f avex = %f num_freqs = %d\n",lcv,
                   type_aves[lcv].x,type_aves[lcv].x / (float) type_aves[lcv].num_freqs,
                   type_aves[lcv].num_freqs))
    }
 TRACE(printf("_1_echo_statistics...2\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
sort_type_conn_fac_rec_proc - ???
--------------------------------------------------------------------------*/

int 
sort_type_conn_fac_rec_proc(type1,type2)
 const void *type1,*type2;
{
 if (((struct type_conn_fac_rec *) type1)->conn_fac > 
     ((struct type_conn_fac_rec *) type2)->conn_fac) return -1;
 if (((struct type_conn_fac_rec *) type1)->conn_fac < 
     ((struct type_conn_fac_rec *) type2)->conn_fac) return 1;
 if (((struct type_conn_fac_rec *) type1)->type < 
     ((struct type_conn_fac_rec *) type2)->type) return -1;
 if (((struct type_conn_fac_rec *) type1)->type > 
     ((struct type_conn_fac_rec *) type2)->type) return 1;

 return 0;
}


/*--------------------------------------------------------------------------
incompatible_type_by_neighbors - ???
--------------------------------------------------------------------------*/

void
incompatible_type_by_neighbors(neigh,cur_pix,x,y,neigh_2d)
 struct neighbor_type_rec *neigh;
 struct type_val_rec *cur_pix;
 struct buf_2d_rec *neigh_2d;
 long x,y;
{
 struct type_val_rec *pix;
 long indx1,lcv,x1,y1,type;
 struct neighbor_type_rec *neigh1;
 struct pixel_neighbor_type_rec *pix_neigh;

 neigh->num_neighs = 0;
 for (lcv = 0; lcv < 8; lcv++)
    {x1 = x + neighbor_Offset[lcv][0];
     if ((x1 < 0) || (x1 >= neigh_2d->dimx))
        continue;
     y1 = y + neighbor_Offset[lcv][1];
     if ((y1 < 0) || (y1 >= neigh_2d->dimy)) 
        continue;
     pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[y1],
                         x1,neigh_2d->pixel_depth);
     neigh1 = pix_neigh->neigh;
     if (neigh1 == NULL)
        {pix = pix_neigh->pix;
         if ((pix == 0) || (pix->num_types != 1)) continue;
         type = pix->types[0].indx;}
       else if (!(neigh1->status & TYPE_RESOLVED))
        continue;
       else type = neigh1->neighs[0].type;

     /* a pixel whose type has been determined is found */
     for (indx1 = 0; indx1 < (unsigned long) neigh->num_neighs; indx1++)
        if (neigh->neighs[indx1].type == type)
           {neigh->neighs[indx1].conn_fac += neigh->weights[lcv];
            break;}

     if (indx1 == neigh->num_neighs)
        {neigh->neighs[indx1].conn_fac = neigh->weights[lcv];
         neigh->neighs[indx1].type = type;
         neigh->num_neighs += 1;
        }
    }
 if (neigh->num_neighs > 0)
    {if (neigh->num_neighs > 1)
        qsort(neigh->neighs,neigh->num_neighs,sizeof(*(neigh->neighs)),
                                  sort_type_conn_fac_rec_proc);
     neigh->num_neighs = 1;
     neigh->status |= LEFT_OVER_WEIGHTS_CHECKED | TYPE_RESOLVED;
    }
}


/*--------------------------------------------------------------------------
neighbor_weights - ???
--------------------------------------------------------------------------*/

int
neighbor_weights(neigh,cur_pix,x,y,neigh_2d,image_mask)
 struct neighbor_type_rec *neigh;
 struct type_val_rec *cur_pix;
 long x,y;
 struct buf_2d_rec *neigh_2d,*image_mask;
{
 struct type_val_rec *pix;
 long indx,indx1,lcv,x1,y1,type;
 struct neighbor_type_rec *neigh1;
 struct pixel_neighbor_type_rec *pix_neigh;

 neigh->num_neighs = 0;
 neigh->done_neighs = 0;
 for (lcv = 0; lcv < 8; lcv++)
    {
     x1 = x + neighbor_Offset[lcv][0];
     if ((x1 < 0) || (x1 >= (long) neigh_2d->dimx))
        {neigh->done_neighs |= _EdgeBit[lcv];
         continue;}
     y1 = y + neighbor_Offset[lcv][1];
     if ((y1 < 0) || (y1 >= (long) neigh_2d->dimy)) 
        {neigh->done_neighs |= _EdgeBit[lcv];
         continue;}
     if (image_mask != NULL)
        {if (get_1d_buf_value(image_mask->buf[y1],x1,image_mask->pixel_depth) == 0)
            {neigh->done_neighs |= _EdgeBit[lcv];
             continue;}
        }
     pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[y1],
                         x1,neigh_2d->pixel_depth);
     neigh1 = pix_neigh->neigh;
     if (neigh1 == NULL)
        {pix = pix_neigh->pix;
         if (pix->num_types != 1) continue;
         type = pix->types[0].indx;}
       else if (!(neigh1->status & TYPE_RESOLVED))
         continue;
       else type = neigh1->neighs[0].type;
     neigh->done_neighs |= _EdgeBit[lcv];
/*
     printf("nw %d) type = %d done_neighs = %x num_types = %d %d/%d x = %d y = %d\n",
        lcv,type,(unsigned long) neigh->done_neighs,pix->num_types,x1,y1,x,y);
*/
     neigh->status &= ~LEFT_OVER_WEIGHTS_CHECKED;
     /* a pixel whose type has been determined is found */

     /* looking for a match in the possible types */
     for (indx = 0; indx < (unsigned long)cur_pix->num_types; indx++)
        if (cur_pix->types[indx].indx == type)
           break;
     if (indx == cur_pix->num_types)
        continue;

     /* a possible type is found & compute the accumulated connection factor */
     for (indx1 = 0; indx1 < (unsigned long) neigh->num_neighs; indx1++)
        if (neigh->neighs[indx1].type == type)
           {neigh->neighs[indx1].conn_fac += neigh->weights[lcv];
            break;}

     if (indx1 == neigh->num_neighs)
        {neigh->neighs[indx1].conn_fac = neigh->weights[lcv];
         neigh->neighs[indx1].type = type;
         neigh->num_neighs += 1;
        }
    }
 if (neigh->num_neighs > 1)
    qsort(neigh->neighs,neigh->num_neighs,sizeof(*(neigh->neighs)),
                                  sort_type_conn_fac_rec_proc);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
compute_1_echo_weights - ???
--------------------------------------------------------------------------*/

int
compute_1_echo_weights(neigh,_2d,x,y)
 struct neighbor_type_rec *neigh;
 struct buf_2d_rec *_2d;
 long x,y;
{
 long lcv,x1,y1;
 double vx,v1[8];
 unsigned char valid;
 float temp;

 vx = _2d->GetVal(_2d,y,x);
 for (valid = 0,lcv = 0; lcv < 8; lcv++)
    {
     x1 = x + neighbor_Offset[lcv][0];
     if ((x1 < 0) || (x1 >= _2d->dimx)) continue;
     y1 = y + neighbor_Offset[lcv][1];
     if ((y1 < 0) || (y1 >= _2d->dimy)) continue;
     valid |= _EdgeBit[lcv];
     v1[lcv] = _2d->GetVal(_2d,y1,x1);
    }
 for (lcv = 0; lcv < 8; lcv++)
    {if (valid & _EdgeBit[lcv])
        {if (vx == v1[lcv]) 
            neigh->weights[lcv] = 1.0;
           else
            {temp = (float) (vx - v1[lcv]);
             if (temp < .0) temp += -1.0;
               else temp += 1.0;
             temp = temp * temp;
             neigh->weights[lcv] = _EdgeDistance[lcv % 2] * (float) temp;
             neigh->weights[lcv] = 1.0 / neigh->weights[lcv];
            }
         }
        else neigh->weights[lcv] = .0;
    }
        
 return NO_ERROR;
}

/****************
adjust_done_neighs(neigh_2d,resolve)
 struct pixel_stack_rec_ptr *resolve;
 struct buf_2d_rec *neigh_2d;
{
 long lcv,cnt,indx,x1,y1,num;
 unsigned long next;
 struct neighbor_type_rec *neigh,*neigh1;
 struct pixel_neighbor_type_rec *pix_neigh1;
 struct stack_xy_rec *top;
 unsigned char ok;
 unsigned char done_neighs;
 struct type_val_rec *pix,*cur_pix;

 for (num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;
     while (top != NULL)
        {
         neigh = top->pix_neigh->neigh;
         cur_pix = top->pix_neigh->pix;
         done_neighs = neigh->done_neighs;
         for (lcv = 1; lcv <= (unsigned long)_0Edge[done_neighs][0]; lcv++)
            {next = _0Edge[done_neighs][lcv];
             x1 = top->x + neighbor_Offset[next][0];
             y1 = top->y + neighbor_Offset[next][1];
             pix_neigh1 = (struct pixel_neighbor_type_rec *) 
                     get_1d_buf_value(neigh_2d->buf[y1],
                         x1,neigh_2d->pixel_depth);
             neigh1 = pix_neigh1->neigh;
             pix = pix_neigh1->pix;
             if ((neigh1 != NULL) && (neigh1->status & TYPE_RESOLVED))
                {for (ok = 0,cnt = 0; cnt < (unsigned long) cur_pix->num_types; cnt++)
                    if (cur_pix->types[cnt].indx == neigh1->neighs[0].type)
                       {ok = 1;
                        break;}
                 if (ok) break;
                }

               else
                for (ok = 0,cnt = 0; cnt < (unsigned long)cur_pix->num_types; cnt++)
                   {for (indx = 0; indx < (unsigned long)pix->num_types; indx++)
                       if (cur_pix->types[cnt].indx == pix->types[indx].indx)
                          {ok = 1;
                           break;}
                    if (ok) break;
                   }
             if (!ok)
                {neigh->done_neighs |= _EdgeBit[next];
                 if (neigh1 != NULL) neigh1->done_neighs |= _EdgeBit[_EdgeReversePosi[next]];}

            }
         top = top->next;
        }
    }

}
******************/


/*--------------------------------------------------------------------------
check_done_neighs - ???
--------------------------------------------------------------------------*/

void
check_done_neighs(neigh_2d,resolve)
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num,lcv,x1,y1,indx,time,done,cnt_zero,cnt_zero1,indx1,cnt,incomp,cnt_incomp;
 unsigned long type;
 struct pixel_neighbor_type_rec *pix_neigh,*pix_neigh2;
 struct type_val_rec *pix,*cur_pix;
 struct neighbor_type_rec *neigh;
 struct stack_xy_rec *top;

 for (cnt_zero1 = cnt_zero = lcv = 0,num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;
     while (top != NULL)
        {pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[top->y],
                         (long) top->x,neigh_2d->pixel_depth);
         neigh = pix_neigh->neigh;
         if (neigh->num_neighs == 0)
            {cur_pix = pix_neigh->pix;
             for (incomp = time = 0,done = 0,indx = 0; indx < 8; indx++)
                {x1 = top->x + neighbor_Offset[indx][0];
                 if ((x1 < 0) || (x1 >= neigh_2d->dimx))
                    continue;
                 y1 = top->y + neighbor_Offset[indx][1];
                 if ((y1 < 0) || (y1 >= neigh_2d->dimy)) 
                    continue;
                 time += 1;
                 pix_neigh2 = (struct pixel_neighbor_type_rec *)
                               get_1d_buf_value(neigh_2d->buf[y1],
                              (long) x1,neigh_2d->pixel_depth);
                 if ((pix_neigh2->neigh == NULL) ||
                     (pix_neigh2->neigh->status & TYPE_RESOLVED) ||
                     (pix_neigh2->neigh->done_neighs & _EdgeBit[_EdgeReversePosi[indx]]))
                    {pix = pix_neigh2->pix;
                     for (cnt_incomp = 0,cnt = 0; cnt < (unsigned long)pix->num_types; cnt++)
                        {type = pix->types[cnt].indx;
                         for (indx1 = 0; indx1 < (unsigned long)cur_pix->num_types; indx1++)
                            if (cur_pix->types[indx1].indx == type)
                               break;
                         if (indx1 == cur_pix->num_types)
                            cnt_incomp += 1;
                           else break;
                        }
                     if (cnt_incomp == pix->num_types) incomp += 1;
                     done += 1;
                    }
                } 
              if (done == time)
                 {if (incomp != done)
                     {cnt_zero += 1;
                      printf("www %ld) %lx %ld/%ld  %lx %ld incomp = %ld done = %ld\n",
			     lcv, (unsigned long) neigh->status, 
			     (long) top->y,(long) top->x,
			     (unsigned long) neigh->done_neighs,
			     (long) neigh->num_neighs,incomp,done);}
                 cnt_zero1 += 1;}
             }
         lcv += 1;
         top = top->next;
        }
    }
 printf("==check_done_neighs cnt_zero = %ld cnt_zero1 = %ld lcv = %ld\n",
	cnt_zero,cnt_zero1,lcv);
}

/*****************
                     if ((top->y == 26) && (top->x == 91))
                        if ((y1 == 25) && (x1 == 92))
      {printf("26/91 & 25/92 indx = %d _EdgeReversePosi[indx] = %d _EdgeBit[_EdgeReversePosi[indx]] = %x\n",indx,
              (unsigned long) _EdgeReversePosi[indx],
(unsigned long) _EdgeBit[_EdgeReversePosi[indx]]);
 if (pix_neigh2->neigh == NULL) printf("26/91 & 25/92 NULL\n");
                   if (pix_neigh2->neigh->done_neighs & _EdgeBit[_EdgeReversePosi[indx]])
printf("26/91 & 25/92 = %x %x\n",(unsigned long) pix_neigh2->neigh->done_neighs,
    (unsigned long) pix_neigh2->neigh->done_neighs & _EdgeBit[_EdgeReversePosi[indx]]);
    }
*******************/


/*--------------------------------------------------------------------------
setup_neighbor_type_rec - ???
--------------------------------------------------------------------------*/

int
setup_neighbor_type_rec(neigh_2d,resolve,_2d1,_2d2,image_mask,num_echoes)
 struct buf_2d_rec *neigh_2d,*_2d1,*_2d2,*image_mask;
 struct pixel_stack_rec_ptr *resolve;
 int num_echoes;
{
 long num;
 struct neighbor_type_rec *neigh;
 struct stack_xy_rec *top;
 int err;

 PRT3(printf("setup_neighbor_type_rec resolve->num_lists = %d num_echoes = %d\n",
         resolve->num_lists,num_echoes))
 for (num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;
     while (top != NULL)
        {
         if ((err = get_ptr(&neigh,NULL,(unsigned long) 1,(size_t) sizeof(*neigh)))
                      != NO_ERROR)
            return err;
         top->pix_neigh->neigh = neigh;

         neigh->status = 0;
         neigh->xy_ptr = top;
         if (num_echoes == 1)
            compute_1_echo_weights(neigh,_2d1,(long) top->x,(long) top->y);
           else compute_2_echo_weights(neigh,_2d1,_2d2,(long) top->y,(long) top->x);
         neighbor_weights(neigh,top->pix_neigh->pix,(long) top->x,(long) top->y,
                           neigh_2d,image_mask);               
         top = top->next;
        }
    }
 TRACE(printf("setup_neighbor_type_rec 1=======\n"))

/*
 check_done_neighs(neigh_2d,resolve);
*/
 TRACE(printf("setup_neighbor_type_rec 2\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
update_neighs - ???
--------------------------------------------------------------------------*/

int
update_neighs(neigh,neigh_2d,row,col,type)
 struct neighbor_type_rec *neigh;
 struct buf_2d_rec *neigh_2d;
 long row,col,type;
{
 long indx,indx1,lcv,x,y,x1,y1,cnt;
 int next,next_indx1;
 struct neighbor_type_rec *neigh1,*neigh2;
 struct pixel_neighbor_type_rec *pix_neigh,*pix_neigh1;
 struct type_val_rec *pix;
 unsigned char done_neighs,done_neighs1;

 done_neighs = neigh->done_neighs;
 for (lcv = 1; lcv <= (unsigned long)_0Edge[done_neighs][0]; lcv++)
    {next = _0Edge[done_neighs][lcv];
     x = col + neighbor_Offset[next][0];
     y = row + neighbor_Offset[next][1];
     pix_neigh = (struct pixel_neighbor_type_rec *)
             get_1d_buf_value(neigh_2d->buf[y],x,neigh_2d->pixel_depth);
     if ((neigh1 = pix_neigh->neigh) == NULL) continue;
     if (neigh1->status & TYPE_RESOLVED) continue;
     next = _EdgeReversePosi[next];
     neigh1->done_neighs |= _EdgeBit[next];
     neigh1->status &= ~LEFT_OVER_WEIGHTS_CHECKED;

     pix = pix_neigh->pix;
     for (indx = 0; indx < (unsigned long)pix->num_types; indx++)
        if (pix->types[indx].indx == type)
           break;
     if (indx == pix->num_types)
        continue;

     for (indx1 = 0; indx1 < (unsigned long) neigh1->num_neighs; indx1++)
        if (neigh1->neighs[indx1].type == type)
           {
            neigh1->neighs[indx1].conn_fac += neigh1->weights[next];
            break;}

     if (indx1 == neigh1->num_neighs)
        {
         neigh1->neighs[indx1].conn_fac = neigh1->weights[next];
         neigh1->neighs[indx1].type = type;
         neigh1->num_neighs += 1;
        }
     if (neigh1->num_neighs > 1)
        qsort(neigh1->neighs,neigh1->num_neighs,sizeof(*(neigh1->neighs)),
                                  sort_type_conn_fac_rec_proc);

     done_neighs1 = neigh1->done_neighs;
     for (cnt = 1; cnt <= (unsigned long)_0Edge[done_neighs1][0]; cnt++)
        {next_indx1 = _0Edge[done_neighs1][cnt];
         x1 = x + neighbor_Offset[next_indx1][0];
         y1 = y + neighbor_Offset[next_indx1][1];
         pix_neigh1 = (struct pixel_neighbor_type_rec *)
             get_1d_buf_value(neigh_2d->buf[y1],x1,neigh_2d->pixel_depth);
         if ((neigh2 = pix_neigh1->neigh) == NULL) continue;
         if (neigh2->status & TYPE_RESOLVED) continue;
         neigh2->status &= ~LEFT_OVER_WEIGHTS_CHECKED;
        }

    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
free_neighbor_type_rec - ???
--------------------------------------------------------------------------*/

void
free_neighbor_type_rec(neigh_2d)
 struct buf_2d_rec *neigh_2d;
{
 long row,col;
 struct pixel_neighbor_type_rec *pix_neigh;

 for (row = 0; row < neigh_2d->dimy; row++)
    for (col = 0; col < neigh_2d->dimx; col++)
       {pix_neigh = (struct pixel_neighbor_type_rec *)
             get_1d_buf_value(neigh_2d->buf[row],col,neigh_2d->pixel_depth);
        if (pix_neigh)
           if (pix_neigh->neigh != NULL) c_free(pix_neigh->neigh);}
}


/*--------------------------------------------------------------------------
solve_1_echo_shared_pixel_types - ???
--------------------------------------------------------------------------*/

int
solve_1_echo_shared_pixel_types(type_aves,num_type_aves,neigh_2d,resolve,image_mask)
 struct pixel_type_ave_rec *type_aves;
 long num_type_aves;
 struct buf_2d_rec *neigh_2d,*image_mask;
 struct pixel_stack_rec_ptr *resolve;
{
 long num,keep,total,cnt6;
 struct type_val_rec *cur_pix;
 struct stack_xy_rec *top,*next;
 long whch,type;
 float diff,diff1;
 int err,is_segment,done,done1,is_dead,is_drop;
 struct neighbor_type_rec *neigh;
 float leftover;
 long over,act;
 unsigned char done_neighs;

 PRT3(printf("resolve_1_echo_shared_pixels...num_lists = %d num_type_aves = %d\n",
           resolve->num_lists,num_type_aves))
 is_drop = 0;
 done1 = done = 0;
 err = NO_ERROR;
 PRT3(total = act = over = cnt2 = cnt3 = cnt4 = cnt5 = cnt6 = 0;)
 
 while ((resolve->num_lists > 0) && !done1)
    {is_dead = 0;
     do 
       {
        is_segment = 0;
        for (num = 0; num < resolve->num_lists; num++)
           {if ((top = resolve->lists[num]->top.next) == NULL) continue;
            while (top != NULL)
               {
                neigh = top->pix_neigh->neigh;
                if ((neigh->num_neighs == 0) || 
                    (neigh->status & LEFT_OVER_WEIGHTS_CHECKED))
                   {PRT3(if ((neigh->num_neighs > 0) && 
                             (neigh->status & LEFT_OVER_WEIGHTS_CHECKED))
                            cnt5 += 1;
                         act += 1;)
                    top = top->next;
                    continue;}
                cur_pix = top->pix_neigh->pix;
                if (cur_pix->num_types > 1) 
                   {done_neighs = neigh->done_neighs;
                    if (_0Edge[done_neighs][0] > 0)
                       {PRT3(cnt3 += 1;)
                        leftover = .0;
                        for (keep = 1; keep <= (unsigned long)_0Edge[done_neighs][0]; keep++)
                           leftover += neigh->weights[_0Edge[done_neighs][keep]];
                        if ((leftover > neigh->neighs[0].conn_fac) ||
                            ((neigh->num_neighs > 1) &&
                             ((neigh->neighs[1].conn_fac + leftover)
                                           > neigh->neighs[0].conn_fac)))
                           {top = top->next;
                            neigh->status |= LEFT_OVER_WEIGHTS_CHECKED;
                            PRT3(over += 1;)
                            continue;}
                       }
                   }
                
                if ((neigh->num_neighs > 1) &&
                    (neigh->neighs[0].conn_fac == neigh->neighs[1].conn_fac))
                    {PRT3(cnt2 += 1;)
                     whch = 0;
                     diff = type_aves[neigh->neighs[whch].type].x /
                                (float) type_aves[neigh->neighs[whch].type].num_freqs - 
                             cur_pix->valx;
                     if (diff < .0) diff = -diff;
                     for (keep = 1; keep < (long) neigh->num_neighs; keep++)
                        if (neigh->neighs[whch].conn_fac == 
                                           neigh->neighs[keep].conn_fac)
                           {diff1 = type_aves[neigh->neighs[keep].type].x /
                                      (float) type_aves[neigh->neighs[keep].type].num_freqs - 
                                    cur_pix->valx;
                            if (diff1 < .0) diff1 = -diff1;
                            if (diff1 < diff)
                               {whch = keep;
                                diff = diff1;}
                           }
                          else break;
                    type = neigh->neighs[whch].type;
                    neigh->neighs[0].type = type;
                   }
                  else type = neigh->neighs[0].type;

                if (neigh->status & TYPE_RESOLVED) cnt6 += 1;

                PRT3(total += 1;)

                neigh->num_neighs = 1;
                neigh->status |= TYPE_RESOLVED;
                neigh->xy_ptr = NULL;
                type_aves[type].x += cur_pix->valx;
                type_aves[type].y = type_aves[type].x;
                type_aves[type].num_freqs += 1;

                if (top->next != NULL) top->next->last = top->last;
                if (top->last != NULL) top->last->next = top->next;
                next = top->next;

                update_neighs(neigh,neigh_2d,(long) top->y,(long) top->x,type);
                c_free(top);
                top = next;
                is_segment = 1;
                done1 = 0;
               }
            if (resolve->lists[num]->top.next == NULL)  is_drop = 1;
            if (err != NO_ERROR) break;
           }
        if (is_drop)
           {is_drop = 0;
            drop_empty_stack_lists(resolve);
           }
         if (!is_segment)
            {if (done)
                {done1 = 1;
                 done = 0;}
             if ((resolve->num_lists > 0) &&
                 ((err = sort_resolve_list(resolve,neigh_2d,1)) != NO_ERROR))
                break;
             is_dead += 1;}
           else done = 0;
        }
     while ((is_dead == 2) && (resolve->num_lists > 0));
     if (err != NO_ERROR) break;
     PRT3(printf("dead done = %d done1 = %d not-act = %d over = %d seg = %d  cnt[0]==[1] = %d eval = %d step1 = %d checked = %d \n",
           done,done1,act,over,total,cnt2,cnt3,cnt4,cnt5);)
    act = total = over = 0;

     if ((resolve->num_lists == 0) ||
         ((err = solve_deadlock_pixels(type_aves,num_type_aves,
                         neigh_2d,resolve,image_mask,&done)) != NO_ERROR))
        break;
       else if (resolve->num_lists > 0) 
        if ((err = sort_resolve_list(resolve,neigh_2d,1)) != NO_ERROR)
           break;
     PRT3(printf("after dead done = %d done1 = %d LEFT = %d\n",
           done,done1,cnt_pixel_stack_rec_ptr(resolve)))
    }
 PRT3(printf("err = %d not-act = %d over = %d seg = %d  cnt[0]==[1] = %d eval = %d step1 = %d checked = %d cnt6 = %d\n",err,
           act,over,total,cnt2,cnt3,cnt4,cnt5,cnt6);)

 TRACE(printf("err = %d done = %d\n",err,done);
  for (num = 0; num < num_type_aves; num++)
    {printf("%d) solve_1_echo_shared_pixel_types...avex = %f avey = %f num_freqs = %d\n",num,
                   type_aves[num].x / (float) type_aves[num].num_freqs,
                   type_aves[num].y / (float) type_aves[num].num_freqs,
                   type_aves[num].num_freqs);
    }
   )
 return err;
}


/*--------------------------------------------------------------------------
check_weights - ???
--------------------------------------------------------------------------*/

void
check_weights(neigh_2d,resolve)
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num,indx,cnt;
 struct neighbor_type_rec *neigh;
 struct stack_xy_rec *top;
 float leftover;
 unsigned char done_neighs;

 for (cnt = num = 0; num < resolve->num_lists; num++)
    {if ((top = resolve->lists[num]->top.next) == NULL) continue;
     while (top != NULL)
        {
         neigh = top->pix_neigh->neigh;
         if (neigh->done_neighs == 0xff)
            printf("---%ld) %lx %lx %ld/%ld num = %ld ",
		   cnt,(unsigned long) neigh->status,
                   (unsigned long) neigh->done_neighs,(long) top->y,
		   (long) top->x,(unsigned long) neigh->num_neighs);
	 else 
            {done_neighs = neigh->done_neighs;
             for (leftover = .0,indx = 1; indx < (unsigned long)_0Edge[done_neighs][0]; indx++)
                leftover += neigh->weights[_0Edge[done_neighs][indx]];
             if (neigh->num_neighs > 1)  
                leftover += neigh->neighs[1].conn_fac;
             if (leftover > neigh->neighs[0].conn_fac)
                printf("%ld) %lx %lx %ld/%ld num = %ld l = %f ",
		       cnt,(unsigned long) neigh->status,
		       (unsigned long) neigh->done_neighs,(long) top->y,
		       (long) top->x,
		       (unsigned long) neigh->num_neighs,leftover);
	     else 
                printf("< %ld) %lx %lx %ld/%ld num = %ld l = %f ",
		       cnt,(unsigned long) neigh->status,
		       (unsigned long) neigh->done_neighs,(long) top->y,
		       (long) top->x, (unsigned long) neigh->num_neighs,
		       leftover);
            }
         for (indx = 0; indx < (unsigned long) neigh->num_neighs; indx++)
            printf(" [%ld] = %ld/%f",indx,(long) neigh->neighs[indx].type,
                     neigh->neighs[indx].conn_fac);
         printf("\n");
         top = top->next;
         cnt += 1;
        }
    }
}

/***************
incompatible_1_echo_pixels_by_neighbors(types,num_types,neigh_2d,resolve)
 struct pixel_tissue_type_rec *types;
 unsigned long num_types;
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num,indx,cnt,lcv;
 struct type_val_rec *pix,*cur_pix;
 struct stack_xy_rec *top,*bot,*next;
 long type;
 int err,is_segment,done,is_drop_empty;
 float diff,diff1;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 double ave;

 TRACE(printf("incompatible_1_echo_pixels_by_neighbors...\n");)
 err = NO_ERROR;
 is_drop_empty = 0;
 while (resolve->num_lists > 0)
    {do
       {is_segment = 0;
        for (num = 0; num < resolve->num_lists; num++)
           {if ((top = resolve->lists[num]->top.next) == NULL) continue;
            while (top != NULL)
               {pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(
                        neigh_2d->buf[(long) top->y],(long) top->x,
                        neigh_2d->pixel_depth);
                neigh = pix_neigh->neigh;
                incompatible_type_by_neighbors(neigh,pix_neigh->pix,(long) top->x,
                        (long) top->y,neigh_2d);
                if (neigh->num_neighs > 0)
                   {type = neigh->neighs[0].type;
                    if (top->next != NULL) top->next->last = top->last;
                    if (top->last != NULL) top->last->next = top->next;
                    update_neighs(neigh,neigh_2d,
                      (unsigned long) top->y,(long) top->x,type);
                    next = top->next;
                    c_free(top);
                    is_segment = 1;
                    top = next;
                   }
                  else top = top->next;
                }
            if (resolve->lists[num]->top.next == NULL) is_drop_empty = 1;
            if (err != NO_ERROR) break;
           }
         if (is_drop_empty)
            {is_drop_empty = 0;
             if ((err = drop_empty_stack_lists(resolve)) != NO_ERROR)
                break;
            }
        }
     while (is_segment && (resolve->num_lists > 0));
     if (err != NO_ERROR) break;
    }
 return err;
}

incompatible_1_echo_pixels_by_ave(types,num_types,_2d_types,neigh_2d,resolve)
 struct pixel_tissue_type_rec *types;
 unsigned long num_types;
 struct buf_2d_rec *_2d_types,*neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num,indx,cnt,lcv;
 struct type_val_rec *cur_pix;
 struct stack_xy_rec *top;
 long whch;
 float diff,diff1,diffx,diffy;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 double ave;

 PRT1(printf("incompatible_1_echo_pixels_by_ave...\n");)
 for (num = 0; num < resolve->num_lists; num++)
    {if ((top = resolve->lists[num]->top.next) == NULL) continue;
     while (top != NULL)
        {
         pix_neigh = (struct pixel_neighbor_type_rec *) 
                  get_1d_buf_value(neigh_2d->buf[top->y],
                        (long) top->x,neigh_2d->pixel_depth);
         cur_pix = pix_neigh->pix;
         whch = 0;
         diffx = types[0].type_ave.x /
                      (float) types[0].type_ave.num_freqs - cur_pix->valx;
         diffx = diffx * diffx;
         diffy = types[0].type_ave.y /
                      (float) types[0].type_ave.num_freqs - cur_pix->valy;
         diffy = diffy * diffy;
         diff = (float) sqrt((double) (diffx + diffy));
         for (indx = 1; indx < num_types; indx++)
            {diffx = types[indx].type_ave.x /
                      (float) types[indx].type_ave.num_freqs - cur_pix->valx;
             diffx = diffx * diffx;
             diffy = types[indx].type_ave.y /
                      (float) types[indx].type_ave.num_freqs - cur_pix->valy;
             diffy = diffy * diffy;
             diff1 = (float) sqrt((double) (diffx + diffy));
             if (diff1 < diff)
                {whch = indx;
                 diff = diff1;}
            }
         neigh = pix_neigh->neigh;
         neigh->status |= TYPE_RESOLVED;
         neigh->neighs[0].type = whch;
         neigh->num_neighs = 1;
         top = top->next;
        }
    }
 return NO_ERROR;
}
****************/


/*--------------------------------------------------------------------------
segment_pixel_map - ???
--------------------------------------------------------------------------*/

int
segment_pixel_map(pixel_map,neigh_2d,image_mask)
 struct buf_2d_rec *pixel_map,*neigh_2d,*image_mask;
{
 long row,col;
 struct type_val_rec *cur_pix;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;

 PRT1(printf("segment_pixel_map...\n"))
 PRT1(none = p0 = p1 = p2 = 0;)
 for (row = 0; row < neigh_2d->dimy; row++)
    for (col = 0; col < neigh_2d->dimx; col++)
       {
        if ((image_mask != NULL) && (image_mask->status4 & BUF_NON_EMPTY))
           {if (get_1d_buf_value(image_mask->buf[row],col,image_mask->pixel_depth) == 0)
               continue;
           }
        pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[row],
                         col,neigh_2d->pixel_depth);
        cur_pix = pix_neigh->pix;
        neigh = pix_neigh->neigh;
        if (neigh == NULL)
           {if (cur_pix == 0)
               {set_1d_buf_value(pixel_map->buf[row],col,pixel_map->pixel_depth,
                (unsigned long) 0);
                PRT1(none += 1;)
               }
              else if (cur_pix->num_types == 1)
               {set_1d_buf_value(pixel_map->buf[row],col,pixel_map->pixel_depth,
                    (unsigned long) (cur_pix->types[0].indx + 1));
                PRT1(p1 += 1;)
               }
           }
          else
           {
            if (neigh->status & TYPE_RESOLVED)
               {set_1d_buf_value(pixel_map->buf[row],col,pixel_map->pixel_depth,
                (unsigned long) (neigh->neighs[0].type + 1));
                PRT1(p2 += 1;)}
              else
               {set_1d_buf_value(pixel_map->buf[row],col,pixel_map->pixel_depth,
                   (unsigned long) 0);
                PRT1(p0 += 1;)}
           }
       }
 PRT1(printf("segment_pixel_map...none = %d p0 = %d p1 = %d  p2 = %d\n",
              none,p0,p1,p2))
 pixel_map->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
sort_1_echo_type_val_rec_proc - ???
--------------------------------------------------------------------------*/

int
sort_1_echo_type_val_rec_proc(set1,set2)
 struct type_val_rec **set1,**set2;
{
 if ((*set1)->valx > (*set2)->valx) return 1;
 if ((*set1)->valx < (*set2)->valx) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
cnt_2d_types - ???
--------------------------------------------------------------------------*/

void
cnt_2d_types(_2d_types)
 struct buf_2d_rec *_2d_types;
{
 long row,col,none,p0,p1,p2;
 struct type_val_rec *cur_pix;

 none = p0 = p1 = p2 = 0;
 for (row = 0; row < _2d_types->dimy; row++)
    for (col = 0; col < _2d_types->dimx; col++)
       {cur_pix = (struct type_val_rec *) get_1d_buf_value(
                          _2d_types->buf[row],col,_2d_types->pixel_depth);
        if (cur_pix == 0) none += 1;
          else if (cur_pix->num_types == 0) p0 += 1;
          else if (cur_pix->num_types == 1) p1 += 1;
          else p2 += 1;
       }
 printf("cnt_2d_types none = %ld p0 = %ld p1 = %ld p2 = %ld\n",none,p0,p1,p2);
}


/*--------------------------------------------------------------------------
setup_1_echo_types - ???
--------------------------------------------------------------------------*/

int
setup_1_echo_types(all,_2d_types,_2d,types,num_types)
 struct the_type_val_rec *all;
 struct buf_2d_rec *_2d_types,*_2d;
 struct pixel_tissue_type_rec *types;
 unsigned long num_types;
{
 long row,col,indx,lcv,num,total;
 struct type_val_rec set,*the_set,*set_ptr;
 struct type_indx_rec *type_indxs;
 int err;

 PRT3(printf("setup_1_echo_types..._2d = %u num_types = %d  types = %u\n",_2d,num_types,types))
 total = 0;
 if ((err = get_ptr(&type_indxs,&total,num_types,
             (size_t) sizeof(*type_indxs))) != NO_ERROR)
    return err;
 set_ptr = &set;
 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       {
        set.valx = get_1d_buf_value(_2d->buf[row],col,_2d->pixel_depth);
        if (all->num_sets == 0) indx = 0;
          else if (obj_binary_search(all->sets,all->num_sets,sizeof(*(all->sets)),
             &set_ptr,sort_1_echo_type_val_rec_proc,&indx) == NO_ERROR)
           {set_1d_buf_value(_2d_types->buf[row],col,
                       _2d_types->pixel_depth,all->sets[indx]);
            continue;}

        if (all->num_sets == all->total_sets)
           {
            if ((err = get_handle(&(all->sets),&(all->total_sets),(unsigned long) 200,
                     (size_t) sizeof(**(all->sets)))) != NO_ERROR)
               {c_free(type_indxs);
                return err;}
           }
        for (num = 0,lcv = 0; lcv < num_types; lcv++)
           if ((set.valx >= types[lcv].ext_lb) && 
               (set.valx <= types[lcv].ext_ub))
              {if (set.valx < types[lcv].abs_lb)
                  type_indxs[num].dist = types[lcv].abs_lb - set.valx + 1;
                 else if (set.valx > types[lcv].abs_ub)
                  type_indxs[num].dist = set.valx - types[lcv].abs_ub + 1;
                 else type_indxs[num].dist = 1;
               type_indxs[num++].indx = lcv;}
        the_set = all->sets[all->num_sets];
        init_type_val_rec(the_set);
        total = the_set->num_types;
        if ((err = get_ptr(&(the_set->types),&total,num,
                     (size_t) sizeof(*(the_set->types)))) != NO_ERROR) 
           {c_free(type_indxs);
            return err;}
        the_set->num_types = total;
        the_set->valx = set.valx;
        the_set->valy = set.valx;
        for (lcv = 0; lcv < num; lcv++)
           the_set->types[lcv] = type_indxs[lcv];
        for (num = lcv = all->num_sets; lcv > indx; lcv = num)
           {num -= 1;
            all->sets[lcv] = all->sets[num];}
        all->sets[indx] = the_set;
        all->num_sets += 1;
        set_1d_buf_value(_2d_types->buf[row],col,_2d_types->pixel_depth,all->sets[indx]);
       }
 c_free(type_indxs);
 PRT3(printf("setup_1_echo_types...all  total_sets = %d num_sets = %d\n",all->total_sets,
                  all->num_sets))
 return err;
}


/*--------------------------------------------------------------------------
restore_1_echo_segment_params - ???
--------------------------------------------------------------------------*/

void
restore_1_echo_segment_params(types,num_types)
 struct pixel_tissue_type_rec *types;
 unsigned long num_types;
{
 unsigned long lcv;

 PRT3(printf("restore_1_echo_segment_params...\n"))
 for (lcv = 0; lcv < num_types; lcv++)
    {init_pixel_type_ave_rec(&(types[lcv].type_ave));
     types[lcv].actual_lb = types[lcv].abs_lb;
     types[lcv].actual_ub = types[lcv].abs_ub;
     PRT3(
        printf("   actual_lb = %d ub = %d\n",types[lcv].actual_lb,types[lcv].actual_ub);)
    }
}


/*--------------------------------------------------------------------------
sort_resolve_list_rec_proc - ???
--------------------------------------------------------------------------*/

int
sort_resolve_list_rec_proc(ptr1,ptr2)
 const void *ptr1,*ptr2;
{
 int cnt1,cnt2;
 struct neighbor_type_rec *neigh1,*neigh2;

 neigh1 = ((struct sort_resolve_list_rec *) ptr1)->pix_neigh->neigh;
 neigh2 = ((struct sort_resolve_list_rec *) ptr2)->pix_neigh->neigh;
 cnt1 = _EdgeCounts[neigh1->done_neighs];
 cnt2 = _EdgeCounts[neigh2->done_neighs];
 if (cnt1 > cnt2) return -1;
 if (cnt1 < cnt2) return 1;
 if (neigh1->num_neighs == 0)
    {if (neigh2->num_neighs == 0) return 0;
       else if (neigh2->num_neighs > 0) return 1;
     return -1;}
   else if (neigh2->num_neighs == 0) 
    {if (neigh1->num_neighs > 0) return -1;
     return 1;}
 if (neigh1->neighs[0].conn_fac > neigh2->neighs[0].conn_fac)
    return -1;
 if (neigh1->neighs[0].conn_fac < neigh2->neighs[0].conn_fac)
    return 1;
 return 0;
}


/*--------------------------------------------------------------------------
sort_resolve_list - ???
--------------------------------------------------------------------------*/

int
sort_resolve_list(resolve,neigh_2d,is_pr)
 struct pixel_stack_rec_ptr *resolve;
 struct buf_2d_rec *neigh_2d;
 int is_pr;
{
 unsigned long total,cnt,lcv;
 struct sort_resolve_list_rec *ptr;
 struct stack_xy_rec *top;
 struct pixel_neighbor_type_rec *pix_neigh;
 int err;

 if ((total = cnt_pixel_stack_rec_ptr(resolve)) <= 1) return NO_ERROR;
 PRT1(if (is_pr) printf("\nsort_resolve_list total = %d\n",total))
 if ((err = get_ptr(&ptr,NULL,total,(size_t) sizeof(*ptr))) != NO_ERROR)
    return err;
 for (cnt = lcv = 0; lcv < resolve->num_lists; lcv++)
    {if ((top = resolve->lists[lcv]->top.next) == NULL) continue;
     while (top != NULL)
        {pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(
                         neigh_2d->buf[top->y],(long) top->x,neigh_2d->pixel_depth);
         if ((pix_neigh != NULL) && (pix_neigh->neigh != NULL))
            pix_neigh->neigh->status &= ~LEFT_OVER_WEIGHTS_CHECKED;
         ptr[cnt].pix_neigh = pix_neigh;
         ptr[cnt++].xy = top;
         top = top->next;
        }
     resolve->lists[lcv]->top.last = NULL;
     resolve->lists[lcv]->top.next = NULL;
    }
 qsort(ptr,cnt,sizeof(*ptr),sort_resolve_list_rec_proc);
 cnt -= 1;
 ptr[0].xy->next = NULL;
 ptr[0].xy->last = &(resolve->lists[0]->top);
 top = resolve->lists[0]->top.next = ptr[0].xy;
 resolve->lists[0]->top.last = ptr[cnt].xy;
 resolve->lists[0]->bot = ptr[cnt].xy;
 for (lcv = 1; lcv <= cnt; lcv++)
    {top->next = ptr[lcv].xy;
     ptr[lcv].xy->last = top;
     ptr[lcv].xy->next = NULL;
     top = ptr[lcv].xy;}
 drop_empty_stack_lists(resolve);
 c_free(ptr);
 PRT1(if (is_pr) printf("sort_resolve_list end num_list = %d\n",resolve->num_lists))
 total = cnt_pixel_stack_rec_ptr(resolve);
 PRT1(if (is_pr) printf("sort_resolve_list end total = %d\n\n",total))
 return NO_ERROR;
}

/*******************
check_resolve_list(resolve,neigh_2d)
 struct pixel_stack_rec_ptr *resolve;
 struct buf_2d_rec *neigh_2d;
{
 unsigned long lcv,cnt,cnt1,cnt2,cnt3,cnt10,num,keep;
 struct pixel_neighbor_type_rec *pix_neigh;
 struct stack_xy_rec *top,*last;
 float minw,maxw,minc,maxc,mind,maxd;
 struct type_val_rec *cur_pix;
 int isw,isc,isd;
 static int times = 0;
 FILE *fid = NULL;
 char str[30];
 unsigned char done_neighs;
 struct neighbor_type_rec *neigh2;
 long x,y;

 cnt = cnt_pixel_stack_rec_ptr(resolve);
 
 PRT1(printf("check_resolve_list...num_lists = %d total = %d\n",resolve->num_lists,cnt))
 isw = isc = isd = 0;
 fid = NULL;
 for (cnt10 = cnt1 = cnt2 = cnt3 = cnt = lcv = 0; lcv < resolve->num_lists; lcv++)
    {if ((top = resolve->lists[lcv]->top.next) == NULL) continue;
     while (top != NULL)
        {pix_neigh = top->pix_neigh;
         if (pix_neigh == NULL) 
            {PRT1(printf("x = %d y = %d pix_neigh== NULL...1\n",top->x,top->y))
            }
           else if (pix_neigh->neigh == NULL)
            {PRT1(printf("x = %d y = %d pix_neigh->neigh== NULL...1\n",top->x,top->y))
            }
           else if (pix_neigh->neigh->xy_ptr != top)
            {PRT1(printf("x = %d y = %d xy_ptr = %u != top = %u\n",
                  top->x,top->y,pix_neigh->neigh->xy_ptr,top))
            }
           else
            {cnt += 1;
             if (fid == NULL)
                {sprintf(str,"f%d",times);
                 times += 1;
                 if ((fid = fopen(str,"w")) == NULL) return CANCEL;
                }
             fprintf(fid,"%d)%-d/%-d %x num_types = %d\n   ",
                  cnt,(long) top->x,(long) top->y,
                 (unsigned long) pix_neigh->neigh->done_neighs,(long) pix_neigh->pix->num_types);
             for (keep = 0; keep < 8; keep++)
                fprintf(fid,"%d:%-.4f ",keep,pix_neigh->neigh->weights[keep]);
             fprintf(fid,"\n   %d  ",pix_neigh->neigh->num_neighs);
             for (keep = 0; keep < pix_neigh->neigh->num_neighs; keep++)
                fprintf(fid,"%d:%-.4f ",keep,pix_neigh->neigh->neighs[keep].conn_fac);
             fprintf(fid,"\n");
            }
         cur_pix = pix_neigh->pix;
         for (num = 0; num < cur_pix->num_types; num++)
            {if (!isd)
                {isd = 1;
                 mind = cur_pix->types[num].dist;
                 maxd = cur_pix->types[num].dist;}
               else
                {if (cur_pix->types[num].dist < mind)
                    mind = cur_pix->types[num].dist;
                   else if (cur_pix->types[num].dist > maxd)
                    maxd = cur_pix->types[num].dist;
                }

             if (cur_pix->types[num].dist < .0)
                     printf("< .0 x = %d y = %d types[%d]dist = %d < .0\n",
                      top->x,top->y,num,(long) cur_pix->types[num].dist);
               else if (cur_pix->types[num].dist == .0)
                printf("== .0 x = %d y = %d types[%d]dist = %d == .0\n",
                  top->x,top->y,num,(long) cur_pix->types[num].dist);
               else cnt3 += 1;
            }

         for (num = 0; num < pix_neigh->neigh->num_neighs; num++)
            {if (!isc)
                {isc = 1;
                 minc = pix_neigh->neigh->neighs[num].conn_fac;
                 maxc = pix_neigh->neigh->neighs[num].conn_fac;}
               else
                {if (pix_neigh->neigh->neighs[num].conn_fac < minc)
                    minc = pix_neigh->neigh->neighs[num].conn_fac;
                   else if (pix_neigh->neigh->neighs[num].conn_fac > maxc)
                    maxc = pix_neigh->neigh->neighs[num].conn_fac;
                }

             if (pix_neigh->neigh->neighs[num].conn_fac < .0)
                     printf("< .0 x = %d y = %d neighs[%d]conn_fac = %f < .0\n",
                      top->x,top->y,num,pix_neigh->neigh->neighs[num].conn_fac);
               else if (pix_neigh->neigh->neighs[num].conn_fac == .0)
                printf("== .0 x = %d y = %d neighs[%d]conn_fac = %f == .0\n",
                  top->x,top->y,num,pix_neigh->neigh->neighs[num].conn_fac);
               else if (pix_neigh->neigh->neighs[num].conn_fac > 1.0)
                printf("> 1.0 x = %d y = %d neighs[%d]conn_fac = %f > 1.0\n",
                  top->x,top->y,num,pix_neigh->neigh->neighs[num].conn_fac);
               else if (pix_neigh->neigh->neighs[num].conn_fac == 1.0)
                printf("== 1.0 x = %d y = %d neighs[%d]conn_fac = %f == 1.0\n",
                  top->x,top->y,num,pix_neigh->neigh->neighs[num].conn_fac);
               else cnt1 += 1;
            }
         for (num = 0; num < 8; num++)
            {if (!isw)
                {isw = 1;
                 minw = pix_neigh->neigh->weights[num];
                 maxw = pix_neigh->neigh->weights[num];}
               else
                {if (pix_neigh->neigh->weights[num] < minw)
                    minw = pix_neigh->neigh->weights[num];
                   else if (pix_neigh->neigh->weights[num] > maxw)
                    maxw = pix_neigh->neigh->weights[num];
                }

             if (pix_neigh->neigh->weights[num] < .0)
                     printf("< .0 x = %d y = %d weights[%d] = %f < .0\n",
                      top->x,top->y,num,pix_neigh->neigh->weights[num]);
               else if (pix_neigh->neigh->weights[num] == .0)
                printf("== .0 x = %d y = %d weights[%d] = %f == .0\n",
                  top->x,top->y,num,pix_neigh->neigh->weights[num]);
               else if (pix_neigh->neigh->weights[num] > 1.0)
                printf("> 1.0 x = %d y = %d weights[%d] = %f > 1.0\n",
                  top->x,top->y,num,pix_neigh->neigh->weights[num]);
               else cnt2 += 1;
            }
         done_neighs = pix_neigh->neigh->done_neighs;
         for (num = 0; num < 8; num++)
            {if (!(done_neighs & _EdgeBit[num])) continue;
             x = top->x + neighbor_Offset[num][0];
             if ((x < 0) || (x >= neigh_2d->dimx)) continue;
             y = top->y + neighbor_Offset[num][1];
             if ((y < 0) || (y >= neigh_2d->dimy)) continue;
             pix_neigh = (struct pixel_neighbor_type_rec *)
                get_1d_buf_value(neigh_2d->buf[y],x,neigh_2d->pixel_depth);
             if ((neigh2 = pix_neigh->neigh) == NULL)
                {cnt10 += 1;continue;}
             if (!(neigh2->status & TYPE_RESOLVED))
                {printf("%d:%d) %x not TYPE_RESOLVED %d num_neighs = %d %d/%d x = %d y = %d\n",
                  cnt,num,(unsigned long) done_neighs,
                  pix_neigh->pix->num_types,neigh2->num_neighs,
                     x,y,(long) top->x,(long) top->y);
                for (keep = 0; keep < neigh2->num_neighs; keep++)
                   printf("%d:%-.4f ",keep,neigh2->neighs[keep].conn_fac);
                printf("\n");}
            }

         last = top;
         top = top->next;
        }
     PRT1(printf("check_resolve_list...next...cnt = %d total = %d\n",
          cnt,neigh_2d->dimx * neigh_2d->dimy))
     top = last;
     cnt = 0;
     while ((top != NULL) && (top != &(resolve->lists[lcv]->top)))
        {pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(
                         neigh_2d->buf[top->y],(long) top->x,neigh_2d->pixel_depth);
         if (pix_neigh == NULL) 
            {PRT1(printf("last x = %d y = %d pix_neigh== NULL...1\n",top->x,top->y))
            }
           else if (pix_neigh->neigh == NULL)
            {PRT1(printf("%d) last x = %d y = %d pix_neigh->neigh== NULL...top = %u ltop = %u last = %u\n",
                 cnt,top->x,top->y,top,&(resolve->lists[lcv]->top),
                 resolve->lists[lcv]->top.last))
            }
           else if (pix_neigh->neigh->xy_ptr != top)
            {PRT1(printf("last x = %d y = %d xy_ptr = %u != top = %u\n",
                  top->x,top->y,pix_neigh->neigh->xy_ptr,top))
            }
           else
            {cnt += 1;
            }
         last = top;
         top = top->last;
        }

     PRT1(printf("check_resolve_list...last...cnt = %d cntf = %d cntw = %d cntd = %d total = %d cnt10 = %d\n",
      cnt,cnt1,cnt2,cnt3,neigh_2d->dimx * neigh_2d->dimy,cnt10))
     PRT1(printf("...minc = %f maxc = %f minw = %f maxw = %f mind = %f maxd = %f\n",
      minc,maxc,minw,maxw,mind,maxd))
    }
 if (fid != NULL) fclose(fid);
}
***************/


/*--------------------------------------------------------------------------
segment_1_echo_pixels - ???
--------------------------------------------------------------------------*/

int
segment_1_echo_pixels(types,num_types,_2d,pixel_map,histo,option)
 struct pixel_tissue_type_rec *types;
 unsigned long num_types;
 struct buf_2d_rec *_2d,*pixel_map;
 struct histo_params_rec *histo;
 int option;
{
 int err;
 struct buf_2d_rec _2d_types,neigh_2d;
 struct the_type_val_rec all;
 struct pixel_stack_rec_ptr resolve;
 long depth;
 struct pixel_neighbor_type_rec *pix_neighs;
 struct pixel_type_ave_rec *type_aves;
 long num_type_aves;

 PRT2(printf("segment_1_echo_pixels option = %x\n",option))

 restore_1_echo_segment_params(types,num_types);
 pixel_map->status4 &= ~BUF_DATA_VALID;
 init_the_type_val_rec(&all);
 init_buf_2d_rec(&_2d_types);
 if (((err = setup_pixel_type_ave_rec(&type_aves,&num_type_aves,num_types))
                == NO_ERROR) &&
     ((err = SetupBuf2dRec(&_2d_types,_2d->dimx,_2d->dimy, 
            sizeof(void *) * 8,1))  == NO_ERROR) &&           
     ((err = setup_1_echo_types(&all,&_2d_types,_2d,
                      types,num_types)) == NO_ERROR))
    {
     TRACE(printf("_2d_types...\n");pr_buf_2d_rec(&_2d_types));
     pix_neighs = NULL;
     init_pixel_stack_rec_ptr(&resolve);
     init_buf_2d_rec(&neigh_2d);
     if (((err = SetupBuf2dRec(&neigh_2d,_2d->dimx,_2d->dimy, 
                   sizeof(void *) * 8,1))  == NO_ERROR) &&
         ((err = _1_echo_statistics(type_aves,num_type_aves,&_2d_types,NULL,&pix_neighs,
                 &resolve,&neigh_2d)) == NO_ERROR))
        {
         if ((resolve.num_lists > 0) &&
             ((err = setup_neighbor_type_rec(&neigh_2d,&resolve,
                        _2d,_2d,NULL,1)) == NO_ERROR) &&
             ((err = sort_resolve_list(&resolve,&neigh_2d,1)) == NO_ERROR))
            {PRT3(printf("before resolve_1_echo_shared_pixels total = %d  s resolve.num_lists = %d\n",
                    cnt_pixel_stack_rec_ptr(&resolve),resolve.num_lists);
                    pr_pixel_stack_rec_ptr(&resolve,0,1);)
             /*check_resolve_list(&resolve,&neigh_2d);*/

             err = solve_1_echo_shared_pixel_types(type_aves,num_type_aves,
                                         &neigh_2d,&resolve,NULL);
             PRT3(printf("after resolve_1 err = %d total = %d  s resolve.num_lists = %d\n",
                       err,cnt_pixel_stack_rec_ptr(&resolve),resolve.num_lists);)
/*
             if ((err == NO_ERROR) && (resolve.num_lists > 0))
                {TRACE(resolve_xys(&resolve,&neigh_2d,histo);)
                 if (option & INCOMPATIBLE_TYPE_BY_NEIGHBOR)
                    incompatible_pixels_by_neighbors(type_aves,num_type_aves,
                                     &neigh_2d,&resolve);
                   else 
                    incompatible_pixels_by_ave(type_aves,num_type_aves,
                                     &neigh_2d,&resolve);
                }
*/
            }
        }
     free_pixel_stack_rec_ptr(&resolve,1);
     if (err == NO_ERROR)
        {depth = find_num_bits_needed(num_types + 1);
         if ((err = SetupBuf2dRec(pixel_map,_2d->dimx,_2d->dimy,depth,0)) == NO_ERROR)
            {err = segment_pixel_map(pixel_map,&neigh_2d,NULL);
            }
         PRT4(if (err == NO_ERROR)
            {printf("cnt 0 = %d\n",CntValBuf2dRec(pixel_map,(double) 0));
             for (lcv = 0; lcv < num_types; lcv++)
               printf("type %d) total = %d\n",
                      lcv,CntValBuf2dRec(pixel_map,(double) (lcv+1)));
            })
        }
     if (neigh_2d.status4 & BUF_NON_EMPTY) free_neighbor_type_rec(&neigh_2d);
     free_buf_2d_rec(&neigh_2d);
     c_free(pix_neighs);
    }
 free_buf_2d_rec(&_2d_types);
 free_the_type_val_rec(&all);
 if (num_type_aves > 0) c_free(type_aves);
 if (err == NO_ERROR) pixel_map->status4 |= BUF_DATA_VALID;
 PRT2(printf("segment_1_echo_pixels..end.err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
setup_1_echo_histo_pixel_type_order - ???
--------------------------------------------------------------------------*/

int
setup_1_echo_histo_pixel_type_order(histo)
 struct histo_params_rec *histo;
{
 long lcv,histo_dimx,histo_dimy,pixel_depth;
 struct slice_roi_win_rec *slice_roi_win;
 long y1,y2,offset,height;
 char *str;
 int err;
 struct roi_rec *roi;

 slice_roi_win = (struct slice_roi_win_rec *) 
                       GetHistoSliceRoiWinRec(histo,HISTO_1D);
 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);
 height = 50;
 if (histo_dimy <= height)
    {y1 = 0;
     y2 = histo_dimy - 1;}
   else
    {y1 = 0;
     offset = 25;
     y2 = height;}

 for (lcv = 0; lcv < histo->num_types; lcv++)
    {if ((err = concat_strs(&str,2,histo->types[lcv].roi_label,".TYPE"))
                 != NO_ERROR)
        break;
     TRACE(printf("%d) str = %s...\n",lcv,str))
     if ((err = EnterPtsIntoSliceRoiRec(
             &(slice_roi_win->slice_roi),NULL,str,
             (unsigned int) DRAW_POLYGON,0,5, 
              (float) histo->types[lcv].ext_lb,(float) y1, 
              (float) histo->types[lcv].ext_ub,(float) y1, 
              (float) histo->types[lcv].ext_ub,(float) y2,  
              (float) histo->types[lcv].ext_lb,(float) y2,
              (float) histo->types[lcv].ext_lb,(float) y1)) != NO_ERROR)
        {c_free(str);
         break;}
     TRACE(printf("%d) str = %s...\n",lcv,str))
      if ((roi = get_roi(&(slice_roi_win->slice_roi),str)) == NULL)
         {c_free(str);
          return CANCEL;}
        else
         {roi->status |= HISTO_SEGMENTED_ROI;
          histo->types[lcv].segmented_roi_label = str;}
/*
      if ((err = add_str_to_strs_rec(&(histo->pixel_type_order),str)) != NO_ERROR)
         {break;}
*/
      if (histo_dimy > height)
         {y1 += offset;
          y2 = y1 + height;
          if (y2 >= histo_dimy)
             {y2 = histo_dimy - 1;
              offset = -25 - height;
              y1 = y2 - height;
              if (y1 < 0) y1 = 0;}
            else if (y1 < 0)
             {y1 = 0;
              offset = 25;
              y2 = height;}
          }
     }
 if (err != NO_ERROR)
    {DeleteRoisOfType(&(slice_roi_win->slice_roi),HISTO_SEGMENTED_ROI,1);
     free_strs_rec(&(histo->pixel_type_order));}
 TRACE(printf("setup_1_echo_histo_pixel_type_order...end\n"))
 return err;
}


/*--------------------------------------------------------------------------
setup_pixel_type_order - ???
--------------------------------------------------------------------------*/

int
setup_pixel_type_order(pixel_type,histo)
 struct pixel_type_rec *pixel_type;
 struct histo_params_rec *histo;
{
 int err;

 pixel_type->status &= ~PIXEL_TYPE_DEFINED;
 pixel_type->status &= ~PIXEL_TYPE_AND_ANALYSIS_RELATED;
 str_dealloc_and_cpy(&(pixel_type->slice_map_data_creation_date),
                     current_asctime());
 free_strs_rec(&(pixel_type->order));
 if ((err = cp_strs_rec(&(pixel_type->order),&(histo->pixel_type_order))) ==
          NO_ERROR)
    pixel_type->status |= PIXEL_TYPE_DEFINED | PIXEL_TYPE_3D_REDEFINED |
                    HISTO_AND_PIXEL_TYPE_RELATED;
   else free_strs_rec(&(pixel_type->order));

 return err;
}


/*--------------------------------------------------------------------------
setup_pixel_type_maps - ???
--------------------------------------------------------------------------*/

int
setup_pixel_type_maps(pixel_type,num_slice_maps)
 struct pixel_type_rec *pixel_type; 
 unsigned long num_slice_maps;
{
 int err;
 unsigned long lcv,total,temp;

 if (pixel_type->total_slice_maps < num_slice_maps)
    {total = num_slice_maps - pixel_type->total_slice_maps;
     temp = pixel_type->total_slice_maps;
     if ((err = get_handle(&(pixel_type->slice_maps),
          &(pixel_type->total_slice_maps),
          (unsigned long) total,
          (size_t) sizeof(**(pixel_type->slice_maps)))) != NO_ERROR)
        return err;
     for (lcv = temp; lcv < pixel_type->total_slice_maps; lcv++)
        init_buf_2d_rec(pixel_type->slice_maps[lcv]);
    }
 pixel_type->num_slice_maps = num_slice_maps;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
setup_segment_1_echo - ???
--------------------------------------------------------------------------*/

int
setup_segment_1_echo(histo,pixel_type,priority,num_slice_maps)
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct strs_rec *priority;
 unsigned long num_slice_maps;
{
 int err;
 long histo_dimx,histo_dimy,pixel_depth;
 struct slice_roi_win_rec *slice_roi_win;

 TRACE(printf("setup_segment_1_echo...%d\n",pixel_type->num_slice_maps))
 if (((err = SetupHistoPixelTypeOrder(histo,priority,0,NULL,NULL,
                        HISTO_1D)) != NO_ERROR) ||
     ((err = setup_pixel_type_maps(pixel_type,num_slice_maps)) != NO_ERROR))
    return err;

 TRACE(printf("setup_segment_1_echo...1\n"))
 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);
 slice_roi_win = (struct slice_roi_win_rec *) 
            GetHistoSliceRoiWinRec(histo,HISTO_1D);
 free_histo_pixel_tissue_type_rec(histo);
 if ((err = setup_segment_rois(&(histo->types),&(histo->total_types),
           &(histo->num_types),&(histo->pixel_type_order),
           &(slice_roi_win->slice_roi),1,0,histo_dimx - 1)) == NO_ERROR)
    {PRT1(printf("setup_segment_1_echo...\n"))
     if ((err = setup_1_echo_histo_pixel_type_order(histo)) == NO_ERROR)
        {PRT1(printf("setup_segment_1_echo setup_pixel_type_order...1\n"))
         err = setup_pixel_type_order(pixel_type,histo);}
    }
 PRT1(printf("setup_segment_1_echo...end err = %d\n",err))
 return err;
}
