/****************************************************************************
win_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: win_menu.c,v 1.14 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/notify.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)




/* Functions defined in this file */
void magnify_pixel_option_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
Menu setup_magnify_pixel_menu(void);
void magnify_pixel_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int msg_only_for_2d_window(struct image_display_window *win);
void all_echo_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void get_new_win_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void duplicate_win_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void slave_win_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void the_project_wins_proc(struct display_win_rec *win,
    int num_projected_wins, int num_echoes);
void project_all_echoe_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int value);
void project_1_echoe_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int value);
int change_window_channel(struct image_display_window *win,
    struct display_win_rec *dwin);
int change_channel(struct display_win_rec *dwin, int indx);
static int wid_channel_action_proc(struct display_win_rec *dwin, char *wid);
int change_window_channel_proc(struct display_win_rec *dwin, Xv_Window window,
    Event *event);
void show_window_channel_menu(struct show_menu_rec *show_menu, int which);
void get_channel_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void image_histogram_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void make_window_cur_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void win_stack_slice_or_scan_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void close_win_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void close_stack_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void close_file_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void open_win_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void open_stack_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void open_file_wins_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int win_exit_cur_win(struct display_win_rec *win, int which);
void win_exit_cur_win_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int win_exit(struct image_display_window *win, int which);
void win_exit_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
void win_stack_exit(struct image_display_window *win, int which);
void win_stack_exit_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);



/*--------------------------------------------------------------------------
magnify_pixel_option_proc - ???
--------------------------------------------------------------------------*/

void 
magnify_pixel_option_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 long x,y;
 int center_win,err,value;
 int mag_fac;
 struct int_region_rect dim;
 Menu root;

 PRT1(printf("magnify_pixel_option_proc...\n"))

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     if (event_meta_is_down(last_event) && event_is_button(last_event))
        {
         if (event_middle_is_down(last_event)) value = MAGNIFY_WIN;
           else if (event_right_is_down(last_event)) value = MAGNIFY_SHRINK_WIN;
           else return;
        }
       else value = option;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);
    }
     
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;
 if (last_event != NULL)
    {if (menu == 0)
        {if ((err = dwin_get_coord_xy_from_event(win1,last_event,&x,&y))
               != NO_ERROR)
            return;}
       else
        {x = (win1->screen.dimension.bound.left + 
              win1->screen.dimension.bound.right) / 2;
         y = (win1->screen.dimension.bound.top + 
              win1->screen.dimension.bound.bottom) / 2;}
     center_win = 1;}
   else center_win = 0;

 TRACE(printf("MAGNIFY_...value = %d  mag = %d pixel.mask.dimx = %d  MAX_MAGNIFY_PIXEL_DIM= %d\n",value,win->dwin->screen.dimension.magrect.left,
      win->dwin->screen.pixel.mask.dimx,MAX_MAGNIFY_PIXEL_DIM))
 if ((value > 0) && (value <= MAX_MAGNIFY_PIXEL_DIM))
    {mag_fac = value;
     value = MAGNIFY_WIN;
    }
   else if (value == MAGNIFY_WIN)
    {mag_fac = win->dwin->screen.dimension.magrect.left + 1;
     if (mag_fac > MAX_MAGNIFY_PIXEL_DIM) mag_fac = MAX_MAGNIFY_PIXEL_DIM;}

 TRACE(printf("MAGNIFY_...value = %d  mag = %d pixel.mask.dimx = %d  MAX_MAGNIFY_PIXEL_DIM= %d\n",value,win->dwin->screen.dimension.magrect.left,
      win->dwin->screen.pixel.mask.dimx,MAX_MAGNIFY_PIXEL_DIM))

 switch (value)
    {case MAGNIFY_WIN :
        if ((menu == 0) || (win->control.which_cursor == CURSOR_MAGNIFY_PLUS))
           err = WinSetupMagnifyWindow(win,mag_fac,mag_fac,0,center_win,x,y);
        win_select_cursor(win,CURSOR_MAGNIFY_PLUS);
        break;
     case MAGNIFY_SHRINK_WIN :
        TRACE(printf("MAGNIFY_SHRINK_WIN...\n"))
        if ((menu == 0) || (win->control.which_cursor == CURSOR_MAGNIFY_MINUS))
           {mag_fac = (long) win->dwin->screen.dimension.magrect.left - 1;
            if (mag_fac <= 0) mag_fac = 1;
            err = WinSetupMagnifyWindow(win,mag_fac,mag_fac,0,center_win,x,y);
           }
        win_select_cursor(win,CURSOR_MAGNIFY_MINUS);
        break;
     case MAGNIFY_LAST_DIM :
        TRACE(printf("MAGNIFY_LAST_DIM...\n"))
        swap_screen_dimension(&(win1->screen.dimension),
                              &(win1->screen.last_dimension));
        if ((win1->screen.last_pixel.mask.status4 & BUF_NON_EMPTY) &&
            (win1->screen.last_pixel.mask.dimx == 
                  win1->screen.dimension.magrect.left) &&
            (win1->screen.last_pixel.mask.dimy == 
                  win1->screen.dimension.magrect.top))
           swap_pixel_desc_rec(&(win1->screen.pixel),&(win1->screen.last_pixel));
          else if ((err = setup_screen_pixel_desc_rec1(&(win1->screen.pixel),
              &(win1->screen.last_pixel),win1->screen.dimension.magrect.left,
               win1->screen.dimension.magrect.top)) != NO_ERROR)
           return;
        if (center_win)
           if (!(is_pt_in_int_region_rect(
                   &(win->dwin->screen.dimension),x,y))) center_win = 0;
        err = redisplay_cur_win(win,center_win,x,y,1);
        break;
     case MAGNIFY_DEFAULT_DIM :
        PRT3(printf("MAGNIFY_DEFAULT_DIM...\n"))

        win1->screen.last_dimension = win1->screen.dimension;
        win1->screen.dimension = win1->screen.def_dimension;
        PRT3(printf("def_dimension...\n"))
        PRT3(pr_int_region_rect(&(win1->screen.def_dimension)))

        setup_screen_dimension(&(win->dwin->screen.dimension),
            &dim,
            &(win->dwin->screen.pixel),&(win->dwin->screen.last_pixel),
            0,DIM_OPR_SAME_DIM_MAG_FACTOR,0,0);

        err = redisplay_cur_win(win,0,0,0,1);
        PRT3(printf("MAGNIFY_DEFAULT_DIM dimension...\n"))
        PRT3(pr_int_region_rect(&(win1->screen.dimension)))
        break;
    }
 return;
}


/*--------------------------------------------------------------------------
setup_magnify_pixel_menu - ???

FIXME:  Thus function used to have an argument select which was never used,
either by the definition or the callers.  I have removed it.  -PWH 19990607
--------------------------------------------------------------------------*/

Menu 
setup_magnify_pixel_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_NOTIFY_PROC,magnify_pixel_option_proc,
                       MENU_STRING_ITEM,MAGNIFY_WINDOW,
                           (int) MAGNIFY_WIN,
                       MENU_STRING_ITEM,MAGNIFY_SHRINK_WINDOW,
                           (int) MAGNIFY_SHRINK_WIN,
                       MENU_STRING_ITEM,MAGNIFY_LAST_WINDOW,
                           (int) MAGNIFY_LAST_DIM,
                       MENU_STRING_ITEM,MAGNIFY_DEFAULT_WINDOW,
                           (int) MAGNIFY_DEFAULT_DIM,
                       0);
 return menu;
}


/*--------------------------------------------------------------------------
magnify_pixel_proc - ???
--------------------------------------------------------------------------*/

void 
magnify_pixel_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 enter_magnify_pixel(win,1);

}


/*--------------------------------------------------------------------------
msg_only_for_2d_window - ???
--------------------------------------------------------------------------*/

int
msg_only_for_2d_window(win)
 struct image_display_window *win;
{
 ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,2,
         "This command only works",
         "    for the 2D window !!!",NULL,0);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
all_echo_wins_proc - ???
--------------------------------------------------------------------------*/

void 
all_echo_wins_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 int err;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win1->owner->dwin = win1;
 win = win1->owner;
 win->dwin = win1;
 if (win->type2 & DISPLAY_WINDOW_3D)
    {ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,2,
         "This future version will implement this command",
         "    for the 3D window !!!",NULL,0);
     return;}

 set_win_busy(win);
 if (win->type2 & HISTOGRAM_WINDOW)
    NewWin(win,DISPLAY_WINDOW,0,0,0,0,0,0,NULL);
   else if ((err = win_all_win_echoes_exist(win)) == NO_ERROR)
    win_execute_proc_to_partner_wins(win,win_multiple_win_top,0,0);
 set_win_not_busy(win);
}


/*--------------------------------------------------------------------------
get_new_win_proc - ???
--------------------------------------------------------------------------*/

void 
get_new_win_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win1->owner->dwin = win1;
 PRT(printf("get_new_win_proc...\n"))
 set_win_busy(win1->owner);
 win_cur_scale_is_default(win1->owner);

 if (win1->owner->type2 & DISPLAY_WINDOW_3D)
    win_new_3d_win(win1->owner,NULL);
   else NewWin(win1->owner,DISPLAY_WINDOW,0,0,0,0,0,0,NULL);
 set_win_not_busy(win1->owner);
 PRT(printf("get_new_win_proc...end\n"))
}


/*--------------------------------------------------------------------------
duplicate_win_proc - ???
--------------------------------------------------------------------------*/

void 
duplicate_win_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;

 set_win_busy(win);
 win_cur_scale_is_default(win);
 WinSetupMagnifyWindow(win,
       win->dwin->screen.pixel.mask.dimx,
       win->dwin->screen.pixel.mask.dimy,1,0,0,0);
 win->dwin = win1;
 set_win_not_busy(win);
}


/*--------------------------------------------------------------------------
slave_win_proc - ???
--------------------------------------------------------------------------*/

void 
slave_win_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 long x,y;
 int err;

 PRT1(printf("slave_win_proc...1\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     if (last_event != NULL)
        {if ((err = dwin_get_coord_xy_from_event(win1,last_event,&x,&y))
               != NO_ERROR)
            return;}
       else
        {x = (win1->screen.dimension.bound.left + 
              win1->screen.dimension.bound.right) / 2;
         y = (win1->screen.dimension.bound.top + 
              win1->screen.dimension.bound.bottom) / 2;}
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     x = (win1->screen.dimension.bound.left + 
              win1->screen.dimension.bound.right) / 2;
     y = (win1->screen.dimension.bound.top + 
              win1->screen.dimension.bound.bottom) / 2;
    }
 win = win1->owner;
 if ((win->dwin->status2 & MASTER_WINDOW) && (win->dwin->slave == NULL))
    {
     PRT1(printf("slave_win_proc...2\n"))
     set_win_busy(win);
     err = WinSetupMagnifyWindow(win,5,5,2,1,x,y);
     win->dwin = win1;
     set_win_not_busy(win);
    }
   else win_master_slave_mouse_xy(win,x,y);
 return;
}


/*--------------------------------------------------------------------------
the_project_wins_proc - ???
--------------------------------------------------------------------------*/

void
the_project_wins_proc(win,num_projected_wins,num_echoes)
 struct display_win_rec *win;
 int num_projected_wins,num_echoes;
{
 Rect *rr;
 struct int_rect_rec projected_rect;
 unsigned short type2;

 TRACE(printf("the_project_wins_proc...\n"))
 rr = (Rect *) xv_get(win->frame,WIN_SCREEN_RECT);
 Rect_to_int_rect_rec(rr,&projected_rect);
 xv_set(win->frame,FRAME_BUSY,TRUE,0);
 TRACE(printf("the_project_wins_proc...1\n"))
 if (win->owner->type2 & HISTOGRAM_WINDOW)
    {if (win->owner->type2 & (HISTO_2D_WINDOW | HISTOGRAM_MULTI_D_WINDOW))
        type2 = HISTO_2D_WINDOW;
       else type2 = HISTO_1D_WINDOW;
    }
   else type2 = DISPLAY_WINDOW;
 win_cur_scale_is_default(win->owner);
 ProjectWins(win->owner,&projected_rect,num_projected_wins,num_echoes,type2);
 TRACE(printf("the_project_wins_proc...2\n"))
 xv_set(win->frame,FRAME_BUSY,FALSE,0);
}


/*--------------------------------------------------------------------------
project_all_echoe_wins_proc - ???
--------------------------------------------------------------------------*/

void 
project_all_echoe_wins_proc(menu,item,arg,window,last_event,value)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int value;
{
 struct display_win_rec *win1;
 int num_projected_wins;
 struct img_buf_rec *img;
 char str[60];
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     num_projected_wins = value;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     num_projected_wins = (int) xv_get(item,MENU_CLIENT_DATA);
    }
 if ((img = win_rec_cur_img_buf(win1->owner->owner)) == NULL) return;
 win1->owner->dwin = win1;
 if (win1->owner->type2 & DISPLAY_WINDOW_3D) {
      msg_only_for_2d_window(win1->owner);
      return; }
 sprintf(str,"Computing %-d %-d-echo windows before display...",num_projected_wins,
           img->file->hdr.data_info.num_echoes);
 ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
               str,PLEASE_WAIT,the_project_wins_proc,3,
               win1,num_projected_wins,
               (unsigned long) img->file->hdr.data_info.num_echoes);
}


/*--------------------------------------------------------------------------
project_1_echoe_wins_proc - ???
--------------------------------------------------------------------------*/

void 
project_1_echoe_wins_proc(menu,item,arg,window,last_event,value)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int value;
{
 struct display_win_rec *win1;
 int num_projected_wins,num_echoes;
 char str[60];
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     num_projected_wins = value;
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     num_projected_wins = (int) xv_get(item,MENU_CLIENT_DATA);}
 num_echoes = 1;
 win1->owner->dwin = win1;
 if (win1->owner->type2 & DISPLAY_WINDOW_3D) {
     msg_only_for_2d_window(win1->owner);
     return; }
 sprintf(str,"Computing %-d 1-echo windows before display...",num_projected_wins);
 ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
               str,PLEASE_WAIT,the_project_wins_proc,3,
               win1,num_projected_wins,num_echoes);
/*
 show_menu.win = win1;
 show_menu.num = num_projected_wins;
 show_menu.arg1 = num_echoes;
 (void) notify_set_itimer_func((Notify_client) &show_menu,
             (Notify_func) the_project_wins_proc,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
*/
}


/*--------------------------------------------------------------------------
change_window_channel - ???
--------------------------------------------------------------------------*/

int
change_window_channel(win,dwin)
 struct image_display_window *win;
 struct display_win_rec *dwin;
{
 int err;
 struct image_display_window *owner;
 char *label;
 unsigned long dimx,dimy;

 owner = dwin->owner;
 if ((win == dwin->owner) || (win == NULL)) return NO_ERROR;
 if ((err = WinColorDataDims(win,&dimx,&dimy,NULL)) != NO_ERROR) return err;

 DropHandleAryPtr(&(dwin->owner->dwins),&(dwin->owner->num_display_wins),
                         dwin);
 drop_dwin_from_master_slave_relationship(dwin);

 if ((err = add_handle_element(&(win->dwins),&(win->num_display_wins),dwin))
         != NO_ERROR) return err;
 dwin->owner = win;

 if (win->num_display_wins > 1)
    {add_master_slave_relationship(win->dwin,dwin);
     copy_select_slice_win(&(dwin->select_slice),&(win->dwin->select_slice),
                dwin);}

 win->dwin = dwin;
 if ((dwin->screen.dimension.limitboundrect.width != dimx) ||
     (dwin->screen.dimension.limitboundrect.height != dimy))
    {
     /* Added the argument '&(dwin->screen.dimension.limitrr)' below
	for consistency with the called function. -PWH 19990315 */
     init_dimension(&(dwin->screen.dimension),
	  &(dwin->screen.dimension.limitrr),
          &(dwin->screen.dimension.rr),
	  &(dwin->screen.dimension.magrect),
          &(dwin->screen.dimension.limitboundrect),
          &(dwin->screen.dimension.bound));

     WinSetupMagnifyWindow(win,20,20,0,1,
           dwin->screen.dimension.limitboundrect.width / 2,
           dwin->screen.dimension.limitboundrect.height / 2);
    }
 label = WinRecGetWid(win->owner,win->type2);
 set_icon_label(win->dwin->frame,label);
 update_cur_slice_num(win);

 if ((err = WinNewColorScreen(win)) != NO_ERROR) 
    delete_dwin(win->dwin);
   else WinCanvas(win,1);
 win_set_frame_label(win);

 return err;
}


/*--------------------------------------------------------------------------
change_channel - ???
--------------------------------------------------------------------------*/

int
change_channel(dwin,indx)
 struct display_win_rec *dwin;
 int indx;
{
 static struct strs_rec wids;
 struct win_rec *winrec;
 int err;

 init_strs_rec(&wids);
 if ((err = get_win_list_wids(dwin->owner,&wids)) == NO_ERROR)
    {if (indx < wids.num_strs)
        if ((winrec = get_win_rec_by_wid_str(dwin->owner->owner,
                     wids.strs[indx])) != NULL)
           err = change_window_channel(winrec->image_display,dwin);
     free_strs_rec(&wids);
    }
 return err;
}


/*--------------------------------------------------------------------------
wid_channel_action_proc - ???

FIXME:  Sometimes fails to return a value.
--------------------------------------------------------------------------*/

static int
wid_channel_action_proc(dwin,wid)
 struct display_win_rec *dwin;
 char *wid;
{
 struct win_rec *winrec;

 if (wid != NULL) 
    {
     if ((winrec = get_win_rec_by_wid_str(dwin->owner->owner,wid)) != NULL)
        return change_window_channel(winrec->image_display,dwin);
    }
}


/*--------------------------------------------------------------------------
change_window_channel_proc - ???
--------------------------------------------------------------------------*/

int
change_window_channel_proc(dwin,window,event)
 struct display_win_rec *dwin;
 Xv_Window window;
 Event *event;
{
 struct strs_rec *wids;
 int err,lcv;
 char *str,str2[10];
 static char keys[] = {13,14,15,10,11,12,7,8,9,4,5,6,1,2,3};

 TRACE(printf("change_window_channel_proc...\n"))
 if ((err = setup_strs_rec(&wids,0,0)) != NO_ERROR) return err;
 if ((err = get_win_list_wids(dwin->owner,wids)) == NO_ERROR)
    {
     for (lcv = 0; (lcv < wids->num_strs) && (lcv < 15); lcv++)
        {sprintf(str2,"<> <R%d>",(int) keys[lcv]);
         if ((err = concat_strs(&str,2,wids->strs[lcv],str2)) != NO_ERROR)
            break;
         c_free(wids->strs[lcv]);
         wids->strs[lcv] = str;
        }
     ShowMenuStrsProc(window,event,"Group : CHANNEL TO",wids,
		      USER_MENU_FREE_STRS_AND_PTR,
		      wid_channel_action_proc,dwin,1,0,0);
    }
   else
    {free_strs_rec(wids);
     c_free(wids);}
 TRACE(printf("change_window_channel_proc..emd\n"))
 return err;
}


/*--------------------------------------------------------------------------
show_window_channel_menu - ???
--------------------------------------------------------------------------*/

void
show_window_channel_menu(show_menu,which)
 struct show_menu_rec *show_menu;
 int which;
{

 (void) notify_set_itimer_func((Notify_client) show_menu,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 change_window_channel_proc(show_menu->win,show_menu->window,
              &(show_menu->event));

}


/*--------------------------------------------------------------------------
get_channel_menu_proc - ???
--------------------------------------------------------------------------*/

void
get_channel_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 static struct show_menu_rec show_menu;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     window = win1->frame;}
 win = win1->owner;
 win->dwin = win1;
 show_menu.win = win1;
 show_menu.window = window;
 show_menu.event = *last_event;
 (void) notify_set_itimer_func((Notify_client) &show_menu,
             (Notify_func) show_window_channel_menu,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
}


/*--------------------------------------------------------------------------
image_histogram_proc - ???
--------------------------------------------------------------------------*/

void 
image_histogram_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 struct img_buf_rec *img;
 Menu root;
 unsigned long histo_dimx,histo_dimy,pixel_depth;

 PRT1(printf("image_histogram_proc...\n"))
 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
      window = dwin->frame;
     }
 win = dwin->owner;
 win->dwin = dwin;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;

 set_win_busy(win);
 get_histo_dim(&(img->file->histo_params),&histo_dimx,&histo_dimy,&pixel_depth,0);
 if ((win->type2 & HISTO_2D_WINDOW) ||
     ((win->type2 & HISTO_1D_WINDOW) && (img->file->hdr.data_info.num_echoes == 2)))
     NewWin(win,HISTO_2D_WINDOW,1,histo_dimx,histo_dimy,pixel_depth,0,
               IMG_HISTO_AUTO_SET | IMG_HISTO_INITIALIZE_BUF,NULL);
   else NewWin(win,HISTO_1D_WINDOW,1,histo_dimx,histo_dimy,pixel_depth,0,
               IMG_HISTO_AUTO_SET | IMG_HISTO_INITIALIZE_BUF,NULL);
 set_win_not_busy(win);
}


/*--------------------------------------------------------------------------
make_window_cur_proc - ???
--------------------------------------------------------------------------*/

void 
make_window_cur_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;
 struct strs_rec *wids,fns;
 int err;
 struct img_buf_rec *img;

 PRT1(printf("make_window_cur_proc...\n"))
 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
      window = dwin->frame;
     }
 win = dwin->owner;
 win->dwin = dwin;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 init_strs_rec(&fns);
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    {if (((err = AllWids(win->owner,wids,1,1,MANY_SLICES_WINDOWS)) 
               == NO_ERROR) &&
         ((err = WinWidFiles(win,wids,NULL)) == NO_ERROR) &&
         ((err = AllFiles(img->file,&fns,1,1)) == NO_ERROR) &&
         ((err = append_strs_rec(wids,&fns)) == NO_ERROR))
        {ShowMenuStrsProc(window,NULL,MAKE_WINDOW_CURRENT,
			  wids,USER_MENU_FREE_STRS_AND_PTR,
			  win_make_window_cur,win,1,0,0);
        }
       else 
        {free_strs_rec(wids);
         c_free(wids);}
    }
 free_strs_rec(&fns);
 if (err != NO_ERROR)
    ShowMsgStrs(dwin->frame,1,err,1,1,
                         "Sorry...ERROR !!!",NULL,0);

}



/*--------------------------------------------------------------------------
win_stack_slice_or_scan_proc - ???
--------------------------------------------------------------------------*/

void 
win_stack_slice_or_scan_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *dwin;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {dwin = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         dwin = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
      window = dwin->frame;
     }
 win = dwin->owner;
 win->dwin = dwin;
 WinStackSliceOrScan(win);
}


/*--------------------------------------------------------------------------
close_win_proc - ???
--------------------------------------------------------------------------*/

void
close_win_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_close_multiple_windows(win);

}


/*--------------------------------------------------------------------------
close_stack_wins_proc - ???
--------------------------------------------------------------------------*/

void
close_stack_wins_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_close_stack_windows(win);

}


/*--------------------------------------------------------------------------
close_file_wins_proc - ???
--------------------------------------------------------------------------*/

void
close_file_wins_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_close_file_windows(win);

}


/*--------------------------------------------------------------------------
open_win_proc - ???
--------------------------------------------------------------------------*/

void
open_win_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_show_multiple_windows(win);

}


/*--------------------------------------------------------------------------
open_stack_wins_proc - ???
--------------------------------------------------------------------------*/

void
open_stack_wins_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_show_stack_windows(win);

}


/*--------------------------------------------------------------------------
open_file_wins_proc - ???
--------------------------------------------------------------------------*/

void
open_file_wins_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 win_show_file_windows(win);

}


/*--------------------------------------------------------------------------
win_exit_cur_win - ???
--------------------------------------------------------------------------*/

int
win_exit_cur_win(win,which)
 struct display_win_rec *win;
 int which;
{
 int err;

 (void) notify_set_itimer_func((Notify_client) win,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 err = win_done_it_proc(win->frame);
 PRT2(printf("win_exit_cur_win err = %d\n",err);)
 return XV_OK;
}


/*--------------------------------------------------------------------------
win_exit_cur_win_proc - ???
--------------------------------------------------------------------------*/

void 
win_exit_cur_win_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 (void) notify_set_itimer_func((Notify_client) win1,
             (Notify_func) win_exit_cur_win,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
}


/*--------------------------------------------------------------------------
win_exit - ???
--------------------------------------------------------------------------*/

int
win_exit(win,which)
 struct image_display_window *win;
 int which;
{
 (void) notify_set_itimer_func((Notify_client) win,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 return win_delete_multiple_wins(win);
}


/*--------------------------------------------------------------------------
win_exit_proc - ???
--------------------------------------------------------------------------*/

void 
win_exit_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 (void) notify_set_itimer_func((Notify_client) win1->owner,
             (Notify_func) win_exit,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);

}


/*--------------------------------------------------------------------------
win_stack_exit - ???
--------------------------------------------------------------------------*/

void
win_stack_exit(win,which)
 struct image_display_window *win;
 int which;
{
 (void) notify_set_itimer_func((Notify_client) win,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 win_delete_multiple_wins_in_list(win);
}


/*--------------------------------------------------------------------------
win_stack_exit_proc - ???
--------------------------------------------------------------------------*/

void 
win_stack_exit_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 (void) notify_set_itimer_func((Notify_client) win1->owner,
             (Notify_func) win_stack_exit,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
}
