/****************************************************************************
new_anz2uc.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This source file is apparently never used.  -PWH 19990430
****************************************************************************/

static const char rcsid[] = "$Id: new_anz2uc.c,v 1.4 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

/*
  --------------------------------------------------------------------
  cc -o new_anz2uc new_anz2uc.c imagio.o -lm
  ---------------------------------------------------------------------
  */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "imagio.h"
#include "pet_hdr.h"


#define NO_ERROR 0
#define READ_ERROR -1
#define FILE_ACCESS_ERROR -3
#define READ_ERROR -1
#define WRITE_ERROR -2
#define END_OF_FILE -6


struct makr_hdr_key
   {int size;
    char data_type[10];
    char name[18];
    int extents;
    short int session_error;
    char regular;
    char hkey_un0;
   };


#define _1_ECHO_IMAGE 0x0001
#define _2_ECHO_IMAGE 0x0002
#define _2_ECHO_INDIVIDUAL_MIN_MAX 0x1000
struct mark_hdr_dimension
   {
    unsigned short int num_dims;
    unsigned short int dimx,dimy;
    unsigned short max_slices;
    unsigned short int num_vols;
    unsigned short int histo_dimx,histo_dimy;

    unsigned short status;
    unsigned short unused_ints[8];
    short int pixel_depth_bits;
    short int unused;

    float unused_f;
    float xpixel_size,ypixel_size;
    float pixel_thickness;
    float spacing;
    short plane_type;  /* change */
          /* -1 = unknown,0 = axial, 1 = sagittal, 2 = coronal, 3 = oblique */
    short pulse_sequence;  /* 0 = spin echo,  1 = inversion recovery
                              2 = multiple echo, 3 = partial saturation */
    short orientation;     /* 0 = supine,  1 = prone,  2 = decubitus left
                              3 = decubitus right */
    short position;        /* 0 = head first,  1 = feet first */
          
    short num_echoes;
    short flip_angle;
    short scan_dimx;
    short scan_dimy;

    float field_of_view;
    float num_excitations;
    float tr;    /* repetition/Recovery time */
    char te[12];    /* echo delay */
    float unused_floats[1];
    int glmax,glmin;
   };


struct mark_patient_rec
    {char name[63];
     char ssnum[12];
     char patient_id[12];  /* medical record# */
     char study_num[8];    /* study # */
     char patient_num[8];  /* patient # */
     char sex;
     int age;
     int height; /* in mm */
     int weight; /* in grams */
    };


struct mark_hdr_history 
   {struct mark_patient_rec patient;
    char date_of_study[12];
    char time_of_study[12];
    char comment[60];
   };

struct mark_hdr
   {struct makr_hdr_key key;
    struct mark_hdr_dimension dimen;
    struct mark_hdr_history history;
   };

/***********
struct hdr_key
   {int size;
    char data_type[10];
    char name[18];
    int extents;
    short int session_error;
    char regular;
    char hkey_un0;
   };

struct hdr_dimension
   {
    unsigned short int num_dims;
    unsigned short int dimx,dimy;
    unsigned short max_slices;
    unsigned short int num_vols;
    unsigned short int histo_dimx,histo_dimy;

    unsigned short int unused_ints[9];
    short int pixel_depth_bits;
    short int unused;

    float unused_f;
    float xpixel_size,ypixel_size;
    float pixel_thickness;
    float unused_floats[12];
    int glmax,glmin;
   };

struct hdr_history 
   {char dummy[200];};

struct hdr_info_rec
   {struct hdr_key key;
    struct hdr_dimension dimen;
    struct hdr_history history;
   };
******************/


/*-------------------------------------------------------------------------
frd - ???

  frd = no error
       READ_ERROR
       END_OF_FILE
-------------------------------------------------------------------------*/

int 
frd(buf,item_size,num_items,fid,amt_read)
 unsigned char *buf;
 size_t item_size;
 size_t num_items;
 FILE *fid;
 size_t *amt_read;
{
 size_t len1,len,size;
 char enter;

 len1 = num_items * item_size;
 *amt_read = 0;
 if (len1 == 0) return NO_ERROR;
 for (enter = 0,len = len1; ;len -= size)
    {size = fread(&(buf[*amt_read]),(size_t) 1,len,fid);
     *amt_read += size;
     if ((size == 0) || (size == len)) break;
     enter = 1;}
 if (size == 0)
    {if (enter > 0) return END_OF_FILE;
     return READ_ERROR;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
get_file_size_by_fileno - ???
-------------------------------------------------------------------------*/

unsigned int         /* FIXME:  Change to size_t?  -PWH 19990430 */
get_file_size_by_fileno(fnum,err)
 int fnum;
 int *err;
{
 struct stat buf;

 *err = fstat(fnum,&buf);
 if (*err == 0)
     return (unsigned int) buf.st_size;
 else
     return (unsigned int) 0;
}


/*-------------------------------------------------------------------------
file_size - ???
-------------------------------------------------------------------------*/

int 
file_size(fid,err)
 FILE *fid;
 int *err;
{
 int fnum;

 fflush(fid);
 fnum = fileno(fid);
 return get_file_size_by_fileno(fnum,err);


}


/*-------------------------------------------------------------------------
load_hdr_file - ???
-------------------------------------------------------------------------*/

int
load_hdr_file(fn,db)
 char *fn;
 struct hdr_info_rec *db;
{
 FILE *fid;
 int err;

 TRACE(printf("load_file_proc...\n"))

 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;

 if (fread(db,sizeof(struct hdr_info_rec),1,fid) != 1)
    {
     fclose(fid);
     printf("%s is a BAD DATA %s FILE !!!",fn);
     return READ_ERROR;}
 fclose(fid);
 return NO_ERROR;
}



/*-------------------------------------------------------------------------
put_mri_images_into_pet_file - ???
-------------------------------------------------------------------------*/

int
put_mri_images_into_pet_file(fn,mri_fid,image,offset,num_slices,spacing)
 char *fn;
 FILE *mri_fid;
 unsigned char *image;
 long offset;
 unsigned int num_slices,spacing;
{
 struct pet_mhdr mh;
 struct pet_sbhdr sh;
 int	fdout,err,image_type,byte_scl,mode,type;
 int	phs = 0;	/* Phase number.		*/
 int	frm = 1;	/* Frame number. 		*/
 size_t len1,amt_read;
 int cnt_slice,reverse_slice_num;

 mode = O_RDWR;
 fdout = filcre(fn,&mode);
 if (fdout <= 0) 
    {
     printf("\n\nOpening output file = %s\n",fn);
     printf("Error opening %s\n",fn);
     return FILE_ACCESS_ERROR;}

 mh.slcsep = 0;
 mh.dmax = 256;
 if (wrmhdr(&fdout,&mh) != NULL)
    {printf("Error in wrmhdr.\n");
     return WRITE_ERROR;
    }
 printf("\n\nwriting to output file = %s\n",fn);

 sh.xdim = XDIM;
 sh.ydim = YDIM;
 len1 = IMG_SIZE;

 for(cnt_slice = 0; cnt_slice < num_slices; cnt_slice++)
    {
     if ((err = frd(image,(size_t) len1,(size_t) 1,
                  mri_fid,&amt_read)) != NO_ERROR)
        if (err == READ_ERROR)
    	   {printf("READ Error occurred while reading slice #%d.\n",cnt_slice);
            break;
           }
          else
	   {printf("Reading Error : End of file encountered.\n");
    	    printf("Error occurred while reading slice #%d.\n",cnt_slice);
            break;}

     reverse_slice_num = (num_slices - cnt_slice - 1) * spacing + 1;

     printf("Converting slice #%d --- becoming pet slice #%d\n",cnt_slice + 1,
                 reverse_slice_num);

     sh.slcnum = reverse_slice_num;
     sh.magfac = 1.;
     sh.datype = BYTE_IMG;
     type = IMAGE_SLC;
     image_type = BYTE_IMG;
     byte_scl = NO_SCL;
     if ((err = wrimg(&fdout,&reverse_slice_num,&phs,&frm,image,
			&image_type,&byte_scl,&sh,&type)) < 0)
           {
            printf("WRITE ERROR to the pet file...\n");
	    break;
	   }
     if (cnt_slice < (num_slices - 1)) fseek(mri_fid,offset,1);
    }
 filclose(fdout);
 return err;
}


/*-------------------------------------------------------------------------
prog_usage - ???
-------------------------------------------------------------------------*/

void
prog_usage(argc,argv)
 int	argc;
 char	*argv[];
{
  if (argc != 4)
    {
     printf(
       "Usage: %s mri_input_hdr_file mri_input_img_file pet_output_img_file\n",
       argv[0]);
     printf("Example 1 : %s mri10121a.hdr mri10121a.img pet \n",argv[0]);
     printf("   Result : a) input  = mri10121a.hdr\n");
     printf("            b) input  = mri10121a.img\n");
     printf("            c) output = pet.pr.*\n");
     printf("            d) output = pet.t2.*\n");
     printf("\n\n");
     exit(0);}
}


/*-------------------------------------------------------------------------
main - ???
-------------------------------------------------------------------------*/

#define XDIM 256
#define YDIM 256
#define IMG_SIZE (256 * 256)

void
main(argc,argv)
 int	argc;
 char	*argv[];
{
 FILE	*fid;		/* File designation.		*/	
 unsigned char	image[IMG_SIZE];
 int num_slices,total_slices;
 char outfn[256];
 int err,size,spacing;

 struct hdr_info_rec mri_hdr;

 prog_usage(argc,argv);
 if (load_hdr_file(argv[1],&mri_hdr) != NO_ERROR)
    {printf("an error occurred when the mri .hdr file is read...\n");
     exit(0);}
 spacing = irint((double) (mri_hdr.dimen.pixel_thickness /
                     mri_hdr.dimen.xpixel_size));

 if((fid = fopen(argv[2],"r")) <= 0)
    {printf("\nCould not open MRI input file: %s\n",argv[2]);
     exit(0);}

 size = file_size(fid,&err);
 if (err)
    {printf("Invalid input file...\n");
     exit(0);}
 total_slices = size / (IMG_SIZE);
 num_slices = total_slices / 2;

 printf("  Total proton slices %d   Total T2 slices = %d\n",
              num_slices,num_slices);
 printf("     Slice thickness = %.4f  /  Pixel size = %.4f\n",
            mri_hdr.dimen.pixel_thickness,mri_hdr.dimen.xpixel_size);
 printf("        --> For re-slicing, you have a %d to 1 ratio for each slice\n",
                  spacing);
 if (num_slices < 0)
    {printf("illegal # of pairs of proton & t2 slices...= %d",(int) num_slices);
     exit(0);}

 strcpy(outfn,argv[3]);
 strcat(outfn,".pr.img");
 fseek(fid,0L,0);
 if ((err = put_mri_images_into_pet_file(outfn,fid,image,IMG_SIZE,
        num_slices,spacing)) != NO_ERROR)
    {printf("An error occurred when writing the proton pet file...\n");
     exit(1);}

 strcpy(outfn,argv[3]);
 strcat(outfn,".t2.img");
 fseek(fid,(long) IMG_SIZE,0);
 if ((err = put_mri_images_into_pet_file(outfn,fid,image,IMG_SIZE,
        num_slices,spacing)) != NO_ERROR)
    {printf("An error occurred when writing the T2 pet file...\n");
     exit(1);}

 fclose(fid);

 printf("Proton slice#1..%d   T2 slice#1..%d\n",(num_slices - 1) * spacing + 1,
               (num_slices - 1) * spacing + 1);
 printf("***Slice increment = %d\n",spacing);

 exit(0);
}
