/****************************************************************************
oldhup.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This program does not appear to be compiled or used anywhere.
   -PWH 19990430
****************************************************************************/

#include <stdio.h>

#include <sys/types.h>

#include "error_constants.h"
#include "typedef.h"
#include "str_def.h"
#include "ia_hdr.h"
#include "mark_hdr.h"
#include "nlib.h"

/*
hup /dev/rst0 /exusr/mri/si1 
hup /dev/rst0 /exusr/mri/si2 1 0 250 
hup /dev/rst0 /exusr/mri/si3 0 0 250
hup /dev/rst0 /exusr/mri/si4 1 0 250 0 512

hup "*.ima" /exusr/mri/si1 
hup "*.ima" /exusr/mri/si2 1 0 250 
hup "*.ima" /exusr/mri/si1 0 0 250 
hup "*.ima" /exusr/mri/si1 0 0 250 0 512
hup "*.ima" /exusr/mri/si1 1 0 250 0 512

csh lhup.com
*/


#define TRACE(x) x; fflush(stdout);
#define TRACE1(x) x; fflush(stdout);
#define TRACE2(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#undef TRACE
#undef TRACE1
#undef TRACE2
#undef PRT
#define TRACE(x)
#define TRACE1(x)
#define TRACE2(x)
#define PRT(x)

#define TRACEDRW(x) x; fflush(stdout);

/*
init_acr_rec(acr)
free_acr_rec(acr)
init_slice_rec(slice)
free_slice_rec(slice)
init_file_rec(file,out)
free_file_rec(file)

init_the_file_rec(out)
free_the_file_rec(out)

pr_header(hdr,is_print_all)
pr_file_rec(file)
pr_the_file_rec(out)
enter_slice(file,slice_num,infn,in_img_addr,hdr)
same_hdr(file,hdr2,image_orientation,series)
enter_file(out,hdr,slice_num,image_orientation,series,
           outfn,infn,in_img_addr,in_img_len,which_format)
wr_acr_img_data(file,fid,acr)
sort_echo_cnt_proc(s1,s2)
sort_slice_rec_proc(s1,s2)
sort_slice_rec_max_proc(s1,s2)
rearrange_slice_num(file)
find_num_echoes_and_echo_time(file)
save_file_rec(file)
save_the_file_rec(out)

cp_str_data(dest,src,len)
cp_data(dest,src,select,which_format)
acr_header_to_ia_hdr(fid,acr,hdr,slice_num,image_orientation,series,
                     in_img_addr,in_img_len,which_format)
rd_acr_group_elems(fid,acr,which_format)
pr_group_elem_rec(gelem)
pr_acr_rec(acr)
search_group_elem_rec_proc(obj1,obj2)
rd_acr_data(fid,acr,gid,eid,data,len,data_offset)

prog_usage(argc,argv);
check_minmax_range(out)
get_scale_info(out,argc,argv)
dp_errors(log)
main(argc,argv)

*/

#define G0008 0x0008
#define Eimage_id 0x0060
#define Edate_of_study 0x0020
#define Etime_of_study 0x0030
#define Ehosp_name 0x0080
#define Erefered_by 0x0090

#define G0009 0x0009
#define Etotal_images 0x0015
                                
#define G0010 0x0010
#define Epatient_name 0x0010
#define Epatient_ssnum 0x0020
#define Epatient_sex 0x0040
#define Epatient_id 0x1000
#define Epatient_age 0x1010
#define Epatient_weight 0x1030

#define G0018 0x0018
#define Epixel_thickness 0x0050
#define Etr 0x0080
#define Ete 0x0081
#define Eecho_num 0x0086
#define Eserial_num 0x1000

#define G0019 0x0019
#define Enecho 0x0001

#define G0020 0x0020
#define Estudy_num 0x0010
#define Eseries 0x0011
#define Estudy_series 0x1000
#define EACQ_series 0x1001
#define Eslice_num 0x0013
#define Eorientation 0x0035
#define Etotalimages 0x1002
#define Ecomment 0x4000

#define G0028 0x0028
#define Enum_dims 0x0005
#define Edimx 0x0010
#define Edimy 0x0011
#define Exypixel_size 0x0030
#define Epixel_depth_bits 0x0100

#define G7fe0 0x7fe0
#define Edata 0x0010

struct group_elem_rec
   {
    unsigned long gid,eid;
    unsigned long offset;
   };

struct acr_rec
   {
    unsigned long total,num;
    struct group_elem_rec *gelems;
    unsigned long fsize;
   };

struct slice_rec
   {char *inpfn,*echo_time;
    unsigned long in_img_addr;
    unsigned long num,echo_cnt,offset;
    unsigned long min,max;
   };

#define FLIP_DATA 1
struct file_rec
   {
    struct the_file_rec *root;
    char *fn;
    FILE *fid;
    struct hdr_rec hdr;
    unsigned long offset,insize,outsize,in_pixel_bytes;
    char *image_orientation,*series;
    unsigned long total_slices,num_slices;
    struct slice_rec *slices;
    int which_format;
   };

#define USE_SCALE 1
#define USE_ORIGINAL_BYTES_PER_PIXEL 2
#define USE_WINDOW_MIN_MAX 4
struct the_file_rec
   {
    unsigned status;
    unsigned long scale_bytes,scale_min,scale_max,win_min,win_max;
    unsigned long total,num;
    struct file_rec **files;
   };

init_acr_rec(acr)
 struct acr_rec *acr;
{
 acr->total = acr->num = 0;
 acr->gelems = NULL;
 acr->fsize = 0;
}

free_acr_rec(acr)
 struct acr_rec *acr;
{
 if (acr->total > 0)
    c_free(acr->gelems);
init_acr_rec(acr);
}

init_slice_rec(slice)
 struct slice_rec *slice;
{
 slice->inpfn = NULL;
 slice->echo_time = NULL;
}

free_slice_rec(slice)
 struct slice_rec *slice;
{
 c_free(slice->inpfn);
 c_free(slice->echo_time);
 init_slice_rec(slice);
}

init_file_rec(file,out,which_format)
 struct file_rec *file;
 struct the_file_rec *out;
 int which_format;
{
 file->root = out;
 file->fn = NULL;
 file->fid = NULL;
 file->offset = file->insize = file->outsize = 0;
 file->image_orientation = NULL;
 file->series = NULL;
 file->in_pixel_bytes = 0;
 init_hdr_rec(&(file->hdr));
 file->total_slices = file->num_slices = 0;
 file->slices = NULL;
 file->which_format = which_format;
}

free_file_rec(file)
 struct file_rec *file;
{
 unsigned long lcv;

 c_free(file->fn);
 if (file->fid != NULL) fclose(file->fid);
 c_free(file->image_orientation);
 c_free(file->series);
 free_hdr_rec(&(file->hdr));
 if (file->total_slices > 0)
    {for (lcv = 0; lcv < file->num_slices; lcv++)
        free_slice_rec(&(file->slices[lcv]));
     c_free(file->slices);
    }
 init_file_rec(file,NULL,0);
}

init_the_file_rec(out)
 struct the_file_rec *out;
{
 out->status = 0;
 out->scale_bytes = 0;
 out->total = out->num = 0;
 out->files = NULL;
}

free_the_file_rec(out)
 struct the_file_rec *out;
{
 unsigned long lcv;

 if (out->total > 0)
    {for (lcv = 0; lcv < out->num; lcv++)
        {free_file_rec(out->files[lcv]);
         c_free(out->files[lcv]);}
     c_free(out->files);
    }
 init_the_file_rec(out);

}

pr_header(hdr,is_pr_all)
 struct hdr_rec *hdr;
 int is_pr_all;
{
 struct data_info_rec *info;

 info = &(hdr->data_info);

#if 0
 printf("\n   SUBJECT name = %s   age = %d   sex = %c\n",
        info->patient.name,info->patient.age,
        info->patient.sex);
 printf("           patient id = %s\n",safestring(info->patient.patient_id));
 printf("           hospital = %s\n",info->hosp_name);
#else
 printf("   SUBJECT name: \"%s\"\n", info->patient.name);
#endif

 printf("           study number = %s\n",info->patient.study_num);
 printf("           date of study = %s     time = %.5s\n",
         info->date_of_study,info->time_of_study);
 printf("\n");

 printf("           Image  dimx = %d     dimy = %d     bits/pixel = %d\n",
          info->dimx,info->dimy,info->pixel_depth_bits);
 printf("                  pixel size x/y = %.4f/%.4f\n",
          info->xpixel_size,info->ypixel_size);
 if (is_pr_all)
    printf("                  pixel min = %.0f, max = %.0f\n",
          info->min_pixel,info->max_pixel);
 printf("\n");

 printf("           Slice  thickness = %.2f  spacing = %.2f",
          info->pixel_thickness,info->spacing);
 if (is_pr_all) printf("  total slices = %d\n",info->max_scans);
   else printf("\n");
 printf("                  Delay time (tr) = %.0f, Echo time (te) = %s\n",
          info->tr,info->te);
 printf("                  total echoes/slice = %d\n",info->num_echoes);

 printf("\n\n");
}

pr_file_rec(file)
 struct file_rec *file;
{
 unsigned long lcv;

 printf("fn = %s    image offset = %u insize = %u   outsize = %u\n",
        file->fn,file->offset,file->insize,file->outsize);
 pr_hdr_rec(&(file->hdr));
 printf("pr_file_rec total_slices = %d num_slices = %d\n",
          file->total_slices,file->num_slices);
 for (lcv = 0; lcv < file->num_slices; lcv++)
    {printf("%d) inpfn = %s num = %d  cnt = %d off = %d min = %d  max = %d\n",
        lcv,file->slices[lcv].inpfn,file->slices[lcv].num,
        file->slices[lcv].echo_cnt,
        file->slices[lcv].offset,
        file->slices[lcv].min,file->slices[lcv].max);
    }
}

pr_the_file_rec(out)
 struct the_file_rec *out;
{
 unsigned long lcv;

 printf("pr_the_file_rec total = %d num = %d\n",out->total,out->num);
 for (lcv = 0; lcv < out->num; lcv++)
    pr_file_rec(out->files[lcv]);
}

enter_slice(file,slice_num,infn,in_img_addr,hdr)
 struct file_rec *file;
 unsigned int slice_num;
 char *infn;
 unsigned long in_img_addr;
 struct hdr_rec *hdr;
{
 int err;
 unsigned long lcv,cnt,offset,temp;

 offset = file->offset;
 for (lcv = 0; lcv < 1; lcv++)
    {
     if (file->total_slices == file->num_slices)
        {temp = file->total_slices;
         get_ptr_memory(&(file->slices),&(file->total_slices),100,
                (size_t) sizeof(*(file->slices)),&err);
         if (err != NO_ERROR) return err;
         for (lcv = temp; lcv < file->total_slices; lcv++)
                init_slice_rec(&(file->slices[lcv]));
        }
     if ((err = cp_str(&(file->slices[file->num_slices].inpfn),infn))
                   != NO_ERROR) return err;
     trim_str_blanks(file->slices[file->num_slices].inpfn);
     if ((err = cp_str(&(file->slices[file->num_slices].echo_time),hdr->data_info.te))
                   != NO_ERROR) return err;
     trim_str_blanks(file->slices[file->num_slices].echo_time);

     file->slices[file->num_slices].in_img_addr = in_img_addr;
     file->slices[file->num_slices].num = slice_num;
     file->slices[file->num_slices].echo_cnt = hdr->data_info.num_echoes;
     file->slices[file->num_slices].offset = offset;
     file->slices[file->num_slices].min = (unsigned long) hdr->data_info.min_pixel;
     file->slices[file->num_slices].max = (unsigned long) hdr->data_info.max_pixel;
     offset += file->outsize;
     in_img_addr += file->insize;
     (file->num_slices)++;
     slice_num++;
    }
 file->offset = offset;
 return NO_ERROR;
}

same_hdr(file,hdr2,image_orientation,series)
 struct file_rec *file;
 struct hdr_rec *hdr2;
 char *image_orientation,*series;
{
 struct data_info_rec *info1,*info2;
 struct hdr_rec *hdr1;

 hdr1 = &(file->hdr);
 info1 = &(hdr1->data_info);
 info2 = &(hdr2->data_info);
 if (
     (str_cmp(file->image_orientation,image_orientation) != 0) ||
     (str_cmp(file->series,series) != 0) ||
     (str_cmp(info1->patient.name,info2->patient.name) != 0) ||
     (str_cmp(info1->patient.patient_id,info2->patient.patient_id) != 0) ||
     (str_cmp(info1->patient.study_num,info2->patient.study_num) != 0) ||
     (info2->patient.sex != info2->patient.sex) ||
     (str_cmp(info1->date_of_study,info2->date_of_study) != 0) ||
     (str_cmp(info1->time_of_study,info2->time_of_study) != 0) ||
     (info1->pixel_thickness != info2->pixel_thickness) ||
     (info1->spacing != info2->spacing) ||
     (info1->dimx != info2->dimx) ||
     (info1->dimy != info2->dimy) ||
     (info1->pixel_depth_bits != info2->pixel_depth_bits))
/*
     (info1->pixel_depth_bits != info2->pixel_depth_bits) ||
     (info1->tr != info2->tr) ||
     (str_cmp(info1->te,info2->te) != 0))

     (info1->pixel_depth_bits != info2->pixel_depth_bits) ||
     (info1->num_echoes != info2->num_echoes))
*/
    {return 0;
    }
 return 1;
}

enter_file(out,hdr,slice_num,image_orientation,series,
           outfn,infn,in_img_addr,in_img_len,which_format)
 struct the_file_rec *out;
 struct hdr_rec *hdr;
 unsigned int slice_num;
 char *image_orientation,*series;
 char *outfn,*infn;
 unsigned long in_img_addr,in_img_len;
 int which_format;
{
 unsigned long lcv,temp;
 char found;
 int err;
 char str[250];
 struct file_rec *file;


 /*  Match this file's header with previously read in headers.  If they
  *    are the same, but the image length is different, return an error.
  */
 for (found = 0,lcv = 0; lcv < out->num; lcv++)
    if (same_hdr(out->files[lcv],hdr,image_orientation,series))
       {
        if (out->files[lcv]->insize > in_img_len) return ~NO_ERROR;
        if ((err = enter_slice(out->files[lcv],slice_num,
                       infn,in_img_addr,hdr)) != NO_ERROR)
           return err;
	printf("Processing slice #%03d\r",slice_num);
	fflush(stdout);
        return NO_ERROR;
       }

 /*  Make more room in memory to handle a new file.  */
 if (out->total == out->num)
    {get_handle_memory(&(out->files),&(out->total),1,
         (size_t) sizeof(struct file_rec),&err);
     if (err != NO_ERROR) return err;
    }


 init_file_rec(out->files[out->num],out,which_format);
 out->files[out->num]->insize = (unsigned long) slice_size(hdr);
 if (out->files[out->num]->insize > in_img_len)
    {free_file_rec(out->files[out->num]);
     return ~NO_ERROR;}

 out->files[out->num]->in_pixel_bytes = 
                 GetPixelBytes(hdr->data_info.pixel_depth_bits);
 if (out->status & USE_ORIGINAL_BYTES_PER_PIXEL)
    {out->scale_bytes = out->files[out->num]->in_pixel_bytes;
     if (check_minmax_range(out) != NO_ERROR)
        {free_file_rec(out->files[out->num]);
         return ~NO_ERROR;}
     out->scale_bytes = 0;
    }

 if ((err = cp_str(&(out->files[lcv]->image_orientation),image_orientation))
              != NO_ERROR)
    return err;
 if ((err = cp_str(&(out->files[lcv]->series),series))
              != NO_ERROR)
    return err;

 out->files[out->num]->hdr = *hdr;
 init_hdr_rec(hdr);

 if (out->files[out->num]->root->scale_bytes)
    {temp = out->files[out->num]->hdr.data_info.pixel_depth_bits;
     out->files[out->num]->hdr.data_info.pixel_depth_bits = 
                    out->files[out->num]->root->scale_bytes * 8;
     out->files[out->num]->outsize = 
              (unsigned long) slice_size(&(out->files[out->num]->hdr));
     out->files[out->num]->hdr.data_info.pixel_depth_bits = temp;
    }
   else out->files[out->num]->outsize = out->files[out->num]->insize;

 if (out->num == 0) sprintf(str,"%s.img",outfn);
   else sprintf(str,"%s_%-d.img",outfn,out->num);

 if (((err = enter_slice(out->files[out->num],slice_num,
             infn,in_img_addr,&(out->files[out->num]->hdr))) != NO_ERROR) ||
     ((err = cp_str(&(out->files[out->num]->fn),str)) != NO_ERROR))
    {free_file_rec(out->files[out->num]);
     return err;}

/*  DRW 960326  The header is not completely correct at this stage.  */
#if 0
 printf("\nOUTPUT FILE HEADER INFO for file \"%s\":\n",
	out->files[out->num]->fn);
 pr_header(&(out->files[out->num]->hdr),0);
 printf("Please wait...\n");
#endif

 out->num += 1;
 return NO_ERROR;
}

wr_acr_img_data(file)
 struct file_rec *file;
{
 FILE *fid;
 unsigned char *data,*outdata;
 unsigned long num,lcv,total;
 unsigned long min,max;
 char *reason;
 int err;
 struct data_info_rec *info;

 if (file->fid == NULL)
    {
     if ((file->fid = fopen(file->fn,"w")) == NULL)
        {printf("....Open output file error...%s\n",file->fn);
         file_access(file->fn,2,NULL,&reason);
         printf("....Error reason : %s\n",reason);
         c_free(reason);
         return FILE_ACCESS_ERROR;
        }
    }
 total = 0;
 get_ptr_memory(&data,&total,file->insize,(size_t) 1,&err);
 if (err != NO_ERROR) return err;

 if ((file->root->scale_bytes) && (file->outsize > file->insize))
    {total = 0;
     get_ptr_memory(&outdata,&total,file->outsize,(size_t) 1,&err);
     if (err != NO_ERROR)
        {c_free(outdata);
         return err;}
    }
   else outdata = data;
 info = &(file->hdr.data_info);

#if 0
 if (file->root->scale_bytes == 0)
    {printf("GLOBAL min = %.0f  max = %.0f\n",info->min_pixel,info->max_pixel);
     printf("   Data is not rescaled...\n");
    }
   else 
    {printf("global min = %.0f  max = %.0f    SCALED TO    MIN = %d  MAX = %d\n",
         info->min_pixel,info->max_pixel,
         file->root->scale_min,file->root->scale_max);
     printf("   Each slice is rescaled based on the GLOBAL min & max...\n");
     printf("   not based on the SLICE min & max...\n");
    }
#endif

 for (lcv = 0; lcv < file->num_slices; lcv++)
    {
     if ((fid = fopen(file->slices[lcv].inpfn,"r")) == NULL)
        {printf("input file open error...fn = %s\n",file->slices[lcv].inpfn);
         err = FILE_ACCESS_ERROR;
         break;}

#if 0
     printf("...%d) reading slice# %d - %s...SLICE Min = %d  max = %d\n",
            lcv + 1,file->slices[lcv].num,file->slices[lcv].inpfn,
            file->slices[lcv].min,file->slices[lcv].max);
#else
     printf("%d) Slice #%03d, \"%s\"\r",
	    lcv + 1,
            file->slices[lcv].num,
	    file->slices[lcv].inpfn);
     fflush(stdout);
#endif

     fseek(fid,file->slices[lcv].in_img_addr,0);
     if (fread(data,file->insize,1,fid) != 1)
        {printf("read error...fn = %s\n",file->slices[lcv].inpfn);
          fclose(fid);
         err = READ_ERROR;
         break;}
     fclose(fid);

     num = file->hdr.data_info.dimx * file->hdr.data_info.dimy;

     if (file->which_format == FLIP_DATA)
        if (file->in_pixel_bytes == 2)
           {dec2sun_word(data,num);}
          else if (file->in_pixel_bytes == 4)
           {dec2sun_long(data,num);}

     if (file->root->scale_bytes)
        {
         if (file->root->scale_bytes <= file->in_pixel_bytes)
            {
             scale_values(outdata,outdata,info->dimx,info->dimy,
                 (unsigned long) info->min_pixel,
                 (unsigned long) info->max_pixel,
                 file->root->scale_min,file->root->scale_max,
                 file->in_pixel_bytes);
             get_1d_ary_min_max(outdata,num,&min,&max,file->in_pixel_bytes);
             if (file->root->scale_bytes < file->in_pixel_bytes)
                assign_values(outdata,file->root->scale_bytes,
                          data,file->in_pixel_bytes,num);
             get_1d_ary_min_max(outdata,num,&min,&max,file->root->scale_bytes);

            }
           else
            {assign_values(outdata,file->root->scale_bytes,
                          data,file->in_pixel_bytes,num);
             scale_values(outdata,outdata,info->dimx,info->dimy,
                 (unsigned long) info->min_pixel,
                 (unsigned long) info->max_pixel,
                 file->root->scale_min,file->root->scale_max,
                 file->root->scale_bytes);
            }
        }

     if (fwrite(outdata,file->outsize,1,file->fid) != 1)
        {err = ferror(file->fid);
         printf("...err = %d occurred when writing to %s\n",err,file->fn);
         err = WRITE_ERROR;
         break;}
    }

 printf ("\n");

 fclose(file->fid);
 if (outdata != data) c_free(outdata);
 c_free(data);
 return err;
}

sort_echo_cnt_proc(s1,s2)
 struct slice_rec **s1,**s2;
{
 if ((*s1)->echo_cnt > (*s2)->echo_cnt) return 1;
 if ((*s1)->echo_cnt < (*s2)->echo_cnt) return -1;
 return 0;
}

sort_slice_rec_proc(s1,s2)
 struct slice_rec *s1,*s2;
{
 if (s1->num > s2->num) return 1;
 if (s1->num < s2->num) return -1;
 if (s1->echo_cnt > s2->echo_cnt) return 1;
 if (s1->echo_cnt < s2->echo_cnt) return -1;
 return 0;
}

sort_slice_rec_max_proc(s1,s2)
 struct slice_rec *s1,*s2;
{
 if (s1->max < s2->max) return 1;
 if (s1->max > s2->max) return -1;
 return 0;
}

rearrange_slice_num(file)
 struct file_rec *file;
{
 unsigned long lcv,num_slices,total,cnt;
 struct slice_rec *slices;
 int err;

 num_slices = file->num_slices / file->hdr.data_info.num_echoes;
 file->num_slices = num_slices * file->hdr.data_info.num_echoes;
 if (file->num_slices == 0) return CANCEL;
 total = 0;
 get_ptr_memory(&slices,&total,file->num_slices,
   (size_t) sizeof(*slices),&err);
 if (err != NO_ERROR) return err;
 for (cnt = 0,lcv = 0; lcv < num_slices; lcv++)
    {slices[cnt++] = file->slices[lcv];
     slices[cnt++] = file->slices[num_slices + lcv];
    }
 for (cnt = 0,lcv = 0; lcv < file->num_slices; lcv++)
    file->slices[lcv] = slices[lcv];
 c_free(slices);
 return NO_ERROR;
}

find_num_echoes_and_echo_time(file)
 struct file_rec *file;
{
 unsigned long lcv,total,cnt;
 struct slice_rec **slices;
 int err;
 char *te,*str;

 total = 0;
 get_ptr_memory(&slices,&total,file->num_slices,
   (size_t) sizeof(*slices),&err);
 if (err != NO_ERROR) return err;
 for (lcv = 0; lcv < file->num_slices; lcv++)
    {slices[lcv] = &(file->slices[lcv]);
    }
 qsort(slices,file->num_slices,
        (size_t) sizeof(*slices),sort_echo_cnt_proc);

 file->hdr.data_info.num_echoes = 0;
 te = NULL;
 for (lcv = 0; lcv < file->num_slices; lcv++)
    if (slices[lcv]->echo_cnt > file->hdr.data_info.num_echoes)
       {file->hdr.data_info.num_echoes = slices[lcv]->echo_cnt;
        if (te == NULL)
           {if ((err = cp_str(&te,slices[lcv]->echo_time)) != NO_ERROR)
               return err;
           }
          else
           {str = te;
            if ((err = concat_strs(&te,3,str,"/",slices[lcv]->echo_time)) != NO_ERROR)
               {c_free(str);
                return err;}
            c_free(str);}
        }
 c_free(file->hdr.data_info.te);
 file->hdr.data_info.te = te;

 c_free(slices);

 return NO_ERROR;
}

save_file_rec(file)
 struct file_rec *file;
{
 unsigned long lcv;
 int err;
 char fn[250],hdrfn[250];
 struct mark_hdr mark;
 unsigned long min,max,num;

 if (file->num_slices == 0) return CANCEL;

/*  DRW 960323: Turned off display of min/max for first few slices  */
#if 0
 if (file->num_slices > 1)
    qsort(file->slices,file->num_slices,
        (size_t) sizeof(*(file->slices)),sort_slice_rec_max_proc);

 if (file->num_slices >= 5) num = 5;
   else num = file->num_slices;
 printf("Slice min & largest max for the first %d slices\n", num);
 for (lcv = 0; lcv < num; lcv++)
    printf("  %d) Slice# = %d   min = %d   max = %d\n",lcv + 1,
      file->slices[lcv].num,file->slices[lcv].min,file->slices[lcv].max);
 printf("\n");
#endif

 if (file->num_slices > 1)
    {qsort(file->slices,file->num_slices,
        (size_t) sizeof(*(file->slices)),sort_slice_rec_proc);
/*
     if (file->hdr.data_info.num_echoes > 1)
        if ((err = rearrange_slice_num(file)) != NO_ERROR) return err;
*/
    }

 sprintf(fn,"%s",file->fn);
 drop_suffix(fn);
 sprintf(fn,"%s.nhdr",fn);

 file->hdr.data_info.max_scans = file->num_slices;
 if (file->root->status & USE_ORIGINAL_BYTES_PER_PIXEL)
    file->root->scale_bytes = file->in_pixel_bytes;
 if (file->root->scale_bytes)
    file->hdr.data_info.pixel_depth_bits = file->root->scale_bytes * 8;

 if (((err = build_extra_file_info_rec(&(file->hdr.extra_info)))
              != NO_ERROR) ||
     ((err = BuildRiaHdr(&(file->hdr),0)) != NO_ERROR))
    {printf("ERROR generating the RIA header file = %s ... err = %d\n",
             fn,err);
     return err;}

 min = 0xffffffff;
 max = 0;
 for (lcv = 0; lcv < file->num_slices; lcv++)
    {if (file->root->status & USE_WINDOW_MIN_MAX)
        {
         if (file->slices[lcv].min < file->root->win_min)
            file->slices[lcv].min = file->root->win_min;
         if (file->slices[lcv].max > file->root->win_max)
            file->slices[lcv].max = file->root->win_max;
        }
     if (file->slices[lcv].min < min)
        min = file->slices[lcv].min;
     if (file->slices[lcv].max > max)
        max = file->slices[lcv].max;
    }
 file->hdr.data_info.min_pixel = (double) min;
 file->hdr.data_info.max_pixel = (double) max;
 for (lcv = 0; lcv < file->num_slices; lcv++)
    {file->hdr.scans[lcv].num = file->slices[lcv].num;
     file->slices[lcv].offset = file->hdr.scans[lcv].img_addr;
/*
     if (file->hdr.slices[lcv].img_addr != file->slices[lcv].offset)
        printf("%d) s#%d -- warning image addr : computed  = %u  <>  scanned = %u\n",lcv,file->slices[file->num_slices].num,
             file->hdr.slices[lcv].img_addr,file->slices[lcv].offset);
*/
    }

 if ((err = wr_acr_img_data(file)) != NO_ERROR)
    {if (file->root->status & USE_ORIGINAL_BYTES_PER_PIXEL) 
        file->root->scale_bytes = 0;
     return err;}

#if 0
 printf("\n...img file %s was generated...\n",file->fn);
#endif

 if (file->root->scale_bytes)
    {file->hdr.data_info.min_pixel = (double) file->root->scale_min;
     file->hdr.data_info.max_pixel =  (double) file->root->scale_max;
    }
 if (file->root->status & USE_ORIGINAL_BYTES_PER_PIXEL) 
    file->root->scale_bytes = 0;

 if ((err = wr_the_hdr(fn,&(file->hdr))) != NO_ERROR)
    {
     printf("ERROR writing the RIA header file = %s ... err = %d\n",fn,err);
     return err;}

#if 0
 printf("...RIA header file %s was generated...\n",fn);
#endif

 drop_suffix(fn);
 sprintf(hdrfn,"%s.hdr",fn);
 init_mark_hdr(&mark);
 if ((err = assign_nhdr_to_hdr(&mark,&(file->hdr))) != NO_ERROR)
    {printf("ERROR generating the MRVBR header file = %s ... err = %d\n",
              hdrfn,err);
     return err;}
 if (wr_hdr_file(hdrfn,&mark) != NO_ERROR) 
    {
     printf("ERROR writing the MRVBR header file = %s ... err = %d\n",
              hdrfn,err);
     return err;}

#if 0
 printf("...MRVBR header file %s was generated...\n",hdrfn);
#endif

 if (file->fid)
    {fclose(file->fid);
     file->fid = NULL;
    }
 printf("Image header contents:\n");
 pr_header(&(file->hdr),1);

 return NO_ERROR;

}

save_the_file_rec(out)
 struct the_file_rec *out;
{
  unsigned long lcv;
  int err;

  for (lcv = 0; lcv < out->num; lcv++)
    {
      printf("Writing output file #%d, \"%s\"...\n",
	     lcv + 1,
	     out->files[lcv]->fn);
      if ((err = find_num_echoes_and_echo_time(out->files[lcv])) != NO_ERROR)
	return err;
      save_file_rec(out->files[lcv]);
    }

  return NO_ERROR;
}

cp_str_data(dest,src,len)
 unsigned char *dest,*src;
 unsigned long len;
{
 memcpy(dest,src,len);
 dest[len] = 0;
}

#define SHORT_DATA 2
#define LONG_DATA 3
#define FLOAT_DATA 4
cp_data(dest,src,select,which_format)
 unsigned char *dest,*src;
 unsigned long select;
 int which_format;
{
 unsigned short *sh_num;
 unsigned long *num;
 float fl;

 if (select == SHORT_DATA)
    {sh_num = (unsigned short *) dest;
     memcpy(dest,src,2);
     if (which_format == FLIP_DATA)
        *sh_num = to_dec_short(*sh_num);
    }
   else if (select == LONG_DATA)
    {num = (unsigned long *) dest;
     memcpy(dest,src,4);
     if (which_format == FLIP_DATA)
        *num = to_dec_long(*num);
    }
   else if (select == FLOAT_DATA)
    {
     memcpy(dest,src,4);
     if (which_format == FLIP_DATA)
        dec2sun_float(src,dest);
    }
}

acr_header_to_ia_hdr(fid,acr,hdr,slice_num,image_orientation,series,
                     in_img_addr,in_img_len,which_format)
 FILE *fid;
 struct acr_rec *acr;
 struct hdr_rec *hdr;
 unsigned int *slice_num;
 char **image_orientation,**series;
 unsigned long *in_img_addr,*in_img_len;
 int which_format;
{
 unsigned char *data;
 unsigned long lcv,num,len,num1;
 unsigned short sh_num;
 unsigned short *sh_ptr;
 char str[250];
 float fl;
 struct data_info_rec *info;
 int err;
 unsigned long min,max;

 TRACE2(printf("acr_header_to_ia_hdr...which_format = %d\n",which_format))
 info = (struct data_info_rec *) &(hdr->data_info);
 *image_orientation = NULL;
 *series = NULL;
 if ((err = rd_acr_data(fid,acr,G0008,Eimage_id,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 info->image_id = (char *) data;
 TRACE2(printf("Eimage_id data = %s\n",data))

 if ((err = rd_acr_data(fid,acr,G0008,Edate_of_study,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
      else printf("Warning : date of study not found !!!\n");
 info->date_of_study = (char *) data;
 TRACE2(printf("date_of_study = %s\n",info->date_of_study))

 if ((err = rd_acr_data(fid,acr,G0008,Etime_of_study,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
      else printf("Warning : time of study not found !!!\n");
 info->time_of_study = (char *) data;
 TRACE2(printf("time_of_study = %s\n",info->time_of_study))

 if ((err = rd_acr_data(fid,acr,G0008,Erefered_by,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 info->refered_by = (char *) data;
 TRACE2(printf("refered_by = %s\n",data))

 if ((err = rd_acr_data(fid,acr,G0008,Ehosp_name,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 info->hosp_name = (char *) data;
 TRACE2(printf("hosp_name = %s\n",data))

 if ((err = rd_acr_data(fid,acr,G0010,Epatient_name,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 info->patient.name = (char *) data;
 TRACE2(printf("name = %s\n",data))

 if ((err = rd_acr_data(fid,acr,G0010,Epatient_ssnum,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 info->patient.ssnum = (char *) data;
 TRACE2(printf("Eimage_id ssnum = %s\n",data))

 if ((err = rd_acr_data(fid,acr,G0020,Estudy_num,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;

 info->patient.study_num = (char *) data;
 TRACE2(printf("study_num = %s\n",data))

 if ((err = rd_acr_data(fid,acr,G0020,Eseries,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
      else printf("Warning : series # not found !!!\n");

 *series = (char *) data;
 TRACE2(printf("series = %s\n",data))
/*
 if ((err = rd_acr_data(fid,acr,G0020,Estudy_series,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {
     TRACE2(printf("error reading Estudy_series ...err = %d\n",err))
    }
   else
    {TRACE2(printf("Estudy_series = %s\n",data))
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0020,EACQ_series,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {
     TRACE2(printf("error reading EACQ_series ...err = %d\n",err))
    }
   else
    {TRACE2(printf("EACQ_series = %s\n",data))
     c_free(data);}
*/
 if ((err = rd_acr_data(fid,acr,G0020,Eorientation,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 *image_orientation = (char *) data;

 if ((err = rd_acr_data(fid,acr,G0010,Epatient_sex,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 TRACE2(printf("Epatient_sex = %s\n",data))
 if (data != NULL)
    {if (get_strlen(data) > 0)
        if ((find_sub_str(data,"F",&num) == NO_ERROR) ||
            (find_sub_str(data,"f",&num) == NO_ERROR))
           info->patient.sex = 'F';
          else info->patient.sex = 'M';
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0010,Epatient_age,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 TRACE2(printf("Epatient_age = %s\n",data))
 if (data != NULL)
    {if (sscanf((CONST char *) data,"%d",&num) == 1) info->patient.age = num;
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0010,Epatient_weight,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 TRACE2(printf("Epatient_weight = %s\n",data))
 if (data != NULL)
    {if (sscanf((CONST char *) data,"%f",&fl) == 1)
        {fl = fl * 1000;
         info->patient.weight = (int) fl;}
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0020,Ecomment,&data,&len,NULL,
               which_format)) != NO_ERROR)
    if (err != NOT_FOUND)
       return err;
 if (data != NULL) {
   info->description = (char *) data;
   TRACE2(printf("Ecomment = %s\n",info->description))
 }
 else {
   TRACE2(printf("Ecomment = <MISSING>\n"));
 }

 if ((err = rd_acr_data(fid,acr,G0018,Epixel_thickness,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {if (err != NOT_FOUND)
        return err;
       else printf("Warning : pixel thickness not found !!!\n");
    }
   else if (data != NULL)
    {
     sscanf((CONST char *) data,"%f",&(info->pixel_thickness));
     TRACE2(printf("data = %s thickness = %f\n",data,info->pixel_thickness))
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0018,Etr,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {if (err != NOT_FOUND)
        return err;
       else printf("Warning : tr not found !!!\n");
    }
  else if (data != NULL)
    {
     sscanf((CONST char *) data,"%f",&(info->tr));
     TRACE2(printf("data = %s tr = %f\n",data,info->tr))
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0018,Ete,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {if (err != NOT_FOUND)
        return err;
       else printf("Warning : te (echo time) not found !!!\n");
    }
  else if (data != NULL)
   {info->te = (char *) data;
    TRACE2(printf("te = %s\n",data))}
/*
 if ((err = rd_acr_data(fid,acr,G0018,Eserial_num,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {TRACE2(printf("error reading the Eserial_num...err = %d\n",err);)
    }
   else
    {printf("Eserial_num = %s\n",data);
     if (data != NULL) c_free(data);}

 if ((err = rd_acr_data(fid,acr,G0019,Enecho,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {TRACE2(printf("error reading the Enecho...err = %d\n",err);)
    }
   else
    {cp_data(&sh_num,data,SHORT_DATA,which_format);
     printf("Enecho = %d\n",sh_num);
     if (data != NULL) c_free(data);}
*/
 if ((err = rd_acr_data(fid,acr,G0018,Eecho_num,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {
     if (err != NOT_FOUND)
        {TRACE2(printf("error reading the Eecho_num...err = %d\n",err);)
         return err;}
       else if (info->description != NULL)
        {if (sscanf(info->description,"NECHO=%d ECHON=%d",&num1,&num) == 2)
            {info->num_echoes = num;
             TRACE2(printf("Eecho_num = %d\n",info->num_echoes))}
           else 
            {
             printf("Error : echo# not found !!!\n");
             return CANCEL;
            }
        }
       else 
        {printf("Error : echo# not found !!!\n");
         return CANCEL;
        }
    }
   else if (data != NULL)
    {
     TRACE2(printf("Eecho_num = %s\n",data))
     sscanf((CONST char *) data,"%d",&num);
     info->num_echoes = num;
     c_free(data);}
   else 
    {printf("Error : echo# not found !!!\n");
     return CANCEL;
    }

 if ((err = rd_acr_data(fid,acr,G0028,Edimx,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {printf("Error reading image dimx !!!\n");
     return err;}
 if (data != NULL)
    {cp_data(&sh_num,data,SHORT_DATA,which_format);
     info->dimx = sh_num;
     TRACE2(printf("dimx = %d\n",info->dimx))
     c_free(data);}
   else return CANCEL;

 if ((err = rd_acr_data(fid,acr,G0028,Edimy,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {printf("Error reading image dimy !!!\n");
     return err;}
 if (data != NULL)
    {cp_data(&sh_num,data,SHORT_DATA,which_format);
     info->dimy = sh_num;
     TRACE2(printf("dimy = %d\n",info->dimy))
     c_free(data);}
   else return CANCEL;

 if ((err = rd_acr_data(fid,acr,G0028,Exypixel_size,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {printf("Error reading image xy pixel_size !!!\n");
     return err;}
 if (data != NULL)
    {
     if (sscanf((CONST char *) data,"%f",&(info->xpixel_size)) != 1)
        {printf("Error reading the xy pixel size...\n");
         err = ~NO_ERROR;}
     info->ypixel_size = info->xpixel_size;
     TRACE2(printf("Exypixel_size data = %s xpixel_size = %f %f\n",data,info->xpixel_size,
                  info->ypixel_size))
     c_free(data);
     if (err != NO_ERROR) return err;
    }
   else return CANCEL;

 if ((err = rd_acr_data(fid,acr,G0028,Epixel_depth_bits,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {printf("Error reading the pixel depth...\n");
     return err;}
 if (data != NULL)
    {cp_data(&sh_num,data,SHORT_DATA,which_format);
     TRACE2(printf("Epixel_depth_bits data = %u\n",(unsigned long) sh_num))
     if (sh_num % 8)
        {printf("Sorry...bits per pixel = %d is not a multiple of 8...\n",
                    (int) sh_num);
         printf("Sorry...data cannot be handled !!!\n");
         c_free(data);
         return CANCEL;}

     info->pixel_depth_bits = (sh_num / 8);
     if (sh_num % 8) info->pixel_depth_bits += 1;
     info->pixel_depth_bits *= 8;
     c_free(data);}
   else return CANCEL;


 if ((err = rd_acr_data(fid,acr,G0020,Eslice_num,&data,&len,NULL,
               which_format)) != NO_ERROR)
    {if (err != NOT_FOUND)
        return err;
       else printf("Warning : slice_num not found...\n");
    }
   else if (data != NULL)
    {
     sscanf((CONST char *) data,"%d",&num);
     TRACE2(printf("Eslice_num =  %d data = %s\n",(unsigned int) num,data))
     *slice_num = num;
     c_free(data);}

 if ((err = rd_acr_data(fid,acr,G7fe0,Edata,&data,in_img_len,in_img_addr,
               which_format)) == NO_ERROR)
    {if (which_format == FLIP_DATA)
        if ((info->pixel_depth_bits / 8) == 2)
           {dec2sun_word(data,info->dimx * info->dimy);}
          else if ((info->pixel_depth_bits / 8) == 4)
           {dec2sun_long(data,info->dimx * info->dimy);}
     get_1d_ary_min_max(data,info->dimx * info->dimy,
                &min,&max,info->pixel_depth_bits / 8);
     info->min_pixel = (double) min;
     info->max_pixel = (double) max;
     TRACE2(printf("info->min_pixel = %.0f  info->max_pixel = %.0f\n",
           info->min_pixel,info->max_pixel))
    }
 c_free(data);
 return err;
}

rd_acr_group_elems(fid,acr,which_format)
 FILE *fid;
 struct acr_rec *acr;
 int *which_format;
{
 unsigned short gid,eid;
 unsigned long elen,glen;
 unsigned long offset;
 int err;

 fseek(fid,0,0);
 offset = 0;
 acr->fsize = file_size(fid,&err);
 if (err != NO_ERROR) 
    {printf("...file_size error...\n");
     return err;}
 while (1)
    {
     if (offset >= acr->fsize)
       break;

     gid = eid = 0;
     elen = glen = 0;


     /*
      *  ACR-NEMA Element structure:
      *
      * Offset	Size	Description
      * (bytes)	(bytes)
      *
      *	0	2 	Group ID (16-bit word, unsigned integer)
      *	2	2	Element ID (16-bit word, unsigned integer)
      *	4	4	Element Length (32-bit double word, unsigned integer)
      * 8	???	Element Value
      *
      *  Note that the size of the Element Value is determined by
      *    interpreting the Element Length as an unsigned integer
      *    (NEMA Standard 10-16-1985, Section 4.5, Paragraph 1)
      *
      *
      *  "Data element number 0000H of all groups shall be the first
      *    element.  Its value shall be the number of bytes expressed
      *    in binary from the end of its own value field to the
      *    beginning of the next group."  Ibid., Paragraph 4.
      */


     /*
      *  Read in the next Group ID, Element ID, and Element Length.
      *    If the Element ID is not (xxxxH.0000H), then glen happens
      *    to be the first four bytes of the Value Field.
      *  TODO:
      *    If the Element ID is not (xxxxH.0000H), then something is
      *    wrong since the first Element of each Group MUST be 0000H
      *    (see above, in quotes).  I.E. if eid != 0 then die.
      */
     if ((fread(&gid,(size_t) 1,(size_t) 2,fid) != 2) ||
         (fread(&eid,(size_t) 1,(size_t) 2,fid) != 2) ||
         (fread(&elen,(size_t) 1,(size_t) 4,fid) != 4) ||
         (fread(&glen,(size_t) 1,(size_t) 4,fid) != 4))
        {printf("...READ_ERROR...gid = %d eid = %d  elen = %d glen = %d\n",
                   (unsigned long) gid,(unsigned long) eid,elen,glen);
         return READ_ERROR;}


     /*
      *  If we read in Element (0000H.0000H), the Length should be
      *    4, and its Value should be a 32-bit double word, which is the
      *    even number of bytes from the end of this Element's Value
      *    field to the beginning of the next Group.
      *
      *  If we read in Element (0000H.0000H), and the Length is not
      *    4, we assume the data is in okay condition, but is stored
      *    in Little-Endian format instead of Big-Endian format.
      */
     if ((gid == 0) && (eid == 0))
        if (elen == 4)
	  *which_format = 0;
	else
	  *which_format = FLIP_DATA;

     if (*which_format == FLIP_DATA)
        {dec2sun_word(&gid,1);
         dec2sun_word(&eid,1);
         elen = to_dec_long(elen);
         glen = to_dec_long(glen);}


     /*
      *  Get more memory, in blocks of 50 array members, as necessary.
      */
     if (acr->total == acr->num)
        {
         get_ptr_memory(&(acr->gelems),&(acr->total),(size_t) 50,
             (size_t) sizeof(*(acr->gelems)),&err);
         if (err != NULL) return err;
        }

     /*
      *  Essentially, we are simply keeping track of where each Element
      *    lies within the file, for faster seeking.
      */
     acr->gelems[acr->num].gid = gid;
     acr->gelems[acr->num].eid = eid;
     acr->gelems[acr->num].offset = offset;
     (acr->num)++;

     TRACEDRW(printf("(%04XH.%04XH): offset = %5u, Length = %lu, Value = %08XH\n",
		     gid,eid,offset,elen,glen));

     /*
      *  Move on to the next group.  The magical number 12 is derived
      *    from the fact that Element (xxxxH.0000H) of any group is the
      *    number of bytes in the Group, represented as a 32-bit double
      *    word, which is 4 bytes.  The header of that Element is 8 bytes,
      *    thus 4 + 8 = 12.
      */
     offset += glen + 12;
     fseek( fid, glen, 1 );

    };
 return NO_ERROR;
}

pr_group_elem_rec(gelem)
 struct group_elem_rec *gelem;
{
 printf("gid = %x eid = %x offset = %u\n",(unsigned long) gelem->gid,
         (unsigned long) gelem->eid,gelem->offset);
}

pr_acr_rec(acr)
 struct acr_rec *acr;
{
 unsigned long lcv;

 printf("\n\npr_acr_rec\n");
 printf("total = %u num = %u\n",acr->total,acr->num);
 for (lcv = 0; lcv < acr->num; lcv++)
    pr_group_elem_rec(&(acr->gelems[lcv]));
}

search_group_elem_rec_proc(obj1,obj2)
 struct group_elem_rec *obj1,*obj2;
{
 if (obj1->gid > obj2->gid) return 1;
 if (obj1->gid < obj2->gid) return -1;
 if (obj1->eid > obj2->eid) return 1;
 if (obj1->eid < obj2->eid) return -1;
 return 0;
}

rd_acr_data(fid,acr,gid,eid,data,len,data_offset,which_format)
 FILE *fid;
 struct acr_rec *acr;
 unsigned short gid,eid;
 char **data;
 unsigned long *len,*data_offset;
 int which_format;
{
 unsigned short groupid,elemid;
 unsigned long elen,glen,total;
 int err;
 unsigned long posi;
 struct group_elem_rec gelem;
 unsigned long offset,last_offset;

 if (data != NULL) *data = NULL;
 if (data_offset != NULL) *data_offset = 0;
 if (len != NULL) *len = 0;
 gelem.gid = gid;
 gelem.eid = 0;
 if (obj_binary_search(acr->gelems,acr->num,
        sizeof(struct group_elem_rec),
        &gelem,search_group_elem_rec_proc,&posi) == NO_ERROR)
    {TRACE(printf("found...posi = %d acr->num = %d total = %d offset = %u\n",
             posi,acr->num,acr->total,acr->gelems[posi].offset))
     fseek(fid,acr->gelems[posi].offset,0);
     offset = acr->gelems[posi].offset;
     if ((posi + 1) < acr->num) last_offset = acr->gelems[posi + 1].offset;
       else last_offset = acr->fsize;
     while (1)
        {/*TRACE(printf("rd next...last_offset = %d\n",last_offset))*/
         if (offset >= last_offset) return NOT_FOUND;
         if ((fread(&groupid,(size_t) 1,(size_t) 2,fid) != 2) ||
             (fread(&elemid,(size_t) 1,(size_t) 2,fid) != 2) ||
             (fread(&elen,(size_t) 1,(size_t) 4,fid) != 4))
            return READ_ERROR;
         if (which_format == FLIP_DATA)
            {dec2sun_word(&groupid,1);
             dec2sun_word(&elemid,1);
             elen = to_dec_long(elen);
            }
     TRACE(printf("gid = %x eid = %x.....groupid = %x elemid = %x elen = %u offset = %o\n",
          (unsigned int) gid,(unsigned int) eid,
          (unsigned int) groupid,(unsigned int) elemid,
          (unsigned int) elen,offset))

         if (gid != groupid) 
            {TRACE1(printf("NOT_FOUND gid = %x eid = %x.....groupid = %x elemid = %x elen = %u\n",
               (unsigned int) gid,(unsigned int) eid,
               (unsigned int) groupid,(unsigned int) elemid,
               (unsigned int) elen))
             return NOT_FOUND;}

         if (eid == elemid)
            {
             if (data != NULL)
                {total = 0;
                 get_ptr_memory(data,&total,elen + 1,(size_t) 1,&err);
                 if (err) return err;
                 if (fread(*data,(size_t) 1,(size_t) elen,fid) != elen)
                    {c_free(*data);
                     *data = NULL;
                     return READ_ERROR;
                    }
                 (*data)[elen] = '\0';
                }
             if (len != NULL) *len = elen;
             if (data_offset != NULL) *data_offset = offset + 8;
TRACE1(printf("FOUND gid = %x eid = %x.....groupid = %x elemid = %x elen = %u  offset = %o %d\n",
               (unsigned int) gid,(unsigned int) eid,
               (unsigned int) groupid,(unsigned int) elemid,
               (unsigned int) elen,offset,offset))
             return NO_ERROR;
            }
           else if (elemid > eid)
            {TRACE1(printf("NOT_FOUND == gid = %x eid = %x.....groupid = %x elemid = %x elen = %u\n",
               (unsigned int) gid,(unsigned int) eid,
               (unsigned int) groupid,(unsigned int) elemid,
               (unsigned int) elen))
             return NOT_FOUND;}
           else fseek(fid,elen,1);
         offset += elen + 8;
        }
    }     
 TRACE1(printf("NOT_FOUND == gid = %x eid = %x.....\n",
               (unsigned int) gid,(unsigned int) eid))
 return NOT_FOUND;
}

prog_usage(argc,argv)
 int	argc;
 char	*argv[];
{

 if ((argc != 3) && (argc != 6) && (argc != 8))
    {
     printf("\nGeneral Usage : %s <hup> mri [scale_to_bytes/pixel min max [win_min win_max]]\n",argv[0]);
     printf("                where parameters enclosed in [] are optional...\n",argv[0]);
     printf("        FOR MRVBR USERS....\n");
     printf("NOTE : For users converting images for the use from the \n");
     printf("       mrvbr program, please refer to example 3 !!!!\n\n");
     printf("Usage 1 : %s <hup> mri\n",argv[0]);
     printf("Usage 2 : %s <hup> mri scale_to_bytes/pixel min max\n",
                   argv[0]);
     printf(
     "Usage 3 : %s <hup> mri scale_to_bytes/pixel min max win_min win_max\n",
                   argv[0]);
     printf("\n");
     printf("Where <hup> = hup.img or /dev/rst0 or \"hup*.img\"\n");
     printf("....if the wild card * is used, it must be enclosed by \"\"\n");
     printf("      scale_to_bytes/pixel = number of bytes/pixel\n");
     printf("                           = 1, 2, or 4 bytes/pixel\n");
     printf("                           = 0 use same # of bytes/pixel & do not scale\n");
     printf("                             the data\n");
     printf("\n");
     printf("      min & max = scale the original pixel values to these given\n");
     printf("                  min & max values, based on the original min & max\n");
     printf("\n");
     printf("      win_min & win_max = take original values within the range\n");
     printf("         of these given window min & max, where any values < win_min\n");
     printf("         will be win_min & any values > win_max will be win_max\n");
     printf("\n\n");

     printf("Example 1 : %s hup.img mri\n",argv[0]);
     printf("   Result : 1) input  = hup.img --- hup file name\n\n");
     printf("            2) output = mri.hdr  --- mrvbr header\n");
     printf("            3) output = mri.nhdr  --- ria header\n");
     printf("            4) output = mri.img  --- mri image file\n");
     printf("\n\n");
     printf("Example 2 : %s \"hup*.img\" mri\n",argv[0]);
     printf("   Result : 1) input  = hup*.img --- hup file names\n");
     printf("            2) output = mri.hdr  --- mrvbr header\n");
     printf("            3) output = mri.nhdr  --- ria header\n");
     printf("            4) output = mri.img  --- mri image file\n");
     printf("Note : for example 1 & 2, no scaling is done on the data and the\n");
     printf("       16 bit original data will be passed through into mri.img\n");
     printf("\n\n");
     printf("Example 3 : %s \"hup*.img\" mri 1 0 250\n",argv[0]);
     printf("   Result : 1) input  = hup*.img --- hup file names\n");
     printf("            2) output = mri.hdr  --- mrvbr header\n");
     printf("            3) output = mri.nhdr  --- ria header\n");
     printf("            4) output = mri.img  --- mri image file\n");
     printf("Note : Mrvbr users should use this option !!!\n");
     printf("\n\n");
     printf("Example 4 : %s \"hup*.img\" mri 0 0 0 1000 3000\n",argv[0]);
     printf("   Result : 1) input  = hup*.img --- hup file names\n");
     printf("            2) output = mri.hdr  --- mrvbr header\n");
     printf("            3) output = mri.nhdr  --- ria header\n");
     printf("            4) output = mri.img  --- mri image file\n");
     printf("Note : Users who wants only a certain range of the original data\n");
     printf("       to pass though into mri.img should use this option,\n");
     printf("       where any values < win_min will be win_min \n");
     printf("           & any values > win_max will be win_max\n");
     printf("       The original data is not scaled here.\n");
     printf("\n\n");
     printf("Example 5 : %s \"hup*.img\" mri 1 0 250 1000 3000\n",argv[0]);
     printf("   Result : 1) input  = hup*.img --- hup file names\n");
     printf("            2) output = mri.hdr  --- mrvbr header\n");
     printf("            3) output = mri.nhdr  --- ria header\n");
     printf("            4) output = mri.img  --- mri image file\n");
     printf("Note : Users who wants only a certain range of the original data\n");
     printf("       to be scaled to 1 byte in the range 0 to 250 should use this option,\n");
     printf("       where any values < win_min will be win_min \n");
     printf("           & any values > win_max will be win_max\n");
     printf("\n\n");
     exit(1);}
}

dp_minmax_range()
{
 printf("\n.... Listing of Range of values based on # of bytes/pixel\n");
 printf("....   0 <= 1 byte/pixel <= 255\n");
 printf("....   0 <= 2 byte/pixel <= 65535\n");
 printf("....   0 <= 4 byte/pixel <= %u\n\n",0xffffffff);

}

check_minmax_range(out)
 struct the_file_rec *out;
{
 unsigned long max;

 if (out->scale_bytes == 1) max = 255;
   else if (out->scale_bytes == 2) max = 65535;
   else if (out->scale_bytes == 4) max = 0xffffffff;

 if (out->scale_min > max)
    {printf("Invalid input : scale_min = %d\n",out->scale_min);
     printf("0 <= scale_min <= %u for %d bytes output\n\n",
                     out->scale_bytes,(unsigned long) max);
     dp_minmax_range();
     return CANCEL;}
 if (out->scale_max > max)
    {printf("Invalid input : scale_max = %d\n",out->scale_max);
     printf("0 <= scale_max <= %u for %d bytes output\n\n",
                     out->scale_bytes,(unsigned long) max);
     dp_minmax_range();
     return CANCEL;}
 if (out->scale_min >= out->scale_max)
    {printf("Invalid input : scale_min = %d >= scale_max = %d\n\n",
            out->scale_min,out->scale_max);
     dp_minmax_range();
     return CANCEL;}
 return NO_ERROR;

}

get_scale_info(out,argc,argv)
 struct the_file_rec *out;
 int argc;
 char *argv[];
{
 if (argc > 3)
    {sscanf(argv[3],"%d",&(out->scale_bytes));
     if ((out->scale_bytes != 0) && (out->scale_bytes != 1)
             && (out->scale_bytes != 2) && (out->scale_bytes != 4))
        {printf("Invalid input : scale_to_num_bytes = %d\n",out->scale_bytes);
         printf("   scale_to_num_bytes = 1 or 2 or 4 bytes/pixel!!!\n");
         printf("                      = 0 use same # of bytes/pixel\n");
         exit(1);
        }
     
     sscanf(argv[4],"%d",&(out->scale_min));
     sscanf(argv[5],"%d",&(out->scale_max));
     out->status |= USE_SCALE;
     if (out->scale_bytes != 0)
        {if (check_minmax_range(out) != NO_ERROR) exit(1);
         }
       else out->status |= USE_ORIGINAL_BYTES_PER_PIXEL;
     if (argc == 8)
        {sscanf(argv[6],"%d",&(out->win_min));
         sscanf(argv[7],"%d",&(out->win_max));
         if (out->win_min < out->win_max)
            out->status |= USE_WINDOW_MIN_MAX;
           else
            {printf("...Invalid win_min & win_max values\n");
             printf("...Input : win_min = %d   win_max = %d\n",
                    out->win_min,out->win_max);
             printf("...The values will not be used...\n\n");
            }
        }
    }
}

dp_errors(log)
 struct strs_rec *log;
{
 unsigned long lcv;

 printf("\n");
 printf("The following list shows the files with processing error...\n");
 printf("These error files are not included in any of the .img files...\n");
 for (lcv = 0; lcv < log->num_strs; lcv++)
    printf("%d) %s",lcv + 1,log->strs[lcv]);
 printf("\n");
}

main(argc,argv)
 int argc;
 char *argv[];
{
  FILE *fid;
  struct acr_rec acr;
  struct hdr_rec hdr;
  unsigned int slice_num;
  int err,err1;
  char **fns;
  unsigned int num_fns;
  unsigned long lcv;

  char *dirfn,fn[200],str[250],spec[250],tapedir[250],
  tar[50],mk_tapedir[50],cd_to_tapedir[50],*temp;

  struct the_file_rec out;
  unsigned long in_img_addr,in_img_len;
  struct strs_rec log;
  unsigned long start_indx;
  int which_format;
  char *image_orientation,*series;

  prog_usage(argc,argv);
  init_strs_rec(&log);
  init_the_file_rec(&out);
  get_scale_info(&out,argc,argv);
  /*  TRACE(printf("new_acr...1\n")) */

  if (find_sub_str(argv[1],"/dev/rst",&start_indx) == 0)
    {
      strcpy(tapedir,mktemp("namXXXXXX"));
      if ((temp = (char *) complete_fn(tapedir)) == NULL)
        {printf("Not enough memory...\n");
         exit(~NO_ERROR);}
      strcpy(tapedir,temp);
      c_free(temp);
      sprintf(mk_tapedir,"mkdir %s\n",tapedir);
      sprintf(cd_to_tapedir,"cd %s\n",tapedir);
      sprintf(tar,"tar xvf %s\n",argv[1]);
      if ((err = setup_batch_file("unalias rm",mk_tapedir,cd_to_tapedir,tar,0))
	  != NO_ERROR)
        {printf("Failure to extract data from the tape...\n");
         exit(err);}
      sprintf(spec,"%s/*",tapedir);
    }
  else
    {tapedir[0] = '\0';
     sprintf(spec,"%s",argv[1]);}
  /*  TRACE(printf("new_acr...2\n")) */

 dirfn = (char *) locate_dirfn(spec);
 drop_dirfn(spec);
 if (dirfn == NULL) dirfn = ".";
 if ((err = get_fns(dirfn,NULL,0,0,NULL,&fns,&num_fns,1,spec,
         NULL,0,0,NULL)) != NO_ERROR)
    {printf("Sorry...get file name error...err = %d\n",err);
     exit(err);
    }
 if (num_fns == 0)
    {printf("Sorry...No file names...\n");
     sprintf(fn,"%s/%s",dirfn,spec);
     printf("...Fn specification processed = %s\n",fn);
     if (tapedir[0] != '\0')
        {
         printf("...Error !!! Unable to process the data...\n");
         printf("...If the data has beed stored on the tape with a\n");
         printf("directory file name specification, please tar\n");
         printf("your data to the disk first, cd to that directory, and\n");
         printf("then use argv[0] again to process the data !!!\n");
        }
    }
   else
    {
     printf("# of files read = %d\n",num_fns);
     for (lcv = 0; lcv < num_fns; lcv++)
        {sprintf(fn,"%s/%s",dirfn,fns[lcv]);

         if ((fid = fopen(fn,"r")) == NULL)
            {printf("input file open error...fn = %s\n",fn);
             continue;}
         init_acr_rec(&acr);
         if ((err = rd_acr_group_elems(fid,&acr,&which_format)) == NO_ERROR)
            {init_hdr_rec(&hdr);

             if (acr_header_to_ia_hdr(fid,&acr,&hdr,
                    &slice_num,&image_orientation,&series,
                    &in_img_addr,&in_img_len,which_format) == NO_ERROR)
                {if ((in_img_addr + in_img_len) > acr.fsize)
                    {sprintf(str,
                        "...Invalid file size : %s is excluded...\n",fn);
                     add_str_to_strs_rec(&log,str);
                    }
                   else
                    {
                     err1 = enter_file(&out,&hdr,slice_num,image_orientation,series,
                         argv[2],fn,
                         in_img_addr,in_img_len,which_format);
                     c_free(image_orientation);
                     image_orientation = NULL;
                     c_free(series);
                     series = NULL;
                     if (err1)
                        if (err1 != ~NO_ERROR)
                           {
                            err = err1;
                            sprintf(str,
                              "...err = %d : %s is excluded...\n",err1,fn);
                            add_str_to_strs_rec(&log,str);
                           }
                    }
                }
               else
                {sprintf(str,
                        "...Invalid header : %s is excluded...\n",fn);
                 add_str_to_strs_rec(&log,str);
                }
             free_hdr_rec(&hdr);
            }
           else printf("%d) Error reading file = %s\n",lcv,fn);
         fclose(fid);
         free_acr_rec(&acr);
         if (err != NO_ERROR) break;
       }  /*  end of for loop through input files */

     printf("\n");
     if (err == NO_ERROR)
        {
         err = save_the_file_rec(&out);}
     if (log.num_strs > 0)
        dp_errors(&log);
    }
 free_the_file_rec(&out);
 free_strs_rec(&log);
 if (tapedir[0] != '\0')
    {sprintf(spec,"rm -R %s",tapedir);
     setup_batch_file("unalias rm",spec,0);
    }
 exit(0);
}
