/****************************************************************************
swab.c - swap bytes

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.


  swab: swap bytes.

     assumed: 131072-byte slices

  Usage:  swab infile outfile

     arg 1:  input filename
     arg 2:  output filename

  To compile, use "cc -o ../`uname -r`/swab.bin swab.c".
  To make the object file, use "cc -c ../`uname -r`/swab.o swab.c"
    and "cc ../`uname -r`/swab.bin ../`uname -r`/swab.o"

  DRW 960919

FIXME:  There is a new better but perhaps not upward compatible swab program
defined as part of bblimage.  -PWH 19990430
****************************************************************************/

static const char rcsid[] = "$Id: swab.c,v 1.4 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>

void
main( int argc, char **argv ) 
{
	FILE *fpin, *fpout;
	unsigned char bufptr[131072], tmp;
	int ptr, slicenum = 0;

	fpin = fopen( argv[1], "r" );
	fpout = fopen( argv[2], "w" );

	fprintf( stdout, "Reading from \"%s\", writing to \"%s\".\n",
		argv[1], argv[2] );
	while (fread( bufptr, 131072, 1, fpin ) == 1) {
		fprintf( stdout, "Slice #%d...\r", ++slicenum );
		fflush( stdout );
		for (ptr = 0; ptr < 131072; ptr += 2) {
			tmp = *(bufptr + ptr + 1);
			*(bufptr + ptr + 1) = *(bufptr + ptr);
			*(bufptr + ptr) = tmp;
		}
		fwrite( bufptr, 131072, 1, fpout );
	}
	fprintf( stdout, "\n\n" );
}
